#ifndef _MEMORYSWAP_H_
#define _MEMORYSWAP_H_

#include "A31G22x_hal_cfmc.h"

//////////////////////////////////////////////////////////////////////////////////////////////////

/*< Select MEMROY SWAP */
#define     MEMORY_SWAP     // Define : Use Memory Swap, Undefine: No Memory Swap

/*< Select Target Device (A31G226 or A31G224) */
#define     A31G226
//#define     A31G224

//////////////////////////////////////////////////////////////////////////////////////////////////

#ifdef      A31G226
#undef      A31G224
#define     MEMORY_SIZE             (0x40000)
#else
#undef      A31G226
#define     A31G224
#define     MEMORY_SIZE             (0x20000)
#endif

/* Common Definitions */
#define     SECTOR_SIZE             (0x200)
#define     APP_START_ADDR          (0x2000)    // Application start address

/* define memory size in Memory Swap */
#ifdef      MEMORY_SWAP

#ifdef      A31G226
#define     BANK_NONACTIVE_OFFSET   (0x20000)
#endif

#ifdef      A31G224
#define     BANK_NONACTIVE_OFFSET   (0x10000)
#endif

#define     APP_PGM_OFFSET          (BANK_NONACTIVE_OFFSET)
#define     END_ADDR                (MEMORY_SIZE)
//#define     END_ADDR                (MEMORY_SIZE - 1)
//#define     END_ADDR                ((MEMORY_SIZE/2) - 1)

#else
#define     APP_PGM_OFFSET          (APP_START_ADDR)
#define     END_ADDR                (MEMORY_SIZE - 1)
#endif

void memory_swap(void);

#endif /*< _MEMORYSWAP_H_ */
