#include "MemorySwap.h"

#ifdef  MEMORY_SWAP

const uint32_t TABLE_SWAP_BANK0[] = {
	0x55555555, // Check Code A
	0xAAAAAAAA, // Check Code B
	0xED810148, 0xAA910010, // CFMC->BCR = 0xAA910010, Memory Bank Selection Enable
	0xFFFFFFFF, 0xFFFFFFFF, // CFMC->BCR = 0xAA910011, Memory Bank Selection and Switching Bank	(Bank Switch occurrs after memory bank Selection Enable)
    0xFFFFFFFF, 0xFFFFFFFF, // CFMC->BSR = 0x00000100, Set Current Boot Bank Indicator Flag (This bit is set by user)
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F010020UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F010040UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F010060UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F010080UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F0100A0UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F0100C0UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F0100E0UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F010100UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F010120UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F010140UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F010160UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F010180UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F0101A0UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F0101C0UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F0101E0UL    
};

const uint32_t TABLE_SWAP_BANK1[] = {
	0x55555555, // Check Code A
	0xAAAAAAAA, // Check Code B
	0xED810148, 0xAA910010, // CFMC->BCR = 0xAA910010, Memory Bank Selection Enable
	0xED820148, 0xAA910011, // CFMC->BCR = 0xAA910011, Memory Bank Selection and Switching Bank	(Bank Switch occurrs after memory bank Selection Enable)
    0xED3B014C, 0x00000100, // CFMC->BSR = 0x00000100, Set Current Boot Bank Indicator Flag (This bit is set by user)
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F010020UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F010040UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F010060UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F010080UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F0100A0UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F0100C0UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F0100E0UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F010100UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F010120UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F010140UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F010160UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F010180UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F0101A0UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F0101C0UL
	0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, // < 0x0F0101E0UL
};

void memory_swap(void) {
    __disable_irq();  
    // Write Memory Swap Option (Option Command data) 
	if ((HAL_CFMC_GetBankSwapStatus() & CFMC_BSR_BSWST_Msk) == CFMC_BSR_BSWST_Msk) {
        HAL_CFMC_EraseSector(OPTION_BANKSWAP, CFMC_OPTION_BANKSWAP_ADDR);   // Erase Memory Swap Option Area    
        // Memory Bank 1 is Active Bank, Swap to Bank 0
        HAL_CFMC_ProgramPage(OPTION_BANKSWAP, CFMC_OPTION_BANKSWAP_ADDR , SECTOR_SIZE, (unsigned char *)TABLE_SWAP_BANK0); 
    } else {
        HAL_CFMC_EraseSector(OPTION_BANKSWAP, CFMC_OPTION_BANKSWAP_ADDR);   // Erase Memory Swap Option Area            
        // Memory Bank 0 is Active Bank, Swap to Bank 1
        HAL_CFMC_ProgramPage(OPTION_BANKSWAP, CFMC_OPTION_BANKSWAP_ADDR , SECTOR_SIZE, (unsigned char *)TABLE_SWAP_BANK1);
    }
    __enable_irq();      
}

#endif /*< MEMORY_SWAP */
