/*****************************************************************************
* @file     TestCode_I2C_SLAVE_Polling.h
* @brief    Contains the external function prototypes for TestCode
* @author   AE Team, ABOV Semiconductor Co., Ltd.
* @version  V0.0.1
* @date     14. JUN. 2019
*
* Copyright(C) 2019, ABOV Semiconductor
* All rights reserved.
*
*
********************************************************************************
* DISCLAIMER
*
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
* TIME. AS A RESULT, ABOV SEMICONDUCTOR DISCLAIMS ALL LIABILITIES FROM ANY
* DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
* FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
* CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*
*******************************************************************************/

/*******************************************************************************
* Pre-processor Definition & Macro
*******************************************************************************/
#ifndef __TESTCODE_I2C_MASTER_INTERRUPT_H__
#define __TESTCODE_I2C_MASTER_INTERRUPT_H__

#include "a31G22x_hal_i2c.h"

/*******************************************************************************
* Private Typedef
*******************************************************************************/

/*******************************************************************************
* Private Variable
*******************************************************************************/

/*******************************************************************************
* Private Function Prototype
*******************************************************************************/
void Main_TestI2CMasterInterrupt(void);

static void Main_I2CnIRQHandler(I2C_Type *pI2Cx);
void I2C0_IRQHandler_MasterInterrupt(void);
void I2C1_IRQHandler_MasterInterrupt(void);
void I2C2_SPI20_IRQHandler_MasterInterrupt(void);


#endif
/* --------------------------------- End Of File ------------------------------ */
