#include "main_conf.h"

extern uint32_t msec;

uint8_t *lcdfbuff;//[44];// @ 0x00; // com0~com3,seg2~seg10

void lcd_init(void)
{
	char i;

	lcdfbuff = (uint8_t *)(0x40005010);
	
	// LCD block enable
	SCU->PER2 &= ~(1<<28);
	SCU->PCER2 &= ~(1<<28);	
	
	SCU->PER2 |= (1<<28);
	SCU->PCER2 |= (1<<28);	

//PPCLKSR set	
#if 0	
	HAL_SCU_SetLcdClk(LCDCLK_MCCR5); //LCDCLK_MCCR5, LCDCLK_SOSC, LCDCLK_WDTRC	
	HAL_SCU_SetMCCRx(5,LCD_TYPE,CLKSRC_LSI,16);
#endif
#if 0
	HAL_SCU_SetSOSC(EXSOSC_EN);
	HAL_SCU_WaitForSOSCStartUp();
	for (i=0;i<100;i++);	
	HAL_SCU_SetLcdClk(LCDCLK_SOSC); //LCDCLK_MCCR5, LCDCLK_SOSC, LCDCLK_WDTRC
#endif
#if 1
	HAL_SCU_SetLcdClk(LCDCLK_WDTRC); //LCDCLK_MCCR5, LCDCLK_SOSC, LCDCLK_WDTRC
#endif
	
	LCD->LCDCR = 0
	|(3<<6)   //
	|(3<<3)   // 0: 1/8:1/4, 1: 1/6:1/4, 2: 1/5:1/3, 3: 1/4:1/3, 4: 1/3:1/3, 5: 1/3:1/2
	|(0<<1)   //
	|(0<<0);  // 0:off, 1:on

	LCD->LCDBCCR = 0
	|(0<<12)   //
	|(3<<8)   // 
	|(0<<5)   //
	|(0<<0);  // 

	LCD->LCDTEST = 0
	|(1<<11)
	|(3<<8)  // 0:internal bias, 3:external LCD driving resistors for bias select
	|(0<<7)  // external VLC3 enable bit
	|(1<<6)  // external VLC2 enable bit
	|(1<<5)  // external VLC1 enable bit
	|(1<<4)  // external VLC0 enable bit	
		; 

	for (i=0;i<27;i++)
		lcdfbuff[i]=0x00;
		
//	LCD->LCDCR|=(1<<0); //0: Display off, 1:Normal display on	
}



const char LEDSEG[17]={
	// 0      1    2    3    4    5    6    7    8    9    A    b    c    d    E    F   ' '
//	0x0f,0x00,0x0d,0x09,0x02,0x0b,0x0f,0x03,0x0f,0x0b,0x07,0x0e,0x0f,0x0c,0x0f,0x07,0x00
	0x0f,0x00,0x0b,0x09,0x04,0x0d,0x0f,0x0c,0x0f,0x0d,0x0e,0x07,0x0f,0x03,0x0f,0x0e,0x00	
};
const char LEDSEGn[17]={
	//0    1    2    3    4    5    6    7    8    9    A    b    c    d    E    F   ' '
//	0x05,0x05,0x03,0x07,0x07,0x06,0x06,0x05,0x07,0x07,0x07,0x06,0x00,0x07,0x02,0x02,0x00
	0x0a,0x0a,0x0c,0x0e,0x0e,0x06,0x06,0x0a,0x0e,0x0e,0x0e,0x06,0x00,0x0e,0x0e,0x0e,0x00	
};

void l_init(void)
{
	int i;

	for (i=5;i<44;i++){
		lcdfbuff[i]=0;	
	}
}

void l_disp(unsigned int disp)
{
	char tch[6];
	
	tch[0]=disp%10; disp/=10;
	if (disp==0){
		tch[1]=tch[2]=tch[3]=16;
	}
	else {
		tch[1]=disp%10; disp/=10;
		if (disp==0){
			tch[2]=tch[3]=16;
		}
		else {
			tch[2]=disp%10; disp/=10;
			if (disp==0){
				tch[3]=16;
			}
			else {
				tch[3]=disp%10;
			}
		}
	}

//	cli();
	lcdfbuff[7]=LEDSEG[tch[3]];
	lcdfbuff[8]=LEDSEGn[tch[3]];
	lcdfbuff[9]=LEDSEG[tch[2]];
	lcdfbuff[10]=LEDSEGn[tch[2]];
	lcdfbuff[11]=LEDSEG[tch[1]];
	lcdfbuff[12]=LEDSEGn[tch[1]];
	lcdfbuff[13]=LEDSEG[tch[0]];
	lcdfbuff[14]=LEDSEGn[tch[0]];
//	sei();
}


unsigned char ring_state;
void l_ring(char dir)
{
	char tch[8];

	if (dir){
		ring_state++;
		if (ring_state>11) ring_state=0;
	}
	else {
		ring_state--;
		if (ring_state==0xff) ring_state=11;
	}
	
	switch(ring_state){
		case  0:tch[0]=0x08;tch[1]=0   ;tch[2]=0x08;tch[3]=0   ;tch[4]=0   ;tch[5]=0   ;tch[6]=0   ;tch[7]=0   ;break;
		case  1:tch[0]=0   ;tch[1]=0   ;tch[2]=0x08;tch[3]=0   ;tch[4]=0x08;tch[5]=0   ;tch[6]=0   ;tch[7]=0   ;break;
		case  2:tch[0]=0   ;tch[1]=0   ;tch[2]=0   ;tch[3]=0   ;tch[4]=0x08;tch[5]=0   ;tch[6]=0x08;tch[7]=0   ;break;
		case  3:tch[0]=0   ;tch[1]=0   ;tch[2]=0   ;tch[3]=0   ;tch[4]=0   ;tch[5]=0   ;tch[6]=0x08;tch[7]=0x08;break;
		case  4:tch[0]=0   ;tch[1]=0   ;tch[2]=0   ;tch[3]=0   ;tch[4]=0   ;tch[5]=0   ;tch[6]=0   ;tch[7]=0x0a;break;
		case  5:tch[0]=0   ;tch[1]=0   ;tch[2]=0   ;tch[3]=0   ;tch[4]=0   ;tch[5]=0   ;tch[6]=0x01;tch[7]=0x02;break;
		case  6:tch[0]=0   ;tch[1]=0   ;tch[2]=0   ;tch[3]=0   ;tch[4]=0x01;tch[5]=0   ;tch[6]=0x01;tch[7]=0   ;break;
		case  7:tch[0]=0   ;tch[1]=0   ;tch[2]=0x01;tch[3]=0   ;tch[4]=0x01;tch[5]=0   ;tch[6]=0   ;tch[7]=0   ;break;
		case  8:tch[0]=0x01;tch[1]=0   ;tch[2]=0x01;tch[3]=0   ;tch[4]=0   ;tch[5]=0   ;tch[6]=0   ;tch[7]=0   ;break;
		case  9:tch[0]=0x03;tch[1]=0   ;tch[2]=0   ;tch[3]=0   ;tch[4]=0   ;tch[5]=0   ;tch[6]=0   ;tch[7]=0   ;break;
		case 10:tch[0]=0x06;tch[1]=0   ;tch[2]=0   ;tch[3]=0   ;tch[4]=0   ;tch[5]=0   ;tch[6]=0   ;tch[7]=0   ;break;
		case 11:tch[0]=0x0c;tch[1]=0   ;tch[2]=0   ;tch[3]=0   ;tch[4]=0   ;tch[5]=0   ;tch[6]=0   ;tch[7]=0   ;break;
		default: break;
	}

	cli();
	lcdfbuff[7]=tch[0];
	lcdfbuff[8]=tch[1];	
	lcdfbuff[9]=tch[2];
	lcdfbuff[10]=tch[3];	
	lcdfbuff[11]=tch[4];
 	lcdfbuff[12]=tch[5];
	lcdfbuff[13]=tch[6];
	lcdfbuff[14]=tch[7];
	lcdfbuff[15]=0;	
	sei();			   
}

void l_bar(void)
{
	cli();
	lcdfbuff[7]=0;
	lcdfbuff[8]=0x04;	
	lcdfbuff[9]=0;
	lcdfbuff[10]=0x04;	
	lcdfbuff[11]=0;
 	lcdfbuff[12]=0x04;
	lcdfbuff[13]=0;
	lcdfbuff[14]=0x04;
	lcdfbuff[15]=0;
	sei();			   
}

void lcd_test(void)
{
	uint8_t ch;
	char cmd;
	unsigned int count=0;
		
	cmd='2';

//	LCD->LCDCR |= (1<<0);   //0: Display off, 1:Normal display on	
	
 	for (;;){
		if (_DG_(&ch)){
			cmd=ch;_DBC(ch);
		}
	
		switch(cmd){
			case '1':
				cli();l_init();sei();
				cmd='x';
				break;
			case '2':
				l_disp(count++);
				msec=200;
				while(msec);
				break;
			case '3':l_ring(0);
				msec=200;
				while(msec);
				count=0;
				break;
			case '4':l_ring(1);
				msec=200;
				while(msec);
				count=0;
				break;
			case '5':
				l_bar();
				msec=60;
				while(msec);
				count=0;
				break;
			case '6':
				msec=600;
				while(msec);
				count=0;
				break;
			case '7':
				msec=800;
				while(msec);
				count=0;
				break;
			case 'q':
			case 'Q':				
				return;				
			default: 
				break;
		}
	}		
}

void t_lcd(void)
{
	char cmd;

	cli();
	lcd_init();
	sei();
	
	while(1){
		_DBG("\n\rLCD test Program\n\r");
		_DBG("1. LCD ON\n\r");
		_DBG("2. LCD OFF\n\r");	
		_DBG("3. LCD disp test\n\r");				
		_DBG("q. return to main.\n\r");
		
		_DBG(">");
		lcd_test();
		
		getstring();
		if (InFlag){
			_DBG("\n\r");
			cmd=InData[0];
				
			switch(cmd){
				case '1': 
					LCD->LCDCR |= (1<<0);   //0: Display off, 1:Normal display on		
					break;
				case '2':		
					LCD->LCDCR &= ~(1<<0);   //0: Display off, 1:Normal display on					
					break;	
				case '3':
					lcd_test();
					break;																						
				case 'q':
				case 'Q':
					_DBG("Bye~\n\r");		
					return;				
			}
		}
		else {
			_DBG("\n\r");
			InFlag=0;
			InCount=0;
		}
	}
}



