/*****************************************************************************
* @file     TestCode_SPI_EEPROM.c
* @brief    Contains the external function prototypes for TestCode
* @author   AE Team, ABOV Semiconductor Co., Ltd.
* @version  V0.0.1
* @date     14. JUN. 2019
*
* Copyright(C) 2019, ABOV Semiconductor
* All rights reserved.
*
*
********************************************************************************
* DISCLAIMER
*
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
* TIME. AS A RESULT, ABOV SEMICONDUCTOR DISCLAIMS ALL LIABILITIES FROM ANY
* DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
* FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
* CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*
*******************************************************************************/

/*******************************************************************************
* Pre-processor Definition & Macro
*******************************************************************************/
#include "TestCode_SPI_EEPROM.h"
#include "main_conf.h"

// External AT45DBXX Drivers
#include "ws_AT45DBXX.h"

/*******************************************************************************
* Private Typedef
*******************************************************************************/
// #define PIN_REMAP

/*******************************************************************************
* Private Variable
*******************************************************************************/

/*******************************************************************************
* Private Function Prototype
*******************************************************************************/

/*******************************************************************************
* Public Function
*******************************************************************************/

void  Delay (uint32_t nCount)
{
  for(; nCount != 0; nCount--);
}

/**********************************************************************
 * @brief		AT45DBXX_Application
 * @param[in]	None
 * @return 		None
 **********************************************************************/
void AT45DBXX_Application(void) {
	uint8_t num,i;
	uint8_t ID[4];
	uint8_t s_buffer[256],r_buffer[256];

	cputs("\r\n****************************************************************\r\n");

	AT45DBXX_Init();
	cputs("AT45DBXX had been Init!\r\n");

	AT45DBXX_Read_ID(ID);
	cputs("AT45DBXX ID is");
	for(num = 0; num < 4; num++) {
        cprintf("0x%02X ", ID[num]);
	}
	cputs("\r\n****************************************************************\r\n");
	cputs("\r\n");

	cputs("\r\n****************************************************************\r\n");
	cputs("Buffer Write !! \r\n");
	write_buffer(0x02, 10);
	write_buffer(0x04, 9);

	cputs("Buffer Read !! \r\n");
	cputs(" SRAM Buffer : 0x02 : ");
    cprintf("%02X", read_buffer(0x02));
	//_DBH8(read_buffer(0x02));
	cputs("\r\n SRAM Buffer : 0x04 : ");
//	_DBH8(read_buffer(0x04));
    cprintf("%02X", read_buffer(0x04));
	cputs("\r\n****************************************************************\r\n");
	cputs("\r\n");

	cputs("\r\n****************************************************************\r\n");
	cputs("BUFFER 1 TO MAIN MEMORY PAGE PROGRAM \r\n");
	cputs("PAGE SIZE : 264 byte \r\n");
	cputs("PAGE 10, PROGRAM VALUE 0x0 - 0xFE\r\n");

	for(i=0;i<255;i++) {
		s_buffer[i] = i;
	}
	flash_write_page(10, s_buffer, 0);

	cputs("\r\nREAD BUFFER 1 TO MAIN MEMORY PAGE ");

	flash_read_page(10,r_buffer);
	for(i=0;i<255;i++) {
		if(i%8==0) {
            cputs("\r\n");
        }
        cprintf("%02X ", r_buffer[i]);
	}
cputs("\r\n****************************************************************\r\n\r\n");

cputs("FLASH ERASE PAGE !! \r\n");

	flash_erase_page(10);

	flash_read_page(10,r_buffer);

	for(i=0;i<255;i++) {
		if(i%8==0) {
            cputs("\r\n");
        }
        cprintf("%02X ", r_buffer[i]);
	}
cputs("\r\n****************************************************************\r\n");
cputs("\r\n");

	while (1)
  {
	/*====LED-ON=======*/
	HAL_GPIO_SetPin(PB, _BIT(0));
	HAL_GPIO_SetPin(PB, _BIT(1));
	HAL_GPIO_SetPin(PB, _BIT(2));
	HAL_GPIO_SetPin(PB, _BIT(3));

	Delay(0xfffff);
	Delay(0xfffff);
	Delay(0x5ffff);

	/*====LED-OFF=======*/
	HAL_GPIO_ClearPin(PB , _BIT(0));
	HAL_GPIO_ClearPin(PB , _BIT(1));
	HAL_GPIO_ClearPin(PB , _BIT(2));
	HAL_GPIO_ClearPin(PB , _BIT(3));
	Delay(0xfffff);
	Delay(0xfffff);
	Delay(0x5ffff);
  }

}

/* --------------------------------- End Of File ------------------------------ */
