/**************************************************************************
* @file     main_conf.h
* @brief    Contains all A31G22x macro definitions and function prototypes
*           for main code that build the example project for user
* @version  1.00
* @date     22 July 2020
* @author   ABOV AE team
* Copyright(C) 2020, ABOV Semiconductor All rights reserved.
**************************************************************************/
#ifndef __MAIN_CONF_H
#define __MAIN_CONF_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
/* Uncomment the line below to enable peripheral header file inclusion */
#include "A31G22x_libcfg.h"
#include "A31G22x_hal_pcu.h"
#include "A31G22x_hal_scu.h"
#include "A31G22x_hal_spi.h"
#include "debug_frmwrk.h"
#include "debug_cmd.h"
#include "debug.h"

#include "A31G22x_hal_assert.h"
#include "A31G22x_it.h"

#ifdef __cplusplus
extern "C"
{
#endif
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/


/* Private function prototypes -----------------------------------------------*/

/* Initialize all port */
extern void Port_Init(void);
/* Configure the system clock initialization */
extern void SystemClock_Config(void);

#ifdef __cplusplus
}
#endif

#endif /* __A31G22x_CONF_H */
