/**********************************************************************
* @file		main.c
* @brief	debug framework Example Code tested on A31G22x StarterKit
* @version	1.00
* @date		22 July 2020
* @author	ABOV AE team
*
* Copyright(C) 2020, ABOV Semiconductor
* All rights reserved.
**********************************************************************/
#include "main_conf.h"
#include "A31G22x_it.h"
#include "A31G22x_hal_uartn.h"

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
void DEBUG_MenuPrint(void);
void mainloop(void);
int main (void);

/* Private variables ---------------------------------------------------------*/

#ifdef _DEBUG_MSG
static const char Menu[] =
"************************************************\n\r"
"\t - MCU: A31G22x \n\r"
"\t - Core: ARM Cortex-M0+ \n\r"
"\t - Communicate via: USART10 - 38400 bps \n\r"
" StarterKit - Debug cprintf test \n\r"
"************************************************\n\r";
#endif

extern uint8_t uart_mode;


/* Public Function ------------------------------------------------------------*/

/**********************************************************************
 * @brief		Main loop
 * @param[in]	None
 * @return	None
 **********************************************************************/
void mainloop(void)
{       
    char ch;
    
#if (DEBUG_PORT_NUMBER == 0 || DEBUG_PORT_NUMBER == 1)
    #ifdef  DEBUG_POLLING
        uart_mode = 0;
    #else
        uart_mode = 1;
    #endif
#endif
    
#if (DEBUG_PORT_NUMBER == 10 || DEBUG_PORT_NUMBER == 11 || DEBUG_PORT_NUMBER == 12 || DEBUG_PORT_NUMBER == 13)    
    #ifdef  DEBUG_POLLING
//        usart_mode = 0;
    #else
//        usart_mode = 1;
    #endif    
#endif
    
    cputs((char *)Menu);

    cprintf("Hello, World!\r\n");    
    cprintf("0x%04X 0x%04x\r\n\r\n", 0xABCD, 0xABCD);
    
	while(1) {
        ch = cgetchar();
        if (ch > 0 && ch <= 0x7F) {
            cputc(ch);
        }
    }
}

/**********************************************************************
 * @brief		Main program
 * @param[in]	None
 * @return	None
 **********************************************************************/
int main (void)
{
	 /* Initialize all port */
	Port_Init(); 

	/* Configure the system clock to HSE 8 MHz */
	SystemClock_Config();
	
//	/* Initialize Debug frame work through initializing UART port  */
    #ifdef _DEBUG_MSG
    debug_frmwrk_init();
    #endif
    
	/* Infinite loop */
	mainloop();

	return (0);
}

/* --------------------------------- End Of File ------------------------------ */
