
/****************************************************************************************************//**
 * @file     A31G22x.h
 *
 * @brief    CMSIS Cortex-M0PLUS Peripheral Access Layer Header File for
 *           A31G22x from ABOV Semiconductor Co., Ltd..
 *
 * @version  V0.2
 * @date     27. March 2020
 *
 * @note     Generated with SVDConv V2.85b 
 *           from CMSIS SVD File 'A31G22x.svd' Version 0.2,
 *
 * @par      ARM Limited (ARM) is supplying this software for use with Cortex-M
 *           processor based microcontroller, but can be equally used for other
 *           suitable processor architectures. This file can be freely distributed.
 *           Modifications to this file shall be clearly marked.
 *           
 *           THIS SOFTWARE IS PROVIDED "AS IS". NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 *           OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 *           MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
 *           ARM SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR
 *           CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER. 
 *
 *******************************************************************************************************/



/** @addtogroup ABOV Semiconductor Co., Ltd.
  * @{
  */

/** @addtogroup A31G22x
  * @{
  */

#ifndef A31G22X_H
#define A31G22X_H

#ifdef __cplusplus
extern "C" {
#endif


/* -------------------------  Interrupt Number Definition  ------------------------ */

typedef enum {
/* -----------------  Cortex-M0PLUS Processor Exceptions Numbers  ----------------- */
  Reset_IRQn                    = -15,              /*!<   1  Reset Vector, invoked on Power up and warm reset                 */
  NonMaskableInt_IRQn           = -14,              /*!<   2  Non maskable Interrupt, cannot be stopped or preempted           */
  HardFault_IRQn                = -13,              /*!<   3  Hard Fault, all classes of Fault                                 */
  SVCall_IRQn                   =  -5,              /*!<  11  System Service Call via SVC instruction                          */
  DebugMonitor_IRQn             =  -4,              /*!<  12  Debug Monitor                                                    */
  SysTick_IRQn                  =  -1,              /*!<  15  System Tick Timer                                                */
/* ---------------------  A31G22x Specific Interrupt Numbers  --------------------- */
  LVI_IRQn                      =   0,              /*!<   0  LVI                                                              */
  SYSCLKFAIL_IRQn               =   1,              /*!<   1  SYSCLKFAIL                                                       */
  WDT_IRQn                      =   2,              /*!<   2  WDT                                                              */
  GPIOAB_IRQn                   =   3,              /*!<   3  GPIOAB                                                           */
  GPIOCD_IRQn                   =   4,              /*!<   4  GPIOCD                                                           */
  GPIOE_IRQn                    =   5,              /*!<   5  GPIOE                                                            */
  GPIOF_IRQn                    =   6,              /*!<   6  GPIOF                                                            */
  TIMER10_IRQn                  =   7,              /*!<   7  TIMER10                                                          */
  TIMER11_IRQn                  =   8,              /*!<   8  TIMER11                                                          */
  TIMER12_IRQn                  =   9,              /*!<   9  TIMER12                                                          */
  I2C0_IRQn                     =  10,              /*!<  10  I2C0                                                             */
  USART10_IRQn                  =  11,              /*!<  11  USART10                                                          */
  WT_IRQn                       =  12,              /*!<  12  WT                                                               */
  TIMER30_IRQn                  =  13,              /*!<  13  TIMER30                                                          */
  I2C1_IRQn                     =  14,              /*!<  14  I2C1                                                             */
  TIMER20_IRQn                  =  15,              /*!<  15  TIMER20                                                          */
  TIMER21_IRQn                  =  16,              /*!<  16  TIMER21                                                          */
  USART11_IRQn                  =  17,              /*!<  17  USART11                                                          */
  ADC_IRQn                      =  18,              /*!<  18  ADC                                                              */
  UART0_IRQn                    =  19,              /*!<  19  UART0                                                            */
  UART1_IRQn                    =  20,              /*!<  20  UART1                                                            */
  TIMER13_IRQn                  =  21,              /*!<  21  TIMER13                                                          */
  TIMER14_IRQn                  =  22,              /*!<  22  TIMER14                                                          */
  TIMER15_IRQn                  =  23,              /*!<  23  TIMER15                                                          */
  TIMER16_IRQn                  =  24,              /*!<  24  TIMER16                                                          */
  I2C2_SPI20_IRQn               =  25,              /*!<  25  I2C2_SPI20                                                       */
  USART12_13_SPI21_IRQn         =  26,              /*!<  26  USART12_13_SPI21                                                 */
  DAC_IRQn                      =  27,              /*!<  27  DAC                                                              */
  TEMP_SENSOR_IRQn              =  28,              /*!<  28  TEMP_SENSOR                                                      */
  CMP_CRC_IRQn                  =  31               /*!<  31  CMP_CRC                                                          */
} IRQn_Type;


/** @addtogroup Configuration_of_CMSIS
  * @{
  */


/* ================================================================================ */
/* ================      Processor and Core Peripheral Section     ================ */
/* ================================================================================ */

/* ----------------Configuration of the Cortex-M0PLUS Processor and Core Peripherals---------------- */
#define __CM0PLUS_REV                 0x0001        /*!< Cortex-M0PLUS Core Revision                                           */
#define __MPU_PRESENT                  0            /*!< MPU present or not                                                    */
#define __NVIC_PRIO_BITS               2            /*!< Number of Bits used for Priority Levels                               */
#define __Vendor_SysTickConfig         0            /*!< Set to 1 if different SysTick Config is used                          */
#define __VTOR_PRESENT                 1            /*!< Set to 1 if CPU supports Vector Table Offset Register                 */
/** @} */ /* End of group Configuration_of_CMSIS */

#include "core_cm0plus.h"                           /*!< Cortex-M0PLUS processor and core peripherals                          */
#include "system_A31G22x.h"                         /*!< A31G22x System                                                        */


/* ================================================================================ */
/* ================       Device Specific Peripheral Section       ================ */
/* ================================================================================ */


/** @addtogroup Device_Peripheral_Registers
  * @{
  */


/* -------------------  Start of section using anonymous unions  ------------------ */
#if defined(__CC_ARM)
  #pragma push
  #pragma anon_unions
#elif defined(__ICCARM__)
  #pragma language=extended
#elif defined(__GNUC__)
  /* anonymous unions are enabled by default */
#elif defined(__TMS470__)
/* anonymous unions are enabled by default */
#elif defined(__TASKING__)
  #pragma warning 586
#else
  #warning Not supported compiler type
#endif



/* ================================================================================ */
/* ================                      SCUCC                     ================ */
/* ================================================================================ */


/**
  * @brief SYSTEM CONTROL UNIT CHIP CONFIGURATION (SCUCC)
  */

typedef struct {                                    /*!< (@ 0x4000F000) SCUCC Structure                                        */
  __I  uint32_t  VENDORID;                          /*!< (@ 0x4000F000) Vendor Identification Register                         */
  __I  uint32_t  CHIPID;                            /*!< (@ 0x4000F004) Chip Identification Register                           */
  __I  uint32_t  REVNR;                             /*!< (@ 0x4000F008) Revision Number Register                               */
} SCUCC_Type;


/* ================================================================================ */
/* ================                       SCU                      ================ */
/* ================================================================================ */


/**
  * @brief SYSTEM CONTROL UNIT (SCU)
  */

typedef struct {                                    /*!< (@ 0x40000000) SCU Structure                                          */
  __I  uint32_t  RESERVED;
  __IO uint32_t  SMR;                               /*!< (@ 0x40000004) System Mode Register                                   */
  __IO uint32_t  SCR;                               /*!< (@ 0x40000008) System Control Register                                */
  __I  uint32_t  RESERVED1;
  __IO uint32_t  WUER;                              /*!< (@ 0x40000010) Wake up source enable register                         */
  __IO uint32_t  WUSR;                              /*!< (@ 0x40000014) Wake up source status register                         */
  __IO uint32_t  RSER;                              /*!< (@ 0x40000018) Reset source enable register                           */
  __IO uint32_t  RSSR;                              /*!< (@ 0x4000001C) Reset source status register                           */
  __IO uint32_t  PRER1;                             /*!< (@ 0x40000020) Peripheral reset enable register 1                     */
  __IO uint32_t  PRER2;                             /*!< (@ 0x40000024) Peripheral reset enable register 2                     */
  __IO uint32_t  PER1;                              /*!< (@ 0x40000028) Peripheral enable register 1                           */
  __IO uint32_t  PER2;                              /*!< (@ 0x4000002C) Peripheral enable register 2                           */
  __IO uint32_t  PCER1;                             /*!< (@ 0x40000030) Peripheral clock enable register 1                     */
  __IO uint32_t  PCER2;                             /*!< (@ 0x40000034) Peripheral clock enable register 2                     */
  __IO uint32_t  PPCLKSR;                           /*!< (@ 0x40000038) Peripheral clock selection register                    */
  __I  uint32_t  RESERVED2;
  __IO uint32_t  CSCR;                              /*!< (@ 0x40000040) Clock Source Control register                          */
  __IO uint32_t  SCCR;                              /*!< (@ 0x40000044) System Clock Control register                          */
  __IO uint32_t  CMR;                               /*!< (@ 0x40000048) Clock Monitoring register                              */
  __IO uint32_t  NMIR;                              /*!< (@ 0x4000004C) NMI control register                                   */
  __IO uint32_t  COR;                               /*!< (@ 0x40000050) Clock Output Control register                          */
  __I  uint32_t  RESERVED3[3];
  __IO uint32_t  PLLCON;                            /*!< (@ 0x40000060) PLL Control register                                   */
  __IO uint32_t  VDCCON;                            /*!< (@ 0x40000064) VDC Control register                                   */
  __I  uint32_t  RESERVED4;
  __IO uint32_t  LSICON;                            /*!< (@ 0x4000006C) LSI Control Register                                   */
  __I  uint32_t  RESERVED5[4];
  __IO uint32_t  EOSCR;                             /*!< (@ 0x40000080) External Oscillator control register                   */
  __IO uint32_t  EMODR;                             /*!< (@ 0x40000084) External mode pin read register                        */
  __IO uint32_t  RSTDBCR;                           /*!< (@ 0x40000088) Pin Reset Debounce Control Register                    */
  __I  uint32_t  RESERVED6;
  __IO uint32_t  MCCR1;                             /*!< (@ 0x40000090) Miscellaneous Clock Control Register 1                 */
  __IO uint32_t  MCCR2;                             /*!< (@ 0x40000094) Miscellaneous Clock Control Register 2                 */
  __IO uint32_t  MCCR3;                             /*!< (@ 0x40000098) Miscellaneous Clock Control Register 3                 */
  __IO uint32_t  MCCR4;                             /*!< (@ 0x4000009C) Miscellaneous Clock Control Register 4                 */
  __IO uint32_t  MCCR5;                             /*!< (@ 0x400000A0) Miscellaneous Clock Control Register 5                 */
  __IO uint32_t  MCCR6;                             /*!< (@ 0x400000A4) Miscellaneous Clock Control Register 6                 */
  __IO uint32_t  MCCR7;                             /*!< (@ 0x400000A8) Miscellaneous Clock Control Register 7                 */
  __I  uint32_t  RESERVED7;
  __IO uint32_t  HSITRIM;                           /*!< (@ 0x400000B0) Internal OSC Trim Register                             */
  __IO uint32_t  BISCCON;                           /*!< (@ 0x400000B4) Build in self calibration contrl register              */
} SCU_Type;


/* ================================================================================ */
/* ================                      SCULV                     ================ */
/* ================================================================================ */


/**
  * @brief SYSTEM CONTROL UNIT LOW VOLTAGE(INDICATOR / RESET) (SCULV)
  */

typedef struct {                                    /*!< (@ 0x40005100) SCULV Structure                                        */
  __IO uint32_t  LVICR;                             /*!< (@ 0x40005100) Low Voltage Indicator Control Register                 */
  __IO uint32_t  LVRCR;                             /*!< (@ 0x40005104) Low Voltage Reset Control Register                     */
  __IO uint32_t  LVRCNFIG;                          /*!< (@ 0x40005108) Configuration for Low Voltage Reset                    */
} SCULV_Type;


/* ================================================================================ */
/* ================                    PORT [PA]                   ================ */
/* ================================================================================ */


/**
  * @brief GENERAL PORT (PORT)
  */

typedef struct {                                    /*!< (@ 0x40001000) PORT Structure                                         */
  __IO uint32_t  MOD;                               /*!< (@ 0x40001000) Port n Mode Register                                   */
  __IO uint32_t  TYP;                               /*!< (@ 0x40001004) Port n Output Type Selection Register                  */
  __IO uint32_t  AFSR1;                             /*!< (@ 0x40001008) Port n Alternative Function Selection Register
                                                         1                                                                     */
  __IO uint32_t  AFSR2;                             /*!< (@ 0x4000100C) Port n Alternative Function Selection Register
                                                         2                                                                     */
  __IO uint32_t  PUPD;                              /*!< (@ 0x40001010) Port n Pull-up/down Resistor Selection Register        */
  __I  uint32_t  INDR;                              /*!< (@ 0x40001014) Port n Input Data Register                             */
  __IO uint32_t  OUTDR;                             /*!< (@ 0x40001018) Port n Output Data Register                            */
  __O  uint32_t  BSR;                               /*!< (@ 0x4000101C) Port n Output Bit Set Register                         */
  __O  uint32_t  BCR;                               /*!< (@ 0x40001020) Port n Output Bit Clear Register                       */
  __IO uint32_t  OUTDMSK;                           /*!< (@ 0x40001024) Port n Output Data Mask Register                       */
  __IO uint32_t  DBCR;                              /*!< (@ 0x40001028) Port n Debounce Control Register                       */
  __IO uint32_t  IER;                               /*!< (@ 0x4000102C) Port n interrupt enable register                       */
  __IO uint32_t  ISR;                               /*!< (@ 0x40001030) Port n interrupt status register                       */
  __IO uint32_t  ICR;                               /*!< (@ 0x40001034) Port n interrupt control register                      */
  __I  uint32_t  RESERVED[2];
  __IO uint32_t  STR;                               /*!< (@ 0x40001040) Port n Strength Configuration Register
                                                          This function is only valid for PB[2:0] and PC[4:2] ports.           */
} PORT_Type;


/* ================================================================================ */
/* ================                   PORTF [PF]                   ================ */
/* ================================================================================ */


/**
  * @brief GENERAL PORT (PORTF)
  */

typedef struct {                                    /*!< (@ 0x40001500) PORTF Structure                                        */
  __IO uint32_t  MOD;                               /*!< (@ 0x40001500) Port n Mode Register                                   */
  __IO uint32_t  TYP;                               /*!< (@ 0x40001504) Port n Output Type Selection Register                  */
  __IO uint32_t  AFSR1;                             /*!< (@ 0x40001508) Port n Alternative Function Selection Register
                                                         1                                                                     */
  __IO uint32_t  AFSR2;                             /*!< (@ 0x4000150C) Port n Alternative Function Selection Register
                                                         2                                                                     */
  __IO uint32_t  PUPD;                              /*!< (@ 0x40001510) Port n Pull-up/down Resistor Selection Register        */
  __I  uint32_t  INDR;                              /*!< (@ 0x40001514) Port n Input Data Register                             */
  __IO uint32_t  OUTDR;                             /*!< (@ 0x40001518) Port n Output Data Register                            */
  __O  uint32_t  BSR;                               /*!< (@ 0x4000151C) Port n Output Bit Set Register                         */
  __O  uint32_t  BCR;                               /*!< (@ 0x40001520) Port n Output Bit Clear Register                       */
  __IO uint32_t  OUTDMSK;                           /*!< (@ 0x40001524) Port n Output Data Mask Register                       */
  __IO uint32_t  DBCR;                              /*!< (@ 0x40001528) Port n Debounce Control Register                       */
  __IO uint32_t  IER;                               /*!< (@ 0x4000152C) Port n interrupt enable register                       */
  __IO uint32_t  ISR;                               /*!< (@ 0x40001530) Port n interrupt status register                       */
  __IO uint32_t  ICR;                               /*!< (@ 0x40001534) Port n interrupt control register                      */
  __IO uint32_t  PLSR;                              /*!< (@ 0x40001538) PORT F level select register                           */
  __I  uint32_t  RESERVED;
  __IO uint32_t  STR;                               /*!< (@ 0x40001540) Port n Strength Configuration Register
                                                          This function is only valid for PB[2:0] and PC[4:2] ports.           */
} PORTF_Type;


/* ================================================================================ */
/* ================                      PCU1                      ================ */
/* ================================================================================ */


/**
  * @brief PORT CONTROL UNIT 1 (PCU1)
  */

typedef struct {                                    /*!< (@ 0x40001544) PCU1 Structure                                         */
  __IO uint32_t  SPI2PMR;                           /*!< (@ 0x40001544) Port SPI2n Pin Re-Map Register                         */
} PCU1_Type;


/* ================================================================================ */
/* ================                      PCU2                      ================ */
/* ================================================================================ */


/**
  * @brief PORT CONTROL UNIT 2 (PCU2)
  */

typedef struct {                                    /*!< (@ 0x40001F00) PCU2 Structure                                         */
  __IO uint32_t  ISEGPEN;                           /*!< (@ 0x40001F00) Port LED ISEG Port Enable Register                     */
  __IO uint32_t  ISEGR;                             /*!< (@ 0x40001F04) Port LED ISEG Register                                 */
  __I  uint32_t  RESERVED[2];
  __IO uint32_t  ISEGIR;                            /*!< (@ 0x40001F10) Port LED ISEG Inversion Register                       */
  __I  uint32_t  RESERVED1[55];
  __O  uint32_t  PORTEN;                            /*!< (@ 0x40001FF0) Port Access Enable Register                            */
} PCU2_Type;


/* ================================================================================ */
/* ================                      CFMC                      ================ */
/* ================================================================================ */


/**
  * @brief CODE FLASH MEMORY CONTROLLER (CFMC)
  */

typedef struct {                                    /*!< (@ 0x40000100) CFMC Structure                                         */
  __IO uint32_t  INIT;                              /*!< (@ 0x40000100) Code Flash Memory INIT Register                        */
  __IO uint32_t  MR;                                /*!< (@ 0x40000104) Code Flash Memory Mode Register                        */
  __IO uint32_t  CR;                                /*!< (@ 0x40000108) Code Flash Memory Control Register                     */
  __IO uint32_t  AR;                                /*!< (@ 0x4000010C) Code Flash Memory Address Register                     */
  __IO uint32_t  DR;                                /*!< (@ 0x40000110) Code Flash Memory Data Register                        */
  __I  uint32_t  RESERVED;
  __IO uint32_t  BUSY;                              /*!< (@ 0x40000118) Code Flash Memory Write Busy Status Register           */
  __I  uint32_t  RESERVED1;
  __IO uint32_t  CRCCCITT;                          /*!< (@ 0x40000120) Code Flash Memory CRC-CCITT Check Register             */
  __I  uint32_t  RESERVED2[3];
  __IO uint32_t  CFG;                               /*!< (@ 0x40000130) Code Flash Memory Config Register                      */
  __IO uint32_t  WPROT;                             /*!< (@ 0x40000134) Flash Memory Write Protection Register                 */
  __I  uint32_t  RESERVED3;
  __IO uint32_t  RPROT;                             /*!< (@ 0x4000013C) Code Flash Memory Read Protection Register             */
  __O  uint32_t  PWIN;                              /*!< (@ 0x40000140) Code Flash Memory Password Input Register              */
  __O  uint32_t  PWPRST;                            /*!< (@ 0x40000144) Code Flash Memory Password Preset Register             */
  __IO uint32_t  BCR;                               /*!< (@ 0x40000148) Code Flash Memory Bank Control Register                */
  __IO uint32_t  BSR;                               /*!< (@ 0x4000014C) Code Flash Memory Bank Status Register                 */
  __IO uint32_t  ABWPROT;                           /*!< (@ 0x40000150) Code Flash Memory Active Bootloader Area Write
                                                         Protection Register                                                   */
  __IO uint32_t  NBWPROT;                           /*!< (@ 0x40000154) Code Flash Memory Non-active Bootloader Area
                                                         Write Protection Register                                             */
  __I  uint32_t  RESERVED4[2];
  __IO uint32_t  BOOT;                              /*!< (@ 0x40000160) Code Flash Memory Boot Register                        */
  __IO uint32_t  TMR;                               /*!< (@ 0x40000164) Code Flash Memory Timer Counter Register               */
  __IO uint32_t  TICK;                              /*!< (@ 0x40000168) Code Flash Memory Tick Timer Register                  */
  __I  uint32_t  RESERVED5[5];
  __IO uint32_t  TEST;                              /*!< (@ 0x40000180) Code Flash Memory TEST Register                        */
  __IO uint32_t  HWID;                              /*!< (@ 0x40000184) Code Flash Memory Hardware ID Register                 */
  __IO uint32_t  SIZE;                              /*!< (@ 0x40000188) Code Flash Memory Size Register                        */
  __I  uint32_t  RESERVED6;
  __I  uint32_t  DCT0;                              /*!< (@ 0x40000190) Code Flash Memory DCT0 Register                        */
  __I  uint32_t  DCT1;                              /*!< (@ 0x40000194) Code Flash Memory DCT0 Register                        */
} CFMC_Type;


/* ================================================================================ */
/* ================                      DFMC                      ================ */
/* ================================================================================ */


/**
  * @brief DATA FLASH MEMORY CONTROLLER (DFMC)
  */

typedef struct {                                    /*!< (@ 0x40000200) DFMC Structure                                         */
  __IO uint32_t  INIT;                              /*!< (@ 0x40000200) DATA Flash Memory INIT Register                        */
  __IO uint32_t  MR;                                /*!< (@ 0x40000204) Data Flash Memory Mode Register                        */
  __IO uint32_t  CR;                                /*!< (@ 0x40000208) Data Flash Memory Control Register                     */
  __IO uint32_t  AR;                                /*!< (@ 0x4000020C) Data Flash Memory Address Register                     */
  __IO uint32_t  DR;                                /*!< (@ 0x40000210) Data Flash Memory Data Register                        */
  __I  uint32_t  RESERVED;
  __IO uint32_t  BUSY;                              /*!< (@ 0x40000218) Data Flash Memory Write Busy Status Register           */
  __I  uint32_t  RESERVED1;
  __IO uint32_t  CRCCCITT;                          /*!< (@ 0x40000220) Data Flash Memory CRC-CCITT Check Register             */
  __I  uint32_t  RESERVED2[3];
  __IO uint32_t  CFG;                               /*!< (@ 0x40000230) Data Flash Memory Config Register                      */
  __IO uint32_t  WPROT;                             /*!< (@ 0x40000234) Data Flash Memory Write Protection Register            */
  __I  uint32_t  RESERVED3;
  __IO uint32_t  RPROT;                             /*!< (@ 0x4000023C) Data Flash Memory Read Protection Register             */
  __O  uint32_t  PWIN;                              /*!< (@ 0x40000240) Data Flash Memory Password Input Register              */
  __O  uint32_t  PWPRST;                            /*!< (@ 0x40000244) Data Flash Memory Password Preset Register             */
  __I  uint32_t  RESERVED4[14];
  __IO uint32_t  TEST;                              /*!< (@ 0x40000280) Code Flash Memory TEST Register                        */
  __I  uint32_t  RESERVED5[3];
  __I  uint32_t  DCT0;                              /*!< (@ 0x40000290) Code Flash Memory DCT0 Register                        */
  __I  uint32_t  DCT1;                              /*!< (@ 0x40000294) Code Flash Memory DCT0 Register                        */
} DFMC_Type;


/* ================================================================================ */
/* ================                  DMAC [DMAC0]                  ================ */
/* ================================================================================ */


/**
  * @brief DIRECT MEMORY ACCESS CONTROLLER (DMAC)
  */

typedef struct {                                    /*!< (@ 0x40000400) DMAC Structure                                         */
  __IO uint32_t  CR;                                /*!< (@ 0x40000400) DMA Channel n Control Register                         */
  __IO uint32_t  SR;                                /*!< (@ 0x40000404) DMA Channel n Status Register                          */
  __IO uint32_t  PAR;                               /*!< (@ 0x40000408) DMA Channel n Peripheral Address                       */
  __IO uint32_t  MAR;                               /*!< (@ 0x4000040C) DMA Channel n Memory Address                           */
} DMAC_Type;


/* ================================================================================ */
/* ================                       WDT                      ================ */
/* ================================================================================ */


/**
  * @brief WATCH-DOG TIMER (WDT)
  */

typedef struct {                                    /*!< (@ 0x40001A00) WDT Structure                                          */
  __IO uint32_t  CR;                                /*!< (@ 0x40001A00) Watch-dog Timer Control Register                       */
  __IO uint32_t  SR;                                /*!< (@ 0x40001A04) Watch-dog Timer Status Register                        */
  __IO uint32_t  DR;                                /*!< (@ 0x40001A08) Watch-dog Timer Data Register                          */
  __I  uint32_t  CNT;                               /*!< (@ 0x40001A0C) Watch-dog Timer Counter Register                       */
  __IO uint32_t  WINDR;                             /*!< (@ 0x40001A10) Watch-dog Timer Window Data Register (Note: Once
                                                         any value is written to this window data register, the register
                                                          can't be changed until a system reset.)                              */
  __O  uint32_t  CNTR;                              /*!< (@ 0x40001A14) Watch-dog Timer Counter Reload Register                */
} WDT_Type;


/* ================================================================================ */
/* ================                       WT                       ================ */
/* ================================================================================ */


/**
  * @brief WATCH TIMER (WT)
  */

typedef struct {                                    /*!< (@ 0x40002000) WT Structure                                           */
  __IO uint32_t  CR;                                /*!< (@ 0x40002000) Watch Timer Control Register                           */
  __IO uint32_t  DR;                                /*!< (@ 0x40002004) Watch Timer Data Register                              */
  __I  uint32_t  CNT;                               /*!< (@ 0x40002008) Watch Timer Counter Register                           */
} WT_Type;


/* ================================================================================ */
/* ================                TIMER1n [TIMER10]               ================ */
/* ================================================================================ */


/**
  * @brief 16-BIT TIMER1n (TIMER1n)
  */

typedef struct {                                    /*!< (@ 0x40002100) TIMER1n Structure                                      */
  __IO uint32_t  CR;                                /*!< (@ 0x40002100) Timer/Counter n Control Register                       */
  __IO uint32_t  ADR;                               /*!< (@ 0x40002104) Timer/Counter n A Data Register                        */
  __IO uint32_t  BDR;                               /*!< (@ 0x40002108) Timer/Counter n B Data Register                        */
  __I  uint32_t  CAPDR;                             /*!< (@ 0x4000210C) Timer/Counter n Capture Data Register                  */
  __IO uint32_t  PREDR;                             /*!< (@ 0x40002110) Timer/Counter n Prescaler Data Register                */
  __I  uint32_t  CNT;                               /*!< (@ 0x40002114) Timer/Counter n Counter Register                       */
} TIMER1n_Type;


/* ================================================================================ */
/* ================                TIMER2n [TIMER20]               ================ */
/* ================================================================================ */


/**
  * @brief 32-BIT TIMER2n (TIMER2n)
  */

typedef struct {                                    /*!< (@ 0x40002500) TIMER2n Structure                                      */
  __IO uint32_t  CR;                                /*!< (@ 0x40002500) Timer/Counter n Control Register                       */
  __IO uint32_t  ADR;                               /*!< (@ 0x40002504) Timer/Counter n A Data Register                        */
  __IO uint32_t  BDR;                               /*!< (@ 0x40002508) Timer/Counter n B Data Register                        */
  __I  uint32_t  CAPDR;                             /*!< (@ 0x4000250C) Timer/Counter n Capture Data Register                  */
  __IO uint32_t  PREDR;                             /*!< (@ 0x40002510) Timer/Counter n Prescaler Data Register                */
  __I  uint32_t  CNT;                               /*!< (@ 0x40002514) Timer/Counter n Counter Register                       */
} TIMER2n_Type;


/* ================================================================================ */
/* ================                TIMER3n [TIMER30]               ================ */
/* ================================================================================ */


/**
  * @brief TIMER COUNTER30 (TIMER3n)
  */

typedef struct {                                    /*!< (@ 0x40002400) TIMER3n Structure                                      */
  __IO uint32_t  CR;                                /*!< (@ 0x40002400) Timer/Counter 30 Control Register                      */
  __IO uint32_t  PDR;                               /*!< (@ 0x40002404) Timer/Counter 30 Period Data Register                  */
  __IO uint32_t  ADR;                               /*!< (@ 0x40002408) Timer/Counter 30 A Data Register                       */
  __IO uint32_t  BDR;                               /*!< (@ 0x4000240C) Timer/Counter 30 B Data Register                       */
  __IO uint32_t  CDR;                               /*!< (@ 0x40002410) Timer/Counter 30 C Data Register                       */
  __I  uint32_t  CAPDR;                             /*!< (@ 0x40002414) Timer/Counter 30 Capture Data Register                 */
  __IO uint32_t  PREDR;                             /*!< (@ 0x40002418) Timer/Counter 30 Prescaler Data Register               */
  __I  uint32_t  CNT;                               /*!< (@ 0x4000241C) Timer/Counter 30 Counter Register                      */
  __IO uint32_t  OUTCR;                             /*!< (@ 0x40002420) Timer/Counter 30 Output Control Register               */
  __IO uint32_t  DLY;                               /*!< (@ 0x40002424) Timer/Counter 30 PWM Output Delay Data Register        */
  __IO uint32_t  INTCR;                             /*!< (@ 0x40002428) Timer/Counter 30 Interrupt Control Register            */
  __IO uint32_t  INTFLAG;                           /*!< (@ 0x4000242C) Timer/Counter 30 Interrupt Flag Register               */
  __IO uint32_t  HIZCR;                             /*!< (@ 0x40002430) Timer/Counter 30 High-Impedance Control Register       */
  __IO uint32_t  ADTCR;                             /*!< (@ 0x40002434) Timer/Counter 30 A/DC Trigger Control Register         */
  __IO uint32_t  ADTDR;                             /*!< (@ 0x40002438) Timer/Counter 30 A/DC Trigger Generator Data
                                                         Register                                                              */
} TIMER3n_Type;


/* ================================================================================ */
/* ================                 USART [USART10]                ================ */
/* ================================================================================ */


/**
  * @brief UNIVERSAL SYNCHRONOUS/ASYNCHRONOUS RECEIVER/TRANSMITTER (USART)
  */

typedef struct {                                    /*!< (@ 0x40003800) USART Structure                                        */
  __IO uint32_t  CR1;                               /*!< (@ 0x40003800) USARTn Control Register 1                              */
  __IO uint32_t  CR2;                               /*!< (@ 0x40003804) USARTn Control Register 2                              */
  __I  uint32_t  RESERVED;
  __IO uint32_t  ST;                                /*!< (@ 0x4000380C) USARTn Status Register                                 */
  __IO uint32_t  BDR;                               /*!< (@ 0x40003810) USARTn Baud Rate Generation Register                   */
  __IO uint32_t  DR;                                /*!< (@ 0x40003814) USARTn Data Register                                   */
  __IO uint32_t  BFR;                               /*!< (@ 0x40003818) USARTn Baud-Rate Fraction Count Register               */
  __IO uint32_t  RTO;                               /*!< (@ 0x4000381C) USARTn Receive Time Out Register                       */
} USART_Type;


/* ================================================================================ */
/* ================                  UART [UART0]                  ================ */
/* ================================================================================ */


/**
  * @brief UNIVERSAL ASYNCHRONOUS RECEIVER/TRANSMITTER (UART)
  */

typedef struct {                                    /*!< (@ 0x40004000) UART Structure                                         */
  
  union {
    __O  uint32_t  THR;                             /*!< (@ 0x40004000) UARTn Transmit Data Hold Register                      */
    __I  uint32_t  RBR;                             /*!< (@ 0x40004000) UARTn Receive Buffer Register                          */
  };
  __IO uint32_t  IER;                               /*!< (@ 0x40004004) UARTn Interrupt Enable Register                        */
  __IO uint32_t  IIR;                               /*!< (@ 0x40004008) UARTn Interrupt ID Register                            */
  __IO uint32_t  LCR;                               /*!< (@ 0x4000400C) UARTn Line Control Register                            */
  __IO uint32_t  DCR;                               /*!< (@ 0x40004010) UARTn Data Control Register                            */
  __IO uint32_t  LSR;                               /*!< (@ 0x40004014) UARTn Line Status Register                             */
  __I  uint32_t  RESERVED[2];
  __IO uint32_t  BDR;                               /*!< (@ 0x40004020) UARTn Baud rate Divisor Latch Register                 */
  __IO uint32_t  BFR;                               /*!< (@ 0x40004024) UARTn Baud rate Fraction Counter Register              */
  __I  uint32_t  RESERVED1[2];
  __IO uint32_t  IDTR;                              /*!< (@ 0x40004030) UARTn Inter-frame Delay Time Register                  */
} UART_Type;


/* ================================================================================ */
/* ================                   SPI [SPI20]                  ================ */
/* ================================================================================ */


/**
  * @brief SERIAL PERIPHERAL INTERFACE (SPI)
  */

typedef struct {                                    /*!< (@ 0x40004C00) SPI Structure                                          */
  
  union {
    __I  uint32_t  RDR;                             /*!< (@ 0x40004C00) SPI n Received Data Register                           */
    __O  uint32_t  TDR;                             /*!< (@ 0x40004C00) SPI n Transmit Data Register                           */
  };
  __IO uint32_t  CR;                                /*!< (@ 0x40004C04) SPI n Control Register                                 */
  __IO uint32_t  SR;                                /*!< (@ 0x40004C08) SPI n Status Register                                  */
  __IO uint32_t  BR;                                /*!< (@ 0x40004C0C) SPI n Baud Rate Register                               */
  __IO uint32_t  EN;                                /*!< (@ 0x40004C10) SPI n Enable Register                                  */
  __IO uint32_t  LR;                                /*!< (@ 0x40004C14) SPI n Delay Length Register                            */
} SPI_Type;


/* ================================================================================ */
/* ================                   I2C [I2C0]                   ================ */
/* ================================================================================ */


/**
  * @brief INTER-INTEGRATED CIRCUIT (I2C)
  */

typedef struct {                                    /*!< (@ 0x40004800) I2C Structure                                          */
  __IO uint32_t  CR;                                /*!< (@ 0x40004800) I2C n Control Register                                 */
  __IO uint32_t  ST;                                /*!< (@ 0x40004804) I2C n Status Register                                  */
  __IO uint32_t  SAR1;                              /*!< (@ 0x40004808) I2C n Slave Address Register 1                         */
  __IO uint32_t  SAR2;                              /*!< (@ 0x4000480C) I2C n Slave Address Register 2                         */
  __IO uint32_t  DR;                                /*!< (@ 0x40004810) I2C n Data Register                                    */
  __IO uint32_t  SDHR;                              /*!< (@ 0x40004814) I2C n SDA Hold Time Register                           */
  __IO uint32_t  SCLR;                              /*!< (@ 0x40004818) I2C n SCL Low Period Register                          */
  __IO uint32_t  SCHR;                              /*!< (@ 0x4000481C) I2C n SCL High Period Register                         */
  __IO uint32_t  SLTCR;                             /*!< (@ 0x40004820) I2C n SCL Low Timeout Control Register                 */
  __IO uint32_t  SLTPDR;                            /*!< (@ 0x40004824) I2C n SCL Low Timeout Control Register                 */
  __IO uint32_t  MBCR;                              /*!< (@ 0x40004828) I2C n Manual Bus Control Register                      */
} I2C_Type;


/* ================================================================================ */
/* ================                       ADC                      ================ */
/* ================================================================================ */


/**
  * @brief 12-BIT A/D CONVERTER (ADC)
  */

typedef struct {                                    /*!< (@ 0x40003100) ADC Structure                                          */
  __IO uint32_t  MR;                                /*!< (@ 0x40003100) ADC Mode Register                                      */
  __IO uint32_t  CSCR;                              /*!< (@ 0x40003104) ADC Current Sequence_Channel Register                  */
  __IO uint32_t  CCR;                               /*!< (@ 0x40003108) ADC Clock Control Register                             */
  __IO uint32_t  TRG;                               /*!< (@ 0x4000310C) ADC Trigger Selection Register                         */
  __I  uint32_t  RESERVED[2];
  __IO uint32_t  SCSR1;                             /*!< (@ 0x40003118) ADC Channel Selection Register 1                       */
  __IO uint32_t  SCSR2;                             /*!< (@ 0x4000311C) ADC Channel Selection Register 2                       */
  __IO uint32_t  CR;                                /*!< (@ 0x40003120) ADC Control Register                                   */
  __IO uint32_t  SR;                                /*!< (@ 0x40003124) ADC Status Register                                    */
  __IO uint32_t  IER;                               /*!< (@ 0x40003128) ADC Interrupt Enable Register                          */
  __I  uint32_t  DDR;                               /*!< (@ 0x4000312C) ADC DMA Data Register                                  */
  __IO uint32_t  DR0;                               /*!< (@ 0x40003130) ADC Sequence Data Register0                            */
  __IO uint32_t  DR1;                               /*!< (@ 0x40003134) ADC Sequence Data Register1                            */
  __IO uint32_t  DR2;                               /*!< (@ 0x40003138) ADC Sequence Data Register2                            */
  __IO uint32_t  DR3;                               /*!< (@ 0x4000313C) ADC Sequence Data Register3                            */
  __IO uint32_t  DR4;                               /*!< (@ 0x40003140) ADC Sequence Data Register4                            */
  __IO uint32_t  DR5;                               /*!< (@ 0x40003144) ADC Sequence Data Register5                            */
  __IO uint32_t  DR6;                               /*!< (@ 0x40003148) ADC Sequence Data Register6                            */
  __IO uint32_t  DR7;                               /*!< (@ 0x4000314C) ADC Sequence Data Register7                            */
  __I  uint32_t  RESERVED1[8];
  __IO uint32_t  CMPR;                              /*!< (@ 0x40003170) ADC Channel Compare Register                           */
  __IO uint32_t  BCR;                               /*!< (@ 0x40003174) ADC Buffer Control Register                            */
} ADC_Type;


/* ================================================================================ */
/* ================                       DAC                      ================ */
/* ================================================================================ */


/**
  * @brief 12-BIT D/A CONVERTER (DAC)
  */

typedef struct {                                    /*!< (@ 0x40003450) DAC Structure                                          */
  __IO uint32_t  DR;                                /*!< (@ 0x40003450) D/A Converter Data Register                            */
  __I  uint32_t  BR;                                /*!< (@ 0x40003454) D/A Converter Buffer Register                          */
  __IO uint32_t  CR;                                /*!< (@ 0x40003458) D/A Converter Control Register                         */
  __IO uint32_t  PGSR;                              /*!< (@ 0x4000345C) Programmable Gain Control Register                     */
  __IO uint32_t  OFSCR;                             /*!< (@ 0x40003460) D/A Converter Offset Control Register                  */
  __IO uint32_t  ICR;                               /*!< (@ 0x40003464) D/A Converter Interrupt Control Register               */
} DAC_Type;


/* ================================================================================ */
/* ================                       CMP                      ================ */
/* ================================================================================ */


/**
  * @brief COMPARATOR (CMP)
  */

typedef struct {                                    /*!< (@ 0x40003420) CMP Structure                                          */
  __IO uint32_t  CMP0CR;                            /*!< (@ 0x40003420) Comparator 0 Control Register                          */
  __IO uint32_t  CMP1CR;                            /*!< (@ 0x40003424) Comparator 1 Control Register                          */
  __I  uint32_t  RESERVED[2];
  __IO uint32_t  DBNC;                              /*!< (@ 0x40003430) Comparator Debounce Register                           */
  __IO uint32_t  ICON;                              /*!< (@ 0x40003434) Comparator Interrupt Control Register                  */
  __IO uint32_t  IEN;                               /*!< (@ 0x40003438) Comparator Interrupt Enable Register                   */
  __I  uint32_t  IST;                               /*!< (@ 0x4000343C) Comparator Interrupt Status Register                   */
  __IO uint32_t  ICLR;                              /*!< (@ 0x40003440) Comparator Interrupt Clear Register                    */
} CMP_Type;


/* ================================================================================ */
/* ================                       LCD                      ================ */
/* ================================================================================ */


/**
  * @brief LCD DRIVER (LCD)
  */

typedef struct {                                    /*!< (@ 0x40005000) LCD Structure                                          */
  __IO uint32_t  CR;                                /*!< (@ 0x40005000) LCD Driver Control Register                            */
  __IO uint32_t  BCCR;                              /*!< (@ 0x40005004) LCD Automatic Bias and Contrast Control Register       */
  __I  uint32_t  RESERVED;
  __IO uint32_t  BSSR;                              /*!< (@ 0x4000500C) LCD Bias Source Selection Register                     */
  __IO uint8_t   LCDDR0;                            /*!< (@ 0x40005010) LCD Display Data Register 0                            */
  __IO uint8_t   LCDDR1;                            /*!< (@ 0x40005011) LCD Display Data Register 1                            */
  __IO uint8_t   LCDDR2;                            /*!< (@ 0x40005012) LCD Display Data Register 2                            */
  __IO uint8_t   LCDDR3;                            /*!< (@ 0x40005013) LCD Display Data Register 3                            */
  __IO uint8_t   LCDDR4;                            /*!< (@ 0x40005014) LCD Display Data Register 4                            */
  __IO uint8_t   LCDDR5;                            /*!< (@ 0x40005015) LCD Display Data Register 5                            */
  __IO uint8_t   LCDDR6;                            /*!< (@ 0x40005016) LCD Display Data Register 6                            */
  __IO uint8_t   LCDDR7;                            /*!< (@ 0x40005017) LCD Display Data Register 7                            */
  __IO uint8_t   LCDDR8;                            /*!< (@ 0x40005018) LCD Display Data Register 8                            */
  __IO uint8_t   LCDDR9;                            /*!< (@ 0x40005019) LCD Display Data Register 9                            */
  __IO uint8_t   LCDDR10;                           /*!< (@ 0x4000501A) LCD Display Data Register 10                           */
  __IO uint8_t   LCDDR11;                           /*!< (@ 0x4000501B) LCD Display Data Register 11                           */
  __IO uint8_t   LCDDR12;                           /*!< (@ 0x4000501C) LCD Display Data Register 12                           */
  __IO uint8_t   LCDDR13;                           /*!< (@ 0x4000501D) LCD Display Data Register 13                           */
  __IO uint8_t   LCDDR14;                           /*!< (@ 0x4000501E) LCD Display Data Register 14                           */
  __IO uint8_t   LCDDR15;                           /*!< (@ 0x4000501F) LCD Display Data Register 15                           */
  __IO uint8_t   LCDDR16;                           /*!< (@ 0x40005020) LCD Display Data Register 16                           */
  __IO uint8_t   LCDDR17;                           /*!< (@ 0x40005021) LCD Display Data Register 17                           */
  __IO uint8_t   LCDDR18;                           /*!< (@ 0x40005022) LCD Display Data Register 18                           */
  __IO uint8_t   LCDDR19;                           /*!< (@ 0x40005023) LCD Display Data Register 19                           */
  __IO uint8_t   LCDDR20;                           /*!< (@ 0x40005024) LCD Display Data Register 20                           */
  __IO uint8_t   LCDDR21;                           /*!< (@ 0x40005025) LCD Display Data Register 21                           */
  __IO uint8_t   LCDDR22;                           /*!< (@ 0x40005026) LCD Display Data Register 22                           */
  __IO uint8_t   LCDDR23;                           /*!< (@ 0x40005027) LCD Display Data Register 23                           */
  __IO uint8_t   LCDDR24;                           /*!< (@ 0x40005028) LCD Display Data Register 24                           */
  __IO uint8_t   LCDDR25;                           /*!< (@ 0x40005029) LCD Display Data Register 25                           */
  __IO uint8_t   LCDDR26;                           /*!< (@ 0x4000502A) LCD Display Data Register 26                           */
  __IO uint8_t   LCDDR27;                           /*!< (@ 0x4000502B) LCD Display Data Register 27                           */
  __IO uint8_t   LCDDR28;                           /*!< (@ 0x4000502C) LCD Display Data Register 28                           */
  __IO uint8_t   LCDDR29;                           /*!< (@ 0x4000502D) LCD Display Data Register 29                           */
  __IO uint8_t   LCDDR30;                           /*!< (@ 0x4000502E) LCD Display Data Register 30                           */
  __IO uint8_t   LCDDR31;                           /*!< (@ 0x4000502F) LCD Display Data Register 31                           */
  __IO uint8_t   LCDDR32;                           /*!< (@ 0x40005030) LCD Display Data Register 32                           */
  __IO uint8_t   LCDDR33;                           /*!< (@ 0x40005031) LCD Display Data Register 33                           */
  __IO uint8_t   LCDDR34;                           /*!< (@ 0x40005032) LCD Display Data Register 34                           */
  __IO uint8_t   LCDDR35;                           /*!< (@ 0x40005033) LCD Display Data Register 35                           */
  __IO uint8_t   LCDDR36;                           /*!< (@ 0x40005034) LCD Display Data Register 36                           */
  __IO uint8_t   LCDDR37;                           /*!< (@ 0x40005035) LCD Display Data Register 37                           */
  __IO uint8_t   LCDDR38;                           /*!< (@ 0x40005036) LCD Display Data Register 38                           */
  __IO uint8_t   LCDDR39;                           /*!< (@ 0x40005037) LCD Display Data Register 39                           */
  __IO uint8_t   LCDDR40;                           /*!< (@ 0x40005038) LCD Display Data Register 40                           */
  __IO uint8_t   LCDDR41;                           /*!< (@ 0x40005039) LCD Display Data Register 41                           */
  __IO uint8_t   LCDDR42;                           /*!< (@ 0x4000503A) LCD Display Data Register 42                           */
  __IO uint8_t   LCDDR43;                           /*!< (@ 0x4000503B) LCD Display Data Register 43                           */
} LCD_Type;


/* ================================================================================ */
/* ================                       CRC                      ================ */
/* ================================================================================ */


/**
  * @brief CYCLIC REDUNDANCY CHECK AND CHECKSUM (CRC)
  */

typedef struct {                                    /*!< (@ 0x40000300) CRC Structure                                          */
  __IO uint32_t  CR;                                /*!< (@ 0x40000300) CRC Control Register                                   */
  __IO uint32_t  INIT;                              /*!< (@ 0x40000304) CRC Initial Data Register                              */
  
  union {
    __I  uint32_t  ODR;                             /*!< (@ 0x40000308) CRC Output Data Register                               */
    __O  uint8_t   IDR;                             /*!< (@ 0x40000308) CRC Input Data Register                                */
  };
  __IO uint32_t  SR;                                /*!< (@ 0x4000030C) CRC Status Register                                    */
} CRC_Type;


/* ================================================================================ */
/* ================                       TS                       ================ */
/* ================================================================================ */


/**
  * @brief TEMPERATURE SENSOR (TS)
  */

typedef struct {                                    /*!< (@ 0x40006300) TS Structure                                           */
  __IO uint32_t  CR;                                /*!< (@ 0x40006300) Temperature Sensor Control Register                    */
  __IO uint32_t  RCCNT;                             /*!< (@ 0x40006304) Temperature Sensor Reference Clock Counter Register    */
  __I  uint32_t  SCCNT;                             /*!< (@ 0x40006308) Temperature Sensor Sensing Clock Counter Register      */
  __IO uint32_t  SR;                                /*!< (@ 0x4000630C) Temperature Sensor Status Register                     */
} TS_Type;


/* --------------------  End of section using anonymous unions  ------------------- */
#if defined(__CC_ARM)
  #pragma pop
#elif defined(__ICCARM__)
  /* leave anonymous unions enabled */
#elif defined(__GNUC__)
  /* anonymous unions are enabled by default */
#elif defined(__TMS470__)
  /* anonymous unions are enabled by default */
#elif defined(__TASKING__)
  #pragma warning restore
#else
  #warning Not supported compiler type
#endif



/* ================================================================================ */
/* ================         struct 'SCUCC' Position & Mask         ================ */
/* ================================================================================ */


/* -------------------------------  SCUCC_VENDORID  ------------------------------- */
#define SCUCC_VENDORID_VENDID_Pos             0                                                       /*!< SCUCC VENDORID: VENDID Position         */
#define SCUCC_VENDORID_VENDID_Msk             (0xffffffffUL << SCUCC_VENDORID_VENDID_Pos)             /*!< SCUCC VENDORID: VENDID Mask             */

/* --------------------------------  SCUCC_CHIPID  -------------------------------- */
#define SCUCC_CHIPID_CHIPID_Pos               0                                                       /*!< SCUCC CHIPID: CHIPID Position           */
#define SCUCC_CHIPID_CHIPID_Msk               (0xffffffffUL << SCUCC_CHIPID_CHIPID_Pos)               /*!< SCUCC CHIPID: CHIPID Mask               */

/* ---------------------------------  SCUCC_REVNR  -------------------------------- */
#define SCUCC_REVNR_REVNO_Pos                 0                                                       /*!< SCUCC REVNR: REVNO Position             */
#define SCUCC_REVNR_REVNO_Msk                 (0x000000ffUL << SCUCC_REVNR_REVNO_Pos)                 /*!< SCUCC REVNR: REVNO Mask                 */


/* ================================================================================ */
/* ================          struct 'SCU' Position & Mask          ================ */
/* ================================================================================ */


/* -----------------------------------  SCU_SMR  ---------------------------------- */
#define SCU_SMR_PREVMODE_Pos                  4                                                       /*!< SCU SMR: PREVMODE Position              */
#define SCU_SMR_PREVMODE_Msk                  (0x03UL << SCU_SMR_PREVMODE_Pos)                        /*!< SCU SMR: PREVMODE Mask                  */
#define SCU_SMR_VDCAON_Pos                    8                                                       /*!< SCU SMR: VDCAON Position                */
#define SCU_SMR_VDCAON_Msk                    (0x01UL << SCU_SMR_VDCAON_Pos)                          /*!< SCU SMR: VDCAON Mask                    */
#define SCU_SMR_BGRAON_Pos                    9                                                       /*!< SCU SMR: BGRAON Position                */
#define SCU_SMR_BGRAON_Msk                    (0x01UL << SCU_SMR_BGRAON_Pos)                          /*!< SCU SMR: BGRAON Mask                    */
#define SCU_SMR_LSIAON_Pos                    10                                                      /*!< SCU SMR: LSIAON Position                */
#define SCU_SMR_LSIAON_Msk                    (0x01UL << SCU_SMR_LSIAON_Pos)                          /*!< SCU SMR: LSIAON Mask                    */
#define SCU_SMR_LSEAON_Pos                    11                                                      /*!< SCU SMR: LSEAON Position                */
#define SCU_SMR_LSEAON_Msk                    (0x01UL << SCU_SMR_LSEAON_Pos)                          /*!< SCU SMR: LSEAON Mask                    */

/* -----------------------------------  SCU_SCR  ---------------------------------- */
#define SCU_SCR_SWRST_Pos                     0                                                       /*!< SCU SCR: SWRST Position                 */
#define SCU_SCR_SWRST_Msk                     (0x01UL << SCU_SCR_SWRST_Pos)                           /*!< SCU SCR: SWRST Mask                     */
#define SCU_SCR_WTIDKY_Pos                    16                                                      /*!< SCU SCR: WTIDKY Position                */
#define SCU_SCR_WTIDKY_Msk                    (0x0000ffffUL << SCU_SCR_WTIDKY_Pos)                    /*!< SCU SCR: WTIDKY Mask                    */

/* ----------------------------------  SCU_WUER  ---------------------------------- */
#define SCU_WUER_LVDWUE_Pos                   0                                                       /*!< SCU WUER: LVDWUE Position               */
#define SCU_WUER_LVDWUE_Msk                   (0x01UL << SCU_WUER_LVDWUE_Pos)                         /*!< SCU WUER: LVDWUE Mask                   */
#define SCU_WUER_WDTWUE_Pos                   1                                                       /*!< SCU WUER: WDTWUE Position               */
#define SCU_WUER_WDTWUE_Msk                   (0x01UL << SCU_WUER_WDTWUE_Pos)                         /*!< SCU WUER: WDTWUE Mask                   */
#define SCU_WUER_WTWUE_Pos                    2                                                       /*!< SCU WUER: WTWUE Position                */
#define SCU_WUER_WTWUE_Msk                    (0x01UL << SCU_WUER_WTWUE_Pos)                          /*!< SCU WUER: WTWUE Mask                    */
#define SCU_WUER_GPIOAWUE_Pos                 8                                                       /*!< SCU WUER: GPIOAWUE Position             */
#define SCU_WUER_GPIOAWUE_Msk                 (0x01UL << SCU_WUER_GPIOAWUE_Pos)                       /*!< SCU WUER: GPIOAWUE Mask                 */
#define SCU_WUER_GPIOBWUE_Pos                 9                                                       /*!< SCU WUER: GPIOBWUE Position             */
#define SCU_WUER_GPIOBWUE_Msk                 (0x01UL << SCU_WUER_GPIOBWUE_Pos)                       /*!< SCU WUER: GPIOBWUE Mask                 */
#define SCU_WUER_GPIOCWUE_Pos                 10                                                      /*!< SCU WUER: GPIOCWUE Position             */
#define SCU_WUER_GPIOCWUE_Msk                 (0x01UL << SCU_WUER_GPIOCWUE_Pos)                       /*!< SCU WUER: GPIOCWUE Mask                 */
#define SCU_WUER_GPIODWUE_Pos                 11                                                      /*!< SCU WUER: GPIODWUE Position             */
#define SCU_WUER_GPIODWUE_Msk                 (0x01UL << SCU_WUER_GPIODWUE_Pos)                       /*!< SCU WUER: GPIODWUE Mask                 */
#define SCU_WUER_GPIOEWUE_Pos                 12                                                      /*!< SCU WUER: GPIOEWUE Position             */
#define SCU_WUER_GPIOEWUE_Msk                 (0x01UL << SCU_WUER_GPIOEWUE_Pos)                       /*!< SCU WUER: GPIOEWUE Mask                 */
#define SCU_WUER_GPIOFWUE_Pos                 13                                                      /*!< SCU WUER: GPIOFWUE Position             */
#define SCU_WUER_GPIOFWUE_Msk                 (0x01UL << SCU_WUER_GPIOFWUE_Pos)                       /*!< SCU WUER: GPIOFWUE Mask                 */

/* ----------------------------------  SCU_WUSR  ---------------------------------- */
#define SCU_WUSR_LVDWU_Pos                    0                                                       /*!< SCU WUSR: LVDWU Position                */
#define SCU_WUSR_LVDWU_Msk                    (0x01UL << SCU_WUSR_LVDWU_Pos)                          /*!< SCU WUSR: LVDWU Mask                    */
#define SCU_WUSR_WDTWU_Pos                    1                                                       /*!< SCU WUSR: WDTWU Position                */
#define SCU_WUSR_WDTWU_Msk                    (0x01UL << SCU_WUSR_WDTWU_Pos)                          /*!< SCU WUSR: WDTWU Mask                    */
#define SCU_WUSR_WTWU_Pos                     2                                                       /*!< SCU WUSR: WTWU Position                 */
#define SCU_WUSR_WTWU_Msk                     (0x01UL << SCU_WUSR_WTWU_Pos)                           /*!< SCU WUSR: WTWU Mask                     */
#define SCU_WUSR_GPIOAWU_Pos                  8                                                       /*!< SCU WUSR: GPIOAWU Position              */
#define SCU_WUSR_GPIOAWU_Msk                  (0x01UL << SCU_WUSR_GPIOAWU_Pos)                        /*!< SCU WUSR: GPIOAWU Mask                  */
#define SCU_WUSR_GPIOBWU_Pos                  9                                                       /*!< SCU WUSR: GPIOBWU Position              */
#define SCU_WUSR_GPIOBWU_Msk                  (0x01UL << SCU_WUSR_GPIOBWU_Pos)                        /*!< SCU WUSR: GPIOBWU Mask                  */
#define SCU_WUSR_GPIOCWU_Pos                  10                                                      /*!< SCU WUSR: GPIOCWU Position              */
#define SCU_WUSR_GPIOCWU_Msk                  (0x01UL << SCU_WUSR_GPIOCWU_Pos)                        /*!< SCU WUSR: GPIOCWU Mask                  */
#define SCU_WUSR_GPIODWU_Pos                  11                                                      /*!< SCU WUSR: GPIODWU Position              */
#define SCU_WUSR_GPIODWU_Msk                  (0x01UL << SCU_WUSR_GPIODWU_Pos)                        /*!< SCU WUSR: GPIODWU Mask                  */
#define SCU_WUSR_GPIOEWU_Pos                  12                                                      /*!< SCU WUSR: GPIOEWU Position              */
#define SCU_WUSR_GPIOEWU_Msk                  (0x01UL << SCU_WUSR_GPIOEWU_Pos)                        /*!< SCU WUSR: GPIOEWU Mask                  */
#define SCU_WUSR_GPIOFWU_Pos                  13                                                      /*!< SCU WUSR: GPIOFWU Position              */
#define SCU_WUSR_GPIOFWU_Msk                  (0x01UL << SCU_WUSR_GPIOFWU_Pos)                        /*!< SCU WUSR: GPIOFWU Mask                  */

/* ----------------------------------  SCU_RSER  ---------------------------------- */
#define SCU_RSER_LVDRST_Pos                   0                                                       /*!< SCU RSER: LVDRST Position               */
#define SCU_RSER_LVDRST_Msk                   (0x01UL << SCU_RSER_LVDRST_Pos)                         /*!< SCU RSER: LVDRST Mask                   */
#define SCU_RSER_HSEFRST_Pos                  1                                                       /*!< SCU RSER: HSEFRST Position              */
#define SCU_RSER_HSEFRST_Msk                  (0x01UL << SCU_RSER_HSEFRST_Pos)                        /*!< SCU RSER: HSEFRST Mask                  */
#define SCU_RSER_MCKFRST_Pos                  2                                                       /*!< SCU RSER: MCKFRST Position              */
#define SCU_RSER_MCKFRST_Msk                  (0x01UL << SCU_RSER_MCKFRST_Pos)                        /*!< SCU RSER: MCKFRST Mask                  */
#define SCU_RSER_WDTRST_Pos                   3                                                       /*!< SCU RSER: WDTRST Position               */
#define SCU_RSER_WDTRST_Msk                   (0x01UL << SCU_RSER_WDTRST_Pos)                         /*!< SCU RSER: WDTRST Mask                   */
#define SCU_RSER_SWRST_Pos                    4                                                       /*!< SCU RSER: SWRST Position                */
#define SCU_RSER_SWRST_Msk                    (0x01UL << SCU_RSER_SWRST_Pos)                          /*!< SCU RSER: SWRST Mask                    */
#define SCU_RSER_CPURST_Pos                   5                                                       /*!< SCU RSER: CPURST Position               */
#define SCU_RSER_CPURST_Msk                   (0x01UL << SCU_RSER_CPURST_Pos)                         /*!< SCU RSER: CPURST Mask                   */
#define SCU_RSER_PINRST_Pos                   6                                                       /*!< SCU RSER: PINRST Position               */
#define SCU_RSER_PINRST_Msk                   (0x01UL << SCU_RSER_PINRST_Pos)                         /*!< SCU RSER: PINRST Mask                   */

/* ----------------------------------  SCU_RSSR  ---------------------------------- */
#define SCU_RSSR_LVDRST_Pos                   0                                                       /*!< SCU RSSR: LVDRST Position               */
#define SCU_RSSR_LVDRST_Msk                   (0x01UL << SCU_RSSR_LVDRST_Pos)                         /*!< SCU RSSR: LVDRST Mask                   */
#define SCU_RSSR_HSEFRST_Pos                  1                                                       /*!< SCU RSSR: HSEFRST Position              */
#define SCU_RSSR_HSEFRST_Msk                  (0x01UL << SCU_RSSR_HSEFRST_Pos)                        /*!< SCU RSSR: HSEFRST Mask                  */
#define SCU_RSSR_MCKFRST_Pos                  2                                                       /*!< SCU RSSR: MCKFRST Position              */
#define SCU_RSSR_MCKFRST_Msk                  (0x01UL << SCU_RSSR_MCKFRST_Pos)                        /*!< SCU RSSR: MCKFRST Mask                  */
#define SCU_RSSR_WDTRST_Pos                   3                                                       /*!< SCU RSSR: WDTRST Position               */
#define SCU_RSSR_WDTRST_Msk                   (0x01UL << SCU_RSSR_WDTRST_Pos)                         /*!< SCU RSSR: WDTRST Mask                   */
#define SCU_RSSR_SWRST_Pos                    4                                                       /*!< SCU RSSR: SWRST Position                */
#define SCU_RSSR_SWRST_Msk                    (0x01UL << SCU_RSSR_SWRST_Pos)                          /*!< SCU RSSR: SWRST Mask                    */
#define SCU_RSSR_CPURST_Pos                   5                                                       /*!< SCU RSSR: CPURST Position               */
#define SCU_RSSR_CPURST_Msk                   (0x01UL << SCU_RSSR_CPURST_Pos)                         /*!< SCU RSSR: CPURST Mask                   */
#define SCU_RSSR_PINRST_Pos                   6                                                       /*!< SCU RSSR: PINRST Position               */
#define SCU_RSSR_PINRST_Msk                   (0x01UL << SCU_RSSR_PINRST_Pos)                         /*!< SCU RSSR: PINRST Mask                   */
#define SCU_RSSR_PORST_Pos                    7                                                       /*!< SCU RSSR: PORST Position                */
#define SCU_RSSR_PORST_Msk                    (0x01UL << SCU_RSSR_PORST_Pos)                          /*!< SCU RSSR: PORST Mask                    */

/* ----------------------------------  SCU_PRER1  --------------------------------- */
#define SCU_PRER1_SCU_Pos                     0                                                       /*!< SCU PRER1: SCU Position                 */
#define SCU_PRER1_SCU_Msk                     (0x01UL << SCU_PRER1_SCU_Pos)                           /*!< SCU PRER1: SCU Mask                     */
#define SCU_PRER1_FMC_Pos                     1                                                       /*!< SCU PRER1: FMC Position                 */
#define SCU_PRER1_FMC_Msk                     (0x01UL << SCU_PRER1_FMC_Pos)                           /*!< SCU PRER1: FMC Mask                     */
#define SCU_PRER1_WDT_Pos                     2                                                       /*!< SCU PRER1: WDT Position                 */
#define SCU_PRER1_WDT_Msk                     (0x01UL << SCU_PRER1_WDT_Pos)                           /*!< SCU PRER1: WDT Mask                     */
#define SCU_PRER1_PCU_Pos                     3                                                       /*!< SCU PRER1: PCU Position                 */
#define SCU_PRER1_PCU_Msk                     (0x01UL << SCU_PRER1_PCU_Pos)                           /*!< SCU PRER1: PCU Mask                     */
#define SCU_PRER1_DMA_Pos                     4                                                       /*!< SCU PRER1: DMA Position                 */
#define SCU_PRER1_DMA_Msk                     (0x01UL << SCU_PRER1_DMA_Pos)                           /*!< SCU PRER1: DMA Mask                     */
#define SCU_PRER1_GPIOA_Pos                   8                                                       /*!< SCU PRER1: GPIOA Position               */
#define SCU_PRER1_GPIOA_Msk                   (0x01UL << SCU_PRER1_GPIOA_Pos)                         /*!< SCU PRER1: GPIOA Mask                   */
#define SCU_PRER1_GPIOB_Pos                   9                                                       /*!< SCU PRER1: GPIOB Position               */
#define SCU_PRER1_GPIOB_Msk                   (0x01UL << SCU_PRER1_GPIOB_Pos)                         /*!< SCU PRER1: GPIOB Mask                   */
#define SCU_PRER1_GPIOC_Pos                   10                                                      /*!< SCU PRER1: GPIOC Position               */
#define SCU_PRER1_GPIOC_Msk                   (0x01UL << SCU_PRER1_GPIOC_Pos)                         /*!< SCU PRER1: GPIOC Mask                   */
#define SCU_PRER1_GPIOD_Pos                   11                                                      /*!< SCU PRER1: GPIOD Position               */
#define SCU_PRER1_GPIOD_Msk                   (0x01UL << SCU_PRER1_GPIOD_Pos)                         /*!< SCU PRER1: GPIOD Mask                   */
#define SCU_PRER1_GPIOE_Pos                   12                                                      /*!< SCU PRER1: GPIOE Position               */
#define SCU_PRER1_GPIOE_Msk                   (0x01UL << SCU_PRER1_GPIOE_Pos)                         /*!< SCU PRER1: GPIOE Mask                   */
#define SCU_PRER1_GPIOF_Pos                   13                                                      /*!< SCU PRER1: GPIOF Position               */
#define SCU_PRER1_GPIOF_Msk                   (0x01UL << SCU_PRER1_GPIOF_Pos)                         /*!< SCU PRER1: GPIOF Mask                   */
#define SCU_PRER1_TIMER10_Pos                 16                                                      /*!< SCU PRER1: TIMER10 Position             */
#define SCU_PRER1_TIMER10_Msk                 (0x01UL << SCU_PRER1_TIMER10_Pos)                       /*!< SCU PRER1: TIMER10 Mask                 */
#define SCU_PRER1_TIMER11_Pos                 17                                                      /*!< SCU PRER1: TIMER11 Position             */
#define SCU_PRER1_TIMER11_Msk                 (0x01UL << SCU_PRER1_TIMER11_Pos)                       /*!< SCU PRER1: TIMER11 Mask                 */
#define SCU_PRER1_TIMER12_Pos                 18                                                      /*!< SCU PRER1: TIMER12 Position             */
#define SCU_PRER1_TIMER12_Msk                 (0x01UL << SCU_PRER1_TIMER12_Pos)                       /*!< SCU PRER1: TIMER12 Mask                 */
#define SCU_PRER1_TIMER13_Pos                 19                                                      /*!< SCU PRER1: TIMER13 Position             */
#define SCU_PRER1_TIMER13_Msk                 (0x01UL << SCU_PRER1_TIMER13_Pos)                       /*!< SCU PRER1: TIMER13 Mask                 */
#define SCU_PRER1_TIMER14_Pos                 20                                                      /*!< SCU PRER1: TIMER14 Position             */
#define SCU_PRER1_TIMER14_Msk                 (0x01UL << SCU_PRER1_TIMER14_Pos)                       /*!< SCU PRER1: TIMER14 Mask                 */
#define SCU_PRER1_TIMER15_Pos                 21                                                      /*!< SCU PRER1: TIMER15 Position             */
#define SCU_PRER1_TIMER15_Msk                 (0x01UL << SCU_PRER1_TIMER15_Pos)                       /*!< SCU PRER1: TIMER15 Mask                 */
#define SCU_PRER1_TIMER16_Pos                 22                                                      /*!< SCU PRER1: TIMER16 Position             */
#define SCU_PRER1_TIMER16_Msk                 (0x01UL << SCU_PRER1_TIMER16_Pos)                       /*!< SCU PRER1: TIMER16 Mask                 */
#define SCU_PRER1_TIMER30_Pos                 24                                                      /*!< SCU PRER1: TIMER30 Position             */
#define SCU_PRER1_TIMER30_Msk                 (0x01UL << SCU_PRER1_TIMER30_Pos)                       /*!< SCU PRER1: TIMER30 Mask                 */
#define SCU_PRER1_TIMER20_Pos                 25                                                      /*!< SCU PRER1: TIMER20 Position             */
#define SCU_PRER1_TIMER20_Msk                 (0x01UL << SCU_PRER1_TIMER20_Pos)                       /*!< SCU PRER1: TIMER20 Mask                 */
#define SCU_PRER1_TIMER21_Pos                 26                                                      /*!< SCU PRER1: TIMER21 Position             */
#define SCU_PRER1_TIMER21_Msk                 (0x01UL << SCU_PRER1_TIMER21_Pos)                       /*!< SCU PRER1: TIMER21 Mask                 */
#define SCU_PRER1_WT_Pos                      31                                                      /*!< SCU PRER1: WT Position                  */
#define SCU_PRER1_WT_Msk                      (0x01UL << SCU_PRER1_WT_Pos)                            /*!< SCU PRER1: WT Mask                      */

/* ----------------------------------  SCU_PRER2  --------------------------------- */
#define SCU_PRER2_I2C0_Pos                    4                                                       /*!< SCU PRER2: I2C0 Position                */
#define SCU_PRER2_I2C0_Msk                    (0x01UL << SCU_PRER2_I2C0_Pos)                          /*!< SCU PRER2: I2C0 Mask                    */
#define SCU_PRER2_I2C1_Pos                    5                                                       /*!< SCU PRER2: I2C1 Position                */
#define SCU_PRER2_I2C1_Msk                    (0x01UL << SCU_PRER2_I2C1_Pos)                          /*!< SCU PRER2: I2C1 Mask                    */
#define SCU_PRER2_I2C2_Pos                    6                                                       /*!< SCU PRER2: I2C2 Position                */
#define SCU_PRER2_I2C2_Msk                    (0x01UL << SCU_PRER2_I2C2_Pos)                          /*!< SCU PRER2: I2C2 Mask                    */
#define SCU_PRER2_USART10_Pos                 8                                                       /*!< SCU PRER2: USART10 Position             */
#define SCU_PRER2_USART10_Msk                 (0x01UL << SCU_PRER2_USART10_Pos)                       /*!< SCU PRER2: USART10 Mask                 */
#define SCU_PRER2_USART11_Pos                 9                                                       /*!< SCU PRER2: USART11 Position             */
#define SCU_PRER2_USART11_Msk                 (0x01UL << SCU_PRER2_USART11_Pos)                       /*!< SCU PRER2: USART11 Mask                 */
#define SCU_PRER2_USART12_Pos                 10                                                      /*!< SCU PRER2: USART12 Position             */
#define SCU_PRER2_USART12_Msk                 (0x01UL << SCU_PRER2_USART12_Pos)                       /*!< SCU PRER2: USART12 Mask                 */
#define SCU_PRER2_USART13_Pos                 11                                                      /*!< SCU PRER2: USART13 Position             */
#define SCU_PRER2_USART13_Msk                 (0x01UL << SCU_PRER2_USART13_Pos)                       /*!< SCU PRER2: USART13 Mask                 */
#define SCU_PRER2_UART0_Pos                   12                                                      /*!< SCU PRER2: UART0 Position               */
#define SCU_PRER2_UART0_Msk                   (0x01UL << SCU_PRER2_UART0_Pos)                         /*!< SCU PRER2: UART0 Mask                   */
#define SCU_PRER2_UART1_Pos                   13                                                      /*!< SCU PRER2: UART1 Position               */
#define SCU_PRER2_UART1_Msk                   (0x01UL << SCU_PRER2_UART1_Pos)                         /*!< SCU PRER2: UART1 Mask                   */
#define SCU_PRER2_SPI20_Pos                   14                                                      /*!< SCU PRER2: SPI20 Position               */
#define SCU_PRER2_SPI20_Msk                   (0x01UL << SCU_PRER2_SPI20_Pos)                         /*!< SCU PRER2: SPI20 Mask                   */
#define SCU_PRER2_SPI21_Pos                   15                                                      /*!< SCU PRER2: SPI21 Position               */
#define SCU_PRER2_SPI21_Msk                   (0x01UL << SCU_PRER2_SPI21_Pos)                         /*!< SCU PRER2: SPI21 Mask                   */
#define SCU_PRER2_ADC_Pos                     20                                                      /*!< SCU PRER2: ADC Position                 */
#define SCU_PRER2_ADC_Msk                     (0x01UL << SCU_PRER2_ADC_Pos)                           /*!< SCU PRER2: ADC Mask                     */
#define SCU_PRER2_DAC_Pos                     22                                                      /*!< SCU PRER2: DAC Position                 */
#define SCU_PRER2_DAC_Msk                     (0x01UL << SCU_PRER2_DAC_Pos)                           /*!< SCU PRER2: DAC Mask                     */
#define SCU_PRER2_CMP_Pos                     23                                                      /*!< SCU PRER2: CMP Position                 */
#define SCU_PRER2_CMP_Msk                     (0x01UL << SCU_PRER2_CMP_Pos)                           /*!< SCU PRER2: CMP Mask                     */
#define SCU_PRER2_TS_Pos                      27                                                      /*!< SCU PRER2: TS Position                  */
#define SCU_PRER2_TS_Msk                      (0x01UL << SCU_PRER2_TS_Pos)                            /*!< SCU PRER2: TS Mask                      */
#define SCU_PRER2_LCD_Pos                     28                                                      /*!< SCU PRER2: LCD Position                 */
#define SCU_PRER2_LCD_Msk                     (0x01UL << SCU_PRER2_LCD_Pos)                           /*!< SCU PRER2: LCD Mask                     */
#define SCU_PRER2_CRC_Pos                     31                                                      /*!< SCU PRER2: CRC Position                 */
#define SCU_PRER2_CRC_Msk                     (0x01UL << SCU_PRER2_CRC_Pos)                           /*!< SCU PRER2: CRC Mask                     */

/* ----------------------------------  SCU_PER1  ---------------------------------- */
#define SCU_PER1_DMA_Pos                      4                                                       /*!< SCU PER1: DMA Position                  */
#define SCU_PER1_DMA_Msk                      (0x01UL << SCU_PER1_DMA_Pos)                            /*!< SCU PER1: DMA Mask                      */
#define SCU_PER1_GPIOA_Pos                    8                                                       /*!< SCU PER1: GPIOA Position                */
#define SCU_PER1_GPIOA_Msk                    (0x01UL << SCU_PER1_GPIOA_Pos)                          /*!< SCU PER1: GPIOA Mask                    */
#define SCU_PER1_GPIOB_Pos                    9                                                       /*!< SCU PER1: GPIOB Position                */
#define SCU_PER1_GPIOB_Msk                    (0x01UL << SCU_PER1_GPIOB_Pos)                          /*!< SCU PER1: GPIOB Mask                    */
#define SCU_PER1_GPIOC_Pos                    10                                                      /*!< SCU PER1: GPIOC Position                */
#define SCU_PER1_GPIOC_Msk                    (0x01UL << SCU_PER1_GPIOC_Pos)                          /*!< SCU PER1: GPIOC Mask                    */
#define SCU_PER1_GPIOD_Pos                    11                                                      /*!< SCU PER1: GPIOD Position                */
#define SCU_PER1_GPIOD_Msk                    (0x01UL << SCU_PER1_GPIOD_Pos)                          /*!< SCU PER1: GPIOD Mask                    */
#define SCU_PER1_GPIOE_Pos                    12                                                      /*!< SCU PER1: GPIOE Position                */
#define SCU_PER1_GPIOE_Msk                    (0x01UL << SCU_PER1_GPIOE_Pos)                          /*!< SCU PER1: GPIOE Mask                    */
#define SCU_PER1_GPIOF_Pos                    13                                                      /*!< SCU PER1: GPIOF Position                */
#define SCU_PER1_GPIOF_Msk                    (0x01UL << SCU_PER1_GPIOF_Pos)                          /*!< SCU PER1: GPIOF Mask                    */
#define SCU_PER1_TIMER10_Pos                  16                                                      /*!< SCU PER1: TIMER10 Position              */
#define SCU_PER1_TIMER10_Msk                  (0x01UL << SCU_PER1_TIMER10_Pos)                        /*!< SCU PER1: TIMER10 Mask                  */
#define SCU_PER1_TIMER11_Pos                  17                                                      /*!< SCU PER1: TIMER11 Position              */
#define SCU_PER1_TIMER11_Msk                  (0x01UL << SCU_PER1_TIMER11_Pos)                        /*!< SCU PER1: TIMER11 Mask                  */
#define SCU_PER1_TIMER12_Pos                  18                                                      /*!< SCU PER1: TIMER12 Position              */
#define SCU_PER1_TIMER12_Msk                  (0x01UL << SCU_PER1_TIMER12_Pos)                        /*!< SCU PER1: TIMER12 Mask                  */
#define SCU_PER1_TIMER13_Pos                  19                                                      /*!< SCU PER1: TIMER13 Position              */
#define SCU_PER1_TIMER13_Msk                  (0x01UL << SCU_PER1_TIMER13_Pos)                        /*!< SCU PER1: TIMER13 Mask                  */
#define SCU_PER1_TIMER14_Pos                  20                                                      /*!< SCU PER1: TIMER14 Position              */
#define SCU_PER1_TIMER14_Msk                  (0x01UL << SCU_PER1_TIMER14_Pos)                        /*!< SCU PER1: TIMER14 Mask                  */
#define SCU_PER1_TIMER15_Pos                  21                                                      /*!< SCU PER1: TIMER15 Position              */
#define SCU_PER1_TIMER15_Msk                  (0x01UL << SCU_PER1_TIMER15_Pos)                        /*!< SCU PER1: TIMER15 Mask                  */
#define SCU_PER1_TIMER16_Pos                  22                                                      /*!< SCU PER1: TIMER16 Position              */
#define SCU_PER1_TIMER16_Msk                  (0x01UL << SCU_PER1_TIMER16_Pos)                        /*!< SCU PER1: TIMER16 Mask                  */
#define SCU_PER1_TIMER30_Pos                  24                                                      /*!< SCU PER1: TIMER30 Position              */
#define SCU_PER1_TIMER30_Msk                  (0x01UL << SCU_PER1_TIMER30_Pos)                        /*!< SCU PER1: TIMER30 Mask                  */
#define SCU_PER1_TIMER20_Pos                  25                                                      /*!< SCU PER1: TIMER20 Position              */
#define SCU_PER1_TIMER20_Msk                  (0x01UL << SCU_PER1_TIMER20_Pos)                        /*!< SCU PER1: TIMER20 Mask                  */
#define SCU_PER1_TIMER21_Pos                  26                                                      /*!< SCU PER1: TIMER21 Position              */
#define SCU_PER1_TIMER21_Msk                  (0x01UL << SCU_PER1_TIMER21_Pos)                        /*!< SCU PER1: TIMER21 Mask                  */
#define SCU_PER1_WT_Pos                       31                                                      /*!< SCU PER1: WT Position                   */
#define SCU_PER1_WT_Msk                       (0x01UL << SCU_PER1_WT_Pos)                             /*!< SCU PER1: WT Mask                       */

/* ----------------------------------  SCU_PER2  ---------------------------------- */
#define SCU_PER2_I2C0_Pos                     4                                                       /*!< SCU PER2: I2C0 Position                 */
#define SCU_PER2_I2C0_Msk                     (0x01UL << SCU_PER2_I2C0_Pos)                           /*!< SCU PER2: I2C0 Mask                     */
#define SCU_PER2_I2C1_Pos                     5                                                       /*!< SCU PER2: I2C1 Position                 */
#define SCU_PER2_I2C1_Msk                     (0x01UL << SCU_PER2_I2C1_Pos)                           /*!< SCU PER2: I2C1 Mask                     */
#define SCU_PER2_I2C2_Pos                     6                                                       /*!< SCU PER2: I2C2 Position                 */
#define SCU_PER2_I2C2_Msk                     (0x01UL << SCU_PER2_I2C2_Pos)                           /*!< SCU PER2: I2C2 Mask                     */
#define SCU_PER2_USART10_Pos                  8                                                       /*!< SCU PER2: USART10 Position              */
#define SCU_PER2_USART10_Msk                  (0x01UL << SCU_PER2_USART10_Pos)                        /*!< SCU PER2: USART10 Mask                  */
#define SCU_PER2_USART11_Pos                  9                                                       /*!< SCU PER2: USART11 Position              */
#define SCU_PER2_USART11_Msk                  (0x01UL << SCU_PER2_USART11_Pos)                        /*!< SCU PER2: USART11 Mask                  */
#define SCU_PER2_USART12_Pos                  10                                                      /*!< SCU PER2: USART12 Position              */
#define SCU_PER2_USART12_Msk                  (0x01UL << SCU_PER2_USART12_Pos)                        /*!< SCU PER2: USART12 Mask                  */
#define SCU_PER2_USART13_Pos                  11                                                      /*!< SCU PER2: USART13 Position              */
#define SCU_PER2_USART13_Msk                  (0x01UL << SCU_PER2_USART13_Pos)                        /*!< SCU PER2: USART13 Mask                  */
#define SCU_PER2_UART0_Pos                    12                                                      /*!< SCU PER2: UART0 Position                */
#define SCU_PER2_UART0_Msk                    (0x01UL << SCU_PER2_UART0_Pos)                          /*!< SCU PER2: UART0 Mask                    */
#define SCU_PER2_UART1_Pos                    13                                                      /*!< SCU PER2: UART1 Position                */
#define SCU_PER2_UART1_Msk                    (0x01UL << SCU_PER2_UART1_Pos)                          /*!< SCU PER2: UART1 Mask                    */
#define SCU_PER2_SPI20_Pos                    14                                                      /*!< SCU PER2: SPI20 Position                */
#define SCU_PER2_SPI20_Msk                    (0x01UL << SCU_PER2_SPI20_Pos)                          /*!< SCU PER2: SPI20 Mask                    */
#define SCU_PER2_SPI21_Pos                    15                                                      /*!< SCU PER2: SPI21 Position                */
#define SCU_PER2_SPI21_Msk                    (0x01UL << SCU_PER2_SPI21_Pos)                          /*!< SCU PER2: SPI21 Mask                    */
#define SCU_PER2_ADC_Pos                      20                                                      /*!< SCU PER2: ADC Position                  */
#define SCU_PER2_ADC_Msk                      (0x01UL << SCU_PER2_ADC_Pos)                            /*!< SCU PER2: ADC Mask                      */
#define SCU_PER2_DAC_Pos                      22                                                      /*!< SCU PER2: DAC Position                  */
#define SCU_PER2_DAC_Msk                      (0x01UL << SCU_PER2_DAC_Pos)                            /*!< SCU PER2: DAC Mask                      */
#define SCU_PER2_CMP_Pos                      23                                                      /*!< SCU PER2: CMP Position                  */
#define SCU_PER2_CMP_Msk                      (0x01UL << SCU_PER2_CMP_Pos)                            /*!< SCU PER2: CMP Mask                      */
#define SCU_PER2_TS_Pos                       27                                                      /*!< SCU PER2: TS Position                   */
#define SCU_PER2_TS_Msk                       (0x01UL << SCU_PER2_TS_Pos)                             /*!< SCU PER2: TS Mask                       */
#define SCU_PER2_LCD_Pos                      28                                                      /*!< SCU PER2: LCD Position                  */
#define SCU_PER2_LCD_Msk                      (0x01UL << SCU_PER2_LCD_Pos)                            /*!< SCU PER2: LCD Mask                      */
#define SCU_PER2_CRC_Pos                      31                                                      /*!< SCU PER2: CRC Position                  */
#define SCU_PER2_CRC_Msk                      (0x01UL << SCU_PER2_CRC_Pos)                            /*!< SCU PER2: CRC Mask                      */

/* ----------------------------------  SCU_PCER1  --------------------------------- */
#define SCU_PCER1_DMA_Pos                     4                                                       /*!< SCU PCER1: DMA Position                 */
#define SCU_PCER1_DMA_Msk                     (0x01UL << SCU_PCER1_DMA_Pos)                           /*!< SCU PCER1: DMA Mask                     */
#define SCU_PCER1_GPIOA_Pos                   8                                                       /*!< SCU PCER1: GPIOA Position               */
#define SCU_PCER1_GPIOA_Msk                   (0x01UL << SCU_PCER1_GPIOA_Pos)                         /*!< SCU PCER1: GPIOA Mask                   */
#define SCU_PCER1_GPIOB_Pos                   9                                                       /*!< SCU PCER1: GPIOB Position               */
#define SCU_PCER1_GPIOB_Msk                   (0x01UL << SCU_PCER1_GPIOB_Pos)                         /*!< SCU PCER1: GPIOB Mask                   */
#define SCU_PCER1_GPIOC_Pos                   10                                                      /*!< SCU PCER1: GPIOC Position               */
#define SCU_PCER1_GPIOC_Msk                   (0x01UL << SCU_PCER1_GPIOC_Pos)                         /*!< SCU PCER1: GPIOC Mask                   */
#define SCU_PCER1_GPIOD_Pos                   11                                                      /*!< SCU PCER1: GPIOD Position               */
#define SCU_PCER1_GPIOD_Msk                   (0x01UL << SCU_PCER1_GPIOD_Pos)                         /*!< SCU PCER1: GPIOD Mask                   */
#define SCU_PCER1_GPIOE_Pos                   12                                                      /*!< SCU PCER1: GPIOE Position               */
#define SCU_PCER1_GPIOE_Msk                   (0x01UL << SCU_PCER1_GPIOE_Pos)                         /*!< SCU PCER1: GPIOE Mask                   */
#define SCU_PCER1_GPIOF_Pos                   13                                                      /*!< SCU PCER1: GPIOF Position               */
#define SCU_PCER1_GPIOF_Msk                   (0x01UL << SCU_PCER1_GPIOF_Pos)                         /*!< SCU PCER1: GPIOF Mask                   */
#define SCU_PCER1_TIMER10_Pos                 16                                                      /*!< SCU PCER1: TIMER10 Position             */
#define SCU_PCER1_TIMER10_Msk                 (0x01UL << SCU_PCER1_TIMER10_Pos)                       /*!< SCU PCER1: TIMER10 Mask                 */
#define SCU_PCER1_TIMER11_Pos                 17                                                      /*!< SCU PCER1: TIMER11 Position             */
#define SCU_PCER1_TIMER11_Msk                 (0x01UL << SCU_PCER1_TIMER11_Pos)                       /*!< SCU PCER1: TIMER11 Mask                 */
#define SCU_PCER1_TIMER12_Pos                 18                                                      /*!< SCU PCER1: TIMER12 Position             */
#define SCU_PCER1_TIMER12_Msk                 (0x01UL << SCU_PCER1_TIMER12_Pos)                       /*!< SCU PCER1: TIMER12 Mask                 */
#define SCU_PCER1_TIMER13_Pos                 19                                                      /*!< SCU PCER1: TIMER13 Position             */
#define SCU_PCER1_TIMER13_Msk                 (0x01UL << SCU_PCER1_TIMER13_Pos)                       /*!< SCU PCER1: TIMER13 Mask                 */
#define SCU_PCER1_TIMER14_Pos                 20                                                      /*!< SCU PCER1: TIMER14 Position             */
#define SCU_PCER1_TIMER14_Msk                 (0x01UL << SCU_PCER1_TIMER14_Pos)                       /*!< SCU PCER1: TIMER14 Mask                 */
#define SCU_PCER1_TIMER15_Pos                 21                                                      /*!< SCU PCER1: TIMER15 Position             */
#define SCU_PCER1_TIMER15_Msk                 (0x01UL << SCU_PCER1_TIMER15_Pos)                       /*!< SCU PCER1: TIMER15 Mask                 */
#define SCU_PCER1_TIMER16_Pos                 22                                                      /*!< SCU PCER1: TIMER16 Position             */
#define SCU_PCER1_TIMER16_Msk                 (0x01UL << SCU_PCER1_TIMER16_Pos)                       /*!< SCU PCER1: TIMER16 Mask                 */
#define SCU_PCER1_TIMER30_Pos                 24                                                      /*!< SCU PCER1: TIMER30 Position             */
#define SCU_PCER1_TIMER30_Msk                 (0x01UL << SCU_PCER1_TIMER30_Pos)                       /*!< SCU PCER1: TIMER30 Mask                 */
#define SCU_PCER1_TIMER20_Pos                 25                                                      /*!< SCU PCER1: TIMER20 Position             */
#define SCU_PCER1_TIMER20_Msk                 (0x01UL << SCU_PCER1_TIMER20_Pos)                       /*!< SCU PCER1: TIMER20 Mask                 */
#define SCU_PCER1_TIMER21_Pos                 26                                                      /*!< SCU PCER1: TIMER21 Position             */
#define SCU_PCER1_TIMER21_Msk                 (0x01UL << SCU_PCER1_TIMER21_Pos)                       /*!< SCU PCER1: TIMER21 Mask                 */
#define SCU_PCER1_WT_Pos                      31                                                      /*!< SCU PCER1: WT Position                  */
#define SCU_PCER1_WT_Msk                      (0x01UL << SCU_PCER1_WT_Pos)                            /*!< SCU PCER1: WT Mask                      */

/* ----------------------------------  SCU_PCER2  --------------------------------- */
#define SCU_PCER2_I2C0_Pos                    4                                                       /*!< SCU PCER2: I2C0 Position                */
#define SCU_PCER2_I2C0_Msk                    (0x01UL << SCU_PCER2_I2C0_Pos)                          /*!< SCU PCER2: I2C0 Mask                    */
#define SCU_PCER2_I2C1_Pos                    5                                                       /*!< SCU PCER2: I2C1 Position                */
#define SCU_PCER2_I2C1_Msk                    (0x01UL << SCU_PCER2_I2C1_Pos)                          /*!< SCU PCER2: I2C1 Mask                    */
#define SCU_PCER2_I2C2_Pos                    6                                                       /*!< SCU PCER2: I2C2 Position                */
#define SCU_PCER2_I2C2_Msk                    (0x01UL << SCU_PCER2_I2C2_Pos)                          /*!< SCU PCER2: I2C2 Mask                    */
#define SCU_PCER2_USART10_Pos                 8                                                       /*!< SCU PCER2: USART10 Position             */
#define SCU_PCER2_USART10_Msk                 (0x01UL << SCU_PCER2_USART10_Pos)                       /*!< SCU PCER2: USART10 Mask                 */
#define SCU_PCER2_USART11_Pos                 9                                                       /*!< SCU PCER2: USART11 Position             */
#define SCU_PCER2_USART11_Msk                 (0x01UL << SCU_PCER2_USART11_Pos)                       /*!< SCU PCER2: USART11 Mask                 */
#define SCU_PCER2_USART12_Pos                 10                                                      /*!< SCU PCER2: USART12 Position             */
#define SCU_PCER2_USART12_Msk                 (0x01UL << SCU_PCER2_USART12_Pos)                       /*!< SCU PCER2: USART12 Mask                 */
#define SCU_PCER2_USART13_Pos                 11                                                      /*!< SCU PCER2: USART13 Position             */
#define SCU_PCER2_USART13_Msk                 (0x01UL << SCU_PCER2_USART13_Pos)                       /*!< SCU PCER2: USART13 Mask                 */
#define SCU_PCER2_UART0_Pos                   12                                                      /*!< SCU PCER2: UART0 Position               */
#define SCU_PCER2_UART0_Msk                   (0x01UL << SCU_PCER2_UART0_Pos)                         /*!< SCU PCER2: UART0 Mask                   */
#define SCU_PCER2_UART1_Pos                   13                                                      /*!< SCU PCER2: UART1 Position               */
#define SCU_PCER2_UART1_Msk                   (0x01UL << SCU_PCER2_UART1_Pos)                         /*!< SCU PCER2: UART1 Mask                   */
#define SCU_PCER2_SPI20_Pos                   14                                                      /*!< SCU PCER2: SPI20 Position               */
#define SCU_PCER2_SPI20_Msk                   (0x01UL << SCU_PCER2_SPI20_Pos)                         /*!< SCU PCER2: SPI20 Mask                   */
#define SCU_PCER2_SPI21_Pos                   15                                                      /*!< SCU PCER2: SPI21 Position               */
#define SCU_PCER2_SPI21_Msk                   (0x01UL << SCU_PCER2_SPI21_Pos)                         /*!< SCU PCER2: SPI21 Mask                   */
#define SCU_PCER2_ADC_Pos                     20                                                      /*!< SCU PCER2: ADC Position                 */
#define SCU_PCER2_ADC_Msk                     (0x01UL << SCU_PCER2_ADC_Pos)                           /*!< SCU PCER2: ADC Mask                     */
#define SCU_PCER2_DAC_Pos                     22                                                      /*!< SCU PCER2: DAC Position                 */
#define SCU_PCER2_DAC_Msk                     (0x01UL << SCU_PCER2_DAC_Pos)                           /*!< SCU PCER2: DAC Mask                     */
#define SCU_PCER2_CMP_Pos                     23                                                      /*!< SCU PCER2: CMP Position                 */
#define SCU_PCER2_CMP_Msk                     (0x01UL << SCU_PCER2_CMP_Pos)                           /*!< SCU PCER2: CMP Mask                     */
#define SCU_PCER2_TS_Pos                      27                                                      /*!< SCU PCER2: TS Position                  */
#define SCU_PCER2_TS_Msk                      (0x01UL << SCU_PCER2_TS_Pos)                            /*!< SCU PCER2: TS Mask                      */
#define SCU_PCER2_LCD_Pos                     28                                                      /*!< SCU PCER2: LCD Position                 */
#define SCU_PCER2_LCD_Msk                     (0x01UL << SCU_PCER2_LCD_Pos)                           /*!< SCU PCER2: LCD Mask                     */
#define SCU_PCER2_CRC_Pos                     31                                                      /*!< SCU PCER2: CRC Position                 */
#define SCU_PCER2_CRC_Msk                     (0x01UL << SCU_PCER2_CRC_Pos)                           /*!< SCU PCER2: CRC Mask                     */

/* ---------------------------------  SCU_PPCLKSR  -------------------------------- */
#define SCU_PPCLKSR_WDTCLK_Pos                0                                                       /*!< SCU PPCLKSR: WDTCLK Position            */
#define SCU_PPCLKSR_WDTCLK_Msk                (0x01UL << SCU_PPCLKSR_WDTCLK_Pos)                      /*!< SCU PPCLKSR: WDTCLK Mask                */
#define SCU_PPCLKSR_WTCLK_Pos                 3                                                       /*!< SCU PPCLKSR: WTCLK Position             */
#define SCU_PPCLKSR_WTCLK_Msk                 (0x03UL << SCU_PPCLKSR_WTCLK_Pos)                       /*!< SCU PPCLKSR: WTCLK Mask                 */
#define SCU_PPCLKSR_LCDCLK_Pos                6                                                       /*!< SCU PPCLKSR: LCDCLK Position            */
#define SCU_PPCLKSR_LCDCLK_Msk                (0x03UL << SCU_PPCLKSR_LCDCLK_Pos)                      /*!< SCU PPCLKSR: LCDCLK Mask                */
#define SCU_PPCLKSR_T30CLK_Pos                17                                                      /*!< SCU PPCLKSR: T30CLK Position            */
#define SCU_PPCLKSR_T30CLK_Msk                (0x01UL << SCU_PPCLKSR_T30CLK_Pos)                      /*!< SCU PPCLKSR: T30CLK Mask                */
#define SCU_PPCLKSR_T20CLK_Pos                20                                                      /*!< SCU PPCLKSR: T20CLK Position            */
#define SCU_PPCLKSR_T20CLK_Msk                (0x01UL << SCU_PPCLKSR_T20CLK_Pos)                      /*!< SCU PPCLKSR: T20CLK Mask                */
#define SCU_PPCLKSR_T1xCLK_Pos                22                                                      /*!< SCU PPCLKSR: T1xCLK Position            */
#define SCU_PPCLKSR_T1xCLK_Msk                (0x01UL << SCU_PPCLKSR_T1xCLK_Pos)                      /*!< SCU PPCLKSR: T1xCLK Mask                */

/* ----------------------------------  SCU_CSCR  ---------------------------------- */
#define SCU_CSCR_HSECON_Pos                   0                                                       /*!< SCU CSCR: HSECON Position               */
#define SCU_CSCR_HSECON_Msk                   (0x0fUL << SCU_CSCR_HSECON_Pos)                         /*!< SCU CSCR: HSECON Mask                   */
#define SCU_CSCR_HSICON_Pos                   4                                                       /*!< SCU CSCR: HSICON Position               */
#define SCU_CSCR_HSICON_Msk                   (0x0fUL << SCU_CSCR_HSICON_Pos)                         /*!< SCU CSCR: HSICON Mask                   */
#define SCU_CSCR_LSICON_Pos                   8                                                       /*!< SCU CSCR: LSICON Position               */
#define SCU_CSCR_LSICON_Msk                   (0x0fUL << SCU_CSCR_LSICON_Pos)                         /*!< SCU CSCR: LSICON Mask                   */
#define SCU_CSCR_LSECON_Pos                   12                                                      /*!< SCU CSCR: LSECON Position               */
#define SCU_CSCR_LSECON_Msk                   (0x0fUL << SCU_CSCR_LSECON_Pos)                         /*!< SCU CSCR: LSECON Mask                   */
#define SCU_CSCR_WTIDKY_Pos                   16                                                      /*!< SCU CSCR: WTIDKY Position               */
#define SCU_CSCR_WTIDKY_Msk                   (0x0000ffffUL << SCU_CSCR_WTIDKY_Pos)                   /*!< SCU CSCR: WTIDKY Mask                   */

/* ----------------------------------  SCU_SCCR  ---------------------------------- */
#define SCU_SCCR_MCLKSEL_Pos                  0                                                       /*!< SCU SCCR: MCLKSEL Position              */
#define SCU_SCCR_MCLKSEL_Msk                  (0x03UL << SCU_SCCR_MCLKSEL_Pos)                        /*!< SCU SCCR: MCLKSEL Mask                  */
#define SCU_SCCR_FINSEL_Pos                   2                                                       /*!< SCU SCCR: FINSEL Position               */
#define SCU_SCCR_FINSEL_Msk                   (0x01UL << SCU_SCCR_FINSEL_Pos)                         /*!< SCU SCCR: FINSEL Mask                   */
#define SCU_SCCR_WTIDKY_Pos                   16                                                      /*!< SCU SCCR: WTIDKY Position               */
#define SCU_SCCR_WTIDKY_Msk                   (0x0000ffffUL << SCU_SCCR_WTIDKY_Pos)                   /*!< SCU SCCR: WTIDKY Mask                   */

/* -----------------------------------  SCU_CMR  ---------------------------------- */
#define SCU_CMR_HSESTS_Pos                    0                                                       /*!< SCU CMR: HSESTS Position                */
#define SCU_CMR_HSESTS_Msk                    (0x01UL << SCU_CMR_HSESTS_Pos)                          /*!< SCU CMR: HSESTS Mask                    */
#define SCU_CMR_HSEFAIL_Pos                   1                                                       /*!< SCU CMR: HSEFAIL Position               */
#define SCU_CMR_HSEFAIL_Msk                   (0x01UL << SCU_CMR_HSEFAIL_Pos)                         /*!< SCU CMR: HSEFAIL Mask                   */
#define SCU_CMR_HSEIE_Pos                     2                                                       /*!< SCU CMR: HSEIE Position                 */
#define SCU_CMR_HSEIE_Msk                     (0x01UL << SCU_CMR_HSEIE_Pos)                           /*!< SCU CMR: HSEIE Mask                     */
#define SCU_CMR_HSEMNT_Pos                    3                                                       /*!< SCU CMR: HSEMNT Position                */
#define SCU_CMR_HSEMNT_Msk                    (0x01UL << SCU_CMR_HSEMNT_Pos)                          /*!< SCU CMR: HSEMNT Mask                    */
#define SCU_CMR_MCLKSTS_Pos                   4                                                       /*!< SCU CMR: MCLKSTS Position               */
#define SCU_CMR_MCLKSTS_Msk                   (0x01UL << SCU_CMR_MCLKSTS_Pos)                         /*!< SCU CMR: MCLKSTS Mask                   */
#define SCU_CMR_MCLKFAIL_Pos                  5                                                       /*!< SCU CMR: MCLKFAIL Position              */
#define SCU_CMR_MCLKFAIL_Msk                  (0x01UL << SCU_CMR_MCLKFAIL_Pos)                        /*!< SCU CMR: MCLKFAIL Mask                  */
#define SCU_CMR_MCLKIE_Pos                    6                                                       /*!< SCU CMR: MCLKIE Position                */
#define SCU_CMR_MCLKIE_Msk                    (0x01UL << SCU_CMR_MCLKIE_Pos)                          /*!< SCU CMR: MCLKIE Mask                    */
#define SCU_CMR_MCLKMNT_Pos                   7                                                       /*!< SCU CMR: MCLKMNT Position               */
#define SCU_CMR_MCLKMNT_Msk                   (0x01UL << SCU_CMR_MCLKMNT_Pos)                         /*!< SCU CMR: MCLKMNT Mask                   */
#define SCU_CMR_LSESTS_Pos                    8                                                       /*!< SCU CMR: LSESTS Position                */
#define SCU_CMR_LSESTS_Msk                    (0x01UL << SCU_CMR_LSESTS_Pos)                          /*!< SCU CMR: LSESTS Mask                    */
#define SCU_CMR_LSEFAIL_Pos                   9                                                       /*!< SCU CMR: LSEFAIL Position               */
#define SCU_CMR_LSEFAIL_Msk                   (0x01UL << SCU_CMR_LSEFAIL_Pos)                         /*!< SCU CMR: LSEFAIL Mask                   */
#define SCU_CMR_LSEIE_Pos                     10                                                      /*!< SCU CMR: LSEIE Position                 */
#define SCU_CMR_LSEIE_Msk                     (0x01UL << SCU_CMR_LSEIE_Pos)                           /*!< SCU CMR: LSEIE Mask                     */
#define SCU_CMR_LSEMNT_Pos                    11                                                      /*!< SCU CMR: LSEMNT Position                */
#define SCU_CMR_LSEMNT_Msk                    (0x01UL << SCU_CMR_LSEMNT_Pos)                          /*!< SCU CMR: LSEMNT Mask                    */
#define SCU_CMR_MCLKREC_Pos                   15                                                      /*!< SCU CMR: MCLKREC Position               */
#define SCU_CMR_MCLKREC_Msk                   (0x01UL << SCU_CMR_MCLKREC_Pos)                         /*!< SCU CMR: MCLKREC Mask                   */

/* ----------------------------------  SCU_NMIR  ---------------------------------- */
#define SCU_NMIR_LVDEN_Pos                    0                                                       /*!< SCU NMIR: LVDEN Position                */
#define SCU_NMIR_LVDEN_Msk                    (0x01UL << SCU_NMIR_LVDEN_Pos)                          /*!< SCU NMIR: LVDEN Mask                    */
#define SCU_NMIR_MCLKFAILEN_Pos               1                                                       /*!< SCU NMIR: MCLKFAILEN Position           */
#define SCU_NMIR_MCLKFAILEN_Msk               (0x01UL << SCU_NMIR_MCLKFAILEN_Pos)                     /*!< SCU NMIR: MCLKFAILEN Mask               */
#define SCU_NMIR_WDTINTEN_Pos                 2                                                       /*!< SCU NMIR: WDTINTEN Position             */
#define SCU_NMIR_WDTINTEN_Msk                 (0x01UL << SCU_NMIR_WDTINTEN_Pos)                       /*!< SCU NMIR: WDTINTEN Mask                 */
#define SCU_NMIR_T30IEN_Pos                   3                                                       /*!< SCU NMIR: T30IEN Position               */
#define SCU_NMIR_T30IEN_Msk                   (0x01UL << SCU_NMIR_T30IEN_Pos)                         /*!< SCU NMIR: T30IEN Mask                   */
#define SCU_NMIR_CMPINTEN_Pos                 4                                                       /*!< SCU NMIR: CMPINTEN Position             */
#define SCU_NMIR_CMPINTEN_Msk                 (0x01UL << SCU_NMIR_CMPINTEN_Pos)                       /*!< SCU NMIR: CMPINTEN Mask                 */
#define SCU_NMIR_SWAPERRIEN_Pos               5                                                       /*!< SCU NMIR: SWAPERRIEN Position           */
#define SCU_NMIR_SWAPERRIEN_Msk               (0x01UL << SCU_NMIR_SWAPERRIEN_Pos)                     /*!< SCU NMIR: SWAPERRIEN Mask               */
#define SCU_NMIR_LVDSTS_Pos                   8                                                       /*!< SCU NMIR: LVDSTS Position               */
#define SCU_NMIR_LVDSTS_Msk                   (0x01UL << SCU_NMIR_LVDSTS_Pos)                         /*!< SCU NMIR: LVDSTS Mask                   */
#define SCU_NMIR_MCLKFAILSTS_Pos              9                                                       /*!< SCU NMIR: MCLKFAILSTS Position          */
#define SCU_NMIR_MCLKFAILSTS_Msk              (0x01UL << SCU_NMIR_MCLKFAILSTS_Pos)                    /*!< SCU NMIR: MCLKFAILSTS Mask              */
#define SCU_NMIR_WDTINTSTS_Pos                10                                                      /*!< SCU NMIR: WDTINTSTS Position            */
#define SCU_NMIR_WDTINTSTS_Msk                (0x01UL << SCU_NMIR_WDTINTSTS_Pos)                      /*!< SCU NMIR: WDTINTSTS Mask                */
#define SCU_NMIR_T30INTSTS_Pos                11                                                      /*!< SCU NMIR: T30INTSTS Position            */
#define SCU_NMIR_T30INTSTS_Msk                (0x01UL << SCU_NMIR_T30INTSTS_Pos)                      /*!< SCU NMIR: T30INTSTS Mask                */
#define SCU_NMIR_CMPINTSTS_Pos                12                                                      /*!< SCU NMIR: CMPINTSTS Position            */
#define SCU_NMIR_CMPINTSTS_Msk                (0x01UL << SCU_NMIR_CMPINTSTS_Pos)                      /*!< SCU NMIR: CMPINTSTS Mask                */
#define SCU_NMIR_SWAPERRSTS_Pos               13                                                      /*!< SCU NMIR: SWAPERRSTS Position           */
#define SCU_NMIR_SWAPERRSTS_Msk               (0x01UL << SCU_NMIR_SWAPERRSTS_Pos)                     /*!< SCU NMIR: SWAPERRSTS Mask               */
#define SCU_NMIR_ACCESSCODE_Pos               16                                                      /*!< SCU NMIR: ACCESSCODE Position           */
#define SCU_NMIR_ACCESSCODE_Msk               (0x0000ffffUL << SCU_NMIR_ACCESSCODE_Pos)               /*!< SCU NMIR: ACCESSCODE Mask               */

/* -----------------------------------  SCU_COR  ---------------------------------- */
#define SCU_COR_CLKODIV_Pos                   0                                                       /*!< SCU COR: CLKODIV Position               */
#define SCU_COR_CLKODIV_Msk                   (0x0fUL << SCU_COR_CLKODIV_Pos)                         /*!< SCU COR: CLKODIV Mask                   */
#define SCU_COR_CLKOEN_Pos                    4                                                       /*!< SCU COR: CLKOEN Position                */
#define SCU_COR_CLKOEN_Msk                    (0x01UL << SCU_COR_CLKOEN_Pos)                          /*!< SCU COR: CLKOEN Mask                    */

/* ---------------------------------  SCU_PLLCON  --------------------------------- */
#define SCU_PLLCON_OUTDIV_Pos                 0                                                       /*!< SCU PLLCON: OUTDIV Position             */
#define SCU_PLLCON_OUTDIV_Msk                 (0x07UL << SCU_PLLCON_OUTDIV_Pos)                       /*!< SCU PLLCON: OUTDIV Mask                 */
#define SCU_PLLCON_POSTDIV2_Pos               4                                                       /*!< SCU PLLCON: POSTDIV2 Position           */
#define SCU_PLLCON_POSTDIV2_Msk               (0x0fUL << SCU_PLLCON_POSTDIV2_Pos)                     /*!< SCU PLLCON: POSTDIV2 Mask               */
#define SCU_PLLCON_POSTDIV1_Pos               8                                                       /*!< SCU PLLCON: POSTDIV1 Position           */
#define SCU_PLLCON_POSTDIV1_Msk               (0x000000ffUL << SCU_PLLCON_POSTDIV1_Pos)               /*!< SCU PLLCON: POSTDIV1 Mask               */
#define SCU_PLLCON_PREDIV_Pos                 16                                                      /*!< SCU PLLCON: PREDIV Position             */
#define SCU_PLLCON_PREDIV_Msk                 (0x07UL << SCU_PLLCON_PREDIV_Pos)                       /*!< SCU PLLCON: PREDIV Mask                 */
#define SCU_PLLCON_PLLMODE_Pos                20                                                      /*!< SCU PLLCON: PLLMODE Position            */
#define SCU_PLLCON_PLLMODE_Msk                (0x01UL << SCU_PLLCON_PLLMODE_Pos)                      /*!< SCU PLLCON: PLLMODE Mask                */
#define SCU_PLLCON_BYPASSB_Pos                21                                                      /*!< SCU PLLCON: BYPASSB Position            */
#define SCU_PLLCON_BYPASSB_Msk                (0x01UL << SCU_PLLCON_BYPASSB_Pos)                      /*!< SCU PLLCON: BYPASSB Mask                */
#define SCU_PLLCON_PLLEN_Pos                  22                                                      /*!< SCU PLLCON: PLLEN Position              */
#define SCU_PLLCON_PLLEN_Msk                  (0x01UL << SCU_PLLCON_PLLEN_Pos)                        /*!< SCU PLLCON: PLLEN Mask                  */
#define SCU_PLLCON_PLLRSTB_Pos                23                                                      /*!< SCU PLLCON: PLLRSTB Position            */
#define SCU_PLLCON_PLLRSTB_Msk                (0x01UL << SCU_PLLCON_PLLRSTB_Pos)                      /*!< SCU PLLCON: PLLRSTB Mask                */
#define SCU_PLLCON_LOCK_Pos                   31                                                      /*!< SCU PLLCON: LOCK Position               */
#define SCU_PLLCON_LOCK_Msk                   (0x01UL << SCU_PLLCON_LOCK_Pos)                         /*!< SCU PLLCON: LOCK Mask                   */

/* ---------------------------------  SCU_VDCCON  --------------------------------- */
#define SCU_VDCCON_VDCWDLY_Pos                0                                                       /*!< SCU VDCCON: VDCWDLY Position            */
#define SCU_VDCCON_VDCWDLY_Msk                (0x000000ffUL << SCU_VDCCON_VDCWDLY_Pos)                /*!< SCU VDCCON: VDCWDLY Mask                */
#define SCU_VDCCON_VDCWDLY_WEN_Pos            8                                                       /*!< SCU VDCCON: VDCWDLY_WEN Position        */
#define SCU_VDCCON_VDCWDLY_WEN_Msk            (0x01UL << SCU_VDCCON_VDCWDLY_WEN_Pos)                  /*!< SCU VDCCON: VDCWDLY_WEN Mask            */
#define SCU_VDCCON_VDC_LOCK_Pos               15                                                      /*!< SCU VDCCON: VDC_LOCK Position           */
#define SCU_VDCCON_VDC_LOCK_Msk               (0x01UL << SCU_VDCCON_VDC_LOCK_Pos)                     /*!< SCU VDCCON: VDC_LOCK Mask               */
#define SCU_VDCCON_VDC_IDLE_Pos               16                                                      /*!< SCU VDCCON: VDC_IDLE Position           */
#define SCU_VDCCON_VDC_IDLE_Msk               (0x01UL << SCU_VDCCON_VDC_IDLE_Pos)                     /*!< SCU VDCCON: VDC_IDLE Mask               */
#define SCU_VDCCON_VDC_STOP_Pos               17                                                      /*!< SCU VDCCON: VDC_STOP Position           */
#define SCU_VDCCON_VDC_STOP_Msk               (0x01UL << SCU_VDCCON_VDC_STOP_Pos)                     /*!< SCU VDCCON: VDC_STOP Mask               */
#define SCU_VDCCON_VDC_PDBGR_Pos              19                                                      /*!< SCU VDCCON: VDC_PDBGR Position          */
#define SCU_VDCCON_VDC_PDBGR_Msk              (0x01UL << SCU_VDCCON_VDC_PDBGR_Pos)                    /*!< SCU VDCCON: VDC_PDBGR Mask              */
#define SCU_VDCCON_VDC_WTIDKY_Pos             20                                                      /*!< SCU VDCCON: VDC_WTIDKY Position         */
#define SCU_VDCCON_VDC_WTIDKY_Msk             (0x0fUL << SCU_VDCCON_VDC_WTIDKY_Pos)                   /*!< SCU VDCCON: VDC_WTIDKY Mask             */

/* ---------------------------------  SCU_LSICON  --------------------------------- */
#define SCU_LSICON_SKIP_LS_Pos                0                                                       /*!< SCU LSICON: SKIP_LS Position            */
#define SCU_LSICON_SKIP_LS_Msk                (0x01UL << SCU_LSICON_SKIP_LS_Pos)                      /*!< SCU LSICON: SKIP_LS Mask                */

/* ----------------------------------  SCU_EOSCR  --------------------------------- */
#define SCU_EOSCR_NCSKIP_Pos                  0                                                       /*!< SCU EOSCR: NCSKIP Position              */
#define SCU_EOSCR_NCSKIP_Msk                  (0x01UL << SCU_EOSCR_NCSKIP_Pos)                        /*!< SCU EOSCR: NCSKIP Mask                  */
#define SCU_EOSCR_NCOPT_Pos                   2                                                       /*!< SCU EOSCR: NCOPT Position               */
#define SCU_EOSCR_NCOPT_Msk                   (0x03UL << SCU_EOSCR_NCOPT_Pos)                         /*!< SCU EOSCR: NCOPT Mask                   */
#define SCU_EOSCR_ISE_Pos                     4                                                       /*!< SCU EOSCR: ISE Position                 */
#define SCU_EOSCR_ISE_Msk                     (0x03UL << SCU_EOSCR_ISE_Pos)                           /*!< SCU EOSCR: ISE Mask                     */
#define SCU_EOSCR_EMEN_Pos                    7                                                       /*!< SCU EOSCR: EMEN Position                */
#define SCU_EOSCR_EMEN_Msk                    (0x01UL << SCU_EOSCR_EMEN_Pos)                          /*!< SCU EOSCR: EMEN Mask                    */
#define SCU_EOSCR_ESNCBYPS_Pos                8                                                       /*!< SCU EOSCR: ESNCBYPS Position            */
#define SCU_EOSCR_ESNCBYPS_Msk                (0x01UL << SCU_EOSCR_ESNCBYPS_Pos)                      /*!< SCU EOSCR: ESNCBYPS Mask                */
#define SCU_EOSCR_ESISEL_Pos                  12                                                      /*!< SCU EOSCR: ESISEL Position              */
#define SCU_EOSCR_ESISEL_Msk                  (0x03UL << SCU_EOSCR_ESISEL_Pos)                        /*!< SCU EOSCR: ESISEL Mask                  */
#define SCU_EOSCR_ESEN_Pos                    15                                                      /*!< SCU EOSCR: ESEN Position                */
#define SCU_EOSCR_ESEN_Msk                    (0x01UL << SCU_EOSCR_ESEN_Pos)                          /*!< SCU EOSCR: ESEN Mask                    */

/* ----------------------------------  SCU_EMODR  --------------------------------- */
#define SCU_EMODR_BOOT_Pos                    0                                                       /*!< SCU EMODR: BOOT Position                */
#define SCU_EMODR_BOOT_Msk                    (0x01UL << SCU_EMODR_BOOT_Pos)                          /*!< SCU EMODR: BOOT Mask                    */

/* ---------------------------------  SCU_RSTDBCR  -------------------------------- */
#define SCU_RSTDBCR_EN_Pos                    0                                                       /*!< SCU RSTDBCR: EN Position                */
#define SCU_RSTDBCR_EN_Msk                    (0x01UL << SCU_RSTDBCR_EN_Pos)                          /*!< SCU RSTDBCR: EN Mask                    */
#define SCU_RSTDBCR_CLKCNT_Pos                8                                                       /*!< SCU RSTDBCR: CLKCNT Position            */
#define SCU_RSTDBCR_CLKCNT_Msk                (0x3fUL << SCU_RSTDBCR_CLKCNT_Pos)                      /*!< SCU RSTDBCR: CLKCNT Mask                */
#define SCU_RSTDBCR_WTIDKY_Pos                16                                                      /*!< SCU RSTDBCR: WTIDKY Position            */
#define SCU_RSTDBCR_WTIDKY_Msk                (0x0000ffffUL << SCU_RSTDBCR_WTIDKY_Pos)                /*!< SCU RSTDBCR: WTIDKY Mask                */

/* ----------------------------------  SCU_MCCR1  --------------------------------- */
#define SCU_MCCR1_STDIV_Pos                   0                                                       /*!< SCU MCCR1: STDIV Position               */
#define SCU_MCCR1_STDIV_Msk                   (0x000000ffUL << SCU_MCCR1_STDIV_Pos)                   /*!< SCU MCCR1: STDIV Mask                   */
#define SCU_MCCR1_STCSEL_Pos                  8                                                       /*!< SCU MCCR1: STCSEL Position              */
#define SCU_MCCR1_STCSEL_Msk                  (0x07UL << SCU_MCCR1_STCSEL_Pos)                        /*!< SCU MCCR1: STCSEL Mask                  */
#define SCU_MCCR1_TEXT1DIV_Pos                16                                                      /*!< SCU MCCR1: TEXT1DIV Position            */
#define SCU_MCCR1_TEXT1DIV_Msk                (0x000000ffUL << SCU_MCCR1_TEXT1DIV_Pos)                /*!< SCU MCCR1: TEXT1DIV Mask                */
#define SCU_MCCR1_TEXT1CSEL_Pos               24                                                      /*!< SCU MCCR1: TEXT1CSEL Position           */
#define SCU_MCCR1_TEXT1CSEL_Msk               (0x07UL << SCU_MCCR1_TEXT1CSEL_Pos)                     /*!< SCU MCCR1: TEXT1CSEL Mask               */

/* ----------------------------------  SCU_MCCR2  --------------------------------- */
#define SCU_MCCR2_TEXT2DIV_Pos                0                                                       /*!< SCU MCCR2: TEXT2DIV Position            */
#define SCU_MCCR2_TEXT2DIV_Msk                (0x000000ffUL << SCU_MCCR2_TEXT2DIV_Pos)                /*!< SCU MCCR2: TEXT2DIV Mask                */
#define SCU_MCCR2_TEXT2CSEL_Pos               8                                                       /*!< SCU MCCR2: TEXT2CSEL Position           */
#define SCU_MCCR2_TEXT2CSEL_Msk               (0x07UL << SCU_MCCR2_TEXT2CSEL_Pos)                     /*!< SCU MCCR2: TEXT2CSEL Mask               */
#define SCU_MCCR2_TEXT3DIV_Pos                16                                                      /*!< SCU MCCR2: TEXT3DIV Position            */
#define SCU_MCCR2_TEXT3DIV_Msk                (0x000000ffUL << SCU_MCCR2_TEXT3DIV_Pos)                /*!< SCU MCCR2: TEXT3DIV Mask                */
#define SCU_MCCR2_TEXT3CSEL_Pos               24                                                      /*!< SCU MCCR2: TEXT3CSEL Position           */
#define SCU_MCCR2_TEXT3CSEL_Msk               (0x07UL << SCU_MCCR2_TEXT3CSEL_Pos)                     /*!< SCU MCCR2: TEXT3CSEL Mask               */

/* ----------------------------------  SCU_MCCR3  --------------------------------- */
#define SCU_MCCR3_WDTDIV_Pos                  0                                                       /*!< SCU MCCR3: WDTDIV Position              */
#define SCU_MCCR3_WDTDIV_Msk                  (0x000000ffUL << SCU_MCCR3_WDTDIV_Pos)                  /*!< SCU MCCR3: WDTDIV Mask                  */
#define SCU_MCCR3_WDTCSEL_Pos                 8                                                       /*!< SCU MCCR3: WDTCSEL Position             */
#define SCU_MCCR3_WDTCSEL_Msk                 (0x07UL << SCU_MCCR3_WDTCSEL_Pos)                       /*!< SCU MCCR3: WDTCSEL Mask                 */
#define SCU_MCCR3_WTEXTCDIV_Pos               16                                                      /*!< SCU MCCR3: WTEXTCDIV Position           */
#define SCU_MCCR3_WTEXTCDIV_Msk               (0x000000ffUL << SCU_MCCR3_WTEXTCDIV_Pos)               /*!< SCU MCCR3: WTEXTCDIV Mask               */
#define SCU_MCCR3_WTEXTCSEL_Pos               24                                                      /*!< SCU MCCR3: WTEXTCSEL Position           */
#define SCU_MCCR3_WTEXTCSEL_Msk               (0x07UL << SCU_MCCR3_WTEXTCSEL_Pos)                     /*!< SCU MCCR3: WTEXTCSEL Mask               */

/* ----------------------------------  SCU_MCCR4  --------------------------------- */
#define SCU_MCCR4_PD0DIV_Pos                  0                                                       /*!< SCU MCCR4: PD0DIV Position              */
#define SCU_MCCR4_PD0DIV_Msk                  (0x000000ffUL << SCU_MCCR4_PD0DIV_Pos)                  /*!< SCU MCCR4: PD0DIV Mask                  */
#define SCU_MCCR4_PD0CSEL_Pos                 8                                                       /*!< SCU MCCR4: PD0CSEL Position             */
#define SCU_MCCR4_PD0CSEL_Msk                 (0x07UL << SCU_MCCR4_PD0CSEL_Pos)                       /*!< SCU MCCR4: PD0CSEL Mask                 */
#define SCU_MCCR4_PD1DIV_Pos                  16                                                      /*!< SCU MCCR4: PD1DIV Position              */
#define SCU_MCCR4_PD1DIV_Msk                  (0x000000ffUL << SCU_MCCR4_PD1DIV_Pos)                  /*!< SCU MCCR4: PD1DIV Mask                  */
#define SCU_MCCR4_PD1CSEL_Pos                 24                                                      /*!< SCU MCCR4: PD1CSEL Position             */
#define SCU_MCCR4_PD1CSEL_Msk                 (0x07UL << SCU_MCCR4_PD1CSEL_Pos)                       /*!< SCU MCCR4: PD1CSEL Mask                 */

/* ----------------------------------  SCU_MCCR5  --------------------------------- */
#define SCU_MCCR5_TSSLSITSEN_Pos              11                                                      /*!< SCU MCCR5: TSSLSITSEN Position          */
#define SCU_MCCR5_TSSLSITSEN_Msk              (0x01UL << SCU_MCCR5_TSSLSITSEN_Pos)                    /*!< SCU MCCR5: TSSLSITSEN Mask              */
#define SCU_MCCR5_TSSCSEL_Pos                 12                                                      /*!< SCU MCCR5: TSSCSEL Position             */
#define SCU_MCCR5_TSSCSEL_Msk                 (0x03UL << SCU_MCCR5_TSSCSEL_Pos)                       /*!< SCU MCCR5: TSSCSEL Mask                 */
#define SCU_MCCR5_TSRCSEL_Pos                 14                                                      /*!< SCU MCCR5: TSRCSEL Position             */
#define SCU_MCCR5_TSRCSEL_Msk                 (0x03UL << SCU_MCCR5_TSRCSEL_Pos)                       /*!< SCU MCCR5: TSRCSEL Mask                 */
#define SCU_MCCR5_LCDDIV_Pos                  16                                                      /*!< SCU MCCR5: LCDDIV Position              */
#define SCU_MCCR5_LCDDIV_Msk                  (0x000000ffUL << SCU_MCCR5_LCDDIV_Pos)                  /*!< SCU MCCR5: LCDDIV Mask                  */
#define SCU_MCCR5_LCDSEL_Pos                  24                                                      /*!< SCU MCCR5: LCDSEL Position              */
#define SCU_MCCR5_LCDSEL_Msk                  (0x07UL << SCU_MCCR5_LCDSEL_Pos)                        /*!< SCU MCCR5: LCDSEL Mask                  */

/* ----------------------------------  SCU_MCCR7  --------------------------------- */
#define SCU_MCCR7_ADCCDIV_Pos                 16                                                      /*!< SCU MCCR7: ADCCDIV Position             */
#define SCU_MCCR7_ADCCDIV_Msk                 (0x000000ffUL << SCU_MCCR7_ADCCDIV_Pos)                 /*!< SCU MCCR7: ADCCDIV Mask                 */
#define SCU_MCCR7_ADCCSEL_Pos                 24                                                      /*!< SCU MCCR7: ADCCSEL Position             */
#define SCU_MCCR7_ADCCSEL_Msk                 (0x07UL << SCU_MCCR7_ADCCSEL_Pos)                       /*!< SCU MCCR7: ADCCSEL Mask                 */

/* ---------------------------------  SCU_HSITRIM  -------------------------------- */
#define SCU_HSITRIM_REFSEL_Pos                30                                                      /*!< SCU HSITRIM: REFSEL Position            */
#define SCU_HSITRIM_REFSEL_Msk                (0x01UL << SCU_HSITRIM_REFSEL_Pos)                      /*!< SCU HSITRIM: REFSEL Mask                */
#define SCU_HSITRIM_BISCON_Pos                31                                                      /*!< SCU HSITRIM: BISCON Position            */
#define SCU_HSITRIM_BISCON_Msk                (0x01UL << SCU_HSITRIM_BISCON_Pos)                      /*!< SCU HSITRIM: BISCON Mask                */

/* ---------------------------------  SCU_BISCCON  -------------------------------- */
#define SCU_BISCCON_REF_COMP_Pos              0                                                       /*!< SCU BISCCON: REF_COMP Position          */
#define SCU_BISCCON_REF_COMP_Msk              (0x0000ffffUL << SCU_BISCCON_REF_COMP_Pos)              /*!< SCU BISCCON: REF_COMP Mask              */
#define SCU_BISCCON_HSIOSC_COMP_Pos           16                                                      /*!< SCU BISCCON: HSIOSC_COMP Position       */
#define SCU_BISCCON_HSIOSC_COMP_Msk           (0x0000ffffUL << SCU_BISCCON_HSIOSC_COMP_Pos)           /*!< SCU BISCCON: HSIOSC_COMP Mask           */


/* ================================================================================ */
/* ================         struct 'SCULV' Position & Mask         ================ */
/* ================================================================================ */


/* ---------------------------------  SCULV_LVICR  -------------------------------- */
#define SCULV_LVICR_LVIVS_Pos                 0                                                       /*!< SCULV LVICR: LVIVS Position             */
#define SCULV_LVICR_LVIVS_Msk                 (0x0fUL << SCULV_LVICR_LVIVS_Pos)                       /*!< SCULV LVICR: LVIVS Mask                 */
#define SCULV_LVICR_LVIST_Pos                 4                                                       /*!< SCULV LVICR: LVIST Position             */
#define SCULV_LVICR_LVIST_Msk                 (0x01UL << SCULV_LVICR_LVIST_Pos)                       /*!< SCULV LVICR: LVIST Mask                 */
#define SCULV_LVICR_LVINTEN_Pos               5                                                       /*!< SCULV LVICR: LVINTEN Position           */
#define SCULV_LVICR_LVINTEN_Msk               (0x01UL << SCULV_LVICR_LVINTEN_Pos)                     /*!< SCULV LVICR: LVINTEN Mask               */
#define SCULV_LVICR_LVIEN_Pos                 7                                                       /*!< SCULV LVICR: LVIEN Position             */
#define SCULV_LVICR_LVIEN_Msk                 (0x01UL << SCULV_LVICR_LVIEN_Pos)                       /*!< SCULV LVICR: LVIEN Mask                 */
#define SCULV_LVICR_LVIFLAG_Pos               8                                                       /*!< SCULV LVICR: LVIFLAG Position           */
#define SCULV_LVICR_LVIFLAG_Msk               (0x01UL << SCULV_LVICR_LVIFLAG_Pos)                     /*!< SCULV LVICR: LVIFLAG Mask               */

/* ---------------------------------  SCULV_LVRCR  -------------------------------- */
#define SCULV_LVRCR_LVREN_Pos                 0                                                       /*!< SCULV LVRCR: LVREN Position             */
#define SCULV_LVRCR_LVREN_Msk                 (0x000000ffUL << SCULV_LVRCR_LVREN_Pos)                 /*!< SCULV LVRCR: LVREN Mask                 */

/* -------------------------------  SCULV_LVRCNFIG  ------------------------------- */
#define SCULV_LVRCNFIG_LVRVS_Pos              0                                                       /*!< SCULV LVRCNFIG: LVRVS Position          */
#define SCULV_LVRCNFIG_LVRVS_Msk              (0x0fUL << SCULV_LVRCNFIG_LVRVS_Pos)                    /*!< SCULV LVRCNFIG: LVRVS Mask              */
#define SCULV_LVRCNFIG_LVRENM_Pos             8                                                       /*!< SCULV LVRCNFIG: LVRENM Position         */
#define SCULV_LVRCNFIG_LVRENM_Msk             (0x000000ffUL << SCULV_LVRCNFIG_LVRENM_Pos)             /*!< SCULV LVRCNFIG: LVRENM Mask             */
#define SCULV_LVRCNFIG_WTIDKY_Pos             16                                                      /*!< SCULV LVRCNFIG: WTIDKY Position         */
#define SCULV_LVRCNFIG_WTIDKY_Msk             (0x0000ffffUL << SCULV_LVRCNFIG_WTIDKY_Pos)             /*!< SCULV LVRCNFIG: WTIDKY Mask             */


/* ================================================================================ */
/* ================          Group 'PORT' Position & Mask          ================ */
/* ================================================================================ */


/* ----------------------------------  PORT_MOD  ---------------------------------- */
#define PORT_MOD_MODE0_Pos                    0                                                       /*!< PORT MOD: MODE0 Position                */
#define PORT_MOD_MODE0_Msk                    (0x03UL << PORT_MOD_MODE0_Pos)                          /*!< PORT MOD: MODE0 Mask                    */
#define PORT_MOD_MODE1_Pos                    2                                                       /*!< PORT MOD: MODE1 Position                */
#define PORT_MOD_MODE1_Msk                    (0x03UL << PORT_MOD_MODE1_Pos)                          /*!< PORT MOD: MODE1 Mask                    */
#define PORT_MOD_MODE2_Pos                    4                                                       /*!< PORT MOD: MODE2 Position                */
#define PORT_MOD_MODE2_Msk                    (0x03UL << PORT_MOD_MODE2_Pos)                          /*!< PORT MOD: MODE2 Mask                    */
#define PORT_MOD_MODE3_Pos                    6                                                       /*!< PORT MOD: MODE3 Position                */
#define PORT_MOD_MODE3_Msk                    (0x03UL << PORT_MOD_MODE3_Pos)                          /*!< PORT MOD: MODE3 Mask                    */
#define PORT_MOD_MODE4_Pos                    8                                                       /*!< PORT MOD: MODE4 Position                */
#define PORT_MOD_MODE4_Msk                    (0x03UL << PORT_MOD_MODE4_Pos)                          /*!< PORT MOD: MODE4 Mask                    */
#define PORT_MOD_MODE5_Pos                    10                                                      /*!< PORT MOD: MODE5 Position                */
#define PORT_MOD_MODE5_Msk                    (0x03UL << PORT_MOD_MODE5_Pos)                          /*!< PORT MOD: MODE5 Mask                    */
#define PORT_MOD_MODE6_Pos                    12                                                      /*!< PORT MOD: MODE6 Position                */
#define PORT_MOD_MODE6_Msk                    (0x03UL << PORT_MOD_MODE6_Pos)                          /*!< PORT MOD: MODE6 Mask                    */
#define PORT_MOD_MODE7_Pos                    14                                                      /*!< PORT MOD: MODE7 Position                */
#define PORT_MOD_MODE7_Msk                    (0x03UL << PORT_MOD_MODE7_Pos)                          /*!< PORT MOD: MODE7 Mask                    */
#define PORT_MOD_MODE8_Pos                    16                                                      /*!< PORT MOD: MODE8 Position                */
#define PORT_MOD_MODE8_Msk                    (0x03UL << PORT_MOD_MODE8_Pos)                          /*!< PORT MOD: MODE8 Mask                    */
#define PORT_MOD_MODE9_Pos                    18                                                      /*!< PORT MOD: MODE9 Position                */
#define PORT_MOD_MODE9_Msk                    (0x03UL << PORT_MOD_MODE9_Pos)                          /*!< PORT MOD: MODE9 Mask                    */
#define PORT_MOD_MODE10_Pos                   20                                                      /*!< PORT MOD: MODE10 Position               */
#define PORT_MOD_MODE10_Msk                   (0x03UL << PORT_MOD_MODE10_Pos)                         /*!< PORT MOD: MODE10 Mask                   */
#define PORT_MOD_MODE11_Pos                   22                                                      /*!< PORT MOD: MODE11 Position               */
#define PORT_MOD_MODE11_Msk                   (0x03UL << PORT_MOD_MODE11_Pos)                         /*!< PORT MOD: MODE11 Mask                   */
#define PORT_MOD_MODE12_Pos                   24                                                      /*!< PORT MOD: MODE12 Position               */
#define PORT_MOD_MODE12_Msk                   (0x03UL << PORT_MOD_MODE12_Pos)                         /*!< PORT MOD: MODE12 Mask                   */
#define PORT_MOD_MODE13_Pos                   26                                                      /*!< PORT MOD: MODE13 Position               */
#define PORT_MOD_MODE13_Msk                   (0x03UL << PORT_MOD_MODE13_Pos)                         /*!< PORT MOD: MODE13 Mask                   */
#define PORT_MOD_MODE14_Pos                   28                                                      /*!< PORT MOD: MODE14 Position               */
#define PORT_MOD_MODE14_Msk                   (0x03UL << PORT_MOD_MODE14_Pos)                         /*!< PORT MOD: MODE14 Mask                   */
#define PORT_MOD_MODE15_Pos                   30                                                      /*!< PORT MOD: MODE15 Position               */
#define PORT_MOD_MODE15_Msk                   (0x03UL << PORT_MOD_MODE15_Pos)                         /*!< PORT MOD: MODE15 Mask                   */

/* ----------------------------------  PORT_TYP  ---------------------------------- */
#define PORT_TYP_TYP0_Pos                     0                                                       /*!< PORT TYP: TYP0 Position                 */
#define PORT_TYP_TYP0_Msk                     (0x01UL << PORT_TYP_TYP0_Pos)                           /*!< PORT TYP: TYP0 Mask                     */
#define PORT_TYP_TYP1_Pos                     1                                                       /*!< PORT TYP: TYP1 Position                 */
#define PORT_TYP_TYP1_Msk                     (0x01UL << PORT_TYP_TYP1_Pos)                           /*!< PORT TYP: TYP1 Mask                     */
#define PORT_TYP_TYP2_Pos                     2                                                       /*!< PORT TYP: TYP2 Position                 */
#define PORT_TYP_TYP2_Msk                     (0x01UL << PORT_TYP_TYP2_Pos)                           /*!< PORT TYP: TYP2 Mask                     */
#define PORT_TYP_TYP3_Pos                     3                                                       /*!< PORT TYP: TYP3 Position                 */
#define PORT_TYP_TYP3_Msk                     (0x01UL << PORT_TYP_TYP3_Pos)                           /*!< PORT TYP: TYP3 Mask                     */
#define PORT_TYP_TYP4_Pos                     4                                                       /*!< PORT TYP: TYP4 Position                 */
#define PORT_TYP_TYP4_Msk                     (0x01UL << PORT_TYP_TYP4_Pos)                           /*!< PORT TYP: TYP4 Mask                     */
#define PORT_TYP_TYP5_Pos                     5                                                       /*!< PORT TYP: TYP5 Position                 */
#define PORT_TYP_TYP5_Msk                     (0x01UL << PORT_TYP_TYP5_Pos)                           /*!< PORT TYP: TYP5 Mask                     */
#define PORT_TYP_TYP6_Pos                     6                                                       /*!< PORT TYP: TYP6 Position                 */
#define PORT_TYP_TYP6_Msk                     (0x01UL << PORT_TYP_TYP6_Pos)                           /*!< PORT TYP: TYP6 Mask                     */
#define PORT_TYP_TYP7_Pos                     7                                                       /*!< PORT TYP: TYP7 Position                 */
#define PORT_TYP_TYP7_Msk                     (0x01UL << PORT_TYP_TYP7_Pos)                           /*!< PORT TYP: TYP7 Mask                     */
#define PORT_TYP_TYP8_Pos                     8                                                       /*!< PORT TYP: TYP8 Position                 */
#define PORT_TYP_TYP8_Msk                     (0x01UL << PORT_TYP_TYP8_Pos)                           /*!< PORT TYP: TYP8 Mask                     */
#define PORT_TYP_TYP9_Pos                     9                                                       /*!< PORT TYP: TYP9 Position                 */
#define PORT_TYP_TYP9_Msk                     (0x01UL << PORT_TYP_TYP9_Pos)                           /*!< PORT TYP: TYP9 Mask                     */
#define PORT_TYP_TYP10_Pos                    10                                                      /*!< PORT TYP: TYP10 Position                */
#define PORT_TYP_TYP10_Msk                    (0x01UL << PORT_TYP_TYP10_Pos)                          /*!< PORT TYP: TYP10 Mask                    */
#define PORT_TYP_TYP11_Pos                    11                                                      /*!< PORT TYP: TYP11 Position                */
#define PORT_TYP_TYP11_Msk                    (0x01UL << PORT_TYP_TYP11_Pos)                          /*!< PORT TYP: TYP11 Mask                    */
#define PORT_TYP_TYP12_Pos                    12                                                      /*!< PORT TYP: TYP12 Position                */
#define PORT_TYP_TYP12_Msk                    (0x01UL << PORT_TYP_TYP12_Pos)                          /*!< PORT TYP: TYP12 Mask                    */
#define PORT_TYP_TYP13_Pos                    13                                                      /*!< PORT TYP: TYP13 Position                */
#define PORT_TYP_TYP13_Msk                    (0x01UL << PORT_TYP_TYP13_Pos)                          /*!< PORT TYP: TYP13 Mask                    */
#define PORT_TYP_TYP14_Pos                    14                                                      /*!< PORT TYP: TYP14 Position                */
#define PORT_TYP_TYP14_Msk                    (0x01UL << PORT_TYP_TYP14_Pos)                          /*!< PORT TYP: TYP14 Mask                    */
#define PORT_TYP_TYP15_Pos                    15                                                      /*!< PORT TYP: TYP15 Position                */
#define PORT_TYP_TYP15_Msk                    (0x01UL << PORT_TYP_TYP15_Pos)                          /*!< PORT TYP: TYP15 Mask                    */

/* ---------------------------------  PORT_AFSR1  --------------------------------- */
#define PORT_AFSR1_AFSR0_Pos                  0                                                       /*!< PORT AFSR1: AFSR0 Position              */
#define PORT_AFSR1_AFSR0_Msk                  (0x0fUL << PORT_AFSR1_AFSR0_Pos)                        /*!< PORT AFSR1: AFSR0 Mask                  */
#define PORT_AFSR1_AFSR1_Pos                  4                                                       /*!< PORT AFSR1: AFSR1 Position              */
#define PORT_AFSR1_AFSR1_Msk                  (0x0fUL << PORT_AFSR1_AFSR1_Pos)                        /*!< PORT AFSR1: AFSR1 Mask                  */
#define PORT_AFSR1_AFSR2_Pos                  8                                                       /*!< PORT AFSR1: AFSR2 Position              */
#define PORT_AFSR1_AFSR2_Msk                  (0x0fUL << PORT_AFSR1_AFSR2_Pos)                        /*!< PORT AFSR1: AFSR2 Mask                  */
#define PORT_AFSR1_AFSR3_Pos                  12                                                      /*!< PORT AFSR1: AFSR3 Position              */
#define PORT_AFSR1_AFSR3_Msk                  (0x0fUL << PORT_AFSR1_AFSR3_Pos)                        /*!< PORT AFSR1: AFSR3 Mask                  */
#define PORT_AFSR1_AFSR4_Pos                  16                                                      /*!< PORT AFSR1: AFSR4 Position              */
#define PORT_AFSR1_AFSR4_Msk                  (0x0fUL << PORT_AFSR1_AFSR4_Pos)                        /*!< PORT AFSR1: AFSR4 Mask                  */
#define PORT_AFSR1_AFSR5_Pos                  20                                                      /*!< PORT AFSR1: AFSR5 Position              */
#define PORT_AFSR1_AFSR5_Msk                  (0x0fUL << PORT_AFSR1_AFSR5_Pos)                        /*!< PORT AFSR1: AFSR5 Mask                  */
#define PORT_AFSR1_AFSR6_Pos                  24                                                      /*!< PORT AFSR1: AFSR6 Position              */
#define PORT_AFSR1_AFSR6_Msk                  (0x0fUL << PORT_AFSR1_AFSR6_Pos)                        /*!< PORT AFSR1: AFSR6 Mask                  */
#define PORT_AFSR1_AFSR7_Pos                  28                                                      /*!< PORT AFSR1: AFSR7 Position              */
#define PORT_AFSR1_AFSR7_Msk                  (0x0fUL << PORT_AFSR1_AFSR7_Pos)                        /*!< PORT AFSR1: AFSR7 Mask                  */

/* ---------------------------------  PORT_AFSR2  --------------------------------- */
#define PORT_AFSR2_AFSR8_Pos                  0                                                       /*!< PORT AFSR2: AFSR8 Position              */
#define PORT_AFSR2_AFSR8_Msk                  (0x0fUL << PORT_AFSR2_AFSR8_Pos)                        /*!< PORT AFSR2: AFSR8 Mask                  */
#define PORT_AFSR2_AFSR9_Pos                  4                                                       /*!< PORT AFSR2: AFSR9 Position              */
#define PORT_AFSR2_AFSR9_Msk                  (0x0fUL << PORT_AFSR2_AFSR9_Pos)                        /*!< PORT AFSR2: AFSR9 Mask                  */
#define PORT_AFSR2_AFSR10_Pos                 8                                                       /*!< PORT AFSR2: AFSR10 Position             */
#define PORT_AFSR2_AFSR10_Msk                 (0x0fUL << PORT_AFSR2_AFSR10_Pos)                       /*!< PORT AFSR2: AFSR10 Mask                 */
#define PORT_AFSR2_AFSR11_Pos                 12                                                      /*!< PORT AFSR2: AFSR11 Position             */
#define PORT_AFSR2_AFSR11_Msk                 (0x0fUL << PORT_AFSR2_AFSR11_Pos)                       /*!< PORT AFSR2: AFSR11 Mask                 */
#define PORT_AFSR2_AFSR12_Pos                 16                                                      /*!< PORT AFSR2: AFSR12 Position             */
#define PORT_AFSR2_AFSR12_Msk                 (0x0fUL << PORT_AFSR2_AFSR12_Pos)                       /*!< PORT AFSR2: AFSR12 Mask                 */
#define PORT_AFSR2_AFSR13_Pos                 20                                                      /*!< PORT AFSR2: AFSR13 Position             */
#define PORT_AFSR2_AFSR13_Msk                 (0x0fUL << PORT_AFSR2_AFSR13_Pos)                       /*!< PORT AFSR2: AFSR13 Mask                 */
#define PORT_AFSR2_AFSR14_Pos                 24                                                      /*!< PORT AFSR2: AFSR14 Position             */
#define PORT_AFSR2_AFSR14_Msk                 (0x0fUL << PORT_AFSR2_AFSR14_Pos)                       /*!< PORT AFSR2: AFSR14 Mask                 */
#define PORT_AFSR2_AFSR15_Pos                 28                                                      /*!< PORT AFSR2: AFSR15 Position             */
#define PORT_AFSR2_AFSR15_Msk                 (0x0fUL << PORT_AFSR2_AFSR15_Pos)                       /*!< PORT AFSR2: AFSR15 Mask                 */

/* ----------------------------------  PORT_PUPD  --------------------------------- */
#define PORT_PUPD_PUPD0_Pos                   0                                                       /*!< PORT PUPD: PUPD0 Position               */
#define PORT_PUPD_PUPD0_Msk                   (0x03UL << PORT_PUPD_PUPD0_Pos)                         /*!< PORT PUPD: PUPD0 Mask                   */
#define PORT_PUPD_PUPD1_Pos                   2                                                       /*!< PORT PUPD: PUPD1 Position               */
#define PORT_PUPD_PUPD1_Msk                   (0x03UL << PORT_PUPD_PUPD1_Pos)                         /*!< PORT PUPD: PUPD1 Mask                   */
#define PORT_PUPD_PUPD2_Pos                   4                                                       /*!< PORT PUPD: PUPD2 Position               */
#define PORT_PUPD_PUPD2_Msk                   (0x03UL << PORT_PUPD_PUPD2_Pos)                         /*!< PORT PUPD: PUPD2 Mask                   */
#define PORT_PUPD_PUPD3_Pos                   6                                                       /*!< PORT PUPD: PUPD3 Position               */
#define PORT_PUPD_PUPD3_Msk                   (0x03UL << PORT_PUPD_PUPD3_Pos)                         /*!< PORT PUPD: PUPD3 Mask                   */
#define PORT_PUPD_PUPD4_Pos                   8                                                       /*!< PORT PUPD: PUPD4 Position               */
#define PORT_PUPD_PUPD4_Msk                   (0x03UL << PORT_PUPD_PUPD4_Pos)                         /*!< PORT PUPD: PUPD4 Mask                   */
#define PORT_PUPD_PUPD5_Pos                   10                                                      /*!< PORT PUPD: PUPD5 Position               */
#define PORT_PUPD_PUPD5_Msk                   (0x03UL << PORT_PUPD_PUPD5_Pos)                         /*!< PORT PUPD: PUPD5 Mask                   */
#define PORT_PUPD_PUPD6_Pos                   12                                                      /*!< PORT PUPD: PUPD6 Position               */
#define PORT_PUPD_PUPD6_Msk                   (0x03UL << PORT_PUPD_PUPD6_Pos)                         /*!< PORT PUPD: PUPD6 Mask                   */
#define PORT_PUPD_PUPD7_Pos                   14                                                      /*!< PORT PUPD: PUPD7 Position               */
#define PORT_PUPD_PUPD7_Msk                   (0x03UL << PORT_PUPD_PUPD7_Pos)                         /*!< PORT PUPD: PUPD7 Mask                   */
#define PORT_PUPD_PUPD8_Pos                   16                                                      /*!< PORT PUPD: PUPD8 Position               */
#define PORT_PUPD_PUPD8_Msk                   (0x03UL << PORT_PUPD_PUPD8_Pos)                         /*!< PORT PUPD: PUPD8 Mask                   */
#define PORT_PUPD_PUPD9_Pos                   18                                                      /*!< PORT PUPD: PUPD9 Position               */
#define PORT_PUPD_PUPD9_Msk                   (0x03UL << PORT_PUPD_PUPD9_Pos)                         /*!< PORT PUPD: PUPD9 Mask                   */
#define PORT_PUPD_PUPD10_Pos                  20                                                      /*!< PORT PUPD: PUPD10 Position              */
#define PORT_PUPD_PUPD10_Msk                  (0x03UL << PORT_PUPD_PUPD10_Pos)                        /*!< PORT PUPD: PUPD10 Mask                  */
#define PORT_PUPD_PUPD11_Pos                  22                                                      /*!< PORT PUPD: PUPD11 Position              */
#define PORT_PUPD_PUPD11_Msk                  (0x03UL << PORT_PUPD_PUPD11_Pos)                        /*!< PORT PUPD: PUPD11 Mask                  */
#define PORT_PUPD_PUPD12_Pos                  24                                                      /*!< PORT PUPD: PUPD12 Position              */
#define PORT_PUPD_PUPD12_Msk                  (0x03UL << PORT_PUPD_PUPD12_Pos)                        /*!< PORT PUPD: PUPD12 Mask                  */
#define PORT_PUPD_PUPD13_Pos                  26                                                      /*!< PORT PUPD: PUPD13 Position              */
#define PORT_PUPD_PUPD13_Msk                  (0x03UL << PORT_PUPD_PUPD13_Pos)                        /*!< PORT PUPD: PUPD13 Mask                  */
#define PORT_PUPD_PUPD14_Pos                  28                                                      /*!< PORT PUPD: PUPD14 Position              */
#define PORT_PUPD_PUPD14_Msk                  (0x03UL << PORT_PUPD_PUPD14_Pos)                        /*!< PORT PUPD: PUPD14 Mask                  */
#define PORT_PUPD_PUPD15_Pos                  30                                                      /*!< PORT PUPD: PUPD15 Position              */
#define PORT_PUPD_PUPD15_Msk                  (0x03UL << PORT_PUPD_PUPD15_Pos)                        /*!< PORT PUPD: PUPD15 Mask                  */

/* ----------------------------------  PORT_INDR  --------------------------------- */
#define PORT_INDR_INDR0_Pos                   0                                                       /*!< PORT INDR: INDR0 Position               */
#define PORT_INDR_INDR0_Msk                   (0x01UL << PORT_INDR_INDR0_Pos)                         /*!< PORT INDR: INDR0 Mask                   */
#define PORT_INDR_INDR1_Pos                   1                                                       /*!< PORT INDR: INDR1 Position               */
#define PORT_INDR_INDR1_Msk                   (0x01UL << PORT_INDR_INDR1_Pos)                         /*!< PORT INDR: INDR1 Mask                   */
#define PORT_INDR_INDR2_Pos                   2                                                       /*!< PORT INDR: INDR2 Position               */
#define PORT_INDR_INDR2_Msk                   (0x01UL << PORT_INDR_INDR2_Pos)                         /*!< PORT INDR: INDR2 Mask                   */
#define PORT_INDR_INDR3_Pos                   3                                                       /*!< PORT INDR: INDR3 Position               */
#define PORT_INDR_INDR3_Msk                   (0x01UL << PORT_INDR_INDR3_Pos)                         /*!< PORT INDR: INDR3 Mask                   */
#define PORT_INDR_INDR4_Pos                   4                                                       /*!< PORT INDR: INDR4 Position               */
#define PORT_INDR_INDR4_Msk                   (0x01UL << PORT_INDR_INDR4_Pos)                         /*!< PORT INDR: INDR4 Mask                   */
#define PORT_INDR_INDR5_Pos                   5                                                       /*!< PORT INDR: INDR5 Position               */
#define PORT_INDR_INDR5_Msk                   (0x01UL << PORT_INDR_INDR5_Pos)                         /*!< PORT INDR: INDR5 Mask                   */
#define PORT_INDR_INDR6_Pos                   6                                                       /*!< PORT INDR: INDR6 Position               */
#define PORT_INDR_INDR6_Msk                   (0x01UL << PORT_INDR_INDR6_Pos)                         /*!< PORT INDR: INDR6 Mask                   */
#define PORT_INDR_INDR7_Pos                   7                                                       /*!< PORT INDR: INDR7 Position               */
#define PORT_INDR_INDR7_Msk                   (0x01UL << PORT_INDR_INDR7_Pos)                         /*!< PORT INDR: INDR7 Mask                   */
#define PORT_INDR_INDR8_Pos                   8                                                       /*!< PORT INDR: INDR8 Position               */
#define PORT_INDR_INDR8_Msk                   (0x01UL << PORT_INDR_INDR8_Pos)                         /*!< PORT INDR: INDR8 Mask                   */
#define PORT_INDR_INDR9_Pos                   9                                                       /*!< PORT INDR: INDR9 Position               */
#define PORT_INDR_INDR9_Msk                   (0x01UL << PORT_INDR_INDR9_Pos)                         /*!< PORT INDR: INDR9 Mask                   */
#define PORT_INDR_INDR10_Pos                  10                                                      /*!< PORT INDR: INDR10 Position              */
#define PORT_INDR_INDR10_Msk                  (0x01UL << PORT_INDR_INDR10_Pos)                        /*!< PORT INDR: INDR10 Mask                  */
#define PORT_INDR_INDR11_Pos                  11                                                      /*!< PORT INDR: INDR11 Position              */
#define PORT_INDR_INDR11_Msk                  (0x01UL << PORT_INDR_INDR11_Pos)                        /*!< PORT INDR: INDR11 Mask                  */
#define PORT_INDR_INDR12_Pos                  12                                                      /*!< PORT INDR: INDR12 Position              */
#define PORT_INDR_INDR12_Msk                  (0x01UL << PORT_INDR_INDR12_Pos)                        /*!< PORT INDR: INDR12 Mask                  */
#define PORT_INDR_INDR13_Pos                  13                                                      /*!< PORT INDR: INDR13 Position              */
#define PORT_INDR_INDR13_Msk                  (0x01UL << PORT_INDR_INDR13_Pos)                        /*!< PORT INDR: INDR13 Mask                  */
#define PORT_INDR_INDR14_Pos                  14                                                      /*!< PORT INDR: INDR14 Position              */
#define PORT_INDR_INDR14_Msk                  (0x01UL << PORT_INDR_INDR14_Pos)                        /*!< PORT INDR: INDR14 Mask                  */
#define PORT_INDR_INDR15_Pos                  15                                                      /*!< PORT INDR: INDR15 Position              */
#define PORT_INDR_INDR15_Msk                  (0x01UL << PORT_INDR_INDR15_Pos)                        /*!< PORT INDR: INDR15 Mask                  */

/* ---------------------------------  PORT_OUTDR  --------------------------------- */
#define PORT_OUTDR_OUTDR0_Pos                 0                                                       /*!< PORT OUTDR: OUTDR0 Position             */
#define PORT_OUTDR_OUTDR0_Msk                 (0x01UL << PORT_OUTDR_OUTDR0_Pos)                       /*!< PORT OUTDR: OUTDR0 Mask                 */
#define PORT_OUTDR_OUTDR1_Pos                 1                                                       /*!< PORT OUTDR: OUTDR1 Position             */
#define PORT_OUTDR_OUTDR1_Msk                 (0x01UL << PORT_OUTDR_OUTDR1_Pos)                       /*!< PORT OUTDR: OUTDR1 Mask                 */
#define PORT_OUTDR_OUTDR2_Pos                 2                                                       /*!< PORT OUTDR: OUTDR2 Position             */
#define PORT_OUTDR_OUTDR2_Msk                 (0x01UL << PORT_OUTDR_OUTDR2_Pos)                       /*!< PORT OUTDR: OUTDR2 Mask                 */
#define PORT_OUTDR_OUTDR3_Pos                 3                                                       /*!< PORT OUTDR: OUTDR3 Position             */
#define PORT_OUTDR_OUTDR3_Msk                 (0x01UL << PORT_OUTDR_OUTDR3_Pos)                       /*!< PORT OUTDR: OUTDR3 Mask                 */
#define PORT_OUTDR_OUTDR4_Pos                 4                                                       /*!< PORT OUTDR: OUTDR4 Position             */
#define PORT_OUTDR_OUTDR4_Msk                 (0x01UL << PORT_OUTDR_OUTDR4_Pos)                       /*!< PORT OUTDR: OUTDR4 Mask                 */
#define PORT_OUTDR_OUTDR5_Pos                 5                                                       /*!< PORT OUTDR: OUTDR5 Position             */
#define PORT_OUTDR_OUTDR5_Msk                 (0x01UL << PORT_OUTDR_OUTDR5_Pos)                       /*!< PORT OUTDR: OUTDR5 Mask                 */
#define PORT_OUTDR_OUTDR6_Pos                 6                                                       /*!< PORT OUTDR: OUTDR6 Position             */
#define PORT_OUTDR_OUTDR6_Msk                 (0x01UL << PORT_OUTDR_OUTDR6_Pos)                       /*!< PORT OUTDR: OUTDR6 Mask                 */
#define PORT_OUTDR_OUTDR7_Pos                 7                                                       /*!< PORT OUTDR: OUTDR7 Position             */
#define PORT_OUTDR_OUTDR7_Msk                 (0x01UL << PORT_OUTDR_OUTDR7_Pos)                       /*!< PORT OUTDR: OUTDR7 Mask                 */
#define PORT_OUTDR_OUTDR8_Pos                 8                                                       /*!< PORT OUTDR: OUTDR8 Position             */
#define PORT_OUTDR_OUTDR8_Msk                 (0x01UL << PORT_OUTDR_OUTDR8_Pos)                       /*!< PORT OUTDR: OUTDR8 Mask                 */
#define PORT_OUTDR_OUTDR9_Pos                 9                                                       /*!< PORT OUTDR: OUTDR9 Position             */
#define PORT_OUTDR_OUTDR9_Msk                 (0x01UL << PORT_OUTDR_OUTDR9_Pos)                       /*!< PORT OUTDR: OUTDR9 Mask                 */
#define PORT_OUTDR_OUTDR10_Pos                10                                                      /*!< PORT OUTDR: OUTDR10 Position            */
#define PORT_OUTDR_OUTDR10_Msk                (0x01UL << PORT_OUTDR_OUTDR10_Pos)                      /*!< PORT OUTDR: OUTDR10 Mask                */
#define PORT_OUTDR_OUTDR11_Pos                11                                                      /*!< PORT OUTDR: OUTDR11 Position            */
#define PORT_OUTDR_OUTDR11_Msk                (0x01UL << PORT_OUTDR_OUTDR11_Pos)                      /*!< PORT OUTDR: OUTDR11 Mask                */
#define PORT_OUTDR_OUTDR12_Pos                12                                                      /*!< PORT OUTDR: OUTDR12 Position            */
#define PORT_OUTDR_OUTDR12_Msk                (0x01UL << PORT_OUTDR_OUTDR12_Pos)                      /*!< PORT OUTDR: OUTDR12 Mask                */
#define PORT_OUTDR_OUTDR13_Pos                13                                                      /*!< PORT OUTDR: OUTDR13 Position            */
#define PORT_OUTDR_OUTDR13_Msk                (0x01UL << PORT_OUTDR_OUTDR13_Pos)                      /*!< PORT OUTDR: OUTDR13 Mask                */
#define PORT_OUTDR_OUTDR14_Pos                14                                                      /*!< PORT OUTDR: OUTDR14 Position            */
#define PORT_OUTDR_OUTDR14_Msk                (0x01UL << PORT_OUTDR_OUTDR14_Pos)                      /*!< PORT OUTDR: OUTDR14 Mask                */
#define PORT_OUTDR_OUTDR15_Pos                15                                                      /*!< PORT OUTDR: OUTDR15 Position            */
#define PORT_OUTDR_OUTDR15_Msk                (0x01UL << PORT_OUTDR_OUTDR15_Pos)                      /*!< PORT OUTDR: OUTDR15 Mask                */

/* ----------------------------------  PORT_BSR  ---------------------------------- */
#define PORT_BSR_BSR0_Pos                     0                                                       /*!< PORT BSR: BSR0 Position                 */
#define PORT_BSR_BSR0_Msk                     (0x01UL << PORT_BSR_BSR0_Pos)                           /*!< PORT BSR: BSR0 Mask                     */
#define PORT_BSR_BSR1_Pos                     1                                                       /*!< PORT BSR: BSR1 Position                 */
#define PORT_BSR_BSR1_Msk                     (0x01UL << PORT_BSR_BSR1_Pos)                           /*!< PORT BSR: BSR1 Mask                     */
#define PORT_BSR_BSR2_Pos                     2                                                       /*!< PORT BSR: BSR2 Position                 */
#define PORT_BSR_BSR2_Msk                     (0x01UL << PORT_BSR_BSR2_Pos)                           /*!< PORT BSR: BSR2 Mask                     */
#define PORT_BSR_BSR3_Pos                     3                                                       /*!< PORT BSR: BSR3 Position                 */
#define PORT_BSR_BSR3_Msk                     (0x01UL << PORT_BSR_BSR3_Pos)                           /*!< PORT BSR: BSR3 Mask                     */
#define PORT_BSR_BSR4_Pos                     4                                                       /*!< PORT BSR: BSR4 Position                 */
#define PORT_BSR_BSR4_Msk                     (0x01UL << PORT_BSR_BSR4_Pos)                           /*!< PORT BSR: BSR4 Mask                     */
#define PORT_BSR_BSR5_Pos                     5                                                       /*!< PORT BSR: BSR5 Position                 */
#define PORT_BSR_BSR5_Msk                     (0x01UL << PORT_BSR_BSR5_Pos)                           /*!< PORT BSR: BSR5 Mask                     */
#define PORT_BSR_BSR6_Pos                     6                                                       /*!< PORT BSR: BSR6 Position                 */
#define PORT_BSR_BSR6_Msk                     (0x01UL << PORT_BSR_BSR6_Pos)                           /*!< PORT BSR: BSR6 Mask                     */
#define PORT_BSR_BSR7_Pos                     7                                                       /*!< PORT BSR: BSR7 Position                 */
#define PORT_BSR_BSR7_Msk                     (0x01UL << PORT_BSR_BSR7_Pos)                           /*!< PORT BSR: BSR7 Mask                     */
#define PORT_BSR_BSR8_Pos                     8                                                       /*!< PORT BSR: BSR8 Position                 */
#define PORT_BSR_BSR8_Msk                     (0x01UL << PORT_BSR_BSR8_Pos)                           /*!< PORT BSR: BSR8 Mask                     */
#define PORT_BSR_BSR9_Pos                     9                                                       /*!< PORT BSR: BSR9 Position                 */
#define PORT_BSR_BSR9_Msk                     (0x01UL << PORT_BSR_BSR9_Pos)                           /*!< PORT BSR: BSR9 Mask                     */
#define PORT_BSR_BSR10_Pos                    10                                                      /*!< PORT BSR: BSR10 Position                */
#define PORT_BSR_BSR10_Msk                    (0x01UL << PORT_BSR_BSR10_Pos)                          /*!< PORT BSR: BSR10 Mask                    */
#define PORT_BSR_BSR11_Pos                    11                                                      /*!< PORT BSR: BSR11 Position                */
#define PORT_BSR_BSR11_Msk                    (0x01UL << PORT_BSR_BSR11_Pos)                          /*!< PORT BSR: BSR11 Mask                    */
#define PORT_BSR_BSR12_Pos                    12                                                      /*!< PORT BSR: BSR12 Position                */
#define PORT_BSR_BSR12_Msk                    (0x01UL << PORT_BSR_BSR12_Pos)                          /*!< PORT BSR: BSR12 Mask                    */
#define PORT_BSR_BSR13_Pos                    13                                                      /*!< PORT BSR: BSR13 Position                */
#define PORT_BSR_BSR13_Msk                    (0x01UL << PORT_BSR_BSR13_Pos)                          /*!< PORT BSR: BSR13 Mask                    */
#define PORT_BSR_BSR14_Pos                    14                                                      /*!< PORT BSR: BSR14 Position                */
#define PORT_BSR_BSR14_Msk                    (0x01UL << PORT_BSR_BSR14_Pos)                          /*!< PORT BSR: BSR14 Mask                    */
#define PORT_BSR_BSR15_Pos                    15                                                      /*!< PORT BSR: BSR15 Position                */
#define PORT_BSR_BSR15_Msk                    (0x01UL << PORT_BSR_BSR15_Pos)                          /*!< PORT BSR: BSR15 Mask                    */

/* ----------------------------------  PORT_BCR  ---------------------------------- */
#define PORT_BCR_BCR0_Pos                     0                                                       /*!< PORT BCR: BCR0 Position                 */
#define PORT_BCR_BCR0_Msk                     (0x01UL << PORT_BCR_BCR0_Pos)                           /*!< PORT BCR: BCR0 Mask                     */
#define PORT_BCR_BCR1_Pos                     1                                                       /*!< PORT BCR: BCR1 Position                 */
#define PORT_BCR_BCR1_Msk                     (0x01UL << PORT_BCR_BCR1_Pos)                           /*!< PORT BCR: BCR1 Mask                     */
#define PORT_BCR_BCR2_Pos                     2                                                       /*!< PORT BCR: BCR2 Position                 */
#define PORT_BCR_BCR2_Msk                     (0x01UL << PORT_BCR_BCR2_Pos)                           /*!< PORT BCR: BCR2 Mask                     */
#define PORT_BCR_BCR3_Pos                     3                                                       /*!< PORT BCR: BCR3 Position                 */
#define PORT_BCR_BCR3_Msk                     (0x01UL << PORT_BCR_BCR3_Pos)                           /*!< PORT BCR: BCR3 Mask                     */
#define PORT_BCR_BCR4_Pos                     4                                                       /*!< PORT BCR: BCR4 Position                 */
#define PORT_BCR_BCR4_Msk                     (0x01UL << PORT_BCR_BCR4_Pos)                           /*!< PORT BCR: BCR4 Mask                     */
#define PORT_BCR_BCR5_Pos                     5                                                       /*!< PORT BCR: BCR5 Position                 */
#define PORT_BCR_BCR5_Msk                     (0x01UL << PORT_BCR_BCR5_Pos)                           /*!< PORT BCR: BCR5 Mask                     */
#define PORT_BCR_BCR6_Pos                     6                                                       /*!< PORT BCR: BCR6 Position                 */
#define PORT_BCR_BCR6_Msk                     (0x01UL << PORT_BCR_BCR6_Pos)                           /*!< PORT BCR: BCR6 Mask                     */
#define PORT_BCR_BCR7_Pos                     7                                                       /*!< PORT BCR: BCR7 Position                 */
#define PORT_BCR_BCR7_Msk                     (0x01UL << PORT_BCR_BCR7_Pos)                           /*!< PORT BCR: BCR7 Mask                     */
#define PORT_BCR_BCR8_Pos                     8                                                       /*!< PORT BCR: BCR8 Position                 */
#define PORT_BCR_BCR8_Msk                     (0x01UL << PORT_BCR_BCR8_Pos)                           /*!< PORT BCR: BCR8 Mask                     */
#define PORT_BCR_BCR9_Pos                     9                                                       /*!< PORT BCR: BCR9 Position                 */
#define PORT_BCR_BCR9_Msk                     (0x01UL << PORT_BCR_BCR9_Pos)                           /*!< PORT BCR: BCR9 Mask                     */
#define PORT_BCR_BCR10_Pos                    10                                                      /*!< PORT BCR: BCR10 Position                */
#define PORT_BCR_BCR10_Msk                    (0x01UL << PORT_BCR_BCR10_Pos)                          /*!< PORT BCR: BCR10 Mask                    */
#define PORT_BCR_BCR11_Pos                    11                                                      /*!< PORT BCR: BCR11 Position                */
#define PORT_BCR_BCR11_Msk                    (0x01UL << PORT_BCR_BCR11_Pos)                          /*!< PORT BCR: BCR11 Mask                    */
#define PORT_BCR_BCR12_Pos                    12                                                      /*!< PORT BCR: BCR12 Position                */
#define PORT_BCR_BCR12_Msk                    (0x01UL << PORT_BCR_BCR12_Pos)                          /*!< PORT BCR: BCR12 Mask                    */
#define PORT_BCR_BCR13_Pos                    13                                                      /*!< PORT BCR: BCR13 Position                */
#define PORT_BCR_BCR13_Msk                    (0x01UL << PORT_BCR_BCR13_Pos)                          /*!< PORT BCR: BCR13 Mask                    */
#define PORT_BCR_BCR14_Pos                    14                                                      /*!< PORT BCR: BCR14 Position                */
#define PORT_BCR_BCR14_Msk                    (0x01UL << PORT_BCR_BCR14_Pos)                          /*!< PORT BCR: BCR14 Mask                    */
#define PORT_BCR_BCR15_Pos                    15                                                      /*!< PORT BCR: BCR15 Position                */
#define PORT_BCR_BCR15_Msk                    (0x01UL << PORT_BCR_BCR15_Pos)                          /*!< PORT BCR: BCR15 Mask                    */

/* --------------------------------  PORT_OUTDMSK  -------------------------------- */
#define PORT_OUTDMSK_OUTDMSK0_Pos             0                                                       /*!< PORT OUTDMSK: OUTDMSK0 Position         */
#define PORT_OUTDMSK_OUTDMSK0_Msk             (0x01UL << PORT_OUTDMSK_OUTDMSK0_Pos)                   /*!< PORT OUTDMSK: OUTDMSK0 Mask             */
#define PORT_OUTDMSK_OUTDMSK1_Pos             1                                                       /*!< PORT OUTDMSK: OUTDMSK1 Position         */
#define PORT_OUTDMSK_OUTDMSK1_Msk             (0x01UL << PORT_OUTDMSK_OUTDMSK1_Pos)                   /*!< PORT OUTDMSK: OUTDMSK1 Mask             */
#define PORT_OUTDMSK_OUTDMSK2_Pos             2                                                       /*!< PORT OUTDMSK: OUTDMSK2 Position         */
#define PORT_OUTDMSK_OUTDMSK2_Msk             (0x01UL << PORT_OUTDMSK_OUTDMSK2_Pos)                   /*!< PORT OUTDMSK: OUTDMSK2 Mask             */
#define PORT_OUTDMSK_OUTDMSK3_Pos             3                                                       /*!< PORT OUTDMSK: OUTDMSK3 Position         */
#define PORT_OUTDMSK_OUTDMSK3_Msk             (0x01UL << PORT_OUTDMSK_OUTDMSK3_Pos)                   /*!< PORT OUTDMSK: OUTDMSK3 Mask             */
#define PORT_OUTDMSK_OUTDMSK4_Pos             4                                                       /*!< PORT OUTDMSK: OUTDMSK4 Position         */
#define PORT_OUTDMSK_OUTDMSK4_Msk             (0x01UL << PORT_OUTDMSK_OUTDMSK4_Pos)                   /*!< PORT OUTDMSK: OUTDMSK4 Mask             */
#define PORT_OUTDMSK_OUTDMSK5_Pos             5                                                       /*!< PORT OUTDMSK: OUTDMSK5 Position         */
#define PORT_OUTDMSK_OUTDMSK5_Msk             (0x01UL << PORT_OUTDMSK_OUTDMSK5_Pos)                   /*!< PORT OUTDMSK: OUTDMSK5 Mask             */
#define PORT_OUTDMSK_OUTDMSK6_Pos             6                                                       /*!< PORT OUTDMSK: OUTDMSK6 Position         */
#define PORT_OUTDMSK_OUTDMSK6_Msk             (0x01UL << PORT_OUTDMSK_OUTDMSK6_Pos)                   /*!< PORT OUTDMSK: OUTDMSK6 Mask             */
#define PORT_OUTDMSK_OUTDMSK7_Pos             7                                                       /*!< PORT OUTDMSK: OUTDMSK7 Position         */
#define PORT_OUTDMSK_OUTDMSK7_Msk             (0x01UL << PORT_OUTDMSK_OUTDMSK7_Pos)                   /*!< PORT OUTDMSK: OUTDMSK7 Mask             */
#define PORT_OUTDMSK_OUTDMSK8_Pos             8                                                       /*!< PORT OUTDMSK: OUTDMSK8 Position         */
#define PORT_OUTDMSK_OUTDMSK8_Msk             (0x01UL << PORT_OUTDMSK_OUTDMSK8_Pos)                   /*!< PORT OUTDMSK: OUTDMSK8 Mask             */
#define PORT_OUTDMSK_OUTDMSK9_Pos             9                                                       /*!< PORT OUTDMSK: OUTDMSK9 Position         */
#define PORT_OUTDMSK_OUTDMSK9_Msk             (0x01UL << PORT_OUTDMSK_OUTDMSK9_Pos)                   /*!< PORT OUTDMSK: OUTDMSK9 Mask             */
#define PORT_OUTDMSK_OUTDMSK10_Pos            10                                                      /*!< PORT OUTDMSK: OUTDMSK10 Position        */
#define PORT_OUTDMSK_OUTDMSK10_Msk            (0x01UL << PORT_OUTDMSK_OUTDMSK10_Pos)                  /*!< PORT OUTDMSK: OUTDMSK10 Mask            */
#define PORT_OUTDMSK_OUTDMSK11_Pos            11                                                      /*!< PORT OUTDMSK: OUTDMSK11 Position        */
#define PORT_OUTDMSK_OUTDMSK11_Msk            (0x01UL << PORT_OUTDMSK_OUTDMSK11_Pos)                  /*!< PORT OUTDMSK: OUTDMSK11 Mask            */
#define PORT_OUTDMSK_OUTDMSK12_Pos            12                                                      /*!< PORT OUTDMSK: OUTDMSK12 Position        */
#define PORT_OUTDMSK_OUTDMSK12_Msk            (0x01UL << PORT_OUTDMSK_OUTDMSK12_Pos)                  /*!< PORT OUTDMSK: OUTDMSK12 Mask            */
#define PORT_OUTDMSK_OUTDMSK13_Pos            13                                                      /*!< PORT OUTDMSK: OUTDMSK13 Position        */
#define PORT_OUTDMSK_OUTDMSK13_Msk            (0x01UL << PORT_OUTDMSK_OUTDMSK13_Pos)                  /*!< PORT OUTDMSK: OUTDMSK13 Mask            */
#define PORT_OUTDMSK_OUTDMSK14_Pos            14                                                      /*!< PORT OUTDMSK: OUTDMSK14 Position        */
#define PORT_OUTDMSK_OUTDMSK14_Msk            (0x01UL << PORT_OUTDMSK_OUTDMSK14_Pos)                  /*!< PORT OUTDMSK: OUTDMSK14 Mask            */
#define PORT_OUTDMSK_OUTDMSK15_Pos            15                                                      /*!< PORT OUTDMSK: OUTDMSK15 Position        */
#define PORT_OUTDMSK_OUTDMSK15_Msk            (0x01UL << PORT_OUTDMSK_OUTDMSK15_Pos)                  /*!< PORT OUTDMSK: OUTDMSK15 Mask            */

/* ----------------------------------  PORT_DBCR  --------------------------------- */
#define PORT_DBCR_DBEN0_Pos                   0                                                       /*!< PORT DBCR: DBEN0 Position               */
#define PORT_DBCR_DBEN0_Msk                   (0x01UL << PORT_DBCR_DBEN0_Pos)                         /*!< PORT DBCR: DBEN0 Mask                   */
#define PORT_DBCR_DBEN1_Pos                   1                                                       /*!< PORT DBCR: DBEN1 Position               */
#define PORT_DBCR_DBEN1_Msk                   (0x01UL << PORT_DBCR_DBEN1_Pos)                         /*!< PORT DBCR: DBEN1 Mask                   */
#define PORT_DBCR_DBEN2_Pos                   2                                                       /*!< PORT DBCR: DBEN2 Position               */
#define PORT_DBCR_DBEN2_Msk                   (0x01UL << PORT_DBCR_DBEN2_Pos)                         /*!< PORT DBCR: DBEN2 Mask                   */
#define PORT_DBCR_DBEN3_Pos                   3                                                       /*!< PORT DBCR: DBEN3 Position               */
#define PORT_DBCR_DBEN3_Msk                   (0x01UL << PORT_DBCR_DBEN3_Pos)                         /*!< PORT DBCR: DBEN3 Mask                   */
#define PORT_DBCR_DBEN4_Pos                   4                                                       /*!< PORT DBCR: DBEN4 Position               */
#define PORT_DBCR_DBEN4_Msk                   (0x01UL << PORT_DBCR_DBEN4_Pos)                         /*!< PORT DBCR: DBEN4 Mask                   */
#define PORT_DBCR_DBEN5_Pos                   5                                                       /*!< PORT DBCR: DBEN5 Position               */
#define PORT_DBCR_DBEN5_Msk                   (0x01UL << PORT_DBCR_DBEN5_Pos)                         /*!< PORT DBCR: DBEN5 Mask                   */
#define PORT_DBCR_DBEN6_Pos                   6                                                       /*!< PORT DBCR: DBEN6 Position               */
#define PORT_DBCR_DBEN6_Msk                   (0x01UL << PORT_DBCR_DBEN6_Pos)                         /*!< PORT DBCR: DBEN6 Mask                   */
#define PORT_DBCR_DBEN7_Pos                   7                                                       /*!< PORT DBCR: DBEN7 Position               */
#define PORT_DBCR_DBEN7_Msk                   (0x01UL << PORT_DBCR_DBEN7_Pos)                         /*!< PORT DBCR: DBEN7 Mask                   */
#define PORT_DBCR_DBEN8_Pos                   8                                                       /*!< PORT DBCR: DBEN8 Position               */
#define PORT_DBCR_DBEN8_Msk                   (0x01UL << PORT_DBCR_DBEN8_Pos)                         /*!< PORT DBCR: DBEN8 Mask                   */
#define PORT_DBCR_DBEN9_Pos                   9                                                       /*!< PORT DBCR: DBEN9 Position               */
#define PORT_DBCR_DBEN9_Msk                   (0x01UL << PORT_DBCR_DBEN9_Pos)                         /*!< PORT DBCR: DBEN9 Mask                   */
#define PORT_DBCR_DBEN10_Pos                  10                                                      /*!< PORT DBCR: DBEN10 Position              */
#define PORT_DBCR_DBEN10_Msk                  (0x01UL << PORT_DBCR_DBEN10_Pos)                        /*!< PORT DBCR: DBEN10 Mask                  */
#define PORT_DBCR_DBEN11_Pos                  11                                                      /*!< PORT DBCR: DBEN11 Position              */
#define PORT_DBCR_DBEN11_Msk                  (0x01UL << PORT_DBCR_DBEN11_Pos)                        /*!< PORT DBCR: DBEN11 Mask                  */
#define PORT_DBCR_DBEN12_Pos                  12                                                      /*!< PORT DBCR: DBEN12 Position              */
#define PORT_DBCR_DBEN12_Msk                  (0x01UL << PORT_DBCR_DBEN12_Pos)                        /*!< PORT DBCR: DBEN12 Mask                  */
#define PORT_DBCR_DBEN13_Pos                  13                                                      /*!< PORT DBCR: DBEN13 Position              */
#define PORT_DBCR_DBEN13_Msk                  (0x01UL << PORT_DBCR_DBEN13_Pos)                        /*!< PORT DBCR: DBEN13 Mask                  */
#define PORT_DBCR_DBEN14_Pos                  14                                                      /*!< PORT DBCR: DBEN14 Position              */
#define PORT_DBCR_DBEN14_Msk                  (0x01UL << PORT_DBCR_DBEN14_Pos)                        /*!< PORT DBCR: DBEN14 Mask                  */
#define PORT_DBCR_DBEN15_Pos                  15                                                      /*!< PORT DBCR: DBEN15 Position              */
#define PORT_DBCR_DBEN15_Msk                  (0x01UL << PORT_DBCR_DBEN15_Pos)                        /*!< PORT DBCR: DBEN15 Mask                  */

/* ----------------------------------  PORT_IER  ---------------------------------- */
#define PORT_IER_P0_Pos                       0                                                       /*!< PORT IER: P0 Position                   */
#define PORT_IER_P0_Msk                       (0x03UL << PORT_IER_P0_Pos)                             /*!< PORT IER: P0 Mask                       */
#define PORT_IER_P1_Pos                       2                                                       /*!< PORT IER: P1 Position                   */
#define PORT_IER_P1_Msk                       (0x03UL << PORT_IER_P1_Pos)                             /*!< PORT IER: P1 Mask                       */
#define PORT_IER_P2_Pos                       4                                                       /*!< PORT IER: P2 Position                   */
#define PORT_IER_P2_Msk                       (0x03UL << PORT_IER_P2_Pos)                             /*!< PORT IER: P2 Mask                       */
#define PORT_IER_P3_Pos                       6                                                       /*!< PORT IER: P3 Position                   */
#define PORT_IER_P3_Msk                       (0x03UL << PORT_IER_P3_Pos)                             /*!< PORT IER: P3 Mask                       */
#define PORT_IER_P4_Pos                       8                                                       /*!< PORT IER: P4 Position                   */
#define PORT_IER_P4_Msk                       (0x03UL << PORT_IER_P4_Pos)                             /*!< PORT IER: P4 Mask                       */
#define PORT_IER_P5_Pos                       10                                                      /*!< PORT IER: P5 Position                   */
#define PORT_IER_P5_Msk                       (0x03UL << PORT_IER_P5_Pos)                             /*!< PORT IER: P5 Mask                       */
#define PORT_IER_P6_Pos                       12                                                      /*!< PORT IER: P6 Position                   */
#define PORT_IER_P6_Msk                       (0x03UL << PORT_IER_P6_Pos)                             /*!< PORT IER: P6 Mask                       */
#define PORT_IER_P7_Pos                       14                                                      /*!< PORT IER: P7 Position                   */
#define PORT_IER_P7_Msk                       (0x03UL << PORT_IER_P7_Pos)                             /*!< PORT IER: P7 Mask                       */
#define PORT_IER_P8_Pos                       16                                                      /*!< PORT IER: P8 Position                   */
#define PORT_IER_P8_Msk                       (0x03UL << PORT_IER_P8_Pos)                             /*!< PORT IER: P8 Mask                       */
#define PORT_IER_P9_Pos                       18                                                      /*!< PORT IER: P9 Position                   */
#define PORT_IER_P9_Msk                       (0x03UL << PORT_IER_P9_Pos)                             /*!< PORT IER: P9 Mask                       */
#define PORT_IER_P10_Pos                      20                                                      /*!< PORT IER: P10 Position                  */
#define PORT_IER_P10_Msk                      (0x03UL << PORT_IER_P10_Pos)                            /*!< PORT IER: P10 Mask                      */
#define PORT_IER_P11_Pos                      22                                                      /*!< PORT IER: P11 Position                  */
#define PORT_IER_P11_Msk                      (0x03UL << PORT_IER_P11_Pos)                            /*!< PORT IER: P11 Mask                      */
#define PORT_IER_P12_Pos                      24                                                      /*!< PORT IER: P12 Position                  */
#define PORT_IER_P12_Msk                      (0x03UL << PORT_IER_P12_Pos)                            /*!< PORT IER: P12 Mask                      */
#define PORT_IER_P13_Pos                      26                                                      /*!< PORT IER: P13 Position                  */
#define PORT_IER_P13_Msk                      (0x03UL << PORT_IER_P13_Pos)                            /*!< PORT IER: P13 Mask                      */
#define PORT_IER_P14_Pos                      28                                                      /*!< PORT IER: P14 Position                  */
#define PORT_IER_P14_Msk                      (0x03UL << PORT_IER_P14_Pos)                            /*!< PORT IER: P14 Mask                      */
#define PORT_IER_P15_Pos                      30                                                      /*!< PORT IER: P15 Position                  */
#define PORT_IER_P15_Msk                      (0x03UL << PORT_IER_P15_Pos)                            /*!< PORT IER: P15 Mask                      */

/* ----------------------------------  PORT_ISR  ---------------------------------- */
#define PORT_ISR_P0_Pos                       0                                                       /*!< PORT ISR: P0 Position                   */
#define PORT_ISR_P0_Msk                       (0x03UL << PORT_ISR_P0_Pos)                             /*!< PORT ISR: P0 Mask                       */
#define PORT_ISR_P1_Pos                       2                                                       /*!< PORT ISR: P1 Position                   */
#define PORT_ISR_P1_Msk                       (0x03UL << PORT_ISR_P1_Pos)                             /*!< PORT ISR: P1 Mask                       */
#define PORT_ISR_P2_Pos                       4                                                       /*!< PORT ISR: P2 Position                   */
#define PORT_ISR_P2_Msk                       (0x03UL << PORT_ISR_P2_Pos)                             /*!< PORT ISR: P2 Mask                       */
#define PORT_ISR_P3_Pos                       6                                                       /*!< PORT ISR: P3 Position                   */
#define PORT_ISR_P3_Msk                       (0x03UL << PORT_ISR_P3_Pos)                             /*!< PORT ISR: P3 Mask                       */
#define PORT_ISR_P4_Pos                       8                                                       /*!< PORT ISR: P4 Position                   */
#define PORT_ISR_P4_Msk                       (0x03UL << PORT_ISR_P4_Pos)                             /*!< PORT ISR: P4 Mask                       */
#define PORT_ISR_P5_Pos                       10                                                      /*!< PORT ISR: P5 Position                   */
#define PORT_ISR_P5_Msk                       (0x03UL << PORT_ISR_P5_Pos)                             /*!< PORT ISR: P5 Mask                       */
#define PORT_ISR_P6_Pos                       12                                                      /*!< PORT ISR: P6 Position                   */
#define PORT_ISR_P6_Msk                       (0x03UL << PORT_ISR_P6_Pos)                             /*!< PORT ISR: P6 Mask                       */
#define PORT_ISR_P7_Pos                       14                                                      /*!< PORT ISR: P7 Position                   */
#define PORT_ISR_P7_Msk                       (0x03UL << PORT_ISR_P7_Pos)                             /*!< PORT ISR: P7 Mask                       */
#define PORT_ISR_P8_Pos                       16                                                      /*!< PORT ISR: P8 Position                   */
#define PORT_ISR_P8_Msk                       (0x03UL << PORT_ISR_P8_Pos)                             /*!< PORT ISR: P8 Mask                       */
#define PORT_ISR_P9_Pos                       18                                                      /*!< PORT ISR: P9 Position                   */
#define PORT_ISR_P9_Msk                       (0x03UL << PORT_ISR_P9_Pos)                             /*!< PORT ISR: P9 Mask                       */
#define PORT_ISR_P10_Pos                      20                                                      /*!< PORT ISR: P10 Position                  */
#define PORT_ISR_P10_Msk                      (0x03UL << PORT_ISR_P10_Pos)                            /*!< PORT ISR: P10 Mask                      */
#define PORT_ISR_P11_Pos                      22                                                      /*!< PORT ISR: P11 Position                  */
#define PORT_ISR_P11_Msk                      (0x03UL << PORT_ISR_P11_Pos)                            /*!< PORT ISR: P11 Mask                      */
#define PORT_ISR_P12_Pos                      24                                                      /*!< PORT ISR: P12 Position                  */
#define PORT_ISR_P12_Msk                      (0x03UL << PORT_ISR_P12_Pos)                            /*!< PORT ISR: P12 Mask                      */
#define PORT_ISR_P13_Pos                      26                                                      /*!< PORT ISR: P13 Position                  */
#define PORT_ISR_P13_Msk                      (0x03UL << PORT_ISR_P13_Pos)                            /*!< PORT ISR: P13 Mask                      */
#define PORT_ISR_P14_Pos                      28                                                      /*!< PORT ISR: P14 Position                  */
#define PORT_ISR_P14_Msk                      (0x03UL << PORT_ISR_P14_Pos)                            /*!< PORT ISR: P14 Mask                      */
#define PORT_ISR_P15_Pos                      30                                                      /*!< PORT ISR: P15 Position                  */
#define PORT_ISR_P15_Msk                      (0x03UL << PORT_ISR_P15_Pos)                            /*!< PORT ISR: P15 Mask                      */

/* ----------------------------------  PORT_ICR  ---------------------------------- */
#define PORT_ICR_P0_Pos                       0                                                       /*!< PORT ICR: P0 Position                   */
#define PORT_ICR_P0_Msk                       (0x03UL << PORT_ICR_P0_Pos)                             /*!< PORT ICR: P0 Mask                       */
#define PORT_ICR_P1_Pos                       2                                                       /*!< PORT ICR: P1 Position                   */
#define PORT_ICR_P1_Msk                       (0x03UL << PORT_ICR_P1_Pos)                             /*!< PORT ICR: P1 Mask                       */
#define PORT_ICR_P2_Pos                       4                                                       /*!< PORT ICR: P2 Position                   */
#define PORT_ICR_P2_Msk                       (0x03UL << PORT_ICR_P2_Pos)                             /*!< PORT ICR: P2 Mask                       */
#define PORT_ICR_P3_Pos                       6                                                       /*!< PORT ICR: P3 Position                   */
#define PORT_ICR_P3_Msk                       (0x03UL << PORT_ICR_P3_Pos)                             /*!< PORT ICR: P3 Mask                       */
#define PORT_ICR_P4_Pos                       8                                                       /*!< PORT ICR: P4 Position                   */
#define PORT_ICR_P4_Msk                       (0x03UL << PORT_ICR_P4_Pos)                             /*!< PORT ICR: P4 Mask                       */
#define PORT_ICR_P5_Pos                       10                                                      /*!< PORT ICR: P5 Position                   */
#define PORT_ICR_P5_Msk                       (0x03UL << PORT_ICR_P5_Pos)                             /*!< PORT ICR: P5 Mask                       */
#define PORT_ICR_P6_Pos                       12                                                      /*!< PORT ICR: P6 Position                   */
#define PORT_ICR_P6_Msk                       (0x03UL << PORT_ICR_P6_Pos)                             /*!< PORT ICR: P6 Mask                       */
#define PORT_ICR_P7_Pos                       14                                                      /*!< PORT ICR: P7 Position                   */
#define PORT_ICR_P7_Msk                       (0x03UL << PORT_ICR_P7_Pos)                             /*!< PORT ICR: P7 Mask                       */
#define PORT_ICR_P8_Pos                       16                                                      /*!< PORT ICR: P8 Position                   */
#define PORT_ICR_P8_Msk                       (0x03UL << PORT_ICR_P8_Pos)                             /*!< PORT ICR: P8 Mask                       */
#define PORT_ICR_P9_Pos                       18                                                      /*!< PORT ICR: P9 Position                   */
#define PORT_ICR_P9_Msk                       (0x03UL << PORT_ICR_P9_Pos)                             /*!< PORT ICR: P9 Mask                       */
#define PORT_ICR_P10_Pos                      20                                                      /*!< PORT ICR: P10 Position                  */
#define PORT_ICR_P10_Msk                      (0x03UL << PORT_ICR_P10_Pos)                            /*!< PORT ICR: P10 Mask                      */
#define PORT_ICR_P11_Pos                      22                                                      /*!< PORT ICR: P11 Position                  */
#define PORT_ICR_P11_Msk                      (0x03UL << PORT_ICR_P11_Pos)                            /*!< PORT ICR: P11 Mask                      */
#define PORT_ICR_P12_Pos                      24                                                      /*!< PORT ICR: P12 Position                  */
#define PORT_ICR_P12_Msk                      (0x03UL << PORT_ICR_P12_Pos)                            /*!< PORT ICR: P12 Mask                      */
#define PORT_ICR_P13_Pos                      26                                                      /*!< PORT ICR: P13 Position                  */
#define PORT_ICR_P13_Msk                      (0x03UL << PORT_ICR_P13_Pos)                            /*!< PORT ICR: P13 Mask                      */
#define PORT_ICR_P14_Pos                      28                                                      /*!< PORT ICR: P14 Position                  */
#define PORT_ICR_P14_Msk                      (0x03UL << PORT_ICR_P14_Pos)                            /*!< PORT ICR: P14 Mask                      */
#define PORT_ICR_P15_Pos                      30                                                      /*!< PORT ICR: P15 Position                  */
#define PORT_ICR_P15_Msk                      (0x03UL << PORT_ICR_P15_Pos)                            /*!< PORT ICR: P15 Mask                      */

/* ----------------------------------  PORT_STR  ---------------------------------- */
#define PORT_STR_P0_Pos                       0                                                       /*!< PORT STR: P0 Position                   */
#define PORT_STR_P0_Msk                       (0x03UL << PORT_STR_P0_Pos)                             /*!< PORT STR: P0 Mask                       */
#define PORT_STR_P1_Pos                       2                                                       /*!< PORT STR: P1 Position                   */
#define PORT_STR_P1_Msk                       (0x03UL << PORT_STR_P1_Pos)                             /*!< PORT STR: P1 Mask                       */
#define PORT_STR_P2_Pos                       4                                                       /*!< PORT STR: P2 Position                   */
#define PORT_STR_P2_Msk                       (0x03UL << PORT_STR_P2_Pos)                             /*!< PORT STR: P2 Mask                       */
#define PORT_STR_P3_Pos                       6                                                       /*!< PORT STR: P3 Position                   */
#define PORT_STR_P3_Msk                       (0x03UL << PORT_STR_P3_Pos)                             /*!< PORT STR: P3 Mask                       */
#define PORT_STR_P4_Pos                       8                                                       /*!< PORT STR: P4 Position                   */
#define PORT_STR_P4_Msk                       (0x03UL << PORT_STR_P4_Pos)                             /*!< PORT STR: P4 Mask                       */


/* ================================================================================ */
/* ================           struct 'PA' Position & Mask          ================ */
/* ================================================================================ */


/* -----------------------------------  PA_MOD  ----------------------------------- */
#define PA_MOD_MODE0_Pos                      0                                                       /*!< PA MOD: MODE0 Position                  */
#define PA_MOD_MODE0_Msk                      (0x03UL << PA_MOD_MODE0_Pos)                            /*!< PA MOD: MODE0 Mask                      */
#define PA_MOD_MODE1_Pos                      2                                                       /*!< PA MOD: MODE1 Position                  */
#define PA_MOD_MODE1_Msk                      (0x03UL << PA_MOD_MODE1_Pos)                            /*!< PA MOD: MODE1 Mask                      */
#define PA_MOD_MODE2_Pos                      4                                                       /*!< PA MOD: MODE2 Position                  */
#define PA_MOD_MODE2_Msk                      (0x03UL << PA_MOD_MODE2_Pos)                            /*!< PA MOD: MODE2 Mask                      */
#define PA_MOD_MODE3_Pos                      6                                                       /*!< PA MOD: MODE3 Position                  */
#define PA_MOD_MODE3_Msk                      (0x03UL << PA_MOD_MODE3_Pos)                            /*!< PA MOD: MODE3 Mask                      */
#define PA_MOD_MODE4_Pos                      8                                                       /*!< PA MOD: MODE4 Position                  */
#define PA_MOD_MODE4_Msk                      (0x03UL << PA_MOD_MODE4_Pos)                            /*!< PA MOD: MODE4 Mask                      */
#define PA_MOD_MODE5_Pos                      10                                                      /*!< PA MOD: MODE5 Position                  */
#define PA_MOD_MODE5_Msk                      (0x03UL << PA_MOD_MODE5_Pos)                            /*!< PA MOD: MODE5 Mask                      */
#define PA_MOD_MODE6_Pos                      12                                                      /*!< PA MOD: MODE6 Position                  */
#define PA_MOD_MODE6_Msk                      (0x03UL << PA_MOD_MODE6_Pos)                            /*!< PA MOD: MODE6 Mask                      */
#define PA_MOD_MODE7_Pos                      14                                                      /*!< PA MOD: MODE7 Position                  */
#define PA_MOD_MODE7_Msk                      (0x03UL << PA_MOD_MODE7_Pos)                            /*!< PA MOD: MODE7 Mask                      */
#define PA_MOD_MODE8_Pos                      16                                                      /*!< PA MOD: MODE8 Position                  */
#define PA_MOD_MODE8_Msk                      (0x03UL << PA_MOD_MODE8_Pos)                            /*!< PA MOD: MODE8 Mask                      */
#define PA_MOD_MODE9_Pos                      18                                                      /*!< PA MOD: MODE9 Position                  */
#define PA_MOD_MODE9_Msk                      (0x03UL << PA_MOD_MODE9_Pos)                            /*!< PA MOD: MODE9 Mask                      */
#define PA_MOD_MODE10_Pos                     20                                                      /*!< PA MOD: MODE10 Position                 */
#define PA_MOD_MODE10_Msk                     (0x03UL << PA_MOD_MODE10_Pos)                           /*!< PA MOD: MODE10 Mask                     */
#define PA_MOD_MODE11_Pos                     22                                                      /*!< PA MOD: MODE11 Position                 */
#define PA_MOD_MODE11_Msk                     (0x03UL << PA_MOD_MODE11_Pos)                           /*!< PA MOD: MODE11 Mask                     */
#define PA_MOD_MODE12_Pos                     24                                                      /*!< PA MOD: MODE12 Position                 */
#define PA_MOD_MODE12_Msk                     (0x03UL << PA_MOD_MODE12_Pos)                           /*!< PA MOD: MODE12 Mask                     */
#define PA_MOD_MODE13_Pos                     26                                                      /*!< PA MOD: MODE13 Position                 */
#define PA_MOD_MODE13_Msk                     (0x03UL << PA_MOD_MODE13_Pos)                           /*!< PA MOD: MODE13 Mask                     */
#define PA_MOD_MODE14_Pos                     28                                                      /*!< PA MOD: MODE14 Position                 */
#define PA_MOD_MODE14_Msk                     (0x03UL << PA_MOD_MODE14_Pos)                           /*!< PA MOD: MODE14 Mask                     */
#define PA_MOD_MODE15_Pos                     30                                                      /*!< PA MOD: MODE15 Position                 */
#define PA_MOD_MODE15_Msk                     (0x03UL << PA_MOD_MODE15_Pos)                           /*!< PA MOD: MODE15 Mask                     */

/* -----------------------------------  PA_TYP  ----------------------------------- */
#define PA_TYP_TYP0_Pos                       0                                                       /*!< PA TYP: TYP0 Position                   */
#define PA_TYP_TYP0_Msk                       (0x01UL << PA_TYP_TYP0_Pos)                             /*!< PA TYP: TYP0 Mask                       */
#define PA_TYP_TYP1_Pos                       1                                                       /*!< PA TYP: TYP1 Position                   */
#define PA_TYP_TYP1_Msk                       (0x01UL << PA_TYP_TYP1_Pos)                             /*!< PA TYP: TYP1 Mask                       */
#define PA_TYP_TYP2_Pos                       2                                                       /*!< PA TYP: TYP2 Position                   */
#define PA_TYP_TYP2_Msk                       (0x01UL << PA_TYP_TYP2_Pos)                             /*!< PA TYP: TYP2 Mask                       */
#define PA_TYP_TYP3_Pos                       3                                                       /*!< PA TYP: TYP3 Position                   */
#define PA_TYP_TYP3_Msk                       (0x01UL << PA_TYP_TYP3_Pos)                             /*!< PA TYP: TYP3 Mask                       */
#define PA_TYP_TYP4_Pos                       4                                                       /*!< PA TYP: TYP4 Position                   */
#define PA_TYP_TYP4_Msk                       (0x01UL << PA_TYP_TYP4_Pos)                             /*!< PA TYP: TYP4 Mask                       */
#define PA_TYP_TYP5_Pos                       5                                                       /*!< PA TYP: TYP5 Position                   */
#define PA_TYP_TYP5_Msk                       (0x01UL << PA_TYP_TYP5_Pos)                             /*!< PA TYP: TYP5 Mask                       */
#define PA_TYP_TYP6_Pos                       6                                                       /*!< PA TYP: TYP6 Position                   */
#define PA_TYP_TYP6_Msk                       (0x01UL << PA_TYP_TYP6_Pos)                             /*!< PA TYP: TYP6 Mask                       */
#define PA_TYP_TYP7_Pos                       7                                                       /*!< PA TYP: TYP7 Position                   */
#define PA_TYP_TYP7_Msk                       (0x01UL << PA_TYP_TYP7_Pos)                             /*!< PA TYP: TYP7 Mask                       */
#define PA_TYP_TYP8_Pos                       8                                                       /*!< PA TYP: TYP8 Position                   */
#define PA_TYP_TYP8_Msk                       (0x01UL << PA_TYP_TYP8_Pos)                             /*!< PA TYP: TYP8 Mask                       */
#define PA_TYP_TYP9_Pos                       9                                                       /*!< PA TYP: TYP9 Position                   */
#define PA_TYP_TYP9_Msk                       (0x01UL << PA_TYP_TYP9_Pos)                             /*!< PA TYP: TYP9 Mask                       */
#define PA_TYP_TYP10_Pos                      10                                                      /*!< PA TYP: TYP10 Position                  */
#define PA_TYP_TYP10_Msk                      (0x01UL << PA_TYP_TYP10_Pos)                            /*!< PA TYP: TYP10 Mask                      */
#define PA_TYP_TYP11_Pos                      11                                                      /*!< PA TYP: TYP11 Position                  */
#define PA_TYP_TYP11_Msk                      (0x01UL << PA_TYP_TYP11_Pos)                            /*!< PA TYP: TYP11 Mask                      */
#define PA_TYP_TYP12_Pos                      12                                                      /*!< PA TYP: TYP12 Position                  */
#define PA_TYP_TYP12_Msk                      (0x01UL << PA_TYP_TYP12_Pos)                            /*!< PA TYP: TYP12 Mask                      */
#define PA_TYP_TYP13_Pos                      13                                                      /*!< PA TYP: TYP13 Position                  */
#define PA_TYP_TYP13_Msk                      (0x01UL << PA_TYP_TYP13_Pos)                            /*!< PA TYP: TYP13 Mask                      */
#define PA_TYP_TYP14_Pos                      14                                                      /*!< PA TYP: TYP14 Position                  */
#define PA_TYP_TYP14_Msk                      (0x01UL << PA_TYP_TYP14_Pos)                            /*!< PA TYP: TYP14 Mask                      */
#define PA_TYP_TYP15_Pos                      15                                                      /*!< PA TYP: TYP15 Position                  */
#define PA_TYP_TYP15_Msk                      (0x01UL << PA_TYP_TYP15_Pos)                            /*!< PA TYP: TYP15 Mask                      */

/* ----------------------------------  PA_AFSR1  ---------------------------------- */
#define PA_AFSR1_AFSR0_Pos                    0                                                       /*!< PA AFSR1: AFSR0 Position                */
#define PA_AFSR1_AFSR0_Msk                    (0x0fUL << PA_AFSR1_AFSR0_Pos)                          /*!< PA AFSR1: AFSR0 Mask                    */
#define PA_AFSR1_AFSR1_Pos                    4                                                       /*!< PA AFSR1: AFSR1 Position                */
#define PA_AFSR1_AFSR1_Msk                    (0x0fUL << PA_AFSR1_AFSR1_Pos)                          /*!< PA AFSR1: AFSR1 Mask                    */
#define PA_AFSR1_AFSR2_Pos                    8                                                       /*!< PA AFSR1: AFSR2 Position                */
#define PA_AFSR1_AFSR2_Msk                    (0x0fUL << PA_AFSR1_AFSR2_Pos)                          /*!< PA AFSR1: AFSR2 Mask                    */
#define PA_AFSR1_AFSR3_Pos                    12                                                      /*!< PA AFSR1: AFSR3 Position                */
#define PA_AFSR1_AFSR3_Msk                    (0x0fUL << PA_AFSR1_AFSR3_Pos)                          /*!< PA AFSR1: AFSR3 Mask                    */
#define PA_AFSR1_AFSR4_Pos                    16                                                      /*!< PA AFSR1: AFSR4 Position                */
#define PA_AFSR1_AFSR4_Msk                    (0x0fUL << PA_AFSR1_AFSR4_Pos)                          /*!< PA AFSR1: AFSR4 Mask                    */
#define PA_AFSR1_AFSR5_Pos                    20                                                      /*!< PA AFSR1: AFSR5 Position                */
#define PA_AFSR1_AFSR5_Msk                    (0x0fUL << PA_AFSR1_AFSR5_Pos)                          /*!< PA AFSR1: AFSR5 Mask                    */
#define PA_AFSR1_AFSR6_Pos                    24                                                      /*!< PA AFSR1: AFSR6 Position                */
#define PA_AFSR1_AFSR6_Msk                    (0x0fUL << PA_AFSR1_AFSR6_Pos)                          /*!< PA AFSR1: AFSR6 Mask                    */
#define PA_AFSR1_AFSR7_Pos                    28                                                      /*!< PA AFSR1: AFSR7 Position                */
#define PA_AFSR1_AFSR7_Msk                    (0x0fUL << PA_AFSR1_AFSR7_Pos)                          /*!< PA AFSR1: AFSR7 Mask                    */

/* ----------------------------------  PA_AFSR2  ---------------------------------- */
#define PA_AFSR2_AFSR8_Pos                    0                                                       /*!< PA AFSR2: AFSR8 Position                */
#define PA_AFSR2_AFSR8_Msk                    (0x0fUL << PA_AFSR2_AFSR8_Pos)                          /*!< PA AFSR2: AFSR8 Mask                    */
#define PA_AFSR2_AFSR9_Pos                    4                                                       /*!< PA AFSR2: AFSR9 Position                */
#define PA_AFSR2_AFSR9_Msk                    (0x0fUL << PA_AFSR2_AFSR9_Pos)                          /*!< PA AFSR2: AFSR9 Mask                    */
#define PA_AFSR2_AFSR10_Pos                   8                                                       /*!< PA AFSR2: AFSR10 Position               */
#define PA_AFSR2_AFSR10_Msk                   (0x0fUL << PA_AFSR2_AFSR10_Pos)                         /*!< PA AFSR2: AFSR10 Mask                   */
#define PA_AFSR2_AFSR11_Pos                   12                                                      /*!< PA AFSR2: AFSR11 Position               */
#define PA_AFSR2_AFSR11_Msk                   (0x0fUL << PA_AFSR2_AFSR11_Pos)                         /*!< PA AFSR2: AFSR11 Mask                   */
#define PA_AFSR2_AFSR12_Pos                   16                                                      /*!< PA AFSR2: AFSR12 Position               */
#define PA_AFSR2_AFSR12_Msk                   (0x0fUL << PA_AFSR2_AFSR12_Pos)                         /*!< PA AFSR2: AFSR12 Mask                   */
#define PA_AFSR2_AFSR13_Pos                   20                                                      /*!< PA AFSR2: AFSR13 Position               */
#define PA_AFSR2_AFSR13_Msk                   (0x0fUL << PA_AFSR2_AFSR13_Pos)                         /*!< PA AFSR2: AFSR13 Mask                   */
#define PA_AFSR2_AFSR14_Pos                   24                                                      /*!< PA AFSR2: AFSR14 Position               */
#define PA_AFSR2_AFSR14_Msk                   (0x0fUL << PA_AFSR2_AFSR14_Pos)                         /*!< PA AFSR2: AFSR14 Mask                   */
#define PA_AFSR2_AFSR15_Pos                   28                                                      /*!< PA AFSR2: AFSR15 Position               */
#define PA_AFSR2_AFSR15_Msk                   (0x0fUL << PA_AFSR2_AFSR15_Pos)                         /*!< PA AFSR2: AFSR15 Mask                   */

/* -----------------------------------  PA_PUPD  ---------------------------------- */
#define PA_PUPD_PUPD0_Pos                     0                                                       /*!< PA PUPD: PUPD0 Position                 */
#define PA_PUPD_PUPD0_Msk                     (0x03UL << PA_PUPD_PUPD0_Pos)                           /*!< PA PUPD: PUPD0 Mask                     */
#define PA_PUPD_PUPD1_Pos                     2                                                       /*!< PA PUPD: PUPD1 Position                 */
#define PA_PUPD_PUPD1_Msk                     (0x03UL << PA_PUPD_PUPD1_Pos)                           /*!< PA PUPD: PUPD1 Mask                     */
#define PA_PUPD_PUPD2_Pos                     4                                                       /*!< PA PUPD: PUPD2 Position                 */
#define PA_PUPD_PUPD2_Msk                     (0x03UL << PA_PUPD_PUPD2_Pos)                           /*!< PA PUPD: PUPD2 Mask                     */
#define PA_PUPD_PUPD3_Pos                     6                                                       /*!< PA PUPD: PUPD3 Position                 */
#define PA_PUPD_PUPD3_Msk                     (0x03UL << PA_PUPD_PUPD3_Pos)                           /*!< PA PUPD: PUPD3 Mask                     */
#define PA_PUPD_PUPD4_Pos                     8                                                       /*!< PA PUPD: PUPD4 Position                 */
#define PA_PUPD_PUPD4_Msk                     (0x03UL << PA_PUPD_PUPD4_Pos)                           /*!< PA PUPD: PUPD4 Mask                     */
#define PA_PUPD_PUPD5_Pos                     10                                                      /*!< PA PUPD: PUPD5 Position                 */
#define PA_PUPD_PUPD5_Msk                     (0x03UL << PA_PUPD_PUPD5_Pos)                           /*!< PA PUPD: PUPD5 Mask                     */
#define PA_PUPD_PUPD6_Pos                     12                                                      /*!< PA PUPD: PUPD6 Position                 */
#define PA_PUPD_PUPD6_Msk                     (0x03UL << PA_PUPD_PUPD6_Pos)                           /*!< PA PUPD: PUPD6 Mask                     */
#define PA_PUPD_PUPD7_Pos                     14                                                      /*!< PA PUPD: PUPD7 Position                 */
#define PA_PUPD_PUPD7_Msk                     (0x03UL << PA_PUPD_PUPD7_Pos)                           /*!< PA PUPD: PUPD7 Mask                     */
#define PA_PUPD_PUPD8_Pos                     16                                                      /*!< PA PUPD: PUPD8 Position                 */
#define PA_PUPD_PUPD8_Msk                     (0x03UL << PA_PUPD_PUPD8_Pos)                           /*!< PA PUPD: PUPD8 Mask                     */
#define PA_PUPD_PUPD9_Pos                     18                                                      /*!< PA PUPD: PUPD9 Position                 */
#define PA_PUPD_PUPD9_Msk                     (0x03UL << PA_PUPD_PUPD9_Pos)                           /*!< PA PUPD: PUPD9 Mask                     */
#define PA_PUPD_PUPD10_Pos                    20                                                      /*!< PA PUPD: PUPD10 Position                */
#define PA_PUPD_PUPD10_Msk                    (0x03UL << PA_PUPD_PUPD10_Pos)                          /*!< PA PUPD: PUPD10 Mask                    */
#define PA_PUPD_PUPD11_Pos                    22                                                      /*!< PA PUPD: PUPD11 Position                */
#define PA_PUPD_PUPD11_Msk                    (0x03UL << PA_PUPD_PUPD11_Pos)                          /*!< PA PUPD: PUPD11 Mask                    */
#define PA_PUPD_PUPD12_Pos                    24                                                      /*!< PA PUPD: PUPD12 Position                */
#define PA_PUPD_PUPD12_Msk                    (0x03UL << PA_PUPD_PUPD12_Pos)                          /*!< PA PUPD: PUPD12 Mask                    */
#define PA_PUPD_PUPD13_Pos                    26                                                      /*!< PA PUPD: PUPD13 Position                */
#define PA_PUPD_PUPD13_Msk                    (0x03UL << PA_PUPD_PUPD13_Pos)                          /*!< PA PUPD: PUPD13 Mask                    */
#define PA_PUPD_PUPD14_Pos                    28                                                      /*!< PA PUPD: PUPD14 Position                */
#define PA_PUPD_PUPD14_Msk                    (0x03UL << PA_PUPD_PUPD14_Pos)                          /*!< PA PUPD: PUPD14 Mask                    */
#define PA_PUPD_PUPD15_Pos                    30                                                      /*!< PA PUPD: PUPD15 Position                */
#define PA_PUPD_PUPD15_Msk                    (0x03UL << PA_PUPD_PUPD15_Pos)                          /*!< PA PUPD: PUPD15 Mask                    */

/* -----------------------------------  PA_INDR  ---------------------------------- */
#define PA_INDR_INDR0_Pos                     0                                                       /*!< PA INDR: INDR0 Position                 */
#define PA_INDR_INDR0_Msk                     (0x01UL << PA_INDR_INDR0_Pos)                           /*!< PA INDR: INDR0 Mask                     */
#define PA_INDR_INDR1_Pos                     1                                                       /*!< PA INDR: INDR1 Position                 */
#define PA_INDR_INDR1_Msk                     (0x01UL << PA_INDR_INDR1_Pos)                           /*!< PA INDR: INDR1 Mask                     */
#define PA_INDR_INDR2_Pos                     2                                                       /*!< PA INDR: INDR2 Position                 */
#define PA_INDR_INDR2_Msk                     (0x01UL << PA_INDR_INDR2_Pos)                           /*!< PA INDR: INDR2 Mask                     */
#define PA_INDR_INDR3_Pos                     3                                                       /*!< PA INDR: INDR3 Position                 */
#define PA_INDR_INDR3_Msk                     (0x01UL << PA_INDR_INDR3_Pos)                           /*!< PA INDR: INDR3 Mask                     */
#define PA_INDR_INDR4_Pos                     4                                                       /*!< PA INDR: INDR4 Position                 */
#define PA_INDR_INDR4_Msk                     (0x01UL << PA_INDR_INDR4_Pos)                           /*!< PA INDR: INDR4 Mask                     */
#define PA_INDR_INDR5_Pos                     5                                                       /*!< PA INDR: INDR5 Position                 */
#define PA_INDR_INDR5_Msk                     (0x01UL << PA_INDR_INDR5_Pos)                           /*!< PA INDR: INDR5 Mask                     */
#define PA_INDR_INDR6_Pos                     6                                                       /*!< PA INDR: INDR6 Position                 */
#define PA_INDR_INDR6_Msk                     (0x01UL << PA_INDR_INDR6_Pos)                           /*!< PA INDR: INDR6 Mask                     */
#define PA_INDR_INDR7_Pos                     7                                                       /*!< PA INDR: INDR7 Position                 */
#define PA_INDR_INDR7_Msk                     (0x01UL << PA_INDR_INDR7_Pos)                           /*!< PA INDR: INDR7 Mask                     */
#define PA_INDR_INDR8_Pos                     8                                                       /*!< PA INDR: INDR8 Position                 */
#define PA_INDR_INDR8_Msk                     (0x01UL << PA_INDR_INDR8_Pos)                           /*!< PA INDR: INDR8 Mask                     */
#define PA_INDR_INDR9_Pos                     9                                                       /*!< PA INDR: INDR9 Position                 */
#define PA_INDR_INDR9_Msk                     (0x01UL << PA_INDR_INDR9_Pos)                           /*!< PA INDR: INDR9 Mask                     */
#define PA_INDR_INDR10_Pos                    10                                                      /*!< PA INDR: INDR10 Position                */
#define PA_INDR_INDR10_Msk                    (0x01UL << PA_INDR_INDR10_Pos)                          /*!< PA INDR: INDR10 Mask                    */
#define PA_INDR_INDR11_Pos                    11                                                      /*!< PA INDR: INDR11 Position                */
#define PA_INDR_INDR11_Msk                    (0x01UL << PA_INDR_INDR11_Pos)                          /*!< PA INDR: INDR11 Mask                    */
#define PA_INDR_INDR12_Pos                    12                                                      /*!< PA INDR: INDR12 Position                */
#define PA_INDR_INDR12_Msk                    (0x01UL << PA_INDR_INDR12_Pos)                          /*!< PA INDR: INDR12 Mask                    */
#define PA_INDR_INDR13_Pos                    13                                                      /*!< PA INDR: INDR13 Position                */
#define PA_INDR_INDR13_Msk                    (0x01UL << PA_INDR_INDR13_Pos)                          /*!< PA INDR: INDR13 Mask                    */
#define PA_INDR_INDR14_Pos                    14                                                      /*!< PA INDR: INDR14 Position                */
#define PA_INDR_INDR14_Msk                    (0x01UL << PA_INDR_INDR14_Pos)                          /*!< PA INDR: INDR14 Mask                    */
#define PA_INDR_INDR15_Pos                    15                                                      /*!< PA INDR: INDR15 Position                */
#define PA_INDR_INDR15_Msk                    (0x01UL << PA_INDR_INDR15_Pos)                          /*!< PA INDR: INDR15 Mask                    */

/* ----------------------------------  PA_OUTDR  ---------------------------------- */
#define PA_OUTDR_OUTDR0_Pos                   0                                                       /*!< PA OUTDR: OUTDR0 Position               */
#define PA_OUTDR_OUTDR0_Msk                   (0x01UL << PA_OUTDR_OUTDR0_Pos)                         /*!< PA OUTDR: OUTDR0 Mask                   */
#define PA_OUTDR_OUTDR1_Pos                   1                                                       /*!< PA OUTDR: OUTDR1 Position               */
#define PA_OUTDR_OUTDR1_Msk                   (0x01UL << PA_OUTDR_OUTDR1_Pos)                         /*!< PA OUTDR: OUTDR1 Mask                   */
#define PA_OUTDR_OUTDR2_Pos                   2                                                       /*!< PA OUTDR: OUTDR2 Position               */
#define PA_OUTDR_OUTDR2_Msk                   (0x01UL << PA_OUTDR_OUTDR2_Pos)                         /*!< PA OUTDR: OUTDR2 Mask                   */
#define PA_OUTDR_OUTDR3_Pos                   3                                                       /*!< PA OUTDR: OUTDR3 Position               */
#define PA_OUTDR_OUTDR3_Msk                   (0x01UL << PA_OUTDR_OUTDR3_Pos)                         /*!< PA OUTDR: OUTDR3 Mask                   */
#define PA_OUTDR_OUTDR4_Pos                   4                                                       /*!< PA OUTDR: OUTDR4 Position               */
#define PA_OUTDR_OUTDR4_Msk                   (0x01UL << PA_OUTDR_OUTDR4_Pos)                         /*!< PA OUTDR: OUTDR4 Mask                   */
#define PA_OUTDR_OUTDR5_Pos                   5                                                       /*!< PA OUTDR: OUTDR5 Position               */
#define PA_OUTDR_OUTDR5_Msk                   (0x01UL << PA_OUTDR_OUTDR5_Pos)                         /*!< PA OUTDR: OUTDR5 Mask                   */
#define PA_OUTDR_OUTDR6_Pos                   6                                                       /*!< PA OUTDR: OUTDR6 Position               */
#define PA_OUTDR_OUTDR6_Msk                   (0x01UL << PA_OUTDR_OUTDR6_Pos)                         /*!< PA OUTDR: OUTDR6 Mask                   */
#define PA_OUTDR_OUTDR7_Pos                   7                                                       /*!< PA OUTDR: OUTDR7 Position               */
#define PA_OUTDR_OUTDR7_Msk                   (0x01UL << PA_OUTDR_OUTDR7_Pos)                         /*!< PA OUTDR: OUTDR7 Mask                   */
#define PA_OUTDR_OUTDR8_Pos                   8                                                       /*!< PA OUTDR: OUTDR8 Position               */
#define PA_OUTDR_OUTDR8_Msk                   (0x01UL << PA_OUTDR_OUTDR8_Pos)                         /*!< PA OUTDR: OUTDR8 Mask                   */
#define PA_OUTDR_OUTDR9_Pos                   9                                                       /*!< PA OUTDR: OUTDR9 Position               */
#define PA_OUTDR_OUTDR9_Msk                   (0x01UL << PA_OUTDR_OUTDR9_Pos)                         /*!< PA OUTDR: OUTDR9 Mask                   */
#define PA_OUTDR_OUTDR10_Pos                  10                                                      /*!< PA OUTDR: OUTDR10 Position              */
#define PA_OUTDR_OUTDR10_Msk                  (0x01UL << PA_OUTDR_OUTDR10_Pos)                        /*!< PA OUTDR: OUTDR10 Mask                  */
#define PA_OUTDR_OUTDR11_Pos                  11                                                      /*!< PA OUTDR: OUTDR11 Position              */
#define PA_OUTDR_OUTDR11_Msk                  (0x01UL << PA_OUTDR_OUTDR11_Pos)                        /*!< PA OUTDR: OUTDR11 Mask                  */
#define PA_OUTDR_OUTDR12_Pos                  12                                                      /*!< PA OUTDR: OUTDR12 Position              */
#define PA_OUTDR_OUTDR12_Msk                  (0x01UL << PA_OUTDR_OUTDR12_Pos)                        /*!< PA OUTDR: OUTDR12 Mask                  */
#define PA_OUTDR_OUTDR13_Pos                  13                                                      /*!< PA OUTDR: OUTDR13 Position              */
#define PA_OUTDR_OUTDR13_Msk                  (0x01UL << PA_OUTDR_OUTDR13_Pos)                        /*!< PA OUTDR: OUTDR13 Mask                  */
#define PA_OUTDR_OUTDR14_Pos                  14                                                      /*!< PA OUTDR: OUTDR14 Position              */
#define PA_OUTDR_OUTDR14_Msk                  (0x01UL << PA_OUTDR_OUTDR14_Pos)                        /*!< PA OUTDR: OUTDR14 Mask                  */
#define PA_OUTDR_OUTDR15_Pos                  15                                                      /*!< PA OUTDR: OUTDR15 Position              */
#define PA_OUTDR_OUTDR15_Msk                  (0x01UL << PA_OUTDR_OUTDR15_Pos)                        /*!< PA OUTDR: OUTDR15 Mask                  */

/* -----------------------------------  PA_BSR  ----------------------------------- */
#define PA_BSR_BSR0_Pos                       0                                                       /*!< PA BSR: BSR0 Position                   */
#define PA_BSR_BSR0_Msk                       (0x01UL << PA_BSR_BSR0_Pos)                             /*!< PA BSR: BSR0 Mask                       */
#define PA_BSR_BSR1_Pos                       1                                                       /*!< PA BSR: BSR1 Position                   */
#define PA_BSR_BSR1_Msk                       (0x01UL << PA_BSR_BSR1_Pos)                             /*!< PA BSR: BSR1 Mask                       */
#define PA_BSR_BSR2_Pos                       2                                                       /*!< PA BSR: BSR2 Position                   */
#define PA_BSR_BSR2_Msk                       (0x01UL << PA_BSR_BSR2_Pos)                             /*!< PA BSR: BSR2 Mask                       */
#define PA_BSR_BSR3_Pos                       3                                                       /*!< PA BSR: BSR3 Position                   */
#define PA_BSR_BSR3_Msk                       (0x01UL << PA_BSR_BSR3_Pos)                             /*!< PA BSR: BSR3 Mask                       */
#define PA_BSR_BSR4_Pos                       4                                                       /*!< PA BSR: BSR4 Position                   */
#define PA_BSR_BSR4_Msk                       (0x01UL << PA_BSR_BSR4_Pos)                             /*!< PA BSR: BSR4 Mask                       */
#define PA_BSR_BSR5_Pos                       5                                                       /*!< PA BSR: BSR5 Position                   */
#define PA_BSR_BSR5_Msk                       (0x01UL << PA_BSR_BSR5_Pos)                             /*!< PA BSR: BSR5 Mask                       */
#define PA_BSR_BSR6_Pos                       6                                                       /*!< PA BSR: BSR6 Position                   */
#define PA_BSR_BSR6_Msk                       (0x01UL << PA_BSR_BSR6_Pos)                             /*!< PA BSR: BSR6 Mask                       */
#define PA_BSR_BSR7_Pos                       7                                                       /*!< PA BSR: BSR7 Position                   */
#define PA_BSR_BSR7_Msk                       (0x01UL << PA_BSR_BSR7_Pos)                             /*!< PA BSR: BSR7 Mask                       */
#define PA_BSR_BSR8_Pos                       8                                                       /*!< PA BSR: BSR8 Position                   */
#define PA_BSR_BSR8_Msk                       (0x01UL << PA_BSR_BSR8_Pos)                             /*!< PA BSR: BSR8 Mask                       */
#define PA_BSR_BSR9_Pos                       9                                                       /*!< PA BSR: BSR9 Position                   */
#define PA_BSR_BSR9_Msk                       (0x01UL << PA_BSR_BSR9_Pos)                             /*!< PA BSR: BSR9 Mask                       */
#define PA_BSR_BSR10_Pos                      10                                                      /*!< PA BSR: BSR10 Position                  */
#define PA_BSR_BSR10_Msk                      (0x01UL << PA_BSR_BSR10_Pos)                            /*!< PA BSR: BSR10 Mask                      */
#define PA_BSR_BSR11_Pos                      11                                                      /*!< PA BSR: BSR11 Position                  */
#define PA_BSR_BSR11_Msk                      (0x01UL << PA_BSR_BSR11_Pos)                            /*!< PA BSR: BSR11 Mask                      */
#define PA_BSR_BSR12_Pos                      12                                                      /*!< PA BSR: BSR12 Position                  */
#define PA_BSR_BSR12_Msk                      (0x01UL << PA_BSR_BSR12_Pos)                            /*!< PA BSR: BSR12 Mask                      */
#define PA_BSR_BSR13_Pos                      13                                                      /*!< PA BSR: BSR13 Position                  */
#define PA_BSR_BSR13_Msk                      (0x01UL << PA_BSR_BSR13_Pos)                            /*!< PA BSR: BSR13 Mask                      */
#define PA_BSR_BSR14_Pos                      14                                                      /*!< PA BSR: BSR14 Position                  */
#define PA_BSR_BSR14_Msk                      (0x01UL << PA_BSR_BSR14_Pos)                            /*!< PA BSR: BSR14 Mask                      */
#define PA_BSR_BSR15_Pos                      15                                                      /*!< PA BSR: BSR15 Position                  */
#define PA_BSR_BSR15_Msk                      (0x01UL << PA_BSR_BSR15_Pos)                            /*!< PA BSR: BSR15 Mask                      */

/* -----------------------------------  PA_BCR  ----------------------------------- */
#define PA_BCR_BCR0_Pos                       0                                                       /*!< PA BCR: BCR0 Position                   */
#define PA_BCR_BCR0_Msk                       (0x01UL << PA_BCR_BCR0_Pos)                             /*!< PA BCR: BCR0 Mask                       */
#define PA_BCR_BCR1_Pos                       1                                                       /*!< PA BCR: BCR1 Position                   */
#define PA_BCR_BCR1_Msk                       (0x01UL << PA_BCR_BCR1_Pos)                             /*!< PA BCR: BCR1 Mask                       */
#define PA_BCR_BCR2_Pos                       2                                                       /*!< PA BCR: BCR2 Position                   */
#define PA_BCR_BCR2_Msk                       (0x01UL << PA_BCR_BCR2_Pos)                             /*!< PA BCR: BCR2 Mask                       */
#define PA_BCR_BCR3_Pos                       3                                                       /*!< PA BCR: BCR3 Position                   */
#define PA_BCR_BCR3_Msk                       (0x01UL << PA_BCR_BCR3_Pos)                             /*!< PA BCR: BCR3 Mask                       */
#define PA_BCR_BCR4_Pos                       4                                                       /*!< PA BCR: BCR4 Position                   */
#define PA_BCR_BCR4_Msk                       (0x01UL << PA_BCR_BCR4_Pos)                             /*!< PA BCR: BCR4 Mask                       */
#define PA_BCR_BCR5_Pos                       5                                                       /*!< PA BCR: BCR5 Position                   */
#define PA_BCR_BCR5_Msk                       (0x01UL << PA_BCR_BCR5_Pos)                             /*!< PA BCR: BCR5 Mask                       */
#define PA_BCR_BCR6_Pos                       6                                                       /*!< PA BCR: BCR6 Position                   */
#define PA_BCR_BCR6_Msk                       (0x01UL << PA_BCR_BCR6_Pos)                             /*!< PA BCR: BCR6 Mask                       */
#define PA_BCR_BCR7_Pos                       7                                                       /*!< PA BCR: BCR7 Position                   */
#define PA_BCR_BCR7_Msk                       (0x01UL << PA_BCR_BCR7_Pos)                             /*!< PA BCR: BCR7 Mask                       */
#define PA_BCR_BCR8_Pos                       8                                                       /*!< PA BCR: BCR8 Position                   */
#define PA_BCR_BCR8_Msk                       (0x01UL << PA_BCR_BCR8_Pos)                             /*!< PA BCR: BCR8 Mask                       */
#define PA_BCR_BCR9_Pos                       9                                                       /*!< PA BCR: BCR9 Position                   */
#define PA_BCR_BCR9_Msk                       (0x01UL << PA_BCR_BCR9_Pos)                             /*!< PA BCR: BCR9 Mask                       */
#define PA_BCR_BCR10_Pos                      10                                                      /*!< PA BCR: BCR10 Position                  */
#define PA_BCR_BCR10_Msk                      (0x01UL << PA_BCR_BCR10_Pos)                            /*!< PA BCR: BCR10 Mask                      */
#define PA_BCR_BCR11_Pos                      11                                                      /*!< PA BCR: BCR11 Position                  */
#define PA_BCR_BCR11_Msk                      (0x01UL << PA_BCR_BCR11_Pos)                            /*!< PA BCR: BCR11 Mask                      */
#define PA_BCR_BCR12_Pos                      12                                                      /*!< PA BCR: BCR12 Position                  */
#define PA_BCR_BCR12_Msk                      (0x01UL << PA_BCR_BCR12_Pos)                            /*!< PA BCR: BCR12 Mask                      */
#define PA_BCR_BCR13_Pos                      13                                                      /*!< PA BCR: BCR13 Position                  */
#define PA_BCR_BCR13_Msk                      (0x01UL << PA_BCR_BCR13_Pos)                            /*!< PA BCR: BCR13 Mask                      */
#define PA_BCR_BCR14_Pos                      14                                                      /*!< PA BCR: BCR14 Position                  */
#define PA_BCR_BCR14_Msk                      (0x01UL << PA_BCR_BCR14_Pos)                            /*!< PA BCR: BCR14 Mask                      */
#define PA_BCR_BCR15_Pos                      15                                                      /*!< PA BCR: BCR15 Position                  */
#define PA_BCR_BCR15_Msk                      (0x01UL << PA_BCR_BCR15_Pos)                            /*!< PA BCR: BCR15 Mask                      */

/* ---------------------------------  PA_OUTDMSK  --------------------------------- */
#define PA_OUTDMSK_OUTDMSK0_Pos               0                                                       /*!< PA OUTDMSK: OUTDMSK0 Position           */
#define PA_OUTDMSK_OUTDMSK0_Msk               (0x01UL << PA_OUTDMSK_OUTDMSK0_Pos)                     /*!< PA OUTDMSK: OUTDMSK0 Mask               */
#define PA_OUTDMSK_OUTDMSK1_Pos               1                                                       /*!< PA OUTDMSK: OUTDMSK1 Position           */
#define PA_OUTDMSK_OUTDMSK1_Msk               (0x01UL << PA_OUTDMSK_OUTDMSK1_Pos)                     /*!< PA OUTDMSK: OUTDMSK1 Mask               */
#define PA_OUTDMSK_OUTDMSK2_Pos               2                                                       /*!< PA OUTDMSK: OUTDMSK2 Position           */
#define PA_OUTDMSK_OUTDMSK2_Msk               (0x01UL << PA_OUTDMSK_OUTDMSK2_Pos)                     /*!< PA OUTDMSK: OUTDMSK2 Mask               */
#define PA_OUTDMSK_OUTDMSK3_Pos               3                                                       /*!< PA OUTDMSK: OUTDMSK3 Position           */
#define PA_OUTDMSK_OUTDMSK3_Msk               (0x01UL << PA_OUTDMSK_OUTDMSK3_Pos)                     /*!< PA OUTDMSK: OUTDMSK3 Mask               */
#define PA_OUTDMSK_OUTDMSK4_Pos               4                                                       /*!< PA OUTDMSK: OUTDMSK4 Position           */
#define PA_OUTDMSK_OUTDMSK4_Msk               (0x01UL << PA_OUTDMSK_OUTDMSK4_Pos)                     /*!< PA OUTDMSK: OUTDMSK4 Mask               */
#define PA_OUTDMSK_OUTDMSK5_Pos               5                                                       /*!< PA OUTDMSK: OUTDMSK5 Position           */
#define PA_OUTDMSK_OUTDMSK5_Msk               (0x01UL << PA_OUTDMSK_OUTDMSK5_Pos)                     /*!< PA OUTDMSK: OUTDMSK5 Mask               */
#define PA_OUTDMSK_OUTDMSK6_Pos               6                                                       /*!< PA OUTDMSK: OUTDMSK6 Position           */
#define PA_OUTDMSK_OUTDMSK6_Msk               (0x01UL << PA_OUTDMSK_OUTDMSK6_Pos)                     /*!< PA OUTDMSK: OUTDMSK6 Mask               */
#define PA_OUTDMSK_OUTDMSK7_Pos               7                                                       /*!< PA OUTDMSK: OUTDMSK7 Position           */
#define PA_OUTDMSK_OUTDMSK7_Msk               (0x01UL << PA_OUTDMSK_OUTDMSK7_Pos)                     /*!< PA OUTDMSK: OUTDMSK7 Mask               */
#define PA_OUTDMSK_OUTDMSK8_Pos               8                                                       /*!< PA OUTDMSK: OUTDMSK8 Position           */
#define PA_OUTDMSK_OUTDMSK8_Msk               (0x01UL << PA_OUTDMSK_OUTDMSK8_Pos)                     /*!< PA OUTDMSK: OUTDMSK8 Mask               */
#define PA_OUTDMSK_OUTDMSK9_Pos               9                                                       /*!< PA OUTDMSK: OUTDMSK9 Position           */
#define PA_OUTDMSK_OUTDMSK9_Msk               (0x01UL << PA_OUTDMSK_OUTDMSK9_Pos)                     /*!< PA OUTDMSK: OUTDMSK9 Mask               */
#define PA_OUTDMSK_OUTDMSK10_Pos              10                                                      /*!< PA OUTDMSK: OUTDMSK10 Position          */
#define PA_OUTDMSK_OUTDMSK10_Msk              (0x01UL << PA_OUTDMSK_OUTDMSK10_Pos)                    /*!< PA OUTDMSK: OUTDMSK10 Mask              */
#define PA_OUTDMSK_OUTDMSK11_Pos              11                                                      /*!< PA OUTDMSK: OUTDMSK11 Position          */
#define PA_OUTDMSK_OUTDMSK11_Msk              (0x01UL << PA_OUTDMSK_OUTDMSK11_Pos)                    /*!< PA OUTDMSK: OUTDMSK11 Mask              */
#define PA_OUTDMSK_OUTDMSK12_Pos              12                                                      /*!< PA OUTDMSK: OUTDMSK12 Position          */
#define PA_OUTDMSK_OUTDMSK12_Msk              (0x01UL << PA_OUTDMSK_OUTDMSK12_Pos)                    /*!< PA OUTDMSK: OUTDMSK12 Mask              */
#define PA_OUTDMSK_OUTDMSK13_Pos              13                                                      /*!< PA OUTDMSK: OUTDMSK13 Position          */
#define PA_OUTDMSK_OUTDMSK13_Msk              (0x01UL << PA_OUTDMSK_OUTDMSK13_Pos)                    /*!< PA OUTDMSK: OUTDMSK13 Mask              */
#define PA_OUTDMSK_OUTDMSK14_Pos              14                                                      /*!< PA OUTDMSK: OUTDMSK14 Position          */
#define PA_OUTDMSK_OUTDMSK14_Msk              (0x01UL << PA_OUTDMSK_OUTDMSK14_Pos)                    /*!< PA OUTDMSK: OUTDMSK14 Mask              */
#define PA_OUTDMSK_OUTDMSK15_Pos              15                                                      /*!< PA OUTDMSK: OUTDMSK15 Position          */
#define PA_OUTDMSK_OUTDMSK15_Msk              (0x01UL << PA_OUTDMSK_OUTDMSK15_Pos)                    /*!< PA OUTDMSK: OUTDMSK15 Mask              */

/* -----------------------------------  PA_DBCR  ---------------------------------- */
#define PA_DBCR_DBEN0_Pos                     0                                                       /*!< PA DBCR: DBEN0 Position                 */
#define PA_DBCR_DBEN0_Msk                     (0x01UL << PA_DBCR_DBEN0_Pos)                           /*!< PA DBCR: DBEN0 Mask                     */
#define PA_DBCR_DBEN1_Pos                     1                                                       /*!< PA DBCR: DBEN1 Position                 */
#define PA_DBCR_DBEN1_Msk                     (0x01UL << PA_DBCR_DBEN1_Pos)                           /*!< PA DBCR: DBEN1 Mask                     */
#define PA_DBCR_DBEN2_Pos                     2                                                       /*!< PA DBCR: DBEN2 Position                 */
#define PA_DBCR_DBEN2_Msk                     (0x01UL << PA_DBCR_DBEN2_Pos)                           /*!< PA DBCR: DBEN2 Mask                     */
#define PA_DBCR_DBEN3_Pos                     3                                                       /*!< PA DBCR: DBEN3 Position                 */
#define PA_DBCR_DBEN3_Msk                     (0x01UL << PA_DBCR_DBEN3_Pos)                           /*!< PA DBCR: DBEN3 Mask                     */
#define PA_DBCR_DBEN4_Pos                     4                                                       /*!< PA DBCR: DBEN4 Position                 */
#define PA_DBCR_DBEN4_Msk                     (0x01UL << PA_DBCR_DBEN4_Pos)                           /*!< PA DBCR: DBEN4 Mask                     */
#define PA_DBCR_DBEN5_Pos                     5                                                       /*!< PA DBCR: DBEN5 Position                 */
#define PA_DBCR_DBEN5_Msk                     (0x01UL << PA_DBCR_DBEN5_Pos)                           /*!< PA DBCR: DBEN5 Mask                     */
#define PA_DBCR_DBEN6_Pos                     6                                                       /*!< PA DBCR: DBEN6 Position                 */
#define PA_DBCR_DBEN6_Msk                     (0x01UL << PA_DBCR_DBEN6_Pos)                           /*!< PA DBCR: DBEN6 Mask                     */
#define PA_DBCR_DBEN7_Pos                     7                                                       /*!< PA DBCR: DBEN7 Position                 */
#define PA_DBCR_DBEN7_Msk                     (0x01UL << PA_DBCR_DBEN7_Pos)                           /*!< PA DBCR: DBEN7 Mask                     */
#define PA_DBCR_DBEN8_Pos                     8                                                       /*!< PA DBCR: DBEN8 Position                 */
#define PA_DBCR_DBEN8_Msk                     (0x01UL << PA_DBCR_DBEN8_Pos)                           /*!< PA DBCR: DBEN8 Mask                     */
#define PA_DBCR_DBEN9_Pos                     9                                                       /*!< PA DBCR: DBEN9 Position                 */
#define PA_DBCR_DBEN9_Msk                     (0x01UL << PA_DBCR_DBEN9_Pos)                           /*!< PA DBCR: DBEN9 Mask                     */
#define PA_DBCR_DBEN10_Pos                    10                                                      /*!< PA DBCR: DBEN10 Position                */
#define PA_DBCR_DBEN10_Msk                    (0x01UL << PA_DBCR_DBEN10_Pos)                          /*!< PA DBCR: DBEN10 Mask                    */
#define PA_DBCR_DBEN11_Pos                    11                                                      /*!< PA DBCR: DBEN11 Position                */
#define PA_DBCR_DBEN11_Msk                    (0x01UL << PA_DBCR_DBEN11_Pos)                          /*!< PA DBCR: DBEN11 Mask                    */
#define PA_DBCR_DBEN12_Pos                    12                                                      /*!< PA DBCR: DBEN12 Position                */
#define PA_DBCR_DBEN12_Msk                    (0x01UL << PA_DBCR_DBEN12_Pos)                          /*!< PA DBCR: DBEN12 Mask                    */
#define PA_DBCR_DBEN13_Pos                    13                                                      /*!< PA DBCR: DBEN13 Position                */
#define PA_DBCR_DBEN13_Msk                    (0x01UL << PA_DBCR_DBEN13_Pos)                          /*!< PA DBCR: DBEN13 Mask                    */
#define PA_DBCR_DBEN14_Pos                    14                                                      /*!< PA DBCR: DBEN14 Position                */
#define PA_DBCR_DBEN14_Msk                    (0x01UL << PA_DBCR_DBEN14_Pos)                          /*!< PA DBCR: DBEN14 Mask                    */
#define PA_DBCR_DBEN15_Pos                    15                                                      /*!< PA DBCR: DBEN15 Position                */
#define PA_DBCR_DBEN15_Msk                    (0x01UL << PA_DBCR_DBEN15_Pos)                          /*!< PA DBCR: DBEN15 Mask                    */

/* -----------------------------------  PA_IER  ----------------------------------- */
#define PA_IER_P0_Pos                         0                                                       /*!< PA IER: P0 Position                     */
#define PA_IER_P0_Msk                         (0x03UL << PA_IER_P0_Pos)                               /*!< PA IER: P0 Mask                         */
#define PA_IER_P1_Pos                         2                                                       /*!< PA IER: P1 Position                     */
#define PA_IER_P1_Msk                         (0x03UL << PA_IER_P1_Pos)                               /*!< PA IER: P1 Mask                         */
#define PA_IER_P2_Pos                         4                                                       /*!< PA IER: P2 Position                     */
#define PA_IER_P2_Msk                         (0x03UL << PA_IER_P2_Pos)                               /*!< PA IER: P2 Mask                         */
#define PA_IER_P3_Pos                         6                                                       /*!< PA IER: P3 Position                     */
#define PA_IER_P3_Msk                         (0x03UL << PA_IER_P3_Pos)                               /*!< PA IER: P3 Mask                         */
#define PA_IER_P4_Pos                         8                                                       /*!< PA IER: P4 Position                     */
#define PA_IER_P4_Msk                         (0x03UL << PA_IER_P4_Pos)                               /*!< PA IER: P4 Mask                         */
#define PA_IER_P5_Pos                         10                                                      /*!< PA IER: P5 Position                     */
#define PA_IER_P5_Msk                         (0x03UL << PA_IER_P5_Pos)                               /*!< PA IER: P5 Mask                         */
#define PA_IER_P6_Pos                         12                                                      /*!< PA IER: P6 Position                     */
#define PA_IER_P6_Msk                         (0x03UL << PA_IER_P6_Pos)                               /*!< PA IER: P6 Mask                         */
#define PA_IER_P7_Pos                         14                                                      /*!< PA IER: P7 Position                     */
#define PA_IER_P7_Msk                         (0x03UL << PA_IER_P7_Pos)                               /*!< PA IER: P7 Mask                         */
#define PA_IER_P8_Pos                         16                                                      /*!< PA IER: P8 Position                     */
#define PA_IER_P8_Msk                         (0x03UL << PA_IER_P8_Pos)                               /*!< PA IER: P8 Mask                         */
#define PA_IER_P9_Pos                         18                                                      /*!< PA IER: P9 Position                     */
#define PA_IER_P9_Msk                         (0x03UL << PA_IER_P9_Pos)                               /*!< PA IER: P9 Mask                         */
#define PA_IER_P10_Pos                        20                                                      /*!< PA IER: P10 Position                    */
#define PA_IER_P10_Msk                        (0x03UL << PA_IER_P10_Pos)                              /*!< PA IER: P10 Mask                        */
#define PA_IER_P11_Pos                        22                                                      /*!< PA IER: P11 Position                    */
#define PA_IER_P11_Msk                        (0x03UL << PA_IER_P11_Pos)                              /*!< PA IER: P11 Mask                        */
#define PA_IER_P12_Pos                        24                                                      /*!< PA IER: P12 Position                    */
#define PA_IER_P12_Msk                        (0x03UL << PA_IER_P12_Pos)                              /*!< PA IER: P12 Mask                        */
#define PA_IER_P13_Pos                        26                                                      /*!< PA IER: P13 Position                    */
#define PA_IER_P13_Msk                        (0x03UL << PA_IER_P13_Pos)                              /*!< PA IER: P13 Mask                        */
#define PA_IER_P14_Pos                        28                                                      /*!< PA IER: P14 Position                    */
#define PA_IER_P14_Msk                        (0x03UL << PA_IER_P14_Pos)                              /*!< PA IER: P14 Mask                        */
#define PA_IER_P15_Pos                        30                                                      /*!< PA IER: P15 Position                    */
#define PA_IER_P15_Msk                        (0x03UL << PA_IER_P15_Pos)                              /*!< PA IER: P15 Mask                        */

/* -----------------------------------  PA_ISR  ----------------------------------- */
#define PA_ISR_P0_Pos                         0                                                       /*!< PA ISR: P0 Position                     */
#define PA_ISR_P0_Msk                         (0x03UL << PA_ISR_P0_Pos)                               /*!< PA ISR: P0 Mask                         */
#define PA_ISR_P1_Pos                         2                                                       /*!< PA ISR: P1 Position                     */
#define PA_ISR_P1_Msk                         (0x03UL << PA_ISR_P1_Pos)                               /*!< PA ISR: P1 Mask                         */
#define PA_ISR_P2_Pos                         4                                                       /*!< PA ISR: P2 Position                     */
#define PA_ISR_P2_Msk                         (0x03UL << PA_ISR_P2_Pos)                               /*!< PA ISR: P2 Mask                         */
#define PA_ISR_P3_Pos                         6                                                       /*!< PA ISR: P3 Position                     */
#define PA_ISR_P3_Msk                         (0x03UL << PA_ISR_P3_Pos)                               /*!< PA ISR: P3 Mask                         */
#define PA_ISR_P4_Pos                         8                                                       /*!< PA ISR: P4 Position                     */
#define PA_ISR_P4_Msk                         (0x03UL << PA_ISR_P4_Pos)                               /*!< PA ISR: P4 Mask                         */
#define PA_ISR_P5_Pos                         10                                                      /*!< PA ISR: P5 Position                     */
#define PA_ISR_P5_Msk                         (0x03UL << PA_ISR_P5_Pos)                               /*!< PA ISR: P5 Mask                         */
#define PA_ISR_P6_Pos                         12                                                      /*!< PA ISR: P6 Position                     */
#define PA_ISR_P6_Msk                         (0x03UL << PA_ISR_P6_Pos)                               /*!< PA ISR: P6 Mask                         */
#define PA_ISR_P7_Pos                         14                                                      /*!< PA ISR: P7 Position                     */
#define PA_ISR_P7_Msk                         (0x03UL << PA_ISR_P7_Pos)                               /*!< PA ISR: P7 Mask                         */
#define PA_ISR_P8_Pos                         16                                                      /*!< PA ISR: P8 Position                     */
#define PA_ISR_P8_Msk                         (0x03UL << PA_ISR_P8_Pos)                               /*!< PA ISR: P8 Mask                         */
#define PA_ISR_P9_Pos                         18                                                      /*!< PA ISR: P9 Position                     */
#define PA_ISR_P9_Msk                         (0x03UL << PA_ISR_P9_Pos)                               /*!< PA ISR: P9 Mask                         */
#define PA_ISR_P10_Pos                        20                                                      /*!< PA ISR: P10 Position                    */
#define PA_ISR_P10_Msk                        (0x03UL << PA_ISR_P10_Pos)                              /*!< PA ISR: P10 Mask                        */
#define PA_ISR_P11_Pos                        22                                                      /*!< PA ISR: P11 Position                    */
#define PA_ISR_P11_Msk                        (0x03UL << PA_ISR_P11_Pos)                              /*!< PA ISR: P11 Mask                        */
#define PA_ISR_P12_Pos                        24                                                      /*!< PA ISR: P12 Position                    */
#define PA_ISR_P12_Msk                        (0x03UL << PA_ISR_P12_Pos)                              /*!< PA ISR: P12 Mask                        */
#define PA_ISR_P13_Pos                        26                                                      /*!< PA ISR: P13 Position                    */
#define PA_ISR_P13_Msk                        (0x03UL << PA_ISR_P13_Pos)                              /*!< PA ISR: P13 Mask                        */
#define PA_ISR_P14_Pos                        28                                                      /*!< PA ISR: P14 Position                    */
#define PA_ISR_P14_Msk                        (0x03UL << PA_ISR_P14_Pos)                              /*!< PA ISR: P14 Mask                        */
#define PA_ISR_P15_Pos                        30                                                      /*!< PA ISR: P15 Position                    */
#define PA_ISR_P15_Msk                        (0x03UL << PA_ISR_P15_Pos)                              /*!< PA ISR: P15 Mask                        */

/* -----------------------------------  PA_ICR  ----------------------------------- */
#define PA_ICR_P0_Pos                         0                                                       /*!< PA ICR: P0 Position                     */
#define PA_ICR_P0_Msk                         (0x03UL << PA_ICR_P0_Pos)                               /*!< PA ICR: P0 Mask                         */
#define PA_ICR_P1_Pos                         2                                                       /*!< PA ICR: P1 Position                     */
#define PA_ICR_P1_Msk                         (0x03UL << PA_ICR_P1_Pos)                               /*!< PA ICR: P1 Mask                         */
#define PA_ICR_P2_Pos                         4                                                       /*!< PA ICR: P2 Position                     */
#define PA_ICR_P2_Msk                         (0x03UL << PA_ICR_P2_Pos)                               /*!< PA ICR: P2 Mask                         */
#define PA_ICR_P3_Pos                         6                                                       /*!< PA ICR: P3 Position                     */
#define PA_ICR_P3_Msk                         (0x03UL << PA_ICR_P3_Pos)                               /*!< PA ICR: P3 Mask                         */
#define PA_ICR_P4_Pos                         8                                                       /*!< PA ICR: P4 Position                     */
#define PA_ICR_P4_Msk                         (0x03UL << PA_ICR_P4_Pos)                               /*!< PA ICR: P4 Mask                         */
#define PA_ICR_P5_Pos                         10                                                      /*!< PA ICR: P5 Position                     */
#define PA_ICR_P5_Msk                         (0x03UL << PA_ICR_P5_Pos)                               /*!< PA ICR: P5 Mask                         */
#define PA_ICR_P6_Pos                         12                                                      /*!< PA ICR: P6 Position                     */
#define PA_ICR_P6_Msk                         (0x03UL << PA_ICR_P6_Pos)                               /*!< PA ICR: P6 Mask                         */
#define PA_ICR_P7_Pos                         14                                                      /*!< PA ICR: P7 Position                     */
#define PA_ICR_P7_Msk                         (0x03UL << PA_ICR_P7_Pos)                               /*!< PA ICR: P7 Mask                         */
#define PA_ICR_P8_Pos                         16                                                      /*!< PA ICR: P8 Position                     */
#define PA_ICR_P8_Msk                         (0x03UL << PA_ICR_P8_Pos)                               /*!< PA ICR: P8 Mask                         */
#define PA_ICR_P9_Pos                         18                                                      /*!< PA ICR: P9 Position                     */
#define PA_ICR_P9_Msk                         (0x03UL << PA_ICR_P9_Pos)                               /*!< PA ICR: P9 Mask                         */
#define PA_ICR_P10_Pos                        20                                                      /*!< PA ICR: P10 Position                    */
#define PA_ICR_P10_Msk                        (0x03UL << PA_ICR_P10_Pos)                              /*!< PA ICR: P10 Mask                        */
#define PA_ICR_P11_Pos                        22                                                      /*!< PA ICR: P11 Position                    */
#define PA_ICR_P11_Msk                        (0x03UL << PA_ICR_P11_Pos)                              /*!< PA ICR: P11 Mask                        */
#define PA_ICR_P12_Pos                        24                                                      /*!< PA ICR: P12 Position                    */
#define PA_ICR_P12_Msk                        (0x03UL << PA_ICR_P12_Pos)                              /*!< PA ICR: P12 Mask                        */
#define PA_ICR_P13_Pos                        26                                                      /*!< PA ICR: P13 Position                    */
#define PA_ICR_P13_Msk                        (0x03UL << PA_ICR_P13_Pos)                              /*!< PA ICR: P13 Mask                        */
#define PA_ICR_P14_Pos                        28                                                      /*!< PA ICR: P14 Position                    */
#define PA_ICR_P14_Msk                        (0x03UL << PA_ICR_P14_Pos)                              /*!< PA ICR: P14 Mask                        */
#define PA_ICR_P15_Pos                        30                                                      /*!< PA ICR: P15 Position                    */
#define PA_ICR_P15_Msk                        (0x03UL << PA_ICR_P15_Pos)                              /*!< PA ICR: P15 Mask                        */

/* -----------------------------------  PA_STR  ----------------------------------- */
#define PA_STR_P0_Pos                         0                                                       /*!< PA STR: P0 Position                     */
#define PA_STR_P0_Msk                         (0x03UL << PA_STR_P0_Pos)                               /*!< PA STR: P0 Mask                         */
#define PA_STR_P1_Pos                         2                                                       /*!< PA STR: P1 Position                     */
#define PA_STR_P1_Msk                         (0x03UL << PA_STR_P1_Pos)                               /*!< PA STR: P1 Mask                         */
#define PA_STR_P2_Pos                         4                                                       /*!< PA STR: P2 Position                     */
#define PA_STR_P2_Msk                         (0x03UL << PA_STR_P2_Pos)                               /*!< PA STR: P2 Mask                         */
#define PA_STR_P3_Pos                         6                                                       /*!< PA STR: P3 Position                     */
#define PA_STR_P3_Msk                         (0x03UL << PA_STR_P3_Pos)                               /*!< PA STR: P3 Mask                         */
#define PA_STR_P4_Pos                         8                                                       /*!< PA STR: P4 Position                     */
#define PA_STR_P4_Msk                         (0x03UL << PA_STR_P4_Pos)                               /*!< PA STR: P4 Mask                         */


/* ================================================================================ */
/* ================           struct 'PB' Position & Mask          ================ */
/* ================================================================================ */


/* -----------------------------------  PB_MOD  ----------------------------------- */
#define PB_MOD_MODE0_Pos                      0                                                       /*!< PB MOD: MODE0 Position                  */
#define PB_MOD_MODE0_Msk                      (0x03UL << PB_MOD_MODE0_Pos)                            /*!< PB MOD: MODE0 Mask                      */
#define PB_MOD_MODE1_Pos                      2                                                       /*!< PB MOD: MODE1 Position                  */
#define PB_MOD_MODE1_Msk                      (0x03UL << PB_MOD_MODE1_Pos)                            /*!< PB MOD: MODE1 Mask                      */
#define PB_MOD_MODE2_Pos                      4                                                       /*!< PB MOD: MODE2 Position                  */
#define PB_MOD_MODE2_Msk                      (0x03UL << PB_MOD_MODE2_Pos)                            /*!< PB MOD: MODE2 Mask                      */
#define PB_MOD_MODE3_Pos                      6                                                       /*!< PB MOD: MODE3 Position                  */
#define PB_MOD_MODE3_Msk                      (0x03UL << PB_MOD_MODE3_Pos)                            /*!< PB MOD: MODE3 Mask                      */
#define PB_MOD_MODE4_Pos                      8                                                       /*!< PB MOD: MODE4 Position                  */
#define PB_MOD_MODE4_Msk                      (0x03UL << PB_MOD_MODE4_Pos)                            /*!< PB MOD: MODE4 Mask                      */
#define PB_MOD_MODE5_Pos                      10                                                      /*!< PB MOD: MODE5 Position                  */
#define PB_MOD_MODE5_Msk                      (0x03UL << PB_MOD_MODE5_Pos)                            /*!< PB MOD: MODE5 Mask                      */
#define PB_MOD_MODE6_Pos                      12                                                      /*!< PB MOD: MODE6 Position                  */
#define PB_MOD_MODE6_Msk                      (0x03UL << PB_MOD_MODE6_Pos)                            /*!< PB MOD: MODE6 Mask                      */
#define PB_MOD_MODE7_Pos                      14                                                      /*!< PB MOD: MODE7 Position                  */
#define PB_MOD_MODE7_Msk                      (0x03UL << PB_MOD_MODE7_Pos)                            /*!< PB MOD: MODE7 Mask                      */
#define PB_MOD_MODE8_Pos                      16                                                      /*!< PB MOD: MODE8 Position                  */
#define PB_MOD_MODE8_Msk                      (0x03UL << PB_MOD_MODE8_Pos)                            /*!< PB MOD: MODE8 Mask                      */
#define PB_MOD_MODE9_Pos                      18                                                      /*!< PB MOD: MODE9 Position                  */
#define PB_MOD_MODE9_Msk                      (0x03UL << PB_MOD_MODE9_Pos)                            /*!< PB MOD: MODE9 Mask                      */
#define PB_MOD_MODE10_Pos                     20                                                      /*!< PB MOD: MODE10 Position                 */
#define PB_MOD_MODE10_Msk                     (0x03UL << PB_MOD_MODE10_Pos)                           /*!< PB MOD: MODE10 Mask                     */
#define PB_MOD_MODE11_Pos                     22                                                      /*!< PB MOD: MODE11 Position                 */
#define PB_MOD_MODE11_Msk                     (0x03UL << PB_MOD_MODE11_Pos)                           /*!< PB MOD: MODE11 Mask                     */
#define PB_MOD_MODE12_Pos                     24                                                      /*!< PB MOD: MODE12 Position                 */
#define PB_MOD_MODE12_Msk                     (0x03UL << PB_MOD_MODE12_Pos)                           /*!< PB MOD: MODE12 Mask                     */
#define PB_MOD_MODE13_Pos                     26                                                      /*!< PB MOD: MODE13 Position                 */
#define PB_MOD_MODE13_Msk                     (0x03UL << PB_MOD_MODE13_Pos)                           /*!< PB MOD: MODE13 Mask                     */
#define PB_MOD_MODE14_Pos                     28                                                      /*!< PB MOD: MODE14 Position                 */
#define PB_MOD_MODE14_Msk                     (0x03UL << PB_MOD_MODE14_Pos)                           /*!< PB MOD: MODE14 Mask                     */
#define PB_MOD_MODE15_Pos                     30                                                      /*!< PB MOD: MODE15 Position                 */
#define PB_MOD_MODE15_Msk                     (0x03UL << PB_MOD_MODE15_Pos)                           /*!< PB MOD: MODE15 Mask                     */

/* -----------------------------------  PB_TYP  ----------------------------------- */
#define PB_TYP_TYP0_Pos                       0                                                       /*!< PB TYP: TYP0 Position                   */
#define PB_TYP_TYP0_Msk                       (0x01UL << PB_TYP_TYP0_Pos)                             /*!< PB TYP: TYP0 Mask                       */
#define PB_TYP_TYP1_Pos                       1                                                       /*!< PB TYP: TYP1 Position                   */
#define PB_TYP_TYP1_Msk                       (0x01UL << PB_TYP_TYP1_Pos)                             /*!< PB TYP: TYP1 Mask                       */
#define PB_TYP_TYP2_Pos                       2                                                       /*!< PB TYP: TYP2 Position                   */
#define PB_TYP_TYP2_Msk                       (0x01UL << PB_TYP_TYP2_Pos)                             /*!< PB TYP: TYP2 Mask                       */
#define PB_TYP_TYP3_Pos                       3                                                       /*!< PB TYP: TYP3 Position                   */
#define PB_TYP_TYP3_Msk                       (0x01UL << PB_TYP_TYP3_Pos)                             /*!< PB TYP: TYP3 Mask                       */
#define PB_TYP_TYP4_Pos                       4                                                       /*!< PB TYP: TYP4 Position                   */
#define PB_TYP_TYP4_Msk                       (0x01UL << PB_TYP_TYP4_Pos)                             /*!< PB TYP: TYP4 Mask                       */
#define PB_TYP_TYP5_Pos                       5                                                       /*!< PB TYP: TYP5 Position                   */
#define PB_TYP_TYP5_Msk                       (0x01UL << PB_TYP_TYP5_Pos)                             /*!< PB TYP: TYP5 Mask                       */
#define PB_TYP_TYP6_Pos                       6                                                       /*!< PB TYP: TYP6 Position                   */
#define PB_TYP_TYP6_Msk                       (0x01UL << PB_TYP_TYP6_Pos)                             /*!< PB TYP: TYP6 Mask                       */
#define PB_TYP_TYP7_Pos                       7                                                       /*!< PB TYP: TYP7 Position                   */
#define PB_TYP_TYP7_Msk                       (0x01UL << PB_TYP_TYP7_Pos)                             /*!< PB TYP: TYP7 Mask                       */
#define PB_TYP_TYP8_Pos                       8                                                       /*!< PB TYP: TYP8 Position                   */
#define PB_TYP_TYP8_Msk                       (0x01UL << PB_TYP_TYP8_Pos)                             /*!< PB TYP: TYP8 Mask                       */
#define PB_TYP_TYP9_Pos                       9                                                       /*!< PB TYP: TYP9 Position                   */
#define PB_TYP_TYP9_Msk                       (0x01UL << PB_TYP_TYP9_Pos)                             /*!< PB TYP: TYP9 Mask                       */
#define PB_TYP_TYP10_Pos                      10                                                      /*!< PB TYP: TYP10 Position                  */
#define PB_TYP_TYP10_Msk                      (0x01UL << PB_TYP_TYP10_Pos)                            /*!< PB TYP: TYP10 Mask                      */
#define PB_TYP_TYP11_Pos                      11                                                      /*!< PB TYP: TYP11 Position                  */
#define PB_TYP_TYP11_Msk                      (0x01UL << PB_TYP_TYP11_Pos)                            /*!< PB TYP: TYP11 Mask                      */
#define PB_TYP_TYP12_Pos                      12                                                      /*!< PB TYP: TYP12 Position                  */
#define PB_TYP_TYP12_Msk                      (0x01UL << PB_TYP_TYP12_Pos)                            /*!< PB TYP: TYP12 Mask                      */
#define PB_TYP_TYP13_Pos                      13                                                      /*!< PB TYP: TYP13 Position                  */
#define PB_TYP_TYP13_Msk                      (0x01UL << PB_TYP_TYP13_Pos)                            /*!< PB TYP: TYP13 Mask                      */
#define PB_TYP_TYP14_Pos                      14                                                      /*!< PB TYP: TYP14 Position                  */
#define PB_TYP_TYP14_Msk                      (0x01UL << PB_TYP_TYP14_Pos)                            /*!< PB TYP: TYP14 Mask                      */
#define PB_TYP_TYP15_Pos                      15                                                      /*!< PB TYP: TYP15 Position                  */
#define PB_TYP_TYP15_Msk                      (0x01UL << PB_TYP_TYP15_Pos)                            /*!< PB TYP: TYP15 Mask                      */

/* ----------------------------------  PB_AFSR1  ---------------------------------- */
#define PB_AFSR1_AFSR0_Pos                    0                                                       /*!< PB AFSR1: AFSR0 Position                */
#define PB_AFSR1_AFSR0_Msk                    (0x0fUL << PB_AFSR1_AFSR0_Pos)                          /*!< PB AFSR1: AFSR0 Mask                    */
#define PB_AFSR1_AFSR1_Pos                    4                                                       /*!< PB AFSR1: AFSR1 Position                */
#define PB_AFSR1_AFSR1_Msk                    (0x0fUL << PB_AFSR1_AFSR1_Pos)                          /*!< PB AFSR1: AFSR1 Mask                    */
#define PB_AFSR1_AFSR2_Pos                    8                                                       /*!< PB AFSR1: AFSR2 Position                */
#define PB_AFSR1_AFSR2_Msk                    (0x0fUL << PB_AFSR1_AFSR2_Pos)                          /*!< PB AFSR1: AFSR2 Mask                    */
#define PB_AFSR1_AFSR3_Pos                    12                                                      /*!< PB AFSR1: AFSR3 Position                */
#define PB_AFSR1_AFSR3_Msk                    (0x0fUL << PB_AFSR1_AFSR3_Pos)                          /*!< PB AFSR1: AFSR3 Mask                    */
#define PB_AFSR1_AFSR4_Pos                    16                                                      /*!< PB AFSR1: AFSR4 Position                */
#define PB_AFSR1_AFSR4_Msk                    (0x0fUL << PB_AFSR1_AFSR4_Pos)                          /*!< PB AFSR1: AFSR4 Mask                    */
#define PB_AFSR1_AFSR5_Pos                    20                                                      /*!< PB AFSR1: AFSR5 Position                */
#define PB_AFSR1_AFSR5_Msk                    (0x0fUL << PB_AFSR1_AFSR5_Pos)                          /*!< PB AFSR1: AFSR5 Mask                    */
#define PB_AFSR1_AFSR6_Pos                    24                                                      /*!< PB AFSR1: AFSR6 Position                */
#define PB_AFSR1_AFSR6_Msk                    (0x0fUL << PB_AFSR1_AFSR6_Pos)                          /*!< PB AFSR1: AFSR6 Mask                    */
#define PB_AFSR1_AFSR7_Pos                    28                                                      /*!< PB AFSR1: AFSR7 Position                */
#define PB_AFSR1_AFSR7_Msk                    (0x0fUL << PB_AFSR1_AFSR7_Pos)                          /*!< PB AFSR1: AFSR7 Mask                    */

/* ----------------------------------  PB_AFSR2  ---------------------------------- */
#define PB_AFSR2_AFSR8_Pos                    0                                                       /*!< PB AFSR2: AFSR8 Position                */
#define PB_AFSR2_AFSR8_Msk                    (0x0fUL << PB_AFSR2_AFSR8_Pos)                          /*!< PB AFSR2: AFSR8 Mask                    */
#define PB_AFSR2_AFSR9_Pos                    4                                                       /*!< PB AFSR2: AFSR9 Position                */
#define PB_AFSR2_AFSR9_Msk                    (0x0fUL << PB_AFSR2_AFSR9_Pos)                          /*!< PB AFSR2: AFSR9 Mask                    */
#define PB_AFSR2_AFSR10_Pos                   8                                                       /*!< PB AFSR2: AFSR10 Position               */
#define PB_AFSR2_AFSR10_Msk                   (0x0fUL << PB_AFSR2_AFSR10_Pos)                         /*!< PB AFSR2: AFSR10 Mask                   */
#define PB_AFSR2_AFSR11_Pos                   12                                                      /*!< PB AFSR2: AFSR11 Position               */
#define PB_AFSR2_AFSR11_Msk                   (0x0fUL << PB_AFSR2_AFSR11_Pos)                         /*!< PB AFSR2: AFSR11 Mask                   */
#define PB_AFSR2_AFSR12_Pos                   16                                                      /*!< PB AFSR2: AFSR12 Position               */
#define PB_AFSR2_AFSR12_Msk                   (0x0fUL << PB_AFSR2_AFSR12_Pos)                         /*!< PB AFSR2: AFSR12 Mask                   */
#define PB_AFSR2_AFSR13_Pos                   20                                                      /*!< PB AFSR2: AFSR13 Position               */
#define PB_AFSR2_AFSR13_Msk                   (0x0fUL << PB_AFSR2_AFSR13_Pos)                         /*!< PB AFSR2: AFSR13 Mask                   */
#define PB_AFSR2_AFSR14_Pos                   24                                                      /*!< PB AFSR2: AFSR14 Position               */
#define PB_AFSR2_AFSR14_Msk                   (0x0fUL << PB_AFSR2_AFSR14_Pos)                         /*!< PB AFSR2: AFSR14 Mask                   */
#define PB_AFSR2_AFSR15_Pos                   28                                                      /*!< PB AFSR2: AFSR15 Position               */
#define PB_AFSR2_AFSR15_Msk                   (0x0fUL << PB_AFSR2_AFSR15_Pos)                         /*!< PB AFSR2: AFSR15 Mask                   */

/* -----------------------------------  PB_PUPD  ---------------------------------- */
#define PB_PUPD_PUPD0_Pos                     0                                                       /*!< PB PUPD: PUPD0 Position                 */
#define PB_PUPD_PUPD0_Msk                     (0x03UL << PB_PUPD_PUPD0_Pos)                           /*!< PB PUPD: PUPD0 Mask                     */
#define PB_PUPD_PUPD1_Pos                     2                                                       /*!< PB PUPD: PUPD1 Position                 */
#define PB_PUPD_PUPD1_Msk                     (0x03UL << PB_PUPD_PUPD1_Pos)                           /*!< PB PUPD: PUPD1 Mask                     */
#define PB_PUPD_PUPD2_Pos                     4                                                       /*!< PB PUPD: PUPD2 Position                 */
#define PB_PUPD_PUPD2_Msk                     (0x03UL << PB_PUPD_PUPD2_Pos)                           /*!< PB PUPD: PUPD2 Mask                     */
#define PB_PUPD_PUPD3_Pos                     6                                                       /*!< PB PUPD: PUPD3 Position                 */
#define PB_PUPD_PUPD3_Msk                     (0x03UL << PB_PUPD_PUPD3_Pos)                           /*!< PB PUPD: PUPD3 Mask                     */
#define PB_PUPD_PUPD4_Pos                     8                                                       /*!< PB PUPD: PUPD4 Position                 */
#define PB_PUPD_PUPD4_Msk                     (0x03UL << PB_PUPD_PUPD4_Pos)                           /*!< PB PUPD: PUPD4 Mask                     */
#define PB_PUPD_PUPD5_Pos                     10                                                      /*!< PB PUPD: PUPD5 Position                 */
#define PB_PUPD_PUPD5_Msk                     (0x03UL << PB_PUPD_PUPD5_Pos)                           /*!< PB PUPD: PUPD5 Mask                     */
#define PB_PUPD_PUPD6_Pos                     12                                                      /*!< PB PUPD: PUPD6 Position                 */
#define PB_PUPD_PUPD6_Msk                     (0x03UL << PB_PUPD_PUPD6_Pos)                           /*!< PB PUPD: PUPD6 Mask                     */
#define PB_PUPD_PUPD7_Pos                     14                                                      /*!< PB PUPD: PUPD7 Position                 */
#define PB_PUPD_PUPD7_Msk                     (0x03UL << PB_PUPD_PUPD7_Pos)                           /*!< PB PUPD: PUPD7 Mask                     */
#define PB_PUPD_PUPD8_Pos                     16                                                      /*!< PB PUPD: PUPD8 Position                 */
#define PB_PUPD_PUPD8_Msk                     (0x03UL << PB_PUPD_PUPD8_Pos)                           /*!< PB PUPD: PUPD8 Mask                     */
#define PB_PUPD_PUPD9_Pos                     18                                                      /*!< PB PUPD: PUPD9 Position                 */
#define PB_PUPD_PUPD9_Msk                     (0x03UL << PB_PUPD_PUPD9_Pos)                           /*!< PB PUPD: PUPD9 Mask                     */
#define PB_PUPD_PUPD10_Pos                    20                                                      /*!< PB PUPD: PUPD10 Position                */
#define PB_PUPD_PUPD10_Msk                    (0x03UL << PB_PUPD_PUPD10_Pos)                          /*!< PB PUPD: PUPD10 Mask                    */
#define PB_PUPD_PUPD11_Pos                    22                                                      /*!< PB PUPD: PUPD11 Position                */
#define PB_PUPD_PUPD11_Msk                    (0x03UL << PB_PUPD_PUPD11_Pos)                          /*!< PB PUPD: PUPD11 Mask                    */
#define PB_PUPD_PUPD12_Pos                    24                                                      /*!< PB PUPD: PUPD12 Position                */
#define PB_PUPD_PUPD12_Msk                    (0x03UL << PB_PUPD_PUPD12_Pos)                          /*!< PB PUPD: PUPD12 Mask                    */
#define PB_PUPD_PUPD13_Pos                    26                                                      /*!< PB PUPD: PUPD13 Position                */
#define PB_PUPD_PUPD13_Msk                    (0x03UL << PB_PUPD_PUPD13_Pos)                          /*!< PB PUPD: PUPD13 Mask                    */
#define PB_PUPD_PUPD14_Pos                    28                                                      /*!< PB PUPD: PUPD14 Position                */
#define PB_PUPD_PUPD14_Msk                    (0x03UL << PB_PUPD_PUPD14_Pos)                          /*!< PB PUPD: PUPD14 Mask                    */
#define PB_PUPD_PUPD15_Pos                    30                                                      /*!< PB PUPD: PUPD15 Position                */
#define PB_PUPD_PUPD15_Msk                    (0x03UL << PB_PUPD_PUPD15_Pos)                          /*!< PB PUPD: PUPD15 Mask                    */

/* -----------------------------------  PB_INDR  ---------------------------------- */
#define PB_INDR_INDR0_Pos                     0                                                       /*!< PB INDR: INDR0 Position                 */
#define PB_INDR_INDR0_Msk                     (0x01UL << PB_INDR_INDR0_Pos)                           /*!< PB INDR: INDR0 Mask                     */
#define PB_INDR_INDR1_Pos                     1                                                       /*!< PB INDR: INDR1 Position                 */
#define PB_INDR_INDR1_Msk                     (0x01UL << PB_INDR_INDR1_Pos)                           /*!< PB INDR: INDR1 Mask                     */
#define PB_INDR_INDR2_Pos                     2                                                       /*!< PB INDR: INDR2 Position                 */
#define PB_INDR_INDR2_Msk                     (0x01UL << PB_INDR_INDR2_Pos)                           /*!< PB INDR: INDR2 Mask                     */
#define PB_INDR_INDR3_Pos                     3                                                       /*!< PB INDR: INDR3 Position                 */
#define PB_INDR_INDR3_Msk                     (0x01UL << PB_INDR_INDR3_Pos)                           /*!< PB INDR: INDR3 Mask                     */
#define PB_INDR_INDR4_Pos                     4                                                       /*!< PB INDR: INDR4 Position                 */
#define PB_INDR_INDR4_Msk                     (0x01UL << PB_INDR_INDR4_Pos)                           /*!< PB INDR: INDR4 Mask                     */
#define PB_INDR_INDR5_Pos                     5                                                       /*!< PB INDR: INDR5 Position                 */
#define PB_INDR_INDR5_Msk                     (0x01UL << PB_INDR_INDR5_Pos)                           /*!< PB INDR: INDR5 Mask                     */
#define PB_INDR_INDR6_Pos                     6                                                       /*!< PB INDR: INDR6 Position                 */
#define PB_INDR_INDR6_Msk                     (0x01UL << PB_INDR_INDR6_Pos)                           /*!< PB INDR: INDR6 Mask                     */
#define PB_INDR_INDR7_Pos                     7                                                       /*!< PB INDR: INDR7 Position                 */
#define PB_INDR_INDR7_Msk                     (0x01UL << PB_INDR_INDR7_Pos)                           /*!< PB INDR: INDR7 Mask                     */
#define PB_INDR_INDR8_Pos                     8                                                       /*!< PB INDR: INDR8 Position                 */
#define PB_INDR_INDR8_Msk                     (0x01UL << PB_INDR_INDR8_Pos)                           /*!< PB INDR: INDR8 Mask                     */
#define PB_INDR_INDR9_Pos                     9                                                       /*!< PB INDR: INDR9 Position                 */
#define PB_INDR_INDR9_Msk                     (0x01UL << PB_INDR_INDR9_Pos)                           /*!< PB INDR: INDR9 Mask                     */
#define PB_INDR_INDR10_Pos                    10                                                      /*!< PB INDR: INDR10 Position                */
#define PB_INDR_INDR10_Msk                    (0x01UL << PB_INDR_INDR10_Pos)                          /*!< PB INDR: INDR10 Mask                    */
#define PB_INDR_INDR11_Pos                    11                                                      /*!< PB INDR: INDR11 Position                */
#define PB_INDR_INDR11_Msk                    (0x01UL << PB_INDR_INDR11_Pos)                          /*!< PB INDR: INDR11 Mask                    */
#define PB_INDR_INDR12_Pos                    12                                                      /*!< PB INDR: INDR12 Position                */
#define PB_INDR_INDR12_Msk                    (0x01UL << PB_INDR_INDR12_Pos)                          /*!< PB INDR: INDR12 Mask                    */
#define PB_INDR_INDR13_Pos                    13                                                      /*!< PB INDR: INDR13 Position                */
#define PB_INDR_INDR13_Msk                    (0x01UL << PB_INDR_INDR13_Pos)                          /*!< PB INDR: INDR13 Mask                    */
#define PB_INDR_INDR14_Pos                    14                                                      /*!< PB INDR: INDR14 Position                */
#define PB_INDR_INDR14_Msk                    (0x01UL << PB_INDR_INDR14_Pos)                          /*!< PB INDR: INDR14 Mask                    */
#define PB_INDR_INDR15_Pos                    15                                                      /*!< PB INDR: INDR15 Position                */
#define PB_INDR_INDR15_Msk                    (0x01UL << PB_INDR_INDR15_Pos)                          /*!< PB INDR: INDR15 Mask                    */

/* ----------------------------------  PB_OUTDR  ---------------------------------- */
#define PB_OUTDR_OUTDR0_Pos                   0                                                       /*!< PB OUTDR: OUTDR0 Position               */
#define PB_OUTDR_OUTDR0_Msk                   (0x01UL << PB_OUTDR_OUTDR0_Pos)                         /*!< PB OUTDR: OUTDR0 Mask                   */
#define PB_OUTDR_OUTDR1_Pos                   1                                                       /*!< PB OUTDR: OUTDR1 Position               */
#define PB_OUTDR_OUTDR1_Msk                   (0x01UL << PB_OUTDR_OUTDR1_Pos)                         /*!< PB OUTDR: OUTDR1 Mask                   */
#define PB_OUTDR_OUTDR2_Pos                   2                                                       /*!< PB OUTDR: OUTDR2 Position               */
#define PB_OUTDR_OUTDR2_Msk                   (0x01UL << PB_OUTDR_OUTDR2_Pos)                         /*!< PB OUTDR: OUTDR2 Mask                   */
#define PB_OUTDR_OUTDR3_Pos                   3                                                       /*!< PB OUTDR: OUTDR3 Position               */
#define PB_OUTDR_OUTDR3_Msk                   (0x01UL << PB_OUTDR_OUTDR3_Pos)                         /*!< PB OUTDR: OUTDR3 Mask                   */
#define PB_OUTDR_OUTDR4_Pos                   4                                                       /*!< PB OUTDR: OUTDR4 Position               */
#define PB_OUTDR_OUTDR4_Msk                   (0x01UL << PB_OUTDR_OUTDR4_Pos)                         /*!< PB OUTDR: OUTDR4 Mask                   */
#define PB_OUTDR_OUTDR5_Pos                   5                                                       /*!< PB OUTDR: OUTDR5 Position               */
#define PB_OUTDR_OUTDR5_Msk                   (0x01UL << PB_OUTDR_OUTDR5_Pos)                         /*!< PB OUTDR: OUTDR5 Mask                   */
#define PB_OUTDR_OUTDR6_Pos                   6                                                       /*!< PB OUTDR: OUTDR6 Position               */
#define PB_OUTDR_OUTDR6_Msk                   (0x01UL << PB_OUTDR_OUTDR6_Pos)                         /*!< PB OUTDR: OUTDR6 Mask                   */
#define PB_OUTDR_OUTDR7_Pos                   7                                                       /*!< PB OUTDR: OUTDR7 Position               */
#define PB_OUTDR_OUTDR7_Msk                   (0x01UL << PB_OUTDR_OUTDR7_Pos)                         /*!< PB OUTDR: OUTDR7 Mask                   */
#define PB_OUTDR_OUTDR8_Pos                   8                                                       /*!< PB OUTDR: OUTDR8 Position               */
#define PB_OUTDR_OUTDR8_Msk                   (0x01UL << PB_OUTDR_OUTDR8_Pos)                         /*!< PB OUTDR: OUTDR8 Mask                   */
#define PB_OUTDR_OUTDR9_Pos                   9                                                       /*!< PB OUTDR: OUTDR9 Position               */
#define PB_OUTDR_OUTDR9_Msk                   (0x01UL << PB_OUTDR_OUTDR9_Pos)                         /*!< PB OUTDR: OUTDR9 Mask                   */
#define PB_OUTDR_OUTDR10_Pos                  10                                                      /*!< PB OUTDR: OUTDR10 Position              */
#define PB_OUTDR_OUTDR10_Msk                  (0x01UL << PB_OUTDR_OUTDR10_Pos)                        /*!< PB OUTDR: OUTDR10 Mask                  */
#define PB_OUTDR_OUTDR11_Pos                  11                                                      /*!< PB OUTDR: OUTDR11 Position              */
#define PB_OUTDR_OUTDR11_Msk                  (0x01UL << PB_OUTDR_OUTDR11_Pos)                        /*!< PB OUTDR: OUTDR11 Mask                  */
#define PB_OUTDR_OUTDR12_Pos                  12                                                      /*!< PB OUTDR: OUTDR12 Position              */
#define PB_OUTDR_OUTDR12_Msk                  (0x01UL << PB_OUTDR_OUTDR12_Pos)                        /*!< PB OUTDR: OUTDR12 Mask                  */
#define PB_OUTDR_OUTDR13_Pos                  13                                                      /*!< PB OUTDR: OUTDR13 Position              */
#define PB_OUTDR_OUTDR13_Msk                  (0x01UL << PB_OUTDR_OUTDR13_Pos)                        /*!< PB OUTDR: OUTDR13 Mask                  */
#define PB_OUTDR_OUTDR14_Pos                  14                                                      /*!< PB OUTDR: OUTDR14 Position              */
#define PB_OUTDR_OUTDR14_Msk                  (0x01UL << PB_OUTDR_OUTDR14_Pos)                        /*!< PB OUTDR: OUTDR14 Mask                  */
#define PB_OUTDR_OUTDR15_Pos                  15                                                      /*!< PB OUTDR: OUTDR15 Position              */
#define PB_OUTDR_OUTDR15_Msk                  (0x01UL << PB_OUTDR_OUTDR15_Pos)                        /*!< PB OUTDR: OUTDR15 Mask                  */

/* -----------------------------------  PB_BSR  ----------------------------------- */
#define PB_BSR_BSR0_Pos                       0                                                       /*!< PB BSR: BSR0 Position                   */
#define PB_BSR_BSR0_Msk                       (0x01UL << PB_BSR_BSR0_Pos)                             /*!< PB BSR: BSR0 Mask                       */
#define PB_BSR_BSR1_Pos                       1                                                       /*!< PB BSR: BSR1 Position                   */
#define PB_BSR_BSR1_Msk                       (0x01UL << PB_BSR_BSR1_Pos)                             /*!< PB BSR: BSR1 Mask                       */
#define PB_BSR_BSR2_Pos                       2                                                       /*!< PB BSR: BSR2 Position                   */
#define PB_BSR_BSR2_Msk                       (0x01UL << PB_BSR_BSR2_Pos)                             /*!< PB BSR: BSR2 Mask                       */
#define PB_BSR_BSR3_Pos                       3                                                       /*!< PB BSR: BSR3 Position                   */
#define PB_BSR_BSR3_Msk                       (0x01UL << PB_BSR_BSR3_Pos)                             /*!< PB BSR: BSR3 Mask                       */
#define PB_BSR_BSR4_Pos                       4                                                       /*!< PB BSR: BSR4 Position                   */
#define PB_BSR_BSR4_Msk                       (0x01UL << PB_BSR_BSR4_Pos)                             /*!< PB BSR: BSR4 Mask                       */
#define PB_BSR_BSR5_Pos                       5                                                       /*!< PB BSR: BSR5 Position                   */
#define PB_BSR_BSR5_Msk                       (0x01UL << PB_BSR_BSR5_Pos)                             /*!< PB BSR: BSR5 Mask                       */
#define PB_BSR_BSR6_Pos                       6                                                       /*!< PB BSR: BSR6 Position                   */
#define PB_BSR_BSR6_Msk                       (0x01UL << PB_BSR_BSR6_Pos)                             /*!< PB BSR: BSR6 Mask                       */
#define PB_BSR_BSR7_Pos                       7                                                       /*!< PB BSR: BSR7 Position                   */
#define PB_BSR_BSR7_Msk                       (0x01UL << PB_BSR_BSR7_Pos)                             /*!< PB BSR: BSR7 Mask                       */
#define PB_BSR_BSR8_Pos                       8                                                       /*!< PB BSR: BSR8 Position                   */
#define PB_BSR_BSR8_Msk                       (0x01UL << PB_BSR_BSR8_Pos)                             /*!< PB BSR: BSR8 Mask                       */
#define PB_BSR_BSR9_Pos                       9                                                       /*!< PB BSR: BSR9 Position                   */
#define PB_BSR_BSR9_Msk                       (0x01UL << PB_BSR_BSR9_Pos)                             /*!< PB BSR: BSR9 Mask                       */
#define PB_BSR_BSR10_Pos                      10                                                      /*!< PB BSR: BSR10 Position                  */
#define PB_BSR_BSR10_Msk                      (0x01UL << PB_BSR_BSR10_Pos)                            /*!< PB BSR: BSR10 Mask                      */
#define PB_BSR_BSR11_Pos                      11                                                      /*!< PB BSR: BSR11 Position                  */
#define PB_BSR_BSR11_Msk                      (0x01UL << PB_BSR_BSR11_Pos)                            /*!< PB BSR: BSR11 Mask                      */
#define PB_BSR_BSR12_Pos                      12                                                      /*!< PB BSR: BSR12 Position                  */
#define PB_BSR_BSR12_Msk                      (0x01UL << PB_BSR_BSR12_Pos)                            /*!< PB BSR: BSR12 Mask                      */
#define PB_BSR_BSR13_Pos                      13                                                      /*!< PB BSR: BSR13 Position                  */
#define PB_BSR_BSR13_Msk                      (0x01UL << PB_BSR_BSR13_Pos)                            /*!< PB BSR: BSR13 Mask                      */
#define PB_BSR_BSR14_Pos                      14                                                      /*!< PB BSR: BSR14 Position                  */
#define PB_BSR_BSR14_Msk                      (0x01UL << PB_BSR_BSR14_Pos)                            /*!< PB BSR: BSR14 Mask                      */
#define PB_BSR_BSR15_Pos                      15                                                      /*!< PB BSR: BSR15 Position                  */
#define PB_BSR_BSR15_Msk                      (0x01UL << PB_BSR_BSR15_Pos)                            /*!< PB BSR: BSR15 Mask                      */

/* -----------------------------------  PB_BCR  ----------------------------------- */
#define PB_BCR_BCR0_Pos                       0                                                       /*!< PB BCR: BCR0 Position                   */
#define PB_BCR_BCR0_Msk                       (0x01UL << PB_BCR_BCR0_Pos)                             /*!< PB BCR: BCR0 Mask                       */
#define PB_BCR_BCR1_Pos                       1                                                       /*!< PB BCR: BCR1 Position                   */
#define PB_BCR_BCR1_Msk                       (0x01UL << PB_BCR_BCR1_Pos)                             /*!< PB BCR: BCR1 Mask                       */
#define PB_BCR_BCR2_Pos                       2                                                       /*!< PB BCR: BCR2 Position                   */
#define PB_BCR_BCR2_Msk                       (0x01UL << PB_BCR_BCR2_Pos)                             /*!< PB BCR: BCR2 Mask                       */
#define PB_BCR_BCR3_Pos                       3                                                       /*!< PB BCR: BCR3 Position                   */
#define PB_BCR_BCR3_Msk                       (0x01UL << PB_BCR_BCR3_Pos)                             /*!< PB BCR: BCR3 Mask                       */
#define PB_BCR_BCR4_Pos                       4                                                       /*!< PB BCR: BCR4 Position                   */
#define PB_BCR_BCR4_Msk                       (0x01UL << PB_BCR_BCR4_Pos)                             /*!< PB BCR: BCR4 Mask                       */
#define PB_BCR_BCR5_Pos                       5                                                       /*!< PB BCR: BCR5 Position                   */
#define PB_BCR_BCR5_Msk                       (0x01UL << PB_BCR_BCR5_Pos)                             /*!< PB BCR: BCR5 Mask                       */
#define PB_BCR_BCR6_Pos                       6                                                       /*!< PB BCR: BCR6 Position                   */
#define PB_BCR_BCR6_Msk                       (0x01UL << PB_BCR_BCR6_Pos)                             /*!< PB BCR: BCR6 Mask                       */
#define PB_BCR_BCR7_Pos                       7                                                       /*!< PB BCR: BCR7 Position                   */
#define PB_BCR_BCR7_Msk                       (0x01UL << PB_BCR_BCR7_Pos)                             /*!< PB BCR: BCR7 Mask                       */
#define PB_BCR_BCR8_Pos                       8                                                       /*!< PB BCR: BCR8 Position                   */
#define PB_BCR_BCR8_Msk                       (0x01UL << PB_BCR_BCR8_Pos)                             /*!< PB BCR: BCR8 Mask                       */
#define PB_BCR_BCR9_Pos                       9                                                       /*!< PB BCR: BCR9 Position                   */
#define PB_BCR_BCR9_Msk                       (0x01UL << PB_BCR_BCR9_Pos)                             /*!< PB BCR: BCR9 Mask                       */
#define PB_BCR_BCR10_Pos                      10                                                      /*!< PB BCR: BCR10 Position                  */
#define PB_BCR_BCR10_Msk                      (0x01UL << PB_BCR_BCR10_Pos)                            /*!< PB BCR: BCR10 Mask                      */
#define PB_BCR_BCR11_Pos                      11                                                      /*!< PB BCR: BCR11 Position                  */
#define PB_BCR_BCR11_Msk                      (0x01UL << PB_BCR_BCR11_Pos)                            /*!< PB BCR: BCR11 Mask                      */
#define PB_BCR_BCR12_Pos                      12                                                      /*!< PB BCR: BCR12 Position                  */
#define PB_BCR_BCR12_Msk                      (0x01UL << PB_BCR_BCR12_Pos)                            /*!< PB BCR: BCR12 Mask                      */
#define PB_BCR_BCR13_Pos                      13                                                      /*!< PB BCR: BCR13 Position                  */
#define PB_BCR_BCR13_Msk                      (0x01UL << PB_BCR_BCR13_Pos)                            /*!< PB BCR: BCR13 Mask                      */
#define PB_BCR_BCR14_Pos                      14                                                      /*!< PB BCR: BCR14 Position                  */
#define PB_BCR_BCR14_Msk                      (0x01UL << PB_BCR_BCR14_Pos)                            /*!< PB BCR: BCR14 Mask                      */
#define PB_BCR_BCR15_Pos                      15                                                      /*!< PB BCR: BCR15 Position                  */
#define PB_BCR_BCR15_Msk                      (0x01UL << PB_BCR_BCR15_Pos)                            /*!< PB BCR: BCR15 Mask                      */

/* ---------------------------------  PB_OUTDMSK  --------------------------------- */
#define PB_OUTDMSK_OUTDMSK0_Pos               0                                                       /*!< PB OUTDMSK: OUTDMSK0 Position           */
#define PB_OUTDMSK_OUTDMSK0_Msk               (0x01UL << PB_OUTDMSK_OUTDMSK0_Pos)                     /*!< PB OUTDMSK: OUTDMSK0 Mask               */
#define PB_OUTDMSK_OUTDMSK1_Pos               1                                                       /*!< PB OUTDMSK: OUTDMSK1 Position           */
#define PB_OUTDMSK_OUTDMSK1_Msk               (0x01UL << PB_OUTDMSK_OUTDMSK1_Pos)                     /*!< PB OUTDMSK: OUTDMSK1 Mask               */
#define PB_OUTDMSK_OUTDMSK2_Pos               2                                                       /*!< PB OUTDMSK: OUTDMSK2 Position           */
#define PB_OUTDMSK_OUTDMSK2_Msk               (0x01UL << PB_OUTDMSK_OUTDMSK2_Pos)                     /*!< PB OUTDMSK: OUTDMSK2 Mask               */
#define PB_OUTDMSK_OUTDMSK3_Pos               3                                                       /*!< PB OUTDMSK: OUTDMSK3 Position           */
#define PB_OUTDMSK_OUTDMSK3_Msk               (0x01UL << PB_OUTDMSK_OUTDMSK3_Pos)                     /*!< PB OUTDMSK: OUTDMSK3 Mask               */
#define PB_OUTDMSK_OUTDMSK4_Pos               4                                                       /*!< PB OUTDMSK: OUTDMSK4 Position           */
#define PB_OUTDMSK_OUTDMSK4_Msk               (0x01UL << PB_OUTDMSK_OUTDMSK4_Pos)                     /*!< PB OUTDMSK: OUTDMSK4 Mask               */
#define PB_OUTDMSK_OUTDMSK5_Pos               5                                                       /*!< PB OUTDMSK: OUTDMSK5 Position           */
#define PB_OUTDMSK_OUTDMSK5_Msk               (0x01UL << PB_OUTDMSK_OUTDMSK5_Pos)                     /*!< PB OUTDMSK: OUTDMSK5 Mask               */
#define PB_OUTDMSK_OUTDMSK6_Pos               6                                                       /*!< PB OUTDMSK: OUTDMSK6 Position           */
#define PB_OUTDMSK_OUTDMSK6_Msk               (0x01UL << PB_OUTDMSK_OUTDMSK6_Pos)                     /*!< PB OUTDMSK: OUTDMSK6 Mask               */
#define PB_OUTDMSK_OUTDMSK7_Pos               7                                                       /*!< PB OUTDMSK: OUTDMSK7 Position           */
#define PB_OUTDMSK_OUTDMSK7_Msk               (0x01UL << PB_OUTDMSK_OUTDMSK7_Pos)                     /*!< PB OUTDMSK: OUTDMSK7 Mask               */
#define PB_OUTDMSK_OUTDMSK8_Pos               8                                                       /*!< PB OUTDMSK: OUTDMSK8 Position           */
#define PB_OUTDMSK_OUTDMSK8_Msk               (0x01UL << PB_OUTDMSK_OUTDMSK8_Pos)                     /*!< PB OUTDMSK: OUTDMSK8 Mask               */
#define PB_OUTDMSK_OUTDMSK9_Pos               9                                                       /*!< PB OUTDMSK: OUTDMSK9 Position           */
#define PB_OUTDMSK_OUTDMSK9_Msk               (0x01UL << PB_OUTDMSK_OUTDMSK9_Pos)                     /*!< PB OUTDMSK: OUTDMSK9 Mask               */
#define PB_OUTDMSK_OUTDMSK10_Pos              10                                                      /*!< PB OUTDMSK: OUTDMSK10 Position          */
#define PB_OUTDMSK_OUTDMSK10_Msk              (0x01UL << PB_OUTDMSK_OUTDMSK10_Pos)                    /*!< PB OUTDMSK: OUTDMSK10 Mask              */
#define PB_OUTDMSK_OUTDMSK11_Pos              11                                                      /*!< PB OUTDMSK: OUTDMSK11 Position          */
#define PB_OUTDMSK_OUTDMSK11_Msk              (0x01UL << PB_OUTDMSK_OUTDMSK11_Pos)                    /*!< PB OUTDMSK: OUTDMSK11 Mask              */
#define PB_OUTDMSK_OUTDMSK12_Pos              12                                                      /*!< PB OUTDMSK: OUTDMSK12 Position          */
#define PB_OUTDMSK_OUTDMSK12_Msk              (0x01UL << PB_OUTDMSK_OUTDMSK12_Pos)                    /*!< PB OUTDMSK: OUTDMSK12 Mask              */
#define PB_OUTDMSK_OUTDMSK13_Pos              13                                                      /*!< PB OUTDMSK: OUTDMSK13 Position          */
#define PB_OUTDMSK_OUTDMSK13_Msk              (0x01UL << PB_OUTDMSK_OUTDMSK13_Pos)                    /*!< PB OUTDMSK: OUTDMSK13 Mask              */
#define PB_OUTDMSK_OUTDMSK14_Pos              14                                                      /*!< PB OUTDMSK: OUTDMSK14 Position          */
#define PB_OUTDMSK_OUTDMSK14_Msk              (0x01UL << PB_OUTDMSK_OUTDMSK14_Pos)                    /*!< PB OUTDMSK: OUTDMSK14 Mask              */
#define PB_OUTDMSK_OUTDMSK15_Pos              15                                                      /*!< PB OUTDMSK: OUTDMSK15 Position          */
#define PB_OUTDMSK_OUTDMSK15_Msk              (0x01UL << PB_OUTDMSK_OUTDMSK15_Pos)                    /*!< PB OUTDMSK: OUTDMSK15 Mask              */

/* -----------------------------------  PB_DBCR  ---------------------------------- */
#define PB_DBCR_DBEN0_Pos                     0                                                       /*!< PB DBCR: DBEN0 Position                 */
#define PB_DBCR_DBEN0_Msk                     (0x01UL << PB_DBCR_DBEN0_Pos)                           /*!< PB DBCR: DBEN0 Mask                     */
#define PB_DBCR_DBEN1_Pos                     1                                                       /*!< PB DBCR: DBEN1 Position                 */
#define PB_DBCR_DBEN1_Msk                     (0x01UL << PB_DBCR_DBEN1_Pos)                           /*!< PB DBCR: DBEN1 Mask                     */
#define PB_DBCR_DBEN2_Pos                     2                                                       /*!< PB DBCR: DBEN2 Position                 */
#define PB_DBCR_DBEN2_Msk                     (0x01UL << PB_DBCR_DBEN2_Pos)                           /*!< PB DBCR: DBEN2 Mask                     */
#define PB_DBCR_DBEN3_Pos                     3                                                       /*!< PB DBCR: DBEN3 Position                 */
#define PB_DBCR_DBEN3_Msk                     (0x01UL << PB_DBCR_DBEN3_Pos)                           /*!< PB DBCR: DBEN3 Mask                     */
#define PB_DBCR_DBEN4_Pos                     4                                                       /*!< PB DBCR: DBEN4 Position                 */
#define PB_DBCR_DBEN4_Msk                     (0x01UL << PB_DBCR_DBEN4_Pos)                           /*!< PB DBCR: DBEN4 Mask                     */
#define PB_DBCR_DBEN5_Pos                     5                                                       /*!< PB DBCR: DBEN5 Position                 */
#define PB_DBCR_DBEN5_Msk                     (0x01UL << PB_DBCR_DBEN5_Pos)                           /*!< PB DBCR: DBEN5 Mask                     */
#define PB_DBCR_DBEN6_Pos                     6                                                       /*!< PB DBCR: DBEN6 Position                 */
#define PB_DBCR_DBEN6_Msk                     (0x01UL << PB_DBCR_DBEN6_Pos)                           /*!< PB DBCR: DBEN6 Mask                     */
#define PB_DBCR_DBEN7_Pos                     7                                                       /*!< PB DBCR: DBEN7 Position                 */
#define PB_DBCR_DBEN7_Msk                     (0x01UL << PB_DBCR_DBEN7_Pos)                           /*!< PB DBCR: DBEN7 Mask                     */
#define PB_DBCR_DBEN8_Pos                     8                                                       /*!< PB DBCR: DBEN8 Position                 */
#define PB_DBCR_DBEN8_Msk                     (0x01UL << PB_DBCR_DBEN8_Pos)                           /*!< PB DBCR: DBEN8 Mask                     */
#define PB_DBCR_DBEN9_Pos                     9                                                       /*!< PB DBCR: DBEN9 Position                 */
#define PB_DBCR_DBEN9_Msk                     (0x01UL << PB_DBCR_DBEN9_Pos)                           /*!< PB DBCR: DBEN9 Mask                     */
#define PB_DBCR_DBEN10_Pos                    10                                                      /*!< PB DBCR: DBEN10 Position                */
#define PB_DBCR_DBEN10_Msk                    (0x01UL << PB_DBCR_DBEN10_Pos)                          /*!< PB DBCR: DBEN10 Mask                    */
#define PB_DBCR_DBEN11_Pos                    11                                                      /*!< PB DBCR: DBEN11 Position                */
#define PB_DBCR_DBEN11_Msk                    (0x01UL << PB_DBCR_DBEN11_Pos)                          /*!< PB DBCR: DBEN11 Mask                    */
#define PB_DBCR_DBEN12_Pos                    12                                                      /*!< PB DBCR: DBEN12 Position                */
#define PB_DBCR_DBEN12_Msk                    (0x01UL << PB_DBCR_DBEN12_Pos)                          /*!< PB DBCR: DBEN12 Mask                    */
#define PB_DBCR_DBEN13_Pos                    13                                                      /*!< PB DBCR: DBEN13 Position                */
#define PB_DBCR_DBEN13_Msk                    (0x01UL << PB_DBCR_DBEN13_Pos)                          /*!< PB DBCR: DBEN13 Mask                    */
#define PB_DBCR_DBEN14_Pos                    14                                                      /*!< PB DBCR: DBEN14 Position                */
#define PB_DBCR_DBEN14_Msk                    (0x01UL << PB_DBCR_DBEN14_Pos)                          /*!< PB DBCR: DBEN14 Mask                    */
#define PB_DBCR_DBEN15_Pos                    15                                                      /*!< PB DBCR: DBEN15 Position                */
#define PB_DBCR_DBEN15_Msk                    (0x01UL << PB_DBCR_DBEN15_Pos)                          /*!< PB DBCR: DBEN15 Mask                    */

/* -----------------------------------  PB_IER  ----------------------------------- */
#define PB_IER_P0_Pos                         0                                                       /*!< PB IER: P0 Position                     */
#define PB_IER_P0_Msk                         (0x03UL << PB_IER_P0_Pos)                               /*!< PB IER: P0 Mask                         */
#define PB_IER_P1_Pos                         2                                                       /*!< PB IER: P1 Position                     */
#define PB_IER_P1_Msk                         (0x03UL << PB_IER_P1_Pos)                               /*!< PB IER: P1 Mask                         */
#define PB_IER_P2_Pos                         4                                                       /*!< PB IER: P2 Position                     */
#define PB_IER_P2_Msk                         (0x03UL << PB_IER_P2_Pos)                               /*!< PB IER: P2 Mask                         */
#define PB_IER_P3_Pos                         6                                                       /*!< PB IER: P3 Position                     */
#define PB_IER_P3_Msk                         (0x03UL << PB_IER_P3_Pos)                               /*!< PB IER: P3 Mask                         */
#define PB_IER_P4_Pos                         8                                                       /*!< PB IER: P4 Position                     */
#define PB_IER_P4_Msk                         (0x03UL << PB_IER_P4_Pos)                               /*!< PB IER: P4 Mask                         */
#define PB_IER_P5_Pos                         10                                                      /*!< PB IER: P5 Position                     */
#define PB_IER_P5_Msk                         (0x03UL << PB_IER_P5_Pos)                               /*!< PB IER: P5 Mask                         */
#define PB_IER_P6_Pos                         12                                                      /*!< PB IER: P6 Position                     */
#define PB_IER_P6_Msk                         (0x03UL << PB_IER_P6_Pos)                               /*!< PB IER: P6 Mask                         */
#define PB_IER_P7_Pos                         14                                                      /*!< PB IER: P7 Position                     */
#define PB_IER_P7_Msk                         (0x03UL << PB_IER_P7_Pos)                               /*!< PB IER: P7 Mask                         */
#define PB_IER_P8_Pos                         16                                                      /*!< PB IER: P8 Position                     */
#define PB_IER_P8_Msk                         (0x03UL << PB_IER_P8_Pos)                               /*!< PB IER: P8 Mask                         */
#define PB_IER_P9_Pos                         18                                                      /*!< PB IER: P9 Position                     */
#define PB_IER_P9_Msk                         (0x03UL << PB_IER_P9_Pos)                               /*!< PB IER: P9 Mask                         */
#define PB_IER_P10_Pos                        20                                                      /*!< PB IER: P10 Position                    */
#define PB_IER_P10_Msk                        (0x03UL << PB_IER_P10_Pos)                              /*!< PB IER: P10 Mask                        */
#define PB_IER_P11_Pos                        22                                                      /*!< PB IER: P11 Position                    */
#define PB_IER_P11_Msk                        (0x03UL << PB_IER_P11_Pos)                              /*!< PB IER: P11 Mask                        */
#define PB_IER_P12_Pos                        24                                                      /*!< PB IER: P12 Position                    */
#define PB_IER_P12_Msk                        (0x03UL << PB_IER_P12_Pos)                              /*!< PB IER: P12 Mask                        */
#define PB_IER_P13_Pos                        26                                                      /*!< PB IER: P13 Position                    */
#define PB_IER_P13_Msk                        (0x03UL << PB_IER_P13_Pos)                              /*!< PB IER: P13 Mask                        */
#define PB_IER_P14_Pos                        28                                                      /*!< PB IER: P14 Position                    */
#define PB_IER_P14_Msk                        (0x03UL << PB_IER_P14_Pos)                              /*!< PB IER: P14 Mask                        */
#define PB_IER_P15_Pos                        30                                                      /*!< PB IER: P15 Position                    */
#define PB_IER_P15_Msk                        (0x03UL << PB_IER_P15_Pos)                              /*!< PB IER: P15 Mask                        */

/* -----------------------------------  PB_ISR  ----------------------------------- */
#define PB_ISR_P0_Pos                         0                                                       /*!< PB ISR: P0 Position                     */
#define PB_ISR_P0_Msk                         (0x03UL << PB_ISR_P0_Pos)                               /*!< PB ISR: P0 Mask                         */
#define PB_ISR_P1_Pos                         2                                                       /*!< PB ISR: P1 Position                     */
#define PB_ISR_P1_Msk                         (0x03UL << PB_ISR_P1_Pos)                               /*!< PB ISR: P1 Mask                         */
#define PB_ISR_P2_Pos                         4                                                       /*!< PB ISR: P2 Position                     */
#define PB_ISR_P2_Msk                         (0x03UL << PB_ISR_P2_Pos)                               /*!< PB ISR: P2 Mask                         */
#define PB_ISR_P3_Pos                         6                                                       /*!< PB ISR: P3 Position                     */
#define PB_ISR_P3_Msk                         (0x03UL << PB_ISR_P3_Pos)                               /*!< PB ISR: P3 Mask                         */
#define PB_ISR_P4_Pos                         8                                                       /*!< PB ISR: P4 Position                     */
#define PB_ISR_P4_Msk                         (0x03UL << PB_ISR_P4_Pos)                               /*!< PB ISR: P4 Mask                         */
#define PB_ISR_P5_Pos                         10                                                      /*!< PB ISR: P5 Position                     */
#define PB_ISR_P5_Msk                         (0x03UL << PB_ISR_P5_Pos)                               /*!< PB ISR: P5 Mask                         */
#define PB_ISR_P6_Pos                         12                                                      /*!< PB ISR: P6 Position                     */
#define PB_ISR_P6_Msk                         (0x03UL << PB_ISR_P6_Pos)                               /*!< PB ISR: P6 Mask                         */
#define PB_ISR_P7_Pos                         14                                                      /*!< PB ISR: P7 Position                     */
#define PB_ISR_P7_Msk                         (0x03UL << PB_ISR_P7_Pos)                               /*!< PB ISR: P7 Mask                         */
#define PB_ISR_P8_Pos                         16                                                      /*!< PB ISR: P8 Position                     */
#define PB_ISR_P8_Msk                         (0x03UL << PB_ISR_P8_Pos)                               /*!< PB ISR: P8 Mask                         */
#define PB_ISR_P9_Pos                         18                                                      /*!< PB ISR: P9 Position                     */
#define PB_ISR_P9_Msk                         (0x03UL << PB_ISR_P9_Pos)                               /*!< PB ISR: P9 Mask                         */
#define PB_ISR_P10_Pos                        20                                                      /*!< PB ISR: P10 Position                    */
#define PB_ISR_P10_Msk                        (0x03UL << PB_ISR_P10_Pos)                              /*!< PB ISR: P10 Mask                        */
#define PB_ISR_P11_Pos                        22                                                      /*!< PB ISR: P11 Position                    */
#define PB_ISR_P11_Msk                        (0x03UL << PB_ISR_P11_Pos)                              /*!< PB ISR: P11 Mask                        */
#define PB_ISR_P12_Pos                        24                                                      /*!< PB ISR: P12 Position                    */
#define PB_ISR_P12_Msk                        (0x03UL << PB_ISR_P12_Pos)                              /*!< PB ISR: P12 Mask                        */
#define PB_ISR_P13_Pos                        26                                                      /*!< PB ISR: P13 Position                    */
#define PB_ISR_P13_Msk                        (0x03UL << PB_ISR_P13_Pos)                              /*!< PB ISR: P13 Mask                        */
#define PB_ISR_P14_Pos                        28                                                      /*!< PB ISR: P14 Position                    */
#define PB_ISR_P14_Msk                        (0x03UL << PB_ISR_P14_Pos)                              /*!< PB ISR: P14 Mask                        */
#define PB_ISR_P15_Pos                        30                                                      /*!< PB ISR: P15 Position                    */
#define PB_ISR_P15_Msk                        (0x03UL << PB_ISR_P15_Pos)                              /*!< PB ISR: P15 Mask                        */

/* -----------------------------------  PB_ICR  ----------------------------------- */
#define PB_ICR_P0_Pos                         0                                                       /*!< PB ICR: P0 Position                     */
#define PB_ICR_P0_Msk                         (0x03UL << PB_ICR_P0_Pos)                               /*!< PB ICR: P0 Mask                         */
#define PB_ICR_P1_Pos                         2                                                       /*!< PB ICR: P1 Position                     */
#define PB_ICR_P1_Msk                         (0x03UL << PB_ICR_P1_Pos)                               /*!< PB ICR: P1 Mask                         */
#define PB_ICR_P2_Pos                         4                                                       /*!< PB ICR: P2 Position                     */
#define PB_ICR_P2_Msk                         (0x03UL << PB_ICR_P2_Pos)                               /*!< PB ICR: P2 Mask                         */
#define PB_ICR_P3_Pos                         6                                                       /*!< PB ICR: P3 Position                     */
#define PB_ICR_P3_Msk                         (0x03UL << PB_ICR_P3_Pos)                               /*!< PB ICR: P3 Mask                         */
#define PB_ICR_P4_Pos                         8                                                       /*!< PB ICR: P4 Position                     */
#define PB_ICR_P4_Msk                         (0x03UL << PB_ICR_P4_Pos)                               /*!< PB ICR: P4 Mask                         */
#define PB_ICR_P5_Pos                         10                                                      /*!< PB ICR: P5 Position                     */
#define PB_ICR_P5_Msk                         (0x03UL << PB_ICR_P5_Pos)                               /*!< PB ICR: P5 Mask                         */
#define PB_ICR_P6_Pos                         12                                                      /*!< PB ICR: P6 Position                     */
#define PB_ICR_P6_Msk                         (0x03UL << PB_ICR_P6_Pos)                               /*!< PB ICR: P6 Mask                         */
#define PB_ICR_P7_Pos                         14                                                      /*!< PB ICR: P7 Position                     */
#define PB_ICR_P7_Msk                         (0x03UL << PB_ICR_P7_Pos)                               /*!< PB ICR: P7 Mask                         */
#define PB_ICR_P8_Pos                         16                                                      /*!< PB ICR: P8 Position                     */
#define PB_ICR_P8_Msk                         (0x03UL << PB_ICR_P8_Pos)                               /*!< PB ICR: P8 Mask                         */
#define PB_ICR_P9_Pos                         18                                                      /*!< PB ICR: P9 Position                     */
#define PB_ICR_P9_Msk                         (0x03UL << PB_ICR_P9_Pos)                               /*!< PB ICR: P9 Mask                         */
#define PB_ICR_P10_Pos                        20                                                      /*!< PB ICR: P10 Position                    */
#define PB_ICR_P10_Msk                        (0x03UL << PB_ICR_P10_Pos)                              /*!< PB ICR: P10 Mask                        */
#define PB_ICR_P11_Pos                        22                                                      /*!< PB ICR: P11 Position                    */
#define PB_ICR_P11_Msk                        (0x03UL << PB_ICR_P11_Pos)                              /*!< PB ICR: P11 Mask                        */
#define PB_ICR_P12_Pos                        24                                                      /*!< PB ICR: P12 Position                    */
#define PB_ICR_P12_Msk                        (0x03UL << PB_ICR_P12_Pos)                              /*!< PB ICR: P12 Mask                        */
#define PB_ICR_P13_Pos                        26                                                      /*!< PB ICR: P13 Position                    */
#define PB_ICR_P13_Msk                        (0x03UL << PB_ICR_P13_Pos)                              /*!< PB ICR: P13 Mask                        */
#define PB_ICR_P14_Pos                        28                                                      /*!< PB ICR: P14 Position                    */
#define PB_ICR_P14_Msk                        (0x03UL << PB_ICR_P14_Pos)                              /*!< PB ICR: P14 Mask                        */
#define PB_ICR_P15_Pos                        30                                                      /*!< PB ICR: P15 Position                    */
#define PB_ICR_P15_Msk                        (0x03UL << PB_ICR_P15_Pos)                              /*!< PB ICR: P15 Mask                        */

/* -----------------------------------  PB_STR  ----------------------------------- */
#define PB_STR_P0_Pos                         0                                                       /*!< PB STR: P0 Position                     */
#define PB_STR_P0_Msk                         (0x03UL << PB_STR_P0_Pos)                               /*!< PB STR: P0 Mask                         */
#define PB_STR_P1_Pos                         2                                                       /*!< PB STR: P1 Position                     */
#define PB_STR_P1_Msk                         (0x03UL << PB_STR_P1_Pos)                               /*!< PB STR: P1 Mask                         */
#define PB_STR_P2_Pos                         4                                                       /*!< PB STR: P2 Position                     */
#define PB_STR_P2_Msk                         (0x03UL << PB_STR_P2_Pos)                               /*!< PB STR: P2 Mask                         */
#define PB_STR_P3_Pos                         6                                                       /*!< PB STR: P3 Position                     */
#define PB_STR_P3_Msk                         (0x03UL << PB_STR_P3_Pos)                               /*!< PB STR: P3 Mask                         */
#define PB_STR_P4_Pos                         8                                                       /*!< PB STR: P4 Position                     */
#define PB_STR_P4_Msk                         (0x03UL << PB_STR_P4_Pos)                               /*!< PB STR: P4 Mask                         */


/* ================================================================================ */
/* ================           struct 'PC' Position & Mask          ================ */
/* ================================================================================ */


/* -----------------------------------  PC_MOD  ----------------------------------- */
#define PC_MOD_MODE0_Pos                      0                                                       /*!< PC MOD: MODE0 Position                  */
#define PC_MOD_MODE0_Msk                      (0x03UL << PC_MOD_MODE0_Pos)                            /*!< PC MOD: MODE0 Mask                      */
#define PC_MOD_MODE1_Pos                      2                                                       /*!< PC MOD: MODE1 Position                  */
#define PC_MOD_MODE1_Msk                      (0x03UL << PC_MOD_MODE1_Pos)                            /*!< PC MOD: MODE1 Mask                      */
#define PC_MOD_MODE2_Pos                      4                                                       /*!< PC MOD: MODE2 Position                  */
#define PC_MOD_MODE2_Msk                      (0x03UL << PC_MOD_MODE2_Pos)                            /*!< PC MOD: MODE2 Mask                      */
#define PC_MOD_MODE3_Pos                      6                                                       /*!< PC MOD: MODE3 Position                  */
#define PC_MOD_MODE3_Msk                      (0x03UL << PC_MOD_MODE3_Pos)                            /*!< PC MOD: MODE3 Mask                      */
#define PC_MOD_MODE4_Pos                      8                                                       /*!< PC MOD: MODE4 Position                  */
#define PC_MOD_MODE4_Msk                      (0x03UL << PC_MOD_MODE4_Pos)                            /*!< PC MOD: MODE4 Mask                      */
#define PC_MOD_MODE5_Pos                      10                                                      /*!< PC MOD: MODE5 Position                  */
#define PC_MOD_MODE5_Msk                      (0x03UL << PC_MOD_MODE5_Pos)                            /*!< PC MOD: MODE5 Mask                      */
#define PC_MOD_MODE6_Pos                      12                                                      /*!< PC MOD: MODE6 Position                  */
#define PC_MOD_MODE6_Msk                      (0x03UL << PC_MOD_MODE6_Pos)                            /*!< PC MOD: MODE6 Mask                      */
#define PC_MOD_MODE7_Pos                      14                                                      /*!< PC MOD: MODE7 Position                  */
#define PC_MOD_MODE7_Msk                      (0x03UL << PC_MOD_MODE7_Pos)                            /*!< PC MOD: MODE7 Mask                      */
#define PC_MOD_MODE8_Pos                      16                                                      /*!< PC MOD: MODE8 Position                  */
#define PC_MOD_MODE8_Msk                      (0x03UL << PC_MOD_MODE8_Pos)                            /*!< PC MOD: MODE8 Mask                      */
#define PC_MOD_MODE9_Pos                      18                                                      /*!< PC MOD: MODE9 Position                  */
#define PC_MOD_MODE9_Msk                      (0x03UL << PC_MOD_MODE9_Pos)                            /*!< PC MOD: MODE9 Mask                      */
#define PC_MOD_MODE10_Pos                     20                                                      /*!< PC MOD: MODE10 Position                 */
#define PC_MOD_MODE10_Msk                     (0x03UL << PC_MOD_MODE10_Pos)                           /*!< PC MOD: MODE10 Mask                     */
#define PC_MOD_MODE11_Pos                     22                                                      /*!< PC MOD: MODE11 Position                 */
#define PC_MOD_MODE11_Msk                     (0x03UL << PC_MOD_MODE11_Pos)                           /*!< PC MOD: MODE11 Mask                     */
#define PC_MOD_MODE12_Pos                     24                                                      /*!< PC MOD: MODE12 Position                 */
#define PC_MOD_MODE12_Msk                     (0x03UL << PC_MOD_MODE12_Pos)                           /*!< PC MOD: MODE12 Mask                     */
#define PC_MOD_MODE13_Pos                     26                                                      /*!< PC MOD: MODE13 Position                 */
#define PC_MOD_MODE13_Msk                     (0x03UL << PC_MOD_MODE13_Pos)                           /*!< PC MOD: MODE13 Mask                     */
#define PC_MOD_MODE14_Pos                     28                                                      /*!< PC MOD: MODE14 Position                 */
#define PC_MOD_MODE14_Msk                     (0x03UL << PC_MOD_MODE14_Pos)                           /*!< PC MOD: MODE14 Mask                     */
#define PC_MOD_MODE15_Pos                     30                                                      /*!< PC MOD: MODE15 Position                 */
#define PC_MOD_MODE15_Msk                     (0x03UL << PC_MOD_MODE15_Pos)                           /*!< PC MOD: MODE15 Mask                     */

/* -----------------------------------  PC_TYP  ----------------------------------- */
#define PC_TYP_TYP0_Pos                       0                                                       /*!< PC TYP: TYP0 Position                   */
#define PC_TYP_TYP0_Msk                       (0x01UL << PC_TYP_TYP0_Pos)                             /*!< PC TYP: TYP0 Mask                       */
#define PC_TYP_TYP1_Pos                       1                                                       /*!< PC TYP: TYP1 Position                   */
#define PC_TYP_TYP1_Msk                       (0x01UL << PC_TYP_TYP1_Pos)                             /*!< PC TYP: TYP1 Mask                       */
#define PC_TYP_TYP2_Pos                       2                                                       /*!< PC TYP: TYP2 Position                   */
#define PC_TYP_TYP2_Msk                       (0x01UL << PC_TYP_TYP2_Pos)                             /*!< PC TYP: TYP2 Mask                       */
#define PC_TYP_TYP3_Pos                       3                                                       /*!< PC TYP: TYP3 Position                   */
#define PC_TYP_TYP3_Msk                       (0x01UL << PC_TYP_TYP3_Pos)                             /*!< PC TYP: TYP3 Mask                       */
#define PC_TYP_TYP4_Pos                       4                                                       /*!< PC TYP: TYP4 Position                   */
#define PC_TYP_TYP4_Msk                       (0x01UL << PC_TYP_TYP4_Pos)                             /*!< PC TYP: TYP4 Mask                       */
#define PC_TYP_TYP5_Pos                       5                                                       /*!< PC TYP: TYP5 Position                   */
#define PC_TYP_TYP5_Msk                       (0x01UL << PC_TYP_TYP5_Pos)                             /*!< PC TYP: TYP5 Mask                       */
#define PC_TYP_TYP6_Pos                       6                                                       /*!< PC TYP: TYP6 Position                   */
#define PC_TYP_TYP6_Msk                       (0x01UL << PC_TYP_TYP6_Pos)                             /*!< PC TYP: TYP6 Mask                       */
#define PC_TYP_TYP7_Pos                       7                                                       /*!< PC TYP: TYP7 Position                   */
#define PC_TYP_TYP7_Msk                       (0x01UL << PC_TYP_TYP7_Pos)                             /*!< PC TYP: TYP7 Mask                       */
#define PC_TYP_TYP8_Pos                       8                                                       /*!< PC TYP: TYP8 Position                   */
#define PC_TYP_TYP8_Msk                       (0x01UL << PC_TYP_TYP8_Pos)                             /*!< PC TYP: TYP8 Mask                       */
#define PC_TYP_TYP9_Pos                       9                                                       /*!< PC TYP: TYP9 Position                   */
#define PC_TYP_TYP9_Msk                       (0x01UL << PC_TYP_TYP9_Pos)                             /*!< PC TYP: TYP9 Mask                       */
#define PC_TYP_TYP10_Pos                      10                                                      /*!< PC TYP: TYP10 Position                  */
#define PC_TYP_TYP10_Msk                      (0x01UL << PC_TYP_TYP10_Pos)                            /*!< PC TYP: TYP10 Mask                      */
#define PC_TYP_TYP11_Pos                      11                                                      /*!< PC TYP: TYP11 Position                  */
#define PC_TYP_TYP11_Msk                      (0x01UL << PC_TYP_TYP11_Pos)                            /*!< PC TYP: TYP11 Mask                      */
#define PC_TYP_TYP12_Pos                      12                                                      /*!< PC TYP: TYP12 Position                  */
#define PC_TYP_TYP12_Msk                      (0x01UL << PC_TYP_TYP12_Pos)                            /*!< PC TYP: TYP12 Mask                      */
#define PC_TYP_TYP13_Pos                      13                                                      /*!< PC TYP: TYP13 Position                  */
#define PC_TYP_TYP13_Msk                      (0x01UL << PC_TYP_TYP13_Pos)                            /*!< PC TYP: TYP13 Mask                      */
#define PC_TYP_TYP14_Pos                      14                                                      /*!< PC TYP: TYP14 Position                  */
#define PC_TYP_TYP14_Msk                      (0x01UL << PC_TYP_TYP14_Pos)                            /*!< PC TYP: TYP14 Mask                      */
#define PC_TYP_TYP15_Pos                      15                                                      /*!< PC TYP: TYP15 Position                  */
#define PC_TYP_TYP15_Msk                      (0x01UL << PC_TYP_TYP15_Pos)                            /*!< PC TYP: TYP15 Mask                      */

/* ----------------------------------  PC_AFSR1  ---------------------------------- */
#define PC_AFSR1_AFSR0_Pos                    0                                                       /*!< PC AFSR1: AFSR0 Position                */
#define PC_AFSR1_AFSR0_Msk                    (0x0fUL << PC_AFSR1_AFSR0_Pos)                          /*!< PC AFSR1: AFSR0 Mask                    */
#define PC_AFSR1_AFSR1_Pos                    4                                                       /*!< PC AFSR1: AFSR1 Position                */
#define PC_AFSR1_AFSR1_Msk                    (0x0fUL << PC_AFSR1_AFSR1_Pos)                          /*!< PC AFSR1: AFSR1 Mask                    */
#define PC_AFSR1_AFSR2_Pos                    8                                                       /*!< PC AFSR1: AFSR2 Position                */
#define PC_AFSR1_AFSR2_Msk                    (0x0fUL << PC_AFSR1_AFSR2_Pos)                          /*!< PC AFSR1: AFSR2 Mask                    */
#define PC_AFSR1_AFSR3_Pos                    12                                                      /*!< PC AFSR1: AFSR3 Position                */
#define PC_AFSR1_AFSR3_Msk                    (0x0fUL << PC_AFSR1_AFSR3_Pos)                          /*!< PC AFSR1: AFSR3 Mask                    */
#define PC_AFSR1_AFSR4_Pos                    16                                                      /*!< PC AFSR1: AFSR4 Position                */
#define PC_AFSR1_AFSR4_Msk                    (0x0fUL << PC_AFSR1_AFSR4_Pos)                          /*!< PC AFSR1: AFSR4 Mask                    */
#define PC_AFSR1_AFSR5_Pos                    20                                                      /*!< PC AFSR1: AFSR5 Position                */
#define PC_AFSR1_AFSR5_Msk                    (0x0fUL << PC_AFSR1_AFSR5_Pos)                          /*!< PC AFSR1: AFSR5 Mask                    */
#define PC_AFSR1_AFSR6_Pos                    24                                                      /*!< PC AFSR1: AFSR6 Position                */
#define PC_AFSR1_AFSR6_Msk                    (0x0fUL << PC_AFSR1_AFSR6_Pos)                          /*!< PC AFSR1: AFSR6 Mask                    */
#define PC_AFSR1_AFSR7_Pos                    28                                                      /*!< PC AFSR1: AFSR7 Position                */
#define PC_AFSR1_AFSR7_Msk                    (0x0fUL << PC_AFSR1_AFSR7_Pos)                          /*!< PC AFSR1: AFSR7 Mask                    */

/* ----------------------------------  PC_AFSR2  ---------------------------------- */
#define PC_AFSR2_AFSR8_Pos                    0                                                       /*!< PC AFSR2: AFSR8 Position                */
#define PC_AFSR2_AFSR8_Msk                    (0x0fUL << PC_AFSR2_AFSR8_Pos)                          /*!< PC AFSR2: AFSR8 Mask                    */
#define PC_AFSR2_AFSR9_Pos                    4                                                       /*!< PC AFSR2: AFSR9 Position                */
#define PC_AFSR2_AFSR9_Msk                    (0x0fUL << PC_AFSR2_AFSR9_Pos)                          /*!< PC AFSR2: AFSR9 Mask                    */
#define PC_AFSR2_AFSR10_Pos                   8                                                       /*!< PC AFSR2: AFSR10 Position               */
#define PC_AFSR2_AFSR10_Msk                   (0x0fUL << PC_AFSR2_AFSR10_Pos)                         /*!< PC AFSR2: AFSR10 Mask                   */
#define PC_AFSR2_AFSR11_Pos                   12                                                      /*!< PC AFSR2: AFSR11 Position               */
#define PC_AFSR2_AFSR11_Msk                   (0x0fUL << PC_AFSR2_AFSR11_Pos)                         /*!< PC AFSR2: AFSR11 Mask                   */
#define PC_AFSR2_AFSR12_Pos                   16                                                      /*!< PC AFSR2: AFSR12 Position               */
#define PC_AFSR2_AFSR12_Msk                   (0x0fUL << PC_AFSR2_AFSR12_Pos)                         /*!< PC AFSR2: AFSR12 Mask                   */
#define PC_AFSR2_AFSR13_Pos                   20                                                      /*!< PC AFSR2: AFSR13 Position               */
#define PC_AFSR2_AFSR13_Msk                   (0x0fUL << PC_AFSR2_AFSR13_Pos)                         /*!< PC AFSR2: AFSR13 Mask                   */
#define PC_AFSR2_AFSR14_Pos                   24                                                      /*!< PC AFSR2: AFSR14 Position               */
#define PC_AFSR2_AFSR14_Msk                   (0x0fUL << PC_AFSR2_AFSR14_Pos)                         /*!< PC AFSR2: AFSR14 Mask                   */
#define PC_AFSR2_AFSR15_Pos                   28                                                      /*!< PC AFSR2: AFSR15 Position               */
#define PC_AFSR2_AFSR15_Msk                   (0x0fUL << PC_AFSR2_AFSR15_Pos)                         /*!< PC AFSR2: AFSR15 Mask                   */

/* -----------------------------------  PC_PUPD  ---------------------------------- */
#define PC_PUPD_PUPD0_Pos                     0                                                       /*!< PC PUPD: PUPD0 Position                 */
#define PC_PUPD_PUPD0_Msk                     (0x03UL << PC_PUPD_PUPD0_Pos)                           /*!< PC PUPD: PUPD0 Mask                     */
#define PC_PUPD_PUPD1_Pos                     2                                                       /*!< PC PUPD: PUPD1 Position                 */
#define PC_PUPD_PUPD1_Msk                     (0x03UL << PC_PUPD_PUPD1_Pos)                           /*!< PC PUPD: PUPD1 Mask                     */
#define PC_PUPD_PUPD2_Pos                     4                                                       /*!< PC PUPD: PUPD2 Position                 */
#define PC_PUPD_PUPD2_Msk                     (0x03UL << PC_PUPD_PUPD2_Pos)                           /*!< PC PUPD: PUPD2 Mask                     */
#define PC_PUPD_PUPD3_Pos                     6                                                       /*!< PC PUPD: PUPD3 Position                 */
#define PC_PUPD_PUPD3_Msk                     (0x03UL << PC_PUPD_PUPD3_Pos)                           /*!< PC PUPD: PUPD3 Mask                     */
#define PC_PUPD_PUPD4_Pos                     8                                                       /*!< PC PUPD: PUPD4 Position                 */
#define PC_PUPD_PUPD4_Msk                     (0x03UL << PC_PUPD_PUPD4_Pos)                           /*!< PC PUPD: PUPD4 Mask                     */
#define PC_PUPD_PUPD5_Pos                     10                                                      /*!< PC PUPD: PUPD5 Position                 */
#define PC_PUPD_PUPD5_Msk                     (0x03UL << PC_PUPD_PUPD5_Pos)                           /*!< PC PUPD: PUPD5 Mask                     */
#define PC_PUPD_PUPD6_Pos                     12                                                      /*!< PC PUPD: PUPD6 Position                 */
#define PC_PUPD_PUPD6_Msk                     (0x03UL << PC_PUPD_PUPD6_Pos)                           /*!< PC PUPD: PUPD6 Mask                     */
#define PC_PUPD_PUPD7_Pos                     14                                                      /*!< PC PUPD: PUPD7 Position                 */
#define PC_PUPD_PUPD7_Msk                     (0x03UL << PC_PUPD_PUPD7_Pos)                           /*!< PC PUPD: PUPD7 Mask                     */
#define PC_PUPD_PUPD8_Pos                     16                                                      /*!< PC PUPD: PUPD8 Position                 */
#define PC_PUPD_PUPD8_Msk                     (0x03UL << PC_PUPD_PUPD8_Pos)                           /*!< PC PUPD: PUPD8 Mask                     */
#define PC_PUPD_PUPD9_Pos                     18                                                      /*!< PC PUPD: PUPD9 Position                 */
#define PC_PUPD_PUPD9_Msk                     (0x03UL << PC_PUPD_PUPD9_Pos)                           /*!< PC PUPD: PUPD9 Mask                     */
#define PC_PUPD_PUPD10_Pos                    20                                                      /*!< PC PUPD: PUPD10 Position                */
#define PC_PUPD_PUPD10_Msk                    (0x03UL << PC_PUPD_PUPD10_Pos)                          /*!< PC PUPD: PUPD10 Mask                    */
#define PC_PUPD_PUPD11_Pos                    22                                                      /*!< PC PUPD: PUPD11 Position                */
#define PC_PUPD_PUPD11_Msk                    (0x03UL << PC_PUPD_PUPD11_Pos)                          /*!< PC PUPD: PUPD11 Mask                    */
#define PC_PUPD_PUPD12_Pos                    24                                                      /*!< PC PUPD: PUPD12 Position                */
#define PC_PUPD_PUPD12_Msk                    (0x03UL << PC_PUPD_PUPD12_Pos)                          /*!< PC PUPD: PUPD12 Mask                    */
#define PC_PUPD_PUPD13_Pos                    26                                                      /*!< PC PUPD: PUPD13 Position                */
#define PC_PUPD_PUPD13_Msk                    (0x03UL << PC_PUPD_PUPD13_Pos)                          /*!< PC PUPD: PUPD13 Mask                    */
#define PC_PUPD_PUPD14_Pos                    28                                                      /*!< PC PUPD: PUPD14 Position                */
#define PC_PUPD_PUPD14_Msk                    (0x03UL << PC_PUPD_PUPD14_Pos)                          /*!< PC PUPD: PUPD14 Mask                    */
#define PC_PUPD_PUPD15_Pos                    30                                                      /*!< PC PUPD: PUPD15 Position                */
#define PC_PUPD_PUPD15_Msk                    (0x03UL << PC_PUPD_PUPD15_Pos)                          /*!< PC PUPD: PUPD15 Mask                    */

/* -----------------------------------  PC_INDR  ---------------------------------- */
#define PC_INDR_INDR0_Pos                     0                                                       /*!< PC INDR: INDR0 Position                 */
#define PC_INDR_INDR0_Msk                     (0x01UL << PC_INDR_INDR0_Pos)                           /*!< PC INDR: INDR0 Mask                     */
#define PC_INDR_INDR1_Pos                     1                                                       /*!< PC INDR: INDR1 Position                 */
#define PC_INDR_INDR1_Msk                     (0x01UL << PC_INDR_INDR1_Pos)                           /*!< PC INDR: INDR1 Mask                     */
#define PC_INDR_INDR2_Pos                     2                                                       /*!< PC INDR: INDR2 Position                 */
#define PC_INDR_INDR2_Msk                     (0x01UL << PC_INDR_INDR2_Pos)                           /*!< PC INDR: INDR2 Mask                     */
#define PC_INDR_INDR3_Pos                     3                                                       /*!< PC INDR: INDR3 Position                 */
#define PC_INDR_INDR3_Msk                     (0x01UL << PC_INDR_INDR3_Pos)                           /*!< PC INDR: INDR3 Mask                     */
#define PC_INDR_INDR4_Pos                     4                                                       /*!< PC INDR: INDR4 Position                 */
#define PC_INDR_INDR4_Msk                     (0x01UL << PC_INDR_INDR4_Pos)                           /*!< PC INDR: INDR4 Mask                     */
#define PC_INDR_INDR5_Pos                     5                                                       /*!< PC INDR: INDR5 Position                 */
#define PC_INDR_INDR5_Msk                     (0x01UL << PC_INDR_INDR5_Pos)                           /*!< PC INDR: INDR5 Mask                     */
#define PC_INDR_INDR6_Pos                     6                                                       /*!< PC INDR: INDR6 Position                 */
#define PC_INDR_INDR6_Msk                     (0x01UL << PC_INDR_INDR6_Pos)                           /*!< PC INDR: INDR6 Mask                     */
#define PC_INDR_INDR7_Pos                     7                                                       /*!< PC INDR: INDR7 Position                 */
#define PC_INDR_INDR7_Msk                     (0x01UL << PC_INDR_INDR7_Pos)                           /*!< PC INDR: INDR7 Mask                     */
#define PC_INDR_INDR8_Pos                     8                                                       /*!< PC INDR: INDR8 Position                 */
#define PC_INDR_INDR8_Msk                     (0x01UL << PC_INDR_INDR8_Pos)                           /*!< PC INDR: INDR8 Mask                     */
#define PC_INDR_INDR9_Pos                     9                                                       /*!< PC INDR: INDR9 Position                 */
#define PC_INDR_INDR9_Msk                     (0x01UL << PC_INDR_INDR9_Pos)                           /*!< PC INDR: INDR9 Mask                     */
#define PC_INDR_INDR10_Pos                    10                                                      /*!< PC INDR: INDR10 Position                */
#define PC_INDR_INDR10_Msk                    (0x01UL << PC_INDR_INDR10_Pos)                          /*!< PC INDR: INDR10 Mask                    */
#define PC_INDR_INDR11_Pos                    11                                                      /*!< PC INDR: INDR11 Position                */
#define PC_INDR_INDR11_Msk                    (0x01UL << PC_INDR_INDR11_Pos)                          /*!< PC INDR: INDR11 Mask                    */
#define PC_INDR_INDR12_Pos                    12                                                      /*!< PC INDR: INDR12 Position                */
#define PC_INDR_INDR12_Msk                    (0x01UL << PC_INDR_INDR12_Pos)                          /*!< PC INDR: INDR12 Mask                    */
#define PC_INDR_INDR13_Pos                    13                                                      /*!< PC INDR: INDR13 Position                */
#define PC_INDR_INDR13_Msk                    (0x01UL << PC_INDR_INDR13_Pos)                          /*!< PC INDR: INDR13 Mask                    */
#define PC_INDR_INDR14_Pos                    14                                                      /*!< PC INDR: INDR14 Position                */
#define PC_INDR_INDR14_Msk                    (0x01UL << PC_INDR_INDR14_Pos)                          /*!< PC INDR: INDR14 Mask                    */
#define PC_INDR_INDR15_Pos                    15                                                      /*!< PC INDR: INDR15 Position                */
#define PC_INDR_INDR15_Msk                    (0x01UL << PC_INDR_INDR15_Pos)                          /*!< PC INDR: INDR15 Mask                    */

/* ----------------------------------  PC_OUTDR  ---------------------------------- */
#define PC_OUTDR_OUTDR0_Pos                   0                                                       /*!< PC OUTDR: OUTDR0 Position               */
#define PC_OUTDR_OUTDR0_Msk                   (0x01UL << PC_OUTDR_OUTDR0_Pos)                         /*!< PC OUTDR: OUTDR0 Mask                   */
#define PC_OUTDR_OUTDR1_Pos                   1                                                       /*!< PC OUTDR: OUTDR1 Position               */
#define PC_OUTDR_OUTDR1_Msk                   (0x01UL << PC_OUTDR_OUTDR1_Pos)                         /*!< PC OUTDR: OUTDR1 Mask                   */
#define PC_OUTDR_OUTDR2_Pos                   2                                                       /*!< PC OUTDR: OUTDR2 Position               */
#define PC_OUTDR_OUTDR2_Msk                   (0x01UL << PC_OUTDR_OUTDR2_Pos)                         /*!< PC OUTDR: OUTDR2 Mask                   */
#define PC_OUTDR_OUTDR3_Pos                   3                                                       /*!< PC OUTDR: OUTDR3 Position               */
#define PC_OUTDR_OUTDR3_Msk                   (0x01UL << PC_OUTDR_OUTDR3_Pos)                         /*!< PC OUTDR: OUTDR3 Mask                   */
#define PC_OUTDR_OUTDR4_Pos                   4                                                       /*!< PC OUTDR: OUTDR4 Position               */
#define PC_OUTDR_OUTDR4_Msk                   (0x01UL << PC_OUTDR_OUTDR4_Pos)                         /*!< PC OUTDR: OUTDR4 Mask                   */
#define PC_OUTDR_OUTDR5_Pos                   5                                                       /*!< PC OUTDR: OUTDR5 Position               */
#define PC_OUTDR_OUTDR5_Msk                   (0x01UL << PC_OUTDR_OUTDR5_Pos)                         /*!< PC OUTDR: OUTDR5 Mask                   */
#define PC_OUTDR_OUTDR6_Pos                   6                                                       /*!< PC OUTDR: OUTDR6 Position               */
#define PC_OUTDR_OUTDR6_Msk                   (0x01UL << PC_OUTDR_OUTDR6_Pos)                         /*!< PC OUTDR: OUTDR6 Mask                   */
#define PC_OUTDR_OUTDR7_Pos                   7                                                       /*!< PC OUTDR: OUTDR7 Position               */
#define PC_OUTDR_OUTDR7_Msk                   (0x01UL << PC_OUTDR_OUTDR7_Pos)                         /*!< PC OUTDR: OUTDR7 Mask                   */
#define PC_OUTDR_OUTDR8_Pos                   8                                                       /*!< PC OUTDR: OUTDR8 Position               */
#define PC_OUTDR_OUTDR8_Msk                   (0x01UL << PC_OUTDR_OUTDR8_Pos)                         /*!< PC OUTDR: OUTDR8 Mask                   */
#define PC_OUTDR_OUTDR9_Pos                   9                                                       /*!< PC OUTDR: OUTDR9 Position               */
#define PC_OUTDR_OUTDR9_Msk                   (0x01UL << PC_OUTDR_OUTDR9_Pos)                         /*!< PC OUTDR: OUTDR9 Mask                   */
#define PC_OUTDR_OUTDR10_Pos                  10                                                      /*!< PC OUTDR: OUTDR10 Position              */
#define PC_OUTDR_OUTDR10_Msk                  (0x01UL << PC_OUTDR_OUTDR10_Pos)                        /*!< PC OUTDR: OUTDR10 Mask                  */
#define PC_OUTDR_OUTDR11_Pos                  11                                                      /*!< PC OUTDR: OUTDR11 Position              */
#define PC_OUTDR_OUTDR11_Msk                  (0x01UL << PC_OUTDR_OUTDR11_Pos)                        /*!< PC OUTDR: OUTDR11 Mask                  */
#define PC_OUTDR_OUTDR12_Pos                  12                                                      /*!< PC OUTDR: OUTDR12 Position              */
#define PC_OUTDR_OUTDR12_Msk                  (0x01UL << PC_OUTDR_OUTDR12_Pos)                        /*!< PC OUTDR: OUTDR12 Mask                  */
#define PC_OUTDR_OUTDR13_Pos                  13                                                      /*!< PC OUTDR: OUTDR13 Position              */
#define PC_OUTDR_OUTDR13_Msk                  (0x01UL << PC_OUTDR_OUTDR13_Pos)                        /*!< PC OUTDR: OUTDR13 Mask                  */
#define PC_OUTDR_OUTDR14_Pos                  14                                                      /*!< PC OUTDR: OUTDR14 Position              */
#define PC_OUTDR_OUTDR14_Msk                  (0x01UL << PC_OUTDR_OUTDR14_Pos)                        /*!< PC OUTDR: OUTDR14 Mask                  */
#define PC_OUTDR_OUTDR15_Pos                  15                                                      /*!< PC OUTDR: OUTDR15 Position              */
#define PC_OUTDR_OUTDR15_Msk                  (0x01UL << PC_OUTDR_OUTDR15_Pos)                        /*!< PC OUTDR: OUTDR15 Mask                  */

/* -----------------------------------  PC_BSR  ----------------------------------- */
#define PC_BSR_BSR0_Pos                       0                                                       /*!< PC BSR: BSR0 Position                   */
#define PC_BSR_BSR0_Msk                       (0x01UL << PC_BSR_BSR0_Pos)                             /*!< PC BSR: BSR0 Mask                       */
#define PC_BSR_BSR1_Pos                       1                                                       /*!< PC BSR: BSR1 Position                   */
#define PC_BSR_BSR1_Msk                       (0x01UL << PC_BSR_BSR1_Pos)                             /*!< PC BSR: BSR1 Mask                       */
#define PC_BSR_BSR2_Pos                       2                                                       /*!< PC BSR: BSR2 Position                   */
#define PC_BSR_BSR2_Msk                       (0x01UL << PC_BSR_BSR2_Pos)                             /*!< PC BSR: BSR2 Mask                       */
#define PC_BSR_BSR3_Pos                       3                                                       /*!< PC BSR: BSR3 Position                   */
#define PC_BSR_BSR3_Msk                       (0x01UL << PC_BSR_BSR3_Pos)                             /*!< PC BSR: BSR3 Mask                       */
#define PC_BSR_BSR4_Pos                       4                                                       /*!< PC BSR: BSR4 Position                   */
#define PC_BSR_BSR4_Msk                       (0x01UL << PC_BSR_BSR4_Pos)                             /*!< PC BSR: BSR4 Mask                       */
#define PC_BSR_BSR5_Pos                       5                                                       /*!< PC BSR: BSR5 Position                   */
#define PC_BSR_BSR5_Msk                       (0x01UL << PC_BSR_BSR5_Pos)                             /*!< PC BSR: BSR5 Mask                       */
#define PC_BSR_BSR6_Pos                       6                                                       /*!< PC BSR: BSR6 Position                   */
#define PC_BSR_BSR6_Msk                       (0x01UL << PC_BSR_BSR6_Pos)                             /*!< PC BSR: BSR6 Mask                       */
#define PC_BSR_BSR7_Pos                       7                                                       /*!< PC BSR: BSR7 Position                   */
#define PC_BSR_BSR7_Msk                       (0x01UL << PC_BSR_BSR7_Pos)                             /*!< PC BSR: BSR7 Mask                       */
#define PC_BSR_BSR8_Pos                       8                                                       /*!< PC BSR: BSR8 Position                   */
#define PC_BSR_BSR8_Msk                       (0x01UL << PC_BSR_BSR8_Pos)                             /*!< PC BSR: BSR8 Mask                       */
#define PC_BSR_BSR9_Pos                       9                                                       /*!< PC BSR: BSR9 Position                   */
#define PC_BSR_BSR9_Msk                       (0x01UL << PC_BSR_BSR9_Pos)                             /*!< PC BSR: BSR9 Mask                       */
#define PC_BSR_BSR10_Pos                      10                                                      /*!< PC BSR: BSR10 Position                  */
#define PC_BSR_BSR10_Msk                      (0x01UL << PC_BSR_BSR10_Pos)                            /*!< PC BSR: BSR10 Mask                      */
#define PC_BSR_BSR11_Pos                      11                                                      /*!< PC BSR: BSR11 Position                  */
#define PC_BSR_BSR11_Msk                      (0x01UL << PC_BSR_BSR11_Pos)                            /*!< PC BSR: BSR11 Mask                      */
#define PC_BSR_BSR12_Pos                      12                                                      /*!< PC BSR: BSR12 Position                  */
#define PC_BSR_BSR12_Msk                      (0x01UL << PC_BSR_BSR12_Pos)                            /*!< PC BSR: BSR12 Mask                      */
#define PC_BSR_BSR13_Pos                      13                                                      /*!< PC BSR: BSR13 Position                  */
#define PC_BSR_BSR13_Msk                      (0x01UL << PC_BSR_BSR13_Pos)                            /*!< PC BSR: BSR13 Mask                      */
#define PC_BSR_BSR14_Pos                      14                                                      /*!< PC BSR: BSR14 Position                  */
#define PC_BSR_BSR14_Msk                      (0x01UL << PC_BSR_BSR14_Pos)                            /*!< PC BSR: BSR14 Mask                      */
#define PC_BSR_BSR15_Pos                      15                                                      /*!< PC BSR: BSR15 Position                  */
#define PC_BSR_BSR15_Msk                      (0x01UL << PC_BSR_BSR15_Pos)                            /*!< PC BSR: BSR15 Mask                      */

/* -----------------------------------  PC_BCR  ----------------------------------- */
#define PC_BCR_BCR0_Pos                       0                                                       /*!< PC BCR: BCR0 Position                   */
#define PC_BCR_BCR0_Msk                       (0x01UL << PC_BCR_BCR0_Pos)                             /*!< PC BCR: BCR0 Mask                       */
#define PC_BCR_BCR1_Pos                       1                                                       /*!< PC BCR: BCR1 Position                   */
#define PC_BCR_BCR1_Msk                       (0x01UL << PC_BCR_BCR1_Pos)                             /*!< PC BCR: BCR1 Mask                       */
#define PC_BCR_BCR2_Pos                       2                                                       /*!< PC BCR: BCR2 Position                   */
#define PC_BCR_BCR2_Msk                       (0x01UL << PC_BCR_BCR2_Pos)                             /*!< PC BCR: BCR2 Mask                       */
#define PC_BCR_BCR3_Pos                       3                                                       /*!< PC BCR: BCR3 Position                   */
#define PC_BCR_BCR3_Msk                       (0x01UL << PC_BCR_BCR3_Pos)                             /*!< PC BCR: BCR3 Mask                       */
#define PC_BCR_BCR4_Pos                       4                                                       /*!< PC BCR: BCR4 Position                   */
#define PC_BCR_BCR4_Msk                       (0x01UL << PC_BCR_BCR4_Pos)                             /*!< PC BCR: BCR4 Mask                       */
#define PC_BCR_BCR5_Pos                       5                                                       /*!< PC BCR: BCR5 Position                   */
#define PC_BCR_BCR5_Msk                       (0x01UL << PC_BCR_BCR5_Pos)                             /*!< PC BCR: BCR5 Mask                       */
#define PC_BCR_BCR6_Pos                       6                                                       /*!< PC BCR: BCR6 Position                   */
#define PC_BCR_BCR6_Msk                       (0x01UL << PC_BCR_BCR6_Pos)                             /*!< PC BCR: BCR6 Mask                       */
#define PC_BCR_BCR7_Pos                       7                                                       /*!< PC BCR: BCR7 Position                   */
#define PC_BCR_BCR7_Msk                       (0x01UL << PC_BCR_BCR7_Pos)                             /*!< PC BCR: BCR7 Mask                       */
#define PC_BCR_BCR8_Pos                       8                                                       /*!< PC BCR: BCR8 Position                   */
#define PC_BCR_BCR8_Msk                       (0x01UL << PC_BCR_BCR8_Pos)                             /*!< PC BCR: BCR8 Mask                       */
#define PC_BCR_BCR9_Pos                       9                                                       /*!< PC BCR: BCR9 Position                   */
#define PC_BCR_BCR9_Msk                       (0x01UL << PC_BCR_BCR9_Pos)                             /*!< PC BCR: BCR9 Mask                       */
#define PC_BCR_BCR10_Pos                      10                                                      /*!< PC BCR: BCR10 Position                  */
#define PC_BCR_BCR10_Msk                      (0x01UL << PC_BCR_BCR10_Pos)                            /*!< PC BCR: BCR10 Mask                      */
#define PC_BCR_BCR11_Pos                      11                                                      /*!< PC BCR: BCR11 Position                  */
#define PC_BCR_BCR11_Msk                      (0x01UL << PC_BCR_BCR11_Pos)                            /*!< PC BCR: BCR11 Mask                      */
#define PC_BCR_BCR12_Pos                      12                                                      /*!< PC BCR: BCR12 Position                  */
#define PC_BCR_BCR12_Msk                      (0x01UL << PC_BCR_BCR12_Pos)                            /*!< PC BCR: BCR12 Mask                      */
#define PC_BCR_BCR13_Pos                      13                                                      /*!< PC BCR: BCR13 Position                  */
#define PC_BCR_BCR13_Msk                      (0x01UL << PC_BCR_BCR13_Pos)                            /*!< PC BCR: BCR13 Mask                      */
#define PC_BCR_BCR14_Pos                      14                                                      /*!< PC BCR: BCR14 Position                  */
#define PC_BCR_BCR14_Msk                      (0x01UL << PC_BCR_BCR14_Pos)                            /*!< PC BCR: BCR14 Mask                      */
#define PC_BCR_BCR15_Pos                      15                                                      /*!< PC BCR: BCR15 Position                  */
#define PC_BCR_BCR15_Msk                      (0x01UL << PC_BCR_BCR15_Pos)                            /*!< PC BCR: BCR15 Mask                      */

/* ---------------------------------  PC_OUTDMSK  --------------------------------- */
#define PC_OUTDMSK_OUTDMSK0_Pos               0                                                       /*!< PC OUTDMSK: OUTDMSK0 Position           */
#define PC_OUTDMSK_OUTDMSK0_Msk               (0x01UL << PC_OUTDMSK_OUTDMSK0_Pos)                     /*!< PC OUTDMSK: OUTDMSK0 Mask               */
#define PC_OUTDMSK_OUTDMSK1_Pos               1                                                       /*!< PC OUTDMSK: OUTDMSK1 Position           */
#define PC_OUTDMSK_OUTDMSK1_Msk               (0x01UL << PC_OUTDMSK_OUTDMSK1_Pos)                     /*!< PC OUTDMSK: OUTDMSK1 Mask               */
#define PC_OUTDMSK_OUTDMSK2_Pos               2                                                       /*!< PC OUTDMSK: OUTDMSK2 Position           */
#define PC_OUTDMSK_OUTDMSK2_Msk               (0x01UL << PC_OUTDMSK_OUTDMSK2_Pos)                     /*!< PC OUTDMSK: OUTDMSK2 Mask               */
#define PC_OUTDMSK_OUTDMSK3_Pos               3                                                       /*!< PC OUTDMSK: OUTDMSK3 Position           */
#define PC_OUTDMSK_OUTDMSK3_Msk               (0x01UL << PC_OUTDMSK_OUTDMSK3_Pos)                     /*!< PC OUTDMSK: OUTDMSK3 Mask               */
#define PC_OUTDMSK_OUTDMSK4_Pos               4                                                       /*!< PC OUTDMSK: OUTDMSK4 Position           */
#define PC_OUTDMSK_OUTDMSK4_Msk               (0x01UL << PC_OUTDMSK_OUTDMSK4_Pos)                     /*!< PC OUTDMSK: OUTDMSK4 Mask               */
#define PC_OUTDMSK_OUTDMSK5_Pos               5                                                       /*!< PC OUTDMSK: OUTDMSK5 Position           */
#define PC_OUTDMSK_OUTDMSK5_Msk               (0x01UL << PC_OUTDMSK_OUTDMSK5_Pos)                     /*!< PC OUTDMSK: OUTDMSK5 Mask               */
#define PC_OUTDMSK_OUTDMSK6_Pos               6                                                       /*!< PC OUTDMSK: OUTDMSK6 Position           */
#define PC_OUTDMSK_OUTDMSK6_Msk               (0x01UL << PC_OUTDMSK_OUTDMSK6_Pos)                     /*!< PC OUTDMSK: OUTDMSK6 Mask               */
#define PC_OUTDMSK_OUTDMSK7_Pos               7                                                       /*!< PC OUTDMSK: OUTDMSK7 Position           */
#define PC_OUTDMSK_OUTDMSK7_Msk               (0x01UL << PC_OUTDMSK_OUTDMSK7_Pos)                     /*!< PC OUTDMSK: OUTDMSK7 Mask               */
#define PC_OUTDMSK_OUTDMSK8_Pos               8                                                       /*!< PC OUTDMSK: OUTDMSK8 Position           */
#define PC_OUTDMSK_OUTDMSK8_Msk               (0x01UL << PC_OUTDMSK_OUTDMSK8_Pos)                     /*!< PC OUTDMSK: OUTDMSK8 Mask               */
#define PC_OUTDMSK_OUTDMSK9_Pos               9                                                       /*!< PC OUTDMSK: OUTDMSK9 Position           */
#define PC_OUTDMSK_OUTDMSK9_Msk               (0x01UL << PC_OUTDMSK_OUTDMSK9_Pos)                     /*!< PC OUTDMSK: OUTDMSK9 Mask               */
#define PC_OUTDMSK_OUTDMSK10_Pos              10                                                      /*!< PC OUTDMSK: OUTDMSK10 Position          */
#define PC_OUTDMSK_OUTDMSK10_Msk              (0x01UL << PC_OUTDMSK_OUTDMSK10_Pos)                    /*!< PC OUTDMSK: OUTDMSK10 Mask              */
#define PC_OUTDMSK_OUTDMSK11_Pos              11                                                      /*!< PC OUTDMSK: OUTDMSK11 Position          */
#define PC_OUTDMSK_OUTDMSK11_Msk              (0x01UL << PC_OUTDMSK_OUTDMSK11_Pos)                    /*!< PC OUTDMSK: OUTDMSK11 Mask              */
#define PC_OUTDMSK_OUTDMSK12_Pos              12                                                      /*!< PC OUTDMSK: OUTDMSK12 Position          */
#define PC_OUTDMSK_OUTDMSK12_Msk              (0x01UL << PC_OUTDMSK_OUTDMSK12_Pos)                    /*!< PC OUTDMSK: OUTDMSK12 Mask              */
#define PC_OUTDMSK_OUTDMSK13_Pos              13                                                      /*!< PC OUTDMSK: OUTDMSK13 Position          */
#define PC_OUTDMSK_OUTDMSK13_Msk              (0x01UL << PC_OUTDMSK_OUTDMSK13_Pos)                    /*!< PC OUTDMSK: OUTDMSK13 Mask              */
#define PC_OUTDMSK_OUTDMSK14_Pos              14                                                      /*!< PC OUTDMSK: OUTDMSK14 Position          */
#define PC_OUTDMSK_OUTDMSK14_Msk              (0x01UL << PC_OUTDMSK_OUTDMSK14_Pos)                    /*!< PC OUTDMSK: OUTDMSK14 Mask              */
#define PC_OUTDMSK_OUTDMSK15_Pos              15                                                      /*!< PC OUTDMSK: OUTDMSK15 Position          */
#define PC_OUTDMSK_OUTDMSK15_Msk              (0x01UL << PC_OUTDMSK_OUTDMSK15_Pos)                    /*!< PC OUTDMSK: OUTDMSK15 Mask              */

/* -----------------------------------  PC_DBCR  ---------------------------------- */
#define PC_DBCR_DBEN0_Pos                     0                                                       /*!< PC DBCR: DBEN0 Position                 */
#define PC_DBCR_DBEN0_Msk                     (0x01UL << PC_DBCR_DBEN0_Pos)                           /*!< PC DBCR: DBEN0 Mask                     */
#define PC_DBCR_DBEN1_Pos                     1                                                       /*!< PC DBCR: DBEN1 Position                 */
#define PC_DBCR_DBEN1_Msk                     (0x01UL << PC_DBCR_DBEN1_Pos)                           /*!< PC DBCR: DBEN1 Mask                     */
#define PC_DBCR_DBEN2_Pos                     2                                                       /*!< PC DBCR: DBEN2 Position                 */
#define PC_DBCR_DBEN2_Msk                     (0x01UL << PC_DBCR_DBEN2_Pos)                           /*!< PC DBCR: DBEN2 Mask                     */
#define PC_DBCR_DBEN3_Pos                     3                                                       /*!< PC DBCR: DBEN3 Position                 */
#define PC_DBCR_DBEN3_Msk                     (0x01UL << PC_DBCR_DBEN3_Pos)                           /*!< PC DBCR: DBEN3 Mask                     */
#define PC_DBCR_DBEN4_Pos                     4                                                       /*!< PC DBCR: DBEN4 Position                 */
#define PC_DBCR_DBEN4_Msk                     (0x01UL << PC_DBCR_DBEN4_Pos)                           /*!< PC DBCR: DBEN4 Mask                     */
#define PC_DBCR_DBEN5_Pos                     5                                                       /*!< PC DBCR: DBEN5 Position                 */
#define PC_DBCR_DBEN5_Msk                     (0x01UL << PC_DBCR_DBEN5_Pos)                           /*!< PC DBCR: DBEN5 Mask                     */
#define PC_DBCR_DBEN6_Pos                     6                                                       /*!< PC DBCR: DBEN6 Position                 */
#define PC_DBCR_DBEN6_Msk                     (0x01UL << PC_DBCR_DBEN6_Pos)                           /*!< PC DBCR: DBEN6 Mask                     */
#define PC_DBCR_DBEN7_Pos                     7                                                       /*!< PC DBCR: DBEN7 Position                 */
#define PC_DBCR_DBEN7_Msk                     (0x01UL << PC_DBCR_DBEN7_Pos)                           /*!< PC DBCR: DBEN7 Mask                     */
#define PC_DBCR_DBEN8_Pos                     8                                                       /*!< PC DBCR: DBEN8 Position                 */
#define PC_DBCR_DBEN8_Msk                     (0x01UL << PC_DBCR_DBEN8_Pos)                           /*!< PC DBCR: DBEN8 Mask                     */
#define PC_DBCR_DBEN9_Pos                     9                                                       /*!< PC DBCR: DBEN9 Position                 */
#define PC_DBCR_DBEN9_Msk                     (0x01UL << PC_DBCR_DBEN9_Pos)                           /*!< PC DBCR: DBEN9 Mask                     */
#define PC_DBCR_DBEN10_Pos                    10                                                      /*!< PC DBCR: DBEN10 Position                */
#define PC_DBCR_DBEN10_Msk                    (0x01UL << PC_DBCR_DBEN10_Pos)                          /*!< PC DBCR: DBEN10 Mask                    */
#define PC_DBCR_DBEN11_Pos                    11                                                      /*!< PC DBCR: DBEN11 Position                */
#define PC_DBCR_DBEN11_Msk                    (0x01UL << PC_DBCR_DBEN11_Pos)                          /*!< PC DBCR: DBEN11 Mask                    */
#define PC_DBCR_DBEN12_Pos                    12                                                      /*!< PC DBCR: DBEN12 Position                */
#define PC_DBCR_DBEN12_Msk                    (0x01UL << PC_DBCR_DBEN12_Pos)                          /*!< PC DBCR: DBEN12 Mask                    */
#define PC_DBCR_DBEN13_Pos                    13                                                      /*!< PC DBCR: DBEN13 Position                */
#define PC_DBCR_DBEN13_Msk                    (0x01UL << PC_DBCR_DBEN13_Pos)                          /*!< PC DBCR: DBEN13 Mask                    */
#define PC_DBCR_DBEN14_Pos                    14                                                      /*!< PC DBCR: DBEN14 Position                */
#define PC_DBCR_DBEN14_Msk                    (0x01UL << PC_DBCR_DBEN14_Pos)                          /*!< PC DBCR: DBEN14 Mask                    */
#define PC_DBCR_DBEN15_Pos                    15                                                      /*!< PC DBCR: DBEN15 Position                */
#define PC_DBCR_DBEN15_Msk                    (0x01UL << PC_DBCR_DBEN15_Pos)                          /*!< PC DBCR: DBEN15 Mask                    */

/* -----------------------------------  PC_IER  ----------------------------------- */
#define PC_IER_P0_Pos                         0                                                       /*!< PC IER: P0 Position                     */
#define PC_IER_P0_Msk                         (0x03UL << PC_IER_P0_Pos)                               /*!< PC IER: P0 Mask                         */
#define PC_IER_P1_Pos                         2                                                       /*!< PC IER: P1 Position                     */
#define PC_IER_P1_Msk                         (0x03UL << PC_IER_P1_Pos)                               /*!< PC IER: P1 Mask                         */
#define PC_IER_P2_Pos                         4                                                       /*!< PC IER: P2 Position                     */
#define PC_IER_P2_Msk                         (0x03UL << PC_IER_P2_Pos)                               /*!< PC IER: P2 Mask                         */
#define PC_IER_P3_Pos                         6                                                       /*!< PC IER: P3 Position                     */
#define PC_IER_P3_Msk                         (0x03UL << PC_IER_P3_Pos)                               /*!< PC IER: P3 Mask                         */
#define PC_IER_P4_Pos                         8                                                       /*!< PC IER: P4 Position                     */
#define PC_IER_P4_Msk                         (0x03UL << PC_IER_P4_Pos)                               /*!< PC IER: P4 Mask                         */
#define PC_IER_P5_Pos                         10                                                      /*!< PC IER: P5 Position                     */
#define PC_IER_P5_Msk                         (0x03UL << PC_IER_P5_Pos)                               /*!< PC IER: P5 Mask                         */
#define PC_IER_P6_Pos                         12                                                      /*!< PC IER: P6 Position                     */
#define PC_IER_P6_Msk                         (0x03UL << PC_IER_P6_Pos)                               /*!< PC IER: P6 Mask                         */
#define PC_IER_P7_Pos                         14                                                      /*!< PC IER: P7 Position                     */
#define PC_IER_P7_Msk                         (0x03UL << PC_IER_P7_Pos)                               /*!< PC IER: P7 Mask                         */
#define PC_IER_P8_Pos                         16                                                      /*!< PC IER: P8 Position                     */
#define PC_IER_P8_Msk                         (0x03UL << PC_IER_P8_Pos)                               /*!< PC IER: P8 Mask                         */
#define PC_IER_P9_Pos                         18                                                      /*!< PC IER: P9 Position                     */
#define PC_IER_P9_Msk                         (0x03UL << PC_IER_P9_Pos)                               /*!< PC IER: P9 Mask                         */
#define PC_IER_P10_Pos                        20                                                      /*!< PC IER: P10 Position                    */
#define PC_IER_P10_Msk                        (0x03UL << PC_IER_P10_Pos)                              /*!< PC IER: P10 Mask                        */
#define PC_IER_P11_Pos                        22                                                      /*!< PC IER: P11 Position                    */
#define PC_IER_P11_Msk                        (0x03UL << PC_IER_P11_Pos)                              /*!< PC IER: P11 Mask                        */
#define PC_IER_P12_Pos                        24                                                      /*!< PC IER: P12 Position                    */
#define PC_IER_P12_Msk                        (0x03UL << PC_IER_P12_Pos)                              /*!< PC IER: P12 Mask                        */
#define PC_IER_P13_Pos                        26                                                      /*!< PC IER: P13 Position                    */
#define PC_IER_P13_Msk                        (0x03UL << PC_IER_P13_Pos)                              /*!< PC IER: P13 Mask                        */
#define PC_IER_P14_Pos                        28                                                      /*!< PC IER: P14 Position                    */
#define PC_IER_P14_Msk                        (0x03UL << PC_IER_P14_Pos)                              /*!< PC IER: P14 Mask                        */
#define PC_IER_P15_Pos                        30                                                      /*!< PC IER: P15 Position                    */
#define PC_IER_P15_Msk                        (0x03UL << PC_IER_P15_Pos)                              /*!< PC IER: P15 Mask                        */

/* -----------------------------------  PC_ISR  ----------------------------------- */
#define PC_ISR_P0_Pos                         0                                                       /*!< PC ISR: P0 Position                     */
#define PC_ISR_P0_Msk                         (0x03UL << PC_ISR_P0_Pos)                               /*!< PC ISR: P0 Mask                         */
#define PC_ISR_P1_Pos                         2                                                       /*!< PC ISR: P1 Position                     */
#define PC_ISR_P1_Msk                         (0x03UL << PC_ISR_P1_Pos)                               /*!< PC ISR: P1 Mask                         */
#define PC_ISR_P2_Pos                         4                                                       /*!< PC ISR: P2 Position                     */
#define PC_ISR_P2_Msk                         (0x03UL << PC_ISR_P2_Pos)                               /*!< PC ISR: P2 Mask                         */
#define PC_ISR_P3_Pos                         6                                                       /*!< PC ISR: P3 Position                     */
#define PC_ISR_P3_Msk                         (0x03UL << PC_ISR_P3_Pos)                               /*!< PC ISR: P3 Mask                         */
#define PC_ISR_P4_Pos                         8                                                       /*!< PC ISR: P4 Position                     */
#define PC_ISR_P4_Msk                         (0x03UL << PC_ISR_P4_Pos)                               /*!< PC ISR: P4 Mask                         */
#define PC_ISR_P5_Pos                         10                                                      /*!< PC ISR: P5 Position                     */
#define PC_ISR_P5_Msk                         (0x03UL << PC_ISR_P5_Pos)                               /*!< PC ISR: P5 Mask                         */
#define PC_ISR_P6_Pos                         12                                                      /*!< PC ISR: P6 Position                     */
#define PC_ISR_P6_Msk                         (0x03UL << PC_ISR_P6_Pos)                               /*!< PC ISR: P6 Mask                         */
#define PC_ISR_P7_Pos                         14                                                      /*!< PC ISR: P7 Position                     */
#define PC_ISR_P7_Msk                         (0x03UL << PC_ISR_P7_Pos)                               /*!< PC ISR: P7 Mask                         */
#define PC_ISR_P8_Pos                         16                                                      /*!< PC ISR: P8 Position                     */
#define PC_ISR_P8_Msk                         (0x03UL << PC_ISR_P8_Pos)                               /*!< PC ISR: P8 Mask                         */
#define PC_ISR_P9_Pos                         18                                                      /*!< PC ISR: P9 Position                     */
#define PC_ISR_P9_Msk                         (0x03UL << PC_ISR_P9_Pos)                               /*!< PC ISR: P9 Mask                         */
#define PC_ISR_P10_Pos                        20                                                      /*!< PC ISR: P10 Position                    */
#define PC_ISR_P10_Msk                        (0x03UL << PC_ISR_P10_Pos)                              /*!< PC ISR: P10 Mask                        */
#define PC_ISR_P11_Pos                        22                                                      /*!< PC ISR: P11 Position                    */
#define PC_ISR_P11_Msk                        (0x03UL << PC_ISR_P11_Pos)                              /*!< PC ISR: P11 Mask                        */
#define PC_ISR_P12_Pos                        24                                                      /*!< PC ISR: P12 Position                    */
#define PC_ISR_P12_Msk                        (0x03UL << PC_ISR_P12_Pos)                              /*!< PC ISR: P12 Mask                        */
#define PC_ISR_P13_Pos                        26                                                      /*!< PC ISR: P13 Position                    */
#define PC_ISR_P13_Msk                        (0x03UL << PC_ISR_P13_Pos)                              /*!< PC ISR: P13 Mask                        */
#define PC_ISR_P14_Pos                        28                                                      /*!< PC ISR: P14 Position                    */
#define PC_ISR_P14_Msk                        (0x03UL << PC_ISR_P14_Pos)                              /*!< PC ISR: P14 Mask                        */
#define PC_ISR_P15_Pos                        30                                                      /*!< PC ISR: P15 Position                    */
#define PC_ISR_P15_Msk                        (0x03UL << PC_ISR_P15_Pos)                              /*!< PC ISR: P15 Mask                        */

/* -----------------------------------  PC_ICR  ----------------------------------- */
#define PC_ICR_P0_Pos                         0                                                       /*!< PC ICR: P0 Position                     */
#define PC_ICR_P0_Msk                         (0x03UL << PC_ICR_P0_Pos)                               /*!< PC ICR: P0 Mask                         */
#define PC_ICR_P1_Pos                         2                                                       /*!< PC ICR: P1 Position                     */
#define PC_ICR_P1_Msk                         (0x03UL << PC_ICR_P1_Pos)                               /*!< PC ICR: P1 Mask                         */
#define PC_ICR_P2_Pos                         4                                                       /*!< PC ICR: P2 Position                     */
#define PC_ICR_P2_Msk                         (0x03UL << PC_ICR_P2_Pos)                               /*!< PC ICR: P2 Mask                         */
#define PC_ICR_P3_Pos                         6                                                       /*!< PC ICR: P3 Position                     */
#define PC_ICR_P3_Msk                         (0x03UL << PC_ICR_P3_Pos)                               /*!< PC ICR: P3 Mask                         */
#define PC_ICR_P4_Pos                         8                                                       /*!< PC ICR: P4 Position                     */
#define PC_ICR_P4_Msk                         (0x03UL << PC_ICR_P4_Pos)                               /*!< PC ICR: P4 Mask                         */
#define PC_ICR_P5_Pos                         10                                                      /*!< PC ICR: P5 Position                     */
#define PC_ICR_P5_Msk                         (0x03UL << PC_ICR_P5_Pos)                               /*!< PC ICR: P5 Mask                         */
#define PC_ICR_P6_Pos                         12                                                      /*!< PC ICR: P6 Position                     */
#define PC_ICR_P6_Msk                         (0x03UL << PC_ICR_P6_Pos)                               /*!< PC ICR: P6 Mask                         */
#define PC_ICR_P7_Pos                         14                                                      /*!< PC ICR: P7 Position                     */
#define PC_ICR_P7_Msk                         (0x03UL << PC_ICR_P7_Pos)                               /*!< PC ICR: P7 Mask                         */
#define PC_ICR_P8_Pos                         16                                                      /*!< PC ICR: P8 Position                     */
#define PC_ICR_P8_Msk                         (0x03UL << PC_ICR_P8_Pos)                               /*!< PC ICR: P8 Mask                         */
#define PC_ICR_P9_Pos                         18                                                      /*!< PC ICR: P9 Position                     */
#define PC_ICR_P9_Msk                         (0x03UL << PC_ICR_P9_Pos)                               /*!< PC ICR: P9 Mask                         */
#define PC_ICR_P10_Pos                        20                                                      /*!< PC ICR: P10 Position                    */
#define PC_ICR_P10_Msk                        (0x03UL << PC_ICR_P10_Pos)                              /*!< PC ICR: P10 Mask                        */
#define PC_ICR_P11_Pos                        22                                                      /*!< PC ICR: P11 Position                    */
#define PC_ICR_P11_Msk                        (0x03UL << PC_ICR_P11_Pos)                              /*!< PC ICR: P11 Mask                        */
#define PC_ICR_P12_Pos                        24                                                      /*!< PC ICR: P12 Position                    */
#define PC_ICR_P12_Msk                        (0x03UL << PC_ICR_P12_Pos)                              /*!< PC ICR: P12 Mask                        */
#define PC_ICR_P13_Pos                        26                                                      /*!< PC ICR: P13 Position                    */
#define PC_ICR_P13_Msk                        (0x03UL << PC_ICR_P13_Pos)                              /*!< PC ICR: P13 Mask                        */
#define PC_ICR_P14_Pos                        28                                                      /*!< PC ICR: P14 Position                    */
#define PC_ICR_P14_Msk                        (0x03UL << PC_ICR_P14_Pos)                              /*!< PC ICR: P14 Mask                        */
#define PC_ICR_P15_Pos                        30                                                      /*!< PC ICR: P15 Position                    */
#define PC_ICR_P15_Msk                        (0x03UL << PC_ICR_P15_Pos)                              /*!< PC ICR: P15 Mask                        */

/* -----------------------------------  PC_STR  ----------------------------------- */
#define PC_STR_P0_Pos                         0                                                       /*!< PC STR: P0 Position                     */
#define PC_STR_P0_Msk                         (0x03UL << PC_STR_P0_Pos)                               /*!< PC STR: P0 Mask                         */
#define PC_STR_P1_Pos                         2                                                       /*!< PC STR: P1 Position                     */
#define PC_STR_P1_Msk                         (0x03UL << PC_STR_P1_Pos)                               /*!< PC STR: P1 Mask                         */
#define PC_STR_P2_Pos                         4                                                       /*!< PC STR: P2 Position                     */
#define PC_STR_P2_Msk                         (0x03UL << PC_STR_P2_Pos)                               /*!< PC STR: P2 Mask                         */
#define PC_STR_P3_Pos                         6                                                       /*!< PC STR: P3 Position                     */
#define PC_STR_P3_Msk                         (0x03UL << PC_STR_P3_Pos)                               /*!< PC STR: P3 Mask                         */
#define PC_STR_P4_Pos                         8                                                       /*!< PC STR: P4 Position                     */
#define PC_STR_P4_Msk                         (0x03UL << PC_STR_P4_Pos)                               /*!< PC STR: P4 Mask                         */


/* ================================================================================ */
/* ================           struct 'PD' Position & Mask          ================ */
/* ================================================================================ */


/* -----------------------------------  PD_MOD  ----------------------------------- */
#define PD_MOD_MODE0_Pos                      0                                                       /*!< PD MOD: MODE0 Position                  */
#define PD_MOD_MODE0_Msk                      (0x03UL << PD_MOD_MODE0_Pos)                            /*!< PD MOD: MODE0 Mask                      */
#define PD_MOD_MODE1_Pos                      2                                                       /*!< PD MOD: MODE1 Position                  */
#define PD_MOD_MODE1_Msk                      (0x03UL << PD_MOD_MODE1_Pos)                            /*!< PD MOD: MODE1 Mask                      */
#define PD_MOD_MODE2_Pos                      4                                                       /*!< PD MOD: MODE2 Position                  */
#define PD_MOD_MODE2_Msk                      (0x03UL << PD_MOD_MODE2_Pos)                            /*!< PD MOD: MODE2 Mask                      */
#define PD_MOD_MODE3_Pos                      6                                                       /*!< PD MOD: MODE3 Position                  */
#define PD_MOD_MODE3_Msk                      (0x03UL << PD_MOD_MODE3_Pos)                            /*!< PD MOD: MODE3 Mask                      */
#define PD_MOD_MODE4_Pos                      8                                                       /*!< PD MOD: MODE4 Position                  */
#define PD_MOD_MODE4_Msk                      (0x03UL << PD_MOD_MODE4_Pos)                            /*!< PD MOD: MODE4 Mask                      */
#define PD_MOD_MODE5_Pos                      10                                                      /*!< PD MOD: MODE5 Position                  */
#define PD_MOD_MODE5_Msk                      (0x03UL << PD_MOD_MODE5_Pos)                            /*!< PD MOD: MODE5 Mask                      */
#define PD_MOD_MODE6_Pos                      12                                                      /*!< PD MOD: MODE6 Position                  */
#define PD_MOD_MODE6_Msk                      (0x03UL << PD_MOD_MODE6_Pos)                            /*!< PD MOD: MODE6 Mask                      */
#define PD_MOD_MODE7_Pos                      14                                                      /*!< PD MOD: MODE7 Position                  */
#define PD_MOD_MODE7_Msk                      (0x03UL << PD_MOD_MODE7_Pos)                            /*!< PD MOD: MODE7 Mask                      */
#define PD_MOD_MODE8_Pos                      16                                                      /*!< PD MOD: MODE8 Position                  */
#define PD_MOD_MODE8_Msk                      (0x03UL << PD_MOD_MODE8_Pos)                            /*!< PD MOD: MODE8 Mask                      */
#define PD_MOD_MODE9_Pos                      18                                                      /*!< PD MOD: MODE9 Position                  */
#define PD_MOD_MODE9_Msk                      (0x03UL << PD_MOD_MODE9_Pos)                            /*!< PD MOD: MODE9 Mask                      */
#define PD_MOD_MODE10_Pos                     20                                                      /*!< PD MOD: MODE10 Position                 */
#define PD_MOD_MODE10_Msk                     (0x03UL << PD_MOD_MODE10_Pos)                           /*!< PD MOD: MODE10 Mask                     */
#define PD_MOD_MODE11_Pos                     22                                                      /*!< PD MOD: MODE11 Position                 */
#define PD_MOD_MODE11_Msk                     (0x03UL << PD_MOD_MODE11_Pos)                           /*!< PD MOD: MODE11 Mask                     */
#define PD_MOD_MODE12_Pos                     24                                                      /*!< PD MOD: MODE12 Position                 */
#define PD_MOD_MODE12_Msk                     (0x03UL << PD_MOD_MODE12_Pos)                           /*!< PD MOD: MODE12 Mask                     */
#define PD_MOD_MODE13_Pos                     26                                                      /*!< PD MOD: MODE13 Position                 */
#define PD_MOD_MODE13_Msk                     (0x03UL << PD_MOD_MODE13_Pos)                           /*!< PD MOD: MODE13 Mask                     */
#define PD_MOD_MODE14_Pos                     28                                                      /*!< PD MOD: MODE14 Position                 */
#define PD_MOD_MODE14_Msk                     (0x03UL << PD_MOD_MODE14_Pos)                           /*!< PD MOD: MODE14 Mask                     */
#define PD_MOD_MODE15_Pos                     30                                                      /*!< PD MOD: MODE15 Position                 */
#define PD_MOD_MODE15_Msk                     (0x03UL << PD_MOD_MODE15_Pos)                           /*!< PD MOD: MODE15 Mask                     */

/* -----------------------------------  PD_TYP  ----------------------------------- */
#define PD_TYP_TYP0_Pos                       0                                                       /*!< PD TYP: TYP0 Position                   */
#define PD_TYP_TYP0_Msk                       (0x01UL << PD_TYP_TYP0_Pos)                             /*!< PD TYP: TYP0 Mask                       */
#define PD_TYP_TYP1_Pos                       1                                                       /*!< PD TYP: TYP1 Position                   */
#define PD_TYP_TYP1_Msk                       (0x01UL << PD_TYP_TYP1_Pos)                             /*!< PD TYP: TYP1 Mask                       */
#define PD_TYP_TYP2_Pos                       2                                                       /*!< PD TYP: TYP2 Position                   */
#define PD_TYP_TYP2_Msk                       (0x01UL << PD_TYP_TYP2_Pos)                             /*!< PD TYP: TYP2 Mask                       */
#define PD_TYP_TYP3_Pos                       3                                                       /*!< PD TYP: TYP3 Position                   */
#define PD_TYP_TYP3_Msk                       (0x01UL << PD_TYP_TYP3_Pos)                             /*!< PD TYP: TYP3 Mask                       */
#define PD_TYP_TYP4_Pos                       4                                                       /*!< PD TYP: TYP4 Position                   */
#define PD_TYP_TYP4_Msk                       (0x01UL << PD_TYP_TYP4_Pos)                             /*!< PD TYP: TYP4 Mask                       */
#define PD_TYP_TYP5_Pos                       5                                                       /*!< PD TYP: TYP5 Position                   */
#define PD_TYP_TYP5_Msk                       (0x01UL << PD_TYP_TYP5_Pos)                             /*!< PD TYP: TYP5 Mask                       */
#define PD_TYP_TYP6_Pos                       6                                                       /*!< PD TYP: TYP6 Position                   */
#define PD_TYP_TYP6_Msk                       (0x01UL << PD_TYP_TYP6_Pos)                             /*!< PD TYP: TYP6 Mask                       */
#define PD_TYP_TYP7_Pos                       7                                                       /*!< PD TYP: TYP7 Position                   */
#define PD_TYP_TYP7_Msk                       (0x01UL << PD_TYP_TYP7_Pos)                             /*!< PD TYP: TYP7 Mask                       */
#define PD_TYP_TYP8_Pos                       8                                                       /*!< PD TYP: TYP8 Position                   */
#define PD_TYP_TYP8_Msk                       (0x01UL << PD_TYP_TYP8_Pos)                             /*!< PD TYP: TYP8 Mask                       */
#define PD_TYP_TYP9_Pos                       9                                                       /*!< PD TYP: TYP9 Position                   */
#define PD_TYP_TYP9_Msk                       (0x01UL << PD_TYP_TYP9_Pos)                             /*!< PD TYP: TYP9 Mask                       */
#define PD_TYP_TYP10_Pos                      10                                                      /*!< PD TYP: TYP10 Position                  */
#define PD_TYP_TYP10_Msk                      (0x01UL << PD_TYP_TYP10_Pos)                            /*!< PD TYP: TYP10 Mask                      */
#define PD_TYP_TYP11_Pos                      11                                                      /*!< PD TYP: TYP11 Position                  */
#define PD_TYP_TYP11_Msk                      (0x01UL << PD_TYP_TYP11_Pos)                            /*!< PD TYP: TYP11 Mask                      */
#define PD_TYP_TYP12_Pos                      12                                                      /*!< PD TYP: TYP12 Position                  */
#define PD_TYP_TYP12_Msk                      (0x01UL << PD_TYP_TYP12_Pos)                            /*!< PD TYP: TYP12 Mask                      */
#define PD_TYP_TYP13_Pos                      13                                                      /*!< PD TYP: TYP13 Position                  */
#define PD_TYP_TYP13_Msk                      (0x01UL << PD_TYP_TYP13_Pos)                            /*!< PD TYP: TYP13 Mask                      */
#define PD_TYP_TYP14_Pos                      14                                                      /*!< PD TYP: TYP14 Position                  */
#define PD_TYP_TYP14_Msk                      (0x01UL << PD_TYP_TYP14_Pos)                            /*!< PD TYP: TYP14 Mask                      */
#define PD_TYP_TYP15_Pos                      15                                                      /*!< PD TYP: TYP15 Position                  */
#define PD_TYP_TYP15_Msk                      (0x01UL << PD_TYP_TYP15_Pos)                            /*!< PD TYP: TYP15 Mask                      */

/* ----------------------------------  PD_AFSR1  ---------------------------------- */
#define PD_AFSR1_AFSR0_Pos                    0                                                       /*!< PD AFSR1: AFSR0 Position                */
#define PD_AFSR1_AFSR0_Msk                    (0x0fUL << PD_AFSR1_AFSR0_Pos)                          /*!< PD AFSR1: AFSR0 Mask                    */
#define PD_AFSR1_AFSR1_Pos                    4                                                       /*!< PD AFSR1: AFSR1 Position                */
#define PD_AFSR1_AFSR1_Msk                    (0x0fUL << PD_AFSR1_AFSR1_Pos)                          /*!< PD AFSR1: AFSR1 Mask                    */
#define PD_AFSR1_AFSR2_Pos                    8                                                       /*!< PD AFSR1: AFSR2 Position                */
#define PD_AFSR1_AFSR2_Msk                    (0x0fUL << PD_AFSR1_AFSR2_Pos)                          /*!< PD AFSR1: AFSR2 Mask                    */
#define PD_AFSR1_AFSR3_Pos                    12                                                      /*!< PD AFSR1: AFSR3 Position                */
#define PD_AFSR1_AFSR3_Msk                    (0x0fUL << PD_AFSR1_AFSR3_Pos)                          /*!< PD AFSR1: AFSR3 Mask                    */
#define PD_AFSR1_AFSR4_Pos                    16                                                      /*!< PD AFSR1: AFSR4 Position                */
#define PD_AFSR1_AFSR4_Msk                    (0x0fUL << PD_AFSR1_AFSR4_Pos)                          /*!< PD AFSR1: AFSR4 Mask                    */
#define PD_AFSR1_AFSR5_Pos                    20                                                      /*!< PD AFSR1: AFSR5 Position                */
#define PD_AFSR1_AFSR5_Msk                    (0x0fUL << PD_AFSR1_AFSR5_Pos)                          /*!< PD AFSR1: AFSR5 Mask                    */
#define PD_AFSR1_AFSR6_Pos                    24                                                      /*!< PD AFSR1: AFSR6 Position                */
#define PD_AFSR1_AFSR6_Msk                    (0x0fUL << PD_AFSR1_AFSR6_Pos)                          /*!< PD AFSR1: AFSR6 Mask                    */
#define PD_AFSR1_AFSR7_Pos                    28                                                      /*!< PD AFSR1: AFSR7 Position                */
#define PD_AFSR1_AFSR7_Msk                    (0x0fUL << PD_AFSR1_AFSR7_Pos)                          /*!< PD AFSR1: AFSR7 Mask                    */

/* ----------------------------------  PD_AFSR2  ---------------------------------- */
#define PD_AFSR2_AFSR8_Pos                    0                                                       /*!< PD AFSR2: AFSR8 Position                */
#define PD_AFSR2_AFSR8_Msk                    (0x0fUL << PD_AFSR2_AFSR8_Pos)                          /*!< PD AFSR2: AFSR8 Mask                    */
#define PD_AFSR2_AFSR9_Pos                    4                                                       /*!< PD AFSR2: AFSR9 Position                */
#define PD_AFSR2_AFSR9_Msk                    (0x0fUL << PD_AFSR2_AFSR9_Pos)                          /*!< PD AFSR2: AFSR9 Mask                    */
#define PD_AFSR2_AFSR10_Pos                   8                                                       /*!< PD AFSR2: AFSR10 Position               */
#define PD_AFSR2_AFSR10_Msk                   (0x0fUL << PD_AFSR2_AFSR10_Pos)                         /*!< PD AFSR2: AFSR10 Mask                   */
#define PD_AFSR2_AFSR11_Pos                   12                                                      /*!< PD AFSR2: AFSR11 Position               */
#define PD_AFSR2_AFSR11_Msk                   (0x0fUL << PD_AFSR2_AFSR11_Pos)                         /*!< PD AFSR2: AFSR11 Mask                   */
#define PD_AFSR2_AFSR12_Pos                   16                                                      /*!< PD AFSR2: AFSR12 Position               */
#define PD_AFSR2_AFSR12_Msk                   (0x0fUL << PD_AFSR2_AFSR12_Pos)                         /*!< PD AFSR2: AFSR12 Mask                   */
#define PD_AFSR2_AFSR13_Pos                   20                                                      /*!< PD AFSR2: AFSR13 Position               */
#define PD_AFSR2_AFSR13_Msk                   (0x0fUL << PD_AFSR2_AFSR13_Pos)                         /*!< PD AFSR2: AFSR13 Mask                   */
#define PD_AFSR2_AFSR14_Pos                   24                                                      /*!< PD AFSR2: AFSR14 Position               */
#define PD_AFSR2_AFSR14_Msk                   (0x0fUL << PD_AFSR2_AFSR14_Pos)                         /*!< PD AFSR2: AFSR14 Mask                   */
#define PD_AFSR2_AFSR15_Pos                   28                                                      /*!< PD AFSR2: AFSR15 Position               */
#define PD_AFSR2_AFSR15_Msk                   (0x0fUL << PD_AFSR2_AFSR15_Pos)                         /*!< PD AFSR2: AFSR15 Mask                   */

/* -----------------------------------  PD_PUPD  ---------------------------------- */
#define PD_PUPD_PUPD0_Pos                     0                                                       /*!< PD PUPD: PUPD0 Position                 */
#define PD_PUPD_PUPD0_Msk                     (0x03UL << PD_PUPD_PUPD0_Pos)                           /*!< PD PUPD: PUPD0 Mask                     */
#define PD_PUPD_PUPD1_Pos                     2                                                       /*!< PD PUPD: PUPD1 Position                 */
#define PD_PUPD_PUPD1_Msk                     (0x03UL << PD_PUPD_PUPD1_Pos)                           /*!< PD PUPD: PUPD1 Mask                     */
#define PD_PUPD_PUPD2_Pos                     4                                                       /*!< PD PUPD: PUPD2 Position                 */
#define PD_PUPD_PUPD2_Msk                     (0x03UL << PD_PUPD_PUPD2_Pos)                           /*!< PD PUPD: PUPD2 Mask                     */
#define PD_PUPD_PUPD3_Pos                     6                                                       /*!< PD PUPD: PUPD3 Position                 */
#define PD_PUPD_PUPD3_Msk                     (0x03UL << PD_PUPD_PUPD3_Pos)                           /*!< PD PUPD: PUPD3 Mask                     */
#define PD_PUPD_PUPD4_Pos                     8                                                       /*!< PD PUPD: PUPD4 Position                 */
#define PD_PUPD_PUPD4_Msk                     (0x03UL << PD_PUPD_PUPD4_Pos)                           /*!< PD PUPD: PUPD4 Mask                     */
#define PD_PUPD_PUPD5_Pos                     10                                                      /*!< PD PUPD: PUPD5 Position                 */
#define PD_PUPD_PUPD5_Msk                     (0x03UL << PD_PUPD_PUPD5_Pos)                           /*!< PD PUPD: PUPD5 Mask                     */
#define PD_PUPD_PUPD6_Pos                     12                                                      /*!< PD PUPD: PUPD6 Position                 */
#define PD_PUPD_PUPD6_Msk                     (0x03UL << PD_PUPD_PUPD6_Pos)                           /*!< PD PUPD: PUPD6 Mask                     */
#define PD_PUPD_PUPD7_Pos                     14                                                      /*!< PD PUPD: PUPD7 Position                 */
#define PD_PUPD_PUPD7_Msk                     (0x03UL << PD_PUPD_PUPD7_Pos)                           /*!< PD PUPD: PUPD7 Mask                     */
#define PD_PUPD_PUPD8_Pos                     16                                                      /*!< PD PUPD: PUPD8 Position                 */
#define PD_PUPD_PUPD8_Msk                     (0x03UL << PD_PUPD_PUPD8_Pos)                           /*!< PD PUPD: PUPD8 Mask                     */
#define PD_PUPD_PUPD9_Pos                     18                                                      /*!< PD PUPD: PUPD9 Position                 */
#define PD_PUPD_PUPD9_Msk                     (0x03UL << PD_PUPD_PUPD9_Pos)                           /*!< PD PUPD: PUPD9 Mask                     */
#define PD_PUPD_PUPD10_Pos                    20                                                      /*!< PD PUPD: PUPD10 Position                */
#define PD_PUPD_PUPD10_Msk                    (0x03UL << PD_PUPD_PUPD10_Pos)                          /*!< PD PUPD: PUPD10 Mask                    */
#define PD_PUPD_PUPD11_Pos                    22                                                      /*!< PD PUPD: PUPD11 Position                */
#define PD_PUPD_PUPD11_Msk                    (0x03UL << PD_PUPD_PUPD11_Pos)                          /*!< PD PUPD: PUPD11 Mask                    */
#define PD_PUPD_PUPD12_Pos                    24                                                      /*!< PD PUPD: PUPD12 Position                */
#define PD_PUPD_PUPD12_Msk                    (0x03UL << PD_PUPD_PUPD12_Pos)                          /*!< PD PUPD: PUPD12 Mask                    */
#define PD_PUPD_PUPD13_Pos                    26                                                      /*!< PD PUPD: PUPD13 Position                */
#define PD_PUPD_PUPD13_Msk                    (0x03UL << PD_PUPD_PUPD13_Pos)                          /*!< PD PUPD: PUPD13 Mask                    */
#define PD_PUPD_PUPD14_Pos                    28                                                      /*!< PD PUPD: PUPD14 Position                */
#define PD_PUPD_PUPD14_Msk                    (0x03UL << PD_PUPD_PUPD14_Pos)                          /*!< PD PUPD: PUPD14 Mask                    */
#define PD_PUPD_PUPD15_Pos                    30                                                      /*!< PD PUPD: PUPD15 Position                */
#define PD_PUPD_PUPD15_Msk                    (0x03UL << PD_PUPD_PUPD15_Pos)                          /*!< PD PUPD: PUPD15 Mask                    */

/* -----------------------------------  PD_INDR  ---------------------------------- */
#define PD_INDR_INDR0_Pos                     0                                                       /*!< PD INDR: INDR0 Position                 */
#define PD_INDR_INDR0_Msk                     (0x01UL << PD_INDR_INDR0_Pos)                           /*!< PD INDR: INDR0 Mask                     */
#define PD_INDR_INDR1_Pos                     1                                                       /*!< PD INDR: INDR1 Position                 */
#define PD_INDR_INDR1_Msk                     (0x01UL << PD_INDR_INDR1_Pos)                           /*!< PD INDR: INDR1 Mask                     */
#define PD_INDR_INDR2_Pos                     2                                                       /*!< PD INDR: INDR2 Position                 */
#define PD_INDR_INDR2_Msk                     (0x01UL << PD_INDR_INDR2_Pos)                           /*!< PD INDR: INDR2 Mask                     */
#define PD_INDR_INDR3_Pos                     3                                                       /*!< PD INDR: INDR3 Position                 */
#define PD_INDR_INDR3_Msk                     (0x01UL << PD_INDR_INDR3_Pos)                           /*!< PD INDR: INDR3 Mask                     */
#define PD_INDR_INDR4_Pos                     4                                                       /*!< PD INDR: INDR4 Position                 */
#define PD_INDR_INDR4_Msk                     (0x01UL << PD_INDR_INDR4_Pos)                           /*!< PD INDR: INDR4 Mask                     */
#define PD_INDR_INDR5_Pos                     5                                                       /*!< PD INDR: INDR5 Position                 */
#define PD_INDR_INDR5_Msk                     (0x01UL << PD_INDR_INDR5_Pos)                           /*!< PD INDR: INDR5 Mask                     */
#define PD_INDR_INDR6_Pos                     6                                                       /*!< PD INDR: INDR6 Position                 */
#define PD_INDR_INDR6_Msk                     (0x01UL << PD_INDR_INDR6_Pos)                           /*!< PD INDR: INDR6 Mask                     */
#define PD_INDR_INDR7_Pos                     7                                                       /*!< PD INDR: INDR7 Position                 */
#define PD_INDR_INDR7_Msk                     (0x01UL << PD_INDR_INDR7_Pos)                           /*!< PD INDR: INDR7 Mask                     */
#define PD_INDR_INDR8_Pos                     8                                                       /*!< PD INDR: INDR8 Position                 */
#define PD_INDR_INDR8_Msk                     (0x01UL << PD_INDR_INDR8_Pos)                           /*!< PD INDR: INDR8 Mask                     */
#define PD_INDR_INDR9_Pos                     9                                                       /*!< PD INDR: INDR9 Position                 */
#define PD_INDR_INDR9_Msk                     (0x01UL << PD_INDR_INDR9_Pos)                           /*!< PD INDR: INDR9 Mask                     */
#define PD_INDR_INDR10_Pos                    10                                                      /*!< PD INDR: INDR10 Position                */
#define PD_INDR_INDR10_Msk                    (0x01UL << PD_INDR_INDR10_Pos)                          /*!< PD INDR: INDR10 Mask                    */
#define PD_INDR_INDR11_Pos                    11                                                      /*!< PD INDR: INDR11 Position                */
#define PD_INDR_INDR11_Msk                    (0x01UL << PD_INDR_INDR11_Pos)                          /*!< PD INDR: INDR11 Mask                    */
#define PD_INDR_INDR12_Pos                    12                                                      /*!< PD INDR: INDR12 Position                */
#define PD_INDR_INDR12_Msk                    (0x01UL << PD_INDR_INDR12_Pos)                          /*!< PD INDR: INDR12 Mask                    */
#define PD_INDR_INDR13_Pos                    13                                                      /*!< PD INDR: INDR13 Position                */
#define PD_INDR_INDR13_Msk                    (0x01UL << PD_INDR_INDR13_Pos)                          /*!< PD INDR: INDR13 Mask                    */
#define PD_INDR_INDR14_Pos                    14                                                      /*!< PD INDR: INDR14 Position                */
#define PD_INDR_INDR14_Msk                    (0x01UL << PD_INDR_INDR14_Pos)                          /*!< PD INDR: INDR14 Mask                    */
#define PD_INDR_INDR15_Pos                    15                                                      /*!< PD INDR: INDR15 Position                */
#define PD_INDR_INDR15_Msk                    (0x01UL << PD_INDR_INDR15_Pos)                          /*!< PD INDR: INDR15 Mask                    */

/* ----------------------------------  PD_OUTDR  ---------------------------------- */
#define PD_OUTDR_OUTDR0_Pos                   0                                                       /*!< PD OUTDR: OUTDR0 Position               */
#define PD_OUTDR_OUTDR0_Msk                   (0x01UL << PD_OUTDR_OUTDR0_Pos)                         /*!< PD OUTDR: OUTDR0 Mask                   */
#define PD_OUTDR_OUTDR1_Pos                   1                                                       /*!< PD OUTDR: OUTDR1 Position               */
#define PD_OUTDR_OUTDR1_Msk                   (0x01UL << PD_OUTDR_OUTDR1_Pos)                         /*!< PD OUTDR: OUTDR1 Mask                   */
#define PD_OUTDR_OUTDR2_Pos                   2                                                       /*!< PD OUTDR: OUTDR2 Position               */
#define PD_OUTDR_OUTDR2_Msk                   (0x01UL << PD_OUTDR_OUTDR2_Pos)                         /*!< PD OUTDR: OUTDR2 Mask                   */
#define PD_OUTDR_OUTDR3_Pos                   3                                                       /*!< PD OUTDR: OUTDR3 Position               */
#define PD_OUTDR_OUTDR3_Msk                   (0x01UL << PD_OUTDR_OUTDR3_Pos)                         /*!< PD OUTDR: OUTDR3 Mask                   */
#define PD_OUTDR_OUTDR4_Pos                   4                                                       /*!< PD OUTDR: OUTDR4 Position               */
#define PD_OUTDR_OUTDR4_Msk                   (0x01UL << PD_OUTDR_OUTDR4_Pos)                         /*!< PD OUTDR: OUTDR4 Mask                   */
#define PD_OUTDR_OUTDR5_Pos                   5                                                       /*!< PD OUTDR: OUTDR5 Position               */
#define PD_OUTDR_OUTDR5_Msk                   (0x01UL << PD_OUTDR_OUTDR5_Pos)                         /*!< PD OUTDR: OUTDR5 Mask                   */
#define PD_OUTDR_OUTDR6_Pos                   6                                                       /*!< PD OUTDR: OUTDR6 Position               */
#define PD_OUTDR_OUTDR6_Msk                   (0x01UL << PD_OUTDR_OUTDR6_Pos)                         /*!< PD OUTDR: OUTDR6 Mask                   */
#define PD_OUTDR_OUTDR7_Pos                   7                                                       /*!< PD OUTDR: OUTDR7 Position               */
#define PD_OUTDR_OUTDR7_Msk                   (0x01UL << PD_OUTDR_OUTDR7_Pos)                         /*!< PD OUTDR: OUTDR7 Mask                   */
#define PD_OUTDR_OUTDR8_Pos                   8                                                       /*!< PD OUTDR: OUTDR8 Position               */
#define PD_OUTDR_OUTDR8_Msk                   (0x01UL << PD_OUTDR_OUTDR8_Pos)                         /*!< PD OUTDR: OUTDR8 Mask                   */
#define PD_OUTDR_OUTDR9_Pos                   9                                                       /*!< PD OUTDR: OUTDR9 Position               */
#define PD_OUTDR_OUTDR9_Msk                   (0x01UL << PD_OUTDR_OUTDR9_Pos)                         /*!< PD OUTDR: OUTDR9 Mask                   */
#define PD_OUTDR_OUTDR10_Pos                  10                                                      /*!< PD OUTDR: OUTDR10 Position              */
#define PD_OUTDR_OUTDR10_Msk                  (0x01UL << PD_OUTDR_OUTDR10_Pos)                        /*!< PD OUTDR: OUTDR10 Mask                  */
#define PD_OUTDR_OUTDR11_Pos                  11                                                      /*!< PD OUTDR: OUTDR11 Position              */
#define PD_OUTDR_OUTDR11_Msk                  (0x01UL << PD_OUTDR_OUTDR11_Pos)                        /*!< PD OUTDR: OUTDR11 Mask                  */
#define PD_OUTDR_OUTDR12_Pos                  12                                                      /*!< PD OUTDR: OUTDR12 Position              */
#define PD_OUTDR_OUTDR12_Msk                  (0x01UL << PD_OUTDR_OUTDR12_Pos)                        /*!< PD OUTDR: OUTDR12 Mask                  */
#define PD_OUTDR_OUTDR13_Pos                  13                                                      /*!< PD OUTDR: OUTDR13 Position              */
#define PD_OUTDR_OUTDR13_Msk                  (0x01UL << PD_OUTDR_OUTDR13_Pos)                        /*!< PD OUTDR: OUTDR13 Mask                  */
#define PD_OUTDR_OUTDR14_Pos                  14                                                      /*!< PD OUTDR: OUTDR14 Position              */
#define PD_OUTDR_OUTDR14_Msk                  (0x01UL << PD_OUTDR_OUTDR14_Pos)                        /*!< PD OUTDR: OUTDR14 Mask                  */
#define PD_OUTDR_OUTDR15_Pos                  15                                                      /*!< PD OUTDR: OUTDR15 Position              */
#define PD_OUTDR_OUTDR15_Msk                  (0x01UL << PD_OUTDR_OUTDR15_Pos)                        /*!< PD OUTDR: OUTDR15 Mask                  */

/* -----------------------------------  PD_BSR  ----------------------------------- */
#define PD_BSR_BSR0_Pos                       0                                                       /*!< PD BSR: BSR0 Position                   */
#define PD_BSR_BSR0_Msk                       (0x01UL << PD_BSR_BSR0_Pos)                             /*!< PD BSR: BSR0 Mask                       */
#define PD_BSR_BSR1_Pos                       1                                                       /*!< PD BSR: BSR1 Position                   */
#define PD_BSR_BSR1_Msk                       (0x01UL << PD_BSR_BSR1_Pos)                             /*!< PD BSR: BSR1 Mask                       */
#define PD_BSR_BSR2_Pos                       2                                                       /*!< PD BSR: BSR2 Position                   */
#define PD_BSR_BSR2_Msk                       (0x01UL << PD_BSR_BSR2_Pos)                             /*!< PD BSR: BSR2 Mask                       */
#define PD_BSR_BSR3_Pos                       3                                                       /*!< PD BSR: BSR3 Position                   */
#define PD_BSR_BSR3_Msk                       (0x01UL << PD_BSR_BSR3_Pos)                             /*!< PD BSR: BSR3 Mask                       */
#define PD_BSR_BSR4_Pos                       4                                                       /*!< PD BSR: BSR4 Position                   */
#define PD_BSR_BSR4_Msk                       (0x01UL << PD_BSR_BSR4_Pos)                             /*!< PD BSR: BSR4 Mask                       */
#define PD_BSR_BSR5_Pos                       5                                                       /*!< PD BSR: BSR5 Position                   */
#define PD_BSR_BSR5_Msk                       (0x01UL << PD_BSR_BSR5_Pos)                             /*!< PD BSR: BSR5 Mask                       */
#define PD_BSR_BSR6_Pos                       6                                                       /*!< PD BSR: BSR6 Position                   */
#define PD_BSR_BSR6_Msk                       (0x01UL << PD_BSR_BSR6_Pos)                             /*!< PD BSR: BSR6 Mask                       */
#define PD_BSR_BSR7_Pos                       7                                                       /*!< PD BSR: BSR7 Position                   */
#define PD_BSR_BSR7_Msk                       (0x01UL << PD_BSR_BSR7_Pos)                             /*!< PD BSR: BSR7 Mask                       */
#define PD_BSR_BSR8_Pos                       8                                                       /*!< PD BSR: BSR8 Position                   */
#define PD_BSR_BSR8_Msk                       (0x01UL << PD_BSR_BSR8_Pos)                             /*!< PD BSR: BSR8 Mask                       */
#define PD_BSR_BSR9_Pos                       9                                                       /*!< PD BSR: BSR9 Position                   */
#define PD_BSR_BSR9_Msk                       (0x01UL << PD_BSR_BSR9_Pos)                             /*!< PD BSR: BSR9 Mask                       */
#define PD_BSR_BSR10_Pos                      10                                                      /*!< PD BSR: BSR10 Position                  */
#define PD_BSR_BSR10_Msk                      (0x01UL << PD_BSR_BSR10_Pos)                            /*!< PD BSR: BSR10 Mask                      */
#define PD_BSR_BSR11_Pos                      11                                                      /*!< PD BSR: BSR11 Position                  */
#define PD_BSR_BSR11_Msk                      (0x01UL << PD_BSR_BSR11_Pos)                            /*!< PD BSR: BSR11 Mask                      */
#define PD_BSR_BSR12_Pos                      12                                                      /*!< PD BSR: BSR12 Position                  */
#define PD_BSR_BSR12_Msk                      (0x01UL << PD_BSR_BSR12_Pos)                            /*!< PD BSR: BSR12 Mask                      */
#define PD_BSR_BSR13_Pos                      13                                                      /*!< PD BSR: BSR13 Position                  */
#define PD_BSR_BSR13_Msk                      (0x01UL << PD_BSR_BSR13_Pos)                            /*!< PD BSR: BSR13 Mask                      */
#define PD_BSR_BSR14_Pos                      14                                                      /*!< PD BSR: BSR14 Position                  */
#define PD_BSR_BSR14_Msk                      (0x01UL << PD_BSR_BSR14_Pos)                            /*!< PD BSR: BSR14 Mask                      */
#define PD_BSR_BSR15_Pos                      15                                                      /*!< PD BSR: BSR15 Position                  */
#define PD_BSR_BSR15_Msk                      (0x01UL << PD_BSR_BSR15_Pos)                            /*!< PD BSR: BSR15 Mask                      */

/* -----------------------------------  PD_BCR  ----------------------------------- */
#define PD_BCR_BCR0_Pos                       0                                                       /*!< PD BCR: BCR0 Position                   */
#define PD_BCR_BCR0_Msk                       (0x01UL << PD_BCR_BCR0_Pos)                             /*!< PD BCR: BCR0 Mask                       */
#define PD_BCR_BCR1_Pos                       1                                                       /*!< PD BCR: BCR1 Position                   */
#define PD_BCR_BCR1_Msk                       (0x01UL << PD_BCR_BCR1_Pos)                             /*!< PD BCR: BCR1 Mask                       */
#define PD_BCR_BCR2_Pos                       2                                                       /*!< PD BCR: BCR2 Position                   */
#define PD_BCR_BCR2_Msk                       (0x01UL << PD_BCR_BCR2_Pos)                             /*!< PD BCR: BCR2 Mask                       */
#define PD_BCR_BCR3_Pos                       3                                                       /*!< PD BCR: BCR3 Position                   */
#define PD_BCR_BCR3_Msk                       (0x01UL << PD_BCR_BCR3_Pos)                             /*!< PD BCR: BCR3 Mask                       */
#define PD_BCR_BCR4_Pos                       4                                                       /*!< PD BCR: BCR4 Position                   */
#define PD_BCR_BCR4_Msk                       (0x01UL << PD_BCR_BCR4_Pos)                             /*!< PD BCR: BCR4 Mask                       */
#define PD_BCR_BCR5_Pos                       5                                                       /*!< PD BCR: BCR5 Position                   */
#define PD_BCR_BCR5_Msk                       (0x01UL << PD_BCR_BCR5_Pos)                             /*!< PD BCR: BCR5 Mask                       */
#define PD_BCR_BCR6_Pos                       6                                                       /*!< PD BCR: BCR6 Position                   */
#define PD_BCR_BCR6_Msk                       (0x01UL << PD_BCR_BCR6_Pos)                             /*!< PD BCR: BCR6 Mask                       */
#define PD_BCR_BCR7_Pos                       7                                                       /*!< PD BCR: BCR7 Position                   */
#define PD_BCR_BCR7_Msk                       (0x01UL << PD_BCR_BCR7_Pos)                             /*!< PD BCR: BCR7 Mask                       */
#define PD_BCR_BCR8_Pos                       8                                                       /*!< PD BCR: BCR8 Position                   */
#define PD_BCR_BCR8_Msk                       (0x01UL << PD_BCR_BCR8_Pos)                             /*!< PD BCR: BCR8 Mask                       */
#define PD_BCR_BCR9_Pos                       9                                                       /*!< PD BCR: BCR9 Position                   */
#define PD_BCR_BCR9_Msk                       (0x01UL << PD_BCR_BCR9_Pos)                             /*!< PD BCR: BCR9 Mask                       */
#define PD_BCR_BCR10_Pos                      10                                                      /*!< PD BCR: BCR10 Position                  */
#define PD_BCR_BCR10_Msk                      (0x01UL << PD_BCR_BCR10_Pos)                            /*!< PD BCR: BCR10 Mask                      */
#define PD_BCR_BCR11_Pos                      11                                                      /*!< PD BCR: BCR11 Position                  */
#define PD_BCR_BCR11_Msk                      (0x01UL << PD_BCR_BCR11_Pos)                            /*!< PD BCR: BCR11 Mask                      */
#define PD_BCR_BCR12_Pos                      12                                                      /*!< PD BCR: BCR12 Position                  */
#define PD_BCR_BCR12_Msk                      (0x01UL << PD_BCR_BCR12_Pos)                            /*!< PD BCR: BCR12 Mask                      */
#define PD_BCR_BCR13_Pos                      13                                                      /*!< PD BCR: BCR13 Position                  */
#define PD_BCR_BCR13_Msk                      (0x01UL << PD_BCR_BCR13_Pos)                            /*!< PD BCR: BCR13 Mask                      */
#define PD_BCR_BCR14_Pos                      14                                                      /*!< PD BCR: BCR14 Position                  */
#define PD_BCR_BCR14_Msk                      (0x01UL << PD_BCR_BCR14_Pos)                            /*!< PD BCR: BCR14 Mask                      */
#define PD_BCR_BCR15_Pos                      15                                                      /*!< PD BCR: BCR15 Position                  */
#define PD_BCR_BCR15_Msk                      (0x01UL << PD_BCR_BCR15_Pos)                            /*!< PD BCR: BCR15 Mask                      */

/* ---------------------------------  PD_OUTDMSK  --------------------------------- */
#define PD_OUTDMSK_OUTDMSK0_Pos               0                                                       /*!< PD OUTDMSK: OUTDMSK0 Position           */
#define PD_OUTDMSK_OUTDMSK0_Msk               (0x01UL << PD_OUTDMSK_OUTDMSK0_Pos)                     /*!< PD OUTDMSK: OUTDMSK0 Mask               */
#define PD_OUTDMSK_OUTDMSK1_Pos               1                                                       /*!< PD OUTDMSK: OUTDMSK1 Position           */
#define PD_OUTDMSK_OUTDMSK1_Msk               (0x01UL << PD_OUTDMSK_OUTDMSK1_Pos)                     /*!< PD OUTDMSK: OUTDMSK1 Mask               */
#define PD_OUTDMSK_OUTDMSK2_Pos               2                                                       /*!< PD OUTDMSK: OUTDMSK2 Position           */
#define PD_OUTDMSK_OUTDMSK2_Msk               (0x01UL << PD_OUTDMSK_OUTDMSK2_Pos)                     /*!< PD OUTDMSK: OUTDMSK2 Mask               */
#define PD_OUTDMSK_OUTDMSK3_Pos               3                                                       /*!< PD OUTDMSK: OUTDMSK3 Position           */
#define PD_OUTDMSK_OUTDMSK3_Msk               (0x01UL << PD_OUTDMSK_OUTDMSK3_Pos)                     /*!< PD OUTDMSK: OUTDMSK3 Mask               */
#define PD_OUTDMSK_OUTDMSK4_Pos               4                                                       /*!< PD OUTDMSK: OUTDMSK4 Position           */
#define PD_OUTDMSK_OUTDMSK4_Msk               (0x01UL << PD_OUTDMSK_OUTDMSK4_Pos)                     /*!< PD OUTDMSK: OUTDMSK4 Mask               */
#define PD_OUTDMSK_OUTDMSK5_Pos               5                                                       /*!< PD OUTDMSK: OUTDMSK5 Position           */
#define PD_OUTDMSK_OUTDMSK5_Msk               (0x01UL << PD_OUTDMSK_OUTDMSK5_Pos)                     /*!< PD OUTDMSK: OUTDMSK5 Mask               */
#define PD_OUTDMSK_OUTDMSK6_Pos               6                                                       /*!< PD OUTDMSK: OUTDMSK6 Position           */
#define PD_OUTDMSK_OUTDMSK6_Msk               (0x01UL << PD_OUTDMSK_OUTDMSK6_Pos)                     /*!< PD OUTDMSK: OUTDMSK6 Mask               */
#define PD_OUTDMSK_OUTDMSK7_Pos               7                                                       /*!< PD OUTDMSK: OUTDMSK7 Position           */
#define PD_OUTDMSK_OUTDMSK7_Msk               (0x01UL << PD_OUTDMSK_OUTDMSK7_Pos)                     /*!< PD OUTDMSK: OUTDMSK7 Mask               */
#define PD_OUTDMSK_OUTDMSK8_Pos               8                                                       /*!< PD OUTDMSK: OUTDMSK8 Position           */
#define PD_OUTDMSK_OUTDMSK8_Msk               (0x01UL << PD_OUTDMSK_OUTDMSK8_Pos)                     /*!< PD OUTDMSK: OUTDMSK8 Mask               */
#define PD_OUTDMSK_OUTDMSK9_Pos               9                                                       /*!< PD OUTDMSK: OUTDMSK9 Position           */
#define PD_OUTDMSK_OUTDMSK9_Msk               (0x01UL << PD_OUTDMSK_OUTDMSK9_Pos)                     /*!< PD OUTDMSK: OUTDMSK9 Mask               */
#define PD_OUTDMSK_OUTDMSK10_Pos              10                                                      /*!< PD OUTDMSK: OUTDMSK10 Position          */
#define PD_OUTDMSK_OUTDMSK10_Msk              (0x01UL << PD_OUTDMSK_OUTDMSK10_Pos)                    /*!< PD OUTDMSK: OUTDMSK10 Mask              */
#define PD_OUTDMSK_OUTDMSK11_Pos              11                                                      /*!< PD OUTDMSK: OUTDMSK11 Position          */
#define PD_OUTDMSK_OUTDMSK11_Msk              (0x01UL << PD_OUTDMSK_OUTDMSK11_Pos)                    /*!< PD OUTDMSK: OUTDMSK11 Mask              */
#define PD_OUTDMSK_OUTDMSK12_Pos              12                                                      /*!< PD OUTDMSK: OUTDMSK12 Position          */
#define PD_OUTDMSK_OUTDMSK12_Msk              (0x01UL << PD_OUTDMSK_OUTDMSK12_Pos)                    /*!< PD OUTDMSK: OUTDMSK12 Mask              */
#define PD_OUTDMSK_OUTDMSK13_Pos              13                                                      /*!< PD OUTDMSK: OUTDMSK13 Position          */
#define PD_OUTDMSK_OUTDMSK13_Msk              (0x01UL << PD_OUTDMSK_OUTDMSK13_Pos)                    /*!< PD OUTDMSK: OUTDMSK13 Mask              */
#define PD_OUTDMSK_OUTDMSK14_Pos              14                                                      /*!< PD OUTDMSK: OUTDMSK14 Position          */
#define PD_OUTDMSK_OUTDMSK14_Msk              (0x01UL << PD_OUTDMSK_OUTDMSK14_Pos)                    /*!< PD OUTDMSK: OUTDMSK14 Mask              */
#define PD_OUTDMSK_OUTDMSK15_Pos              15                                                      /*!< PD OUTDMSK: OUTDMSK15 Position          */
#define PD_OUTDMSK_OUTDMSK15_Msk              (0x01UL << PD_OUTDMSK_OUTDMSK15_Pos)                    /*!< PD OUTDMSK: OUTDMSK15 Mask              */

/* -----------------------------------  PD_DBCR  ---------------------------------- */
#define PD_DBCR_DBEN0_Pos                     0                                                       /*!< PD DBCR: DBEN0 Position                 */
#define PD_DBCR_DBEN0_Msk                     (0x01UL << PD_DBCR_DBEN0_Pos)                           /*!< PD DBCR: DBEN0 Mask                     */
#define PD_DBCR_DBEN1_Pos                     1                                                       /*!< PD DBCR: DBEN1 Position                 */
#define PD_DBCR_DBEN1_Msk                     (0x01UL << PD_DBCR_DBEN1_Pos)                           /*!< PD DBCR: DBEN1 Mask                     */
#define PD_DBCR_DBEN2_Pos                     2                                                       /*!< PD DBCR: DBEN2 Position                 */
#define PD_DBCR_DBEN2_Msk                     (0x01UL << PD_DBCR_DBEN2_Pos)                           /*!< PD DBCR: DBEN2 Mask                     */
#define PD_DBCR_DBEN3_Pos                     3                                                       /*!< PD DBCR: DBEN3 Position                 */
#define PD_DBCR_DBEN3_Msk                     (0x01UL << PD_DBCR_DBEN3_Pos)                           /*!< PD DBCR: DBEN3 Mask                     */
#define PD_DBCR_DBEN4_Pos                     4                                                       /*!< PD DBCR: DBEN4 Position                 */
#define PD_DBCR_DBEN4_Msk                     (0x01UL << PD_DBCR_DBEN4_Pos)                           /*!< PD DBCR: DBEN4 Mask                     */
#define PD_DBCR_DBEN5_Pos                     5                                                       /*!< PD DBCR: DBEN5 Position                 */
#define PD_DBCR_DBEN5_Msk                     (0x01UL << PD_DBCR_DBEN5_Pos)                           /*!< PD DBCR: DBEN5 Mask                     */
#define PD_DBCR_DBEN6_Pos                     6                                                       /*!< PD DBCR: DBEN6 Position                 */
#define PD_DBCR_DBEN6_Msk                     (0x01UL << PD_DBCR_DBEN6_Pos)                           /*!< PD DBCR: DBEN6 Mask                     */
#define PD_DBCR_DBEN7_Pos                     7                                                       /*!< PD DBCR: DBEN7 Position                 */
#define PD_DBCR_DBEN7_Msk                     (0x01UL << PD_DBCR_DBEN7_Pos)                           /*!< PD DBCR: DBEN7 Mask                     */
#define PD_DBCR_DBEN8_Pos                     8                                                       /*!< PD DBCR: DBEN8 Position                 */
#define PD_DBCR_DBEN8_Msk                     (0x01UL << PD_DBCR_DBEN8_Pos)                           /*!< PD DBCR: DBEN8 Mask                     */
#define PD_DBCR_DBEN9_Pos                     9                                                       /*!< PD DBCR: DBEN9 Position                 */
#define PD_DBCR_DBEN9_Msk                     (0x01UL << PD_DBCR_DBEN9_Pos)                           /*!< PD DBCR: DBEN9 Mask                     */
#define PD_DBCR_DBEN10_Pos                    10                                                      /*!< PD DBCR: DBEN10 Position                */
#define PD_DBCR_DBEN10_Msk                    (0x01UL << PD_DBCR_DBEN10_Pos)                          /*!< PD DBCR: DBEN10 Mask                    */
#define PD_DBCR_DBEN11_Pos                    11                                                      /*!< PD DBCR: DBEN11 Position                */
#define PD_DBCR_DBEN11_Msk                    (0x01UL << PD_DBCR_DBEN11_Pos)                          /*!< PD DBCR: DBEN11 Mask                    */
#define PD_DBCR_DBEN12_Pos                    12                                                      /*!< PD DBCR: DBEN12 Position                */
#define PD_DBCR_DBEN12_Msk                    (0x01UL << PD_DBCR_DBEN12_Pos)                          /*!< PD DBCR: DBEN12 Mask                    */
#define PD_DBCR_DBEN13_Pos                    13                                                      /*!< PD DBCR: DBEN13 Position                */
#define PD_DBCR_DBEN13_Msk                    (0x01UL << PD_DBCR_DBEN13_Pos)                          /*!< PD DBCR: DBEN13 Mask                    */
#define PD_DBCR_DBEN14_Pos                    14                                                      /*!< PD DBCR: DBEN14 Position                */
#define PD_DBCR_DBEN14_Msk                    (0x01UL << PD_DBCR_DBEN14_Pos)                          /*!< PD DBCR: DBEN14 Mask                    */
#define PD_DBCR_DBEN15_Pos                    15                                                      /*!< PD DBCR: DBEN15 Position                */
#define PD_DBCR_DBEN15_Msk                    (0x01UL << PD_DBCR_DBEN15_Pos)                          /*!< PD DBCR: DBEN15 Mask                    */

/* -----------------------------------  PD_IER  ----------------------------------- */
#define PD_IER_P0_Pos                         0                                                       /*!< PD IER: P0 Position                     */
#define PD_IER_P0_Msk                         (0x03UL << PD_IER_P0_Pos)                               /*!< PD IER: P0 Mask                         */
#define PD_IER_P1_Pos                         2                                                       /*!< PD IER: P1 Position                     */
#define PD_IER_P1_Msk                         (0x03UL << PD_IER_P1_Pos)                               /*!< PD IER: P1 Mask                         */
#define PD_IER_P2_Pos                         4                                                       /*!< PD IER: P2 Position                     */
#define PD_IER_P2_Msk                         (0x03UL << PD_IER_P2_Pos)                               /*!< PD IER: P2 Mask                         */
#define PD_IER_P3_Pos                         6                                                       /*!< PD IER: P3 Position                     */
#define PD_IER_P3_Msk                         (0x03UL << PD_IER_P3_Pos)                               /*!< PD IER: P3 Mask                         */
#define PD_IER_P4_Pos                         8                                                       /*!< PD IER: P4 Position                     */
#define PD_IER_P4_Msk                         (0x03UL << PD_IER_P4_Pos)                               /*!< PD IER: P4 Mask                         */
#define PD_IER_P5_Pos                         10                                                      /*!< PD IER: P5 Position                     */
#define PD_IER_P5_Msk                         (0x03UL << PD_IER_P5_Pos)                               /*!< PD IER: P5 Mask                         */
#define PD_IER_P6_Pos                         12                                                      /*!< PD IER: P6 Position                     */
#define PD_IER_P6_Msk                         (0x03UL << PD_IER_P6_Pos)                               /*!< PD IER: P6 Mask                         */
#define PD_IER_P7_Pos                         14                                                      /*!< PD IER: P7 Position                     */
#define PD_IER_P7_Msk                         (0x03UL << PD_IER_P7_Pos)                               /*!< PD IER: P7 Mask                         */
#define PD_IER_P8_Pos                         16                                                      /*!< PD IER: P8 Position                     */
#define PD_IER_P8_Msk                         (0x03UL << PD_IER_P8_Pos)                               /*!< PD IER: P8 Mask                         */
#define PD_IER_P9_Pos                         18                                                      /*!< PD IER: P9 Position                     */
#define PD_IER_P9_Msk                         (0x03UL << PD_IER_P9_Pos)                               /*!< PD IER: P9 Mask                         */
#define PD_IER_P10_Pos                        20                                                      /*!< PD IER: P10 Position                    */
#define PD_IER_P10_Msk                        (0x03UL << PD_IER_P10_Pos)                              /*!< PD IER: P10 Mask                        */
#define PD_IER_P11_Pos                        22                                                      /*!< PD IER: P11 Position                    */
#define PD_IER_P11_Msk                        (0x03UL << PD_IER_P11_Pos)                              /*!< PD IER: P11 Mask                        */
#define PD_IER_P12_Pos                        24                                                      /*!< PD IER: P12 Position                    */
#define PD_IER_P12_Msk                        (0x03UL << PD_IER_P12_Pos)                              /*!< PD IER: P12 Mask                        */
#define PD_IER_P13_Pos                        26                                                      /*!< PD IER: P13 Position                    */
#define PD_IER_P13_Msk                        (0x03UL << PD_IER_P13_Pos)                              /*!< PD IER: P13 Mask                        */
#define PD_IER_P14_Pos                        28                                                      /*!< PD IER: P14 Position                    */
#define PD_IER_P14_Msk                        (0x03UL << PD_IER_P14_Pos)                              /*!< PD IER: P14 Mask                        */
#define PD_IER_P15_Pos                        30                                                      /*!< PD IER: P15 Position                    */
#define PD_IER_P15_Msk                        (0x03UL << PD_IER_P15_Pos)                              /*!< PD IER: P15 Mask                        */

/* -----------------------------------  PD_ISR  ----------------------------------- */
#define PD_ISR_P0_Pos                         0                                                       /*!< PD ISR: P0 Position                     */
#define PD_ISR_P0_Msk                         (0x03UL << PD_ISR_P0_Pos)                               /*!< PD ISR: P0 Mask                         */
#define PD_ISR_P1_Pos                         2                                                       /*!< PD ISR: P1 Position                     */
#define PD_ISR_P1_Msk                         (0x03UL << PD_ISR_P1_Pos)                               /*!< PD ISR: P1 Mask                         */
#define PD_ISR_P2_Pos                         4                                                       /*!< PD ISR: P2 Position                     */
#define PD_ISR_P2_Msk                         (0x03UL << PD_ISR_P2_Pos)                               /*!< PD ISR: P2 Mask                         */
#define PD_ISR_P3_Pos                         6                                                       /*!< PD ISR: P3 Position                     */
#define PD_ISR_P3_Msk                         (0x03UL << PD_ISR_P3_Pos)                               /*!< PD ISR: P3 Mask                         */
#define PD_ISR_P4_Pos                         8                                                       /*!< PD ISR: P4 Position                     */
#define PD_ISR_P4_Msk                         (0x03UL << PD_ISR_P4_Pos)                               /*!< PD ISR: P4 Mask                         */
#define PD_ISR_P5_Pos                         10                                                      /*!< PD ISR: P5 Position                     */
#define PD_ISR_P5_Msk                         (0x03UL << PD_ISR_P5_Pos)                               /*!< PD ISR: P5 Mask                         */
#define PD_ISR_P6_Pos                         12                                                      /*!< PD ISR: P6 Position                     */
#define PD_ISR_P6_Msk                         (0x03UL << PD_ISR_P6_Pos)                               /*!< PD ISR: P6 Mask                         */
#define PD_ISR_P7_Pos                         14                                                      /*!< PD ISR: P7 Position                     */
#define PD_ISR_P7_Msk                         (0x03UL << PD_ISR_P7_Pos)                               /*!< PD ISR: P7 Mask                         */
#define PD_ISR_P8_Pos                         16                                                      /*!< PD ISR: P8 Position                     */
#define PD_ISR_P8_Msk                         (0x03UL << PD_ISR_P8_Pos)                               /*!< PD ISR: P8 Mask                         */
#define PD_ISR_P9_Pos                         18                                                      /*!< PD ISR: P9 Position                     */
#define PD_ISR_P9_Msk                         (0x03UL << PD_ISR_P9_Pos)                               /*!< PD ISR: P9 Mask                         */
#define PD_ISR_P10_Pos                        20                                                      /*!< PD ISR: P10 Position                    */
#define PD_ISR_P10_Msk                        (0x03UL << PD_ISR_P10_Pos)                              /*!< PD ISR: P10 Mask                        */
#define PD_ISR_P11_Pos                        22                                                      /*!< PD ISR: P11 Position                    */
#define PD_ISR_P11_Msk                        (0x03UL << PD_ISR_P11_Pos)                              /*!< PD ISR: P11 Mask                        */
#define PD_ISR_P12_Pos                        24                                                      /*!< PD ISR: P12 Position                    */
#define PD_ISR_P12_Msk                        (0x03UL << PD_ISR_P12_Pos)                              /*!< PD ISR: P12 Mask                        */
#define PD_ISR_P13_Pos                        26                                                      /*!< PD ISR: P13 Position                    */
#define PD_ISR_P13_Msk                        (0x03UL << PD_ISR_P13_Pos)                              /*!< PD ISR: P13 Mask                        */
#define PD_ISR_P14_Pos                        28                                                      /*!< PD ISR: P14 Position                    */
#define PD_ISR_P14_Msk                        (0x03UL << PD_ISR_P14_Pos)                              /*!< PD ISR: P14 Mask                        */
#define PD_ISR_P15_Pos                        30                                                      /*!< PD ISR: P15 Position                    */
#define PD_ISR_P15_Msk                        (0x03UL << PD_ISR_P15_Pos)                              /*!< PD ISR: P15 Mask                        */

/* -----------------------------------  PD_ICR  ----------------------------------- */
#define PD_ICR_P0_Pos                         0                                                       /*!< PD ICR: P0 Position                     */
#define PD_ICR_P0_Msk                         (0x03UL << PD_ICR_P0_Pos)                               /*!< PD ICR: P0 Mask                         */
#define PD_ICR_P1_Pos                         2                                                       /*!< PD ICR: P1 Position                     */
#define PD_ICR_P1_Msk                         (0x03UL << PD_ICR_P1_Pos)                               /*!< PD ICR: P1 Mask                         */
#define PD_ICR_P2_Pos                         4                                                       /*!< PD ICR: P2 Position                     */
#define PD_ICR_P2_Msk                         (0x03UL << PD_ICR_P2_Pos)                               /*!< PD ICR: P2 Mask                         */
#define PD_ICR_P3_Pos                         6                                                       /*!< PD ICR: P3 Position                     */
#define PD_ICR_P3_Msk                         (0x03UL << PD_ICR_P3_Pos)                               /*!< PD ICR: P3 Mask                         */
#define PD_ICR_P4_Pos                         8                                                       /*!< PD ICR: P4 Position                     */
#define PD_ICR_P4_Msk                         (0x03UL << PD_ICR_P4_Pos)                               /*!< PD ICR: P4 Mask                         */
#define PD_ICR_P5_Pos                         10                                                      /*!< PD ICR: P5 Position                     */
#define PD_ICR_P5_Msk                         (0x03UL << PD_ICR_P5_Pos)                               /*!< PD ICR: P5 Mask                         */
#define PD_ICR_P6_Pos                         12                                                      /*!< PD ICR: P6 Position                     */
#define PD_ICR_P6_Msk                         (0x03UL << PD_ICR_P6_Pos)                               /*!< PD ICR: P6 Mask                         */
#define PD_ICR_P7_Pos                         14                                                      /*!< PD ICR: P7 Position                     */
#define PD_ICR_P7_Msk                         (0x03UL << PD_ICR_P7_Pos)                               /*!< PD ICR: P7 Mask                         */
#define PD_ICR_P8_Pos                         16                                                      /*!< PD ICR: P8 Position                     */
#define PD_ICR_P8_Msk                         (0x03UL << PD_ICR_P8_Pos)                               /*!< PD ICR: P8 Mask                         */
#define PD_ICR_P9_Pos                         18                                                      /*!< PD ICR: P9 Position                     */
#define PD_ICR_P9_Msk                         (0x03UL << PD_ICR_P9_Pos)                               /*!< PD ICR: P9 Mask                         */
#define PD_ICR_P10_Pos                        20                                                      /*!< PD ICR: P10 Position                    */
#define PD_ICR_P10_Msk                        (0x03UL << PD_ICR_P10_Pos)                              /*!< PD ICR: P10 Mask                        */
#define PD_ICR_P11_Pos                        22                                                      /*!< PD ICR: P11 Position                    */
#define PD_ICR_P11_Msk                        (0x03UL << PD_ICR_P11_Pos)                              /*!< PD ICR: P11 Mask                        */
#define PD_ICR_P12_Pos                        24                                                      /*!< PD ICR: P12 Position                    */
#define PD_ICR_P12_Msk                        (0x03UL << PD_ICR_P12_Pos)                              /*!< PD ICR: P12 Mask                        */
#define PD_ICR_P13_Pos                        26                                                      /*!< PD ICR: P13 Position                    */
#define PD_ICR_P13_Msk                        (0x03UL << PD_ICR_P13_Pos)                              /*!< PD ICR: P13 Mask                        */
#define PD_ICR_P14_Pos                        28                                                      /*!< PD ICR: P14 Position                    */
#define PD_ICR_P14_Msk                        (0x03UL << PD_ICR_P14_Pos)                              /*!< PD ICR: P14 Mask                        */
#define PD_ICR_P15_Pos                        30                                                      /*!< PD ICR: P15 Position                    */
#define PD_ICR_P15_Msk                        (0x03UL << PD_ICR_P15_Pos)                              /*!< PD ICR: P15 Mask                        */

/* -----------------------------------  PD_STR  ----------------------------------- */
#define PD_STR_P0_Pos                         0                                                       /*!< PD STR: P0 Position                     */
#define PD_STR_P0_Msk                         (0x03UL << PD_STR_P0_Pos)                               /*!< PD STR: P0 Mask                         */
#define PD_STR_P1_Pos                         2                                                       /*!< PD STR: P1 Position                     */
#define PD_STR_P1_Msk                         (0x03UL << PD_STR_P1_Pos)                               /*!< PD STR: P1 Mask                         */
#define PD_STR_P2_Pos                         4                                                       /*!< PD STR: P2 Position                     */
#define PD_STR_P2_Msk                         (0x03UL << PD_STR_P2_Pos)                               /*!< PD STR: P2 Mask                         */
#define PD_STR_P3_Pos                         6                                                       /*!< PD STR: P3 Position                     */
#define PD_STR_P3_Msk                         (0x03UL << PD_STR_P3_Pos)                               /*!< PD STR: P3 Mask                         */
#define PD_STR_P4_Pos                         8                                                       /*!< PD STR: P4 Position                     */
#define PD_STR_P4_Msk                         (0x03UL << PD_STR_P4_Pos)                               /*!< PD STR: P4 Mask                         */


/* ================================================================================ */
/* ================           struct 'PE' Position & Mask          ================ */
/* ================================================================================ */


/* -----------------------------------  PE_MOD  ----------------------------------- */
#define PE_MOD_MODE0_Pos                      0                                                       /*!< PE MOD: MODE0 Position                  */
#define PE_MOD_MODE0_Msk                      (0x03UL << PE_MOD_MODE0_Pos)                            /*!< PE MOD: MODE0 Mask                      */
#define PE_MOD_MODE1_Pos                      2                                                       /*!< PE MOD: MODE1 Position                  */
#define PE_MOD_MODE1_Msk                      (0x03UL << PE_MOD_MODE1_Pos)                            /*!< PE MOD: MODE1 Mask                      */
#define PE_MOD_MODE2_Pos                      4                                                       /*!< PE MOD: MODE2 Position                  */
#define PE_MOD_MODE2_Msk                      (0x03UL << PE_MOD_MODE2_Pos)                            /*!< PE MOD: MODE2 Mask                      */
#define PE_MOD_MODE3_Pos                      6                                                       /*!< PE MOD: MODE3 Position                  */
#define PE_MOD_MODE3_Msk                      (0x03UL << PE_MOD_MODE3_Pos)                            /*!< PE MOD: MODE3 Mask                      */
#define PE_MOD_MODE4_Pos                      8                                                       /*!< PE MOD: MODE4 Position                  */
#define PE_MOD_MODE4_Msk                      (0x03UL << PE_MOD_MODE4_Pos)                            /*!< PE MOD: MODE4 Mask                      */
#define PE_MOD_MODE5_Pos                      10                                                      /*!< PE MOD: MODE5 Position                  */
#define PE_MOD_MODE5_Msk                      (0x03UL << PE_MOD_MODE5_Pos)                            /*!< PE MOD: MODE5 Mask                      */
#define PE_MOD_MODE6_Pos                      12                                                      /*!< PE MOD: MODE6 Position                  */
#define PE_MOD_MODE6_Msk                      (0x03UL << PE_MOD_MODE6_Pos)                            /*!< PE MOD: MODE6 Mask                      */
#define PE_MOD_MODE7_Pos                      14                                                      /*!< PE MOD: MODE7 Position                  */
#define PE_MOD_MODE7_Msk                      (0x03UL << PE_MOD_MODE7_Pos)                            /*!< PE MOD: MODE7 Mask                      */
#define PE_MOD_MODE8_Pos                      16                                                      /*!< PE MOD: MODE8 Position                  */
#define PE_MOD_MODE8_Msk                      (0x03UL << PE_MOD_MODE8_Pos)                            /*!< PE MOD: MODE8 Mask                      */
#define PE_MOD_MODE9_Pos                      18                                                      /*!< PE MOD: MODE9 Position                  */
#define PE_MOD_MODE9_Msk                      (0x03UL << PE_MOD_MODE9_Pos)                            /*!< PE MOD: MODE9 Mask                      */
#define PE_MOD_MODE10_Pos                     20                                                      /*!< PE MOD: MODE10 Position                 */
#define PE_MOD_MODE10_Msk                     (0x03UL << PE_MOD_MODE10_Pos)                           /*!< PE MOD: MODE10 Mask                     */
#define PE_MOD_MODE11_Pos                     22                                                      /*!< PE MOD: MODE11 Position                 */
#define PE_MOD_MODE11_Msk                     (0x03UL << PE_MOD_MODE11_Pos)                           /*!< PE MOD: MODE11 Mask                     */
#define PE_MOD_MODE12_Pos                     24                                                      /*!< PE MOD: MODE12 Position                 */
#define PE_MOD_MODE12_Msk                     (0x03UL << PE_MOD_MODE12_Pos)                           /*!< PE MOD: MODE12 Mask                     */
#define PE_MOD_MODE13_Pos                     26                                                      /*!< PE MOD: MODE13 Position                 */
#define PE_MOD_MODE13_Msk                     (0x03UL << PE_MOD_MODE13_Pos)                           /*!< PE MOD: MODE13 Mask                     */
#define PE_MOD_MODE14_Pos                     28                                                      /*!< PE MOD: MODE14 Position                 */
#define PE_MOD_MODE14_Msk                     (0x03UL << PE_MOD_MODE14_Pos)                           /*!< PE MOD: MODE14 Mask                     */
#define PE_MOD_MODE15_Pos                     30                                                      /*!< PE MOD: MODE15 Position                 */
#define PE_MOD_MODE15_Msk                     (0x03UL << PE_MOD_MODE15_Pos)                           /*!< PE MOD: MODE15 Mask                     */

/* -----------------------------------  PE_TYP  ----------------------------------- */
#define PE_TYP_TYP0_Pos                       0                                                       /*!< PE TYP: TYP0 Position                   */
#define PE_TYP_TYP0_Msk                       (0x01UL << PE_TYP_TYP0_Pos)                             /*!< PE TYP: TYP0 Mask                       */
#define PE_TYP_TYP1_Pos                       1                                                       /*!< PE TYP: TYP1 Position                   */
#define PE_TYP_TYP1_Msk                       (0x01UL << PE_TYP_TYP1_Pos)                             /*!< PE TYP: TYP1 Mask                       */
#define PE_TYP_TYP2_Pos                       2                                                       /*!< PE TYP: TYP2 Position                   */
#define PE_TYP_TYP2_Msk                       (0x01UL << PE_TYP_TYP2_Pos)                             /*!< PE TYP: TYP2 Mask                       */
#define PE_TYP_TYP3_Pos                       3                                                       /*!< PE TYP: TYP3 Position                   */
#define PE_TYP_TYP3_Msk                       (0x01UL << PE_TYP_TYP3_Pos)                             /*!< PE TYP: TYP3 Mask                       */
#define PE_TYP_TYP4_Pos                       4                                                       /*!< PE TYP: TYP4 Position                   */
#define PE_TYP_TYP4_Msk                       (0x01UL << PE_TYP_TYP4_Pos)                             /*!< PE TYP: TYP4 Mask                       */
#define PE_TYP_TYP5_Pos                       5                                                       /*!< PE TYP: TYP5 Position                   */
#define PE_TYP_TYP5_Msk                       (0x01UL << PE_TYP_TYP5_Pos)                             /*!< PE TYP: TYP5 Mask                       */
#define PE_TYP_TYP6_Pos                       6                                                       /*!< PE TYP: TYP6 Position                   */
#define PE_TYP_TYP6_Msk                       (0x01UL << PE_TYP_TYP6_Pos)                             /*!< PE TYP: TYP6 Mask                       */
#define PE_TYP_TYP7_Pos                       7                                                       /*!< PE TYP: TYP7 Position                   */
#define PE_TYP_TYP7_Msk                       (0x01UL << PE_TYP_TYP7_Pos)                             /*!< PE TYP: TYP7 Mask                       */
#define PE_TYP_TYP8_Pos                       8                                                       /*!< PE TYP: TYP8 Position                   */
#define PE_TYP_TYP8_Msk                       (0x01UL << PE_TYP_TYP8_Pos)                             /*!< PE TYP: TYP8 Mask                       */
#define PE_TYP_TYP9_Pos                       9                                                       /*!< PE TYP: TYP9 Position                   */
#define PE_TYP_TYP9_Msk                       (0x01UL << PE_TYP_TYP9_Pos)                             /*!< PE TYP: TYP9 Mask                       */
#define PE_TYP_TYP10_Pos                      10                                                      /*!< PE TYP: TYP10 Position                  */
#define PE_TYP_TYP10_Msk                      (0x01UL << PE_TYP_TYP10_Pos)                            /*!< PE TYP: TYP10 Mask                      */
#define PE_TYP_TYP11_Pos                      11                                                      /*!< PE TYP: TYP11 Position                  */
#define PE_TYP_TYP11_Msk                      (0x01UL << PE_TYP_TYP11_Pos)                            /*!< PE TYP: TYP11 Mask                      */
#define PE_TYP_TYP12_Pos                      12                                                      /*!< PE TYP: TYP12 Position                  */
#define PE_TYP_TYP12_Msk                      (0x01UL << PE_TYP_TYP12_Pos)                            /*!< PE TYP: TYP12 Mask                      */
#define PE_TYP_TYP13_Pos                      13                                                      /*!< PE TYP: TYP13 Position                  */
#define PE_TYP_TYP13_Msk                      (0x01UL << PE_TYP_TYP13_Pos)                            /*!< PE TYP: TYP13 Mask                      */
#define PE_TYP_TYP14_Pos                      14                                                      /*!< PE TYP: TYP14 Position                  */
#define PE_TYP_TYP14_Msk                      (0x01UL << PE_TYP_TYP14_Pos)                            /*!< PE TYP: TYP14 Mask                      */
#define PE_TYP_TYP15_Pos                      15                                                      /*!< PE TYP: TYP15 Position                  */
#define PE_TYP_TYP15_Msk                      (0x01UL << PE_TYP_TYP15_Pos)                            /*!< PE TYP: TYP15 Mask                      */

/* ----------------------------------  PE_AFSR1  ---------------------------------- */
#define PE_AFSR1_AFSR0_Pos                    0                                                       /*!< PE AFSR1: AFSR0 Position                */
#define PE_AFSR1_AFSR0_Msk                    (0x0fUL << PE_AFSR1_AFSR0_Pos)                          /*!< PE AFSR1: AFSR0 Mask                    */
#define PE_AFSR1_AFSR1_Pos                    4                                                       /*!< PE AFSR1: AFSR1 Position                */
#define PE_AFSR1_AFSR1_Msk                    (0x0fUL << PE_AFSR1_AFSR1_Pos)                          /*!< PE AFSR1: AFSR1 Mask                    */
#define PE_AFSR1_AFSR2_Pos                    8                                                       /*!< PE AFSR1: AFSR2 Position                */
#define PE_AFSR1_AFSR2_Msk                    (0x0fUL << PE_AFSR1_AFSR2_Pos)                          /*!< PE AFSR1: AFSR2 Mask                    */
#define PE_AFSR1_AFSR3_Pos                    12                                                      /*!< PE AFSR1: AFSR3 Position                */
#define PE_AFSR1_AFSR3_Msk                    (0x0fUL << PE_AFSR1_AFSR3_Pos)                          /*!< PE AFSR1: AFSR3 Mask                    */
#define PE_AFSR1_AFSR4_Pos                    16                                                      /*!< PE AFSR1: AFSR4 Position                */
#define PE_AFSR1_AFSR4_Msk                    (0x0fUL << PE_AFSR1_AFSR4_Pos)                          /*!< PE AFSR1: AFSR4 Mask                    */
#define PE_AFSR1_AFSR5_Pos                    20                                                      /*!< PE AFSR1: AFSR5 Position                */
#define PE_AFSR1_AFSR5_Msk                    (0x0fUL << PE_AFSR1_AFSR5_Pos)                          /*!< PE AFSR1: AFSR5 Mask                    */
#define PE_AFSR1_AFSR6_Pos                    24                                                      /*!< PE AFSR1: AFSR6 Position                */
#define PE_AFSR1_AFSR6_Msk                    (0x0fUL << PE_AFSR1_AFSR6_Pos)                          /*!< PE AFSR1: AFSR6 Mask                    */
#define PE_AFSR1_AFSR7_Pos                    28                                                      /*!< PE AFSR1: AFSR7 Position                */
#define PE_AFSR1_AFSR7_Msk                    (0x0fUL << PE_AFSR1_AFSR7_Pos)                          /*!< PE AFSR1: AFSR7 Mask                    */

/* ----------------------------------  PE_AFSR2  ---------------------------------- */
#define PE_AFSR2_AFSR8_Pos                    0                                                       /*!< PE AFSR2: AFSR8 Position                */
#define PE_AFSR2_AFSR8_Msk                    (0x0fUL << PE_AFSR2_AFSR8_Pos)                          /*!< PE AFSR2: AFSR8 Mask                    */
#define PE_AFSR2_AFSR9_Pos                    4                                                       /*!< PE AFSR2: AFSR9 Position                */
#define PE_AFSR2_AFSR9_Msk                    (0x0fUL << PE_AFSR2_AFSR9_Pos)                          /*!< PE AFSR2: AFSR9 Mask                    */
#define PE_AFSR2_AFSR10_Pos                   8                                                       /*!< PE AFSR2: AFSR10 Position               */
#define PE_AFSR2_AFSR10_Msk                   (0x0fUL << PE_AFSR2_AFSR10_Pos)                         /*!< PE AFSR2: AFSR10 Mask                   */
#define PE_AFSR2_AFSR11_Pos                   12                                                      /*!< PE AFSR2: AFSR11 Position               */
#define PE_AFSR2_AFSR11_Msk                   (0x0fUL << PE_AFSR2_AFSR11_Pos)                         /*!< PE AFSR2: AFSR11 Mask                   */
#define PE_AFSR2_AFSR12_Pos                   16                                                      /*!< PE AFSR2: AFSR12 Position               */
#define PE_AFSR2_AFSR12_Msk                   (0x0fUL << PE_AFSR2_AFSR12_Pos)                         /*!< PE AFSR2: AFSR12 Mask                   */
#define PE_AFSR2_AFSR13_Pos                   20                                                      /*!< PE AFSR2: AFSR13 Position               */
#define PE_AFSR2_AFSR13_Msk                   (0x0fUL << PE_AFSR2_AFSR13_Pos)                         /*!< PE AFSR2: AFSR13 Mask                   */
#define PE_AFSR2_AFSR14_Pos                   24                                                      /*!< PE AFSR2: AFSR14 Position               */
#define PE_AFSR2_AFSR14_Msk                   (0x0fUL << PE_AFSR2_AFSR14_Pos)                         /*!< PE AFSR2: AFSR14 Mask                   */
#define PE_AFSR2_AFSR15_Pos                   28                                                      /*!< PE AFSR2: AFSR15 Position               */
#define PE_AFSR2_AFSR15_Msk                   (0x0fUL << PE_AFSR2_AFSR15_Pos)                         /*!< PE AFSR2: AFSR15 Mask                   */

/* -----------------------------------  PE_PUPD  ---------------------------------- */
#define PE_PUPD_PUPD0_Pos                     0                                                       /*!< PE PUPD: PUPD0 Position                 */
#define PE_PUPD_PUPD0_Msk                     (0x03UL << PE_PUPD_PUPD0_Pos)                           /*!< PE PUPD: PUPD0 Mask                     */
#define PE_PUPD_PUPD1_Pos                     2                                                       /*!< PE PUPD: PUPD1 Position                 */
#define PE_PUPD_PUPD1_Msk                     (0x03UL << PE_PUPD_PUPD1_Pos)                           /*!< PE PUPD: PUPD1 Mask                     */
#define PE_PUPD_PUPD2_Pos                     4                                                       /*!< PE PUPD: PUPD2 Position                 */
#define PE_PUPD_PUPD2_Msk                     (0x03UL << PE_PUPD_PUPD2_Pos)                           /*!< PE PUPD: PUPD2 Mask                     */
#define PE_PUPD_PUPD3_Pos                     6                                                       /*!< PE PUPD: PUPD3 Position                 */
#define PE_PUPD_PUPD3_Msk                     (0x03UL << PE_PUPD_PUPD3_Pos)                           /*!< PE PUPD: PUPD3 Mask                     */
#define PE_PUPD_PUPD4_Pos                     8                                                       /*!< PE PUPD: PUPD4 Position                 */
#define PE_PUPD_PUPD4_Msk                     (0x03UL << PE_PUPD_PUPD4_Pos)                           /*!< PE PUPD: PUPD4 Mask                     */
#define PE_PUPD_PUPD5_Pos                     10                                                      /*!< PE PUPD: PUPD5 Position                 */
#define PE_PUPD_PUPD5_Msk                     (0x03UL << PE_PUPD_PUPD5_Pos)                           /*!< PE PUPD: PUPD5 Mask                     */
#define PE_PUPD_PUPD6_Pos                     12                                                      /*!< PE PUPD: PUPD6 Position                 */
#define PE_PUPD_PUPD6_Msk                     (0x03UL << PE_PUPD_PUPD6_Pos)                           /*!< PE PUPD: PUPD6 Mask                     */
#define PE_PUPD_PUPD7_Pos                     14                                                      /*!< PE PUPD: PUPD7 Position                 */
#define PE_PUPD_PUPD7_Msk                     (0x03UL << PE_PUPD_PUPD7_Pos)                           /*!< PE PUPD: PUPD7 Mask                     */
#define PE_PUPD_PUPD8_Pos                     16                                                      /*!< PE PUPD: PUPD8 Position                 */
#define PE_PUPD_PUPD8_Msk                     (0x03UL << PE_PUPD_PUPD8_Pos)                           /*!< PE PUPD: PUPD8 Mask                     */
#define PE_PUPD_PUPD9_Pos                     18                                                      /*!< PE PUPD: PUPD9 Position                 */
#define PE_PUPD_PUPD9_Msk                     (0x03UL << PE_PUPD_PUPD9_Pos)                           /*!< PE PUPD: PUPD9 Mask                     */
#define PE_PUPD_PUPD10_Pos                    20                                                      /*!< PE PUPD: PUPD10 Position                */
#define PE_PUPD_PUPD10_Msk                    (0x03UL << PE_PUPD_PUPD10_Pos)                          /*!< PE PUPD: PUPD10 Mask                    */
#define PE_PUPD_PUPD11_Pos                    22                                                      /*!< PE PUPD: PUPD11 Position                */
#define PE_PUPD_PUPD11_Msk                    (0x03UL << PE_PUPD_PUPD11_Pos)                          /*!< PE PUPD: PUPD11 Mask                    */
#define PE_PUPD_PUPD12_Pos                    24                                                      /*!< PE PUPD: PUPD12 Position                */
#define PE_PUPD_PUPD12_Msk                    (0x03UL << PE_PUPD_PUPD12_Pos)                          /*!< PE PUPD: PUPD12 Mask                    */
#define PE_PUPD_PUPD13_Pos                    26                                                      /*!< PE PUPD: PUPD13 Position                */
#define PE_PUPD_PUPD13_Msk                    (0x03UL << PE_PUPD_PUPD13_Pos)                          /*!< PE PUPD: PUPD13 Mask                    */
#define PE_PUPD_PUPD14_Pos                    28                                                      /*!< PE PUPD: PUPD14 Position                */
#define PE_PUPD_PUPD14_Msk                    (0x03UL << PE_PUPD_PUPD14_Pos)                          /*!< PE PUPD: PUPD14 Mask                    */
#define PE_PUPD_PUPD15_Pos                    30                                                      /*!< PE PUPD: PUPD15 Position                */
#define PE_PUPD_PUPD15_Msk                    (0x03UL << PE_PUPD_PUPD15_Pos)                          /*!< PE PUPD: PUPD15 Mask                    */

/* -----------------------------------  PE_INDR  ---------------------------------- */
#define PE_INDR_INDR0_Pos                     0                                                       /*!< PE INDR: INDR0 Position                 */
#define PE_INDR_INDR0_Msk                     (0x01UL << PE_INDR_INDR0_Pos)                           /*!< PE INDR: INDR0 Mask                     */
#define PE_INDR_INDR1_Pos                     1                                                       /*!< PE INDR: INDR1 Position                 */
#define PE_INDR_INDR1_Msk                     (0x01UL << PE_INDR_INDR1_Pos)                           /*!< PE INDR: INDR1 Mask                     */
#define PE_INDR_INDR2_Pos                     2                                                       /*!< PE INDR: INDR2 Position                 */
#define PE_INDR_INDR2_Msk                     (0x01UL << PE_INDR_INDR2_Pos)                           /*!< PE INDR: INDR2 Mask                     */
#define PE_INDR_INDR3_Pos                     3                                                       /*!< PE INDR: INDR3 Position                 */
#define PE_INDR_INDR3_Msk                     (0x01UL << PE_INDR_INDR3_Pos)                           /*!< PE INDR: INDR3 Mask                     */
#define PE_INDR_INDR4_Pos                     4                                                       /*!< PE INDR: INDR4 Position                 */
#define PE_INDR_INDR4_Msk                     (0x01UL << PE_INDR_INDR4_Pos)                           /*!< PE INDR: INDR4 Mask                     */
#define PE_INDR_INDR5_Pos                     5                                                       /*!< PE INDR: INDR5 Position                 */
#define PE_INDR_INDR5_Msk                     (0x01UL << PE_INDR_INDR5_Pos)                           /*!< PE INDR: INDR5 Mask                     */
#define PE_INDR_INDR6_Pos                     6                                                       /*!< PE INDR: INDR6 Position                 */
#define PE_INDR_INDR6_Msk                     (0x01UL << PE_INDR_INDR6_Pos)                           /*!< PE INDR: INDR6 Mask                     */
#define PE_INDR_INDR7_Pos                     7                                                       /*!< PE INDR: INDR7 Position                 */
#define PE_INDR_INDR7_Msk                     (0x01UL << PE_INDR_INDR7_Pos)                           /*!< PE INDR: INDR7 Mask                     */
#define PE_INDR_INDR8_Pos                     8                                                       /*!< PE INDR: INDR8 Position                 */
#define PE_INDR_INDR8_Msk                     (0x01UL << PE_INDR_INDR8_Pos)                           /*!< PE INDR: INDR8 Mask                     */
#define PE_INDR_INDR9_Pos                     9                                                       /*!< PE INDR: INDR9 Position                 */
#define PE_INDR_INDR9_Msk                     (0x01UL << PE_INDR_INDR9_Pos)                           /*!< PE INDR: INDR9 Mask                     */
#define PE_INDR_INDR10_Pos                    10                                                      /*!< PE INDR: INDR10 Position                */
#define PE_INDR_INDR10_Msk                    (0x01UL << PE_INDR_INDR10_Pos)                          /*!< PE INDR: INDR10 Mask                    */
#define PE_INDR_INDR11_Pos                    11                                                      /*!< PE INDR: INDR11 Position                */
#define PE_INDR_INDR11_Msk                    (0x01UL << PE_INDR_INDR11_Pos)                          /*!< PE INDR: INDR11 Mask                    */
#define PE_INDR_INDR12_Pos                    12                                                      /*!< PE INDR: INDR12 Position                */
#define PE_INDR_INDR12_Msk                    (0x01UL << PE_INDR_INDR12_Pos)                          /*!< PE INDR: INDR12 Mask                    */
#define PE_INDR_INDR13_Pos                    13                                                      /*!< PE INDR: INDR13 Position                */
#define PE_INDR_INDR13_Msk                    (0x01UL << PE_INDR_INDR13_Pos)                          /*!< PE INDR: INDR13 Mask                    */
#define PE_INDR_INDR14_Pos                    14                                                      /*!< PE INDR: INDR14 Position                */
#define PE_INDR_INDR14_Msk                    (0x01UL << PE_INDR_INDR14_Pos)                          /*!< PE INDR: INDR14 Mask                    */
#define PE_INDR_INDR15_Pos                    15                                                      /*!< PE INDR: INDR15 Position                */
#define PE_INDR_INDR15_Msk                    (0x01UL << PE_INDR_INDR15_Pos)                          /*!< PE INDR: INDR15 Mask                    */

/* ----------------------------------  PE_OUTDR  ---------------------------------- */
#define PE_OUTDR_OUTDR0_Pos                   0                                                       /*!< PE OUTDR: OUTDR0 Position               */
#define PE_OUTDR_OUTDR0_Msk                   (0x01UL << PE_OUTDR_OUTDR0_Pos)                         /*!< PE OUTDR: OUTDR0 Mask                   */
#define PE_OUTDR_OUTDR1_Pos                   1                                                       /*!< PE OUTDR: OUTDR1 Position               */
#define PE_OUTDR_OUTDR1_Msk                   (0x01UL << PE_OUTDR_OUTDR1_Pos)                         /*!< PE OUTDR: OUTDR1 Mask                   */
#define PE_OUTDR_OUTDR2_Pos                   2                                                       /*!< PE OUTDR: OUTDR2 Position               */
#define PE_OUTDR_OUTDR2_Msk                   (0x01UL << PE_OUTDR_OUTDR2_Pos)                         /*!< PE OUTDR: OUTDR2 Mask                   */
#define PE_OUTDR_OUTDR3_Pos                   3                                                       /*!< PE OUTDR: OUTDR3 Position               */
#define PE_OUTDR_OUTDR3_Msk                   (0x01UL << PE_OUTDR_OUTDR3_Pos)                         /*!< PE OUTDR: OUTDR3 Mask                   */
#define PE_OUTDR_OUTDR4_Pos                   4                                                       /*!< PE OUTDR: OUTDR4 Position               */
#define PE_OUTDR_OUTDR4_Msk                   (0x01UL << PE_OUTDR_OUTDR4_Pos)                         /*!< PE OUTDR: OUTDR4 Mask                   */
#define PE_OUTDR_OUTDR5_Pos                   5                                                       /*!< PE OUTDR: OUTDR5 Position               */
#define PE_OUTDR_OUTDR5_Msk                   (0x01UL << PE_OUTDR_OUTDR5_Pos)                         /*!< PE OUTDR: OUTDR5 Mask                   */
#define PE_OUTDR_OUTDR6_Pos                   6                                                       /*!< PE OUTDR: OUTDR6 Position               */
#define PE_OUTDR_OUTDR6_Msk                   (0x01UL << PE_OUTDR_OUTDR6_Pos)                         /*!< PE OUTDR: OUTDR6 Mask                   */
#define PE_OUTDR_OUTDR7_Pos                   7                                                       /*!< PE OUTDR: OUTDR7 Position               */
#define PE_OUTDR_OUTDR7_Msk                   (0x01UL << PE_OUTDR_OUTDR7_Pos)                         /*!< PE OUTDR: OUTDR7 Mask                   */
#define PE_OUTDR_OUTDR8_Pos                   8                                                       /*!< PE OUTDR: OUTDR8 Position               */
#define PE_OUTDR_OUTDR8_Msk                   (0x01UL << PE_OUTDR_OUTDR8_Pos)                         /*!< PE OUTDR: OUTDR8 Mask                   */
#define PE_OUTDR_OUTDR9_Pos                   9                                                       /*!< PE OUTDR: OUTDR9 Position               */
#define PE_OUTDR_OUTDR9_Msk                   (0x01UL << PE_OUTDR_OUTDR9_Pos)                         /*!< PE OUTDR: OUTDR9 Mask                   */
#define PE_OUTDR_OUTDR10_Pos                  10                                                      /*!< PE OUTDR: OUTDR10 Position              */
#define PE_OUTDR_OUTDR10_Msk                  (0x01UL << PE_OUTDR_OUTDR10_Pos)                        /*!< PE OUTDR: OUTDR10 Mask                  */
#define PE_OUTDR_OUTDR11_Pos                  11                                                      /*!< PE OUTDR: OUTDR11 Position              */
#define PE_OUTDR_OUTDR11_Msk                  (0x01UL << PE_OUTDR_OUTDR11_Pos)                        /*!< PE OUTDR: OUTDR11 Mask                  */
#define PE_OUTDR_OUTDR12_Pos                  12                                                      /*!< PE OUTDR: OUTDR12 Position              */
#define PE_OUTDR_OUTDR12_Msk                  (0x01UL << PE_OUTDR_OUTDR12_Pos)                        /*!< PE OUTDR: OUTDR12 Mask                  */
#define PE_OUTDR_OUTDR13_Pos                  13                                                      /*!< PE OUTDR: OUTDR13 Position              */
#define PE_OUTDR_OUTDR13_Msk                  (0x01UL << PE_OUTDR_OUTDR13_Pos)                        /*!< PE OUTDR: OUTDR13 Mask                  */
#define PE_OUTDR_OUTDR14_Pos                  14                                                      /*!< PE OUTDR: OUTDR14 Position              */
#define PE_OUTDR_OUTDR14_Msk                  (0x01UL << PE_OUTDR_OUTDR14_Pos)                        /*!< PE OUTDR: OUTDR14 Mask                  */
#define PE_OUTDR_OUTDR15_Pos                  15                                                      /*!< PE OUTDR: OUTDR15 Position              */
#define PE_OUTDR_OUTDR15_Msk                  (0x01UL << PE_OUTDR_OUTDR15_Pos)                        /*!< PE OUTDR: OUTDR15 Mask                  */

/* -----------------------------------  PE_BSR  ----------------------------------- */
#define PE_BSR_BSR0_Pos                       0                                                       /*!< PE BSR: BSR0 Position                   */
#define PE_BSR_BSR0_Msk                       (0x01UL << PE_BSR_BSR0_Pos)                             /*!< PE BSR: BSR0 Mask                       */
#define PE_BSR_BSR1_Pos                       1                                                       /*!< PE BSR: BSR1 Position                   */
#define PE_BSR_BSR1_Msk                       (0x01UL << PE_BSR_BSR1_Pos)                             /*!< PE BSR: BSR1 Mask                       */
#define PE_BSR_BSR2_Pos                       2                                                       /*!< PE BSR: BSR2 Position                   */
#define PE_BSR_BSR2_Msk                       (0x01UL << PE_BSR_BSR2_Pos)                             /*!< PE BSR: BSR2 Mask                       */
#define PE_BSR_BSR3_Pos                       3                                                       /*!< PE BSR: BSR3 Position                   */
#define PE_BSR_BSR3_Msk                       (0x01UL << PE_BSR_BSR3_Pos)                             /*!< PE BSR: BSR3 Mask                       */
#define PE_BSR_BSR4_Pos                       4                                                       /*!< PE BSR: BSR4 Position                   */
#define PE_BSR_BSR4_Msk                       (0x01UL << PE_BSR_BSR4_Pos)                             /*!< PE BSR: BSR4 Mask                       */
#define PE_BSR_BSR5_Pos                       5                                                       /*!< PE BSR: BSR5 Position                   */
#define PE_BSR_BSR5_Msk                       (0x01UL << PE_BSR_BSR5_Pos)                             /*!< PE BSR: BSR5 Mask                       */
#define PE_BSR_BSR6_Pos                       6                                                       /*!< PE BSR: BSR6 Position                   */
#define PE_BSR_BSR6_Msk                       (0x01UL << PE_BSR_BSR6_Pos)                             /*!< PE BSR: BSR6 Mask                       */
#define PE_BSR_BSR7_Pos                       7                                                       /*!< PE BSR: BSR7 Position                   */
#define PE_BSR_BSR7_Msk                       (0x01UL << PE_BSR_BSR7_Pos)                             /*!< PE BSR: BSR7 Mask                       */
#define PE_BSR_BSR8_Pos                       8                                                       /*!< PE BSR: BSR8 Position                   */
#define PE_BSR_BSR8_Msk                       (0x01UL << PE_BSR_BSR8_Pos)                             /*!< PE BSR: BSR8 Mask                       */
#define PE_BSR_BSR9_Pos                       9                                                       /*!< PE BSR: BSR9 Position                   */
#define PE_BSR_BSR9_Msk                       (0x01UL << PE_BSR_BSR9_Pos)                             /*!< PE BSR: BSR9 Mask                       */
#define PE_BSR_BSR10_Pos                      10                                                      /*!< PE BSR: BSR10 Position                  */
#define PE_BSR_BSR10_Msk                      (0x01UL << PE_BSR_BSR10_Pos)                            /*!< PE BSR: BSR10 Mask                      */
#define PE_BSR_BSR11_Pos                      11                                                      /*!< PE BSR: BSR11 Position                  */
#define PE_BSR_BSR11_Msk                      (0x01UL << PE_BSR_BSR11_Pos)                            /*!< PE BSR: BSR11 Mask                      */
#define PE_BSR_BSR12_Pos                      12                                                      /*!< PE BSR: BSR12 Position                  */
#define PE_BSR_BSR12_Msk                      (0x01UL << PE_BSR_BSR12_Pos)                            /*!< PE BSR: BSR12 Mask                      */
#define PE_BSR_BSR13_Pos                      13                                                      /*!< PE BSR: BSR13 Position                  */
#define PE_BSR_BSR13_Msk                      (0x01UL << PE_BSR_BSR13_Pos)                            /*!< PE BSR: BSR13 Mask                      */
#define PE_BSR_BSR14_Pos                      14                                                      /*!< PE BSR: BSR14 Position                  */
#define PE_BSR_BSR14_Msk                      (0x01UL << PE_BSR_BSR14_Pos)                            /*!< PE BSR: BSR14 Mask                      */
#define PE_BSR_BSR15_Pos                      15                                                      /*!< PE BSR: BSR15 Position                  */
#define PE_BSR_BSR15_Msk                      (0x01UL << PE_BSR_BSR15_Pos)                            /*!< PE BSR: BSR15 Mask                      */

/* -----------------------------------  PE_BCR  ----------------------------------- */
#define PE_BCR_BCR0_Pos                       0                                                       /*!< PE BCR: BCR0 Position                   */
#define PE_BCR_BCR0_Msk                       (0x01UL << PE_BCR_BCR0_Pos)                             /*!< PE BCR: BCR0 Mask                       */
#define PE_BCR_BCR1_Pos                       1                                                       /*!< PE BCR: BCR1 Position                   */
#define PE_BCR_BCR1_Msk                       (0x01UL << PE_BCR_BCR1_Pos)                             /*!< PE BCR: BCR1 Mask                       */
#define PE_BCR_BCR2_Pos                       2                                                       /*!< PE BCR: BCR2 Position                   */
#define PE_BCR_BCR2_Msk                       (0x01UL << PE_BCR_BCR2_Pos)                             /*!< PE BCR: BCR2 Mask                       */
#define PE_BCR_BCR3_Pos                       3                                                       /*!< PE BCR: BCR3 Position                   */
#define PE_BCR_BCR3_Msk                       (0x01UL << PE_BCR_BCR3_Pos)                             /*!< PE BCR: BCR3 Mask                       */
#define PE_BCR_BCR4_Pos                       4                                                       /*!< PE BCR: BCR4 Position                   */
#define PE_BCR_BCR4_Msk                       (0x01UL << PE_BCR_BCR4_Pos)                             /*!< PE BCR: BCR4 Mask                       */
#define PE_BCR_BCR5_Pos                       5                                                       /*!< PE BCR: BCR5 Position                   */
#define PE_BCR_BCR5_Msk                       (0x01UL << PE_BCR_BCR5_Pos)                             /*!< PE BCR: BCR5 Mask                       */
#define PE_BCR_BCR6_Pos                       6                                                       /*!< PE BCR: BCR6 Position                   */
#define PE_BCR_BCR6_Msk                       (0x01UL << PE_BCR_BCR6_Pos)                             /*!< PE BCR: BCR6 Mask                       */
#define PE_BCR_BCR7_Pos                       7                                                       /*!< PE BCR: BCR7 Position                   */
#define PE_BCR_BCR7_Msk                       (0x01UL << PE_BCR_BCR7_Pos)                             /*!< PE BCR: BCR7 Mask                       */
#define PE_BCR_BCR8_Pos                       8                                                       /*!< PE BCR: BCR8 Position                   */
#define PE_BCR_BCR8_Msk                       (0x01UL << PE_BCR_BCR8_Pos)                             /*!< PE BCR: BCR8 Mask                       */
#define PE_BCR_BCR9_Pos                       9                                                       /*!< PE BCR: BCR9 Position                   */
#define PE_BCR_BCR9_Msk                       (0x01UL << PE_BCR_BCR9_Pos)                             /*!< PE BCR: BCR9 Mask                       */
#define PE_BCR_BCR10_Pos                      10                                                      /*!< PE BCR: BCR10 Position                  */
#define PE_BCR_BCR10_Msk                      (0x01UL << PE_BCR_BCR10_Pos)                            /*!< PE BCR: BCR10 Mask                      */
#define PE_BCR_BCR11_Pos                      11                                                      /*!< PE BCR: BCR11 Position                  */
#define PE_BCR_BCR11_Msk                      (0x01UL << PE_BCR_BCR11_Pos)                            /*!< PE BCR: BCR11 Mask                      */
#define PE_BCR_BCR12_Pos                      12                                                      /*!< PE BCR: BCR12 Position                  */
#define PE_BCR_BCR12_Msk                      (0x01UL << PE_BCR_BCR12_Pos)                            /*!< PE BCR: BCR12 Mask                      */
#define PE_BCR_BCR13_Pos                      13                                                      /*!< PE BCR: BCR13 Position                  */
#define PE_BCR_BCR13_Msk                      (0x01UL << PE_BCR_BCR13_Pos)                            /*!< PE BCR: BCR13 Mask                      */
#define PE_BCR_BCR14_Pos                      14                                                      /*!< PE BCR: BCR14 Position                  */
#define PE_BCR_BCR14_Msk                      (0x01UL << PE_BCR_BCR14_Pos)                            /*!< PE BCR: BCR14 Mask                      */
#define PE_BCR_BCR15_Pos                      15                                                      /*!< PE BCR: BCR15 Position                  */
#define PE_BCR_BCR15_Msk                      (0x01UL << PE_BCR_BCR15_Pos)                            /*!< PE BCR: BCR15 Mask                      */

/* ---------------------------------  PE_OUTDMSK  --------------------------------- */
#define PE_OUTDMSK_OUTDMSK0_Pos               0                                                       /*!< PE OUTDMSK: OUTDMSK0 Position           */
#define PE_OUTDMSK_OUTDMSK0_Msk               (0x01UL << PE_OUTDMSK_OUTDMSK0_Pos)                     /*!< PE OUTDMSK: OUTDMSK0 Mask               */
#define PE_OUTDMSK_OUTDMSK1_Pos               1                                                       /*!< PE OUTDMSK: OUTDMSK1 Position           */
#define PE_OUTDMSK_OUTDMSK1_Msk               (0x01UL << PE_OUTDMSK_OUTDMSK1_Pos)                     /*!< PE OUTDMSK: OUTDMSK1 Mask               */
#define PE_OUTDMSK_OUTDMSK2_Pos               2                                                       /*!< PE OUTDMSK: OUTDMSK2 Position           */
#define PE_OUTDMSK_OUTDMSK2_Msk               (0x01UL << PE_OUTDMSK_OUTDMSK2_Pos)                     /*!< PE OUTDMSK: OUTDMSK2 Mask               */
#define PE_OUTDMSK_OUTDMSK3_Pos               3                                                       /*!< PE OUTDMSK: OUTDMSK3 Position           */
#define PE_OUTDMSK_OUTDMSK3_Msk               (0x01UL << PE_OUTDMSK_OUTDMSK3_Pos)                     /*!< PE OUTDMSK: OUTDMSK3 Mask               */
#define PE_OUTDMSK_OUTDMSK4_Pos               4                                                       /*!< PE OUTDMSK: OUTDMSK4 Position           */
#define PE_OUTDMSK_OUTDMSK4_Msk               (0x01UL << PE_OUTDMSK_OUTDMSK4_Pos)                     /*!< PE OUTDMSK: OUTDMSK4 Mask               */
#define PE_OUTDMSK_OUTDMSK5_Pos               5                                                       /*!< PE OUTDMSK: OUTDMSK5 Position           */
#define PE_OUTDMSK_OUTDMSK5_Msk               (0x01UL << PE_OUTDMSK_OUTDMSK5_Pos)                     /*!< PE OUTDMSK: OUTDMSK5 Mask               */
#define PE_OUTDMSK_OUTDMSK6_Pos               6                                                       /*!< PE OUTDMSK: OUTDMSK6 Position           */
#define PE_OUTDMSK_OUTDMSK6_Msk               (0x01UL << PE_OUTDMSK_OUTDMSK6_Pos)                     /*!< PE OUTDMSK: OUTDMSK6 Mask               */
#define PE_OUTDMSK_OUTDMSK7_Pos               7                                                       /*!< PE OUTDMSK: OUTDMSK7 Position           */
#define PE_OUTDMSK_OUTDMSK7_Msk               (0x01UL << PE_OUTDMSK_OUTDMSK7_Pos)                     /*!< PE OUTDMSK: OUTDMSK7 Mask               */
#define PE_OUTDMSK_OUTDMSK8_Pos               8                                                       /*!< PE OUTDMSK: OUTDMSK8 Position           */
#define PE_OUTDMSK_OUTDMSK8_Msk               (0x01UL << PE_OUTDMSK_OUTDMSK8_Pos)                     /*!< PE OUTDMSK: OUTDMSK8 Mask               */
#define PE_OUTDMSK_OUTDMSK9_Pos               9                                                       /*!< PE OUTDMSK: OUTDMSK9 Position           */
#define PE_OUTDMSK_OUTDMSK9_Msk               (0x01UL << PE_OUTDMSK_OUTDMSK9_Pos)                     /*!< PE OUTDMSK: OUTDMSK9 Mask               */
#define PE_OUTDMSK_OUTDMSK10_Pos              10                                                      /*!< PE OUTDMSK: OUTDMSK10 Position          */
#define PE_OUTDMSK_OUTDMSK10_Msk              (0x01UL << PE_OUTDMSK_OUTDMSK10_Pos)                    /*!< PE OUTDMSK: OUTDMSK10 Mask              */
#define PE_OUTDMSK_OUTDMSK11_Pos              11                                                      /*!< PE OUTDMSK: OUTDMSK11 Position          */
#define PE_OUTDMSK_OUTDMSK11_Msk              (0x01UL << PE_OUTDMSK_OUTDMSK11_Pos)                    /*!< PE OUTDMSK: OUTDMSK11 Mask              */
#define PE_OUTDMSK_OUTDMSK12_Pos              12                                                      /*!< PE OUTDMSK: OUTDMSK12 Position          */
#define PE_OUTDMSK_OUTDMSK12_Msk              (0x01UL << PE_OUTDMSK_OUTDMSK12_Pos)                    /*!< PE OUTDMSK: OUTDMSK12 Mask              */
#define PE_OUTDMSK_OUTDMSK13_Pos              13                                                      /*!< PE OUTDMSK: OUTDMSK13 Position          */
#define PE_OUTDMSK_OUTDMSK13_Msk              (0x01UL << PE_OUTDMSK_OUTDMSK13_Pos)                    /*!< PE OUTDMSK: OUTDMSK13 Mask              */
#define PE_OUTDMSK_OUTDMSK14_Pos              14                                                      /*!< PE OUTDMSK: OUTDMSK14 Position          */
#define PE_OUTDMSK_OUTDMSK14_Msk              (0x01UL << PE_OUTDMSK_OUTDMSK14_Pos)                    /*!< PE OUTDMSK: OUTDMSK14 Mask              */
#define PE_OUTDMSK_OUTDMSK15_Pos              15                                                      /*!< PE OUTDMSK: OUTDMSK15 Position          */
#define PE_OUTDMSK_OUTDMSK15_Msk              (0x01UL << PE_OUTDMSK_OUTDMSK15_Pos)                    /*!< PE OUTDMSK: OUTDMSK15 Mask              */

/* -----------------------------------  PE_DBCR  ---------------------------------- */
#define PE_DBCR_DBEN0_Pos                     0                                                       /*!< PE DBCR: DBEN0 Position                 */
#define PE_DBCR_DBEN0_Msk                     (0x01UL << PE_DBCR_DBEN0_Pos)                           /*!< PE DBCR: DBEN0 Mask                     */
#define PE_DBCR_DBEN1_Pos                     1                                                       /*!< PE DBCR: DBEN1 Position                 */
#define PE_DBCR_DBEN1_Msk                     (0x01UL << PE_DBCR_DBEN1_Pos)                           /*!< PE DBCR: DBEN1 Mask                     */
#define PE_DBCR_DBEN2_Pos                     2                                                       /*!< PE DBCR: DBEN2 Position                 */
#define PE_DBCR_DBEN2_Msk                     (0x01UL << PE_DBCR_DBEN2_Pos)                           /*!< PE DBCR: DBEN2 Mask                     */
#define PE_DBCR_DBEN3_Pos                     3                                                       /*!< PE DBCR: DBEN3 Position                 */
#define PE_DBCR_DBEN3_Msk                     (0x01UL << PE_DBCR_DBEN3_Pos)                           /*!< PE DBCR: DBEN3 Mask                     */
#define PE_DBCR_DBEN4_Pos                     4                                                       /*!< PE DBCR: DBEN4 Position                 */
#define PE_DBCR_DBEN4_Msk                     (0x01UL << PE_DBCR_DBEN4_Pos)                           /*!< PE DBCR: DBEN4 Mask                     */
#define PE_DBCR_DBEN5_Pos                     5                                                       /*!< PE DBCR: DBEN5 Position                 */
#define PE_DBCR_DBEN5_Msk                     (0x01UL << PE_DBCR_DBEN5_Pos)                           /*!< PE DBCR: DBEN5 Mask                     */
#define PE_DBCR_DBEN6_Pos                     6                                                       /*!< PE DBCR: DBEN6 Position                 */
#define PE_DBCR_DBEN6_Msk                     (0x01UL << PE_DBCR_DBEN6_Pos)                           /*!< PE DBCR: DBEN6 Mask                     */
#define PE_DBCR_DBEN7_Pos                     7                                                       /*!< PE DBCR: DBEN7 Position                 */
#define PE_DBCR_DBEN7_Msk                     (0x01UL << PE_DBCR_DBEN7_Pos)                           /*!< PE DBCR: DBEN7 Mask                     */
#define PE_DBCR_DBEN8_Pos                     8                                                       /*!< PE DBCR: DBEN8 Position                 */
#define PE_DBCR_DBEN8_Msk                     (0x01UL << PE_DBCR_DBEN8_Pos)                           /*!< PE DBCR: DBEN8 Mask                     */
#define PE_DBCR_DBEN9_Pos                     9                                                       /*!< PE DBCR: DBEN9 Position                 */
#define PE_DBCR_DBEN9_Msk                     (0x01UL << PE_DBCR_DBEN9_Pos)                           /*!< PE DBCR: DBEN9 Mask                     */
#define PE_DBCR_DBEN10_Pos                    10                                                      /*!< PE DBCR: DBEN10 Position                */
#define PE_DBCR_DBEN10_Msk                    (0x01UL << PE_DBCR_DBEN10_Pos)                          /*!< PE DBCR: DBEN10 Mask                    */
#define PE_DBCR_DBEN11_Pos                    11                                                      /*!< PE DBCR: DBEN11 Position                */
#define PE_DBCR_DBEN11_Msk                    (0x01UL << PE_DBCR_DBEN11_Pos)                          /*!< PE DBCR: DBEN11 Mask                    */
#define PE_DBCR_DBEN12_Pos                    12                                                      /*!< PE DBCR: DBEN12 Position                */
#define PE_DBCR_DBEN12_Msk                    (0x01UL << PE_DBCR_DBEN12_Pos)                          /*!< PE DBCR: DBEN12 Mask                    */
#define PE_DBCR_DBEN13_Pos                    13                                                      /*!< PE DBCR: DBEN13 Position                */
#define PE_DBCR_DBEN13_Msk                    (0x01UL << PE_DBCR_DBEN13_Pos)                          /*!< PE DBCR: DBEN13 Mask                    */
#define PE_DBCR_DBEN14_Pos                    14                                                      /*!< PE DBCR: DBEN14 Position                */
#define PE_DBCR_DBEN14_Msk                    (0x01UL << PE_DBCR_DBEN14_Pos)                          /*!< PE DBCR: DBEN14 Mask                    */
#define PE_DBCR_DBEN15_Pos                    15                                                      /*!< PE DBCR: DBEN15 Position                */
#define PE_DBCR_DBEN15_Msk                    (0x01UL << PE_DBCR_DBEN15_Pos)                          /*!< PE DBCR: DBEN15 Mask                    */

/* -----------------------------------  PE_IER  ----------------------------------- */
#define PE_IER_P0_Pos                         0                                                       /*!< PE IER: P0 Position                     */
#define PE_IER_P0_Msk                         (0x03UL << PE_IER_P0_Pos)                               /*!< PE IER: P0 Mask                         */
#define PE_IER_P1_Pos                         2                                                       /*!< PE IER: P1 Position                     */
#define PE_IER_P1_Msk                         (0x03UL << PE_IER_P1_Pos)                               /*!< PE IER: P1 Mask                         */
#define PE_IER_P2_Pos                         4                                                       /*!< PE IER: P2 Position                     */
#define PE_IER_P2_Msk                         (0x03UL << PE_IER_P2_Pos)                               /*!< PE IER: P2 Mask                         */
#define PE_IER_P3_Pos                         6                                                       /*!< PE IER: P3 Position                     */
#define PE_IER_P3_Msk                         (0x03UL << PE_IER_P3_Pos)                               /*!< PE IER: P3 Mask                         */
#define PE_IER_P4_Pos                         8                                                       /*!< PE IER: P4 Position                     */
#define PE_IER_P4_Msk                         (0x03UL << PE_IER_P4_Pos)                               /*!< PE IER: P4 Mask                         */
#define PE_IER_P5_Pos                         10                                                      /*!< PE IER: P5 Position                     */
#define PE_IER_P5_Msk                         (0x03UL << PE_IER_P5_Pos)                               /*!< PE IER: P5 Mask                         */
#define PE_IER_P6_Pos                         12                                                      /*!< PE IER: P6 Position                     */
#define PE_IER_P6_Msk                         (0x03UL << PE_IER_P6_Pos)                               /*!< PE IER: P6 Mask                         */
#define PE_IER_P7_Pos                         14                                                      /*!< PE IER: P7 Position                     */
#define PE_IER_P7_Msk                         (0x03UL << PE_IER_P7_Pos)                               /*!< PE IER: P7 Mask                         */
#define PE_IER_P8_Pos                         16                                                      /*!< PE IER: P8 Position                     */
#define PE_IER_P8_Msk                         (0x03UL << PE_IER_P8_Pos)                               /*!< PE IER: P8 Mask                         */
#define PE_IER_P9_Pos                         18                                                      /*!< PE IER: P9 Position                     */
#define PE_IER_P9_Msk                         (0x03UL << PE_IER_P9_Pos)                               /*!< PE IER: P9 Mask                         */
#define PE_IER_P10_Pos                        20                                                      /*!< PE IER: P10 Position                    */
#define PE_IER_P10_Msk                        (0x03UL << PE_IER_P10_Pos)                              /*!< PE IER: P10 Mask                        */
#define PE_IER_P11_Pos                        22                                                      /*!< PE IER: P11 Position                    */
#define PE_IER_P11_Msk                        (0x03UL << PE_IER_P11_Pos)                              /*!< PE IER: P11 Mask                        */
#define PE_IER_P12_Pos                        24                                                      /*!< PE IER: P12 Position                    */
#define PE_IER_P12_Msk                        (0x03UL << PE_IER_P12_Pos)                              /*!< PE IER: P12 Mask                        */
#define PE_IER_P13_Pos                        26                                                      /*!< PE IER: P13 Position                    */
#define PE_IER_P13_Msk                        (0x03UL << PE_IER_P13_Pos)                              /*!< PE IER: P13 Mask                        */
#define PE_IER_P14_Pos                        28                                                      /*!< PE IER: P14 Position                    */
#define PE_IER_P14_Msk                        (0x03UL << PE_IER_P14_Pos)                              /*!< PE IER: P14 Mask                        */
#define PE_IER_P15_Pos                        30                                                      /*!< PE IER: P15 Position                    */
#define PE_IER_P15_Msk                        (0x03UL << PE_IER_P15_Pos)                              /*!< PE IER: P15 Mask                        */

/* -----------------------------------  PE_ISR  ----------------------------------- */
#define PE_ISR_P0_Pos                         0                                                       /*!< PE ISR: P0 Position                     */
#define PE_ISR_P0_Msk                         (0x03UL << PE_ISR_P0_Pos)                               /*!< PE ISR: P0 Mask                         */
#define PE_ISR_P1_Pos                         2                                                       /*!< PE ISR: P1 Position                     */
#define PE_ISR_P1_Msk                         (0x03UL << PE_ISR_P1_Pos)                               /*!< PE ISR: P1 Mask                         */
#define PE_ISR_P2_Pos                         4                                                       /*!< PE ISR: P2 Position                     */
#define PE_ISR_P2_Msk                         (0x03UL << PE_ISR_P2_Pos)                               /*!< PE ISR: P2 Mask                         */
#define PE_ISR_P3_Pos                         6                                                       /*!< PE ISR: P3 Position                     */
#define PE_ISR_P3_Msk                         (0x03UL << PE_ISR_P3_Pos)                               /*!< PE ISR: P3 Mask                         */
#define PE_ISR_P4_Pos                         8                                                       /*!< PE ISR: P4 Position                     */
#define PE_ISR_P4_Msk                         (0x03UL << PE_ISR_P4_Pos)                               /*!< PE ISR: P4 Mask                         */
#define PE_ISR_P5_Pos                         10                                                      /*!< PE ISR: P5 Position                     */
#define PE_ISR_P5_Msk                         (0x03UL << PE_ISR_P5_Pos)                               /*!< PE ISR: P5 Mask                         */
#define PE_ISR_P6_Pos                         12                                                      /*!< PE ISR: P6 Position                     */
#define PE_ISR_P6_Msk                         (0x03UL << PE_ISR_P6_Pos)                               /*!< PE ISR: P6 Mask                         */
#define PE_ISR_P7_Pos                         14                                                      /*!< PE ISR: P7 Position                     */
#define PE_ISR_P7_Msk                         (0x03UL << PE_ISR_P7_Pos)                               /*!< PE ISR: P7 Mask                         */
#define PE_ISR_P8_Pos                         16                                                      /*!< PE ISR: P8 Position                     */
#define PE_ISR_P8_Msk                         (0x03UL << PE_ISR_P8_Pos)                               /*!< PE ISR: P8 Mask                         */
#define PE_ISR_P9_Pos                         18                                                      /*!< PE ISR: P9 Position                     */
#define PE_ISR_P9_Msk                         (0x03UL << PE_ISR_P9_Pos)                               /*!< PE ISR: P9 Mask                         */
#define PE_ISR_P10_Pos                        20                                                      /*!< PE ISR: P10 Position                    */
#define PE_ISR_P10_Msk                        (0x03UL << PE_ISR_P10_Pos)                              /*!< PE ISR: P10 Mask                        */
#define PE_ISR_P11_Pos                        22                                                      /*!< PE ISR: P11 Position                    */
#define PE_ISR_P11_Msk                        (0x03UL << PE_ISR_P11_Pos)                              /*!< PE ISR: P11 Mask                        */
#define PE_ISR_P12_Pos                        24                                                      /*!< PE ISR: P12 Position                    */
#define PE_ISR_P12_Msk                        (0x03UL << PE_ISR_P12_Pos)                              /*!< PE ISR: P12 Mask                        */
#define PE_ISR_P13_Pos                        26                                                      /*!< PE ISR: P13 Position                    */
#define PE_ISR_P13_Msk                        (0x03UL << PE_ISR_P13_Pos)                              /*!< PE ISR: P13 Mask                        */
#define PE_ISR_P14_Pos                        28                                                      /*!< PE ISR: P14 Position                    */
#define PE_ISR_P14_Msk                        (0x03UL << PE_ISR_P14_Pos)                              /*!< PE ISR: P14 Mask                        */
#define PE_ISR_P15_Pos                        30                                                      /*!< PE ISR: P15 Position                    */
#define PE_ISR_P15_Msk                        (0x03UL << PE_ISR_P15_Pos)                              /*!< PE ISR: P15 Mask                        */

/* -----------------------------------  PE_ICR  ----------------------------------- */
#define PE_ICR_P0_Pos                         0                                                       /*!< PE ICR: P0 Position                     */
#define PE_ICR_P0_Msk                         (0x03UL << PE_ICR_P0_Pos)                               /*!< PE ICR: P0 Mask                         */
#define PE_ICR_P1_Pos                         2                                                       /*!< PE ICR: P1 Position                     */
#define PE_ICR_P1_Msk                         (0x03UL << PE_ICR_P1_Pos)                               /*!< PE ICR: P1 Mask                         */
#define PE_ICR_P2_Pos                         4                                                       /*!< PE ICR: P2 Position                     */
#define PE_ICR_P2_Msk                         (0x03UL << PE_ICR_P2_Pos)                               /*!< PE ICR: P2 Mask                         */
#define PE_ICR_P3_Pos                         6                                                       /*!< PE ICR: P3 Position                     */
#define PE_ICR_P3_Msk                         (0x03UL << PE_ICR_P3_Pos)                               /*!< PE ICR: P3 Mask                         */
#define PE_ICR_P4_Pos                         8                                                       /*!< PE ICR: P4 Position                     */
#define PE_ICR_P4_Msk                         (0x03UL << PE_ICR_P4_Pos)                               /*!< PE ICR: P4 Mask                         */
#define PE_ICR_P5_Pos                         10                                                      /*!< PE ICR: P5 Position                     */
#define PE_ICR_P5_Msk                         (0x03UL << PE_ICR_P5_Pos)                               /*!< PE ICR: P5 Mask                         */
#define PE_ICR_P6_Pos                         12                                                      /*!< PE ICR: P6 Position                     */
#define PE_ICR_P6_Msk                         (0x03UL << PE_ICR_P6_Pos)                               /*!< PE ICR: P6 Mask                         */
#define PE_ICR_P7_Pos                         14                                                      /*!< PE ICR: P7 Position                     */
#define PE_ICR_P7_Msk                         (0x03UL << PE_ICR_P7_Pos)                               /*!< PE ICR: P7 Mask                         */
#define PE_ICR_P8_Pos                         16                                                      /*!< PE ICR: P8 Position                     */
#define PE_ICR_P8_Msk                         (0x03UL << PE_ICR_P8_Pos)                               /*!< PE ICR: P8 Mask                         */
#define PE_ICR_P9_Pos                         18                                                      /*!< PE ICR: P9 Position                     */
#define PE_ICR_P9_Msk                         (0x03UL << PE_ICR_P9_Pos)                               /*!< PE ICR: P9 Mask                         */
#define PE_ICR_P10_Pos                        20                                                      /*!< PE ICR: P10 Position                    */
#define PE_ICR_P10_Msk                        (0x03UL << PE_ICR_P10_Pos)                              /*!< PE ICR: P10 Mask                        */
#define PE_ICR_P11_Pos                        22                                                      /*!< PE ICR: P11 Position                    */
#define PE_ICR_P11_Msk                        (0x03UL << PE_ICR_P11_Pos)                              /*!< PE ICR: P11 Mask                        */
#define PE_ICR_P12_Pos                        24                                                      /*!< PE ICR: P12 Position                    */
#define PE_ICR_P12_Msk                        (0x03UL << PE_ICR_P12_Pos)                              /*!< PE ICR: P12 Mask                        */
#define PE_ICR_P13_Pos                        26                                                      /*!< PE ICR: P13 Position                    */
#define PE_ICR_P13_Msk                        (0x03UL << PE_ICR_P13_Pos)                              /*!< PE ICR: P13 Mask                        */
#define PE_ICR_P14_Pos                        28                                                      /*!< PE ICR: P14 Position                    */
#define PE_ICR_P14_Msk                        (0x03UL << PE_ICR_P14_Pos)                              /*!< PE ICR: P14 Mask                        */
#define PE_ICR_P15_Pos                        30                                                      /*!< PE ICR: P15 Position                    */
#define PE_ICR_P15_Msk                        (0x03UL << PE_ICR_P15_Pos)                              /*!< PE ICR: P15 Mask                        */

/* -----------------------------------  PE_STR  ----------------------------------- */
#define PE_STR_P0_Pos                         0                                                       /*!< PE STR: P0 Position                     */
#define PE_STR_P0_Msk                         (0x03UL << PE_STR_P0_Pos)                               /*!< PE STR: P0 Mask                         */
#define PE_STR_P1_Pos                         2                                                       /*!< PE STR: P1 Position                     */
#define PE_STR_P1_Msk                         (0x03UL << PE_STR_P1_Pos)                               /*!< PE STR: P1 Mask                         */
#define PE_STR_P2_Pos                         4                                                       /*!< PE STR: P2 Position                     */
#define PE_STR_P2_Msk                         (0x03UL << PE_STR_P2_Pos)                               /*!< PE STR: P2 Mask                         */
#define PE_STR_P3_Pos                         6                                                       /*!< PE STR: P3 Position                     */
#define PE_STR_P3_Msk                         (0x03UL << PE_STR_P3_Pos)                               /*!< PE STR: P3 Mask                         */
#define PE_STR_P4_Pos                         8                                                       /*!< PE STR: P4 Position                     */
#define PE_STR_P4_Msk                         (0x03UL << PE_STR_P4_Pos)                               /*!< PE STR: P4 Mask                         */


/* ================================================================================ */
/* ================          Group 'PORTF' Position & Mask         ================ */
/* ================================================================================ */


/* ----------------------------------  PORTF_MOD  --------------------------------- */
#define PORTF_MOD_MODE0_Pos                   0                                                       /*!< PORTF MOD: MODE0 Position               */
#define PORTF_MOD_MODE0_Msk                   (0x03UL << PORTF_MOD_MODE0_Pos)                         /*!< PORTF MOD: MODE0 Mask                   */
#define PORTF_MOD_MODE1_Pos                   2                                                       /*!< PORTF MOD: MODE1 Position               */
#define PORTF_MOD_MODE1_Msk                   (0x03UL << PORTF_MOD_MODE1_Pos)                         /*!< PORTF MOD: MODE1 Mask                   */
#define PORTF_MOD_MODE2_Pos                   4                                                       /*!< PORTF MOD: MODE2 Position               */
#define PORTF_MOD_MODE2_Msk                   (0x03UL << PORTF_MOD_MODE2_Pos)                         /*!< PORTF MOD: MODE2 Mask                   */
#define PORTF_MOD_MODE3_Pos                   6                                                       /*!< PORTF MOD: MODE3 Position               */
#define PORTF_MOD_MODE3_Msk                   (0x03UL << PORTF_MOD_MODE3_Pos)                         /*!< PORTF MOD: MODE3 Mask                   */
#define PORTF_MOD_MODE4_Pos                   8                                                       /*!< PORTF MOD: MODE4 Position               */
#define PORTF_MOD_MODE4_Msk                   (0x03UL << PORTF_MOD_MODE4_Pos)                         /*!< PORTF MOD: MODE4 Mask                   */
#define PORTF_MOD_MODE5_Pos                   10                                                      /*!< PORTF MOD: MODE5 Position               */
#define PORTF_MOD_MODE5_Msk                   (0x03UL << PORTF_MOD_MODE5_Pos)                         /*!< PORTF MOD: MODE5 Mask                   */
#define PORTF_MOD_MODE6_Pos                   12                                                      /*!< PORTF MOD: MODE6 Position               */
#define PORTF_MOD_MODE6_Msk                   (0x03UL << PORTF_MOD_MODE6_Pos)                         /*!< PORTF MOD: MODE6 Mask                   */
#define PORTF_MOD_MODE7_Pos                   14                                                      /*!< PORTF MOD: MODE7 Position               */
#define PORTF_MOD_MODE7_Msk                   (0x03UL << PORTF_MOD_MODE7_Pos)                         /*!< PORTF MOD: MODE7 Mask                   */
#define PORTF_MOD_MODE8_Pos                   16                                                      /*!< PORTF MOD: MODE8 Position               */
#define PORTF_MOD_MODE8_Msk                   (0x03UL << PORTF_MOD_MODE8_Pos)                         /*!< PORTF MOD: MODE8 Mask                   */
#define PORTF_MOD_MODE9_Pos                   18                                                      /*!< PORTF MOD: MODE9 Position               */
#define PORTF_MOD_MODE9_Msk                   (0x03UL << PORTF_MOD_MODE9_Pos)                         /*!< PORTF MOD: MODE9 Mask                   */
#define PORTF_MOD_MODE10_Pos                  20                                                      /*!< PORTF MOD: MODE10 Position              */
#define PORTF_MOD_MODE10_Msk                  (0x03UL << PORTF_MOD_MODE10_Pos)                        /*!< PORTF MOD: MODE10 Mask                  */
#define PORTF_MOD_MODE11_Pos                  22                                                      /*!< PORTF MOD: MODE11 Position              */
#define PORTF_MOD_MODE11_Msk                  (0x03UL << PORTF_MOD_MODE11_Pos)                        /*!< PORTF MOD: MODE11 Mask                  */
#define PORTF_MOD_MODE12_Pos                  24                                                      /*!< PORTF MOD: MODE12 Position              */
#define PORTF_MOD_MODE12_Msk                  (0x03UL << PORTF_MOD_MODE12_Pos)                        /*!< PORTF MOD: MODE12 Mask                  */
#define PORTF_MOD_MODE13_Pos                  26                                                      /*!< PORTF MOD: MODE13 Position              */
#define PORTF_MOD_MODE13_Msk                  (0x03UL << PORTF_MOD_MODE13_Pos)                        /*!< PORTF MOD: MODE13 Mask                  */
#define PORTF_MOD_MODE14_Pos                  28                                                      /*!< PORTF MOD: MODE14 Position              */
#define PORTF_MOD_MODE14_Msk                  (0x03UL << PORTF_MOD_MODE14_Pos)                        /*!< PORTF MOD: MODE14 Mask                  */
#define PORTF_MOD_MODE15_Pos                  30                                                      /*!< PORTF MOD: MODE15 Position              */
#define PORTF_MOD_MODE15_Msk                  (0x03UL << PORTF_MOD_MODE15_Pos)                        /*!< PORTF MOD: MODE15 Mask                  */

/* ----------------------------------  PORTF_TYP  --------------------------------- */
#define PORTF_TYP_TYP0_Pos                    0                                                       /*!< PORTF TYP: TYP0 Position                */
#define PORTF_TYP_TYP0_Msk                    (0x01UL << PORTF_TYP_TYP0_Pos)                          /*!< PORTF TYP: TYP0 Mask                    */
#define PORTF_TYP_TYP1_Pos                    1                                                       /*!< PORTF TYP: TYP1 Position                */
#define PORTF_TYP_TYP1_Msk                    (0x01UL << PORTF_TYP_TYP1_Pos)                          /*!< PORTF TYP: TYP1 Mask                    */
#define PORTF_TYP_TYP2_Pos                    2                                                       /*!< PORTF TYP: TYP2 Position                */
#define PORTF_TYP_TYP2_Msk                    (0x01UL << PORTF_TYP_TYP2_Pos)                          /*!< PORTF TYP: TYP2 Mask                    */
#define PORTF_TYP_TYP3_Pos                    3                                                       /*!< PORTF TYP: TYP3 Position                */
#define PORTF_TYP_TYP3_Msk                    (0x01UL << PORTF_TYP_TYP3_Pos)                          /*!< PORTF TYP: TYP3 Mask                    */
#define PORTF_TYP_TYP4_Pos                    4                                                       /*!< PORTF TYP: TYP4 Position                */
#define PORTF_TYP_TYP4_Msk                    (0x01UL << PORTF_TYP_TYP4_Pos)                          /*!< PORTF TYP: TYP4 Mask                    */
#define PORTF_TYP_TYP5_Pos                    5                                                       /*!< PORTF TYP: TYP5 Position                */
#define PORTF_TYP_TYP5_Msk                    (0x01UL << PORTF_TYP_TYP5_Pos)                          /*!< PORTF TYP: TYP5 Mask                    */
#define PORTF_TYP_TYP6_Pos                    6                                                       /*!< PORTF TYP: TYP6 Position                */
#define PORTF_TYP_TYP6_Msk                    (0x01UL << PORTF_TYP_TYP6_Pos)                          /*!< PORTF TYP: TYP6 Mask                    */
#define PORTF_TYP_TYP7_Pos                    7                                                       /*!< PORTF TYP: TYP7 Position                */
#define PORTF_TYP_TYP7_Msk                    (0x01UL << PORTF_TYP_TYP7_Pos)                          /*!< PORTF TYP: TYP7 Mask                    */
#define PORTF_TYP_TYP8_Pos                    8                                                       /*!< PORTF TYP: TYP8 Position                */
#define PORTF_TYP_TYP8_Msk                    (0x01UL << PORTF_TYP_TYP8_Pos)                          /*!< PORTF TYP: TYP8 Mask                    */
#define PORTF_TYP_TYP9_Pos                    9                                                       /*!< PORTF TYP: TYP9 Position                */
#define PORTF_TYP_TYP9_Msk                    (0x01UL << PORTF_TYP_TYP9_Pos)                          /*!< PORTF TYP: TYP9 Mask                    */
#define PORTF_TYP_TYP10_Pos                   10                                                      /*!< PORTF TYP: TYP10 Position               */
#define PORTF_TYP_TYP10_Msk                   (0x01UL << PORTF_TYP_TYP10_Pos)                         /*!< PORTF TYP: TYP10 Mask                   */
#define PORTF_TYP_TYP11_Pos                   11                                                      /*!< PORTF TYP: TYP11 Position               */
#define PORTF_TYP_TYP11_Msk                   (0x01UL << PORTF_TYP_TYP11_Pos)                         /*!< PORTF TYP: TYP11 Mask                   */
#define PORTF_TYP_TYP12_Pos                   12                                                      /*!< PORTF TYP: TYP12 Position               */
#define PORTF_TYP_TYP12_Msk                   (0x01UL << PORTF_TYP_TYP12_Pos)                         /*!< PORTF TYP: TYP12 Mask                   */
#define PORTF_TYP_TYP13_Pos                   13                                                      /*!< PORTF TYP: TYP13 Position               */
#define PORTF_TYP_TYP13_Msk                   (0x01UL << PORTF_TYP_TYP13_Pos)                         /*!< PORTF TYP: TYP13 Mask                   */
#define PORTF_TYP_TYP14_Pos                   14                                                      /*!< PORTF TYP: TYP14 Position               */
#define PORTF_TYP_TYP14_Msk                   (0x01UL << PORTF_TYP_TYP14_Pos)                         /*!< PORTF TYP: TYP14 Mask                   */
#define PORTF_TYP_TYP15_Pos                   15                                                      /*!< PORTF TYP: TYP15 Position               */
#define PORTF_TYP_TYP15_Msk                   (0x01UL << PORTF_TYP_TYP15_Pos)                         /*!< PORTF TYP: TYP15 Mask                   */

/* ---------------------------------  PORTF_AFSR1  -------------------------------- */
#define PORTF_AFSR1_AFSR0_Pos                 0                                                       /*!< PORTF AFSR1: AFSR0 Position             */
#define PORTF_AFSR1_AFSR0_Msk                 (0x0fUL << PORTF_AFSR1_AFSR0_Pos)                       /*!< PORTF AFSR1: AFSR0 Mask                 */
#define PORTF_AFSR1_AFSR1_Pos                 4                                                       /*!< PORTF AFSR1: AFSR1 Position             */
#define PORTF_AFSR1_AFSR1_Msk                 (0x0fUL << PORTF_AFSR1_AFSR1_Pos)                       /*!< PORTF AFSR1: AFSR1 Mask                 */
#define PORTF_AFSR1_AFSR2_Pos                 8                                                       /*!< PORTF AFSR1: AFSR2 Position             */
#define PORTF_AFSR1_AFSR2_Msk                 (0x0fUL << PORTF_AFSR1_AFSR2_Pos)                       /*!< PORTF AFSR1: AFSR2 Mask                 */
#define PORTF_AFSR1_AFSR3_Pos                 12                                                      /*!< PORTF AFSR1: AFSR3 Position             */
#define PORTF_AFSR1_AFSR3_Msk                 (0x0fUL << PORTF_AFSR1_AFSR3_Pos)                       /*!< PORTF AFSR1: AFSR3 Mask                 */
#define PORTF_AFSR1_AFSR4_Pos                 16                                                      /*!< PORTF AFSR1: AFSR4 Position             */
#define PORTF_AFSR1_AFSR4_Msk                 (0x0fUL << PORTF_AFSR1_AFSR4_Pos)                       /*!< PORTF AFSR1: AFSR4 Mask                 */
#define PORTF_AFSR1_AFSR5_Pos                 20                                                      /*!< PORTF AFSR1: AFSR5 Position             */
#define PORTF_AFSR1_AFSR5_Msk                 (0x0fUL << PORTF_AFSR1_AFSR5_Pos)                       /*!< PORTF AFSR1: AFSR5 Mask                 */
#define PORTF_AFSR1_AFSR6_Pos                 24                                                      /*!< PORTF AFSR1: AFSR6 Position             */
#define PORTF_AFSR1_AFSR6_Msk                 (0x0fUL << PORTF_AFSR1_AFSR6_Pos)                       /*!< PORTF AFSR1: AFSR6 Mask                 */
#define PORTF_AFSR1_AFSR7_Pos                 28                                                      /*!< PORTF AFSR1: AFSR7 Position             */
#define PORTF_AFSR1_AFSR7_Msk                 (0x0fUL << PORTF_AFSR1_AFSR7_Pos)                       /*!< PORTF AFSR1: AFSR7 Mask                 */

/* ---------------------------------  PORTF_AFSR2  -------------------------------- */
#define PORTF_AFSR2_AFSR8_Pos                 0                                                       /*!< PORTF AFSR2: AFSR8 Position             */
#define PORTF_AFSR2_AFSR8_Msk                 (0x0fUL << PORTF_AFSR2_AFSR8_Pos)                       /*!< PORTF AFSR2: AFSR8 Mask                 */
#define PORTF_AFSR2_AFSR9_Pos                 4                                                       /*!< PORTF AFSR2: AFSR9 Position             */
#define PORTF_AFSR2_AFSR9_Msk                 (0x0fUL << PORTF_AFSR2_AFSR9_Pos)                       /*!< PORTF AFSR2: AFSR9 Mask                 */
#define PORTF_AFSR2_AFSR10_Pos                8                                                       /*!< PORTF AFSR2: AFSR10 Position            */
#define PORTF_AFSR2_AFSR10_Msk                (0x0fUL << PORTF_AFSR2_AFSR10_Pos)                      /*!< PORTF AFSR2: AFSR10 Mask                */
#define PORTF_AFSR2_AFSR11_Pos                12                                                      /*!< PORTF AFSR2: AFSR11 Position            */
#define PORTF_AFSR2_AFSR11_Msk                (0x0fUL << PORTF_AFSR2_AFSR11_Pos)                      /*!< PORTF AFSR2: AFSR11 Mask                */
#define PORTF_AFSR2_AFSR12_Pos                16                                                      /*!< PORTF AFSR2: AFSR12 Position            */
#define PORTF_AFSR2_AFSR12_Msk                (0x0fUL << PORTF_AFSR2_AFSR12_Pos)                      /*!< PORTF AFSR2: AFSR12 Mask                */
#define PORTF_AFSR2_AFSR13_Pos                20                                                      /*!< PORTF AFSR2: AFSR13 Position            */
#define PORTF_AFSR2_AFSR13_Msk                (0x0fUL << PORTF_AFSR2_AFSR13_Pos)                      /*!< PORTF AFSR2: AFSR13 Mask                */
#define PORTF_AFSR2_AFSR14_Pos                24                                                      /*!< PORTF AFSR2: AFSR14 Position            */
#define PORTF_AFSR2_AFSR14_Msk                (0x0fUL << PORTF_AFSR2_AFSR14_Pos)                      /*!< PORTF AFSR2: AFSR14 Mask                */
#define PORTF_AFSR2_AFSR15_Pos                28                                                      /*!< PORTF AFSR2: AFSR15 Position            */
#define PORTF_AFSR2_AFSR15_Msk                (0x0fUL << PORTF_AFSR2_AFSR15_Pos)                      /*!< PORTF AFSR2: AFSR15 Mask                */

/* ---------------------------------  PORTF_PUPD  --------------------------------- */
#define PORTF_PUPD_PUPD0_Pos                  0                                                       /*!< PORTF PUPD: PUPD0 Position              */
#define PORTF_PUPD_PUPD0_Msk                  (0x03UL << PORTF_PUPD_PUPD0_Pos)                        /*!< PORTF PUPD: PUPD0 Mask                  */
#define PORTF_PUPD_PUPD1_Pos                  2                                                       /*!< PORTF PUPD: PUPD1 Position              */
#define PORTF_PUPD_PUPD1_Msk                  (0x03UL << PORTF_PUPD_PUPD1_Pos)                        /*!< PORTF PUPD: PUPD1 Mask                  */
#define PORTF_PUPD_PUPD2_Pos                  4                                                       /*!< PORTF PUPD: PUPD2 Position              */
#define PORTF_PUPD_PUPD2_Msk                  (0x03UL << PORTF_PUPD_PUPD2_Pos)                        /*!< PORTF PUPD: PUPD2 Mask                  */
#define PORTF_PUPD_PUPD3_Pos                  6                                                       /*!< PORTF PUPD: PUPD3 Position              */
#define PORTF_PUPD_PUPD3_Msk                  (0x03UL << PORTF_PUPD_PUPD3_Pos)                        /*!< PORTF PUPD: PUPD3 Mask                  */
#define PORTF_PUPD_PUPD4_Pos                  8                                                       /*!< PORTF PUPD: PUPD4 Position              */
#define PORTF_PUPD_PUPD4_Msk                  (0x03UL << PORTF_PUPD_PUPD4_Pos)                        /*!< PORTF PUPD: PUPD4 Mask                  */
#define PORTF_PUPD_PUPD5_Pos                  10                                                      /*!< PORTF PUPD: PUPD5 Position              */
#define PORTF_PUPD_PUPD5_Msk                  (0x03UL << PORTF_PUPD_PUPD5_Pos)                        /*!< PORTF PUPD: PUPD5 Mask                  */
#define PORTF_PUPD_PUPD6_Pos                  12                                                      /*!< PORTF PUPD: PUPD6 Position              */
#define PORTF_PUPD_PUPD6_Msk                  (0x03UL << PORTF_PUPD_PUPD6_Pos)                        /*!< PORTF PUPD: PUPD6 Mask                  */
#define PORTF_PUPD_PUPD7_Pos                  14                                                      /*!< PORTF PUPD: PUPD7 Position              */
#define PORTF_PUPD_PUPD7_Msk                  (0x03UL << PORTF_PUPD_PUPD7_Pos)                        /*!< PORTF PUPD: PUPD7 Mask                  */
#define PORTF_PUPD_PUPD8_Pos                  16                                                      /*!< PORTF PUPD: PUPD8 Position              */
#define PORTF_PUPD_PUPD8_Msk                  (0x03UL << PORTF_PUPD_PUPD8_Pos)                        /*!< PORTF PUPD: PUPD8 Mask                  */
#define PORTF_PUPD_PUPD9_Pos                  18                                                      /*!< PORTF PUPD: PUPD9 Position              */
#define PORTF_PUPD_PUPD9_Msk                  (0x03UL << PORTF_PUPD_PUPD9_Pos)                        /*!< PORTF PUPD: PUPD9 Mask                  */
#define PORTF_PUPD_PUPD10_Pos                 20                                                      /*!< PORTF PUPD: PUPD10 Position             */
#define PORTF_PUPD_PUPD10_Msk                 (0x03UL << PORTF_PUPD_PUPD10_Pos)                       /*!< PORTF PUPD: PUPD10 Mask                 */
#define PORTF_PUPD_PUPD11_Pos                 22                                                      /*!< PORTF PUPD: PUPD11 Position             */
#define PORTF_PUPD_PUPD11_Msk                 (0x03UL << PORTF_PUPD_PUPD11_Pos)                       /*!< PORTF PUPD: PUPD11 Mask                 */
#define PORTF_PUPD_PUPD12_Pos                 24                                                      /*!< PORTF PUPD: PUPD12 Position             */
#define PORTF_PUPD_PUPD12_Msk                 (0x03UL << PORTF_PUPD_PUPD12_Pos)                       /*!< PORTF PUPD: PUPD12 Mask                 */
#define PORTF_PUPD_PUPD13_Pos                 26                                                      /*!< PORTF PUPD: PUPD13 Position             */
#define PORTF_PUPD_PUPD13_Msk                 (0x03UL << PORTF_PUPD_PUPD13_Pos)                       /*!< PORTF PUPD: PUPD13 Mask                 */
#define PORTF_PUPD_PUPD14_Pos                 28                                                      /*!< PORTF PUPD: PUPD14 Position             */
#define PORTF_PUPD_PUPD14_Msk                 (0x03UL << PORTF_PUPD_PUPD14_Pos)                       /*!< PORTF PUPD: PUPD14 Mask                 */
#define PORTF_PUPD_PUPD15_Pos                 30                                                      /*!< PORTF PUPD: PUPD15 Position             */
#define PORTF_PUPD_PUPD15_Msk                 (0x03UL << PORTF_PUPD_PUPD15_Pos)                       /*!< PORTF PUPD: PUPD15 Mask                 */

/* ---------------------------------  PORTF_INDR  --------------------------------- */
#define PORTF_INDR_INDR0_Pos                  0                                                       /*!< PORTF INDR: INDR0 Position              */
#define PORTF_INDR_INDR0_Msk                  (0x01UL << PORTF_INDR_INDR0_Pos)                        /*!< PORTF INDR: INDR0 Mask                  */
#define PORTF_INDR_INDR1_Pos                  1                                                       /*!< PORTF INDR: INDR1 Position              */
#define PORTF_INDR_INDR1_Msk                  (0x01UL << PORTF_INDR_INDR1_Pos)                        /*!< PORTF INDR: INDR1 Mask                  */
#define PORTF_INDR_INDR2_Pos                  2                                                       /*!< PORTF INDR: INDR2 Position              */
#define PORTF_INDR_INDR2_Msk                  (0x01UL << PORTF_INDR_INDR2_Pos)                        /*!< PORTF INDR: INDR2 Mask                  */
#define PORTF_INDR_INDR3_Pos                  3                                                       /*!< PORTF INDR: INDR3 Position              */
#define PORTF_INDR_INDR3_Msk                  (0x01UL << PORTF_INDR_INDR3_Pos)                        /*!< PORTF INDR: INDR3 Mask                  */
#define PORTF_INDR_INDR4_Pos                  4                                                       /*!< PORTF INDR: INDR4 Position              */
#define PORTF_INDR_INDR4_Msk                  (0x01UL << PORTF_INDR_INDR4_Pos)                        /*!< PORTF INDR: INDR4 Mask                  */
#define PORTF_INDR_INDR5_Pos                  5                                                       /*!< PORTF INDR: INDR5 Position              */
#define PORTF_INDR_INDR5_Msk                  (0x01UL << PORTF_INDR_INDR5_Pos)                        /*!< PORTF INDR: INDR5 Mask                  */
#define PORTF_INDR_INDR6_Pos                  6                                                       /*!< PORTF INDR: INDR6 Position              */
#define PORTF_INDR_INDR6_Msk                  (0x01UL << PORTF_INDR_INDR6_Pos)                        /*!< PORTF INDR: INDR6 Mask                  */
#define PORTF_INDR_INDR7_Pos                  7                                                       /*!< PORTF INDR: INDR7 Position              */
#define PORTF_INDR_INDR7_Msk                  (0x01UL << PORTF_INDR_INDR7_Pos)                        /*!< PORTF INDR: INDR7 Mask                  */
#define PORTF_INDR_INDR8_Pos                  8                                                       /*!< PORTF INDR: INDR8 Position              */
#define PORTF_INDR_INDR8_Msk                  (0x01UL << PORTF_INDR_INDR8_Pos)                        /*!< PORTF INDR: INDR8 Mask                  */
#define PORTF_INDR_INDR9_Pos                  9                                                       /*!< PORTF INDR: INDR9 Position              */
#define PORTF_INDR_INDR9_Msk                  (0x01UL << PORTF_INDR_INDR9_Pos)                        /*!< PORTF INDR: INDR9 Mask                  */
#define PORTF_INDR_INDR10_Pos                 10                                                      /*!< PORTF INDR: INDR10 Position             */
#define PORTF_INDR_INDR10_Msk                 (0x01UL << PORTF_INDR_INDR10_Pos)                       /*!< PORTF INDR: INDR10 Mask                 */
#define PORTF_INDR_INDR11_Pos                 11                                                      /*!< PORTF INDR: INDR11 Position             */
#define PORTF_INDR_INDR11_Msk                 (0x01UL << PORTF_INDR_INDR11_Pos)                       /*!< PORTF INDR: INDR11 Mask                 */
#define PORTF_INDR_INDR12_Pos                 12                                                      /*!< PORTF INDR: INDR12 Position             */
#define PORTF_INDR_INDR12_Msk                 (0x01UL << PORTF_INDR_INDR12_Pos)                       /*!< PORTF INDR: INDR12 Mask                 */
#define PORTF_INDR_INDR13_Pos                 13                                                      /*!< PORTF INDR: INDR13 Position             */
#define PORTF_INDR_INDR13_Msk                 (0x01UL << PORTF_INDR_INDR13_Pos)                       /*!< PORTF INDR: INDR13 Mask                 */
#define PORTF_INDR_INDR14_Pos                 14                                                      /*!< PORTF INDR: INDR14 Position             */
#define PORTF_INDR_INDR14_Msk                 (0x01UL << PORTF_INDR_INDR14_Pos)                       /*!< PORTF INDR: INDR14 Mask                 */
#define PORTF_INDR_INDR15_Pos                 15                                                      /*!< PORTF INDR: INDR15 Position             */
#define PORTF_INDR_INDR15_Msk                 (0x01UL << PORTF_INDR_INDR15_Pos)                       /*!< PORTF INDR: INDR15 Mask                 */

/* ---------------------------------  PORTF_OUTDR  -------------------------------- */
#define PORTF_OUTDR_OUTDR0_Pos                0                                                       /*!< PORTF OUTDR: OUTDR0 Position            */
#define PORTF_OUTDR_OUTDR0_Msk                (0x01UL << PORTF_OUTDR_OUTDR0_Pos)                      /*!< PORTF OUTDR: OUTDR0 Mask                */
#define PORTF_OUTDR_OUTDR1_Pos                1                                                       /*!< PORTF OUTDR: OUTDR1 Position            */
#define PORTF_OUTDR_OUTDR1_Msk                (0x01UL << PORTF_OUTDR_OUTDR1_Pos)                      /*!< PORTF OUTDR: OUTDR1 Mask                */
#define PORTF_OUTDR_OUTDR2_Pos                2                                                       /*!< PORTF OUTDR: OUTDR2 Position            */
#define PORTF_OUTDR_OUTDR2_Msk                (0x01UL << PORTF_OUTDR_OUTDR2_Pos)                      /*!< PORTF OUTDR: OUTDR2 Mask                */
#define PORTF_OUTDR_OUTDR3_Pos                3                                                       /*!< PORTF OUTDR: OUTDR3 Position            */
#define PORTF_OUTDR_OUTDR3_Msk                (0x01UL << PORTF_OUTDR_OUTDR3_Pos)                      /*!< PORTF OUTDR: OUTDR3 Mask                */
#define PORTF_OUTDR_OUTDR4_Pos                4                                                       /*!< PORTF OUTDR: OUTDR4 Position            */
#define PORTF_OUTDR_OUTDR4_Msk                (0x01UL << PORTF_OUTDR_OUTDR4_Pos)                      /*!< PORTF OUTDR: OUTDR4 Mask                */
#define PORTF_OUTDR_OUTDR5_Pos                5                                                       /*!< PORTF OUTDR: OUTDR5 Position            */
#define PORTF_OUTDR_OUTDR5_Msk                (0x01UL << PORTF_OUTDR_OUTDR5_Pos)                      /*!< PORTF OUTDR: OUTDR5 Mask                */
#define PORTF_OUTDR_OUTDR6_Pos                6                                                       /*!< PORTF OUTDR: OUTDR6 Position            */
#define PORTF_OUTDR_OUTDR6_Msk                (0x01UL << PORTF_OUTDR_OUTDR6_Pos)                      /*!< PORTF OUTDR: OUTDR6 Mask                */
#define PORTF_OUTDR_OUTDR7_Pos                7                                                       /*!< PORTF OUTDR: OUTDR7 Position            */
#define PORTF_OUTDR_OUTDR7_Msk                (0x01UL << PORTF_OUTDR_OUTDR7_Pos)                      /*!< PORTF OUTDR: OUTDR7 Mask                */
#define PORTF_OUTDR_OUTDR8_Pos                8                                                       /*!< PORTF OUTDR: OUTDR8 Position            */
#define PORTF_OUTDR_OUTDR8_Msk                (0x01UL << PORTF_OUTDR_OUTDR8_Pos)                      /*!< PORTF OUTDR: OUTDR8 Mask                */
#define PORTF_OUTDR_OUTDR9_Pos                9                                                       /*!< PORTF OUTDR: OUTDR9 Position            */
#define PORTF_OUTDR_OUTDR9_Msk                (0x01UL << PORTF_OUTDR_OUTDR9_Pos)                      /*!< PORTF OUTDR: OUTDR9 Mask                */
#define PORTF_OUTDR_OUTDR10_Pos               10                                                      /*!< PORTF OUTDR: OUTDR10 Position           */
#define PORTF_OUTDR_OUTDR10_Msk               (0x01UL << PORTF_OUTDR_OUTDR10_Pos)                     /*!< PORTF OUTDR: OUTDR10 Mask               */
#define PORTF_OUTDR_OUTDR11_Pos               11                                                      /*!< PORTF OUTDR: OUTDR11 Position           */
#define PORTF_OUTDR_OUTDR11_Msk               (0x01UL << PORTF_OUTDR_OUTDR11_Pos)                     /*!< PORTF OUTDR: OUTDR11 Mask               */
#define PORTF_OUTDR_OUTDR12_Pos               12                                                      /*!< PORTF OUTDR: OUTDR12 Position           */
#define PORTF_OUTDR_OUTDR12_Msk               (0x01UL << PORTF_OUTDR_OUTDR12_Pos)                     /*!< PORTF OUTDR: OUTDR12 Mask               */
#define PORTF_OUTDR_OUTDR13_Pos               13                                                      /*!< PORTF OUTDR: OUTDR13 Position           */
#define PORTF_OUTDR_OUTDR13_Msk               (0x01UL << PORTF_OUTDR_OUTDR13_Pos)                     /*!< PORTF OUTDR: OUTDR13 Mask               */
#define PORTF_OUTDR_OUTDR14_Pos               14                                                      /*!< PORTF OUTDR: OUTDR14 Position           */
#define PORTF_OUTDR_OUTDR14_Msk               (0x01UL << PORTF_OUTDR_OUTDR14_Pos)                     /*!< PORTF OUTDR: OUTDR14 Mask               */
#define PORTF_OUTDR_OUTDR15_Pos               15                                                      /*!< PORTF OUTDR: OUTDR15 Position           */
#define PORTF_OUTDR_OUTDR15_Msk               (0x01UL << PORTF_OUTDR_OUTDR15_Pos)                     /*!< PORTF OUTDR: OUTDR15 Mask               */

/* ----------------------------------  PORTF_BSR  --------------------------------- */
#define PORTF_BSR_BSR0_Pos                    0                                                       /*!< PORTF BSR: BSR0 Position                */
#define PORTF_BSR_BSR0_Msk                    (0x01UL << PORTF_BSR_BSR0_Pos)                          /*!< PORTF BSR: BSR0 Mask                    */
#define PORTF_BSR_BSR1_Pos                    1                                                       /*!< PORTF BSR: BSR1 Position                */
#define PORTF_BSR_BSR1_Msk                    (0x01UL << PORTF_BSR_BSR1_Pos)                          /*!< PORTF BSR: BSR1 Mask                    */
#define PORTF_BSR_BSR2_Pos                    2                                                       /*!< PORTF BSR: BSR2 Position                */
#define PORTF_BSR_BSR2_Msk                    (0x01UL << PORTF_BSR_BSR2_Pos)                          /*!< PORTF BSR: BSR2 Mask                    */
#define PORTF_BSR_BSR3_Pos                    3                                                       /*!< PORTF BSR: BSR3 Position                */
#define PORTF_BSR_BSR3_Msk                    (0x01UL << PORTF_BSR_BSR3_Pos)                          /*!< PORTF BSR: BSR3 Mask                    */
#define PORTF_BSR_BSR4_Pos                    4                                                       /*!< PORTF BSR: BSR4 Position                */
#define PORTF_BSR_BSR4_Msk                    (0x01UL << PORTF_BSR_BSR4_Pos)                          /*!< PORTF BSR: BSR4 Mask                    */
#define PORTF_BSR_BSR5_Pos                    5                                                       /*!< PORTF BSR: BSR5 Position                */
#define PORTF_BSR_BSR5_Msk                    (0x01UL << PORTF_BSR_BSR5_Pos)                          /*!< PORTF BSR: BSR5 Mask                    */
#define PORTF_BSR_BSR6_Pos                    6                                                       /*!< PORTF BSR: BSR6 Position                */
#define PORTF_BSR_BSR6_Msk                    (0x01UL << PORTF_BSR_BSR6_Pos)                          /*!< PORTF BSR: BSR6 Mask                    */
#define PORTF_BSR_BSR7_Pos                    7                                                       /*!< PORTF BSR: BSR7 Position                */
#define PORTF_BSR_BSR7_Msk                    (0x01UL << PORTF_BSR_BSR7_Pos)                          /*!< PORTF BSR: BSR7 Mask                    */
#define PORTF_BSR_BSR8_Pos                    8                                                       /*!< PORTF BSR: BSR8 Position                */
#define PORTF_BSR_BSR8_Msk                    (0x01UL << PORTF_BSR_BSR8_Pos)                          /*!< PORTF BSR: BSR8 Mask                    */
#define PORTF_BSR_BSR9_Pos                    9                                                       /*!< PORTF BSR: BSR9 Position                */
#define PORTF_BSR_BSR9_Msk                    (0x01UL << PORTF_BSR_BSR9_Pos)                          /*!< PORTF BSR: BSR9 Mask                    */
#define PORTF_BSR_BSR10_Pos                   10                                                      /*!< PORTF BSR: BSR10 Position               */
#define PORTF_BSR_BSR10_Msk                   (0x01UL << PORTF_BSR_BSR10_Pos)                         /*!< PORTF BSR: BSR10 Mask                   */
#define PORTF_BSR_BSR11_Pos                   11                                                      /*!< PORTF BSR: BSR11 Position               */
#define PORTF_BSR_BSR11_Msk                   (0x01UL << PORTF_BSR_BSR11_Pos)                         /*!< PORTF BSR: BSR11 Mask                   */
#define PORTF_BSR_BSR12_Pos                   12                                                      /*!< PORTF BSR: BSR12 Position               */
#define PORTF_BSR_BSR12_Msk                   (0x01UL << PORTF_BSR_BSR12_Pos)                         /*!< PORTF BSR: BSR12 Mask                   */
#define PORTF_BSR_BSR13_Pos                   13                                                      /*!< PORTF BSR: BSR13 Position               */
#define PORTF_BSR_BSR13_Msk                   (0x01UL << PORTF_BSR_BSR13_Pos)                         /*!< PORTF BSR: BSR13 Mask                   */
#define PORTF_BSR_BSR14_Pos                   14                                                      /*!< PORTF BSR: BSR14 Position               */
#define PORTF_BSR_BSR14_Msk                   (0x01UL << PORTF_BSR_BSR14_Pos)                         /*!< PORTF BSR: BSR14 Mask                   */
#define PORTF_BSR_BSR15_Pos                   15                                                      /*!< PORTF BSR: BSR15 Position               */
#define PORTF_BSR_BSR15_Msk                   (0x01UL << PORTF_BSR_BSR15_Pos)                         /*!< PORTF BSR: BSR15 Mask                   */

/* ----------------------------------  PORTF_BCR  --------------------------------- */
#define PORTF_BCR_BCR0_Pos                    0                                                       /*!< PORTF BCR: BCR0 Position                */
#define PORTF_BCR_BCR0_Msk                    (0x01UL << PORTF_BCR_BCR0_Pos)                          /*!< PORTF BCR: BCR0 Mask                    */
#define PORTF_BCR_BCR1_Pos                    1                                                       /*!< PORTF BCR: BCR1 Position                */
#define PORTF_BCR_BCR1_Msk                    (0x01UL << PORTF_BCR_BCR1_Pos)                          /*!< PORTF BCR: BCR1 Mask                    */
#define PORTF_BCR_BCR2_Pos                    2                                                       /*!< PORTF BCR: BCR2 Position                */
#define PORTF_BCR_BCR2_Msk                    (0x01UL << PORTF_BCR_BCR2_Pos)                          /*!< PORTF BCR: BCR2 Mask                    */
#define PORTF_BCR_BCR3_Pos                    3                                                       /*!< PORTF BCR: BCR3 Position                */
#define PORTF_BCR_BCR3_Msk                    (0x01UL << PORTF_BCR_BCR3_Pos)                          /*!< PORTF BCR: BCR3 Mask                    */
#define PORTF_BCR_BCR4_Pos                    4                                                       /*!< PORTF BCR: BCR4 Position                */
#define PORTF_BCR_BCR4_Msk                    (0x01UL << PORTF_BCR_BCR4_Pos)                          /*!< PORTF BCR: BCR4 Mask                    */
#define PORTF_BCR_BCR5_Pos                    5                                                       /*!< PORTF BCR: BCR5 Position                */
#define PORTF_BCR_BCR5_Msk                    (0x01UL << PORTF_BCR_BCR5_Pos)                          /*!< PORTF BCR: BCR5 Mask                    */
#define PORTF_BCR_BCR6_Pos                    6                                                       /*!< PORTF BCR: BCR6 Position                */
#define PORTF_BCR_BCR6_Msk                    (0x01UL << PORTF_BCR_BCR6_Pos)                          /*!< PORTF BCR: BCR6 Mask                    */
#define PORTF_BCR_BCR7_Pos                    7                                                       /*!< PORTF BCR: BCR7 Position                */
#define PORTF_BCR_BCR7_Msk                    (0x01UL << PORTF_BCR_BCR7_Pos)                          /*!< PORTF BCR: BCR7 Mask                    */
#define PORTF_BCR_BCR8_Pos                    8                                                       /*!< PORTF BCR: BCR8 Position                */
#define PORTF_BCR_BCR8_Msk                    (0x01UL << PORTF_BCR_BCR8_Pos)                          /*!< PORTF BCR: BCR8 Mask                    */
#define PORTF_BCR_BCR9_Pos                    9                                                       /*!< PORTF BCR: BCR9 Position                */
#define PORTF_BCR_BCR9_Msk                    (0x01UL << PORTF_BCR_BCR9_Pos)                          /*!< PORTF BCR: BCR9 Mask                    */
#define PORTF_BCR_BCR10_Pos                   10                                                      /*!< PORTF BCR: BCR10 Position               */
#define PORTF_BCR_BCR10_Msk                   (0x01UL << PORTF_BCR_BCR10_Pos)                         /*!< PORTF BCR: BCR10 Mask                   */
#define PORTF_BCR_BCR11_Pos                   11                                                      /*!< PORTF BCR: BCR11 Position               */
#define PORTF_BCR_BCR11_Msk                   (0x01UL << PORTF_BCR_BCR11_Pos)                         /*!< PORTF BCR: BCR11 Mask                   */
#define PORTF_BCR_BCR12_Pos                   12                                                      /*!< PORTF BCR: BCR12 Position               */
#define PORTF_BCR_BCR12_Msk                   (0x01UL << PORTF_BCR_BCR12_Pos)                         /*!< PORTF BCR: BCR12 Mask                   */
#define PORTF_BCR_BCR13_Pos                   13                                                      /*!< PORTF BCR: BCR13 Position               */
#define PORTF_BCR_BCR13_Msk                   (0x01UL << PORTF_BCR_BCR13_Pos)                         /*!< PORTF BCR: BCR13 Mask                   */
#define PORTF_BCR_BCR14_Pos                   14                                                      /*!< PORTF BCR: BCR14 Position               */
#define PORTF_BCR_BCR14_Msk                   (0x01UL << PORTF_BCR_BCR14_Pos)                         /*!< PORTF BCR: BCR14 Mask                   */
#define PORTF_BCR_BCR15_Pos                   15                                                      /*!< PORTF BCR: BCR15 Position               */
#define PORTF_BCR_BCR15_Msk                   (0x01UL << PORTF_BCR_BCR15_Pos)                         /*!< PORTF BCR: BCR15 Mask                   */

/* --------------------------------  PORTF_OUTDMSK  ------------------------------- */
#define PORTF_OUTDMSK_OUTDMSK0_Pos            0                                                       /*!< PORTF OUTDMSK: OUTDMSK0 Position        */
#define PORTF_OUTDMSK_OUTDMSK0_Msk            (0x01UL << PORTF_OUTDMSK_OUTDMSK0_Pos)                  /*!< PORTF OUTDMSK: OUTDMSK0 Mask            */
#define PORTF_OUTDMSK_OUTDMSK1_Pos            1                                                       /*!< PORTF OUTDMSK: OUTDMSK1 Position        */
#define PORTF_OUTDMSK_OUTDMSK1_Msk            (0x01UL << PORTF_OUTDMSK_OUTDMSK1_Pos)                  /*!< PORTF OUTDMSK: OUTDMSK1 Mask            */
#define PORTF_OUTDMSK_OUTDMSK2_Pos            2                                                       /*!< PORTF OUTDMSK: OUTDMSK2 Position        */
#define PORTF_OUTDMSK_OUTDMSK2_Msk            (0x01UL << PORTF_OUTDMSK_OUTDMSK2_Pos)                  /*!< PORTF OUTDMSK: OUTDMSK2 Mask            */
#define PORTF_OUTDMSK_OUTDMSK3_Pos            3                                                       /*!< PORTF OUTDMSK: OUTDMSK3 Position        */
#define PORTF_OUTDMSK_OUTDMSK3_Msk            (0x01UL << PORTF_OUTDMSK_OUTDMSK3_Pos)                  /*!< PORTF OUTDMSK: OUTDMSK3 Mask            */
#define PORTF_OUTDMSK_OUTDMSK4_Pos            4                                                       /*!< PORTF OUTDMSK: OUTDMSK4 Position        */
#define PORTF_OUTDMSK_OUTDMSK4_Msk            (0x01UL << PORTF_OUTDMSK_OUTDMSK4_Pos)                  /*!< PORTF OUTDMSK: OUTDMSK4 Mask            */
#define PORTF_OUTDMSK_OUTDMSK5_Pos            5                                                       /*!< PORTF OUTDMSK: OUTDMSK5 Position        */
#define PORTF_OUTDMSK_OUTDMSK5_Msk            (0x01UL << PORTF_OUTDMSK_OUTDMSK5_Pos)                  /*!< PORTF OUTDMSK: OUTDMSK5 Mask            */
#define PORTF_OUTDMSK_OUTDMSK6_Pos            6                                                       /*!< PORTF OUTDMSK: OUTDMSK6 Position        */
#define PORTF_OUTDMSK_OUTDMSK6_Msk            (0x01UL << PORTF_OUTDMSK_OUTDMSK6_Pos)                  /*!< PORTF OUTDMSK: OUTDMSK6 Mask            */
#define PORTF_OUTDMSK_OUTDMSK7_Pos            7                                                       /*!< PORTF OUTDMSK: OUTDMSK7 Position        */
#define PORTF_OUTDMSK_OUTDMSK7_Msk            (0x01UL << PORTF_OUTDMSK_OUTDMSK7_Pos)                  /*!< PORTF OUTDMSK: OUTDMSK7 Mask            */
#define PORTF_OUTDMSK_OUTDMSK8_Pos            8                                                       /*!< PORTF OUTDMSK: OUTDMSK8 Position        */
#define PORTF_OUTDMSK_OUTDMSK8_Msk            (0x01UL << PORTF_OUTDMSK_OUTDMSK8_Pos)                  /*!< PORTF OUTDMSK: OUTDMSK8 Mask            */
#define PORTF_OUTDMSK_OUTDMSK9_Pos            9                                                       /*!< PORTF OUTDMSK: OUTDMSK9 Position        */
#define PORTF_OUTDMSK_OUTDMSK9_Msk            (0x01UL << PORTF_OUTDMSK_OUTDMSK9_Pos)                  /*!< PORTF OUTDMSK: OUTDMSK9 Mask            */
#define PORTF_OUTDMSK_OUTDMSK10_Pos           10                                                      /*!< PORTF OUTDMSK: OUTDMSK10 Position       */
#define PORTF_OUTDMSK_OUTDMSK10_Msk           (0x01UL << PORTF_OUTDMSK_OUTDMSK10_Pos)                 /*!< PORTF OUTDMSK: OUTDMSK10 Mask           */
#define PORTF_OUTDMSK_OUTDMSK11_Pos           11                                                      /*!< PORTF OUTDMSK: OUTDMSK11 Position       */
#define PORTF_OUTDMSK_OUTDMSK11_Msk           (0x01UL << PORTF_OUTDMSK_OUTDMSK11_Pos)                 /*!< PORTF OUTDMSK: OUTDMSK11 Mask           */
#define PORTF_OUTDMSK_OUTDMSK12_Pos           12                                                      /*!< PORTF OUTDMSK: OUTDMSK12 Position       */
#define PORTF_OUTDMSK_OUTDMSK12_Msk           (0x01UL << PORTF_OUTDMSK_OUTDMSK12_Pos)                 /*!< PORTF OUTDMSK: OUTDMSK12 Mask           */
#define PORTF_OUTDMSK_OUTDMSK13_Pos           13                                                      /*!< PORTF OUTDMSK: OUTDMSK13 Position       */
#define PORTF_OUTDMSK_OUTDMSK13_Msk           (0x01UL << PORTF_OUTDMSK_OUTDMSK13_Pos)                 /*!< PORTF OUTDMSK: OUTDMSK13 Mask           */
#define PORTF_OUTDMSK_OUTDMSK14_Pos           14                                                      /*!< PORTF OUTDMSK: OUTDMSK14 Position       */
#define PORTF_OUTDMSK_OUTDMSK14_Msk           (0x01UL << PORTF_OUTDMSK_OUTDMSK14_Pos)                 /*!< PORTF OUTDMSK: OUTDMSK14 Mask           */
#define PORTF_OUTDMSK_OUTDMSK15_Pos           15                                                      /*!< PORTF OUTDMSK: OUTDMSK15 Position       */
#define PORTF_OUTDMSK_OUTDMSK15_Msk           (0x01UL << PORTF_OUTDMSK_OUTDMSK15_Pos)                 /*!< PORTF OUTDMSK: OUTDMSK15 Mask           */

/* ---------------------------------  PORTF_DBCR  --------------------------------- */
#define PORTF_DBCR_DBEN0_Pos                  0                                                       /*!< PORTF DBCR: DBEN0 Position              */
#define PORTF_DBCR_DBEN0_Msk                  (0x01UL << PORTF_DBCR_DBEN0_Pos)                        /*!< PORTF DBCR: DBEN0 Mask                  */
#define PORTF_DBCR_DBEN1_Pos                  1                                                       /*!< PORTF DBCR: DBEN1 Position              */
#define PORTF_DBCR_DBEN1_Msk                  (0x01UL << PORTF_DBCR_DBEN1_Pos)                        /*!< PORTF DBCR: DBEN1 Mask                  */
#define PORTF_DBCR_DBEN2_Pos                  2                                                       /*!< PORTF DBCR: DBEN2 Position              */
#define PORTF_DBCR_DBEN2_Msk                  (0x01UL << PORTF_DBCR_DBEN2_Pos)                        /*!< PORTF DBCR: DBEN2 Mask                  */
#define PORTF_DBCR_DBEN3_Pos                  3                                                       /*!< PORTF DBCR: DBEN3 Position              */
#define PORTF_DBCR_DBEN3_Msk                  (0x01UL << PORTF_DBCR_DBEN3_Pos)                        /*!< PORTF DBCR: DBEN3 Mask                  */
#define PORTF_DBCR_DBEN4_Pos                  4                                                       /*!< PORTF DBCR: DBEN4 Position              */
#define PORTF_DBCR_DBEN4_Msk                  (0x01UL << PORTF_DBCR_DBEN4_Pos)                        /*!< PORTF DBCR: DBEN4 Mask                  */
#define PORTF_DBCR_DBEN5_Pos                  5                                                       /*!< PORTF DBCR: DBEN5 Position              */
#define PORTF_DBCR_DBEN5_Msk                  (0x01UL << PORTF_DBCR_DBEN5_Pos)                        /*!< PORTF DBCR: DBEN5 Mask                  */
#define PORTF_DBCR_DBEN6_Pos                  6                                                       /*!< PORTF DBCR: DBEN6 Position              */
#define PORTF_DBCR_DBEN6_Msk                  (0x01UL << PORTF_DBCR_DBEN6_Pos)                        /*!< PORTF DBCR: DBEN6 Mask                  */
#define PORTF_DBCR_DBEN7_Pos                  7                                                       /*!< PORTF DBCR: DBEN7 Position              */
#define PORTF_DBCR_DBEN7_Msk                  (0x01UL << PORTF_DBCR_DBEN7_Pos)                        /*!< PORTF DBCR: DBEN7 Mask                  */
#define PORTF_DBCR_DBEN8_Pos                  8                                                       /*!< PORTF DBCR: DBEN8 Position              */
#define PORTF_DBCR_DBEN8_Msk                  (0x01UL << PORTF_DBCR_DBEN8_Pos)                        /*!< PORTF DBCR: DBEN8 Mask                  */
#define PORTF_DBCR_DBEN9_Pos                  9                                                       /*!< PORTF DBCR: DBEN9 Position              */
#define PORTF_DBCR_DBEN9_Msk                  (0x01UL << PORTF_DBCR_DBEN9_Pos)                        /*!< PORTF DBCR: DBEN9 Mask                  */
#define PORTF_DBCR_DBEN10_Pos                 10                                                      /*!< PORTF DBCR: DBEN10 Position             */
#define PORTF_DBCR_DBEN10_Msk                 (0x01UL << PORTF_DBCR_DBEN10_Pos)                       /*!< PORTF DBCR: DBEN10 Mask                 */
#define PORTF_DBCR_DBEN11_Pos                 11                                                      /*!< PORTF DBCR: DBEN11 Position             */
#define PORTF_DBCR_DBEN11_Msk                 (0x01UL << PORTF_DBCR_DBEN11_Pos)                       /*!< PORTF DBCR: DBEN11 Mask                 */
#define PORTF_DBCR_DBEN12_Pos                 12                                                      /*!< PORTF DBCR: DBEN12 Position             */
#define PORTF_DBCR_DBEN12_Msk                 (0x01UL << PORTF_DBCR_DBEN12_Pos)                       /*!< PORTF DBCR: DBEN12 Mask                 */
#define PORTF_DBCR_DBEN13_Pos                 13                                                      /*!< PORTF DBCR: DBEN13 Position             */
#define PORTF_DBCR_DBEN13_Msk                 (0x01UL << PORTF_DBCR_DBEN13_Pos)                       /*!< PORTF DBCR: DBEN13 Mask                 */
#define PORTF_DBCR_DBEN14_Pos                 14                                                      /*!< PORTF DBCR: DBEN14 Position             */
#define PORTF_DBCR_DBEN14_Msk                 (0x01UL << PORTF_DBCR_DBEN14_Pos)                       /*!< PORTF DBCR: DBEN14 Mask                 */
#define PORTF_DBCR_DBEN15_Pos                 15                                                      /*!< PORTF DBCR: DBEN15 Position             */
#define PORTF_DBCR_DBEN15_Msk                 (0x01UL << PORTF_DBCR_DBEN15_Pos)                       /*!< PORTF DBCR: DBEN15 Mask                 */

/* ----------------------------------  PORTF_IER  --------------------------------- */
#define PORTF_IER_P0_Pos                      0                                                       /*!< PORTF IER: P0 Position                  */
#define PORTF_IER_P0_Msk                      (0x03UL << PORTF_IER_P0_Pos)                            /*!< PORTF IER: P0 Mask                      */
#define PORTF_IER_P1_Pos                      2                                                       /*!< PORTF IER: P1 Position                  */
#define PORTF_IER_P1_Msk                      (0x03UL << PORTF_IER_P1_Pos)                            /*!< PORTF IER: P1 Mask                      */
#define PORTF_IER_P2_Pos                      4                                                       /*!< PORTF IER: P2 Position                  */
#define PORTF_IER_P2_Msk                      (0x03UL << PORTF_IER_P2_Pos)                            /*!< PORTF IER: P2 Mask                      */
#define PORTF_IER_P3_Pos                      6                                                       /*!< PORTF IER: P3 Position                  */
#define PORTF_IER_P3_Msk                      (0x03UL << PORTF_IER_P3_Pos)                            /*!< PORTF IER: P3 Mask                      */
#define PORTF_IER_P4_Pos                      8                                                       /*!< PORTF IER: P4 Position                  */
#define PORTF_IER_P4_Msk                      (0x03UL << PORTF_IER_P4_Pos)                            /*!< PORTF IER: P4 Mask                      */
#define PORTF_IER_P5_Pos                      10                                                      /*!< PORTF IER: P5 Position                  */
#define PORTF_IER_P5_Msk                      (0x03UL << PORTF_IER_P5_Pos)                            /*!< PORTF IER: P5 Mask                      */
#define PORTF_IER_P6_Pos                      12                                                      /*!< PORTF IER: P6 Position                  */
#define PORTF_IER_P6_Msk                      (0x03UL << PORTF_IER_P6_Pos)                            /*!< PORTF IER: P6 Mask                      */
#define PORTF_IER_P7_Pos                      14                                                      /*!< PORTF IER: P7 Position                  */
#define PORTF_IER_P7_Msk                      (0x03UL << PORTF_IER_P7_Pos)                            /*!< PORTF IER: P7 Mask                      */
#define PORTF_IER_P8_Pos                      16                                                      /*!< PORTF IER: P8 Position                  */
#define PORTF_IER_P8_Msk                      (0x03UL << PORTF_IER_P8_Pos)                            /*!< PORTF IER: P8 Mask                      */
#define PORTF_IER_P9_Pos                      18                                                      /*!< PORTF IER: P9 Position                  */
#define PORTF_IER_P9_Msk                      (0x03UL << PORTF_IER_P9_Pos)                            /*!< PORTF IER: P9 Mask                      */
#define PORTF_IER_P10_Pos                     20                                                      /*!< PORTF IER: P10 Position                 */
#define PORTF_IER_P10_Msk                     (0x03UL << PORTF_IER_P10_Pos)                           /*!< PORTF IER: P10 Mask                     */
#define PORTF_IER_P11_Pos                     22                                                      /*!< PORTF IER: P11 Position                 */
#define PORTF_IER_P11_Msk                     (0x03UL << PORTF_IER_P11_Pos)                           /*!< PORTF IER: P11 Mask                     */
#define PORTF_IER_P12_Pos                     24                                                      /*!< PORTF IER: P12 Position                 */
#define PORTF_IER_P12_Msk                     (0x03UL << PORTF_IER_P12_Pos)                           /*!< PORTF IER: P12 Mask                     */
#define PORTF_IER_P13_Pos                     26                                                      /*!< PORTF IER: P13 Position                 */
#define PORTF_IER_P13_Msk                     (0x03UL << PORTF_IER_P13_Pos)                           /*!< PORTF IER: P13 Mask                     */
#define PORTF_IER_P14_Pos                     28                                                      /*!< PORTF IER: P14 Position                 */
#define PORTF_IER_P14_Msk                     (0x03UL << PORTF_IER_P14_Pos)                           /*!< PORTF IER: P14 Mask                     */
#define PORTF_IER_P15_Pos                     30                                                      /*!< PORTF IER: P15 Position                 */
#define PORTF_IER_P15_Msk                     (0x03UL << PORTF_IER_P15_Pos)                           /*!< PORTF IER: P15 Mask                     */

/* ----------------------------------  PORTF_ISR  --------------------------------- */
#define PORTF_ISR_P0_Pos                      0                                                       /*!< PORTF ISR: P0 Position                  */
#define PORTF_ISR_P0_Msk                      (0x03UL << PORTF_ISR_P0_Pos)                            /*!< PORTF ISR: P0 Mask                      */
#define PORTF_ISR_P1_Pos                      2                                                       /*!< PORTF ISR: P1 Position                  */
#define PORTF_ISR_P1_Msk                      (0x03UL << PORTF_ISR_P1_Pos)                            /*!< PORTF ISR: P1 Mask                      */
#define PORTF_ISR_P2_Pos                      4                                                       /*!< PORTF ISR: P2 Position                  */
#define PORTF_ISR_P2_Msk                      (0x03UL << PORTF_ISR_P2_Pos)                            /*!< PORTF ISR: P2 Mask                      */
#define PORTF_ISR_P3_Pos                      6                                                       /*!< PORTF ISR: P3 Position                  */
#define PORTF_ISR_P3_Msk                      (0x03UL << PORTF_ISR_P3_Pos)                            /*!< PORTF ISR: P3 Mask                      */
#define PORTF_ISR_P4_Pos                      8                                                       /*!< PORTF ISR: P4 Position                  */
#define PORTF_ISR_P4_Msk                      (0x03UL << PORTF_ISR_P4_Pos)                            /*!< PORTF ISR: P4 Mask                      */
#define PORTF_ISR_P5_Pos                      10                                                      /*!< PORTF ISR: P5 Position                  */
#define PORTF_ISR_P5_Msk                      (0x03UL << PORTF_ISR_P5_Pos)                            /*!< PORTF ISR: P5 Mask                      */
#define PORTF_ISR_P6_Pos                      12                                                      /*!< PORTF ISR: P6 Position                  */
#define PORTF_ISR_P6_Msk                      (0x03UL << PORTF_ISR_P6_Pos)                            /*!< PORTF ISR: P6 Mask                      */
#define PORTF_ISR_P7_Pos                      14                                                      /*!< PORTF ISR: P7 Position                  */
#define PORTF_ISR_P7_Msk                      (0x03UL << PORTF_ISR_P7_Pos)                            /*!< PORTF ISR: P7 Mask                      */
#define PORTF_ISR_P8_Pos                      16                                                      /*!< PORTF ISR: P8 Position                  */
#define PORTF_ISR_P8_Msk                      (0x03UL << PORTF_ISR_P8_Pos)                            /*!< PORTF ISR: P8 Mask                      */
#define PORTF_ISR_P9_Pos                      18                                                      /*!< PORTF ISR: P9 Position                  */
#define PORTF_ISR_P9_Msk                      (0x03UL << PORTF_ISR_P9_Pos)                            /*!< PORTF ISR: P9 Mask                      */
#define PORTF_ISR_P10_Pos                     20                                                      /*!< PORTF ISR: P10 Position                 */
#define PORTF_ISR_P10_Msk                     (0x03UL << PORTF_ISR_P10_Pos)                           /*!< PORTF ISR: P10 Mask                     */
#define PORTF_ISR_P11_Pos                     22                                                      /*!< PORTF ISR: P11 Position                 */
#define PORTF_ISR_P11_Msk                     (0x03UL << PORTF_ISR_P11_Pos)                           /*!< PORTF ISR: P11 Mask                     */
#define PORTF_ISR_P12_Pos                     24                                                      /*!< PORTF ISR: P12 Position                 */
#define PORTF_ISR_P12_Msk                     (0x03UL << PORTF_ISR_P12_Pos)                           /*!< PORTF ISR: P12 Mask                     */
#define PORTF_ISR_P13_Pos                     26                                                      /*!< PORTF ISR: P13 Position                 */
#define PORTF_ISR_P13_Msk                     (0x03UL << PORTF_ISR_P13_Pos)                           /*!< PORTF ISR: P13 Mask                     */
#define PORTF_ISR_P14_Pos                     28                                                      /*!< PORTF ISR: P14 Position                 */
#define PORTF_ISR_P14_Msk                     (0x03UL << PORTF_ISR_P14_Pos)                           /*!< PORTF ISR: P14 Mask                     */
#define PORTF_ISR_P15_Pos                     30                                                      /*!< PORTF ISR: P15 Position                 */
#define PORTF_ISR_P15_Msk                     (0x03UL << PORTF_ISR_P15_Pos)                           /*!< PORTF ISR: P15 Mask                     */

/* ----------------------------------  PORTF_ICR  --------------------------------- */
#define PORTF_ICR_P0_Pos                      0                                                       /*!< PORTF ICR: P0 Position                  */
#define PORTF_ICR_P0_Msk                      (0x03UL << PORTF_ICR_P0_Pos)                            /*!< PORTF ICR: P0 Mask                      */
#define PORTF_ICR_P1_Pos                      2                                                       /*!< PORTF ICR: P1 Position                  */
#define PORTF_ICR_P1_Msk                      (0x03UL << PORTF_ICR_P1_Pos)                            /*!< PORTF ICR: P1 Mask                      */
#define PORTF_ICR_P2_Pos                      4                                                       /*!< PORTF ICR: P2 Position                  */
#define PORTF_ICR_P2_Msk                      (0x03UL << PORTF_ICR_P2_Pos)                            /*!< PORTF ICR: P2 Mask                      */
#define PORTF_ICR_P3_Pos                      6                                                       /*!< PORTF ICR: P3 Position                  */
#define PORTF_ICR_P3_Msk                      (0x03UL << PORTF_ICR_P3_Pos)                            /*!< PORTF ICR: P3 Mask                      */
#define PORTF_ICR_P4_Pos                      8                                                       /*!< PORTF ICR: P4 Position                  */
#define PORTF_ICR_P4_Msk                      (0x03UL << PORTF_ICR_P4_Pos)                            /*!< PORTF ICR: P4 Mask                      */
#define PORTF_ICR_P5_Pos                      10                                                      /*!< PORTF ICR: P5 Position                  */
#define PORTF_ICR_P5_Msk                      (0x03UL << PORTF_ICR_P5_Pos)                            /*!< PORTF ICR: P5 Mask                      */
#define PORTF_ICR_P6_Pos                      12                                                      /*!< PORTF ICR: P6 Position                  */
#define PORTF_ICR_P6_Msk                      (0x03UL << PORTF_ICR_P6_Pos)                            /*!< PORTF ICR: P6 Mask                      */
#define PORTF_ICR_P7_Pos                      14                                                      /*!< PORTF ICR: P7 Position                  */
#define PORTF_ICR_P7_Msk                      (0x03UL << PORTF_ICR_P7_Pos)                            /*!< PORTF ICR: P7 Mask                      */
#define PORTF_ICR_P8_Pos                      16                                                      /*!< PORTF ICR: P8 Position                  */
#define PORTF_ICR_P8_Msk                      (0x03UL << PORTF_ICR_P8_Pos)                            /*!< PORTF ICR: P8 Mask                      */
#define PORTF_ICR_P9_Pos                      18                                                      /*!< PORTF ICR: P9 Position                  */
#define PORTF_ICR_P9_Msk                      (0x03UL << PORTF_ICR_P9_Pos)                            /*!< PORTF ICR: P9 Mask                      */
#define PORTF_ICR_P10_Pos                     20                                                      /*!< PORTF ICR: P10 Position                 */
#define PORTF_ICR_P10_Msk                     (0x03UL << PORTF_ICR_P10_Pos)                           /*!< PORTF ICR: P10 Mask                     */
#define PORTF_ICR_P11_Pos                     22                                                      /*!< PORTF ICR: P11 Position                 */
#define PORTF_ICR_P11_Msk                     (0x03UL << PORTF_ICR_P11_Pos)                           /*!< PORTF ICR: P11 Mask                     */
#define PORTF_ICR_P12_Pos                     24                                                      /*!< PORTF ICR: P12 Position                 */
#define PORTF_ICR_P12_Msk                     (0x03UL << PORTF_ICR_P12_Pos)                           /*!< PORTF ICR: P12 Mask                     */
#define PORTF_ICR_P13_Pos                     26                                                      /*!< PORTF ICR: P13 Position                 */
#define PORTF_ICR_P13_Msk                     (0x03UL << PORTF_ICR_P13_Pos)                           /*!< PORTF ICR: P13 Mask                     */
#define PORTF_ICR_P14_Pos                     28                                                      /*!< PORTF ICR: P14 Position                 */
#define PORTF_ICR_P14_Msk                     (0x03UL << PORTF_ICR_P14_Pos)                           /*!< PORTF ICR: P14 Mask                     */
#define PORTF_ICR_P15_Pos                     30                                                      /*!< PORTF ICR: P15 Position                 */
#define PORTF_ICR_P15_Msk                     (0x03UL << PORTF_ICR_P15_Pos)                           /*!< PORTF ICR: P15 Mask                     */

/* ---------------------------------  PORTF_PLSR  --------------------------------- */
#define PORTF_PLSR_PF5LSB_Pos                 0                                                       /*!< PORTF PLSR: PF5LSB Position             */
#define PORTF_PLSR_PF5LSB_Msk                 (0x01UL << PORTF_PLSR_PF5LSB_Pos)                       /*!< PORTF PLSR: PF5LSB Mask                 */
#define PORTF_PLSR_PF6LSB_Pos                 1                                                       /*!< PORTF PLSR: PF6LSB Position             */
#define PORTF_PLSR_PF6LSB_Msk                 (0x01UL << PORTF_PLSR_PF6LSB_Pos)                       /*!< PORTF PLSR: PF6LSB Mask                 */
#define PORTF_PLSR_PF7LSB_Pos                 2                                                       /*!< PORTF PLSR: PF7LSB Position             */
#define PORTF_PLSR_PF7LSB_Msk                 (0x01UL << PORTF_PLSR_PF7LSB_Pos)                       /*!< PORTF PLSR: PF7LSB Mask                 */

/* ----------------------------------  PORTF_STR  --------------------------------- */
#define PORTF_STR_P0_Pos                      0                                                       /*!< PORTF STR: P0 Position                  */
#define PORTF_STR_P0_Msk                      (0x03UL << PORTF_STR_P0_Pos)                            /*!< PORTF STR: P0 Mask                      */
#define PORTF_STR_P1_Pos                      2                                                       /*!< PORTF STR: P1 Position                  */
#define PORTF_STR_P1_Msk                      (0x03UL << PORTF_STR_P1_Pos)                            /*!< PORTF STR: P1 Mask                      */
#define PORTF_STR_P2_Pos                      4                                                       /*!< PORTF STR: P2 Position                  */
#define PORTF_STR_P2_Msk                      (0x03UL << PORTF_STR_P2_Pos)                            /*!< PORTF STR: P2 Mask                      */
#define PORTF_STR_P3_Pos                      6                                                       /*!< PORTF STR: P3 Position                  */
#define PORTF_STR_P3_Msk                      (0x03UL << PORTF_STR_P3_Pos)                            /*!< PORTF STR: P3 Mask                      */
#define PORTF_STR_P4_Pos                      8                                                       /*!< PORTF STR: P4 Position                  */
#define PORTF_STR_P4_Msk                      (0x03UL << PORTF_STR_P4_Pos)                            /*!< PORTF STR: P4 Mask                      */


/* ================================================================================ */
/* ================           struct 'PF' Position & Mask          ================ */
/* ================================================================================ */


/* -----------------------------------  PF_MOD  ----------------------------------- */
#define PF_MOD_MODE0_Pos                      0                                                       /*!< PF MOD: MODE0 Position                  */
#define PF_MOD_MODE0_Msk                      (0x03UL << PF_MOD_MODE0_Pos)                            /*!< PF MOD: MODE0 Mask                      */
#define PF_MOD_MODE1_Pos                      2                                                       /*!< PF MOD: MODE1 Position                  */
#define PF_MOD_MODE1_Msk                      (0x03UL << PF_MOD_MODE1_Pos)                            /*!< PF MOD: MODE1 Mask                      */
#define PF_MOD_MODE2_Pos                      4                                                       /*!< PF MOD: MODE2 Position                  */
#define PF_MOD_MODE2_Msk                      (0x03UL << PF_MOD_MODE2_Pos)                            /*!< PF MOD: MODE2 Mask                      */
#define PF_MOD_MODE3_Pos                      6                                                       /*!< PF MOD: MODE3 Position                  */
#define PF_MOD_MODE3_Msk                      (0x03UL << PF_MOD_MODE3_Pos)                            /*!< PF MOD: MODE3 Mask                      */
#define PF_MOD_MODE4_Pos                      8                                                       /*!< PF MOD: MODE4 Position                  */
#define PF_MOD_MODE4_Msk                      (0x03UL << PF_MOD_MODE4_Pos)                            /*!< PF MOD: MODE4 Mask                      */
#define PF_MOD_MODE5_Pos                      10                                                      /*!< PF MOD: MODE5 Position                  */
#define PF_MOD_MODE5_Msk                      (0x03UL << PF_MOD_MODE5_Pos)                            /*!< PF MOD: MODE5 Mask                      */
#define PF_MOD_MODE6_Pos                      12                                                      /*!< PF MOD: MODE6 Position                  */
#define PF_MOD_MODE6_Msk                      (0x03UL << PF_MOD_MODE6_Pos)                            /*!< PF MOD: MODE6 Mask                      */
#define PF_MOD_MODE7_Pos                      14                                                      /*!< PF MOD: MODE7 Position                  */
#define PF_MOD_MODE7_Msk                      (0x03UL << PF_MOD_MODE7_Pos)                            /*!< PF MOD: MODE7 Mask                      */
#define PF_MOD_MODE8_Pos                      16                                                      /*!< PF MOD: MODE8 Position                  */
#define PF_MOD_MODE8_Msk                      (0x03UL << PF_MOD_MODE8_Pos)                            /*!< PF MOD: MODE8 Mask                      */
#define PF_MOD_MODE9_Pos                      18                                                      /*!< PF MOD: MODE9 Position                  */
#define PF_MOD_MODE9_Msk                      (0x03UL << PF_MOD_MODE9_Pos)                            /*!< PF MOD: MODE9 Mask                      */
#define PF_MOD_MODE10_Pos                     20                                                      /*!< PF MOD: MODE10 Position                 */
#define PF_MOD_MODE10_Msk                     (0x03UL << PF_MOD_MODE10_Pos)                           /*!< PF MOD: MODE10 Mask                     */
#define PF_MOD_MODE11_Pos                     22                                                      /*!< PF MOD: MODE11 Position                 */
#define PF_MOD_MODE11_Msk                     (0x03UL << PF_MOD_MODE11_Pos)                           /*!< PF MOD: MODE11 Mask                     */
#define PF_MOD_MODE12_Pos                     24                                                      /*!< PF MOD: MODE12 Position                 */
#define PF_MOD_MODE12_Msk                     (0x03UL << PF_MOD_MODE12_Pos)                           /*!< PF MOD: MODE12 Mask                     */
#define PF_MOD_MODE13_Pos                     26                                                      /*!< PF MOD: MODE13 Position                 */
#define PF_MOD_MODE13_Msk                     (0x03UL << PF_MOD_MODE13_Pos)                           /*!< PF MOD: MODE13 Mask                     */
#define PF_MOD_MODE14_Pos                     28                                                      /*!< PF MOD: MODE14 Position                 */
#define PF_MOD_MODE14_Msk                     (0x03UL << PF_MOD_MODE14_Pos)                           /*!< PF MOD: MODE14 Mask                     */
#define PF_MOD_MODE15_Pos                     30                                                      /*!< PF MOD: MODE15 Position                 */
#define PF_MOD_MODE15_Msk                     (0x03UL << PF_MOD_MODE15_Pos)                           /*!< PF MOD: MODE15 Mask                     */

/* -----------------------------------  PF_TYP  ----------------------------------- */
#define PF_TYP_TYP0_Pos                       0                                                       /*!< PF TYP: TYP0 Position                   */
#define PF_TYP_TYP0_Msk                       (0x01UL << PF_TYP_TYP0_Pos)                             /*!< PF TYP: TYP0 Mask                       */
#define PF_TYP_TYP1_Pos                       1                                                       /*!< PF TYP: TYP1 Position                   */
#define PF_TYP_TYP1_Msk                       (0x01UL << PF_TYP_TYP1_Pos)                             /*!< PF TYP: TYP1 Mask                       */
#define PF_TYP_TYP2_Pos                       2                                                       /*!< PF TYP: TYP2 Position                   */
#define PF_TYP_TYP2_Msk                       (0x01UL << PF_TYP_TYP2_Pos)                             /*!< PF TYP: TYP2 Mask                       */
#define PF_TYP_TYP3_Pos                       3                                                       /*!< PF TYP: TYP3 Position                   */
#define PF_TYP_TYP3_Msk                       (0x01UL << PF_TYP_TYP3_Pos)                             /*!< PF TYP: TYP3 Mask                       */
#define PF_TYP_TYP4_Pos                       4                                                       /*!< PF TYP: TYP4 Position                   */
#define PF_TYP_TYP4_Msk                       (0x01UL << PF_TYP_TYP4_Pos)                             /*!< PF TYP: TYP4 Mask                       */
#define PF_TYP_TYP5_Pos                       5                                                       /*!< PF TYP: TYP5 Position                   */
#define PF_TYP_TYP5_Msk                       (0x01UL << PF_TYP_TYP5_Pos)                             /*!< PF TYP: TYP5 Mask                       */
#define PF_TYP_TYP6_Pos                       6                                                       /*!< PF TYP: TYP6 Position                   */
#define PF_TYP_TYP6_Msk                       (0x01UL << PF_TYP_TYP6_Pos)                             /*!< PF TYP: TYP6 Mask                       */
#define PF_TYP_TYP7_Pos                       7                                                       /*!< PF TYP: TYP7 Position                   */
#define PF_TYP_TYP7_Msk                       (0x01UL << PF_TYP_TYP7_Pos)                             /*!< PF TYP: TYP7 Mask                       */
#define PF_TYP_TYP8_Pos                       8                                                       /*!< PF TYP: TYP8 Position                   */
#define PF_TYP_TYP8_Msk                       (0x01UL << PF_TYP_TYP8_Pos)                             /*!< PF TYP: TYP8 Mask                       */
#define PF_TYP_TYP9_Pos                       9                                                       /*!< PF TYP: TYP9 Position                   */
#define PF_TYP_TYP9_Msk                       (0x01UL << PF_TYP_TYP9_Pos)                             /*!< PF TYP: TYP9 Mask                       */
#define PF_TYP_TYP10_Pos                      10                                                      /*!< PF TYP: TYP10 Position                  */
#define PF_TYP_TYP10_Msk                      (0x01UL << PF_TYP_TYP10_Pos)                            /*!< PF TYP: TYP10 Mask                      */
#define PF_TYP_TYP11_Pos                      11                                                      /*!< PF TYP: TYP11 Position                  */
#define PF_TYP_TYP11_Msk                      (0x01UL << PF_TYP_TYP11_Pos)                            /*!< PF TYP: TYP11 Mask                      */
#define PF_TYP_TYP12_Pos                      12                                                      /*!< PF TYP: TYP12 Position                  */
#define PF_TYP_TYP12_Msk                      (0x01UL << PF_TYP_TYP12_Pos)                            /*!< PF TYP: TYP12 Mask                      */
#define PF_TYP_TYP13_Pos                      13                                                      /*!< PF TYP: TYP13 Position                  */
#define PF_TYP_TYP13_Msk                      (0x01UL << PF_TYP_TYP13_Pos)                            /*!< PF TYP: TYP13 Mask                      */
#define PF_TYP_TYP14_Pos                      14                                                      /*!< PF TYP: TYP14 Position                  */
#define PF_TYP_TYP14_Msk                      (0x01UL << PF_TYP_TYP14_Pos)                            /*!< PF TYP: TYP14 Mask                      */
#define PF_TYP_TYP15_Pos                      15                                                      /*!< PF TYP: TYP15 Position                  */
#define PF_TYP_TYP15_Msk                      (0x01UL << PF_TYP_TYP15_Pos)                            /*!< PF TYP: TYP15 Mask                      */

/* ----------------------------------  PF_AFSR1  ---------------------------------- */
#define PF_AFSR1_AFSR0_Pos                    0                                                       /*!< PF AFSR1: AFSR0 Position                */
#define PF_AFSR1_AFSR0_Msk                    (0x0fUL << PF_AFSR1_AFSR0_Pos)                          /*!< PF AFSR1: AFSR0 Mask                    */
#define PF_AFSR1_AFSR1_Pos                    4                                                       /*!< PF AFSR1: AFSR1 Position                */
#define PF_AFSR1_AFSR1_Msk                    (0x0fUL << PF_AFSR1_AFSR1_Pos)                          /*!< PF AFSR1: AFSR1 Mask                    */
#define PF_AFSR1_AFSR2_Pos                    8                                                       /*!< PF AFSR1: AFSR2 Position                */
#define PF_AFSR1_AFSR2_Msk                    (0x0fUL << PF_AFSR1_AFSR2_Pos)                          /*!< PF AFSR1: AFSR2 Mask                    */
#define PF_AFSR1_AFSR3_Pos                    12                                                      /*!< PF AFSR1: AFSR3 Position                */
#define PF_AFSR1_AFSR3_Msk                    (0x0fUL << PF_AFSR1_AFSR3_Pos)                          /*!< PF AFSR1: AFSR3 Mask                    */
#define PF_AFSR1_AFSR4_Pos                    16                                                      /*!< PF AFSR1: AFSR4 Position                */
#define PF_AFSR1_AFSR4_Msk                    (0x0fUL << PF_AFSR1_AFSR4_Pos)                          /*!< PF AFSR1: AFSR4 Mask                    */
#define PF_AFSR1_AFSR5_Pos                    20                                                      /*!< PF AFSR1: AFSR5 Position                */
#define PF_AFSR1_AFSR5_Msk                    (0x0fUL << PF_AFSR1_AFSR5_Pos)                          /*!< PF AFSR1: AFSR5 Mask                    */
#define PF_AFSR1_AFSR6_Pos                    24                                                      /*!< PF AFSR1: AFSR6 Position                */
#define PF_AFSR1_AFSR6_Msk                    (0x0fUL << PF_AFSR1_AFSR6_Pos)                          /*!< PF AFSR1: AFSR6 Mask                    */
#define PF_AFSR1_AFSR7_Pos                    28                                                      /*!< PF AFSR1: AFSR7 Position                */
#define PF_AFSR1_AFSR7_Msk                    (0x0fUL << PF_AFSR1_AFSR7_Pos)                          /*!< PF AFSR1: AFSR7 Mask                    */

/* ----------------------------------  PF_AFSR2  ---------------------------------- */
#define PF_AFSR2_AFSR8_Pos                    0                                                       /*!< PF AFSR2: AFSR8 Position                */
#define PF_AFSR2_AFSR8_Msk                    (0x0fUL << PF_AFSR2_AFSR8_Pos)                          /*!< PF AFSR2: AFSR8 Mask                    */
#define PF_AFSR2_AFSR9_Pos                    4                                                       /*!< PF AFSR2: AFSR9 Position                */
#define PF_AFSR2_AFSR9_Msk                    (0x0fUL << PF_AFSR2_AFSR9_Pos)                          /*!< PF AFSR2: AFSR9 Mask                    */
#define PF_AFSR2_AFSR10_Pos                   8                                                       /*!< PF AFSR2: AFSR10 Position               */
#define PF_AFSR2_AFSR10_Msk                   (0x0fUL << PF_AFSR2_AFSR10_Pos)                         /*!< PF AFSR2: AFSR10 Mask                   */
#define PF_AFSR2_AFSR11_Pos                   12                                                      /*!< PF AFSR2: AFSR11 Position               */
#define PF_AFSR2_AFSR11_Msk                   (0x0fUL << PF_AFSR2_AFSR11_Pos)                         /*!< PF AFSR2: AFSR11 Mask                   */
#define PF_AFSR2_AFSR12_Pos                   16                                                      /*!< PF AFSR2: AFSR12 Position               */
#define PF_AFSR2_AFSR12_Msk                   (0x0fUL << PF_AFSR2_AFSR12_Pos)                         /*!< PF AFSR2: AFSR12 Mask                   */
#define PF_AFSR2_AFSR13_Pos                   20                                                      /*!< PF AFSR2: AFSR13 Position               */
#define PF_AFSR2_AFSR13_Msk                   (0x0fUL << PF_AFSR2_AFSR13_Pos)                         /*!< PF AFSR2: AFSR13 Mask                   */
#define PF_AFSR2_AFSR14_Pos                   24                                                      /*!< PF AFSR2: AFSR14 Position               */
#define PF_AFSR2_AFSR14_Msk                   (0x0fUL << PF_AFSR2_AFSR14_Pos)                         /*!< PF AFSR2: AFSR14 Mask                   */
#define PF_AFSR2_AFSR15_Pos                   28                                                      /*!< PF AFSR2: AFSR15 Position               */
#define PF_AFSR2_AFSR15_Msk                   (0x0fUL << PF_AFSR2_AFSR15_Pos)                         /*!< PF AFSR2: AFSR15 Mask                   */

/* -----------------------------------  PF_PUPD  ---------------------------------- */
#define PF_PUPD_PUPD0_Pos                     0                                                       /*!< PF PUPD: PUPD0 Position                 */
#define PF_PUPD_PUPD0_Msk                     (0x03UL << PF_PUPD_PUPD0_Pos)                           /*!< PF PUPD: PUPD0 Mask                     */
#define PF_PUPD_PUPD1_Pos                     2                                                       /*!< PF PUPD: PUPD1 Position                 */
#define PF_PUPD_PUPD1_Msk                     (0x03UL << PF_PUPD_PUPD1_Pos)                           /*!< PF PUPD: PUPD1 Mask                     */
#define PF_PUPD_PUPD2_Pos                     4                                                       /*!< PF PUPD: PUPD2 Position                 */
#define PF_PUPD_PUPD2_Msk                     (0x03UL << PF_PUPD_PUPD2_Pos)                           /*!< PF PUPD: PUPD2 Mask                     */
#define PF_PUPD_PUPD3_Pos                     6                                                       /*!< PF PUPD: PUPD3 Position                 */
#define PF_PUPD_PUPD3_Msk                     (0x03UL << PF_PUPD_PUPD3_Pos)                           /*!< PF PUPD: PUPD3 Mask                     */
#define PF_PUPD_PUPD4_Pos                     8                                                       /*!< PF PUPD: PUPD4 Position                 */
#define PF_PUPD_PUPD4_Msk                     (0x03UL << PF_PUPD_PUPD4_Pos)                           /*!< PF PUPD: PUPD4 Mask                     */
#define PF_PUPD_PUPD5_Pos                     10                                                      /*!< PF PUPD: PUPD5 Position                 */
#define PF_PUPD_PUPD5_Msk                     (0x03UL << PF_PUPD_PUPD5_Pos)                           /*!< PF PUPD: PUPD5 Mask                     */
#define PF_PUPD_PUPD6_Pos                     12                                                      /*!< PF PUPD: PUPD6 Position                 */
#define PF_PUPD_PUPD6_Msk                     (0x03UL << PF_PUPD_PUPD6_Pos)                           /*!< PF PUPD: PUPD6 Mask                     */
#define PF_PUPD_PUPD7_Pos                     14                                                      /*!< PF PUPD: PUPD7 Position                 */
#define PF_PUPD_PUPD7_Msk                     (0x03UL << PF_PUPD_PUPD7_Pos)                           /*!< PF PUPD: PUPD7 Mask                     */
#define PF_PUPD_PUPD8_Pos                     16                                                      /*!< PF PUPD: PUPD8 Position                 */
#define PF_PUPD_PUPD8_Msk                     (0x03UL << PF_PUPD_PUPD8_Pos)                           /*!< PF PUPD: PUPD8 Mask                     */
#define PF_PUPD_PUPD9_Pos                     18                                                      /*!< PF PUPD: PUPD9 Position                 */
#define PF_PUPD_PUPD9_Msk                     (0x03UL << PF_PUPD_PUPD9_Pos)                           /*!< PF PUPD: PUPD9 Mask                     */
#define PF_PUPD_PUPD10_Pos                    20                                                      /*!< PF PUPD: PUPD10 Position                */
#define PF_PUPD_PUPD10_Msk                    (0x03UL << PF_PUPD_PUPD10_Pos)                          /*!< PF PUPD: PUPD10 Mask                    */
#define PF_PUPD_PUPD11_Pos                    22                                                      /*!< PF PUPD: PUPD11 Position                */
#define PF_PUPD_PUPD11_Msk                    (0x03UL << PF_PUPD_PUPD11_Pos)                          /*!< PF PUPD: PUPD11 Mask                    */
#define PF_PUPD_PUPD12_Pos                    24                                                      /*!< PF PUPD: PUPD12 Position                */
#define PF_PUPD_PUPD12_Msk                    (0x03UL << PF_PUPD_PUPD12_Pos)                          /*!< PF PUPD: PUPD12 Mask                    */
#define PF_PUPD_PUPD13_Pos                    26                                                      /*!< PF PUPD: PUPD13 Position                */
#define PF_PUPD_PUPD13_Msk                    (0x03UL << PF_PUPD_PUPD13_Pos)                          /*!< PF PUPD: PUPD13 Mask                    */
#define PF_PUPD_PUPD14_Pos                    28                                                      /*!< PF PUPD: PUPD14 Position                */
#define PF_PUPD_PUPD14_Msk                    (0x03UL << PF_PUPD_PUPD14_Pos)                          /*!< PF PUPD: PUPD14 Mask                    */
#define PF_PUPD_PUPD15_Pos                    30                                                      /*!< PF PUPD: PUPD15 Position                */
#define PF_PUPD_PUPD15_Msk                    (0x03UL << PF_PUPD_PUPD15_Pos)                          /*!< PF PUPD: PUPD15 Mask                    */

/* -----------------------------------  PF_INDR  ---------------------------------- */
#define PF_INDR_INDR0_Pos                     0                                                       /*!< PF INDR: INDR0 Position                 */
#define PF_INDR_INDR0_Msk                     (0x01UL << PF_INDR_INDR0_Pos)                           /*!< PF INDR: INDR0 Mask                     */
#define PF_INDR_INDR1_Pos                     1                                                       /*!< PF INDR: INDR1 Position                 */
#define PF_INDR_INDR1_Msk                     (0x01UL << PF_INDR_INDR1_Pos)                           /*!< PF INDR: INDR1 Mask                     */
#define PF_INDR_INDR2_Pos                     2                                                       /*!< PF INDR: INDR2 Position                 */
#define PF_INDR_INDR2_Msk                     (0x01UL << PF_INDR_INDR2_Pos)                           /*!< PF INDR: INDR2 Mask                     */
#define PF_INDR_INDR3_Pos                     3                                                       /*!< PF INDR: INDR3 Position                 */
#define PF_INDR_INDR3_Msk                     (0x01UL << PF_INDR_INDR3_Pos)                           /*!< PF INDR: INDR3 Mask                     */
#define PF_INDR_INDR4_Pos                     4                                                       /*!< PF INDR: INDR4 Position                 */
#define PF_INDR_INDR4_Msk                     (0x01UL << PF_INDR_INDR4_Pos)                           /*!< PF INDR: INDR4 Mask                     */
#define PF_INDR_INDR5_Pos                     5                                                       /*!< PF INDR: INDR5 Position                 */
#define PF_INDR_INDR5_Msk                     (0x01UL << PF_INDR_INDR5_Pos)                           /*!< PF INDR: INDR5 Mask                     */
#define PF_INDR_INDR6_Pos                     6                                                       /*!< PF INDR: INDR6 Position                 */
#define PF_INDR_INDR6_Msk                     (0x01UL << PF_INDR_INDR6_Pos)                           /*!< PF INDR: INDR6 Mask                     */
#define PF_INDR_INDR7_Pos                     7                                                       /*!< PF INDR: INDR7 Position                 */
#define PF_INDR_INDR7_Msk                     (0x01UL << PF_INDR_INDR7_Pos)                           /*!< PF INDR: INDR7 Mask                     */
#define PF_INDR_INDR8_Pos                     8                                                       /*!< PF INDR: INDR8 Position                 */
#define PF_INDR_INDR8_Msk                     (0x01UL << PF_INDR_INDR8_Pos)                           /*!< PF INDR: INDR8 Mask                     */
#define PF_INDR_INDR9_Pos                     9                                                       /*!< PF INDR: INDR9 Position                 */
#define PF_INDR_INDR9_Msk                     (0x01UL << PF_INDR_INDR9_Pos)                           /*!< PF INDR: INDR9 Mask                     */
#define PF_INDR_INDR10_Pos                    10                                                      /*!< PF INDR: INDR10 Position                */
#define PF_INDR_INDR10_Msk                    (0x01UL << PF_INDR_INDR10_Pos)                          /*!< PF INDR: INDR10 Mask                    */
#define PF_INDR_INDR11_Pos                    11                                                      /*!< PF INDR: INDR11 Position                */
#define PF_INDR_INDR11_Msk                    (0x01UL << PF_INDR_INDR11_Pos)                          /*!< PF INDR: INDR11 Mask                    */
#define PF_INDR_INDR12_Pos                    12                                                      /*!< PF INDR: INDR12 Position                */
#define PF_INDR_INDR12_Msk                    (0x01UL << PF_INDR_INDR12_Pos)                          /*!< PF INDR: INDR12 Mask                    */
#define PF_INDR_INDR13_Pos                    13                                                      /*!< PF INDR: INDR13 Position                */
#define PF_INDR_INDR13_Msk                    (0x01UL << PF_INDR_INDR13_Pos)                          /*!< PF INDR: INDR13 Mask                    */
#define PF_INDR_INDR14_Pos                    14                                                      /*!< PF INDR: INDR14 Position                */
#define PF_INDR_INDR14_Msk                    (0x01UL << PF_INDR_INDR14_Pos)                          /*!< PF INDR: INDR14 Mask                    */
#define PF_INDR_INDR15_Pos                    15                                                      /*!< PF INDR: INDR15 Position                */
#define PF_INDR_INDR15_Msk                    (0x01UL << PF_INDR_INDR15_Pos)                          /*!< PF INDR: INDR15 Mask                    */

/* ----------------------------------  PF_OUTDR  ---------------------------------- */
#define PF_OUTDR_OUTDR0_Pos                   0                                                       /*!< PF OUTDR: OUTDR0 Position               */
#define PF_OUTDR_OUTDR0_Msk                   (0x01UL << PF_OUTDR_OUTDR0_Pos)                         /*!< PF OUTDR: OUTDR0 Mask                   */
#define PF_OUTDR_OUTDR1_Pos                   1                                                       /*!< PF OUTDR: OUTDR1 Position               */
#define PF_OUTDR_OUTDR1_Msk                   (0x01UL << PF_OUTDR_OUTDR1_Pos)                         /*!< PF OUTDR: OUTDR1 Mask                   */
#define PF_OUTDR_OUTDR2_Pos                   2                                                       /*!< PF OUTDR: OUTDR2 Position               */
#define PF_OUTDR_OUTDR2_Msk                   (0x01UL << PF_OUTDR_OUTDR2_Pos)                         /*!< PF OUTDR: OUTDR2 Mask                   */
#define PF_OUTDR_OUTDR3_Pos                   3                                                       /*!< PF OUTDR: OUTDR3 Position               */
#define PF_OUTDR_OUTDR3_Msk                   (0x01UL << PF_OUTDR_OUTDR3_Pos)                         /*!< PF OUTDR: OUTDR3 Mask                   */
#define PF_OUTDR_OUTDR4_Pos                   4                                                       /*!< PF OUTDR: OUTDR4 Position               */
#define PF_OUTDR_OUTDR4_Msk                   (0x01UL << PF_OUTDR_OUTDR4_Pos)                         /*!< PF OUTDR: OUTDR4 Mask                   */
#define PF_OUTDR_OUTDR5_Pos                   5                                                       /*!< PF OUTDR: OUTDR5 Position               */
#define PF_OUTDR_OUTDR5_Msk                   (0x01UL << PF_OUTDR_OUTDR5_Pos)                         /*!< PF OUTDR: OUTDR5 Mask                   */
#define PF_OUTDR_OUTDR6_Pos                   6                                                       /*!< PF OUTDR: OUTDR6 Position               */
#define PF_OUTDR_OUTDR6_Msk                   (0x01UL << PF_OUTDR_OUTDR6_Pos)                         /*!< PF OUTDR: OUTDR6 Mask                   */
#define PF_OUTDR_OUTDR7_Pos                   7                                                       /*!< PF OUTDR: OUTDR7 Position               */
#define PF_OUTDR_OUTDR7_Msk                   (0x01UL << PF_OUTDR_OUTDR7_Pos)                         /*!< PF OUTDR: OUTDR7 Mask                   */
#define PF_OUTDR_OUTDR8_Pos                   8                                                       /*!< PF OUTDR: OUTDR8 Position               */
#define PF_OUTDR_OUTDR8_Msk                   (0x01UL << PF_OUTDR_OUTDR8_Pos)                         /*!< PF OUTDR: OUTDR8 Mask                   */
#define PF_OUTDR_OUTDR9_Pos                   9                                                       /*!< PF OUTDR: OUTDR9 Position               */
#define PF_OUTDR_OUTDR9_Msk                   (0x01UL << PF_OUTDR_OUTDR9_Pos)                         /*!< PF OUTDR: OUTDR9 Mask                   */
#define PF_OUTDR_OUTDR10_Pos                  10                                                      /*!< PF OUTDR: OUTDR10 Position              */
#define PF_OUTDR_OUTDR10_Msk                  (0x01UL << PF_OUTDR_OUTDR10_Pos)                        /*!< PF OUTDR: OUTDR10 Mask                  */
#define PF_OUTDR_OUTDR11_Pos                  11                                                      /*!< PF OUTDR: OUTDR11 Position              */
#define PF_OUTDR_OUTDR11_Msk                  (0x01UL << PF_OUTDR_OUTDR11_Pos)                        /*!< PF OUTDR: OUTDR11 Mask                  */
#define PF_OUTDR_OUTDR12_Pos                  12                                                      /*!< PF OUTDR: OUTDR12 Position              */
#define PF_OUTDR_OUTDR12_Msk                  (0x01UL << PF_OUTDR_OUTDR12_Pos)                        /*!< PF OUTDR: OUTDR12 Mask                  */
#define PF_OUTDR_OUTDR13_Pos                  13                                                      /*!< PF OUTDR: OUTDR13 Position              */
#define PF_OUTDR_OUTDR13_Msk                  (0x01UL << PF_OUTDR_OUTDR13_Pos)                        /*!< PF OUTDR: OUTDR13 Mask                  */
#define PF_OUTDR_OUTDR14_Pos                  14                                                      /*!< PF OUTDR: OUTDR14 Position              */
#define PF_OUTDR_OUTDR14_Msk                  (0x01UL << PF_OUTDR_OUTDR14_Pos)                        /*!< PF OUTDR: OUTDR14 Mask                  */
#define PF_OUTDR_OUTDR15_Pos                  15                                                      /*!< PF OUTDR: OUTDR15 Position              */
#define PF_OUTDR_OUTDR15_Msk                  (0x01UL << PF_OUTDR_OUTDR15_Pos)                        /*!< PF OUTDR: OUTDR15 Mask                  */

/* -----------------------------------  PF_BSR  ----------------------------------- */
#define PF_BSR_BSR0_Pos                       0                                                       /*!< PF BSR: BSR0 Position                   */
#define PF_BSR_BSR0_Msk                       (0x01UL << PF_BSR_BSR0_Pos)                             /*!< PF BSR: BSR0 Mask                       */
#define PF_BSR_BSR1_Pos                       1                                                       /*!< PF BSR: BSR1 Position                   */
#define PF_BSR_BSR1_Msk                       (0x01UL << PF_BSR_BSR1_Pos)                             /*!< PF BSR: BSR1 Mask                       */
#define PF_BSR_BSR2_Pos                       2                                                       /*!< PF BSR: BSR2 Position                   */
#define PF_BSR_BSR2_Msk                       (0x01UL << PF_BSR_BSR2_Pos)                             /*!< PF BSR: BSR2 Mask                       */
#define PF_BSR_BSR3_Pos                       3                                                       /*!< PF BSR: BSR3 Position                   */
#define PF_BSR_BSR3_Msk                       (0x01UL << PF_BSR_BSR3_Pos)                             /*!< PF BSR: BSR3 Mask                       */
#define PF_BSR_BSR4_Pos                       4                                                       /*!< PF BSR: BSR4 Position                   */
#define PF_BSR_BSR4_Msk                       (0x01UL << PF_BSR_BSR4_Pos)                             /*!< PF BSR: BSR4 Mask                       */
#define PF_BSR_BSR5_Pos                       5                                                       /*!< PF BSR: BSR5 Position                   */
#define PF_BSR_BSR5_Msk                       (0x01UL << PF_BSR_BSR5_Pos)                             /*!< PF BSR: BSR5 Mask                       */
#define PF_BSR_BSR6_Pos                       6                                                       /*!< PF BSR: BSR6 Position                   */
#define PF_BSR_BSR6_Msk                       (0x01UL << PF_BSR_BSR6_Pos)                             /*!< PF BSR: BSR6 Mask                       */
#define PF_BSR_BSR7_Pos                       7                                                       /*!< PF BSR: BSR7 Position                   */
#define PF_BSR_BSR7_Msk                       (0x01UL << PF_BSR_BSR7_Pos)                             /*!< PF BSR: BSR7 Mask                       */
#define PF_BSR_BSR8_Pos                       8                                                       /*!< PF BSR: BSR8 Position                   */
#define PF_BSR_BSR8_Msk                       (0x01UL << PF_BSR_BSR8_Pos)                             /*!< PF BSR: BSR8 Mask                       */
#define PF_BSR_BSR9_Pos                       9                                                       /*!< PF BSR: BSR9 Position                   */
#define PF_BSR_BSR9_Msk                       (0x01UL << PF_BSR_BSR9_Pos)                             /*!< PF BSR: BSR9 Mask                       */
#define PF_BSR_BSR10_Pos                      10                                                      /*!< PF BSR: BSR10 Position                  */
#define PF_BSR_BSR10_Msk                      (0x01UL << PF_BSR_BSR10_Pos)                            /*!< PF BSR: BSR10 Mask                      */
#define PF_BSR_BSR11_Pos                      11                                                      /*!< PF BSR: BSR11 Position                  */
#define PF_BSR_BSR11_Msk                      (0x01UL << PF_BSR_BSR11_Pos)                            /*!< PF BSR: BSR11 Mask                      */
#define PF_BSR_BSR12_Pos                      12                                                      /*!< PF BSR: BSR12 Position                  */
#define PF_BSR_BSR12_Msk                      (0x01UL << PF_BSR_BSR12_Pos)                            /*!< PF BSR: BSR12 Mask                      */
#define PF_BSR_BSR13_Pos                      13                                                      /*!< PF BSR: BSR13 Position                  */
#define PF_BSR_BSR13_Msk                      (0x01UL << PF_BSR_BSR13_Pos)                            /*!< PF BSR: BSR13 Mask                      */
#define PF_BSR_BSR14_Pos                      14                                                      /*!< PF BSR: BSR14 Position                  */
#define PF_BSR_BSR14_Msk                      (0x01UL << PF_BSR_BSR14_Pos)                            /*!< PF BSR: BSR14 Mask                      */
#define PF_BSR_BSR15_Pos                      15                                                      /*!< PF BSR: BSR15 Position                  */
#define PF_BSR_BSR15_Msk                      (0x01UL << PF_BSR_BSR15_Pos)                            /*!< PF BSR: BSR15 Mask                      */

/* -----------------------------------  PF_BCR  ----------------------------------- */
#define PF_BCR_BCR0_Pos                       0                                                       /*!< PF BCR: BCR0 Position                   */
#define PF_BCR_BCR0_Msk                       (0x01UL << PF_BCR_BCR0_Pos)                             /*!< PF BCR: BCR0 Mask                       */
#define PF_BCR_BCR1_Pos                       1                                                       /*!< PF BCR: BCR1 Position                   */
#define PF_BCR_BCR1_Msk                       (0x01UL << PF_BCR_BCR1_Pos)                             /*!< PF BCR: BCR1 Mask                       */
#define PF_BCR_BCR2_Pos                       2                                                       /*!< PF BCR: BCR2 Position                   */
#define PF_BCR_BCR2_Msk                       (0x01UL << PF_BCR_BCR2_Pos)                             /*!< PF BCR: BCR2 Mask                       */
#define PF_BCR_BCR3_Pos                       3                                                       /*!< PF BCR: BCR3 Position                   */
#define PF_BCR_BCR3_Msk                       (0x01UL << PF_BCR_BCR3_Pos)                             /*!< PF BCR: BCR3 Mask                       */
#define PF_BCR_BCR4_Pos                       4                                                       /*!< PF BCR: BCR4 Position                   */
#define PF_BCR_BCR4_Msk                       (0x01UL << PF_BCR_BCR4_Pos)                             /*!< PF BCR: BCR4 Mask                       */
#define PF_BCR_BCR5_Pos                       5                                                       /*!< PF BCR: BCR5 Position                   */
#define PF_BCR_BCR5_Msk                       (0x01UL << PF_BCR_BCR5_Pos)                             /*!< PF BCR: BCR5 Mask                       */
#define PF_BCR_BCR6_Pos                       6                                                       /*!< PF BCR: BCR6 Position                   */
#define PF_BCR_BCR6_Msk                       (0x01UL << PF_BCR_BCR6_Pos)                             /*!< PF BCR: BCR6 Mask                       */
#define PF_BCR_BCR7_Pos                       7                                                       /*!< PF BCR: BCR7 Position                   */
#define PF_BCR_BCR7_Msk                       (0x01UL << PF_BCR_BCR7_Pos)                             /*!< PF BCR: BCR7 Mask                       */
#define PF_BCR_BCR8_Pos                       8                                                       /*!< PF BCR: BCR8 Position                   */
#define PF_BCR_BCR8_Msk                       (0x01UL << PF_BCR_BCR8_Pos)                             /*!< PF BCR: BCR8 Mask                       */
#define PF_BCR_BCR9_Pos                       9                                                       /*!< PF BCR: BCR9 Position                   */
#define PF_BCR_BCR9_Msk                       (0x01UL << PF_BCR_BCR9_Pos)                             /*!< PF BCR: BCR9 Mask                       */
#define PF_BCR_BCR10_Pos                      10                                                      /*!< PF BCR: BCR10 Position                  */
#define PF_BCR_BCR10_Msk                      (0x01UL << PF_BCR_BCR10_Pos)                            /*!< PF BCR: BCR10 Mask                      */
#define PF_BCR_BCR11_Pos                      11                                                      /*!< PF BCR: BCR11 Position                  */
#define PF_BCR_BCR11_Msk                      (0x01UL << PF_BCR_BCR11_Pos)                            /*!< PF BCR: BCR11 Mask                      */
#define PF_BCR_BCR12_Pos                      12                                                      /*!< PF BCR: BCR12 Position                  */
#define PF_BCR_BCR12_Msk                      (0x01UL << PF_BCR_BCR12_Pos)                            /*!< PF BCR: BCR12 Mask                      */
#define PF_BCR_BCR13_Pos                      13                                                      /*!< PF BCR: BCR13 Position                  */
#define PF_BCR_BCR13_Msk                      (0x01UL << PF_BCR_BCR13_Pos)                            /*!< PF BCR: BCR13 Mask                      */
#define PF_BCR_BCR14_Pos                      14                                                      /*!< PF BCR: BCR14 Position                  */
#define PF_BCR_BCR14_Msk                      (0x01UL << PF_BCR_BCR14_Pos)                            /*!< PF BCR: BCR14 Mask                      */
#define PF_BCR_BCR15_Pos                      15                                                      /*!< PF BCR: BCR15 Position                  */
#define PF_BCR_BCR15_Msk                      (0x01UL << PF_BCR_BCR15_Pos)                            /*!< PF BCR: BCR15 Mask                      */

/* ---------------------------------  PF_OUTDMSK  --------------------------------- */
#define PF_OUTDMSK_OUTDMSK0_Pos               0                                                       /*!< PF OUTDMSK: OUTDMSK0 Position           */
#define PF_OUTDMSK_OUTDMSK0_Msk               (0x01UL << PF_OUTDMSK_OUTDMSK0_Pos)                     /*!< PF OUTDMSK: OUTDMSK0 Mask               */
#define PF_OUTDMSK_OUTDMSK1_Pos               1                                                       /*!< PF OUTDMSK: OUTDMSK1 Position           */
#define PF_OUTDMSK_OUTDMSK1_Msk               (0x01UL << PF_OUTDMSK_OUTDMSK1_Pos)                     /*!< PF OUTDMSK: OUTDMSK1 Mask               */
#define PF_OUTDMSK_OUTDMSK2_Pos               2                                                       /*!< PF OUTDMSK: OUTDMSK2 Position           */
#define PF_OUTDMSK_OUTDMSK2_Msk               (0x01UL << PF_OUTDMSK_OUTDMSK2_Pos)                     /*!< PF OUTDMSK: OUTDMSK2 Mask               */
#define PF_OUTDMSK_OUTDMSK3_Pos               3                                                       /*!< PF OUTDMSK: OUTDMSK3 Position           */
#define PF_OUTDMSK_OUTDMSK3_Msk               (0x01UL << PF_OUTDMSK_OUTDMSK3_Pos)                     /*!< PF OUTDMSK: OUTDMSK3 Mask               */
#define PF_OUTDMSK_OUTDMSK4_Pos               4                                                       /*!< PF OUTDMSK: OUTDMSK4 Position           */
#define PF_OUTDMSK_OUTDMSK4_Msk               (0x01UL << PF_OUTDMSK_OUTDMSK4_Pos)                     /*!< PF OUTDMSK: OUTDMSK4 Mask               */
#define PF_OUTDMSK_OUTDMSK5_Pos               5                                                       /*!< PF OUTDMSK: OUTDMSK5 Position           */
#define PF_OUTDMSK_OUTDMSK5_Msk               (0x01UL << PF_OUTDMSK_OUTDMSK5_Pos)                     /*!< PF OUTDMSK: OUTDMSK5 Mask               */
#define PF_OUTDMSK_OUTDMSK6_Pos               6                                                       /*!< PF OUTDMSK: OUTDMSK6 Position           */
#define PF_OUTDMSK_OUTDMSK6_Msk               (0x01UL << PF_OUTDMSK_OUTDMSK6_Pos)                     /*!< PF OUTDMSK: OUTDMSK6 Mask               */
#define PF_OUTDMSK_OUTDMSK7_Pos               7                                                       /*!< PF OUTDMSK: OUTDMSK7 Position           */
#define PF_OUTDMSK_OUTDMSK7_Msk               (0x01UL << PF_OUTDMSK_OUTDMSK7_Pos)                     /*!< PF OUTDMSK: OUTDMSK7 Mask               */
#define PF_OUTDMSK_OUTDMSK8_Pos               8                                                       /*!< PF OUTDMSK: OUTDMSK8 Position           */
#define PF_OUTDMSK_OUTDMSK8_Msk               (0x01UL << PF_OUTDMSK_OUTDMSK8_Pos)                     /*!< PF OUTDMSK: OUTDMSK8 Mask               */
#define PF_OUTDMSK_OUTDMSK9_Pos               9                                                       /*!< PF OUTDMSK: OUTDMSK9 Position           */
#define PF_OUTDMSK_OUTDMSK9_Msk               (0x01UL << PF_OUTDMSK_OUTDMSK9_Pos)                     /*!< PF OUTDMSK: OUTDMSK9 Mask               */
#define PF_OUTDMSK_OUTDMSK10_Pos              10                                                      /*!< PF OUTDMSK: OUTDMSK10 Position          */
#define PF_OUTDMSK_OUTDMSK10_Msk              (0x01UL << PF_OUTDMSK_OUTDMSK10_Pos)                    /*!< PF OUTDMSK: OUTDMSK10 Mask              */
#define PF_OUTDMSK_OUTDMSK11_Pos              11                                                      /*!< PF OUTDMSK: OUTDMSK11 Position          */
#define PF_OUTDMSK_OUTDMSK11_Msk              (0x01UL << PF_OUTDMSK_OUTDMSK11_Pos)                    /*!< PF OUTDMSK: OUTDMSK11 Mask              */
#define PF_OUTDMSK_OUTDMSK12_Pos              12                                                      /*!< PF OUTDMSK: OUTDMSK12 Position          */
#define PF_OUTDMSK_OUTDMSK12_Msk              (0x01UL << PF_OUTDMSK_OUTDMSK12_Pos)                    /*!< PF OUTDMSK: OUTDMSK12 Mask              */
#define PF_OUTDMSK_OUTDMSK13_Pos              13                                                      /*!< PF OUTDMSK: OUTDMSK13 Position          */
#define PF_OUTDMSK_OUTDMSK13_Msk              (0x01UL << PF_OUTDMSK_OUTDMSK13_Pos)                    /*!< PF OUTDMSK: OUTDMSK13 Mask              */
#define PF_OUTDMSK_OUTDMSK14_Pos              14                                                      /*!< PF OUTDMSK: OUTDMSK14 Position          */
#define PF_OUTDMSK_OUTDMSK14_Msk              (0x01UL << PF_OUTDMSK_OUTDMSK14_Pos)                    /*!< PF OUTDMSK: OUTDMSK14 Mask              */
#define PF_OUTDMSK_OUTDMSK15_Pos              15                                                      /*!< PF OUTDMSK: OUTDMSK15 Position          */
#define PF_OUTDMSK_OUTDMSK15_Msk              (0x01UL << PF_OUTDMSK_OUTDMSK15_Pos)                    /*!< PF OUTDMSK: OUTDMSK15 Mask              */

/* -----------------------------------  PF_DBCR  ---------------------------------- */
#define PF_DBCR_DBEN0_Pos                     0                                                       /*!< PF DBCR: DBEN0 Position                 */
#define PF_DBCR_DBEN0_Msk                     (0x01UL << PF_DBCR_DBEN0_Pos)                           /*!< PF DBCR: DBEN0 Mask                     */
#define PF_DBCR_DBEN1_Pos                     1                                                       /*!< PF DBCR: DBEN1 Position                 */
#define PF_DBCR_DBEN1_Msk                     (0x01UL << PF_DBCR_DBEN1_Pos)                           /*!< PF DBCR: DBEN1 Mask                     */
#define PF_DBCR_DBEN2_Pos                     2                                                       /*!< PF DBCR: DBEN2 Position                 */
#define PF_DBCR_DBEN2_Msk                     (0x01UL << PF_DBCR_DBEN2_Pos)                           /*!< PF DBCR: DBEN2 Mask                     */
#define PF_DBCR_DBEN3_Pos                     3                                                       /*!< PF DBCR: DBEN3 Position                 */
#define PF_DBCR_DBEN3_Msk                     (0x01UL << PF_DBCR_DBEN3_Pos)                           /*!< PF DBCR: DBEN3 Mask                     */
#define PF_DBCR_DBEN4_Pos                     4                                                       /*!< PF DBCR: DBEN4 Position                 */
#define PF_DBCR_DBEN4_Msk                     (0x01UL << PF_DBCR_DBEN4_Pos)                           /*!< PF DBCR: DBEN4 Mask                     */
#define PF_DBCR_DBEN5_Pos                     5                                                       /*!< PF DBCR: DBEN5 Position                 */
#define PF_DBCR_DBEN5_Msk                     (0x01UL << PF_DBCR_DBEN5_Pos)                           /*!< PF DBCR: DBEN5 Mask                     */
#define PF_DBCR_DBEN6_Pos                     6                                                       /*!< PF DBCR: DBEN6 Position                 */
#define PF_DBCR_DBEN6_Msk                     (0x01UL << PF_DBCR_DBEN6_Pos)                           /*!< PF DBCR: DBEN6 Mask                     */
#define PF_DBCR_DBEN7_Pos                     7                                                       /*!< PF DBCR: DBEN7 Position                 */
#define PF_DBCR_DBEN7_Msk                     (0x01UL << PF_DBCR_DBEN7_Pos)                           /*!< PF DBCR: DBEN7 Mask                     */
#define PF_DBCR_DBEN8_Pos                     8                                                       /*!< PF DBCR: DBEN8 Position                 */
#define PF_DBCR_DBEN8_Msk                     (0x01UL << PF_DBCR_DBEN8_Pos)                           /*!< PF DBCR: DBEN8 Mask                     */
#define PF_DBCR_DBEN9_Pos                     9                                                       /*!< PF DBCR: DBEN9 Position                 */
#define PF_DBCR_DBEN9_Msk                     (0x01UL << PF_DBCR_DBEN9_Pos)                           /*!< PF DBCR: DBEN9 Mask                     */
#define PF_DBCR_DBEN10_Pos                    10                                                      /*!< PF DBCR: DBEN10 Position                */
#define PF_DBCR_DBEN10_Msk                    (0x01UL << PF_DBCR_DBEN10_Pos)                          /*!< PF DBCR: DBEN10 Mask                    */
#define PF_DBCR_DBEN11_Pos                    11                                                      /*!< PF DBCR: DBEN11 Position                */
#define PF_DBCR_DBEN11_Msk                    (0x01UL << PF_DBCR_DBEN11_Pos)                          /*!< PF DBCR: DBEN11 Mask                    */
#define PF_DBCR_DBEN12_Pos                    12                                                      /*!< PF DBCR: DBEN12 Position                */
#define PF_DBCR_DBEN12_Msk                    (0x01UL << PF_DBCR_DBEN12_Pos)                          /*!< PF DBCR: DBEN12 Mask                    */
#define PF_DBCR_DBEN13_Pos                    13                                                      /*!< PF DBCR: DBEN13 Position                */
#define PF_DBCR_DBEN13_Msk                    (0x01UL << PF_DBCR_DBEN13_Pos)                          /*!< PF DBCR: DBEN13 Mask                    */
#define PF_DBCR_DBEN14_Pos                    14                                                      /*!< PF DBCR: DBEN14 Position                */
#define PF_DBCR_DBEN14_Msk                    (0x01UL << PF_DBCR_DBEN14_Pos)                          /*!< PF DBCR: DBEN14 Mask                    */
#define PF_DBCR_DBEN15_Pos                    15                                                      /*!< PF DBCR: DBEN15 Position                */
#define PF_DBCR_DBEN15_Msk                    (0x01UL << PF_DBCR_DBEN15_Pos)                          /*!< PF DBCR: DBEN15 Mask                    */

/* -----------------------------------  PF_IER  ----------------------------------- */
#define PF_IER_P0_Pos                         0                                                       /*!< PF IER: P0 Position                     */
#define PF_IER_P0_Msk                         (0x03UL << PF_IER_P0_Pos)                               /*!< PF IER: P0 Mask                         */
#define PF_IER_P1_Pos                         2                                                       /*!< PF IER: P1 Position                     */
#define PF_IER_P1_Msk                         (0x03UL << PF_IER_P1_Pos)                               /*!< PF IER: P1 Mask                         */
#define PF_IER_P2_Pos                         4                                                       /*!< PF IER: P2 Position                     */
#define PF_IER_P2_Msk                         (0x03UL << PF_IER_P2_Pos)                               /*!< PF IER: P2 Mask                         */
#define PF_IER_P3_Pos                         6                                                       /*!< PF IER: P3 Position                     */
#define PF_IER_P3_Msk                         (0x03UL << PF_IER_P3_Pos)                               /*!< PF IER: P3 Mask                         */
#define PF_IER_P4_Pos                         8                                                       /*!< PF IER: P4 Position                     */
#define PF_IER_P4_Msk                         (0x03UL << PF_IER_P4_Pos)                               /*!< PF IER: P4 Mask                         */
#define PF_IER_P5_Pos                         10                                                      /*!< PF IER: P5 Position                     */
#define PF_IER_P5_Msk                         (0x03UL << PF_IER_P5_Pos)                               /*!< PF IER: P5 Mask                         */
#define PF_IER_P6_Pos                         12                                                      /*!< PF IER: P6 Position                     */
#define PF_IER_P6_Msk                         (0x03UL << PF_IER_P6_Pos)                               /*!< PF IER: P6 Mask                         */
#define PF_IER_P7_Pos                         14                                                      /*!< PF IER: P7 Position                     */
#define PF_IER_P7_Msk                         (0x03UL << PF_IER_P7_Pos)                               /*!< PF IER: P7 Mask                         */
#define PF_IER_P8_Pos                         16                                                      /*!< PF IER: P8 Position                     */
#define PF_IER_P8_Msk                         (0x03UL << PF_IER_P8_Pos)                               /*!< PF IER: P8 Mask                         */
#define PF_IER_P9_Pos                         18                                                      /*!< PF IER: P9 Position                     */
#define PF_IER_P9_Msk                         (0x03UL << PF_IER_P9_Pos)                               /*!< PF IER: P9 Mask                         */
#define PF_IER_P10_Pos                        20                                                      /*!< PF IER: P10 Position                    */
#define PF_IER_P10_Msk                        (0x03UL << PF_IER_P10_Pos)                              /*!< PF IER: P10 Mask                        */
#define PF_IER_P11_Pos                        22                                                      /*!< PF IER: P11 Position                    */
#define PF_IER_P11_Msk                        (0x03UL << PF_IER_P11_Pos)                              /*!< PF IER: P11 Mask                        */
#define PF_IER_P12_Pos                        24                                                      /*!< PF IER: P12 Position                    */
#define PF_IER_P12_Msk                        (0x03UL << PF_IER_P12_Pos)                              /*!< PF IER: P12 Mask                        */
#define PF_IER_P13_Pos                        26                                                      /*!< PF IER: P13 Position                    */
#define PF_IER_P13_Msk                        (0x03UL << PF_IER_P13_Pos)                              /*!< PF IER: P13 Mask                        */
#define PF_IER_P14_Pos                        28                                                      /*!< PF IER: P14 Position                    */
#define PF_IER_P14_Msk                        (0x03UL << PF_IER_P14_Pos)                              /*!< PF IER: P14 Mask                        */
#define PF_IER_P15_Pos                        30                                                      /*!< PF IER: P15 Position                    */
#define PF_IER_P15_Msk                        (0x03UL << PF_IER_P15_Pos)                              /*!< PF IER: P15 Mask                        */

/* -----------------------------------  PF_ISR  ----------------------------------- */
#define PF_ISR_P0_Pos                         0                                                       /*!< PF ISR: P0 Position                     */
#define PF_ISR_P0_Msk                         (0x03UL << PF_ISR_P0_Pos)                               /*!< PF ISR: P0 Mask                         */
#define PF_ISR_P1_Pos                         2                                                       /*!< PF ISR: P1 Position                     */
#define PF_ISR_P1_Msk                         (0x03UL << PF_ISR_P1_Pos)                               /*!< PF ISR: P1 Mask                         */
#define PF_ISR_P2_Pos                         4                                                       /*!< PF ISR: P2 Position                     */
#define PF_ISR_P2_Msk                         (0x03UL << PF_ISR_P2_Pos)                               /*!< PF ISR: P2 Mask                         */
#define PF_ISR_P3_Pos                         6                                                       /*!< PF ISR: P3 Position                     */
#define PF_ISR_P3_Msk                         (0x03UL << PF_ISR_P3_Pos)                               /*!< PF ISR: P3 Mask                         */
#define PF_ISR_P4_Pos                         8                                                       /*!< PF ISR: P4 Position                     */
#define PF_ISR_P4_Msk                         (0x03UL << PF_ISR_P4_Pos)                               /*!< PF ISR: P4 Mask                         */
#define PF_ISR_P5_Pos                         10                                                      /*!< PF ISR: P5 Position                     */
#define PF_ISR_P5_Msk                         (0x03UL << PF_ISR_P5_Pos)                               /*!< PF ISR: P5 Mask                         */
#define PF_ISR_P6_Pos                         12                                                      /*!< PF ISR: P6 Position                     */
#define PF_ISR_P6_Msk                         (0x03UL << PF_ISR_P6_Pos)                               /*!< PF ISR: P6 Mask                         */
#define PF_ISR_P7_Pos                         14                                                      /*!< PF ISR: P7 Position                     */
#define PF_ISR_P7_Msk                         (0x03UL << PF_ISR_P7_Pos)                               /*!< PF ISR: P7 Mask                         */
#define PF_ISR_P8_Pos                         16                                                      /*!< PF ISR: P8 Position                     */
#define PF_ISR_P8_Msk                         (0x03UL << PF_ISR_P8_Pos)                               /*!< PF ISR: P8 Mask                         */
#define PF_ISR_P9_Pos                         18                                                      /*!< PF ISR: P9 Position                     */
#define PF_ISR_P9_Msk                         (0x03UL << PF_ISR_P9_Pos)                               /*!< PF ISR: P9 Mask                         */
#define PF_ISR_P10_Pos                        20                                                      /*!< PF ISR: P10 Position                    */
#define PF_ISR_P10_Msk                        (0x03UL << PF_ISR_P10_Pos)                              /*!< PF ISR: P10 Mask                        */
#define PF_ISR_P11_Pos                        22                                                      /*!< PF ISR: P11 Position                    */
#define PF_ISR_P11_Msk                        (0x03UL << PF_ISR_P11_Pos)                              /*!< PF ISR: P11 Mask                        */
#define PF_ISR_P12_Pos                        24                                                      /*!< PF ISR: P12 Position                    */
#define PF_ISR_P12_Msk                        (0x03UL << PF_ISR_P12_Pos)                              /*!< PF ISR: P12 Mask                        */
#define PF_ISR_P13_Pos                        26                                                      /*!< PF ISR: P13 Position                    */
#define PF_ISR_P13_Msk                        (0x03UL << PF_ISR_P13_Pos)                              /*!< PF ISR: P13 Mask                        */
#define PF_ISR_P14_Pos                        28                                                      /*!< PF ISR: P14 Position                    */
#define PF_ISR_P14_Msk                        (0x03UL << PF_ISR_P14_Pos)                              /*!< PF ISR: P14 Mask                        */
#define PF_ISR_P15_Pos                        30                                                      /*!< PF ISR: P15 Position                    */
#define PF_ISR_P15_Msk                        (0x03UL << PF_ISR_P15_Pos)                              /*!< PF ISR: P15 Mask                        */

/* -----------------------------------  PF_ICR  ----------------------------------- */
#define PF_ICR_P0_Pos                         0                                                       /*!< PF ICR: P0 Position                     */
#define PF_ICR_P0_Msk                         (0x03UL << PF_ICR_P0_Pos)                               /*!< PF ICR: P0 Mask                         */
#define PF_ICR_P1_Pos                         2                                                       /*!< PF ICR: P1 Position                     */
#define PF_ICR_P1_Msk                         (0x03UL << PF_ICR_P1_Pos)                               /*!< PF ICR: P1 Mask                         */
#define PF_ICR_P2_Pos                         4                                                       /*!< PF ICR: P2 Position                     */
#define PF_ICR_P2_Msk                         (0x03UL << PF_ICR_P2_Pos)                               /*!< PF ICR: P2 Mask                         */
#define PF_ICR_P3_Pos                         6                                                       /*!< PF ICR: P3 Position                     */
#define PF_ICR_P3_Msk                         (0x03UL << PF_ICR_P3_Pos)                               /*!< PF ICR: P3 Mask                         */
#define PF_ICR_P4_Pos                         8                                                       /*!< PF ICR: P4 Position                     */
#define PF_ICR_P4_Msk                         (0x03UL << PF_ICR_P4_Pos)                               /*!< PF ICR: P4 Mask                         */
#define PF_ICR_P5_Pos                         10                                                      /*!< PF ICR: P5 Position                     */
#define PF_ICR_P5_Msk                         (0x03UL << PF_ICR_P5_Pos)                               /*!< PF ICR: P5 Mask                         */
#define PF_ICR_P6_Pos                         12                                                      /*!< PF ICR: P6 Position                     */
#define PF_ICR_P6_Msk                         (0x03UL << PF_ICR_P6_Pos)                               /*!< PF ICR: P6 Mask                         */
#define PF_ICR_P7_Pos                         14                                                      /*!< PF ICR: P7 Position                     */
#define PF_ICR_P7_Msk                         (0x03UL << PF_ICR_P7_Pos)                               /*!< PF ICR: P7 Mask                         */
#define PF_ICR_P8_Pos                         16                                                      /*!< PF ICR: P8 Position                     */
#define PF_ICR_P8_Msk                         (0x03UL << PF_ICR_P8_Pos)                               /*!< PF ICR: P8 Mask                         */
#define PF_ICR_P9_Pos                         18                                                      /*!< PF ICR: P9 Position                     */
#define PF_ICR_P9_Msk                         (0x03UL << PF_ICR_P9_Pos)                               /*!< PF ICR: P9 Mask                         */
#define PF_ICR_P10_Pos                        20                                                      /*!< PF ICR: P10 Position                    */
#define PF_ICR_P10_Msk                        (0x03UL << PF_ICR_P10_Pos)                              /*!< PF ICR: P10 Mask                        */
#define PF_ICR_P11_Pos                        22                                                      /*!< PF ICR: P11 Position                    */
#define PF_ICR_P11_Msk                        (0x03UL << PF_ICR_P11_Pos)                              /*!< PF ICR: P11 Mask                        */
#define PF_ICR_P12_Pos                        24                                                      /*!< PF ICR: P12 Position                    */
#define PF_ICR_P12_Msk                        (0x03UL << PF_ICR_P12_Pos)                              /*!< PF ICR: P12 Mask                        */
#define PF_ICR_P13_Pos                        26                                                      /*!< PF ICR: P13 Position                    */
#define PF_ICR_P13_Msk                        (0x03UL << PF_ICR_P13_Pos)                              /*!< PF ICR: P13 Mask                        */
#define PF_ICR_P14_Pos                        28                                                      /*!< PF ICR: P14 Position                    */
#define PF_ICR_P14_Msk                        (0x03UL << PF_ICR_P14_Pos)                              /*!< PF ICR: P14 Mask                        */
#define PF_ICR_P15_Pos                        30                                                      /*!< PF ICR: P15 Position                    */
#define PF_ICR_P15_Msk                        (0x03UL << PF_ICR_P15_Pos)                              /*!< PF ICR: P15 Mask                        */

/* -----------------------------------  PF_PLSR  ---------------------------------- */
#define PF_PLSR_PF5LSB_Pos                    0                                                       /*!< PF PLSR: PF5LSB Position                */
#define PF_PLSR_PF5LSB_Msk                    (0x01UL << PF_PLSR_PF5LSB_Pos)                          /*!< PF PLSR: PF5LSB Mask                    */
#define PF_PLSR_PF6LSB_Pos                    1                                                       /*!< PF PLSR: PF6LSB Position                */
#define PF_PLSR_PF6LSB_Msk                    (0x01UL << PF_PLSR_PF6LSB_Pos)                          /*!< PF PLSR: PF6LSB Mask                    */
#define PF_PLSR_PF7LSB_Pos                    2                                                       /*!< PF PLSR: PF7LSB Position                */
#define PF_PLSR_PF7LSB_Msk                    (0x01UL << PF_PLSR_PF7LSB_Pos)                          /*!< PF PLSR: PF7LSB Mask                    */

/* -----------------------------------  PF_STR  ----------------------------------- */
#define PF_STR_P0_Pos                         0                                                       /*!< PF STR: P0 Position                     */
#define PF_STR_P0_Msk                         (0x03UL << PF_STR_P0_Pos)                               /*!< PF STR: P0 Mask                         */
#define PF_STR_P1_Pos                         2                                                       /*!< PF STR: P1 Position                     */
#define PF_STR_P1_Msk                         (0x03UL << PF_STR_P1_Pos)                               /*!< PF STR: P1 Mask                         */
#define PF_STR_P2_Pos                         4                                                       /*!< PF STR: P2 Position                     */
#define PF_STR_P2_Msk                         (0x03UL << PF_STR_P2_Pos)                               /*!< PF STR: P2 Mask                         */
#define PF_STR_P3_Pos                         6                                                       /*!< PF STR: P3 Position                     */
#define PF_STR_P3_Msk                         (0x03UL << PF_STR_P3_Pos)                               /*!< PF STR: P3 Mask                         */
#define PF_STR_P4_Pos                         8                                                       /*!< PF STR: P4 Position                     */
#define PF_STR_P4_Msk                         (0x03UL << PF_STR_P4_Pos)                               /*!< PF STR: P4 Mask                         */


/* ================================================================================ */
/* ================          struct 'PCU1' Position & Mask         ================ */
/* ================================================================================ */


/* --------------------------------  PCU1_SPI2PMR  -------------------------------- */
#define PCU1_SPI2PMR_SPI20_PRM_Pos            0                                                       /*!< PCU1 SPI2PMR: SPI20_PRM Position        */
#define PCU1_SPI2PMR_SPI20_PRM_Msk            (0x01UL << PCU1_SPI2PMR_SPI20_PRM_Pos)                  /*!< PCU1 SPI2PMR: SPI20_PRM Mask            */
#define PCU1_SPI2PMR_SPI21_PRM_Pos            1                                                       /*!< PCU1 SPI2PMR: SPI21_PRM Position        */
#define PCU1_SPI2PMR_SPI21_PRM_Msk            (0x01UL << PCU1_SPI2PMR_SPI21_PRM_Pos)                  /*!< PCU1 SPI2PMR: SPI21_PRM Mask            */


/* ================================================================================ */
/* ================          struct 'PCU2' Position & Mask         ================ */
/* ================================================================================ */


/* --------------------------------  PCU2_ISEGPEN  -------------------------------- */
#define PCU2_ISEGPEN_ISEGENKEY_Pos            0                                                       /*!< PCU2 ISEGPEN: ISEGENKEY Position        */
#define PCU2_ISEGPEN_ISEGENKEY_Msk            (0x0000ffffUL << PCU2_ISEGPEN_ISEGENKEY_Pos)            /*!< PCU2 ISEGPEN: ISEGENKEY Mask            */

/* ---------------------------------  PCU2_ISEGR  --------------------------------- */
#define PCU2_ISEGR_ISEG0_Pos                  0                                                       /*!< PCU2 ISEGR: ISEG0 Position              */
#define PCU2_ISEGR_ISEG0_Msk                  (0x01UL << PCU2_ISEGR_ISEG0_Pos)                        /*!< PCU2 ISEGR: ISEG0 Mask                  */
#define PCU2_ISEGR_ISEG1_Pos                  1                                                       /*!< PCU2 ISEGR: ISEG1 Position              */
#define PCU2_ISEGR_ISEG1_Msk                  (0x01UL << PCU2_ISEGR_ISEG1_Pos)                        /*!< PCU2 ISEGR: ISEG1 Mask                  */
#define PCU2_ISEGR_ISEG2_Pos                  2                                                       /*!< PCU2 ISEGR: ISEG2 Position              */
#define PCU2_ISEGR_ISEG2_Msk                  (0x01UL << PCU2_ISEGR_ISEG2_Pos)                        /*!< PCU2 ISEGR: ISEG2 Mask                  */
#define PCU2_ISEGR_ISEG3_Pos                  3                                                       /*!< PCU2 ISEGR: ISEG3 Position              */
#define PCU2_ISEGR_ISEG3_Msk                  (0x01UL << PCU2_ISEGR_ISEG3_Pos)                        /*!< PCU2 ISEGR: ISEG3 Mask                  */
#define PCU2_ISEGR_ISEG4_Pos                  4                                                       /*!< PCU2 ISEGR: ISEG4 Position              */
#define PCU2_ISEGR_ISEG4_Msk                  (0x01UL << PCU2_ISEGR_ISEG4_Pos)                        /*!< PCU2 ISEGR: ISEG4 Mask                  */
#define PCU2_ISEGR_ISEG5_Pos                  5                                                       /*!< PCU2 ISEGR: ISEG5 Position              */
#define PCU2_ISEGR_ISEG5_Msk                  (0x01UL << PCU2_ISEGR_ISEG5_Pos)                        /*!< PCU2 ISEGR: ISEG5 Mask                  */
#define PCU2_ISEGR_ISEG6_Pos                  6                                                       /*!< PCU2 ISEGR: ISEG6 Position              */
#define PCU2_ISEGR_ISEG6_Msk                  (0x01UL << PCU2_ISEGR_ISEG6_Pos)                        /*!< PCU2 ISEGR: ISEG6 Mask                  */
#define PCU2_ISEGR_ISEG7_Pos                  7                                                       /*!< PCU2 ISEGR: ISEG7 Position              */
#define PCU2_ISEGR_ISEG7_Msk                  (0x01UL << PCU2_ISEGR_ISEG7_Pos)                        /*!< PCU2 ISEGR: ISEG7 Mask                  */
#define PCU2_ISEGR_ISEG8_Pos                  8                                                       /*!< PCU2 ISEGR: ISEG8 Position              */
#define PCU2_ISEGR_ISEG8_Msk                  (0x01UL << PCU2_ISEGR_ISEG8_Pos)                        /*!< PCU2 ISEGR: ISEG8 Mask                  */
#define PCU2_ISEGR_ISEG9_Pos                  9                                                       /*!< PCU2 ISEGR: ISEG9 Position              */
#define PCU2_ISEGR_ISEG9_Msk                  (0x01UL << PCU2_ISEGR_ISEG9_Pos)                        /*!< PCU2 ISEGR: ISEG9 Mask                  */

/* ---------------------------------  PCU2_ISEGIR  -------------------------------- */
#define PCU2_ISEGIR_ISEG0_INV_Pos             0                                                       /*!< PCU2 ISEGIR: ISEG0_INV Position         */
#define PCU2_ISEGIR_ISEG0_INV_Msk             (0x01UL << PCU2_ISEGIR_ISEG0_INV_Pos)                   /*!< PCU2 ISEGIR: ISEG0_INV Mask             */
#define PCU2_ISEGIR_ISEG1_INV_Pos             1                                                       /*!< PCU2 ISEGIR: ISEG1_INV Position         */
#define PCU2_ISEGIR_ISEG1_INV_Msk             (0x01UL << PCU2_ISEGIR_ISEG1_INV_Pos)                   /*!< PCU2 ISEGIR: ISEG1_INV Mask             */
#define PCU2_ISEGIR_ISEG2_INV_Pos             2                                                       /*!< PCU2 ISEGIR: ISEG2_INV Position         */
#define PCU2_ISEGIR_ISEG2_INV_Msk             (0x01UL << PCU2_ISEGIR_ISEG2_INV_Pos)                   /*!< PCU2 ISEGIR: ISEG2_INV Mask             */
#define PCU2_ISEGIR_ISEG3_INV_Pos             3                                                       /*!< PCU2 ISEGIR: ISEG3_INV Position         */
#define PCU2_ISEGIR_ISEG3_INV_Msk             (0x01UL << PCU2_ISEGIR_ISEG3_INV_Pos)                   /*!< PCU2 ISEGIR: ISEG3_INV Mask             */
#define PCU2_ISEGIR_ISEG4_INV_Pos             4                                                       /*!< PCU2 ISEGIR: ISEG4_INV Position         */
#define PCU2_ISEGIR_ISEG4_INV_Msk             (0x01UL << PCU2_ISEGIR_ISEG4_INV_Pos)                   /*!< PCU2 ISEGIR: ISEG4_INV Mask             */
#define PCU2_ISEGIR_ISEG5_INV_Pos             5                                                       /*!< PCU2 ISEGIR: ISEG5_INV Position         */
#define PCU2_ISEGIR_ISEG5_INV_Msk             (0x01UL << PCU2_ISEGIR_ISEG5_INV_Pos)                   /*!< PCU2 ISEGIR: ISEG5_INV Mask             */
#define PCU2_ISEGIR_ISEG6_INV_Pos             6                                                       /*!< PCU2 ISEGIR: ISEG6_INV Position         */
#define PCU2_ISEGIR_ISEG6_INV_Msk             (0x01UL << PCU2_ISEGIR_ISEG6_INV_Pos)                   /*!< PCU2 ISEGIR: ISEG6_INV Mask             */
#define PCU2_ISEGIR_ISEG7_INV_Pos             7                                                       /*!< PCU2 ISEGIR: ISEG7_INV Position         */
#define PCU2_ISEGIR_ISEG7_INV_Msk             (0x01UL << PCU2_ISEGIR_ISEG7_INV_Pos)                   /*!< PCU2 ISEGIR: ISEG7_INV Mask             */
#define PCU2_ISEGIR_ISEG8_INV_Pos             8                                                       /*!< PCU2 ISEGIR: ISEG8_INV Position         */
#define PCU2_ISEGIR_ISEG8_INV_Msk             (0x01UL << PCU2_ISEGIR_ISEG8_INV_Pos)                   /*!< PCU2 ISEGIR: ISEG8_INV Mask             */
#define PCU2_ISEGIR_ISEG9_INV_Pos             9                                                       /*!< PCU2 ISEGIR: ISEG9_INV Position         */
#define PCU2_ISEGIR_ISEG9_INV_Msk             (0x01UL << PCU2_ISEGIR_ISEG9_INV_Pos)                   /*!< PCU2 ISEGIR: ISEG9_INV Mask             */

/* ---------------------------------  PCU2_PORTEN  -------------------------------- */
#define PCU2_PORTEN_PORTEN_Pos                0                                                       /*!< PCU2 PORTEN: PORTEN Position            */
#define PCU2_PORTEN_PORTEN_Msk                (0x000000ffUL << PCU2_PORTEN_PORTEN_Pos)                /*!< PCU2 PORTEN: PORTEN Mask                */


/* ================================================================================ */
/* ================          struct 'CFMC' Position & Mask         ================ */
/* ================================================================================ */


/* ----------------------------------  CFMC_INIT  --------------------------------- */
#define CFMC_INIT_FUSERD_Pos                  0                                                       /*!< CFMC INIT: FUSERD Position              */
#define CFMC_INIT_FUSERD_Msk                  (0x01UL << CFMC_INIT_FUSERD_Pos)                        /*!< CFMC INIT: FUSERD Mask                  */
#define CFMC_INIT_FRBSFLG_Pos                 24                                                      /*!< CFMC INIT: FRBSFLG Position             */
#define CFMC_INIT_FRBSFLG_Msk                 (0x01UL << CFMC_INIT_FRBSFLG_Pos)                       /*!< CFMC INIT: FRBSFLG Mask                 */
#define CFMC_INIT_RBSFLAG_Pos                 28                                                      /*!< CFMC INIT: RBSFLAG Position             */
#define CFMC_INIT_RBSFLAG_Msk                 (0x01UL << CFMC_INIT_RBSFLAG_Pos)                       /*!< CFMC INIT: RBSFLAG Mask                 */
#define CFMC_INIT_RSTBUSY_Pos                 29                                                      /*!< CFMC INIT: RSTBUSY Position             */
#define CFMC_INIT_RSTBUSY_Msk                 (0x01UL << CFMC_INIT_RSTBUSY_Pos)                       /*!< CFMC INIT: RSTBUSY Mask                 */

/* -----------------------------------  CFMC_MR  ---------------------------------- */
#define CFMC_MR_ACODE_Pos                     0                                                       /*!< CFMC MR: ACODE Position                 */
#define CFMC_MR_ACODE_Msk                     (0x7fUL << CFMC_MR_ACODE_Pos)                           /*!< CFMC MR: ACODE Mask                     */

/* -----------------------------------  CFMC_CR  ---------------------------------- */
#define CFMC_CR_HVEN_Pos                      0                                                       /*!< CFMC CR: HVEN Position                  */
#define CFMC_CR_HVEN_Msk                      (0x01UL << CFMC_CR_HVEN_Pos)                            /*!< CFMC CR: HVEN Mask                      */
#define CFMC_CR_ERS_Pos                       1                                                       /*!< CFMC CR: ERS Position                   */
#define CFMC_CR_ERS_Msk                       (0x01UL << CFMC_CR_ERS_Pos)                             /*!< CFMC CR: ERS Mask                       */
#define CFMC_CR_PGM_Pos                       2                                                       /*!< CFMC CR: PGM Position                   */
#define CFMC_CR_PGM_Msk                       (0x01UL << CFMC_CR_PGM_Pos)                             /*!< CFMC CR: PGM Mask                       */
#define CFMC_CR_WADCK_Pos                     3                                                       /*!< CFMC CR: WADCK Position                 */
#define CFMC_CR_WADCK_Msk                     (0x01UL << CFMC_CR_WADCK_Pos)                           /*!< CFMC CR: WADCK Mask                     */
#define CFMC_CR_PMODE_Pos                     4                                                       /*!< CFMC CR: PMODE Position                 */
#define CFMC_CR_PMODE_Msk                     (0x01UL << CFMC_CR_PMODE_Pos)                           /*!< CFMC CR: PMODE Mask                     */
#define CFMC_CR_SECT1K_Pos                    5                                                       /*!< CFMC CR: SECT1K Position                */
#define CFMC_CR_SECT1K_Msk                    (0x01UL << CFMC_CR_SECT1K_Pos)                          /*!< CFMC CR: SECT1K Mask                    */
#define CFMC_CR_SECT4K_Pos                    6                                                       /*!< CFMC CR: SECT4K Position                */
#define CFMC_CR_SECT4K_Msk                    (0x01UL << CFMC_CR_SECT4K_Pos)                          /*!< CFMC CR: SECT4K Mask                    */
#define CFMC_CR_MAS_Pos                       7                                                       /*!< CFMC CR: MAS Position                   */
#define CFMC_CR_MAS_Msk                       (0x01UL << CFMC_CR_MAS_Pos)                             /*!< CFMC CR: MAS Mask                       */
#define CFMC_CR_IFAEN_Pos                     12                                                      /*!< CFMC CR: IFAEN Position                 */
#define CFMC_CR_IFAEN_Msk                     (0x01UL << CFMC_CR_IFAEN_Pos)                           /*!< CFMC CR: IFAEN Mask                     */
#define CFMC_CR_SELFPGM_Pos                   23                                                      /*!< CFMC CR: SELFPGM Position               */
#define CFMC_CR_SELFPGM_Msk                   (0x01UL << CFMC_CR_SELFPGM_Pos)                         /*!< CFMC CR: SELFPGM Mask                   */
#define CFMC_CR_RPAEN_Pos                     24                                                      /*!< CFMC CR: RPAEN Position                 */
#define CFMC_CR_RPAEN_Msk                     (0x01UL << CFMC_CR_RPAEN_Pos)                           /*!< CFMC CR: RPAEN Mask                     */
#define CFMC_CR_BSAEN_Pos                     25                                                      /*!< CFMC CR: BSAEN Position                 */
#define CFMC_CR_BSAEN_Msk                     (0x01UL << CFMC_CR_BSAEN_Pos)                           /*!< CFMC CR: BSAEN Mask                     */

/* -----------------------------------  CFMC_AR  ---------------------------------- */
#define CFMC_AR_FADDR_Pos                     0                                                       /*!< CFMC AR: FADDR Position                 */
#define CFMC_AR_FADDR_Msk                     (0x0000ffffUL << CFMC_AR_FADDR_Pos)                     /*!< CFMC AR: FADDR Mask                     */

/* -----------------------------------  CFMC_DR  ---------------------------------- */
#define CFMC_DR_FDATA_Pos                     0                                                       /*!< CFMC DR: FDATA Position                 */
#define CFMC_DR_FDATA_Msk                     (0xffffffffUL << CFMC_DR_FDATA_Pos)                     /*!< CFMC DR: FDATA Mask                     */

/* ----------------------------------  CFMC_BUSY  --------------------------------- */
#define CFMC_BUSY_WRBUSY_Pos                  0                                                       /*!< CFMC BUSY: WRBUSY Position              */
#define CFMC_BUSY_WRBUSY_Msk                  (0x01UL << CFMC_BUSY_WRBUSY_Pos)                        /*!< CFMC BUSY: WRBUSY Mask                  */

/* --------------------------------  CFMC_CRCCCITT  ------------------------------- */
#define CFMC_CRCCCITT_CRC_Pos                 0                                                       /*!< CFMC CRCCCITT: CRC Position             */
#define CFMC_CRCCCITT_CRC_Msk                 (0x0000ffffUL << CFMC_CRCCCITT_CRC_Pos)                 /*!< CFMC CRCCCITT: CRC Mask                 */

/* ----------------------------------  CFMC_CFG  ---------------------------------- */
#define CFMC_CFG_CRCEN_Pos                    6                                                       /*!< CFMC CFG: CRCEN Position                */
#define CFMC_CFG_CRCEN_Msk                    (0x01UL << CFMC_CFG_CRCEN_Pos)                          /*!< CFMC CFG: CRCEN Mask                    */
#define CFMC_CFG_CRCINIT_Pos                  7                                                       /*!< CFMC CFG: CRCINIT Position              */
#define CFMC_CFG_CRCINIT_Msk                  (0x01UL << CFMC_CFG_CRCINIT_Pos)                        /*!< CFMC CFG: CRCINIT Mask                  */
#define CFMC_CFG_WAIT_Pos                     8                                                       /*!< CFMC CFG: WAIT Position                 */
#define CFMC_CFG_WAIT_Msk                     (0x07UL << CFMC_CFG_WAIT_Pos)                           /*!< CFMC CFG: WAIT Mask                     */
#define CFMC_CFG_WTIDKY_Pos                   16                                                      /*!< CFMC CFG: WTIDKY Position               */
#define CFMC_CFG_WTIDKY_Msk                   (0x0000ffffUL << CFMC_CFG_WTIDKY_Pos)                   /*!< CFMC CFG: WTIDKY Mask                   */

/* ---------------------------------  CFMC_WPROT  --------------------------------- */
#define CFMC_WPROT_WPROT_Pos                  0                                                       /*!< CFMC WPROT: WPROT Position              */
#define CFMC_WPROT_WPROT_Msk                  (0x0000ffffUL << CFMC_WPROT_WPROT_Pos)                  /*!< CFMC WPROT: WPROT Mask                  */

/* ---------------------------------  CFMC_RPROT  --------------------------------- */
#define CFMC_RPROT_RPROT_Pos                  0                                                       /*!< CFMC RPROT: RPROT Position              */
#define CFMC_RPROT_RPROT_Msk                  (0x000000ffUL << CFMC_RPROT_RPROT_Pos)                  /*!< CFMC RPROT: RPROT Mask                  */
#define CFMC_RPROT_LVL1_EN_Pos                8                                                       /*!< CFMC RPROT: LVL1_EN Position            */
#define CFMC_RPROT_LVL1_EN_Msk                (0x01UL << CFMC_RPROT_LVL1_EN_Pos)                      /*!< CFMC RPROT: LVL1_EN Mask                */
#define CFMC_RPROT_LVL2_EN_Pos                9                                                       /*!< CFMC RPROT: LVL2_EN Position            */
#define CFMC_RPROT_LVL2_EN_Msk                (0x01UL << CFMC_RPROT_LVL2_EN_Pos)                      /*!< CFMC RPROT: LVL2_EN Mask                */
#define CFMC_RPROT_LVL1_STS_Pos               16                                                      /*!< CFMC RPROT: LVL1_STS Position           */
#define CFMC_RPROT_LVL1_STS_Msk               (0x01UL << CFMC_RPROT_LVL1_STS_Pos)                     /*!< CFMC RPROT: LVL1_STS Mask               */
#define CFMC_RPROT_LVL2_STS_Pos               17                                                      /*!< CFMC RPROT: LVL2_STS Position           */
#define CFMC_RPROT_LVL2_STS_Msk               (0x01UL << CFMC_RPROT_LVL2_STS_Pos)                     /*!< CFMC RPROT: LVL2_STS Mask               */
#define CFMC_RPROT_CERSD_Pos                  24                                                      /*!< CFMC RPROT: CERSD Position              */
#define CFMC_RPROT_CERSD_Msk                  (0x01UL << CFMC_RPROT_CERSD_Pos)                        /*!< CFMC RPROT: CERSD Mask                  */
#define CFMC_RPROT_RPBERSD_Pos                25                                                      /*!< CFMC RPROT: RPBERSD Position            */
#define CFMC_RPROT_RPBERSD_Msk                (0x01UL << CFMC_RPROT_RPBERSD_Pos)                      /*!< CFMC RPROT: RPBERSD Mask                */
#define CFMC_RPROT_PWMATCH_Pos                26                                                      /*!< CFMC RPROT: PWMATCH Position            */
#define CFMC_RPROT_PWMATCH_Msk                (0x01UL << CFMC_RPROT_PWMATCH_Pos)                      /*!< CFMC RPROT: PWMATCH Mask                */
#define CFMC_RPROT_SRBOOT_Pos                 30                                                      /*!< CFMC RPROT: SRBOOT Position             */
#define CFMC_RPROT_SRBOOT_Msk                 (0x01UL << CFMC_RPROT_SRBOOT_Pos)                       /*!< CFMC RPROT: SRBOOT Mask                 */
#define CFMC_RPROT_DBGMOD_Pos                 31                                                      /*!< CFMC RPROT: DBGMOD Position             */
#define CFMC_RPROT_DBGMOD_Msk                 (0x01UL << CFMC_RPROT_DBGMOD_Pos)                       /*!< CFMC RPROT: DBGMOD Mask                 */

/* ----------------------------------  CFMC_PWIN  --------------------------------- */
#define CFMC_PWIN_PWIN_Pos                    0                                                       /*!< CFMC PWIN: PWIN Position                */
#define CFMC_PWIN_PWIN_Msk                    (0xffffffffUL << CFMC_PWIN_PWIN_Pos)                    /*!< CFMC PWIN: PWIN Mask                    */

/* ---------------------------------  CFMC_PWPRST  -------------------------------- */
#define CFMC_PWPRST_PWPRST_Pos                0                                                       /*!< CFMC PWPRST: PWPRST Position            */
#define CFMC_PWPRST_PWPRST_Msk                (0xffffffffUL << CFMC_PWPRST_PWPRST_Pos)                /*!< CFMC PWPRST: PWPRST Mask                */

/* ----------------------------------  CFMC_BCR  ---------------------------------- */
#define CFMC_BCR_BSW_Pos                      0                                                       /*!< CFMC BCR: BSW Position                  */
#define CFMC_BCR_BSW_Msk                      (0x01UL << CFMC_BCR_BSW_Pos)                            /*!< CFMC BCR: BSW Mask                      */
#define CFMC_BCR_BSE_Pos                      4                                                       /*!< CFMC BCR: BSE Position                  */
#define CFMC_BCR_BSE_Msk                      (0x01UL << CFMC_BCR_BSE_Pos)                            /*!< CFMC BCR: BSE Mask                      */
#define CFMC_BCR_WTIDKY_Pos                   16                                                      /*!< CFMC BCR: WTIDKY Position               */
#define CFMC_BCR_WTIDKY_Msk                   (0x0000ffffUL << CFMC_BCR_WTIDKY_Pos)                   /*!< CFMC BCR: WTIDKY Mask                   */

/* ----------------------------------  CFMC_BSR  ---------------------------------- */
#define CFMC_BSR_BSWST_Pos                    0                                                       /*!< CFMC BSR: BSWST Position                */
#define CFMC_BSR_BSWST_Msk                    (0x01UL << CFMC_BSR_BSWST_Pos)                          /*!< CFMC BSR: BSWST Mask                    */
#define CFMC_BSR_BSST_Pos                     4                                                       /*!< CFMC BSR: BSST Position                 */
#define CFMC_BSR_BSST_Msk                     (0x01UL << CFMC_BSR_BSST_Pos)                           /*!< CFMC BSR: BSST Mask                     */
#define CFMC_BSR_CBF_Pos                      8                                                       /*!< CFMC BSR: CBF Position                  */
#define CFMC_BSR_CBF_Msk                      (0x01UL << CFMC_BSR_CBF_Pos)                            /*!< CFMC BSR: CBF Mask                      */
#define CFMC_BSR_BSERR_Pos                    12                                                      /*!< CFMC BSR: BSERR Position                */
#define CFMC_BSR_BSERR_Msk                    (0x01UL << CFMC_BSR_BSERR_Pos)                          /*!< CFMC BSR: BSERR Mask                    */

/* --------------------------------  CFMC_ABWPROT  -------------------------------- */
#define CFMC_ABWPROT_AB_WPROT_Pos             0                                                       /*!< CFMC ABWPROT: AB_WPROT Position         */
#define CFMC_ABWPROT_AB_WPROT_Msk             (0x0000ffffUL << CFMC_ABWPROT_AB_WPROT_Pos)             /*!< CFMC ABWPROT: AB_WPROT Mask             */
#define CFMC_ABWPROT_AB_KEY_Pos               20                                                      /*!< CFMC ABWPROT: AB_KEY Position           */
#define CFMC_ABWPROT_AB_KEY_Msk               (0x00000fffUL << CFMC_ABWPROT_AB_KEY_Pos)               /*!< CFMC ABWPROT: AB_KEY Mask               */

/* --------------------------------  CFMC_NBWPROT  -------------------------------- */
#define CFMC_NBWPROT_NB_WPROT_Pos             0                                                       /*!< CFMC NBWPROT: NB_WPROT Position         */
#define CFMC_NBWPROT_NB_WPROT_Msk             (0x0000ffffUL << CFMC_NBWPROT_NB_WPROT_Pos)             /*!< CFMC NBWPROT: NB_WPROT Mask             */
#define CFMC_NBWPROT_NB_KEY_Pos               20                                                      /*!< CFMC NBWPROT: NB_KEY Position           */
#define CFMC_NBWPROT_NB_KEY_Msk               (0x00000fffUL << CFMC_NBWPROT_NB_KEY_Pos)               /*!< CFMC NBWPROT: NB_KEY Mask               */

/* ----------------------------------  CFMC_BOOT  --------------------------------- */
#define CFMC_BOOT_BOOTMD_Pos                  0                                                       /*!< CFMC BOOT: BOOTMD Position              */
#define CFMC_BOOT_BOOTMD_Msk                  (0x01UL << CFMC_BOOT_BOOTMD_Pos)                        /*!< CFMC BOOT: BOOTMD Mask                  */
#define CFMC_BOOT_SREMAP_Pos                  4                                                       /*!< CFMC BOOT: SREMAP Position              */
#define CFMC_BOOT_SREMAP_Msk                  (0x01UL << CFMC_BOOT_SREMAP_Pos)                        /*!< CFMC BOOT: SREMAP Mask                  */
#define CFMC_BOOT_FERR_Pos                    6                                                       /*!< CFMC BOOT: FERR Position                */
#define CFMC_BOOT_FERR_Msk                    (0x01UL << CFMC_BOOT_FERR_Pos)                          /*!< CFMC BOOT: FERR Mask                    */
#define CFMC_BOOT_INITFLG_Pos                 7                                                       /*!< CFMC BOOT: INITFLG Position             */
#define CFMC_BOOT_INITFLG_Msk                 (0x01UL << CFMC_BOOT_INITFLG_Pos)                       /*!< CFMC BOOT: INITFLG Mask                 */
#define CFMC_BOOT_SRAMBOOT_Pos                8                                                       /*!< CFMC BOOT: SRAMBOOT Position            */
#define CFMC_BOOT_SRAMBOOT_Msk                (0x01UL << CFMC_BOOT_SRAMBOOT_Pos)                      /*!< CFMC BOOT: SRAMBOOT Mask                */

/* ----------------------------------  CFMC_TMR  ---------------------------------- */
#define CFMC_TMR_TIMER_Pos                    0                                                       /*!< CFMC TMR: TIMER Position                */
#define CFMC_TMR_TIMER_Msk                    (0x000fffffUL << CFMC_TMR_TIMER_Pos)                    /*!< CFMC TMR: TIMER Mask                    */

/* ----------------------------------  CFMC_TICK  --------------------------------- */
#define CFMC_TICK_TICK_Pos                    0                                                       /*!< CFMC TICK: TICK Position                */
#define CFMC_TICK_TICK_Msk                    (0x000fffffUL << CFMC_TICK_TICK_Pos)                    /*!< CFMC TICK: TICK Mask                    */

/* ----------------------------------  CFMC_TEST  --------------------------------- */
#define CFMC_TEST_MCS_Pos                     0                                                       /*!< CFMC TEST: MCS Position                 */
#define CFMC_TEST_MCS_Msk                     (0x01UL << CFMC_TEST_MCS_Pos)                           /*!< CFMC TEST: MCS Mask                     */
#define CFMC_TEST_REDEN_Pos                   1                                                       /*!< CFMC TEST: REDEN Position               */
#define CFMC_TEST_REDEN_Msk                   (0x01UL << CFMC_TEST_REDEN_Pos)                         /*!< CFMC TEST: REDEN Mask                   */
#define CFMC_TEST_LDTEN_Pos                   2                                                       /*!< CFMC TEST: LDTEN Position               */
#define CFMC_TEST_LDTEN_Msk                   (0x01UL << CFMC_TEST_LDTEN_Pos)                         /*!< CFMC TEST: LDTEN Mask                   */
#define CFMC_TEST_DCT_Pos                     3                                                       /*!< CFMC TEST: DCT Position                 */
#define CFMC_TEST_DCT_Msk                     (0x01UL << CFMC_TEST_DCT_Pos)                           /*!< CFMC TEST: DCT Mask                     */
#define CFMC_TEST_TREGSEL_Pos                 6                                                       /*!< CFMC TEST: TREGSEL Position             */
#define CFMC_TEST_TREGSEL_Msk                 (0x01UL << CFMC_TEST_TREGSEL_Pos)                       /*!< CFMC TEST: TREGSEL Mask                 */
#define CFMC_TEST_TSMODE_Pos                  7                                                       /*!< CFMC TEST: TSMODE Position              */
#define CFMC_TEST_TSMODE_Msk                  (0x01UL << CFMC_TEST_TSMODE_Pos)                        /*!< CFMC TEST: TSMODE Mask                  */
#define CFMC_TEST_PROT_Pos                    8                                                       /*!< CFMC TEST: PROT Position                */
#define CFMC_TEST_PROT_Msk                    (0x000001ffUL << CFMC_TEST_PROT_Pos)                    /*!< CFMC TEST: PROT Mask                    */
#define CFMC_TEST_STOP_Pos                    20                                                      /*!< CFMC TEST: STOP Position                */
#define CFMC_TEST_STOP_Msk                    (0x01UL << CFMC_TEST_STOP_Pos)                          /*!< CFMC TEST: STOP Mask                    */
#define CFMC_TEST_HIDDEN0_Pos                 21                                                      /*!< CFMC TEST: HIDDEN0 Position             */
#define CFMC_TEST_HIDDEN0_Msk                 (0x03UL << CFMC_TEST_HIDDEN0_Pos)                       /*!< CFMC TEST: HIDDEN0 Mask                 */
#define CFMC_TEST_HIDDEN1_Pos                 24                                                      /*!< CFMC TEST: HIDDEN1 Position             */
#define CFMC_TEST_HIDDEN1_Msk                 (0x0fUL << CFMC_TEST_HIDDEN1_Pos)                       /*!< CFMC TEST: HIDDEN1 Mask                 */
#define CFMC_TEST_TESTFLG_Pos                 31                                                      /*!< CFMC TEST: TESTFLG Position             */
#define CFMC_TEST_TESTFLG_Msk                 (0x01UL << CFMC_TEST_TESTFLG_Pos)                       /*!< CFMC TEST: TESTFLG Mask                 */


/* ================================================================================ */
/* ================          struct 'DFMC' Position & Mask         ================ */
/* ================================================================================ */


/* ----------------------------------  DFMC_INIT  --------------------------------- */
#define DFMC_INIT_FUSERD_Pos                  0                                                       /*!< DFMC INIT: FUSERD Position              */
#define DFMC_INIT_FUSERD_Msk                  (0x01UL << DFMC_INIT_FUSERD_Pos)                        /*!< DFMC INIT: FUSERD Mask                  */
#define DFMC_INIT_FRBSFLG_Pos                 24                                                      /*!< DFMC INIT: FRBSFLG Position             */
#define DFMC_INIT_FRBSFLG_Msk                 (0x01UL << DFMC_INIT_FRBSFLG_Pos)                       /*!< DFMC INIT: FRBSFLG Mask                 */
#define DFMC_INIT_RBSFLAG_Pos                 28                                                      /*!< DFMC INIT: RBSFLAG Position             */
#define DFMC_INIT_RBSFLAG_Msk                 (0x01UL << DFMC_INIT_RBSFLAG_Pos)                       /*!< DFMC INIT: RBSFLAG Mask                 */
#define DFMC_INIT_RSTBUSY_Pos                 29                                                      /*!< DFMC INIT: RSTBUSY Position             */
#define DFMC_INIT_RSTBUSY_Msk                 (0x01UL << DFMC_INIT_RSTBUSY_Pos)                       /*!< DFMC INIT: RSTBUSY Mask                 */

/* -----------------------------------  DFMC_MR  ---------------------------------- */
#define DFMC_MR_ACODE_Pos                     0                                                       /*!< DFMC MR: ACODE Position                 */
#define DFMC_MR_ACODE_Msk                     (0x7fUL << DFMC_MR_ACODE_Pos)                           /*!< DFMC MR: ACODE Mask                     */

/* -----------------------------------  DFMC_CR  ---------------------------------- */
#define DFMC_CR_HVEN_Pos                      0                                                       /*!< DFMC CR: HVEN Position                  */
#define DFMC_CR_HVEN_Msk                      (0x01UL << DFMC_CR_HVEN_Pos)                            /*!< DFMC CR: HVEN Mask                      */
#define DFMC_CR_ERS_Pos                       1                                                       /*!< DFMC CR: ERS Position                   */
#define DFMC_CR_ERS_Msk                       (0x01UL << DFMC_CR_ERS_Pos)                             /*!< DFMC CR: ERS Mask                       */
#define DFMC_CR_PGM_Pos                       2                                                       /*!< DFMC CR: PGM Position                   */
#define DFMC_CR_PGM_Msk                       (0x01UL << DFMC_CR_PGM_Pos)                             /*!< DFMC CR: PGM Mask                       */
#define DFMC_CR_WADCK_Pos                     3                                                       /*!< DFMC CR: WADCK Position                 */
#define DFMC_CR_WADCK_Msk                     (0x01UL << DFMC_CR_WADCK_Pos)                           /*!< DFMC CR: WADCK Mask                     */
#define DFMC_CR_PMODE_Pos                     4                                                       /*!< DFMC CR: PMODE Position                 */
#define DFMC_CR_PMODE_Msk                     (0x01UL << DFMC_CR_PMODE_Pos)                           /*!< DFMC CR: PMODE Mask                     */
#define DFMC_CR_SECT1K_Pos                    5                                                       /*!< DFMC CR: SECT1K Position                */
#define DFMC_CR_SECT1K_Msk                    (0x01UL << DFMC_CR_SECT1K_Pos)                          /*!< DFMC CR: SECT1K Mask                    */
#define DFMC_CR_SECT4K_Pos                    6                                                       /*!< DFMC CR: SECT4K Position                */
#define DFMC_CR_SECT4K_Msk                    (0x01UL << DFMC_CR_SECT4K_Pos)                          /*!< DFMC CR: SECT4K Mask                    */
#define DFMC_CR_MAS_Pos                       7                                                       /*!< DFMC CR: MAS Position                   */
#define DFMC_CR_MAS_Msk                       (0x01UL << DFMC_CR_MAS_Pos)                             /*!< DFMC CR: MAS Mask                       */
#define DFMC_CR_WPGMEN_Pos                    16                                                      /*!< DFMC CR: WPGMEN Position                */
#define DFMC_CR_WPGMEN_Msk                    (0x01UL << DFMC_CR_WPGMEN_Pos)                          /*!< DFMC CR: WPGMEN Mask                    */
#define DFMC_CR_RPAEN_Pos                     24                                                      /*!< DFMC CR: RPAEN Position                 */
#define DFMC_CR_RPAEN_Msk                     (0x01UL << DFMC_CR_RPAEN_Pos)                           /*!< DFMC CR: RPAEN Mask                     */

/* -----------------------------------  DFMC_AR  ---------------------------------- */
#define DFMC_AR_FADDR_Pos                     0                                                       /*!< DFMC AR: FADDR Position                 */
#define DFMC_AR_FADDR_Msk                     (0x0000ffffUL << DFMC_AR_FADDR_Pos)                     /*!< DFMC AR: FADDR Mask                     */

/* -----------------------------------  DFMC_DR  ---------------------------------- */
#define DFMC_DR_FDATA_Pos                     0                                                       /*!< DFMC DR: FDATA Position                 */
#define DFMC_DR_FDATA_Msk                     (0xffffffffUL << DFMC_DR_FDATA_Pos)                     /*!< DFMC DR: FDATA Mask                     */

/* ----------------------------------  DFMC_BUSY  --------------------------------- */
#define DFMC_BUSY_WRBUSY_Pos                  0                                                       /*!< DFMC BUSY: WRBUSY Position              */
#define DFMC_BUSY_WRBUSY_Msk                  (0x01UL << DFMC_BUSY_WRBUSY_Pos)                        /*!< DFMC BUSY: WRBUSY Mask                  */

/* --------------------------------  DFMC_CRCCCITT  ------------------------------- */
#define DFMC_CRCCCITT_CRC_Pos                 0                                                       /*!< DFMC CRCCCITT: CRC Position             */
#define DFMC_CRCCCITT_CRC_Msk                 (0x0000ffffUL << DFMC_CRCCCITT_CRC_Pos)                 /*!< DFMC CRCCCITT: CRC Mask                 */

/* ----------------------------------  DFMC_CFG  ---------------------------------- */
#define DFMC_CFG_CRCEN_Pos                    6                                                       /*!< DFMC CFG: CRCEN Position                */
#define DFMC_CFG_CRCEN_Msk                    (0x01UL << DFMC_CFG_CRCEN_Pos)                          /*!< DFMC CFG: CRCEN Mask                    */
#define DFMC_CFG_CRCINIT_Pos                  7                                                       /*!< DFMC CFG: CRCINIT Position              */
#define DFMC_CFG_CRCINIT_Msk                  (0x01UL << DFMC_CFG_CRCINIT_Pos)                        /*!< DFMC CFG: CRCINIT Mask                  */
#define DFMC_CFG_WAIT_Pos                     8                                                       /*!< DFMC CFG: WAIT Position                 */
#define DFMC_CFG_WAIT_Msk                     (0x07UL << DFMC_CFG_WAIT_Pos)                           /*!< DFMC CFG: WAIT Mask                     */
#define DFMC_CFG_WTIDKY_Pos                   16                                                      /*!< DFMC CFG: WTIDKY Position               */
#define DFMC_CFG_WTIDKY_Msk                   (0x0000ffffUL << DFMC_CFG_WTIDKY_Pos)                   /*!< DFMC CFG: WTIDKY Mask                   */

/* ---------------------------------  DFMC_WPROT  --------------------------------- */
#define DFMC_WPROT_WPROT_Pos                  0                                                       /*!< DFMC WPROT: WPROT Position              */
#define DFMC_WPROT_WPROT_Msk                  (0xffffffffUL << DFMC_WPROT_WPROT_Pos)                  /*!< DFMC WPROT: WPROT Mask                  */

/* ---------------------------------  DFMC_RPROT  --------------------------------- */
#define DFMC_RPROT_RPROT_Pos                  0                                                       /*!< DFMC RPROT: RPROT Position              */
#define DFMC_RPROT_RPROT_Msk                  (0x000000ffUL << DFMC_RPROT_RPROT_Pos)                  /*!< DFMC RPROT: RPROT Mask                  */
#define DFMC_RPROT_RPROT_EN_Pos               8                                                       /*!< DFMC RPROT: RPROT_EN Position           */
#define DFMC_RPROT_RPROT_EN_Msk               (0x01UL << DFMC_RPROT_RPROT_EN_Pos)                     /*!< DFMC RPROT: RPROT_EN Mask               */
#define DFMC_RPROT_RPROT_STS_Pos              16                                                      /*!< DFMC RPROT: RPROT_STS Position          */
#define DFMC_RPROT_RPROT_STS_Msk              (0x01UL << DFMC_RPROT_RPROT_STS_Pos)                    /*!< DFMC RPROT: RPROT_STS Mask              */
#define DFMC_RPROT_CERSD_Pos                  24                                                      /*!< DFMC RPROT: CERSD Position              */
#define DFMC_RPROT_CERSD_Msk                  (0x01UL << DFMC_RPROT_CERSD_Pos)                        /*!< DFMC RPROT: CERSD Mask                  */
#define DFMC_RPROT_RPBERSD_Pos                25                                                      /*!< DFMC RPROT: RPBERSD Position            */
#define DFMC_RPROT_RPBERSD_Msk                (0x01UL << DFMC_RPROT_RPBERSD_Pos)                      /*!< DFMC RPROT: RPBERSD Mask                */
#define DFMC_RPROT_PWMATCH_Pos                26                                                      /*!< DFMC RPROT: PWMATCH Position            */
#define DFMC_RPROT_PWMATCH_Msk                (0x01UL << DFMC_RPROT_PWMATCH_Pos)                      /*!< DFMC RPROT: PWMATCH Mask                */
#define DFMC_RPROT_SRBOOT_Pos                 30                                                      /*!< DFMC RPROT: SRBOOT Position             */
#define DFMC_RPROT_SRBOOT_Msk                 (0x01UL << DFMC_RPROT_SRBOOT_Pos)                       /*!< DFMC RPROT: SRBOOT Mask                 */
#define DFMC_RPROT_DBGMOD_Pos                 31                                                      /*!< DFMC RPROT: DBGMOD Position             */
#define DFMC_RPROT_DBGMOD_Msk                 (0x01UL << DFMC_RPROT_DBGMOD_Pos)                       /*!< DFMC RPROT: DBGMOD Mask                 */

/* ----------------------------------  DFMC_PWIN  --------------------------------- */
#define DFMC_PWIN_PWIN_Pos                    0                                                       /*!< DFMC PWIN: PWIN Position                */
#define DFMC_PWIN_PWIN_Msk                    (0xffffffffUL << DFMC_PWIN_PWIN_Pos)                    /*!< DFMC PWIN: PWIN Mask                    */

/* ---------------------------------  DFMC_PWPRST  -------------------------------- */
#define DFMC_PWPRST_PWPRST_Pos                0                                                       /*!< DFMC PWPRST: PWPRST Position            */
#define DFMC_PWPRST_PWPRST_Msk                (0xffffffffUL << DFMC_PWPRST_PWPRST_Pos)                /*!< DFMC PWPRST: PWPRST Mask                */

/* ----------------------------------  DFMC_TEST  --------------------------------- */
#define DFMC_TEST_MCS_Pos                     0                                                       /*!< DFMC TEST: MCS Position                 */
#define DFMC_TEST_MCS_Msk                     (0x01UL << DFMC_TEST_MCS_Pos)                           /*!< DFMC TEST: MCS Mask                     */
#define DFMC_TEST_REDEN_Pos                   1                                                       /*!< DFMC TEST: REDEN Position               */
#define DFMC_TEST_REDEN_Msk                   (0x01UL << DFMC_TEST_REDEN_Pos)                         /*!< DFMC TEST: REDEN Mask                   */
#define DFMC_TEST_LDTEN_Pos                   2                                                       /*!< DFMC TEST: LDTEN Position               */
#define DFMC_TEST_LDTEN_Msk                   (0x01UL << DFMC_TEST_LDTEN_Pos)                         /*!< DFMC TEST: LDTEN Mask                   */
#define DFMC_TEST_DCT_Pos                     3                                                       /*!< DFMC TEST: DCT Position                 */
#define DFMC_TEST_DCT_Msk                     (0x01UL << DFMC_TEST_DCT_Pos)                           /*!< DFMC TEST: DCT Mask                     */
#define DFMC_TEST_TREGSEL_Pos                 6                                                       /*!< DFMC TEST: TREGSEL Position             */
#define DFMC_TEST_TREGSEL_Msk                 (0x01UL << DFMC_TEST_TREGSEL_Pos)                       /*!< DFMC TEST: TREGSEL Mask                 */
#define DFMC_TEST_TSMODE_Pos                  7                                                       /*!< DFMC TEST: TSMODE Position              */
#define DFMC_TEST_TSMODE_Msk                  (0x01UL << DFMC_TEST_TSMODE_Pos)                        /*!< DFMC TEST: TSMODE Mask                  */
#define DFMC_TEST_PROT_Pos                    8                                                       /*!< DFMC TEST: PROT Position                */
#define DFMC_TEST_PROT_Msk                    (0x000001ffUL << DFMC_TEST_PROT_Pos)                    /*!< DFMC TEST: PROT Mask                    */
#define DFMC_TEST_STOP_Pos                    20                                                      /*!< DFMC TEST: STOP Position                */
#define DFMC_TEST_STOP_Msk                    (0x01UL << DFMC_TEST_STOP_Pos)                          /*!< DFMC TEST: STOP Mask                    */
#define DFMC_TEST_HIDDEN0_Pos                 21                                                      /*!< DFMC TEST: HIDDEN0 Position             */
#define DFMC_TEST_HIDDEN0_Msk                 (0x03UL << DFMC_TEST_HIDDEN0_Pos)                       /*!< DFMC TEST: HIDDEN0 Mask                 */
#define DFMC_TEST_HIDDEN1_Pos                 24                                                      /*!< DFMC TEST: HIDDEN1 Position             */
#define DFMC_TEST_HIDDEN1_Msk                 (0x0fUL << DFMC_TEST_HIDDEN1_Pos)                       /*!< DFMC TEST: HIDDEN1 Mask                 */
#define DFMC_TEST_TESTFLG_Pos                 31                                                      /*!< DFMC TEST: TESTFLG Position             */
#define DFMC_TEST_TESTFLG_Msk                 (0x01UL << DFMC_TEST_TESTFLG_Pos)                       /*!< DFMC TEST: TESTFLG Mask                 */


/* ================================================================================ */
/* ================          Group 'DMAC' Position & Mask          ================ */
/* ================================================================================ */


/* -----------------------------------  DMAC_CR  ---------------------------------- */
#define DMAC_CR_DIR_Pos                       1                                                       /*!< DMAC CR: DIR Position                   */
#define DMAC_CR_DIR_Msk                       (0x01UL << DMAC_CR_DIR_Pos)                             /*!< DMAC CR: DIR Mask                       */
#define DMAC_CR_SIZE_Pos                      2                                                       /*!< DMAC CR: SIZE Position                  */
#define DMAC_CR_SIZE_Msk                      (0x03UL << DMAC_CR_SIZE_Pos)                            /*!< DMAC CR: SIZE Mask                      */
#define DMAC_CR_PERISEL_Pos                   8                                                       /*!< DMAC CR: PERISEL Position               */
#define DMAC_CR_PERISEL_Msk                   (0x1fUL << DMAC_CR_PERISEL_Pos)                         /*!< DMAC CR: PERISEL Mask                   */
#define DMAC_CR_TRANSCNT_Pos                  16                                                      /*!< DMAC CR: TRANSCNT Position              */
#define DMAC_CR_TRANSCNT_Msk                  (0x00000fffUL << DMAC_CR_TRANSCNT_Pos)                  /*!< DMAC CR: TRANSCNT Mask                  */

/* -----------------------------------  DMAC_SR  ---------------------------------- */
#define DMAC_SR_DMAEN_Pos                     0                                                       /*!< DMAC SR: DMAEN Position                 */
#define DMAC_SR_DMAEN_Msk                     (0x01UL << DMAC_SR_DMAEN_Pos)                           /*!< DMAC SR: DMAEN Mask                     */
#define DMAC_SR_DMARC_Pos                     4                                                       /*!< DMAC SR: DMARC Position                 */
#define DMAC_SR_DMARC_Msk                     (0x01UL << DMAC_SR_DMARC_Pos)                           /*!< DMAC SR: DMARC Mask                     */
#define DMAC_SR_EOT_Pos                       7                                                       /*!< DMAC SR: EOT Position                   */
#define DMAC_SR_EOT_Msk                       (0x01UL << DMAC_SR_EOT_Pos)                             /*!< DMAC SR: EOT Mask                       */

/* ----------------------------------  DMAC_PAR  ---------------------------------- */
#define DMAC_PAR_PAR_Pos                      0                                                       /*!< DMAC PAR: PAR Position                  */
#define DMAC_PAR_PAR_Msk                      (0x0000ffffUL << DMAC_PAR_PAR_Pos)                      /*!< DMAC PAR: PAR Mask                      */

/* ----------------------------------  DMAC_MAR  ---------------------------------- */
#define DMAC_MAR_MAR_Pos                      0                                                       /*!< DMAC MAR: MAR Position                  */
#define DMAC_MAR_MAR_Msk                      (0x0000ffffUL << DMAC_MAR_MAR_Pos)                      /*!< DMAC MAR: MAR Mask                      */
#define DMAC_MAR_OFFSET_Pos                   29                                                      /*!< DMAC MAR: OFFSET Position               */
#define DMAC_MAR_OFFSET_Msk                   (0x03UL << DMAC_MAR_OFFSET_Pos)                         /*!< DMAC MAR: OFFSET Mask                   */


/* ================================================================================ */
/* ================         struct 'DMAC0' Position & Mask         ================ */
/* ================================================================================ */


/* ----------------------------------  DMAC0_CR  ---------------------------------- */
#define DMAC0_CR_DIR_Pos                      1                                                       /*!< DMAC0 CR: DIR Position                  */
#define DMAC0_CR_DIR_Msk                      (0x01UL << DMAC0_CR_DIR_Pos)                            /*!< DMAC0 CR: DIR Mask                      */
#define DMAC0_CR_SIZE_Pos                     2                                                       /*!< DMAC0 CR: SIZE Position                 */
#define DMAC0_CR_SIZE_Msk                     (0x03UL << DMAC0_CR_SIZE_Pos)                           /*!< DMAC0 CR: SIZE Mask                     */
#define DMAC0_CR_PERISEL_Pos                  8                                                       /*!< DMAC0 CR: PERISEL Position              */
#define DMAC0_CR_PERISEL_Msk                  (0x1fUL << DMAC0_CR_PERISEL_Pos)                        /*!< DMAC0 CR: PERISEL Mask                  */
#define DMAC0_CR_TRANSCNT_Pos                 16                                                      /*!< DMAC0 CR: TRANSCNT Position             */
#define DMAC0_CR_TRANSCNT_Msk                 (0x00000fffUL << DMAC0_CR_TRANSCNT_Pos)                 /*!< DMAC0 CR: TRANSCNT Mask                 */

/* ----------------------------------  DMAC0_SR  ---------------------------------- */
#define DMAC0_SR_DMAEN_Pos                    0                                                       /*!< DMAC0 SR: DMAEN Position                */
#define DMAC0_SR_DMAEN_Msk                    (0x01UL << DMAC0_SR_DMAEN_Pos)                          /*!< DMAC0 SR: DMAEN Mask                    */
#define DMAC0_SR_DMARC_Pos                    4                                                       /*!< DMAC0 SR: DMARC Position                */
#define DMAC0_SR_DMARC_Msk                    (0x01UL << DMAC0_SR_DMARC_Pos)                          /*!< DMAC0 SR: DMARC Mask                    */
#define DMAC0_SR_EOT_Pos                      7                                                       /*!< DMAC0 SR: EOT Position                  */
#define DMAC0_SR_EOT_Msk                      (0x01UL << DMAC0_SR_EOT_Pos)                            /*!< DMAC0 SR: EOT Mask                      */

/* ----------------------------------  DMAC0_PAR  --------------------------------- */
#define DMAC0_PAR_PAR_Pos                     0                                                       /*!< DMAC0 PAR: PAR Position                 */
#define DMAC0_PAR_PAR_Msk                     (0x0000ffffUL << DMAC0_PAR_PAR_Pos)                     /*!< DMAC0 PAR: PAR Mask                     */

/* ----------------------------------  DMAC0_MAR  --------------------------------- */
#define DMAC0_MAR_MAR_Pos                     0                                                       /*!< DMAC0 MAR: MAR Position                 */
#define DMAC0_MAR_MAR_Msk                     (0x0000ffffUL << DMAC0_MAR_MAR_Pos)                     /*!< DMAC0 MAR: MAR Mask                     */
#define DMAC0_MAR_OFFSET_Pos                  29                                                      /*!< DMAC0 MAR: OFFSET Position              */
#define DMAC0_MAR_OFFSET_Msk                  (0x03UL << DMAC0_MAR_OFFSET_Pos)                        /*!< DMAC0 MAR: OFFSET Mask                  */


/* ================================================================================ */
/* ================         struct 'DMAC1' Position & Mask         ================ */
/* ================================================================================ */


/* ----------------------------------  DMAC1_CR  ---------------------------------- */
#define DMAC1_CR_DIR_Pos                      1                                                       /*!< DMAC1 CR: DIR Position                  */
#define DMAC1_CR_DIR_Msk                      (0x01UL << DMAC1_CR_DIR_Pos)                            /*!< DMAC1 CR: DIR Mask                      */
#define DMAC1_CR_SIZE_Pos                     2                                                       /*!< DMAC1 CR: SIZE Position                 */
#define DMAC1_CR_SIZE_Msk                     (0x03UL << DMAC1_CR_SIZE_Pos)                           /*!< DMAC1 CR: SIZE Mask                     */
#define DMAC1_CR_PERISEL_Pos                  8                                                       /*!< DMAC1 CR: PERISEL Position              */
#define DMAC1_CR_PERISEL_Msk                  (0x1fUL << DMAC1_CR_PERISEL_Pos)                        /*!< DMAC1 CR: PERISEL Mask                  */
#define DMAC1_CR_TRANSCNT_Pos                 16                                                      /*!< DMAC1 CR: TRANSCNT Position             */
#define DMAC1_CR_TRANSCNT_Msk                 (0x00000fffUL << DMAC1_CR_TRANSCNT_Pos)                 /*!< DMAC1 CR: TRANSCNT Mask                 */

/* ----------------------------------  DMAC1_SR  ---------------------------------- */
#define DMAC1_SR_DMAEN_Pos                    0                                                       /*!< DMAC1 SR: DMAEN Position                */
#define DMAC1_SR_DMAEN_Msk                    (0x01UL << DMAC1_SR_DMAEN_Pos)                          /*!< DMAC1 SR: DMAEN Mask                    */
#define DMAC1_SR_DMARC_Pos                    4                                                       /*!< DMAC1 SR: DMARC Position                */
#define DMAC1_SR_DMARC_Msk                    (0x01UL << DMAC1_SR_DMARC_Pos)                          /*!< DMAC1 SR: DMARC Mask                    */
#define DMAC1_SR_EOT_Pos                      7                                                       /*!< DMAC1 SR: EOT Position                  */
#define DMAC1_SR_EOT_Msk                      (0x01UL << DMAC1_SR_EOT_Pos)                            /*!< DMAC1 SR: EOT Mask                      */

/* ----------------------------------  DMAC1_PAR  --------------------------------- */
#define DMAC1_PAR_PAR_Pos                     0                                                       /*!< DMAC1 PAR: PAR Position                 */
#define DMAC1_PAR_PAR_Msk                     (0x0000ffffUL << DMAC1_PAR_PAR_Pos)                     /*!< DMAC1 PAR: PAR Mask                     */

/* ----------------------------------  DMAC1_MAR  --------------------------------- */
#define DMAC1_MAR_MAR_Pos                     0                                                       /*!< DMAC1 MAR: MAR Position                 */
#define DMAC1_MAR_MAR_Msk                     (0x0000ffffUL << DMAC1_MAR_MAR_Pos)                     /*!< DMAC1 MAR: MAR Mask                     */
#define DMAC1_MAR_OFFSET_Pos                  29                                                      /*!< DMAC1 MAR: OFFSET Position              */
#define DMAC1_MAR_OFFSET_Msk                  (0x03UL << DMAC1_MAR_OFFSET_Pos)                        /*!< DMAC1 MAR: OFFSET Mask                  */


/* ================================================================================ */
/* ================         struct 'DMAC2' Position & Mask         ================ */
/* ================================================================================ */


/* ----------------------------------  DMAC2_CR  ---------------------------------- */
#define DMAC2_CR_DIR_Pos                      1                                                       /*!< DMAC2 CR: DIR Position                  */
#define DMAC2_CR_DIR_Msk                      (0x01UL << DMAC2_CR_DIR_Pos)                            /*!< DMAC2 CR: DIR Mask                      */
#define DMAC2_CR_SIZE_Pos                     2                                                       /*!< DMAC2 CR: SIZE Position                 */
#define DMAC2_CR_SIZE_Msk                     (0x03UL << DMAC2_CR_SIZE_Pos)                           /*!< DMAC2 CR: SIZE Mask                     */
#define DMAC2_CR_PERISEL_Pos                  8                                                       /*!< DMAC2 CR: PERISEL Position              */
#define DMAC2_CR_PERISEL_Msk                  (0x1fUL << DMAC2_CR_PERISEL_Pos)                        /*!< DMAC2 CR: PERISEL Mask                  */
#define DMAC2_CR_TRANSCNT_Pos                 16                                                      /*!< DMAC2 CR: TRANSCNT Position             */
#define DMAC2_CR_TRANSCNT_Msk                 (0x00000fffUL << DMAC2_CR_TRANSCNT_Pos)                 /*!< DMAC2 CR: TRANSCNT Mask                 */

/* ----------------------------------  DMAC2_SR  ---------------------------------- */
#define DMAC2_SR_DMAEN_Pos                    0                                                       /*!< DMAC2 SR: DMAEN Position                */
#define DMAC2_SR_DMAEN_Msk                    (0x01UL << DMAC2_SR_DMAEN_Pos)                          /*!< DMAC2 SR: DMAEN Mask                    */
#define DMAC2_SR_DMARC_Pos                    4                                                       /*!< DMAC2 SR: DMARC Position                */
#define DMAC2_SR_DMARC_Msk                    (0x01UL << DMAC2_SR_DMARC_Pos)                          /*!< DMAC2 SR: DMARC Mask                    */
#define DMAC2_SR_EOT_Pos                      7                                                       /*!< DMAC2 SR: EOT Position                  */
#define DMAC2_SR_EOT_Msk                      (0x01UL << DMAC2_SR_EOT_Pos)                            /*!< DMAC2 SR: EOT Mask                      */

/* ----------------------------------  DMAC2_PAR  --------------------------------- */
#define DMAC2_PAR_PAR_Pos                     0                                                       /*!< DMAC2 PAR: PAR Position                 */
#define DMAC2_PAR_PAR_Msk                     (0x0000ffffUL << DMAC2_PAR_PAR_Pos)                     /*!< DMAC2 PAR: PAR Mask                     */

/* ----------------------------------  DMAC2_MAR  --------------------------------- */
#define DMAC2_MAR_MAR_Pos                     0                                                       /*!< DMAC2 MAR: MAR Position                 */
#define DMAC2_MAR_MAR_Msk                     (0x0000ffffUL << DMAC2_MAR_MAR_Pos)                     /*!< DMAC2 MAR: MAR Mask                     */
#define DMAC2_MAR_OFFSET_Pos                  29                                                      /*!< DMAC2 MAR: OFFSET Position              */
#define DMAC2_MAR_OFFSET_Msk                  (0x03UL << DMAC2_MAR_OFFSET_Pos)                        /*!< DMAC2 MAR: OFFSET Mask                  */


/* ================================================================================ */
/* ================         struct 'DMAC3' Position & Mask         ================ */
/* ================================================================================ */


/* ----------------------------------  DMAC3_CR  ---------------------------------- */
#define DMAC3_CR_DIR_Pos                      1                                                       /*!< DMAC3 CR: DIR Position                  */
#define DMAC3_CR_DIR_Msk                      (0x01UL << DMAC3_CR_DIR_Pos)                            /*!< DMAC3 CR: DIR Mask                      */
#define DMAC3_CR_SIZE_Pos                     2                                                       /*!< DMAC3 CR: SIZE Position                 */
#define DMAC3_CR_SIZE_Msk                     (0x03UL << DMAC3_CR_SIZE_Pos)                           /*!< DMAC3 CR: SIZE Mask                     */
#define DMAC3_CR_PERISEL_Pos                  8                                                       /*!< DMAC3 CR: PERISEL Position              */
#define DMAC3_CR_PERISEL_Msk                  (0x1fUL << DMAC3_CR_PERISEL_Pos)                        /*!< DMAC3 CR: PERISEL Mask                  */
#define DMAC3_CR_TRANSCNT_Pos                 16                                                      /*!< DMAC3 CR: TRANSCNT Position             */
#define DMAC3_CR_TRANSCNT_Msk                 (0x00000fffUL << DMAC3_CR_TRANSCNT_Pos)                 /*!< DMAC3 CR: TRANSCNT Mask                 */

/* ----------------------------------  DMAC3_SR  ---------------------------------- */
#define DMAC3_SR_DMAEN_Pos                    0                                                       /*!< DMAC3 SR: DMAEN Position                */
#define DMAC3_SR_DMAEN_Msk                    (0x01UL << DMAC3_SR_DMAEN_Pos)                          /*!< DMAC3 SR: DMAEN Mask                    */
#define DMAC3_SR_DMARC_Pos                    4                                                       /*!< DMAC3 SR: DMARC Position                */
#define DMAC3_SR_DMARC_Msk                    (0x01UL << DMAC3_SR_DMARC_Pos)                          /*!< DMAC3 SR: DMARC Mask                    */
#define DMAC3_SR_EOT_Pos                      7                                                       /*!< DMAC3 SR: EOT Position                  */
#define DMAC3_SR_EOT_Msk                      (0x01UL << DMAC3_SR_EOT_Pos)                            /*!< DMAC3 SR: EOT Mask                      */

/* ----------------------------------  DMAC3_PAR  --------------------------------- */
#define DMAC3_PAR_PAR_Pos                     0                                                       /*!< DMAC3 PAR: PAR Position                 */
#define DMAC3_PAR_PAR_Msk                     (0x0000ffffUL << DMAC3_PAR_PAR_Pos)                     /*!< DMAC3 PAR: PAR Mask                     */

/* ----------------------------------  DMAC3_MAR  --------------------------------- */
#define DMAC3_MAR_MAR_Pos                     0                                                       /*!< DMAC3 MAR: MAR Position                 */
#define DMAC3_MAR_MAR_Msk                     (0x0000ffffUL << DMAC3_MAR_MAR_Pos)                     /*!< DMAC3 MAR: MAR Mask                     */
#define DMAC3_MAR_OFFSET_Pos                  29                                                      /*!< DMAC3 MAR: OFFSET Position              */
#define DMAC3_MAR_OFFSET_Msk                  (0x03UL << DMAC3_MAR_OFFSET_Pos)                        /*!< DMAC3 MAR: OFFSET Mask                  */


/* ================================================================================ */
/* ================         struct 'DMAC4' Position & Mask         ================ */
/* ================================================================================ */


/* ----------------------------------  DMAC4_CR  ---------------------------------- */
#define DMAC4_CR_DIR_Pos                      1                                                       /*!< DMAC4 CR: DIR Position                  */
#define DMAC4_CR_DIR_Msk                      (0x01UL << DMAC4_CR_DIR_Pos)                            /*!< DMAC4 CR: DIR Mask                      */
#define DMAC4_CR_SIZE_Pos                     2                                                       /*!< DMAC4 CR: SIZE Position                 */
#define DMAC4_CR_SIZE_Msk                     (0x03UL << DMAC4_CR_SIZE_Pos)                           /*!< DMAC4 CR: SIZE Mask                     */
#define DMAC4_CR_PERISEL_Pos                  8                                                       /*!< DMAC4 CR: PERISEL Position              */
#define DMAC4_CR_PERISEL_Msk                  (0x1fUL << DMAC4_CR_PERISEL_Pos)                        /*!< DMAC4 CR: PERISEL Mask                  */
#define DMAC4_CR_TRANSCNT_Pos                 16                                                      /*!< DMAC4 CR: TRANSCNT Position             */
#define DMAC4_CR_TRANSCNT_Msk                 (0x00000fffUL << DMAC4_CR_TRANSCNT_Pos)                 /*!< DMAC4 CR: TRANSCNT Mask                 */

/* ----------------------------------  DMAC4_SR  ---------------------------------- */
#define DMAC4_SR_DMAEN_Pos                    0                                                       /*!< DMAC4 SR: DMAEN Position                */
#define DMAC4_SR_DMAEN_Msk                    (0x01UL << DMAC4_SR_DMAEN_Pos)                          /*!< DMAC4 SR: DMAEN Mask                    */
#define DMAC4_SR_DMARC_Pos                    4                                                       /*!< DMAC4 SR: DMARC Position                */
#define DMAC4_SR_DMARC_Msk                    (0x01UL << DMAC4_SR_DMARC_Pos)                          /*!< DMAC4 SR: DMARC Mask                    */
#define DMAC4_SR_EOT_Pos                      7                                                       /*!< DMAC4 SR: EOT Position                  */
#define DMAC4_SR_EOT_Msk                      (0x01UL << DMAC4_SR_EOT_Pos)                            /*!< DMAC4 SR: EOT Mask                      */

/* ----------------------------------  DMAC4_PAR  --------------------------------- */
#define DMAC4_PAR_PAR_Pos                     0                                                       /*!< DMAC4 PAR: PAR Position                 */
#define DMAC4_PAR_PAR_Msk                     (0x0000ffffUL << DMAC4_PAR_PAR_Pos)                     /*!< DMAC4 PAR: PAR Mask                     */

/* ----------------------------------  DMAC4_MAR  --------------------------------- */
#define DMAC4_MAR_MAR_Pos                     0                                                       /*!< DMAC4 MAR: MAR Position                 */
#define DMAC4_MAR_MAR_Msk                     (0x0000ffffUL << DMAC4_MAR_MAR_Pos)                     /*!< DMAC4 MAR: MAR Mask                     */
#define DMAC4_MAR_OFFSET_Pos                  29                                                      /*!< DMAC4 MAR: OFFSET Position              */
#define DMAC4_MAR_OFFSET_Msk                  (0x03UL << DMAC4_MAR_OFFSET_Pos)                        /*!< DMAC4 MAR: OFFSET Mask                  */


/* ================================================================================ */
/* ================         struct 'DMAC5' Position & Mask         ================ */
/* ================================================================================ */


/* ----------------------------------  DMAC5_CR  ---------------------------------- */
#define DMAC5_CR_DIR_Pos                      1                                                       /*!< DMAC5 CR: DIR Position                  */
#define DMAC5_CR_DIR_Msk                      (0x01UL << DMAC5_CR_DIR_Pos)                            /*!< DMAC5 CR: DIR Mask                      */
#define DMAC5_CR_SIZE_Pos                     2                                                       /*!< DMAC5 CR: SIZE Position                 */
#define DMAC5_CR_SIZE_Msk                     (0x03UL << DMAC5_CR_SIZE_Pos)                           /*!< DMAC5 CR: SIZE Mask                     */
#define DMAC5_CR_PERISEL_Pos                  8                                                       /*!< DMAC5 CR: PERISEL Position              */
#define DMAC5_CR_PERISEL_Msk                  (0x1fUL << DMAC5_CR_PERISEL_Pos)                        /*!< DMAC5 CR: PERISEL Mask                  */
#define DMAC5_CR_TRANSCNT_Pos                 16                                                      /*!< DMAC5 CR: TRANSCNT Position             */
#define DMAC5_CR_TRANSCNT_Msk                 (0x00000fffUL << DMAC5_CR_TRANSCNT_Pos)                 /*!< DMAC5 CR: TRANSCNT Mask                 */

/* ----------------------------------  DMAC5_SR  ---------------------------------- */
#define DMAC5_SR_DMAEN_Pos                    0                                                       /*!< DMAC5 SR: DMAEN Position                */
#define DMAC5_SR_DMAEN_Msk                    (0x01UL << DMAC5_SR_DMAEN_Pos)                          /*!< DMAC5 SR: DMAEN Mask                    */
#define DMAC5_SR_DMARC_Pos                    4                                                       /*!< DMAC5 SR: DMARC Position                */
#define DMAC5_SR_DMARC_Msk                    (0x01UL << DMAC5_SR_DMARC_Pos)                          /*!< DMAC5 SR: DMARC Mask                    */
#define DMAC5_SR_EOT_Pos                      7                                                       /*!< DMAC5 SR: EOT Position                  */
#define DMAC5_SR_EOT_Msk                      (0x01UL << DMAC5_SR_EOT_Pos)                            /*!< DMAC5 SR: EOT Mask                      */

/* ----------------------------------  DMAC5_PAR  --------------------------------- */
#define DMAC5_PAR_PAR_Pos                     0                                                       /*!< DMAC5 PAR: PAR Position                 */
#define DMAC5_PAR_PAR_Msk                     (0x0000ffffUL << DMAC5_PAR_PAR_Pos)                     /*!< DMAC5 PAR: PAR Mask                     */

/* ----------------------------------  DMAC5_MAR  --------------------------------- */
#define DMAC5_MAR_MAR_Pos                     0                                                       /*!< DMAC5 MAR: MAR Position                 */
#define DMAC5_MAR_MAR_Msk                     (0x0000ffffUL << DMAC5_MAR_MAR_Pos)                     /*!< DMAC5 MAR: MAR Mask                     */
#define DMAC5_MAR_OFFSET_Pos                  29                                                      /*!< DMAC5 MAR: OFFSET Position              */
#define DMAC5_MAR_OFFSET_Msk                  (0x03UL << DMAC5_MAR_OFFSET_Pos)                        /*!< DMAC5 MAR: OFFSET Mask                  */


/* ================================================================================ */
/* ================         struct 'DMAC6' Position & Mask         ================ */
/* ================================================================================ */


/* ----------------------------------  DMAC6_CR  ---------------------------------- */
#define DMAC6_CR_DIR_Pos                      1                                                       /*!< DMAC6 CR: DIR Position                  */
#define DMAC6_CR_DIR_Msk                      (0x01UL << DMAC6_CR_DIR_Pos)                            /*!< DMAC6 CR: DIR Mask                      */
#define DMAC6_CR_SIZE_Pos                     2                                                       /*!< DMAC6 CR: SIZE Position                 */
#define DMAC6_CR_SIZE_Msk                     (0x03UL << DMAC6_CR_SIZE_Pos)                           /*!< DMAC6 CR: SIZE Mask                     */
#define DMAC6_CR_PERISEL_Pos                  8                                                       /*!< DMAC6 CR: PERISEL Position              */
#define DMAC6_CR_PERISEL_Msk                  (0x1fUL << DMAC6_CR_PERISEL_Pos)                        /*!< DMAC6 CR: PERISEL Mask                  */
#define DMAC6_CR_TRANSCNT_Pos                 16                                                      /*!< DMAC6 CR: TRANSCNT Position             */
#define DMAC6_CR_TRANSCNT_Msk                 (0x00000fffUL << DMAC6_CR_TRANSCNT_Pos)                 /*!< DMAC6 CR: TRANSCNT Mask                 */

/* ----------------------------------  DMAC6_SR  ---------------------------------- */
#define DMAC6_SR_DMAEN_Pos                    0                                                       /*!< DMAC6 SR: DMAEN Position                */
#define DMAC6_SR_DMAEN_Msk                    (0x01UL << DMAC6_SR_DMAEN_Pos)                          /*!< DMAC6 SR: DMAEN Mask                    */
#define DMAC6_SR_DMARC_Pos                    4                                                       /*!< DMAC6 SR: DMARC Position                */
#define DMAC6_SR_DMARC_Msk                    (0x01UL << DMAC6_SR_DMARC_Pos)                          /*!< DMAC6 SR: DMARC Mask                    */
#define DMAC6_SR_EOT_Pos                      7                                                       /*!< DMAC6 SR: EOT Position                  */
#define DMAC6_SR_EOT_Msk                      (0x01UL << DMAC6_SR_EOT_Pos)                            /*!< DMAC6 SR: EOT Mask                      */

/* ----------------------------------  DMAC6_PAR  --------------------------------- */
#define DMAC6_PAR_PAR_Pos                     0                                                       /*!< DMAC6 PAR: PAR Position                 */
#define DMAC6_PAR_PAR_Msk                     (0x0000ffffUL << DMAC6_PAR_PAR_Pos)                     /*!< DMAC6 PAR: PAR Mask                     */

/* ----------------------------------  DMAC6_MAR  --------------------------------- */
#define DMAC6_MAR_MAR_Pos                     0                                                       /*!< DMAC6 MAR: MAR Position                 */
#define DMAC6_MAR_MAR_Msk                     (0x0000ffffUL << DMAC6_MAR_MAR_Pos)                     /*!< DMAC6 MAR: MAR Mask                     */
#define DMAC6_MAR_OFFSET_Pos                  29                                                      /*!< DMAC6 MAR: OFFSET Position              */
#define DMAC6_MAR_OFFSET_Msk                  (0x03UL << DMAC6_MAR_OFFSET_Pos)                        /*!< DMAC6 MAR: OFFSET Mask                  */


/* ================================================================================ */
/* ================         struct 'DMAC7' Position & Mask         ================ */
/* ================================================================================ */


/* ----------------------------------  DMAC7_CR  ---------------------------------- */
#define DMAC7_CR_DIR_Pos                      1                                                       /*!< DMAC7 CR: DIR Position                  */
#define DMAC7_CR_DIR_Msk                      (0x01UL << DMAC7_CR_DIR_Pos)                            /*!< DMAC7 CR: DIR Mask                      */
#define DMAC7_CR_SIZE_Pos                     2                                                       /*!< DMAC7 CR: SIZE Position                 */
#define DMAC7_CR_SIZE_Msk                     (0x03UL << DMAC7_CR_SIZE_Pos)                           /*!< DMAC7 CR: SIZE Mask                     */
#define DMAC7_CR_PERISEL_Pos                  8                                                       /*!< DMAC7 CR: PERISEL Position              */
#define DMAC7_CR_PERISEL_Msk                  (0x1fUL << DMAC7_CR_PERISEL_Pos)                        /*!< DMAC7 CR: PERISEL Mask                  */
#define DMAC7_CR_TRANSCNT_Pos                 16                                                      /*!< DMAC7 CR: TRANSCNT Position             */
#define DMAC7_CR_TRANSCNT_Msk                 (0x00000fffUL << DMAC7_CR_TRANSCNT_Pos)                 /*!< DMAC7 CR: TRANSCNT Mask                 */

/* ----------------------------------  DMAC7_SR  ---------------------------------- */
#define DMAC7_SR_DMAEN_Pos                    0                                                       /*!< DMAC7 SR: DMAEN Position                */
#define DMAC7_SR_DMAEN_Msk                    (0x01UL << DMAC7_SR_DMAEN_Pos)                          /*!< DMAC7 SR: DMAEN Mask                    */
#define DMAC7_SR_DMARC_Pos                    4                                                       /*!< DMAC7 SR: DMARC Position                */
#define DMAC7_SR_DMARC_Msk                    (0x01UL << DMAC7_SR_DMARC_Pos)                          /*!< DMAC7 SR: DMARC Mask                    */
#define DMAC7_SR_EOT_Pos                      7                                                       /*!< DMAC7 SR: EOT Position                  */
#define DMAC7_SR_EOT_Msk                      (0x01UL << DMAC7_SR_EOT_Pos)                            /*!< DMAC7 SR: EOT Mask                      */

/* ----------------------------------  DMAC7_PAR  --------------------------------- */
#define DMAC7_PAR_PAR_Pos                     0                                                       /*!< DMAC7 PAR: PAR Position                 */
#define DMAC7_PAR_PAR_Msk                     (0x0000ffffUL << DMAC7_PAR_PAR_Pos)                     /*!< DMAC7 PAR: PAR Mask                     */

/* ----------------------------------  DMAC7_MAR  --------------------------------- */
#define DMAC7_MAR_MAR_Pos                     0                                                       /*!< DMAC7 MAR: MAR Position                 */
#define DMAC7_MAR_MAR_Msk                     (0x0000ffffUL << DMAC7_MAR_MAR_Pos)                     /*!< DMAC7 MAR: MAR Mask                     */
#define DMAC7_MAR_OFFSET_Pos                  29                                                      /*!< DMAC7 MAR: OFFSET Position              */
#define DMAC7_MAR_OFFSET_Msk                  (0x03UL << DMAC7_MAR_OFFSET_Pos)                        /*!< DMAC7 MAR: OFFSET Mask                  */


/* ================================================================================ */
/* ================          struct 'WDT' Position & Mask          ================ */
/* ================================================================================ */


/* -----------------------------------  WDT_CR  ----------------------------------- */
#define WDT_CR_CLKDIV_Pos                     0                                                       /*!< WDT CR: CLKDIV Position                 */
#define WDT_CR_CLKDIV_Msk                     (0x03UL << WDT_CR_CLKDIV_Pos)                           /*!< WDT CR: CLKDIV Mask                     */
#define WDT_CR_UNFIEN_Pos                     2                                                       /*!< WDT CR: UNFIEN Position                 */
#define WDT_CR_UNFIEN_Msk                     (0x01UL << WDT_CR_UNFIEN_Pos)                           /*!< WDT CR: UNFIEN Mask                     */
#define WDT_CR_WINMIEN_Pos                    3                                                       /*!< WDT CR: WINMIEN Position                */
#define WDT_CR_WINMIEN_Msk                    (0x01UL << WDT_CR_WINMIEN_Pos)                          /*!< WDT CR: WINMIEN Mask                    */
#define WDT_CR_CNTEN_Pos                      4                                                       /*!< WDT CR: CNTEN Position                  */
#define WDT_CR_CNTEN_Msk                      (0x3fUL << WDT_CR_CNTEN_Pos)                            /*!< WDT CR: CNTEN Mask                      */
#define WDT_CR_RSTEN_Pos                      10                                                      /*!< WDT CR: RSTEN Position                  */
#define WDT_CR_RSTEN_Msk                      (0x3fUL << WDT_CR_RSTEN_Pos)                            /*!< WDT CR: RSTEN Mask                      */
#define WDT_CR_WTIDKY_Pos                     16                                                      /*!< WDT CR: WTIDKY Position                 */
#define WDT_CR_WTIDKY_Msk                     (0x0000ffffUL << WDT_CR_WTIDKY_Pos)                     /*!< WDT CR: WTIDKY Mask                     */

/* -----------------------------------  WDT_SR  ----------------------------------- */
#define WDT_SR_UNFIFLAG_Pos                   0                                                       /*!< WDT SR: UNFIFLAG Position               */
#define WDT_SR_UNFIFLAG_Msk                   (0x01UL << WDT_SR_UNFIFLAG_Pos)                         /*!< WDT SR: UNFIFLAG Mask                   */
#define WDT_SR_WINMIFLAG_Pos                  1                                                       /*!< WDT SR: WINMIFLAG Position              */
#define WDT_SR_WINMIFLAG_Msk                  (0x01UL << WDT_SR_WINMIFLAG_Pos)                        /*!< WDT SR: WINMIFLAG Mask                  */
#define WDT_SR_DBGCNTEN_Pos                   7                                                       /*!< WDT SR: DBGCNTEN Position               */
#define WDT_SR_DBGCNTEN_Msk                   (0x01UL << WDT_SR_DBGCNTEN_Pos)                         /*!< WDT SR: DBGCNTEN Mask                   */

/* -----------------------------------  WDT_DR  ----------------------------------- */
#define WDT_DR_DATA_Pos                       0                                                       /*!< WDT DR: DATA Position                   */
#define WDT_DR_DATA_Msk                       (0x00ffffffUL << WDT_DR_DATA_Pos)                       /*!< WDT DR: DATA Mask                       */

/* -----------------------------------  WDT_CNT  ---------------------------------- */
#define WDT_CNT_CNT_Pos                       0                                                       /*!< WDT CNT: CNT Position                   */
#define WDT_CNT_CNT_Msk                       (0x00ffffffUL << WDT_CNT_CNT_Pos)                       /*!< WDT CNT: CNT Mask                       */

/* ----------------------------------  WDT_WINDR  --------------------------------- */
#define WDT_WINDR_WDATA_Pos                   0                                                       /*!< WDT WINDR: WDATA Position               */
#define WDT_WINDR_WDATA_Msk                   (0x00ffffffUL << WDT_WINDR_WDATA_Pos)                   /*!< WDT WINDR: WDATA Mask                   */

/* ----------------------------------  WDT_CNTR  ---------------------------------- */
#define WDT_CNTR_CNTR_Pos                     0                                                       /*!< WDT CNTR: CNTR Position                 */
#define WDT_CNTR_CNTR_Msk                     (0x000000ffUL << WDT_CNTR_CNTR_Pos)                     /*!< WDT CNTR: CNTR Mask                     */


/* ================================================================================ */
/* ================           struct 'WT' Position & Mask          ================ */
/* ================================================================================ */


/* ------------------------------------  WT_CR  ----------------------------------- */
#define WT_CR_WTCLR_Pos                       0                                                       /*!< WT CR: WTCLR Position                   */
#define WT_CR_WTCLR_Msk                       (0x01UL << WT_CR_WTCLR_Pos)                             /*!< WT CR: WTCLR Mask                       */
#define WT_CR_WTIFLAG_Pos                     1                                                       /*!< WT CR: WTIFLAG Position                 */
#define WT_CR_WTIFLAG_Msk                     (0x01UL << WT_CR_WTIFLAG_Pos)                           /*!< WT CR: WTIFLAG Mask                     */
#define WT_CR_WTIEN_Pos                       3                                                       /*!< WT CR: WTIEN Position                   */
#define WT_CR_WTIEN_Msk                       (0x01UL << WT_CR_WTIEN_Pos)                             /*!< WT CR: WTIEN Mask                       */
#define WT_CR_WTINTV_Pos                      4                                                       /*!< WT CR: WTINTV Position                  */
#define WT_CR_WTINTV_Msk                      (0x03UL << WT_CR_WTINTV_Pos)                            /*!< WT CR: WTINTV Mask                      */
#define WT_CR_WTEN_Pos                        7                                                       /*!< WT CR: WTEN Position                    */
#define WT_CR_WTEN_Msk                        (0x01UL << WT_CR_WTEN_Pos)                              /*!< WT CR: WTEN Mask                        */

/* ------------------------------------  WT_DR  ----------------------------------- */
#define WT_DR_WTDATA_Pos                      0                                                       /*!< WT DR: WTDATA Position                  */
#define WT_DR_WTDATA_Msk                      (0x00000fffUL << WT_DR_WTDATA_Pos)                      /*!< WT DR: WTDATA Mask                      */

/* -----------------------------------  WT_CNT  ----------------------------------- */
#define WT_CNT_CNT_Pos                        0                                                       /*!< WT CNT: CNT Position                    */
#define WT_CNT_CNT_Msk                        (0x00000fffUL << WT_CNT_CNT_Pos)                        /*!< WT CNT: CNT Mask                        */


/* ================================================================================ */
/* ================         Group 'TIMER1n' Position & Mask        ================ */
/* ================================================================================ */


/* ---------------------------------  TIMER1n_CR  --------------------------------- */
#define TIMER1n_CR_CLR_Pos                    0                                                       /*!< TIMER1n CR: CLR Position                */
#define TIMER1n_CR_CLR_Msk                    (0x01UL << TIMER1n_CR_CLR_Pos)                          /*!< TIMER1n CR: CLR Mask                    */
#define TIMER1n_CR_PAU_Pos                    1                                                       /*!< TIMER1n CR: PAU Position                */
#define TIMER1n_CR_PAU_Msk                    (0x01UL << TIMER1n_CR_PAU_Pos)                          /*!< TIMER1n CR: PAU Mask                    */
#define TIMER1n_CR_CIFLAG_Pos                 2                                                       /*!< TIMER1n CR: CIFLAG Position             */
#define TIMER1n_CR_CIFLAG_Msk                 (0x01UL << TIMER1n_CR_CIFLAG_Pos)                       /*!< TIMER1n CR: CIFLAG Mask                 */
#define TIMER1n_CR_MIFLAG_Pos                 3                                                       /*!< TIMER1n CR: MIFLAG Position             */
#define TIMER1n_CR_MIFLAG_Msk                 (0x01UL << TIMER1n_CR_MIFLAG_Pos)                       /*!< TIMER1n CR: MIFLAG Mask                 */
#define TIMER1n_CR_CIEN_Pos                   4                                                       /*!< TIMER1n CR: CIEN Position               */
#define TIMER1n_CR_CIEN_Msk                   (0x01UL << TIMER1n_CR_CIEN_Pos)                         /*!< TIMER1n CR: CIEN Mask                   */
#define TIMER1n_CR_MIEN_Pos                   5                                                       /*!< TIMER1n CR: MIEN Position               */
#define TIMER1n_CR_MIEN_Msk                   (0x01UL << TIMER1n_CR_MIEN_Pos)                         /*!< TIMER1n CR: MIEN Mask                   */
#define TIMER1n_CR_CPOL_Pos                   6                                                       /*!< TIMER1n CR: CPOL Position               */
#define TIMER1n_CR_CPOL_Msk                   (0x03UL << TIMER1n_CR_CPOL_Pos)                         /*!< TIMER1n CR: CPOL Mask                   */
#define TIMER1n_CR_OPOL_Pos                   8                                                       /*!< TIMER1n CR: OPOL Position               */
#define TIMER1n_CR_OPOL_Msk                   (0x01UL << TIMER1n_CR_OPOL_Pos)                         /*!< TIMER1n CR: OPOL Mask                   */
#define TIMER1n_CR_ECE_Pos                    11                                                      /*!< TIMER1n CR: ECE Position                */
#define TIMER1n_CR_ECE_Msk                    (0x01UL << TIMER1n_CR_ECE_Pos)                          /*!< TIMER1n CR: ECE Mask                    */
#define TIMER1n_CR_MS_Pos                     12                                                      /*!< TIMER1n CR: MS Position                 */
#define TIMER1n_CR_MS_Msk                     (0x03UL << TIMER1n_CR_MS_Pos)                           /*!< TIMER1n CR: MS Mask                     */
#define TIMER1n_CR_CLK_Pos                    14                                                      /*!< TIMER1n CR: CLK Position                */
#define TIMER1n_CR_CLK_Msk                    (0x01UL << TIMER1n_CR_CLK_Pos)                          /*!< TIMER1n CR: CLK Mask                    */
#define TIMER1n_CR_EN_Pos                     15                                                      /*!< TIMER1n CR: EN Position                 */
#define TIMER1n_CR_EN_Msk                     (0x01UL << TIMER1n_CR_EN_Pos)                           /*!< TIMER1n CR: EN Mask                     */
#define TIMER1n_CR_CSYNC_Pos                  30                                                      /*!< TIMER1n CR: CSYNC Position              */
#define TIMER1n_CR_CSYNC_Msk                  (0x01UL << TIMER1n_CR_CSYNC_Pos)                        /*!< TIMER1n CR: CSYNC Mask                  */
#define TIMER1n_CR_SSYNC_Pos                  31                                                      /*!< TIMER1n CR: SSYNC Position              */
#define TIMER1n_CR_SSYNC_Msk                  (0x01UL << TIMER1n_CR_SSYNC_Pos)                        /*!< TIMER1n CR: SSYNC Mask                  */

/* ---------------------------------  TIMER1n_ADR  -------------------------------- */
#define TIMER1n_ADR_ADATA_Pos                 0                                                       /*!< TIMER1n ADR: ADATA Position             */
#define TIMER1n_ADR_ADATA_Msk                 (0x0000ffffUL << TIMER1n_ADR_ADATA_Pos)                 /*!< TIMER1n ADR: ADATA Mask                 */

/* ---------------------------------  TIMER1n_BDR  -------------------------------- */
#define TIMER1n_BDR_BDATA_Pos                 0                                                       /*!< TIMER1n BDR: BDATA Position             */
#define TIMER1n_BDR_BDATA_Msk                 (0x0000ffffUL << TIMER1n_BDR_BDATA_Pos)                 /*!< TIMER1n BDR: BDATA Mask                 */

/* --------------------------------  TIMER1n_CAPDR  ------------------------------- */
#define TIMER1n_CAPDR_CAPD_Pos                0                                                       /*!< TIMER1n CAPDR: CAPD Position            */
#define TIMER1n_CAPDR_CAPD_Msk                (0x0000ffffUL << TIMER1n_CAPDR_CAPD_Pos)                /*!< TIMER1n CAPDR: CAPD Mask                */

/* --------------------------------  TIMER1n_PREDR  ------------------------------- */
#define TIMER1n_PREDR_PRED_Pos                0                                                       /*!< TIMER1n PREDR: PRED Position            */
#define TIMER1n_PREDR_PRED_Msk                (0x00000fffUL << TIMER1n_PREDR_PRED_Pos)                /*!< TIMER1n PREDR: PRED Mask                */

/* ---------------------------------  TIMER1n_CNT  -------------------------------- */
#define TIMER1n_CNT_CNT_Pos                   0                                                       /*!< TIMER1n CNT: CNT Position               */
#define TIMER1n_CNT_CNT_Msk                   (0x0000ffffUL << TIMER1n_CNT_CNT_Pos)                   /*!< TIMER1n CNT: CNT Mask                   */


/* ================================================================================ */
/* ================        struct 'TIMER10' Position & Mask        ================ */
/* ================================================================================ */


/* ---------------------------------  TIMER10_CR  --------------------------------- */
#define TIMER10_CR_CLR_Pos                    0                                                       /*!< TIMER10 CR: CLR Position                */
#define TIMER10_CR_CLR_Msk                    (0x01UL << TIMER10_CR_CLR_Pos)                          /*!< TIMER10 CR: CLR Mask                    */
#define TIMER10_CR_PAU_Pos                    1                                                       /*!< TIMER10 CR: PAU Position                */
#define TIMER10_CR_PAU_Msk                    (0x01UL << TIMER10_CR_PAU_Pos)                          /*!< TIMER10 CR: PAU Mask                    */
#define TIMER10_CR_CIFLAG_Pos                 2                                                       /*!< TIMER10 CR: CIFLAG Position             */
#define TIMER10_CR_CIFLAG_Msk                 (0x01UL << TIMER10_CR_CIFLAG_Pos)                       /*!< TIMER10 CR: CIFLAG Mask                 */
#define TIMER10_CR_MIFLAG_Pos                 3                                                       /*!< TIMER10 CR: MIFLAG Position             */
#define TIMER10_CR_MIFLAG_Msk                 (0x01UL << TIMER10_CR_MIFLAG_Pos)                       /*!< TIMER10 CR: MIFLAG Mask                 */
#define TIMER10_CR_CIEN_Pos                   4                                                       /*!< TIMER10 CR: CIEN Position               */
#define TIMER10_CR_CIEN_Msk                   (0x01UL << TIMER10_CR_CIEN_Pos)                         /*!< TIMER10 CR: CIEN Mask                   */
#define TIMER10_CR_MIEN_Pos                   5                                                       /*!< TIMER10 CR: MIEN Position               */
#define TIMER10_CR_MIEN_Msk                   (0x01UL << TIMER10_CR_MIEN_Pos)                         /*!< TIMER10 CR: MIEN Mask                   */
#define TIMER10_CR_CPOL_Pos                   6                                                       /*!< TIMER10 CR: CPOL Position               */
#define TIMER10_CR_CPOL_Msk                   (0x03UL << TIMER10_CR_CPOL_Pos)                         /*!< TIMER10 CR: CPOL Mask                   */
#define TIMER10_CR_OPOL_Pos                   8                                                       /*!< TIMER10 CR: OPOL Position               */
#define TIMER10_CR_OPOL_Msk                   (0x01UL << TIMER10_CR_OPOL_Pos)                         /*!< TIMER10 CR: OPOL Mask                   */
#define TIMER10_CR_ECE_Pos                    11                                                      /*!< TIMER10 CR: ECE Position                */
#define TIMER10_CR_ECE_Msk                    (0x01UL << TIMER10_CR_ECE_Pos)                          /*!< TIMER10 CR: ECE Mask                    */
#define TIMER10_CR_MS_Pos                     12                                                      /*!< TIMER10 CR: MS Position                 */
#define TIMER10_CR_MS_Msk                     (0x03UL << TIMER10_CR_MS_Pos)                           /*!< TIMER10 CR: MS Mask                     */
#define TIMER10_CR_CLK_Pos                    14                                                      /*!< TIMER10 CR: CLK Position                */
#define TIMER10_CR_CLK_Msk                    (0x01UL << TIMER10_CR_CLK_Pos)                          /*!< TIMER10 CR: CLK Mask                    */
#define TIMER10_CR_EN_Pos                     15                                                      /*!< TIMER10 CR: EN Position                 */
#define TIMER10_CR_EN_Msk                     (0x01UL << TIMER10_CR_EN_Pos)                           /*!< TIMER10 CR: EN Mask                     */
#define TIMER10_CR_CSYNC_Pos                  30                                                      /*!< TIMER10 CR: CSYNC Position              */
#define TIMER10_CR_CSYNC_Msk                  (0x01UL << TIMER10_CR_CSYNC_Pos)                        /*!< TIMER10 CR: CSYNC Mask                  */
#define TIMER10_CR_SSYNC_Pos                  31                                                      /*!< TIMER10 CR: SSYNC Position              */
#define TIMER10_CR_SSYNC_Msk                  (0x01UL << TIMER10_CR_SSYNC_Pos)                        /*!< TIMER10 CR: SSYNC Mask                  */

/* ---------------------------------  TIMER10_ADR  -------------------------------- */
#define TIMER10_ADR_ADATA_Pos                 0                                                       /*!< TIMER10 ADR: ADATA Position             */
#define TIMER10_ADR_ADATA_Msk                 (0x0000ffffUL << TIMER10_ADR_ADATA_Pos)                 /*!< TIMER10 ADR: ADATA Mask                 */

/* ---------------------------------  TIMER10_BDR  -------------------------------- */
#define TIMER10_BDR_BDATA_Pos                 0                                                       /*!< TIMER10 BDR: BDATA Position             */
#define TIMER10_BDR_BDATA_Msk                 (0x0000ffffUL << TIMER10_BDR_BDATA_Pos)                 /*!< TIMER10 BDR: BDATA Mask                 */

/* --------------------------------  TIMER10_CAPDR  ------------------------------- */
#define TIMER10_CAPDR_CAPD_Pos                0                                                       /*!< TIMER10 CAPDR: CAPD Position            */
#define TIMER10_CAPDR_CAPD_Msk                (0x0000ffffUL << TIMER10_CAPDR_CAPD_Pos)                /*!< TIMER10 CAPDR: CAPD Mask                */

/* --------------------------------  TIMER10_PREDR  ------------------------------- */
#define TIMER10_PREDR_PRED_Pos                0                                                       /*!< TIMER10 PREDR: PRED Position            */
#define TIMER10_PREDR_PRED_Msk                (0x00000fffUL << TIMER10_PREDR_PRED_Pos)                /*!< TIMER10 PREDR: PRED Mask                */

/* ---------------------------------  TIMER10_CNT  -------------------------------- */
#define TIMER10_CNT_CNT_Pos                   0                                                       /*!< TIMER10 CNT: CNT Position               */
#define TIMER10_CNT_CNT_Msk                   (0x0000ffffUL << TIMER10_CNT_CNT_Pos)                   /*!< TIMER10 CNT: CNT Mask                   */


/* ================================================================================ */
/* ================        struct 'TIMER11' Position & Mask        ================ */
/* ================================================================================ */


/* ---------------------------------  TIMER11_CR  --------------------------------- */
#define TIMER11_CR_CLR_Pos                    0                                                       /*!< TIMER11 CR: CLR Position                */
#define TIMER11_CR_CLR_Msk                    (0x01UL << TIMER11_CR_CLR_Pos)                          /*!< TIMER11 CR: CLR Mask                    */
#define TIMER11_CR_PAU_Pos                    1                                                       /*!< TIMER11 CR: PAU Position                */
#define TIMER11_CR_PAU_Msk                    (0x01UL << TIMER11_CR_PAU_Pos)                          /*!< TIMER11 CR: PAU Mask                    */
#define TIMER11_CR_CIFLAG_Pos                 2                                                       /*!< TIMER11 CR: CIFLAG Position             */
#define TIMER11_CR_CIFLAG_Msk                 (0x01UL << TIMER11_CR_CIFLAG_Pos)                       /*!< TIMER11 CR: CIFLAG Mask                 */
#define TIMER11_CR_MIFLAG_Pos                 3                                                       /*!< TIMER11 CR: MIFLAG Position             */
#define TIMER11_CR_MIFLAG_Msk                 (0x01UL << TIMER11_CR_MIFLAG_Pos)                       /*!< TIMER11 CR: MIFLAG Mask                 */
#define TIMER11_CR_CIEN_Pos                   4                                                       /*!< TIMER11 CR: CIEN Position               */
#define TIMER11_CR_CIEN_Msk                   (0x01UL << TIMER11_CR_CIEN_Pos)                         /*!< TIMER11 CR: CIEN Mask                   */
#define TIMER11_CR_MIEN_Pos                   5                                                       /*!< TIMER11 CR: MIEN Position               */
#define TIMER11_CR_MIEN_Msk                   (0x01UL << TIMER11_CR_MIEN_Pos)                         /*!< TIMER11 CR: MIEN Mask                   */
#define TIMER11_CR_CPOL_Pos                   6                                                       /*!< TIMER11 CR: CPOL Position               */
#define TIMER11_CR_CPOL_Msk                   (0x03UL << TIMER11_CR_CPOL_Pos)                         /*!< TIMER11 CR: CPOL Mask                   */
#define TIMER11_CR_OPOL_Pos                   8                                                       /*!< TIMER11 CR: OPOL Position               */
#define TIMER11_CR_OPOL_Msk                   (0x01UL << TIMER11_CR_OPOL_Pos)                         /*!< TIMER11 CR: OPOL Mask                   */
#define TIMER11_CR_ECE_Pos                    11                                                      /*!< TIMER11 CR: ECE Position                */
#define TIMER11_CR_ECE_Msk                    (0x01UL << TIMER11_CR_ECE_Pos)                          /*!< TIMER11 CR: ECE Mask                    */
#define TIMER11_CR_MS_Pos                     12                                                      /*!< TIMER11 CR: MS Position                 */
#define TIMER11_CR_MS_Msk                     (0x03UL << TIMER11_CR_MS_Pos)                           /*!< TIMER11 CR: MS Mask                     */
#define TIMER11_CR_CLK_Pos                    14                                                      /*!< TIMER11 CR: CLK Position                */
#define TIMER11_CR_CLK_Msk                    (0x01UL << TIMER11_CR_CLK_Pos)                          /*!< TIMER11 CR: CLK Mask                    */
#define TIMER11_CR_EN_Pos                     15                                                      /*!< TIMER11 CR: EN Position                 */
#define TIMER11_CR_EN_Msk                     (0x01UL << TIMER11_CR_EN_Pos)                           /*!< TIMER11 CR: EN Mask                     */
#define TIMER11_CR_CSYNC_Pos                  30                                                      /*!< TIMER11 CR: CSYNC Position              */
#define TIMER11_CR_CSYNC_Msk                  (0x01UL << TIMER11_CR_CSYNC_Pos)                        /*!< TIMER11 CR: CSYNC Mask                  */
#define TIMER11_CR_SSYNC_Pos                  31                                                      /*!< TIMER11 CR: SSYNC Position              */
#define TIMER11_CR_SSYNC_Msk                  (0x01UL << TIMER11_CR_SSYNC_Pos)                        /*!< TIMER11 CR: SSYNC Mask                  */

/* ---------------------------------  TIMER11_ADR  -------------------------------- */
#define TIMER11_ADR_ADATA_Pos                 0                                                       /*!< TIMER11 ADR: ADATA Position             */
#define TIMER11_ADR_ADATA_Msk                 (0x0000ffffUL << TIMER11_ADR_ADATA_Pos)                 /*!< TIMER11 ADR: ADATA Mask                 */

/* ---------------------------------  TIMER11_BDR  -------------------------------- */
#define TIMER11_BDR_BDATA_Pos                 0                                                       /*!< TIMER11 BDR: BDATA Position             */
#define TIMER11_BDR_BDATA_Msk                 (0x0000ffffUL << TIMER11_BDR_BDATA_Pos)                 /*!< TIMER11 BDR: BDATA Mask                 */

/* --------------------------------  TIMER11_CAPDR  ------------------------------- */
#define TIMER11_CAPDR_CAPD_Pos                0                                                       /*!< TIMER11 CAPDR: CAPD Position            */
#define TIMER11_CAPDR_CAPD_Msk                (0x0000ffffUL << TIMER11_CAPDR_CAPD_Pos)                /*!< TIMER11 CAPDR: CAPD Mask                */

/* --------------------------------  TIMER11_PREDR  ------------------------------- */
#define TIMER11_PREDR_PRED_Pos                0                                                       /*!< TIMER11 PREDR: PRED Position            */
#define TIMER11_PREDR_PRED_Msk                (0x00000fffUL << TIMER11_PREDR_PRED_Pos)                /*!< TIMER11 PREDR: PRED Mask                */

/* ---------------------------------  TIMER11_CNT  -------------------------------- */
#define TIMER11_CNT_CNT_Pos                   0                                                       /*!< TIMER11 CNT: CNT Position               */
#define TIMER11_CNT_CNT_Msk                   (0x0000ffffUL << TIMER11_CNT_CNT_Pos)                   /*!< TIMER11 CNT: CNT Mask                   */


/* ================================================================================ */
/* ================        struct 'TIMER12' Position & Mask        ================ */
/* ================================================================================ */


/* ---------------------------------  TIMER12_CR  --------------------------------- */
#define TIMER12_CR_CLR_Pos                    0                                                       /*!< TIMER12 CR: CLR Position                */
#define TIMER12_CR_CLR_Msk                    (0x01UL << TIMER12_CR_CLR_Pos)                          /*!< TIMER12 CR: CLR Mask                    */
#define TIMER12_CR_PAU_Pos                    1                                                       /*!< TIMER12 CR: PAU Position                */
#define TIMER12_CR_PAU_Msk                    (0x01UL << TIMER12_CR_PAU_Pos)                          /*!< TIMER12 CR: PAU Mask                    */
#define TIMER12_CR_CIFLAG_Pos                 2                                                       /*!< TIMER12 CR: CIFLAG Position             */
#define TIMER12_CR_CIFLAG_Msk                 (0x01UL << TIMER12_CR_CIFLAG_Pos)                       /*!< TIMER12 CR: CIFLAG Mask                 */
#define TIMER12_CR_MIFLAG_Pos                 3                                                       /*!< TIMER12 CR: MIFLAG Position             */
#define TIMER12_CR_MIFLAG_Msk                 (0x01UL << TIMER12_CR_MIFLAG_Pos)                       /*!< TIMER12 CR: MIFLAG Mask                 */
#define TIMER12_CR_CIEN_Pos                   4                                                       /*!< TIMER12 CR: CIEN Position               */
#define TIMER12_CR_CIEN_Msk                   (0x01UL << TIMER12_CR_CIEN_Pos)                         /*!< TIMER12 CR: CIEN Mask                   */
#define TIMER12_CR_MIEN_Pos                   5                                                       /*!< TIMER12 CR: MIEN Position               */
#define TIMER12_CR_MIEN_Msk                   (0x01UL << TIMER12_CR_MIEN_Pos)                         /*!< TIMER12 CR: MIEN Mask                   */
#define TIMER12_CR_CPOL_Pos                   6                                                       /*!< TIMER12 CR: CPOL Position               */
#define TIMER12_CR_CPOL_Msk                   (0x03UL << TIMER12_CR_CPOL_Pos)                         /*!< TIMER12 CR: CPOL Mask                   */
#define TIMER12_CR_OPOL_Pos                   8                                                       /*!< TIMER12 CR: OPOL Position               */
#define TIMER12_CR_OPOL_Msk                   (0x01UL << TIMER12_CR_OPOL_Pos)                         /*!< TIMER12 CR: OPOL Mask                   */
#define TIMER12_CR_ECE_Pos                    11                                                      /*!< TIMER12 CR: ECE Position                */
#define TIMER12_CR_ECE_Msk                    (0x01UL << TIMER12_CR_ECE_Pos)                          /*!< TIMER12 CR: ECE Mask                    */
#define TIMER12_CR_MS_Pos                     12                                                      /*!< TIMER12 CR: MS Position                 */
#define TIMER12_CR_MS_Msk                     (0x03UL << TIMER12_CR_MS_Pos)                           /*!< TIMER12 CR: MS Mask                     */
#define TIMER12_CR_CLK_Pos                    14                                                      /*!< TIMER12 CR: CLK Position                */
#define TIMER12_CR_CLK_Msk                    (0x01UL << TIMER12_CR_CLK_Pos)                          /*!< TIMER12 CR: CLK Mask                    */
#define TIMER12_CR_EN_Pos                     15                                                      /*!< TIMER12 CR: EN Position                 */
#define TIMER12_CR_EN_Msk                     (0x01UL << TIMER12_CR_EN_Pos)                           /*!< TIMER12 CR: EN Mask                     */
#define TIMER12_CR_CSYNC_Pos                  30                                                      /*!< TIMER12 CR: CSYNC Position              */
#define TIMER12_CR_CSYNC_Msk                  (0x01UL << TIMER12_CR_CSYNC_Pos)                        /*!< TIMER12 CR: CSYNC Mask                  */
#define TIMER12_CR_SSYNC_Pos                  31                                                      /*!< TIMER12 CR: SSYNC Position              */
#define TIMER12_CR_SSYNC_Msk                  (0x01UL << TIMER12_CR_SSYNC_Pos)                        /*!< TIMER12 CR: SSYNC Mask                  */

/* ---------------------------------  TIMER12_ADR  -------------------------------- */
#define TIMER12_ADR_ADATA_Pos                 0                                                       /*!< TIMER12 ADR: ADATA Position             */
#define TIMER12_ADR_ADATA_Msk                 (0x0000ffffUL << TIMER12_ADR_ADATA_Pos)                 /*!< TIMER12 ADR: ADATA Mask                 */

/* ---------------------------------  TIMER12_BDR  -------------------------------- */
#define TIMER12_BDR_BDATA_Pos                 0                                                       /*!< TIMER12 BDR: BDATA Position             */
#define TIMER12_BDR_BDATA_Msk                 (0x0000ffffUL << TIMER12_BDR_BDATA_Pos)                 /*!< TIMER12 BDR: BDATA Mask                 */

/* --------------------------------  TIMER12_CAPDR  ------------------------------- */
#define TIMER12_CAPDR_CAPD_Pos                0                                                       /*!< TIMER12 CAPDR: CAPD Position            */
#define TIMER12_CAPDR_CAPD_Msk                (0x0000ffffUL << TIMER12_CAPDR_CAPD_Pos)                /*!< TIMER12 CAPDR: CAPD Mask                */

/* --------------------------------  TIMER12_PREDR  ------------------------------- */
#define TIMER12_PREDR_PRED_Pos                0                                                       /*!< TIMER12 PREDR: PRED Position            */
#define TIMER12_PREDR_PRED_Msk                (0x00000fffUL << TIMER12_PREDR_PRED_Pos)                /*!< TIMER12 PREDR: PRED Mask                */

/* ---------------------------------  TIMER12_CNT  -------------------------------- */
#define TIMER12_CNT_CNT_Pos                   0                                                       /*!< TIMER12 CNT: CNT Position               */
#define TIMER12_CNT_CNT_Msk                   (0x0000ffffUL << TIMER12_CNT_CNT_Pos)                   /*!< TIMER12 CNT: CNT Mask                   */


/* ================================================================================ */
/* ================        struct 'TIMER13' Position & Mask        ================ */
/* ================================================================================ */


/* ---------------------------------  TIMER13_CR  --------------------------------- */
#define TIMER13_CR_CLR_Pos                    0                                                       /*!< TIMER13 CR: CLR Position                */
#define TIMER13_CR_CLR_Msk                    (0x01UL << TIMER13_CR_CLR_Pos)                          /*!< TIMER13 CR: CLR Mask                    */
#define TIMER13_CR_PAU_Pos                    1                                                       /*!< TIMER13 CR: PAU Position                */
#define TIMER13_CR_PAU_Msk                    (0x01UL << TIMER13_CR_PAU_Pos)                          /*!< TIMER13 CR: PAU Mask                    */
#define TIMER13_CR_CIFLAG_Pos                 2                                                       /*!< TIMER13 CR: CIFLAG Position             */
#define TIMER13_CR_CIFLAG_Msk                 (0x01UL << TIMER13_CR_CIFLAG_Pos)                       /*!< TIMER13 CR: CIFLAG Mask                 */
#define TIMER13_CR_MIFLAG_Pos                 3                                                       /*!< TIMER13 CR: MIFLAG Position             */
#define TIMER13_CR_MIFLAG_Msk                 (0x01UL << TIMER13_CR_MIFLAG_Pos)                       /*!< TIMER13 CR: MIFLAG Mask                 */
#define TIMER13_CR_CIEN_Pos                   4                                                       /*!< TIMER13 CR: CIEN Position               */
#define TIMER13_CR_CIEN_Msk                   (0x01UL << TIMER13_CR_CIEN_Pos)                         /*!< TIMER13 CR: CIEN Mask                   */
#define TIMER13_CR_MIEN_Pos                   5                                                       /*!< TIMER13 CR: MIEN Position               */
#define TIMER13_CR_MIEN_Msk                   (0x01UL << TIMER13_CR_MIEN_Pos)                         /*!< TIMER13 CR: MIEN Mask                   */
#define TIMER13_CR_CPOL_Pos                   6                                                       /*!< TIMER13 CR: CPOL Position               */
#define TIMER13_CR_CPOL_Msk                   (0x03UL << TIMER13_CR_CPOL_Pos)                         /*!< TIMER13 CR: CPOL Mask                   */
#define TIMER13_CR_OPOL_Pos                   8                                                       /*!< TIMER13 CR: OPOL Position               */
#define TIMER13_CR_OPOL_Msk                   (0x01UL << TIMER13_CR_OPOL_Pos)                         /*!< TIMER13 CR: OPOL Mask                   */
#define TIMER13_CR_ECE_Pos                    11                                                      /*!< TIMER13 CR: ECE Position                */
#define TIMER13_CR_ECE_Msk                    (0x01UL << TIMER13_CR_ECE_Pos)                          /*!< TIMER13 CR: ECE Mask                    */
#define TIMER13_CR_MS_Pos                     12                                                      /*!< TIMER13 CR: MS Position                 */
#define TIMER13_CR_MS_Msk                     (0x03UL << TIMER13_CR_MS_Pos)                           /*!< TIMER13 CR: MS Mask                     */
#define TIMER13_CR_CLK_Pos                    14                                                      /*!< TIMER13 CR: CLK Position                */
#define TIMER13_CR_CLK_Msk                    (0x01UL << TIMER13_CR_CLK_Pos)                          /*!< TIMER13 CR: CLK Mask                    */
#define TIMER13_CR_EN_Pos                     15                                                      /*!< TIMER13 CR: EN Position                 */
#define TIMER13_CR_EN_Msk                     (0x01UL << TIMER13_CR_EN_Pos)                           /*!< TIMER13 CR: EN Mask                     */
#define TIMER13_CR_CSYNC_Pos                  30                                                      /*!< TIMER13 CR: CSYNC Position              */
#define TIMER13_CR_CSYNC_Msk                  (0x01UL << TIMER13_CR_CSYNC_Pos)                        /*!< TIMER13 CR: CSYNC Mask                  */
#define TIMER13_CR_SSYNC_Pos                  31                                                      /*!< TIMER13 CR: SSYNC Position              */
#define TIMER13_CR_SSYNC_Msk                  (0x01UL << TIMER13_CR_SSYNC_Pos)                        /*!< TIMER13 CR: SSYNC Mask                  */

/* ---------------------------------  TIMER13_ADR  -------------------------------- */
#define TIMER13_ADR_ADATA_Pos                 0                                                       /*!< TIMER13 ADR: ADATA Position             */
#define TIMER13_ADR_ADATA_Msk                 (0x0000ffffUL << TIMER13_ADR_ADATA_Pos)                 /*!< TIMER13 ADR: ADATA Mask                 */

/* ---------------------------------  TIMER13_BDR  -------------------------------- */
#define TIMER13_BDR_BDATA_Pos                 0                                                       /*!< TIMER13 BDR: BDATA Position             */
#define TIMER13_BDR_BDATA_Msk                 (0x0000ffffUL << TIMER13_BDR_BDATA_Pos)                 /*!< TIMER13 BDR: BDATA Mask                 */

/* --------------------------------  TIMER13_CAPDR  ------------------------------- */
#define TIMER13_CAPDR_CAPD_Pos                0                                                       /*!< TIMER13 CAPDR: CAPD Position            */
#define TIMER13_CAPDR_CAPD_Msk                (0x0000ffffUL << TIMER13_CAPDR_CAPD_Pos)                /*!< TIMER13 CAPDR: CAPD Mask                */

/* --------------------------------  TIMER13_PREDR  ------------------------------- */
#define TIMER13_PREDR_PRED_Pos                0                                                       /*!< TIMER13 PREDR: PRED Position            */
#define TIMER13_PREDR_PRED_Msk                (0x00000fffUL << TIMER13_PREDR_PRED_Pos)                /*!< TIMER13 PREDR: PRED Mask                */

/* ---------------------------------  TIMER13_CNT  -------------------------------- */
#define TIMER13_CNT_CNT_Pos                   0                                                       /*!< TIMER13 CNT: CNT Position               */
#define TIMER13_CNT_CNT_Msk                   (0x0000ffffUL << TIMER13_CNT_CNT_Pos)                   /*!< TIMER13 CNT: CNT Mask                   */


/* ================================================================================ */
/* ================        struct 'TIMER14' Position & Mask        ================ */
/* ================================================================================ */


/* ---------------------------------  TIMER14_CR  --------------------------------- */
#define TIMER14_CR_CLR_Pos                    0                                                       /*!< TIMER14 CR: CLR Position                */
#define TIMER14_CR_CLR_Msk                    (0x01UL << TIMER14_CR_CLR_Pos)                          /*!< TIMER14 CR: CLR Mask                    */
#define TIMER14_CR_PAU_Pos                    1                                                       /*!< TIMER14 CR: PAU Position                */
#define TIMER14_CR_PAU_Msk                    (0x01UL << TIMER14_CR_PAU_Pos)                          /*!< TIMER14 CR: PAU Mask                    */
#define TIMER14_CR_CIFLAG_Pos                 2                                                       /*!< TIMER14 CR: CIFLAG Position             */
#define TIMER14_CR_CIFLAG_Msk                 (0x01UL << TIMER14_CR_CIFLAG_Pos)                       /*!< TIMER14 CR: CIFLAG Mask                 */
#define TIMER14_CR_MIFLAG_Pos                 3                                                       /*!< TIMER14 CR: MIFLAG Position             */
#define TIMER14_CR_MIFLAG_Msk                 (0x01UL << TIMER14_CR_MIFLAG_Pos)                       /*!< TIMER14 CR: MIFLAG Mask                 */
#define TIMER14_CR_CIEN_Pos                   4                                                       /*!< TIMER14 CR: CIEN Position               */
#define TIMER14_CR_CIEN_Msk                   (0x01UL << TIMER14_CR_CIEN_Pos)                         /*!< TIMER14 CR: CIEN Mask                   */
#define TIMER14_CR_MIEN_Pos                   5                                                       /*!< TIMER14 CR: MIEN Position               */
#define TIMER14_CR_MIEN_Msk                   (0x01UL << TIMER14_CR_MIEN_Pos)                         /*!< TIMER14 CR: MIEN Mask                   */
#define TIMER14_CR_CPOL_Pos                   6                                                       /*!< TIMER14 CR: CPOL Position               */
#define TIMER14_CR_CPOL_Msk                   (0x03UL << TIMER14_CR_CPOL_Pos)                         /*!< TIMER14 CR: CPOL Mask                   */
#define TIMER14_CR_OPOL_Pos                   8                                                       /*!< TIMER14 CR: OPOL Position               */
#define TIMER14_CR_OPOL_Msk                   (0x01UL << TIMER14_CR_OPOL_Pos)                         /*!< TIMER14 CR: OPOL Mask                   */
#define TIMER14_CR_ECE_Pos                    11                                                      /*!< TIMER14 CR: ECE Position                */
#define TIMER14_CR_ECE_Msk                    (0x01UL << TIMER14_CR_ECE_Pos)                          /*!< TIMER14 CR: ECE Mask                    */
#define TIMER14_CR_MS_Pos                     12                                                      /*!< TIMER14 CR: MS Position                 */
#define TIMER14_CR_MS_Msk                     (0x03UL << TIMER14_CR_MS_Pos)                           /*!< TIMER14 CR: MS Mask                     */
#define TIMER14_CR_CLK_Pos                    14                                                      /*!< TIMER14 CR: CLK Position                */
#define TIMER14_CR_CLK_Msk                    (0x01UL << TIMER14_CR_CLK_Pos)                          /*!< TIMER14 CR: CLK Mask                    */
#define TIMER14_CR_EN_Pos                     15                                                      /*!< TIMER14 CR: EN Position                 */
#define TIMER14_CR_EN_Msk                     (0x01UL << TIMER14_CR_EN_Pos)                           /*!< TIMER14 CR: EN Mask                     */
#define TIMER14_CR_CSYNC_Pos                  30                                                      /*!< TIMER14 CR: CSYNC Position              */
#define TIMER14_CR_CSYNC_Msk                  (0x01UL << TIMER14_CR_CSYNC_Pos)                        /*!< TIMER14 CR: CSYNC Mask                  */
#define TIMER14_CR_SSYNC_Pos                  31                                                      /*!< TIMER14 CR: SSYNC Position              */
#define TIMER14_CR_SSYNC_Msk                  (0x01UL << TIMER14_CR_SSYNC_Pos)                        /*!< TIMER14 CR: SSYNC Mask                  */

/* ---------------------------------  TIMER14_ADR  -------------------------------- */
#define TIMER14_ADR_ADATA_Pos                 0                                                       /*!< TIMER14 ADR: ADATA Position             */
#define TIMER14_ADR_ADATA_Msk                 (0x0000ffffUL << TIMER14_ADR_ADATA_Pos)                 /*!< TIMER14 ADR: ADATA Mask                 */

/* ---------------------------------  TIMER14_BDR  -------------------------------- */
#define TIMER14_BDR_BDATA_Pos                 0                                                       /*!< TIMER14 BDR: BDATA Position             */
#define TIMER14_BDR_BDATA_Msk                 (0x0000ffffUL << TIMER14_BDR_BDATA_Pos)                 /*!< TIMER14 BDR: BDATA Mask                 */

/* --------------------------------  TIMER14_CAPDR  ------------------------------- */
#define TIMER14_CAPDR_CAPD_Pos                0                                                       /*!< TIMER14 CAPDR: CAPD Position            */
#define TIMER14_CAPDR_CAPD_Msk                (0x0000ffffUL << TIMER14_CAPDR_CAPD_Pos)                /*!< TIMER14 CAPDR: CAPD Mask                */

/* --------------------------------  TIMER14_PREDR  ------------------------------- */
#define TIMER14_PREDR_PRED_Pos                0                                                       /*!< TIMER14 PREDR: PRED Position            */
#define TIMER14_PREDR_PRED_Msk                (0x00000fffUL << TIMER14_PREDR_PRED_Pos)                /*!< TIMER14 PREDR: PRED Mask                */

/* ---------------------------------  TIMER14_CNT  -------------------------------- */
#define TIMER14_CNT_CNT_Pos                   0                                                       /*!< TIMER14 CNT: CNT Position               */
#define TIMER14_CNT_CNT_Msk                   (0x0000ffffUL << TIMER14_CNT_CNT_Pos)                   /*!< TIMER14 CNT: CNT Mask                   */


/* ================================================================================ */
/* ================        struct 'TIMER15' Position & Mask        ================ */
/* ================================================================================ */


/* ---------------------------------  TIMER15_CR  --------------------------------- */
#define TIMER15_CR_CLR_Pos                    0                                                       /*!< TIMER15 CR: CLR Position                */
#define TIMER15_CR_CLR_Msk                    (0x01UL << TIMER15_CR_CLR_Pos)                          /*!< TIMER15 CR: CLR Mask                    */
#define TIMER15_CR_PAU_Pos                    1                                                       /*!< TIMER15 CR: PAU Position                */
#define TIMER15_CR_PAU_Msk                    (0x01UL << TIMER15_CR_PAU_Pos)                          /*!< TIMER15 CR: PAU Mask                    */
#define TIMER15_CR_CIFLAG_Pos                 2                                                       /*!< TIMER15 CR: CIFLAG Position             */
#define TIMER15_CR_CIFLAG_Msk                 (0x01UL << TIMER15_CR_CIFLAG_Pos)                       /*!< TIMER15 CR: CIFLAG Mask                 */
#define TIMER15_CR_MIFLAG_Pos                 3                                                       /*!< TIMER15 CR: MIFLAG Position             */
#define TIMER15_CR_MIFLAG_Msk                 (0x01UL << TIMER15_CR_MIFLAG_Pos)                       /*!< TIMER15 CR: MIFLAG Mask                 */
#define TIMER15_CR_CIEN_Pos                   4                                                       /*!< TIMER15 CR: CIEN Position               */
#define TIMER15_CR_CIEN_Msk                   (0x01UL << TIMER15_CR_CIEN_Pos)                         /*!< TIMER15 CR: CIEN Mask                   */
#define TIMER15_CR_MIEN_Pos                   5                                                       /*!< TIMER15 CR: MIEN Position               */
#define TIMER15_CR_MIEN_Msk                   (0x01UL << TIMER15_CR_MIEN_Pos)                         /*!< TIMER15 CR: MIEN Mask                   */
#define TIMER15_CR_CPOL_Pos                   6                                                       /*!< TIMER15 CR: CPOL Position               */
#define TIMER15_CR_CPOL_Msk                   (0x03UL << TIMER15_CR_CPOL_Pos)                         /*!< TIMER15 CR: CPOL Mask                   */
#define TIMER15_CR_OPOL_Pos                   8                                                       /*!< TIMER15 CR: OPOL Position               */
#define TIMER15_CR_OPOL_Msk                   (0x01UL << TIMER15_CR_OPOL_Pos)                         /*!< TIMER15 CR: OPOL Mask                   */
#define TIMER15_CR_ECE_Pos                    11                                                      /*!< TIMER15 CR: ECE Position                */
#define TIMER15_CR_ECE_Msk                    (0x01UL << TIMER15_CR_ECE_Pos)                          /*!< TIMER15 CR: ECE Mask                    */
#define TIMER15_CR_MS_Pos                     12                                                      /*!< TIMER15 CR: MS Position                 */
#define TIMER15_CR_MS_Msk                     (0x03UL << TIMER15_CR_MS_Pos)                           /*!< TIMER15 CR: MS Mask                     */
#define TIMER15_CR_CLK_Pos                    14                                                      /*!< TIMER15 CR: CLK Position                */
#define TIMER15_CR_CLK_Msk                    (0x01UL << TIMER15_CR_CLK_Pos)                          /*!< TIMER15 CR: CLK Mask                    */
#define TIMER15_CR_EN_Pos                     15                                                      /*!< TIMER15 CR: EN Position                 */
#define TIMER15_CR_EN_Msk                     (0x01UL << TIMER15_CR_EN_Pos)                           /*!< TIMER15 CR: EN Mask                     */
#define TIMER15_CR_CSYNC_Pos                  30                                                      /*!< TIMER15 CR: CSYNC Position              */
#define TIMER15_CR_CSYNC_Msk                  (0x01UL << TIMER15_CR_CSYNC_Pos)                        /*!< TIMER15 CR: CSYNC Mask                  */
#define TIMER15_CR_SSYNC_Pos                  31                                                      /*!< TIMER15 CR: SSYNC Position              */
#define TIMER15_CR_SSYNC_Msk                  (0x01UL << TIMER15_CR_SSYNC_Pos)                        /*!< TIMER15 CR: SSYNC Mask                  */

/* ---------------------------------  TIMER15_ADR  -------------------------------- */
#define TIMER15_ADR_ADATA_Pos                 0                                                       /*!< TIMER15 ADR: ADATA Position             */
#define TIMER15_ADR_ADATA_Msk                 (0x0000ffffUL << TIMER15_ADR_ADATA_Pos)                 /*!< TIMER15 ADR: ADATA Mask                 */

/* ---------------------------------  TIMER15_BDR  -------------------------------- */
#define TIMER15_BDR_BDATA_Pos                 0                                                       /*!< TIMER15 BDR: BDATA Position             */
#define TIMER15_BDR_BDATA_Msk                 (0x0000ffffUL << TIMER15_BDR_BDATA_Pos)                 /*!< TIMER15 BDR: BDATA Mask                 */

/* --------------------------------  TIMER15_CAPDR  ------------------------------- */
#define TIMER15_CAPDR_CAPD_Pos                0                                                       /*!< TIMER15 CAPDR: CAPD Position            */
#define TIMER15_CAPDR_CAPD_Msk                (0x0000ffffUL << TIMER15_CAPDR_CAPD_Pos)                /*!< TIMER15 CAPDR: CAPD Mask                */

/* --------------------------------  TIMER15_PREDR  ------------------------------- */
#define TIMER15_PREDR_PRED_Pos                0                                                       /*!< TIMER15 PREDR: PRED Position            */
#define TIMER15_PREDR_PRED_Msk                (0x00000fffUL << TIMER15_PREDR_PRED_Pos)                /*!< TIMER15 PREDR: PRED Mask                */

/* ---------------------------------  TIMER15_CNT  -------------------------------- */
#define TIMER15_CNT_CNT_Pos                   0                                                       /*!< TIMER15 CNT: CNT Position               */
#define TIMER15_CNT_CNT_Msk                   (0x0000ffffUL << TIMER15_CNT_CNT_Pos)                   /*!< TIMER15 CNT: CNT Mask                   */


/* ================================================================================ */
/* ================        struct 'TIMER16' Position & Mask        ================ */
/* ================================================================================ */


/* ---------------------------------  TIMER16_CR  --------------------------------- */
#define TIMER16_CR_CLR_Pos                    0                                                       /*!< TIMER16 CR: CLR Position                */
#define TIMER16_CR_CLR_Msk                    (0x01UL << TIMER16_CR_CLR_Pos)                          /*!< TIMER16 CR: CLR Mask                    */
#define TIMER16_CR_PAU_Pos                    1                                                       /*!< TIMER16 CR: PAU Position                */
#define TIMER16_CR_PAU_Msk                    (0x01UL << TIMER16_CR_PAU_Pos)                          /*!< TIMER16 CR: PAU Mask                    */
#define TIMER16_CR_CIFLAG_Pos                 2                                                       /*!< TIMER16 CR: CIFLAG Position             */
#define TIMER16_CR_CIFLAG_Msk                 (0x01UL << TIMER16_CR_CIFLAG_Pos)                       /*!< TIMER16 CR: CIFLAG Mask                 */
#define TIMER16_CR_MIFLAG_Pos                 3                                                       /*!< TIMER16 CR: MIFLAG Position             */
#define TIMER16_CR_MIFLAG_Msk                 (0x01UL << TIMER16_CR_MIFLAG_Pos)                       /*!< TIMER16 CR: MIFLAG Mask                 */
#define TIMER16_CR_CIEN_Pos                   4                                                       /*!< TIMER16 CR: CIEN Position               */
#define TIMER16_CR_CIEN_Msk                   (0x01UL << TIMER16_CR_CIEN_Pos)                         /*!< TIMER16 CR: CIEN Mask                   */
#define TIMER16_CR_MIEN_Pos                   5                                                       /*!< TIMER16 CR: MIEN Position               */
#define TIMER16_CR_MIEN_Msk                   (0x01UL << TIMER16_CR_MIEN_Pos)                         /*!< TIMER16 CR: MIEN Mask                   */
#define TIMER16_CR_CPOL_Pos                   6                                                       /*!< TIMER16 CR: CPOL Position               */
#define TIMER16_CR_CPOL_Msk                   (0x03UL << TIMER16_CR_CPOL_Pos)                         /*!< TIMER16 CR: CPOL Mask                   */
#define TIMER16_CR_OPOL_Pos                   8                                                       /*!< TIMER16 CR: OPOL Position               */
#define TIMER16_CR_OPOL_Msk                   (0x01UL << TIMER16_CR_OPOL_Pos)                         /*!< TIMER16 CR: OPOL Mask                   */
#define TIMER16_CR_ECE_Pos                    11                                                      /*!< TIMER16 CR: ECE Position                */
#define TIMER16_CR_ECE_Msk                    (0x01UL << TIMER16_CR_ECE_Pos)                          /*!< TIMER16 CR: ECE Mask                    */
#define TIMER16_CR_MS_Pos                     12                                                      /*!< TIMER16 CR: MS Position                 */
#define TIMER16_CR_MS_Msk                     (0x03UL << TIMER16_CR_MS_Pos)                           /*!< TIMER16 CR: MS Mask                     */
#define TIMER16_CR_CLK_Pos                    14                                                      /*!< TIMER16 CR: CLK Position                */
#define TIMER16_CR_CLK_Msk                    (0x01UL << TIMER16_CR_CLK_Pos)                          /*!< TIMER16 CR: CLK Mask                    */
#define TIMER16_CR_EN_Pos                     15                                                      /*!< TIMER16 CR: EN Position                 */
#define TIMER16_CR_EN_Msk                     (0x01UL << TIMER16_CR_EN_Pos)                           /*!< TIMER16 CR: EN Mask                     */
#define TIMER16_CR_CSYNC_Pos                  30                                                      /*!< TIMER16 CR: CSYNC Position              */
#define TIMER16_CR_CSYNC_Msk                  (0x01UL << TIMER16_CR_CSYNC_Pos)                        /*!< TIMER16 CR: CSYNC Mask                  */
#define TIMER16_CR_SSYNC_Pos                  31                                                      /*!< TIMER16 CR: SSYNC Position              */
#define TIMER16_CR_SSYNC_Msk                  (0x01UL << TIMER16_CR_SSYNC_Pos)                        /*!< TIMER16 CR: SSYNC Mask                  */

/* ---------------------------------  TIMER16_ADR  -------------------------------- */
#define TIMER16_ADR_ADATA_Pos                 0                                                       /*!< TIMER16 ADR: ADATA Position             */
#define TIMER16_ADR_ADATA_Msk                 (0x0000ffffUL << TIMER16_ADR_ADATA_Pos)                 /*!< TIMER16 ADR: ADATA Mask                 */

/* ---------------------------------  TIMER16_BDR  -------------------------------- */
#define TIMER16_BDR_BDATA_Pos                 0                                                       /*!< TIMER16 BDR: BDATA Position             */
#define TIMER16_BDR_BDATA_Msk                 (0x0000ffffUL << TIMER16_BDR_BDATA_Pos)                 /*!< TIMER16 BDR: BDATA Mask                 */

/* --------------------------------  TIMER16_CAPDR  ------------------------------- */
#define TIMER16_CAPDR_CAPD_Pos                0                                                       /*!< TIMER16 CAPDR: CAPD Position            */
#define TIMER16_CAPDR_CAPD_Msk                (0x0000ffffUL << TIMER16_CAPDR_CAPD_Pos)                /*!< TIMER16 CAPDR: CAPD Mask                */

/* --------------------------------  TIMER16_PREDR  ------------------------------- */
#define TIMER16_PREDR_PRED_Pos                0                                                       /*!< TIMER16 PREDR: PRED Position            */
#define TIMER16_PREDR_PRED_Msk                (0x00000fffUL << TIMER16_PREDR_PRED_Pos)                /*!< TIMER16 PREDR: PRED Mask                */

/* ---------------------------------  TIMER16_CNT  -------------------------------- */
#define TIMER16_CNT_CNT_Pos                   0                                                       /*!< TIMER16 CNT: CNT Position               */
#define TIMER16_CNT_CNT_Msk                   (0x0000ffffUL << TIMER16_CNT_CNT_Pos)                   /*!< TIMER16 CNT: CNT Mask                   */


/* ================================================================================ */
/* ================         Group 'TIMER2n' Position & Mask        ================ */
/* ================================================================================ */


/* ---------------------------------  TIMER2n_CR  --------------------------------- */
#define TIMER2n_CR_CLR_Pos                    0                                                       /*!< TIMER2n CR: CLR Position                */
#define TIMER2n_CR_CLR_Msk                    (0x01UL << TIMER2n_CR_CLR_Pos)                          /*!< TIMER2n CR: CLR Mask                    */
#define TIMER2n_CR_PAU_Pos                    1                                                       /*!< TIMER2n CR: PAU Position                */
#define TIMER2n_CR_PAU_Msk                    (0x01UL << TIMER2n_CR_PAU_Pos)                          /*!< TIMER2n CR: PAU Mask                    */
#define TIMER2n_CR_CIFLAG_Pos                 2                                                       /*!< TIMER2n CR: CIFLAG Position             */
#define TIMER2n_CR_CIFLAG_Msk                 (0x01UL << TIMER2n_CR_CIFLAG_Pos)                       /*!< TIMER2n CR: CIFLAG Mask                 */
#define TIMER2n_CR_MIFLAG_Pos                 3                                                       /*!< TIMER2n CR: MIFLAG Position             */
#define TIMER2n_CR_MIFLAG_Msk                 (0x01UL << TIMER2n_CR_MIFLAG_Pos)                       /*!< TIMER2n CR: MIFLAG Mask                 */
#define TIMER2n_CR_CIEN_Pos                   4                                                       /*!< TIMER2n CR: CIEN Position               */
#define TIMER2n_CR_CIEN_Msk                   (0x01UL << TIMER2n_CR_CIEN_Pos)                         /*!< TIMER2n CR: CIEN Mask                   */
#define TIMER2n_CR_MIEN_Pos                   5                                                       /*!< TIMER2n CR: MIEN Position               */
#define TIMER2n_CR_MIEN_Msk                   (0x01UL << TIMER2n_CR_MIEN_Pos)                         /*!< TIMER2n CR: MIEN Mask                   */
#define TIMER2n_CR_CPOL_Pos                   6                                                       /*!< TIMER2n CR: CPOL Position               */
#define TIMER2n_CR_CPOL_Msk                   (0x03UL << TIMER2n_CR_CPOL_Pos)                         /*!< TIMER2n CR: CPOL Mask                   */
#define TIMER2n_CR_OPOL_Pos                   8                                                       /*!< TIMER2n CR: OPOL Position               */
#define TIMER2n_CR_OPOL_Msk                   (0x01UL << TIMER2n_CR_OPOL_Pos)                         /*!< TIMER2n CR: OPOL Mask                   */
#define TIMER2n_CR_CAPSEL_Pos                 9                                                       /*!< TIMER2n CR: CAPSEL Position             */
#define TIMER2n_CR_CAPSEL_Msk                 (0x03UL << TIMER2n_CR_CAPSEL_Pos)                       /*!< TIMER2n CR: CAPSEL Mask                 */
#define TIMER2n_CR_ECE_Pos                    11                                                      /*!< TIMER2n CR: ECE Position                */
#define TIMER2n_CR_ECE_Msk                    (0x01UL << TIMER2n_CR_ECE_Pos)                          /*!< TIMER2n CR: ECE Mask                    */
#define TIMER2n_CR_MS_Pos                     12                                                      /*!< TIMER2n CR: MS Position                 */
#define TIMER2n_CR_MS_Msk                     (0x03UL << TIMER2n_CR_MS_Pos)                           /*!< TIMER2n CR: MS Mask                     */
#define TIMER2n_CR_CLK_Pos                    14                                                      /*!< TIMER2n CR: CLK Position                */
#define TIMER2n_CR_CLK_Msk                    (0x01UL << TIMER2n_CR_CLK_Pos)                          /*!< TIMER2n CR: CLK Mask                    */
#define TIMER2n_CR_EN_Pos                     15                                                      /*!< TIMER2n CR: EN Position                 */
#define TIMER2n_CR_EN_Msk                     (0x01UL << TIMER2n_CR_EN_Pos)                           /*!< TIMER2n CR: EN Mask                     */

/* ---------------------------------  TIMER2n_ADR  -------------------------------- */
#define TIMER2n_ADR_ADATA_Pos                 0                                                       /*!< TIMER2n ADR: ADATA Position             */
#define TIMER2n_ADR_ADATA_Msk                 (0xffffffffUL << TIMER2n_ADR_ADATA_Pos)                 /*!< TIMER2n ADR: ADATA Mask                 */

/* ---------------------------------  TIMER2n_BDR  -------------------------------- */
#define TIMER2n_BDR_BDATA_Pos                 0                                                       /*!< TIMER2n BDR: BDATA Position             */
#define TIMER2n_BDR_BDATA_Msk                 (0xffffffffUL << TIMER2n_BDR_BDATA_Pos)                 /*!< TIMER2n BDR: BDATA Mask                 */

/* --------------------------------  TIMER2n_CAPDR  ------------------------------- */
#define TIMER2n_CAPDR_CAPD_Pos                0                                                       /*!< TIMER2n CAPDR: CAPD Position            */
#define TIMER2n_CAPDR_CAPD_Msk                (0xffffffffUL << TIMER2n_CAPDR_CAPD_Pos)                /*!< TIMER2n CAPDR: CAPD Mask                */

/* --------------------------------  TIMER2n_PREDR  ------------------------------- */
#define TIMER2n_PREDR_PRED_Pos                0                                                       /*!< TIMER2n PREDR: PRED Position            */
#define TIMER2n_PREDR_PRED_Msk                (0x00000fffUL << TIMER2n_PREDR_PRED_Pos)                /*!< TIMER2n PREDR: PRED Mask                */

/* ---------------------------------  TIMER2n_CNT  -------------------------------- */
#define TIMER2n_CNT_CNT_Pos                   0                                                       /*!< TIMER2n CNT: CNT Position               */
#define TIMER2n_CNT_CNT_Msk                   (0xffffffffUL << TIMER2n_CNT_CNT_Pos)                   /*!< TIMER2n CNT: CNT Mask                   */


/* ================================================================================ */
/* ================        struct 'TIMER20' Position & Mask        ================ */
/* ================================================================================ */


/* ---------------------------------  TIMER20_CR  --------------------------------- */
#define TIMER20_CR_CLR_Pos                    0                                                       /*!< TIMER20 CR: CLR Position                */
#define TIMER20_CR_CLR_Msk                    (0x01UL << TIMER20_CR_CLR_Pos)                          /*!< TIMER20 CR: CLR Mask                    */
#define TIMER20_CR_PAU_Pos                    1                                                       /*!< TIMER20 CR: PAU Position                */
#define TIMER20_CR_PAU_Msk                    (0x01UL << TIMER20_CR_PAU_Pos)                          /*!< TIMER20 CR: PAU Mask                    */
#define TIMER20_CR_CIFLAG_Pos                 2                                                       /*!< TIMER20 CR: CIFLAG Position             */
#define TIMER20_CR_CIFLAG_Msk                 (0x01UL << TIMER20_CR_CIFLAG_Pos)                       /*!< TIMER20 CR: CIFLAG Mask                 */
#define TIMER20_CR_MIFLAG_Pos                 3                                                       /*!< TIMER20 CR: MIFLAG Position             */
#define TIMER20_CR_MIFLAG_Msk                 (0x01UL << TIMER20_CR_MIFLAG_Pos)                       /*!< TIMER20 CR: MIFLAG Mask                 */
#define TIMER20_CR_CIEN_Pos                   4                                                       /*!< TIMER20 CR: CIEN Position               */
#define TIMER20_CR_CIEN_Msk                   (0x01UL << TIMER20_CR_CIEN_Pos)                         /*!< TIMER20 CR: CIEN Mask                   */
#define TIMER20_CR_MIEN_Pos                   5                                                       /*!< TIMER20 CR: MIEN Position               */
#define TIMER20_CR_MIEN_Msk                   (0x01UL << TIMER20_CR_MIEN_Pos)                         /*!< TIMER20 CR: MIEN Mask                   */
#define TIMER20_CR_CPOL_Pos                   6                                                       /*!< TIMER20 CR: CPOL Position               */
#define TIMER20_CR_CPOL_Msk                   (0x03UL << TIMER20_CR_CPOL_Pos)                         /*!< TIMER20 CR: CPOL Mask                   */
#define TIMER20_CR_OPOL_Pos                   8                                                       /*!< TIMER20 CR: OPOL Position               */
#define TIMER20_CR_OPOL_Msk                   (0x01UL << TIMER20_CR_OPOL_Pos)                         /*!< TIMER20 CR: OPOL Mask                   */
#define TIMER20_CR_CAPSEL_Pos                 9                                                       /*!< TIMER20 CR: CAPSEL Position             */
#define TIMER20_CR_CAPSEL_Msk                 (0x03UL << TIMER20_CR_CAPSEL_Pos)                       /*!< TIMER20 CR: CAPSEL Mask                 */
#define TIMER20_CR_ECE_Pos                    11                                                      /*!< TIMER20 CR: ECE Position                */
#define TIMER20_CR_ECE_Msk                    (0x01UL << TIMER20_CR_ECE_Pos)                          /*!< TIMER20 CR: ECE Mask                    */
#define TIMER20_CR_MS_Pos                     12                                                      /*!< TIMER20 CR: MS Position                 */
#define TIMER20_CR_MS_Msk                     (0x03UL << TIMER20_CR_MS_Pos)                           /*!< TIMER20 CR: MS Mask                     */
#define TIMER20_CR_CLK_Pos                    14                                                      /*!< TIMER20 CR: CLK Position                */
#define TIMER20_CR_CLK_Msk                    (0x01UL << TIMER20_CR_CLK_Pos)                          /*!< TIMER20 CR: CLK Mask                    */
#define TIMER20_CR_EN_Pos                     15                                                      /*!< TIMER20 CR: EN Position                 */
#define TIMER20_CR_EN_Msk                     (0x01UL << TIMER20_CR_EN_Pos)                           /*!< TIMER20 CR: EN Mask                     */

/* ---------------------------------  TIMER20_ADR  -------------------------------- */
#define TIMER20_ADR_ADATA_Pos                 0                                                       /*!< TIMER20 ADR: ADATA Position             */
#define TIMER20_ADR_ADATA_Msk                 (0xffffffffUL << TIMER20_ADR_ADATA_Pos)                 /*!< TIMER20 ADR: ADATA Mask                 */

/* ---------------------------------  TIMER20_BDR  -------------------------------- */
#define TIMER20_BDR_BDATA_Pos                 0                                                       /*!< TIMER20 BDR: BDATA Position             */
#define TIMER20_BDR_BDATA_Msk                 (0xffffffffUL << TIMER20_BDR_BDATA_Pos)                 /*!< TIMER20 BDR: BDATA Mask                 */

/* --------------------------------  TIMER20_CAPDR  ------------------------------- */
#define TIMER20_CAPDR_CAPD_Pos                0                                                       /*!< TIMER20 CAPDR: CAPD Position            */
#define TIMER20_CAPDR_CAPD_Msk                (0xffffffffUL << TIMER20_CAPDR_CAPD_Pos)                /*!< TIMER20 CAPDR: CAPD Mask                */

/* --------------------------------  TIMER20_PREDR  ------------------------------- */
#define TIMER20_PREDR_PRED_Pos                0                                                       /*!< TIMER20 PREDR: PRED Position            */
#define TIMER20_PREDR_PRED_Msk                (0x00000fffUL << TIMER20_PREDR_PRED_Pos)                /*!< TIMER20 PREDR: PRED Mask                */

/* ---------------------------------  TIMER20_CNT  -------------------------------- */
#define TIMER20_CNT_CNT_Pos                   0                                                       /*!< TIMER20 CNT: CNT Position               */
#define TIMER20_CNT_CNT_Msk                   (0xffffffffUL << TIMER20_CNT_CNT_Pos)                   /*!< TIMER20 CNT: CNT Mask                   */


/* ================================================================================ */
/* ================        struct 'TIMER21' Position & Mask        ================ */
/* ================================================================================ */


/* ---------------------------------  TIMER21_CR  --------------------------------- */
#define TIMER21_CR_CLR_Pos                    0                                                       /*!< TIMER21 CR: CLR Position                */
#define TIMER21_CR_CLR_Msk                    (0x01UL << TIMER21_CR_CLR_Pos)                          /*!< TIMER21 CR: CLR Mask                    */
#define TIMER21_CR_PAU_Pos                    1                                                       /*!< TIMER21 CR: PAU Position                */
#define TIMER21_CR_PAU_Msk                    (0x01UL << TIMER21_CR_PAU_Pos)                          /*!< TIMER21 CR: PAU Mask                    */
#define TIMER21_CR_CIFLAG_Pos                 2                                                       /*!< TIMER21 CR: CIFLAG Position             */
#define TIMER21_CR_CIFLAG_Msk                 (0x01UL << TIMER21_CR_CIFLAG_Pos)                       /*!< TIMER21 CR: CIFLAG Mask                 */
#define TIMER21_CR_MIFLAG_Pos                 3                                                       /*!< TIMER21 CR: MIFLAG Position             */
#define TIMER21_CR_MIFLAG_Msk                 (0x01UL << TIMER21_CR_MIFLAG_Pos)                       /*!< TIMER21 CR: MIFLAG Mask                 */
#define TIMER21_CR_CIEN_Pos                   4                                                       /*!< TIMER21 CR: CIEN Position               */
#define TIMER21_CR_CIEN_Msk                   (0x01UL << TIMER21_CR_CIEN_Pos)                         /*!< TIMER21 CR: CIEN Mask                   */
#define TIMER21_CR_MIEN_Pos                   5                                                       /*!< TIMER21 CR: MIEN Position               */
#define TIMER21_CR_MIEN_Msk                   (0x01UL << TIMER21_CR_MIEN_Pos)                         /*!< TIMER21 CR: MIEN Mask                   */
#define TIMER21_CR_CPOL_Pos                   6                                                       /*!< TIMER21 CR: CPOL Position               */
#define TIMER21_CR_CPOL_Msk                   (0x03UL << TIMER21_CR_CPOL_Pos)                         /*!< TIMER21 CR: CPOL Mask                   */
#define TIMER21_CR_OPOL_Pos                   8                                                       /*!< TIMER21 CR: OPOL Position               */
#define TIMER21_CR_OPOL_Msk                   (0x01UL << TIMER21_CR_OPOL_Pos)                         /*!< TIMER21 CR: OPOL Mask                   */
#define TIMER21_CR_CAPSEL_Pos                 9                                                       /*!< TIMER21 CR: CAPSEL Position             */
#define TIMER21_CR_CAPSEL_Msk                 (0x03UL << TIMER21_CR_CAPSEL_Pos)                       /*!< TIMER21 CR: CAPSEL Mask                 */
#define TIMER21_CR_ECE_Pos                    11                                                      /*!< TIMER21 CR: ECE Position                */
#define TIMER21_CR_ECE_Msk                    (0x01UL << TIMER21_CR_ECE_Pos)                          /*!< TIMER21 CR: ECE Mask                    */
#define TIMER21_CR_MS_Pos                     12                                                      /*!< TIMER21 CR: MS Position                 */
#define TIMER21_CR_MS_Msk                     (0x03UL << TIMER21_CR_MS_Pos)                           /*!< TIMER21 CR: MS Mask                     */
#define TIMER21_CR_CLK_Pos                    14                                                      /*!< TIMER21 CR: CLK Position                */
#define TIMER21_CR_CLK_Msk                    (0x01UL << TIMER21_CR_CLK_Pos)                          /*!< TIMER21 CR: CLK Mask                    */
#define TIMER21_CR_EN_Pos                     15                                                      /*!< TIMER21 CR: EN Position                 */
#define TIMER21_CR_EN_Msk                     (0x01UL << TIMER21_CR_EN_Pos)                           /*!< TIMER21 CR: EN Mask                     */

/* ---------------------------------  TIMER21_ADR  -------------------------------- */
#define TIMER21_ADR_ADATA_Pos                 0                                                       /*!< TIMER21 ADR: ADATA Position             */
#define TIMER21_ADR_ADATA_Msk                 (0xffffffffUL << TIMER21_ADR_ADATA_Pos)                 /*!< TIMER21 ADR: ADATA Mask                 */

/* ---------------------------------  TIMER21_BDR  -------------------------------- */
#define TIMER21_BDR_BDATA_Pos                 0                                                       /*!< TIMER21 BDR: BDATA Position             */
#define TIMER21_BDR_BDATA_Msk                 (0xffffffffUL << TIMER21_BDR_BDATA_Pos)                 /*!< TIMER21 BDR: BDATA Mask                 */

/* --------------------------------  TIMER21_CAPDR  ------------------------------- */
#define TIMER21_CAPDR_CAPD_Pos                0                                                       /*!< TIMER21 CAPDR: CAPD Position            */
#define TIMER21_CAPDR_CAPD_Msk                (0xffffffffUL << TIMER21_CAPDR_CAPD_Pos)                /*!< TIMER21 CAPDR: CAPD Mask                */

/* --------------------------------  TIMER21_PREDR  ------------------------------- */
#define TIMER21_PREDR_PRED_Pos                0                                                       /*!< TIMER21 PREDR: PRED Position            */
#define TIMER21_PREDR_PRED_Msk                (0x00000fffUL << TIMER21_PREDR_PRED_Pos)                /*!< TIMER21 PREDR: PRED Mask                */

/* ---------------------------------  TIMER21_CNT  -------------------------------- */
#define TIMER21_CNT_CNT_Pos                   0                                                       /*!< TIMER21 CNT: CNT Position               */
#define TIMER21_CNT_CNT_Msk                   (0xffffffffUL << TIMER21_CNT_CNT_Pos)                   /*!< TIMER21 CNT: CNT Mask                   */


/* ================================================================================ */
/* ================         Group 'TIMER3n' Position & Mask        ================ */
/* ================================================================================ */


/* ---------------------------------  TIMER3n_CR  --------------------------------- */
#define TIMER3n_CR_CLR_Pos                    0                                                       /*!< TIMER3n CR: CLR Position                */
#define TIMER3n_CR_CLR_Msk                    (0x01UL << TIMER3n_CR_CLR_Pos)                          /*!< TIMER3n CR: CLR Mask                    */
#define TIMER3n_CR_PMOC_Pos                   1                                                       /*!< TIMER3n CR: PMOC Position               */
#define TIMER3n_CR_PMOC_Msk                   (0x07UL << TIMER3n_CR_PMOC_Pos)                         /*!< TIMER3n CR: PMOC Mask                   */
#define TIMER3n_CR_UPDT_Pos                   4                                                       /*!< TIMER3n CR: UPDT Position               */
#define TIMER3n_CR_UPDT_Msk                   (0x03UL << TIMER3n_CR_UPDT_Pos)                         /*!< TIMER3n CR: UPDT Mask                   */
#define TIMER3n_CR_CPOL_Pos                   6                                                       /*!< TIMER3n CR: CPOL Position               */
#define TIMER3n_CR_CPOL_Msk                   (0x03UL << TIMER3n_CR_CPOL_Pos)                         /*!< TIMER3n CR: CPOL Mask                   */
#define TIMER3n_CR_DLYPOS_Pos                 8                                                       /*!< TIMER3n CR: DLYPOS Position             */
#define TIMER3n_CR_DLYPOS_Msk                 (0x01UL << TIMER3n_CR_DLYPOS_Pos)                       /*!< TIMER3n CR: DLYPOS Mask                 */
#define TIMER3n_CR_DLYEN_Pos                  9                                                       /*!< TIMER3n CR: DLYEN Position              */
#define TIMER3n_CR_DLYEN_Msk                  (0x01UL << TIMER3n_CR_DLYEN_Pos)                        /*!< TIMER3n CR: DLYEN Mask                  */
#define TIMER3n_CR_FORCA_Pos                  10                                                      /*!< TIMER3n CR: FORCA Position              */
#define TIMER3n_CR_FORCA_Msk                  (0x01UL << TIMER3n_CR_FORCA_Pos)                        /*!< TIMER3n CR: FORCA Mask                  */
#define TIMER3n_CR_ECE_Pos                    11                                                      /*!< TIMER3n CR: ECE Position                */
#define TIMER3n_CR_ECE_Msk                    (0x01UL << TIMER3n_CR_ECE_Pos)                          /*!< TIMER3n CR: ECE Mask                    */
#define TIMER3n_CR_MS_Pos                     12                                                      /*!< TIMER3n CR: MS Position                 */
#define TIMER3n_CR_MS_Msk                     (0x03UL << TIMER3n_CR_MS_Pos)                           /*!< TIMER3n CR: MS Mask                     */
#define TIMER3n_CR_CLK_Pos                    14                                                      /*!< TIMER3n CR: CLK Position                */
#define TIMER3n_CR_CLK_Msk                    (0x01UL << TIMER3n_CR_CLK_Pos)                          /*!< TIMER3n CR: CLK Mask                    */
#define TIMER3n_CR_EN_Pos                     15                                                      /*!< TIMER3n CR: EN Position                 */
#define TIMER3n_CR_EN_Msk                     (0x01UL << TIMER3n_CR_EN_Pos)                           /*!< TIMER3n CR: EN Mask                     */

/* ---------------------------------  TIMER3n_PDR  -------------------------------- */
#define TIMER3n_PDR_PDATA_Pos                 0                                                       /*!< TIMER3n PDR: PDATA Position             */
#define TIMER3n_PDR_PDATA_Msk                 (0x0000ffffUL << TIMER3n_PDR_PDATA_Pos)                 /*!< TIMER3n PDR: PDATA Mask                 */

/* ---------------------------------  TIMER3n_ADR  -------------------------------- */
#define TIMER3n_ADR_ADATA_Pos                 0                                                       /*!< TIMER3n ADR: ADATA Position             */
#define TIMER3n_ADR_ADATA_Msk                 (0x0000ffffUL << TIMER3n_ADR_ADATA_Pos)                 /*!< TIMER3n ADR: ADATA Mask                 */

/* ---------------------------------  TIMER3n_BDR  -------------------------------- */
#define TIMER3n_BDR_BDATA_Pos                 0                                                       /*!< TIMER3n BDR: BDATA Position             */
#define TIMER3n_BDR_BDATA_Msk                 (0x0000ffffUL << TIMER3n_BDR_BDATA_Pos)                 /*!< TIMER3n BDR: BDATA Mask                 */

/* ---------------------------------  TIMER3n_CDR  -------------------------------- */
#define TIMER3n_CDR_CDATA_Pos                 0                                                       /*!< TIMER3n CDR: CDATA Position             */
#define TIMER3n_CDR_CDATA_Msk                 (0x0000ffffUL << TIMER3n_CDR_CDATA_Pos)                 /*!< TIMER3n CDR: CDATA Mask                 */

/* --------------------------------  TIMER3n_CAPDR  ------------------------------- */
#define TIMER3n_CAPDR_CAPD_Pos                0                                                       /*!< TIMER3n CAPDR: CAPD Position            */
#define TIMER3n_CAPDR_CAPD_Msk                (0x0000ffffUL << TIMER3n_CAPDR_CAPD_Pos)                /*!< TIMER3n CAPDR: CAPD Mask                */

/* --------------------------------  TIMER3n_PREDR  ------------------------------- */
#define TIMER3n_PREDR_PRED_Pos                0                                                       /*!< TIMER3n PREDR: PRED Position            */
#define TIMER3n_PREDR_PRED_Msk                (0x00000fffUL << TIMER3n_PREDR_PRED_Pos)                /*!< TIMER3n PREDR: PRED Mask                */

/* ---------------------------------  TIMER3n_CNT  -------------------------------- */
#define TIMER3n_CNT_CNT_Pos                   0                                                       /*!< TIMER3n CNT: CNT Position               */
#define TIMER3n_CNT_CNT_Msk                   (0x0000ffffUL << TIMER3n_CNT_CNT_Pos)                   /*!< TIMER3n CNT: CNT Mask                   */

/* --------------------------------  TIMER3n_OUTCR  ------------------------------- */
#define TIMER3n_OUTCR_LVLCA_Pos               0                                                       /*!< TIMER3n OUTCR: LVLCA Position           */
#define TIMER3n_OUTCR_LVLCA_Msk               (0x01UL << TIMER3n_OUTCR_LVLCA_Pos)                     /*!< TIMER3n OUTCR: LVLCA Mask               */
#define TIMER3n_OUTCR_LVLBA_Pos               1                                                       /*!< TIMER3n OUTCR: LVLBA Position           */
#define TIMER3n_OUTCR_LVLBA_Msk               (0x01UL << TIMER3n_OUTCR_LVLBA_Pos)                     /*!< TIMER3n OUTCR: LVLBA Mask               */
#define TIMER3n_OUTCR_LVLAA_Pos               2                                                       /*!< TIMER3n OUTCR: LVLAA Position           */
#define TIMER3n_OUTCR_LVLAA_Msk               (0x01UL << TIMER3n_OUTCR_LVLAA_Pos)                     /*!< TIMER3n OUTCR: LVLAA Mask               */
#define TIMER3n_OUTCR_LVLCB_Pos               4                                                       /*!< TIMER3n OUTCR: LVLCB Position           */
#define TIMER3n_OUTCR_LVLCB_Msk               (0x01UL << TIMER3n_OUTCR_LVLCB_Pos)                     /*!< TIMER3n OUTCR: LVLCB Mask               */
#define TIMER3n_OUTCR_LVLBB_Pos               5                                                       /*!< TIMER3n OUTCR: LVLBB Position           */
#define TIMER3n_OUTCR_LVLBB_Msk               (0x01UL << TIMER3n_OUTCR_LVLBB_Pos)                     /*!< TIMER3n OUTCR: LVLBB Mask               */
#define TIMER3n_OUTCR_LVLAB_Pos               6                                                       /*!< TIMER3n OUTCR: LVLAB Position           */
#define TIMER3n_OUTCR_LVLAB_Msk               (0x01UL << TIMER3n_OUTCR_LVLAB_Pos)                     /*!< TIMER3n OUTCR: LVLAB Mask               */
#define TIMER3n_OUTCR_PCAOE_Pos               8                                                       /*!< TIMER3n OUTCR: PCAOE Position           */
#define TIMER3n_OUTCR_PCAOE_Msk               (0x01UL << TIMER3n_OUTCR_PCAOE_Pos)                     /*!< TIMER3n OUTCR: PCAOE Mask               */
#define TIMER3n_OUTCR_PBAOE_Pos               9                                                       /*!< TIMER3n OUTCR: PBAOE Position           */
#define TIMER3n_OUTCR_PBAOE_Msk               (0x01UL << TIMER3n_OUTCR_PBAOE_Pos)                     /*!< TIMER3n OUTCR: PBAOE Mask               */
#define TIMER3n_OUTCR_PAAOE_Pos               10                                                      /*!< TIMER3n OUTCR: PAAOE Position           */
#define TIMER3n_OUTCR_PAAOE_Msk               (0x01UL << TIMER3n_OUTCR_PAAOE_Pos)                     /*!< TIMER3n OUTCR: PAAOE Mask               */
#define TIMER3n_OUTCR_PCBOE_Pos               11                                                      /*!< TIMER3n OUTCR: PCBOE Position           */
#define TIMER3n_OUTCR_PCBOE_Msk               (0x01UL << TIMER3n_OUTCR_PCBOE_Pos)                     /*!< TIMER3n OUTCR: PCBOE Mask               */
#define TIMER3n_OUTCR_PBBOE_Pos               12                                                      /*!< TIMER3n OUTCR: PBBOE Position           */
#define TIMER3n_OUTCR_PBBOE_Msk               (0x01UL << TIMER3n_OUTCR_PBBOE_Pos)                     /*!< TIMER3n OUTCR: PBBOE Mask               */
#define TIMER3n_OUTCR_PABOE_Pos               13                                                      /*!< TIMER3n OUTCR: PABOE Position           */
#define TIMER3n_OUTCR_PABOE_Msk               (0x01UL << TIMER3n_OUTCR_PABOE_Pos)                     /*!< TIMER3n OUTCR: PABOE Mask               */
#define TIMER3n_OUTCR_POLA_Pos                14                                                      /*!< TIMER3n OUTCR: POLA Position            */
#define TIMER3n_OUTCR_POLA_Msk                (0x01UL << TIMER3n_OUTCR_POLA_Pos)                      /*!< TIMER3n OUTCR: POLA Mask                */
#define TIMER3n_OUTCR_POLB_Pos                15                                                      /*!< TIMER3n OUTCR: POLB Position            */
#define TIMER3n_OUTCR_POLB_Msk                (0x01UL << TIMER3n_OUTCR_POLB_Pos)                      /*!< TIMER3n OUTCR: POLB Mask                */
#define TIMER3n_OUTCR_WTIDKY_Pos              16                                                      /*!< TIMER3n OUTCR: WTIDKY Position          */
#define TIMER3n_OUTCR_WTIDKY_Msk              (0x0000ffffUL << TIMER3n_OUTCR_WTIDKY_Pos)              /*!< TIMER3n OUTCR: WTIDKY Mask              */

/* ---------------------------------  TIMER3n_DLY  -------------------------------- */
#define TIMER3n_DLY_DLY_Pos                   0                                                       /*!< TIMER3n DLY: DLY Position               */
#define TIMER3n_DLY_DLY_Msk                   (0x000003ffUL << TIMER3n_DLY_DLY_Pos)                   /*!< TIMER3n DLY: DLY Mask                   */

/* --------------------------------  TIMER3n_INTCR  ------------------------------- */
#define TIMER3n_INTCR_CMIEN_Pos               0                                                       /*!< TIMER3n INTCR: CMIEN Position           */
#define TIMER3n_INTCR_CMIEN_Msk               (0x01UL << TIMER3n_INTCR_CMIEN_Pos)                     /*!< TIMER3n INTCR: CMIEN Mask               */
#define TIMER3n_INTCR_BMIEN_Pos               1                                                       /*!< TIMER3n INTCR: BMIEN Position           */
#define TIMER3n_INTCR_BMIEN_Msk               (0x01UL << TIMER3n_INTCR_BMIEN_Pos)                     /*!< TIMER3n INTCR: BMIEN Mask               */
#define TIMER3n_INTCR_AMIEN_Pos               2                                                       /*!< TIMER3n INTCR: AMIEN Position           */
#define TIMER3n_INTCR_AMIEN_Msk               (0x01UL << TIMER3n_INTCR_AMIEN_Pos)                     /*!< TIMER3n INTCR: AMIEN Mask               */
#define TIMER3n_INTCR_PMIEN_Pos               3                                                       /*!< TIMER3n INTCR: PMIEN Position           */
#define TIMER3n_INTCR_PMIEN_Msk               (0x01UL << TIMER3n_INTCR_PMIEN_Pos)                     /*!< TIMER3n INTCR: PMIEN Mask               */
#define TIMER3n_INTCR_BTIEN_Pos               4                                                       /*!< TIMER3n INTCR: BTIEN Position           */
#define TIMER3n_INTCR_BTIEN_Msk               (0x01UL << TIMER3n_INTCR_BTIEN_Pos)                     /*!< TIMER3n INTCR: BTIEN Mask               */
#define TIMER3n_INTCR_CIEN_Pos                5                                                       /*!< TIMER3n INTCR: CIEN Position            */
#define TIMER3n_INTCR_CIEN_Msk                (0x01UL << TIMER3n_INTCR_CIEN_Pos)                      /*!< TIMER3n INTCR: CIEN Mask                */
#define TIMER3n_INTCR_HIZIEN_Pos              6                                                       /*!< TIMER3n INTCR: HIZIEN Position          */
#define TIMER3n_INTCR_HIZIEN_Msk              (0x01UL << TIMER3n_INTCR_HIZIEN_Pos)                    /*!< TIMER3n INTCR: HIZIEN Mask              */

/* -------------------------------  TIMER3n_INTFLAG  ------------------------------ */
#define TIMER3n_INTFLAG_CMIFLAG_Pos           0                                                       /*!< TIMER3n INTFLAG: CMIFLAG Position       */
#define TIMER3n_INTFLAG_CMIFLAG_Msk           (0x01UL << TIMER3n_INTFLAG_CMIFLAG_Pos)                 /*!< TIMER3n INTFLAG: CMIFLAG Mask           */
#define TIMER3n_INTFLAG_BMIFLAG_Pos           1                                                       /*!< TIMER3n INTFLAG: BMIFLAG Position       */
#define TIMER3n_INTFLAG_BMIFLAG_Msk           (0x01UL << TIMER3n_INTFLAG_BMIFLAG_Pos)                 /*!< TIMER3n INTFLAG: BMIFLAG Mask           */
#define TIMER3n_INTFLAG_AMIFLAG_Pos           2                                                       /*!< TIMER3n INTFLAG: AMIFLAG Position       */
#define TIMER3n_INTFLAG_AMIFLAG_Msk           (0x01UL << TIMER3n_INTFLAG_AMIFLAG_Pos)                 /*!< TIMER3n INTFLAG: AMIFLAG Mask           */
#define TIMER3n_INTFLAG_PMIFLAG_Pos           3                                                       /*!< TIMER3n INTFLAG: PMIFLAG Position       */
#define TIMER3n_INTFLAG_PMIFLAG_Msk           (0x01UL << TIMER3n_INTFLAG_PMIFLAG_Pos)                 /*!< TIMER3n INTFLAG: PMIFLAG Mask           */
#define TIMER3n_INTFLAG_BTIFLAG_Pos           4                                                       /*!< TIMER3n INTFLAG: BTIFLAG Position       */
#define TIMER3n_INTFLAG_BTIFLAG_Msk           (0x01UL << TIMER3n_INTFLAG_BTIFLAG_Pos)                 /*!< TIMER3n INTFLAG: BTIFLAG Mask           */
#define TIMER3n_INTFLAG_CIFLAG_Pos            5                                                       /*!< TIMER3n INTFLAG: CIFLAG Position        */
#define TIMER3n_INTFLAG_CIFLAG_Msk            (0x01UL << TIMER3n_INTFLAG_CIFLAG_Pos)                  /*!< TIMER3n INTFLAG: CIFLAG Mask            */
#define TIMER3n_INTFLAG_HIZIFLAG_Pos          6                                                       /*!< TIMER3n INTFLAG: HIZIFLAG Position      */
#define TIMER3n_INTFLAG_HIZIFLAG_Msk          (0x01UL << TIMER3n_INTFLAG_HIZIFLAG_Pos)                /*!< TIMER3n INTFLAG: HIZIFLAG Mask          */

/* --------------------------------  TIMER3n_HIZCR  ------------------------------- */
#define TIMER3n_HIZCR_HIZCLR_Pos              0                                                       /*!< TIMER3n HIZCR: HIZCLR Position          */
#define TIMER3n_HIZCR_HIZCLR_Msk              (0x01UL << TIMER3n_HIZCR_HIZCLR_Pos)                    /*!< TIMER3n HIZCR: HIZCLR Mask              */
#define TIMER3n_HIZCR_HIZSTA_Pos              1                                                       /*!< TIMER3n HIZCR: HIZSTA Position          */
#define TIMER3n_HIZCR_HIZSTA_Msk              (0x01UL << TIMER3n_HIZCR_HIZSTA_Pos)                    /*!< TIMER3n HIZCR: HIZSTA Mask              */
#define TIMER3n_HIZCR_HEDGE_Pos               2                                                       /*!< TIMER3n HIZCR: HEDGE Position           */
#define TIMER3n_HIZCR_HEDGE_Msk               (0x01UL << TIMER3n_HIZCR_HEDGE_Pos)                     /*!< TIMER3n HIZCR: HEDGE Mask               */
#define TIMER3n_HIZCR_HIZSW_Pos               4                                                       /*!< TIMER3n HIZCR: HIZSW Position           */
#define TIMER3n_HIZCR_HIZSW_Msk               (0x01UL << TIMER3n_HIZCR_HIZSW_Pos)                     /*!< TIMER3n HIZCR: HIZSW Mask               */
#define TIMER3n_HIZCR_HIZEN_Pos               7                                                       /*!< TIMER3n HIZCR: HIZEN Position           */
#define TIMER3n_HIZCR_HIZEN_Msk               (0x01UL << TIMER3n_HIZCR_HIZEN_Pos)                     /*!< TIMER3n HIZCR: HIZEN Mask               */

/* --------------------------------  TIMER3n_ADTCR  ------------------------------- */
#define TIMER3n_ADTCR_CMTG_Pos                0                                                       /*!< TIMER3n ADTCR: CMTG Position            */
#define TIMER3n_ADTCR_CMTG_Msk                (0x01UL << TIMER3n_ADTCR_CMTG_Pos)                      /*!< TIMER3n ADTCR: CMTG Mask                */
#define TIMER3n_ADTCR_BMTG_Pos                1                                                       /*!< TIMER3n ADTCR: BMTG Position            */
#define TIMER3n_ADTCR_BMTG_Msk                (0x01UL << TIMER3n_ADTCR_BMTG_Pos)                      /*!< TIMER3n ADTCR: BMTG Mask                */
#define TIMER3n_ADTCR_AMTG_Pos                2                                                       /*!< TIMER3n ADTCR: AMTG Position            */
#define TIMER3n_ADTCR_AMTG_Msk                (0x01UL << TIMER3n_ADTCR_AMTG_Pos)                      /*!< TIMER3n ADTCR: AMTG Mask                */
#define TIMER3n_ADTCR_PMTG_Pos                3                                                       /*!< TIMER3n ADTCR: PMTG Position            */
#define TIMER3n_ADTCR_PMTG_Msk                (0x01UL << TIMER3n_ADTCR_PMTG_Pos)                      /*!< TIMER3n ADTCR: PMTG Mask                */
#define TIMER3n_ADTCR_BTTG_Pos                4                                                       /*!< TIMER3n ADTCR: BTTG Position            */
#define TIMER3n_ADTCR_BTTG_Msk                (0x01UL << TIMER3n_ADTCR_BTTG_Pos)                      /*!< TIMER3n ADTCR: BTTG Mask                */

/* --------------------------------  TIMER3n_ADTDR  ------------------------------- */
#define TIMER3n_ADTDR_ADTDATA_Pos             0                                                       /*!< TIMER3n ADTDR: ADTDATA Position         */
#define TIMER3n_ADTDR_ADTDATA_Msk             (0x00003fffUL << TIMER3n_ADTDR_ADTDATA_Pos)             /*!< TIMER3n ADTDR: ADTDATA Mask             */


/* ================================================================================ */
/* ================        struct 'TIMER30' Position & Mask        ================ */
/* ================================================================================ */


/* ---------------------------------  TIMER30_CR  --------------------------------- */
#define TIMER30_CR_CLR_Pos                    0                                                       /*!< TIMER30 CR: CLR Position                */
#define TIMER30_CR_CLR_Msk                    (0x01UL << TIMER30_CR_CLR_Pos)                          /*!< TIMER30 CR: CLR Mask                    */
#define TIMER30_CR_PMOC_Pos                   1                                                       /*!< TIMER30 CR: PMOC Position               */
#define TIMER30_CR_PMOC_Msk                   (0x07UL << TIMER30_CR_PMOC_Pos)                         /*!< TIMER30 CR: PMOC Mask                   */
#define TIMER30_CR_UPDT_Pos                   4                                                       /*!< TIMER30 CR: UPDT Position               */
#define TIMER30_CR_UPDT_Msk                   (0x03UL << TIMER30_CR_UPDT_Pos)                         /*!< TIMER30 CR: UPDT Mask                   */
#define TIMER30_CR_CPOL_Pos                   6                                                       /*!< TIMER30 CR: CPOL Position               */
#define TIMER30_CR_CPOL_Msk                   (0x03UL << TIMER30_CR_CPOL_Pos)                         /*!< TIMER30 CR: CPOL Mask                   */
#define TIMER30_CR_DLYPOS_Pos                 8                                                       /*!< TIMER30 CR: DLYPOS Position             */
#define TIMER30_CR_DLYPOS_Msk                 (0x01UL << TIMER30_CR_DLYPOS_Pos)                       /*!< TIMER30 CR: DLYPOS Mask                 */
#define TIMER30_CR_DLYEN_Pos                  9                                                       /*!< TIMER30 CR: DLYEN Position              */
#define TIMER30_CR_DLYEN_Msk                  (0x01UL << TIMER30_CR_DLYEN_Pos)                        /*!< TIMER30 CR: DLYEN Mask                  */
#define TIMER30_CR_FORCA_Pos                  10                                                      /*!< TIMER30 CR: FORCA Position              */
#define TIMER30_CR_FORCA_Msk                  (0x01UL << TIMER30_CR_FORCA_Pos)                        /*!< TIMER30 CR: FORCA Mask                  */
#define TIMER30_CR_ECE_Pos                    11                                                      /*!< TIMER30 CR: ECE Position                */
#define TIMER30_CR_ECE_Msk                    (0x01UL << TIMER30_CR_ECE_Pos)                          /*!< TIMER30 CR: ECE Mask                    */
#define TIMER30_CR_MS_Pos                     12                                                      /*!< TIMER30 CR: MS Position                 */
#define TIMER30_CR_MS_Msk                     (0x03UL << TIMER30_CR_MS_Pos)                           /*!< TIMER30 CR: MS Mask                     */
#define TIMER30_CR_CLK_Pos                    14                                                      /*!< TIMER30 CR: CLK Position                */
#define TIMER30_CR_CLK_Msk                    (0x01UL << TIMER30_CR_CLK_Pos)                          /*!< TIMER30 CR: CLK Mask                    */
#define TIMER30_CR_EN_Pos                     15                                                      /*!< TIMER30 CR: EN Position                 */
#define TIMER30_CR_EN_Msk                     (0x01UL << TIMER30_CR_EN_Pos)                           /*!< TIMER30 CR: EN Mask                     */

/* ---------------------------------  TIMER30_PDR  -------------------------------- */
#define TIMER30_PDR_PDATA_Pos                 0                                                       /*!< TIMER30 PDR: PDATA Position             */
#define TIMER30_PDR_PDATA_Msk                 (0x0000ffffUL << TIMER30_PDR_PDATA_Pos)                 /*!< TIMER30 PDR: PDATA Mask                 */

/* ---------------------------------  TIMER30_ADR  -------------------------------- */
#define TIMER30_ADR_ADATA_Pos                 0                                                       /*!< TIMER30 ADR: ADATA Position             */
#define TIMER30_ADR_ADATA_Msk                 (0x0000ffffUL << TIMER30_ADR_ADATA_Pos)                 /*!< TIMER30 ADR: ADATA Mask                 */

/* ---------------------------------  TIMER30_BDR  -------------------------------- */
#define TIMER30_BDR_BDATA_Pos                 0                                                       /*!< TIMER30 BDR: BDATA Position             */
#define TIMER30_BDR_BDATA_Msk                 (0x0000ffffUL << TIMER30_BDR_BDATA_Pos)                 /*!< TIMER30 BDR: BDATA Mask                 */

/* ---------------------------------  TIMER30_CDR  -------------------------------- */
#define TIMER30_CDR_CDATA_Pos                 0                                                       /*!< TIMER30 CDR: CDATA Position             */
#define TIMER30_CDR_CDATA_Msk                 (0x0000ffffUL << TIMER30_CDR_CDATA_Pos)                 /*!< TIMER30 CDR: CDATA Mask                 */

/* --------------------------------  TIMER30_CAPDR  ------------------------------- */
#define TIMER30_CAPDR_CAPD_Pos                0                                                       /*!< TIMER30 CAPDR: CAPD Position            */
#define TIMER30_CAPDR_CAPD_Msk                (0x0000ffffUL << TIMER30_CAPDR_CAPD_Pos)                /*!< TIMER30 CAPDR: CAPD Mask                */

/* --------------------------------  TIMER30_PREDR  ------------------------------- */
#define TIMER30_PREDR_PRED_Pos                0                                                       /*!< TIMER30 PREDR: PRED Position            */
#define TIMER30_PREDR_PRED_Msk                (0x00000fffUL << TIMER30_PREDR_PRED_Pos)                /*!< TIMER30 PREDR: PRED Mask                */

/* ---------------------------------  TIMER30_CNT  -------------------------------- */
#define TIMER30_CNT_CNT_Pos                   0                                                       /*!< TIMER30 CNT: CNT Position               */
#define TIMER30_CNT_CNT_Msk                   (0x0000ffffUL << TIMER30_CNT_CNT_Pos)                   /*!< TIMER30 CNT: CNT Mask                   */

/* --------------------------------  TIMER30_OUTCR  ------------------------------- */
#define TIMER30_OUTCR_LVLCA_Pos               0                                                       /*!< TIMER30 OUTCR: LVLCA Position           */
#define TIMER30_OUTCR_LVLCA_Msk               (0x01UL << TIMER30_OUTCR_LVLCA_Pos)                     /*!< TIMER30 OUTCR: LVLCA Mask               */
#define TIMER30_OUTCR_LVLBA_Pos               1                                                       /*!< TIMER30 OUTCR: LVLBA Position           */
#define TIMER30_OUTCR_LVLBA_Msk               (0x01UL << TIMER30_OUTCR_LVLBA_Pos)                     /*!< TIMER30 OUTCR: LVLBA Mask               */
#define TIMER30_OUTCR_LVLAA_Pos               2                                                       /*!< TIMER30 OUTCR: LVLAA Position           */
#define TIMER30_OUTCR_LVLAA_Msk               (0x01UL << TIMER30_OUTCR_LVLAA_Pos)                     /*!< TIMER30 OUTCR: LVLAA Mask               */
#define TIMER30_OUTCR_LVLCB_Pos               4                                                       /*!< TIMER30 OUTCR: LVLCB Position           */
#define TIMER30_OUTCR_LVLCB_Msk               (0x01UL << TIMER30_OUTCR_LVLCB_Pos)                     /*!< TIMER30 OUTCR: LVLCB Mask               */
#define TIMER30_OUTCR_LVLBB_Pos               5                                                       /*!< TIMER30 OUTCR: LVLBB Position           */
#define TIMER30_OUTCR_LVLBB_Msk               (0x01UL << TIMER30_OUTCR_LVLBB_Pos)                     /*!< TIMER30 OUTCR: LVLBB Mask               */
#define TIMER30_OUTCR_LVLAB_Pos               6                                                       /*!< TIMER30 OUTCR: LVLAB Position           */
#define TIMER30_OUTCR_LVLAB_Msk               (0x01UL << TIMER30_OUTCR_LVLAB_Pos)                     /*!< TIMER30 OUTCR: LVLAB Mask               */
#define TIMER30_OUTCR_PCAOE_Pos               8                                                       /*!< TIMER30 OUTCR: PCAOE Position           */
#define TIMER30_OUTCR_PCAOE_Msk               (0x01UL << TIMER30_OUTCR_PCAOE_Pos)                     /*!< TIMER30 OUTCR: PCAOE Mask               */
#define TIMER30_OUTCR_PBAOE_Pos               9                                                       /*!< TIMER30 OUTCR: PBAOE Position           */
#define TIMER30_OUTCR_PBAOE_Msk               (0x01UL << TIMER30_OUTCR_PBAOE_Pos)                     /*!< TIMER30 OUTCR: PBAOE Mask               */
#define TIMER30_OUTCR_PAAOE_Pos               10                                                      /*!< TIMER30 OUTCR: PAAOE Position           */
#define TIMER30_OUTCR_PAAOE_Msk               (0x01UL << TIMER30_OUTCR_PAAOE_Pos)                     /*!< TIMER30 OUTCR: PAAOE Mask               */
#define TIMER30_OUTCR_PCBOE_Pos               11                                                      /*!< TIMER30 OUTCR: PCBOE Position           */
#define TIMER30_OUTCR_PCBOE_Msk               (0x01UL << TIMER30_OUTCR_PCBOE_Pos)                     /*!< TIMER30 OUTCR: PCBOE Mask               */
#define TIMER30_OUTCR_PBBOE_Pos               12                                                      /*!< TIMER30 OUTCR: PBBOE Position           */
#define TIMER30_OUTCR_PBBOE_Msk               (0x01UL << TIMER30_OUTCR_PBBOE_Pos)                     /*!< TIMER30 OUTCR: PBBOE Mask               */
#define TIMER30_OUTCR_PABOE_Pos               13                                                      /*!< TIMER30 OUTCR: PABOE Position           */
#define TIMER30_OUTCR_PABOE_Msk               (0x01UL << TIMER30_OUTCR_PABOE_Pos)                     /*!< TIMER30 OUTCR: PABOE Mask               */
#define TIMER30_OUTCR_POLA_Pos                14                                                      /*!< TIMER30 OUTCR: POLA Position            */
#define TIMER30_OUTCR_POLA_Msk                (0x01UL << TIMER30_OUTCR_POLA_Pos)                      /*!< TIMER30 OUTCR: POLA Mask                */
#define TIMER30_OUTCR_POLB_Pos                15                                                      /*!< TIMER30 OUTCR: POLB Position            */
#define TIMER30_OUTCR_POLB_Msk                (0x01UL << TIMER30_OUTCR_POLB_Pos)                      /*!< TIMER30 OUTCR: POLB Mask                */
#define TIMER30_OUTCR_WTIDKY_Pos              16                                                      /*!< TIMER30 OUTCR: WTIDKY Position          */
#define TIMER30_OUTCR_WTIDKY_Msk              (0x0000ffffUL << TIMER30_OUTCR_WTIDKY_Pos)              /*!< TIMER30 OUTCR: WTIDKY Mask              */

/* ---------------------------------  TIMER30_DLY  -------------------------------- */
#define TIMER30_DLY_DLY_Pos                   0                                                       /*!< TIMER30 DLY: DLY Position               */
#define TIMER30_DLY_DLY_Msk                   (0x000003ffUL << TIMER30_DLY_DLY_Pos)                   /*!< TIMER30 DLY: DLY Mask                   */

/* --------------------------------  TIMER30_INTCR  ------------------------------- */
#define TIMER30_INTCR_CMIEN_Pos               0                                                       /*!< TIMER30 INTCR: CMIEN Position           */
#define TIMER30_INTCR_CMIEN_Msk               (0x01UL << TIMER30_INTCR_CMIEN_Pos)                     /*!< TIMER30 INTCR: CMIEN Mask               */
#define TIMER30_INTCR_BMIEN_Pos               1                                                       /*!< TIMER30 INTCR: BMIEN Position           */
#define TIMER30_INTCR_BMIEN_Msk               (0x01UL << TIMER30_INTCR_BMIEN_Pos)                     /*!< TIMER30 INTCR: BMIEN Mask               */
#define TIMER30_INTCR_AMIEN_Pos               2                                                       /*!< TIMER30 INTCR: AMIEN Position           */
#define TIMER30_INTCR_AMIEN_Msk               (0x01UL << TIMER30_INTCR_AMIEN_Pos)                     /*!< TIMER30 INTCR: AMIEN Mask               */
#define TIMER30_INTCR_PMIEN_Pos               3                                                       /*!< TIMER30 INTCR: PMIEN Position           */
#define TIMER30_INTCR_PMIEN_Msk               (0x01UL << TIMER30_INTCR_PMIEN_Pos)                     /*!< TIMER30 INTCR: PMIEN Mask               */
#define TIMER30_INTCR_BTIEN_Pos               4                                                       /*!< TIMER30 INTCR: BTIEN Position           */
#define TIMER30_INTCR_BTIEN_Msk               (0x01UL << TIMER30_INTCR_BTIEN_Pos)                     /*!< TIMER30 INTCR: BTIEN Mask               */
#define TIMER30_INTCR_CIEN_Pos                5                                                       /*!< TIMER30 INTCR: CIEN Position            */
#define TIMER30_INTCR_CIEN_Msk                (0x01UL << TIMER30_INTCR_CIEN_Pos)                      /*!< TIMER30 INTCR: CIEN Mask                */
#define TIMER30_INTCR_HIZIEN_Pos              6                                                       /*!< TIMER30 INTCR: HIZIEN Position          */
#define TIMER30_INTCR_HIZIEN_Msk              (0x01UL << TIMER30_INTCR_HIZIEN_Pos)                    /*!< TIMER30 INTCR: HIZIEN Mask              */

/* -------------------------------  TIMER30_INTFLAG  ------------------------------ */
#define TIMER30_INTFLAG_CMIFLAG_Pos           0                                                       /*!< TIMER30 INTFLAG: CMIFLAG Position       */
#define TIMER30_INTFLAG_CMIFLAG_Msk           (0x01UL << TIMER30_INTFLAG_CMIFLAG_Pos)                 /*!< TIMER30 INTFLAG: CMIFLAG Mask           */
#define TIMER30_INTFLAG_BMIFLAG_Pos           1                                                       /*!< TIMER30 INTFLAG: BMIFLAG Position       */
#define TIMER30_INTFLAG_BMIFLAG_Msk           (0x01UL << TIMER30_INTFLAG_BMIFLAG_Pos)                 /*!< TIMER30 INTFLAG: BMIFLAG Mask           */
#define TIMER30_INTFLAG_AMIFLAG_Pos           2                                                       /*!< TIMER30 INTFLAG: AMIFLAG Position       */
#define TIMER30_INTFLAG_AMIFLAG_Msk           (0x01UL << TIMER30_INTFLAG_AMIFLAG_Pos)                 /*!< TIMER30 INTFLAG: AMIFLAG Mask           */
#define TIMER30_INTFLAG_PMIFLAG_Pos           3                                                       /*!< TIMER30 INTFLAG: PMIFLAG Position       */
#define TIMER30_INTFLAG_PMIFLAG_Msk           (0x01UL << TIMER30_INTFLAG_PMIFLAG_Pos)                 /*!< TIMER30 INTFLAG: PMIFLAG Mask           */
#define TIMER30_INTFLAG_BTIFLAG_Pos           4                                                       /*!< TIMER30 INTFLAG: BTIFLAG Position       */
#define TIMER30_INTFLAG_BTIFLAG_Msk           (0x01UL << TIMER30_INTFLAG_BTIFLAG_Pos)                 /*!< TIMER30 INTFLAG: BTIFLAG Mask           */
#define TIMER30_INTFLAG_CIFLAG_Pos            5                                                       /*!< TIMER30 INTFLAG: CIFLAG Position        */
#define TIMER30_INTFLAG_CIFLAG_Msk            (0x01UL << TIMER30_INTFLAG_CIFLAG_Pos)                  /*!< TIMER30 INTFLAG: CIFLAG Mask            */
#define TIMER30_INTFLAG_HIZIFLAG_Pos          6                                                       /*!< TIMER30 INTFLAG: HIZIFLAG Position      */
#define TIMER30_INTFLAG_HIZIFLAG_Msk          (0x01UL << TIMER30_INTFLAG_HIZIFLAG_Pos)                /*!< TIMER30 INTFLAG: HIZIFLAG Mask          */

/* --------------------------------  TIMER30_HIZCR  ------------------------------- */
#define TIMER30_HIZCR_HIZCLR_Pos              0                                                       /*!< TIMER30 HIZCR: HIZCLR Position          */
#define TIMER30_HIZCR_HIZCLR_Msk              (0x01UL << TIMER30_HIZCR_HIZCLR_Pos)                    /*!< TIMER30 HIZCR: HIZCLR Mask              */
#define TIMER30_HIZCR_HIZSTA_Pos              1                                                       /*!< TIMER30 HIZCR: HIZSTA Position          */
#define TIMER30_HIZCR_HIZSTA_Msk              (0x01UL << TIMER30_HIZCR_HIZSTA_Pos)                    /*!< TIMER30 HIZCR: HIZSTA Mask              */
#define TIMER30_HIZCR_HEDGE_Pos               2                                                       /*!< TIMER30 HIZCR: HEDGE Position           */
#define TIMER30_HIZCR_HEDGE_Msk               (0x01UL << TIMER30_HIZCR_HEDGE_Pos)                     /*!< TIMER30 HIZCR: HEDGE Mask               */
#define TIMER30_HIZCR_HIZSW_Pos               4                                                       /*!< TIMER30 HIZCR: HIZSW Position           */
#define TIMER30_HIZCR_HIZSW_Msk               (0x01UL << TIMER30_HIZCR_HIZSW_Pos)                     /*!< TIMER30 HIZCR: HIZSW Mask               */
#define TIMER30_HIZCR_HIZEN_Pos               7                                                       /*!< TIMER30 HIZCR: HIZEN Position           */
#define TIMER30_HIZCR_HIZEN_Msk               (0x01UL << TIMER30_HIZCR_HIZEN_Pos)                     /*!< TIMER30 HIZCR: HIZEN Mask               */

/* --------------------------------  TIMER30_ADTCR  ------------------------------- */
#define TIMER30_ADTCR_CMTG_Pos                0                                                       /*!< TIMER30 ADTCR: CMTG Position            */
#define TIMER30_ADTCR_CMTG_Msk                (0x01UL << TIMER30_ADTCR_CMTG_Pos)                      /*!< TIMER30 ADTCR: CMTG Mask                */
#define TIMER30_ADTCR_BMTG_Pos                1                                                       /*!< TIMER30 ADTCR: BMTG Position            */
#define TIMER30_ADTCR_BMTG_Msk                (0x01UL << TIMER30_ADTCR_BMTG_Pos)                      /*!< TIMER30 ADTCR: BMTG Mask                */
#define TIMER30_ADTCR_AMTG_Pos                2                                                       /*!< TIMER30 ADTCR: AMTG Position            */
#define TIMER30_ADTCR_AMTG_Msk                (0x01UL << TIMER30_ADTCR_AMTG_Pos)                      /*!< TIMER30 ADTCR: AMTG Mask                */
#define TIMER30_ADTCR_PMTG_Pos                3                                                       /*!< TIMER30 ADTCR: PMTG Position            */
#define TIMER30_ADTCR_PMTG_Msk                (0x01UL << TIMER30_ADTCR_PMTG_Pos)                      /*!< TIMER30 ADTCR: PMTG Mask                */
#define TIMER30_ADTCR_BTTG_Pos                4                                                       /*!< TIMER30 ADTCR: BTTG Position            */
#define TIMER30_ADTCR_BTTG_Msk                (0x01UL << TIMER30_ADTCR_BTTG_Pos)                      /*!< TIMER30 ADTCR: BTTG Mask                */

/* --------------------------------  TIMER30_ADTDR  ------------------------------- */
#define TIMER30_ADTDR_ADTDATA_Pos             0                                                       /*!< TIMER30 ADTDR: ADTDATA Position         */
#define TIMER30_ADTDR_ADTDATA_Msk             (0x00003fffUL << TIMER30_ADTDR_ADTDATA_Pos)             /*!< TIMER30 ADTDR: ADTDATA Mask             */


/* ================================================================================ */
/* ================          Group 'USART' Position & Mask         ================ */
/* ================================================================================ */


/* ----------------------------------  USART_CR1  --------------------------------- */
#define USART_CR1_RXE_Pos                     0                                                       /*!< USART CR1: RXE Position                 */
#define USART_CR1_RXE_Msk                     (0x01UL << USART_CR1_RXE_Pos)                           /*!< USART CR1: RXE Mask                     */
#define USART_CR1_TXE_Pos                     1                                                       /*!< USART CR1: TXE Position                 */
#define USART_CR1_TXE_Msk                     (0x01UL << USART_CR1_TXE_Pos)                           /*!< USART CR1: TXE Mask                     */
#define USART_CR1_RXCIE_Pos                   3                                                       /*!< USART CR1: RXCIE Position               */
#define USART_CR1_RXCIE_Msk                   (0x01UL << USART_CR1_RXCIE_Pos)                         /*!< USART CR1: RXCIE Mask                   */
#define USART_CR1_TXCIE_Pos                   4                                                       /*!< USART CR1: TXCIE Position               */
#define USART_CR1_TXCIE_Msk                   (0x01UL << USART_CR1_TXCIE_Pos)                         /*!< USART CR1: TXCIE Mask                   */
#define USART_CR1_DRIE_Pos                    5                                                       /*!< USART CR1: DRIE Position                */
#define USART_CR1_DRIE_Msk                    (0x01UL << USART_CR1_DRIE_Pos)                          /*!< USART CR1: DRIE Mask                    */
#define USART_CR1_CPHA_Pos                    6                                                       /*!< USART CR1: CPHA Position                */
#define USART_CR1_CPHA_Msk                    (0x01UL << USART_CR1_CPHA_Pos)                          /*!< USART CR1: CPHA Mask                    */
#define USART_CR1_CPOL_Pos                    7                                                       /*!< USART CR1: CPOL Position                */
#define USART_CR1_CPOL_Msk                    (0x01UL << USART_CR1_CPOL_Pos)                          /*!< USART CR1: CPOL Mask                    */
#define USART_CR1_ORD_Pos                     8                                                       /*!< USART CR1: ORD Position                 */
#define USART_CR1_ORD_Msk                     (0x01UL << USART_CR1_ORD_Pos)                           /*!< USART CR1: ORD Mask                     */
#define USART_CR1_DLEN_Pos                    9                                                       /*!< USART CR1: DLEN Position                */
#define USART_CR1_DLEN_Msk                    (0x07UL << USART_CR1_DLEN_Pos)                          /*!< USART CR1: DLEN Mask                    */
#define USART_CR1_PG_Pos                      12                                                      /*!< USART CR1: PG Position                  */
#define USART_CR1_PG_Msk                      (0x03UL << USART_CR1_PG_Pos)                            /*!< USART CR1: PG Mask                      */
#define USART_CR1_MS_Pos                      14                                                      /*!< USART CR1: MS Position                  */
#define USART_CR1_MS_Msk                      (0x03UL << USART_CR1_MS_Pos)                            /*!< USART CR1: MS Mask                      */

/* ----------------------------------  USART_CR2  --------------------------------- */
#define USART_CR2_RX8_Pos                     0                                                       /*!< USART CR2: RX8 Position                 */
#define USART_CR2_RX8_Msk                     (0x01UL << USART_CR2_RX8_Pos)                           /*!< USART CR2: RX8 Mask                     */
#define USART_CR2_TX8_Pos                     1                                                       /*!< USART CR2: TX8 Position                 */
#define USART_CR2_TX8_Msk                     (0x01UL << USART_CR2_TX8_Pos)                           /*!< USART CR2: TX8 Mask                     */
#define USART_CR2_SB_Pos                      2                                                       /*!< USART CR2: SB Position                  */
#define USART_CR2_SB_Msk                      (0x01UL << USART_CR2_SB_Pos)                            /*!< USART CR2: SB Mask                      */
#define USART_CR2_FXCH_Pos                    3                                                       /*!< USART CR2: FXCH Position                */
#define USART_CR2_FXCH_Msk                    (0x01UL << USART_CR2_FXCH_Pos)                          /*!< USART CR2: FXCH Mask                    */
#define USART_CR2_SSEN_Pos                    4                                                       /*!< USART CR2: SSEN Position                */
#define USART_CR2_SSEN_Msk                    (0x01UL << USART_CR2_SSEN_Pos)                          /*!< USART CR2: SSEN Mask                    */
#define USART_CR2_DISSCK_Pos                  5                                                       /*!< USART CR2: DISSCK Position              */
#define USART_CR2_DISSCK_Msk                  (0x01UL << USART_CR2_DISSCK_Pos)                        /*!< USART CR2: DISSCK Mask                  */
#define USART_CR2_LOOPS_Pos                   6                                                       /*!< USART CR2: LOOPS Position               */
#define USART_CR2_LOOPS_Msk                   (0x01UL << USART_CR2_LOOPS_Pos)                         /*!< USART CR2: LOOPS Mask                   */
#define USART_CR2_MASTER_Pos                  7                                                       /*!< USART CR2: MASTER Position              */
#define USART_CR2_MASTER_Msk                  (0x01UL << USART_CR2_MASTER_Pos)                        /*!< USART CR2: MASTER Mask                  */
#define USART_CR2_DBLS_Pos                    8                                                       /*!< USART CR2: DBLS Position                */
#define USART_CR2_DBLS_Msk                    (0x01UL << USART_CR2_DBLS_Pos)                          /*!< USART CR2: DBLS Mask                    */
#define USART_CR2_EN_Pos                      9                                                       /*!< USART CR2: EN Position                  */
#define USART_CR2_EN_Msk                      (0x01UL << USART_CR2_EN_Pos)                            /*!< USART CR2: EN Mask                      */
#define USART_CR2_BFREN_Pos                   10                                                      /*!< USART CR2: BFREN Position               */
#define USART_CR2_BFREN_Msk                   (0x01UL << USART_CR2_BFREN_Pos)                         /*!< USART CR2: BFREN Mask                   */
#define USART_CR2_RTOEN_Pos                   11                                                      /*!< USART CR2: RTOEN Position               */
#define USART_CR2_RTOEN_Msk                   (0x01UL << USART_CR2_RTOEN_Pos)                         /*!< USART CR2: RTOEN Mask                   */
#define USART_CR2_RTOIE_Pos                   12                                                      /*!< USART CR2: RTOIE Position               */
#define USART_CR2_RTOIE_Msk                   (0x01UL << USART_CR2_RTOIE_Pos)                         /*!< USART CR2: RTOIE Mask                   */
#define USART_CR2_DMARXIE_Pos                 13                                                      /*!< USART CR2: DMARXIE Position             */
#define USART_CR2_DMARXIE_Msk                 (0x01UL << USART_CR2_DMARXIE_Pos)                       /*!< USART CR2: DMARXIE Mask                 */
#define USART_CR2_DMATXIE_Pos                 14                                                      /*!< USART CR2: DMATXIE Position             */
#define USART_CR2_DMATXIE_Msk                 (0x01UL << USART_CR2_DMATXIE_Pos)                       /*!< USART CR2: DMATXIE Mask                 */

/* ----------------------------------  USART_ST  ---------------------------------- */
#define USART_ST_PE_Pos                       0                                                       /*!< USART ST: PE Position                   */
#define USART_ST_PE_Msk                       (0x01UL << USART_ST_PE_Pos)                             /*!< USART ST: PE Mask                       */
#define USART_ST_FE_Pos                       1                                                       /*!< USART ST: FE Position                   */
#define USART_ST_FE_Msk                       (0x01UL << USART_ST_FE_Pos)                             /*!< USART ST: FE Mask                       */
#define USART_ST_DOR_Pos                      2                                                       /*!< USART ST: DOR Position                  */
#define USART_ST_DOR_Msk                      (0x01UL << USART_ST_DOR_Pos)                            /*!< USART ST: DOR Mask                      */
#define USART_ST_RTOF_Pos                     3                                                       /*!< USART ST: RTOF Position                 */
#define USART_ST_RTOF_Msk                     (0x01UL << USART_ST_RTOF_Pos)                           /*!< USART ST: RTOF Mask                     */
#define USART_ST_RXC_Pos                      5                                                       /*!< USART ST: RXC Position                  */
#define USART_ST_RXC_Msk                      (0x01UL << USART_ST_RXC_Pos)                            /*!< USART ST: RXC Mask                      */
#define USART_ST_TXC_Pos                      6                                                       /*!< USART ST: TXC Position                  */
#define USART_ST_TXC_Msk                      (0x01UL << USART_ST_TXC_Pos)                            /*!< USART ST: TXC Mask                      */
#define USART_ST_DRE_Pos                      7                                                       /*!< USART ST: DRE Position                  */
#define USART_ST_DRE_Msk                      (0x01UL << USART_ST_DRE_Pos)                            /*!< USART ST: DRE Mask                      */
#define USART_ST_DMARXF_Pos                   8                                                       /*!< USART ST: DMARXF Position               */
#define USART_ST_DMARXF_Msk                   (0x01UL << USART_ST_DMARXF_Pos)                         /*!< USART ST: DMARXF Mask                   */
#define USART_ST_DMATXF_Pos                   9                                                       /*!< USART ST: DMATXF Position               */
#define USART_ST_DMATXF_Msk                   (0x01UL << USART_ST_DMATXF_Pos)                         /*!< USART ST: DMATXF Mask                   */

/* ----------------------------------  USART_BDR  --------------------------------- */
#define USART_BDR_BDATA_Pos                   0                                                       /*!< USART BDR: BDATA Position               */
#define USART_BDR_BDATA_Msk                   (0x00000fffUL << USART_BDR_BDATA_Pos)                   /*!< USART BDR: BDATA Mask                   */

/* ----------------------------------  USART_DR  ---------------------------------- */
#define USART_DR_DATA_Pos                     0                                                       /*!< USART DR: DATA Position                 */
#define USART_DR_DATA_Msk                     (0x000000ffUL << USART_DR_DATA_Pos)                     /*!< USART DR: DATA Mask                     */

/* ----------------------------------  USART_BFR  --------------------------------- */
#define USART_BFR_BFC_Pos                     0                                                       /*!< USART BFR: BFC Position                 */
#define USART_BFR_BFC_Msk                     (0x000000ffUL << USART_BFR_BFC_Pos)                     /*!< USART BFR: BFC Mask                     */

/* ----------------------------------  USART_RTO  --------------------------------- */
#define USART_RTO_RTO_Pos                     0                                                       /*!< USART RTO: RTO Position                 */
#define USART_RTO_RTO_Msk                     (0x00ffffffUL << USART_RTO_RTO_Pos)                     /*!< USART RTO: RTO Mask                     */


/* ================================================================================ */
/* ================        struct 'USART10' Position & Mask        ================ */
/* ================================================================================ */


/* ---------------------------------  USART10_CR1  -------------------------------- */
#define USART10_CR1_RXE_Pos                   0                                                       /*!< USART10 CR1: RXE Position               */
#define USART10_CR1_RXE_Msk                   (0x01UL << USART10_CR1_RXE_Pos)                         /*!< USART10 CR1: RXE Mask                   */
#define USART10_CR1_TXE_Pos                   1                                                       /*!< USART10 CR1: TXE Position               */
#define USART10_CR1_TXE_Msk                   (0x01UL << USART10_CR1_TXE_Pos)                         /*!< USART10 CR1: TXE Mask                   */
#define USART10_CR1_RXCIE_Pos                 3                                                       /*!< USART10 CR1: RXCIE Position             */
#define USART10_CR1_RXCIE_Msk                 (0x01UL << USART10_CR1_RXCIE_Pos)                       /*!< USART10 CR1: RXCIE Mask                 */
#define USART10_CR1_TXCIE_Pos                 4                                                       /*!< USART10 CR1: TXCIE Position             */
#define USART10_CR1_TXCIE_Msk                 (0x01UL << USART10_CR1_TXCIE_Pos)                       /*!< USART10 CR1: TXCIE Mask                 */
#define USART10_CR1_DRIE_Pos                  5                                                       /*!< USART10 CR1: DRIE Position              */
#define USART10_CR1_DRIE_Msk                  (0x01UL << USART10_CR1_DRIE_Pos)                        /*!< USART10 CR1: DRIE Mask                  */
#define USART10_CR1_CPHA_Pos                  6                                                       /*!< USART10 CR1: CPHA Position              */
#define USART10_CR1_CPHA_Msk                  (0x01UL << USART10_CR1_CPHA_Pos)                        /*!< USART10 CR1: CPHA Mask                  */
#define USART10_CR1_CPOL_Pos                  7                                                       /*!< USART10 CR1: CPOL Position              */
#define USART10_CR1_CPOL_Msk                  (0x01UL << USART10_CR1_CPOL_Pos)                        /*!< USART10 CR1: CPOL Mask                  */
#define USART10_CR1_ORD_Pos                   8                                                       /*!< USART10 CR1: ORD Position               */
#define USART10_CR1_ORD_Msk                   (0x01UL << USART10_CR1_ORD_Pos)                         /*!< USART10 CR1: ORD Mask                   */
#define USART10_CR1_DLEN_Pos                  9                                                       /*!< USART10 CR1: DLEN Position              */
#define USART10_CR1_DLEN_Msk                  (0x07UL << USART10_CR1_DLEN_Pos)                        /*!< USART10 CR1: DLEN Mask                  */
#define USART10_CR1_PG_Pos                    12                                                      /*!< USART10 CR1: PG Position                */
#define USART10_CR1_PG_Msk                    (0x03UL << USART10_CR1_PG_Pos)                          /*!< USART10 CR1: PG Mask                    */
#define USART10_CR1_MS_Pos                    14                                                      /*!< USART10 CR1: MS Position                */
#define USART10_CR1_MS_Msk                    (0x03UL << USART10_CR1_MS_Pos)                          /*!< USART10 CR1: MS Mask                    */

/* ---------------------------------  USART10_CR2  -------------------------------- */
#define USART10_CR2_RX8_Pos                   0                                                       /*!< USART10 CR2: RX8 Position               */
#define USART10_CR2_RX8_Msk                   (0x01UL << USART10_CR2_RX8_Pos)                         /*!< USART10 CR2: RX8 Mask                   */
#define USART10_CR2_TX8_Pos                   1                                                       /*!< USART10 CR2: TX8 Position               */
#define USART10_CR2_TX8_Msk                   (0x01UL << USART10_CR2_TX8_Pos)                         /*!< USART10 CR2: TX8 Mask                   */
#define USART10_CR2_SB_Pos                    2                                                       /*!< USART10 CR2: SB Position                */
#define USART10_CR2_SB_Msk                    (0x01UL << USART10_CR2_SB_Pos)                          /*!< USART10 CR2: SB Mask                    */
#define USART10_CR2_FXCH_Pos                  3                                                       /*!< USART10 CR2: FXCH Position              */
#define USART10_CR2_FXCH_Msk                  (0x01UL << USART10_CR2_FXCH_Pos)                        /*!< USART10 CR2: FXCH Mask                  */
#define USART10_CR2_SSEN_Pos                  4                                                       /*!< USART10 CR2: SSEN Position              */
#define USART10_CR2_SSEN_Msk                  (0x01UL << USART10_CR2_SSEN_Pos)                        /*!< USART10 CR2: SSEN Mask                  */
#define USART10_CR2_DISSCK_Pos                5                                                       /*!< USART10 CR2: DISSCK Position            */
#define USART10_CR2_DISSCK_Msk                (0x01UL << USART10_CR2_DISSCK_Pos)                      /*!< USART10 CR2: DISSCK Mask                */
#define USART10_CR2_LOOPS_Pos                 6                                                       /*!< USART10 CR2: LOOPS Position             */
#define USART10_CR2_LOOPS_Msk                 (0x01UL << USART10_CR2_LOOPS_Pos)                       /*!< USART10 CR2: LOOPS Mask                 */
#define USART10_CR2_MASTER_Pos                7                                                       /*!< USART10 CR2: MASTER Position            */
#define USART10_CR2_MASTER_Msk                (0x01UL << USART10_CR2_MASTER_Pos)                      /*!< USART10 CR2: MASTER Mask                */
#define USART10_CR2_DBLS_Pos                  8                                                       /*!< USART10 CR2: DBLS Position              */
#define USART10_CR2_DBLS_Msk                  (0x01UL << USART10_CR2_DBLS_Pos)                        /*!< USART10 CR2: DBLS Mask                  */
#define USART10_CR2_EN_Pos                    9                                                       /*!< USART10 CR2: EN Position                */
#define USART10_CR2_EN_Msk                    (0x01UL << USART10_CR2_EN_Pos)                          /*!< USART10 CR2: EN Mask                    */
#define USART10_CR2_BFREN_Pos                 10                                                      /*!< USART10 CR2: BFREN Position             */
#define USART10_CR2_BFREN_Msk                 (0x01UL << USART10_CR2_BFREN_Pos)                       /*!< USART10 CR2: BFREN Mask                 */
#define USART10_CR2_RTOEN_Pos                 11                                                      /*!< USART10 CR2: RTOEN Position             */
#define USART10_CR2_RTOEN_Msk                 (0x01UL << USART10_CR2_RTOEN_Pos)                       /*!< USART10 CR2: RTOEN Mask                 */
#define USART10_CR2_RTOIE_Pos                 12                                                      /*!< USART10 CR2: RTOIE Position             */
#define USART10_CR2_RTOIE_Msk                 (0x01UL << USART10_CR2_RTOIE_Pos)                       /*!< USART10 CR2: RTOIE Mask                 */
#define USART10_CR2_DMARXIE_Pos               13                                                      /*!< USART10 CR2: DMARXIE Position           */
#define USART10_CR2_DMARXIE_Msk               (0x01UL << USART10_CR2_DMARXIE_Pos)                     /*!< USART10 CR2: DMARXIE Mask               */
#define USART10_CR2_DMATXIE_Pos               14                                                      /*!< USART10 CR2: DMATXIE Position           */
#define USART10_CR2_DMATXIE_Msk               (0x01UL << USART10_CR2_DMATXIE_Pos)                     /*!< USART10 CR2: DMATXIE Mask               */

/* ---------------------------------  USART10_ST  --------------------------------- */
#define USART10_ST_PE_Pos                     0                                                       /*!< USART10 ST: PE Position                 */
#define USART10_ST_PE_Msk                     (0x01UL << USART10_ST_PE_Pos)                           /*!< USART10 ST: PE Mask                     */
#define USART10_ST_FE_Pos                     1                                                       /*!< USART10 ST: FE Position                 */
#define USART10_ST_FE_Msk                     (0x01UL << USART10_ST_FE_Pos)                           /*!< USART10 ST: FE Mask                     */
#define USART10_ST_DOR_Pos                    2                                                       /*!< USART10 ST: DOR Position                */
#define USART10_ST_DOR_Msk                    (0x01UL << USART10_ST_DOR_Pos)                          /*!< USART10 ST: DOR Mask                    */
#define USART10_ST_RTOF_Pos                   3                                                       /*!< USART10 ST: RTOF Position               */
#define USART10_ST_RTOF_Msk                   (0x01UL << USART10_ST_RTOF_Pos)                         /*!< USART10 ST: RTOF Mask                   */
#define USART10_ST_RXC_Pos                    5                                                       /*!< USART10 ST: RXC Position                */
#define USART10_ST_RXC_Msk                    (0x01UL << USART10_ST_RXC_Pos)                          /*!< USART10 ST: RXC Mask                    */
#define USART10_ST_TXC_Pos                    6                                                       /*!< USART10 ST: TXC Position                */
#define USART10_ST_TXC_Msk                    (0x01UL << USART10_ST_TXC_Pos)                          /*!< USART10 ST: TXC Mask                    */
#define USART10_ST_DRE_Pos                    7                                                       /*!< USART10 ST: DRE Position                */
#define USART10_ST_DRE_Msk                    (0x01UL << USART10_ST_DRE_Pos)                          /*!< USART10 ST: DRE Mask                    */
#define USART10_ST_DMARXF_Pos                 8                                                       /*!< USART10 ST: DMARXF Position             */
#define USART10_ST_DMARXF_Msk                 (0x01UL << USART10_ST_DMARXF_Pos)                       /*!< USART10 ST: DMARXF Mask                 */
#define USART10_ST_DMATXF_Pos                 9                                                       /*!< USART10 ST: DMATXF Position             */
#define USART10_ST_DMATXF_Msk                 (0x01UL << USART10_ST_DMATXF_Pos)                       /*!< USART10 ST: DMATXF Mask                 */

/* ---------------------------------  USART10_BDR  -------------------------------- */
#define USART10_BDR_BDATA_Pos                 0                                                       /*!< USART10 BDR: BDATA Position             */
#define USART10_BDR_BDATA_Msk                 (0x00000fffUL << USART10_BDR_BDATA_Pos)                 /*!< USART10 BDR: BDATA Mask                 */

/* ---------------------------------  USART10_DR  --------------------------------- */
#define USART10_DR_DATA_Pos                   0                                                       /*!< USART10 DR: DATA Position               */
#define USART10_DR_DATA_Msk                   (0x000000ffUL << USART10_DR_DATA_Pos)                   /*!< USART10 DR: DATA Mask                   */

/* ---------------------------------  USART10_BFR  -------------------------------- */
#define USART10_BFR_BFC_Pos                   0                                                       /*!< USART10 BFR: BFC Position               */
#define USART10_BFR_BFC_Msk                   (0x000000ffUL << USART10_BFR_BFC_Pos)                   /*!< USART10 BFR: BFC Mask                   */

/* ---------------------------------  USART10_RTO  -------------------------------- */
#define USART10_RTO_RTO_Pos                   0                                                       /*!< USART10 RTO: RTO Position               */
#define USART10_RTO_RTO_Msk                   (0x00ffffffUL << USART10_RTO_RTO_Pos)                   /*!< USART10 RTO: RTO Mask                   */


/* ================================================================================ */
/* ================        struct 'USART11' Position & Mask        ================ */
/* ================================================================================ */


/* ---------------------------------  USART11_CR1  -------------------------------- */
#define USART11_CR1_RXE_Pos                   0                                                       /*!< USART11 CR1: RXE Position               */
#define USART11_CR1_RXE_Msk                   (0x01UL << USART11_CR1_RXE_Pos)                         /*!< USART11 CR1: RXE Mask                   */
#define USART11_CR1_TXE_Pos                   1                                                       /*!< USART11 CR1: TXE Position               */
#define USART11_CR1_TXE_Msk                   (0x01UL << USART11_CR1_TXE_Pos)                         /*!< USART11 CR1: TXE Mask                   */
#define USART11_CR1_RXCIE_Pos                 3                                                       /*!< USART11 CR1: RXCIE Position             */
#define USART11_CR1_RXCIE_Msk                 (0x01UL << USART11_CR1_RXCIE_Pos)                       /*!< USART11 CR1: RXCIE Mask                 */
#define USART11_CR1_TXCIE_Pos                 4                                                       /*!< USART11 CR1: TXCIE Position             */
#define USART11_CR1_TXCIE_Msk                 (0x01UL << USART11_CR1_TXCIE_Pos)                       /*!< USART11 CR1: TXCIE Mask                 */
#define USART11_CR1_DRIE_Pos                  5                                                       /*!< USART11 CR1: DRIE Position              */
#define USART11_CR1_DRIE_Msk                  (0x01UL << USART11_CR1_DRIE_Pos)                        /*!< USART11 CR1: DRIE Mask                  */
#define USART11_CR1_CPHA_Pos                  6                                                       /*!< USART11 CR1: CPHA Position              */
#define USART11_CR1_CPHA_Msk                  (0x01UL << USART11_CR1_CPHA_Pos)                        /*!< USART11 CR1: CPHA Mask                  */
#define USART11_CR1_CPOL_Pos                  7                                                       /*!< USART11 CR1: CPOL Position              */
#define USART11_CR1_CPOL_Msk                  (0x01UL << USART11_CR1_CPOL_Pos)                        /*!< USART11 CR1: CPOL Mask                  */
#define USART11_CR1_ORD_Pos                   8                                                       /*!< USART11 CR1: ORD Position               */
#define USART11_CR1_ORD_Msk                   (0x01UL << USART11_CR1_ORD_Pos)                         /*!< USART11 CR1: ORD Mask                   */
#define USART11_CR1_DLEN_Pos                  9                                                       /*!< USART11 CR1: DLEN Position              */
#define USART11_CR1_DLEN_Msk                  (0x07UL << USART11_CR1_DLEN_Pos)                        /*!< USART11 CR1: DLEN Mask                  */
#define USART11_CR1_PG_Pos                    12                                                      /*!< USART11 CR1: PG Position                */
#define USART11_CR1_PG_Msk                    (0x03UL << USART11_CR1_PG_Pos)                          /*!< USART11 CR1: PG Mask                    */
#define USART11_CR1_MS_Pos                    14                                                      /*!< USART11 CR1: MS Position                */
#define USART11_CR1_MS_Msk                    (0x03UL << USART11_CR1_MS_Pos)                          /*!< USART11 CR1: MS Mask                    */

/* ---------------------------------  USART11_CR2  -------------------------------- */
#define USART11_CR2_RX8_Pos                   0                                                       /*!< USART11 CR2: RX8 Position               */
#define USART11_CR2_RX8_Msk                   (0x01UL << USART11_CR2_RX8_Pos)                         /*!< USART11 CR2: RX8 Mask                   */
#define USART11_CR2_TX8_Pos                   1                                                       /*!< USART11 CR2: TX8 Position               */
#define USART11_CR2_TX8_Msk                   (0x01UL << USART11_CR2_TX8_Pos)                         /*!< USART11 CR2: TX8 Mask                   */
#define USART11_CR2_SB_Pos                    2                                                       /*!< USART11 CR2: SB Position                */
#define USART11_CR2_SB_Msk                    (0x01UL << USART11_CR2_SB_Pos)                          /*!< USART11 CR2: SB Mask                    */
#define USART11_CR2_FXCH_Pos                  3                                                       /*!< USART11 CR2: FXCH Position              */
#define USART11_CR2_FXCH_Msk                  (0x01UL << USART11_CR2_FXCH_Pos)                        /*!< USART11 CR2: FXCH Mask                  */
#define USART11_CR2_SSEN_Pos                  4                                                       /*!< USART11 CR2: SSEN Position              */
#define USART11_CR2_SSEN_Msk                  (0x01UL << USART11_CR2_SSEN_Pos)                        /*!< USART11 CR2: SSEN Mask                  */
#define USART11_CR2_DISSCK_Pos                5                                                       /*!< USART11 CR2: DISSCK Position            */
#define USART11_CR2_DISSCK_Msk                (0x01UL << USART11_CR2_DISSCK_Pos)                      /*!< USART11 CR2: DISSCK Mask                */
#define USART11_CR2_LOOPS_Pos                 6                                                       /*!< USART11 CR2: LOOPS Position             */
#define USART11_CR2_LOOPS_Msk                 (0x01UL << USART11_CR2_LOOPS_Pos)                       /*!< USART11 CR2: LOOPS Mask                 */
#define USART11_CR2_MASTER_Pos                7                                                       /*!< USART11 CR2: MASTER Position            */
#define USART11_CR2_MASTER_Msk                (0x01UL << USART11_CR2_MASTER_Pos)                      /*!< USART11 CR2: MASTER Mask                */
#define USART11_CR2_DBLS_Pos                  8                                                       /*!< USART11 CR2: DBLS Position              */
#define USART11_CR2_DBLS_Msk                  (0x01UL << USART11_CR2_DBLS_Pos)                        /*!< USART11 CR2: DBLS Mask                  */
#define USART11_CR2_EN_Pos                    9                                                       /*!< USART11 CR2: EN Position                */
#define USART11_CR2_EN_Msk                    (0x01UL << USART11_CR2_EN_Pos)                          /*!< USART11 CR2: EN Mask                    */
#define USART11_CR2_BFREN_Pos                 10                                                      /*!< USART11 CR2: BFREN Position             */
#define USART11_CR2_BFREN_Msk                 (0x01UL << USART11_CR2_BFREN_Pos)                       /*!< USART11 CR2: BFREN Mask                 */
#define USART11_CR2_RTOEN_Pos                 11                                                      /*!< USART11 CR2: RTOEN Position             */
#define USART11_CR2_RTOEN_Msk                 (0x01UL << USART11_CR2_RTOEN_Pos)                       /*!< USART11 CR2: RTOEN Mask                 */
#define USART11_CR2_RTOIE_Pos                 12                                                      /*!< USART11 CR2: RTOIE Position             */
#define USART11_CR2_RTOIE_Msk                 (0x01UL << USART11_CR2_RTOIE_Pos)                       /*!< USART11 CR2: RTOIE Mask                 */
#define USART11_CR2_DMARXIE_Pos               13                                                      /*!< USART11 CR2: DMARXIE Position           */
#define USART11_CR2_DMARXIE_Msk               (0x01UL << USART11_CR2_DMARXIE_Pos)                     /*!< USART11 CR2: DMARXIE Mask               */
#define USART11_CR2_DMATXIE_Pos               14                                                      /*!< USART11 CR2: DMATXIE Position           */
#define USART11_CR2_DMATXIE_Msk               (0x01UL << USART11_CR2_DMATXIE_Pos)                     /*!< USART11 CR2: DMATXIE Mask               */

/* ---------------------------------  USART11_ST  --------------------------------- */
#define USART11_ST_PE_Pos                     0                                                       /*!< USART11 ST: PE Position                 */
#define USART11_ST_PE_Msk                     (0x01UL << USART11_ST_PE_Pos)                           /*!< USART11 ST: PE Mask                     */
#define USART11_ST_FE_Pos                     1                                                       /*!< USART11 ST: FE Position                 */
#define USART11_ST_FE_Msk                     (0x01UL << USART11_ST_FE_Pos)                           /*!< USART11 ST: FE Mask                     */
#define USART11_ST_DOR_Pos                    2                                                       /*!< USART11 ST: DOR Position                */
#define USART11_ST_DOR_Msk                    (0x01UL << USART11_ST_DOR_Pos)                          /*!< USART11 ST: DOR Mask                    */
#define USART11_ST_RTOF_Pos                   3                                                       /*!< USART11 ST: RTOF Position               */
#define USART11_ST_RTOF_Msk                   (0x01UL << USART11_ST_RTOF_Pos)                         /*!< USART11 ST: RTOF Mask                   */
#define USART11_ST_RXC_Pos                    5                                                       /*!< USART11 ST: RXC Position                */
#define USART11_ST_RXC_Msk                    (0x01UL << USART11_ST_RXC_Pos)                          /*!< USART11 ST: RXC Mask                    */
#define USART11_ST_TXC_Pos                    6                                                       /*!< USART11 ST: TXC Position                */
#define USART11_ST_TXC_Msk                    (0x01UL << USART11_ST_TXC_Pos)                          /*!< USART11 ST: TXC Mask                    */
#define USART11_ST_DRE_Pos                    7                                                       /*!< USART11 ST: DRE Position                */
#define USART11_ST_DRE_Msk                    (0x01UL << USART11_ST_DRE_Pos)                          /*!< USART11 ST: DRE Mask                    */
#define USART11_ST_DMARXF_Pos                 8                                                       /*!< USART11 ST: DMARXF Position             */
#define USART11_ST_DMARXF_Msk                 (0x01UL << USART11_ST_DMARXF_Pos)                       /*!< USART11 ST: DMARXF Mask                 */
#define USART11_ST_DMATXF_Pos                 9                                                       /*!< USART11 ST: DMATXF Position             */
#define USART11_ST_DMATXF_Msk                 (0x01UL << USART11_ST_DMATXF_Pos)                       /*!< USART11 ST: DMATXF Mask                 */

/* ---------------------------------  USART11_BDR  -------------------------------- */
#define USART11_BDR_BDATA_Pos                 0                                                       /*!< USART11 BDR: BDATA Position             */
#define USART11_BDR_BDATA_Msk                 (0x00000fffUL << USART11_BDR_BDATA_Pos)                 /*!< USART11 BDR: BDATA Mask                 */

/* ---------------------------------  USART11_DR  --------------------------------- */
#define USART11_DR_DATA_Pos                   0                                                       /*!< USART11 DR: DATA Position               */
#define USART11_DR_DATA_Msk                   (0x000000ffUL << USART11_DR_DATA_Pos)                   /*!< USART11 DR: DATA Mask                   */

/* ---------------------------------  USART11_BFR  -------------------------------- */
#define USART11_BFR_BFC_Pos                   0                                                       /*!< USART11 BFR: BFC Position               */
#define USART11_BFR_BFC_Msk                   (0x000000ffUL << USART11_BFR_BFC_Pos)                   /*!< USART11 BFR: BFC Mask                   */

/* ---------------------------------  USART11_RTO  -------------------------------- */
#define USART11_RTO_RTO_Pos                   0                                                       /*!< USART11 RTO: RTO Position               */
#define USART11_RTO_RTO_Msk                   (0x00ffffffUL << USART11_RTO_RTO_Pos)                   /*!< USART11 RTO: RTO Mask                   */


/* ================================================================================ */
/* ================        struct 'USART12' Position & Mask        ================ */
/* ================================================================================ */


/* ---------------------------------  USART12_CR1  -------------------------------- */
#define USART12_CR1_RXE_Pos                   0                                                       /*!< USART12 CR1: RXE Position               */
#define USART12_CR1_RXE_Msk                   (0x01UL << USART12_CR1_RXE_Pos)                         /*!< USART12 CR1: RXE Mask                   */
#define USART12_CR1_TXE_Pos                   1                                                       /*!< USART12 CR1: TXE Position               */
#define USART12_CR1_TXE_Msk                   (0x01UL << USART12_CR1_TXE_Pos)                         /*!< USART12 CR1: TXE Mask                   */
#define USART12_CR1_RXCIE_Pos                 3                                                       /*!< USART12 CR1: RXCIE Position             */
#define USART12_CR1_RXCIE_Msk                 (0x01UL << USART12_CR1_RXCIE_Pos)                       /*!< USART12 CR1: RXCIE Mask                 */
#define USART12_CR1_TXCIE_Pos                 4                                                       /*!< USART12 CR1: TXCIE Position             */
#define USART12_CR1_TXCIE_Msk                 (0x01UL << USART12_CR1_TXCIE_Pos)                       /*!< USART12 CR1: TXCIE Mask                 */
#define USART12_CR1_DRIE_Pos                  5                                                       /*!< USART12 CR1: DRIE Position              */
#define USART12_CR1_DRIE_Msk                  (0x01UL << USART12_CR1_DRIE_Pos)                        /*!< USART12 CR1: DRIE Mask                  */
#define USART12_CR1_CPHA_Pos                  6                                                       /*!< USART12 CR1: CPHA Position              */
#define USART12_CR1_CPHA_Msk                  (0x01UL << USART12_CR1_CPHA_Pos)                        /*!< USART12 CR1: CPHA Mask                  */
#define USART12_CR1_CPOL_Pos                  7                                                       /*!< USART12 CR1: CPOL Position              */
#define USART12_CR1_CPOL_Msk                  (0x01UL << USART12_CR1_CPOL_Pos)                        /*!< USART12 CR1: CPOL Mask                  */
#define USART12_CR1_ORD_Pos                   8                                                       /*!< USART12 CR1: ORD Position               */
#define USART12_CR1_ORD_Msk                   (0x01UL << USART12_CR1_ORD_Pos)                         /*!< USART12 CR1: ORD Mask                   */
#define USART12_CR1_DLEN_Pos                  9                                                       /*!< USART12 CR1: DLEN Position              */
#define USART12_CR1_DLEN_Msk                  (0x07UL << USART12_CR1_DLEN_Pos)                        /*!< USART12 CR1: DLEN Mask                  */
#define USART12_CR1_PG_Pos                    12                                                      /*!< USART12 CR1: PG Position                */
#define USART12_CR1_PG_Msk                    (0x03UL << USART12_CR1_PG_Pos)                          /*!< USART12 CR1: PG Mask                    */
#define USART12_CR1_MS_Pos                    14                                                      /*!< USART12 CR1: MS Position                */
#define USART12_CR1_MS_Msk                    (0x03UL << USART12_CR1_MS_Pos)                          /*!< USART12 CR1: MS Mask                    */

/* ---------------------------------  USART12_CR2  -------------------------------- */
#define USART12_CR2_RX8_Pos                   0                                                       /*!< USART12 CR2: RX8 Position               */
#define USART12_CR2_RX8_Msk                   (0x01UL << USART12_CR2_RX8_Pos)                         /*!< USART12 CR2: RX8 Mask                   */
#define USART12_CR2_TX8_Pos                   1                                                       /*!< USART12 CR2: TX8 Position               */
#define USART12_CR2_TX8_Msk                   (0x01UL << USART12_CR2_TX8_Pos)                         /*!< USART12 CR2: TX8 Mask                   */
#define USART12_CR2_SB_Pos                    2                                                       /*!< USART12 CR2: SB Position                */
#define USART12_CR2_SB_Msk                    (0x01UL << USART12_CR2_SB_Pos)                          /*!< USART12 CR2: SB Mask                    */
#define USART12_CR2_FXCH_Pos                  3                                                       /*!< USART12 CR2: FXCH Position              */
#define USART12_CR2_FXCH_Msk                  (0x01UL << USART12_CR2_FXCH_Pos)                        /*!< USART12 CR2: FXCH Mask                  */
#define USART12_CR2_SSEN_Pos                  4                                                       /*!< USART12 CR2: SSEN Position              */
#define USART12_CR2_SSEN_Msk                  (0x01UL << USART12_CR2_SSEN_Pos)                        /*!< USART12 CR2: SSEN Mask                  */
#define USART12_CR2_DISSCK_Pos                5                                                       /*!< USART12 CR2: DISSCK Position            */
#define USART12_CR2_DISSCK_Msk                (0x01UL << USART12_CR2_DISSCK_Pos)                      /*!< USART12 CR2: DISSCK Mask                */
#define USART12_CR2_LOOPS_Pos                 6                                                       /*!< USART12 CR2: LOOPS Position             */
#define USART12_CR2_LOOPS_Msk                 (0x01UL << USART12_CR2_LOOPS_Pos)                       /*!< USART12 CR2: LOOPS Mask                 */
#define USART12_CR2_MASTER_Pos                7                                                       /*!< USART12 CR2: MASTER Position            */
#define USART12_CR2_MASTER_Msk                (0x01UL << USART12_CR2_MASTER_Pos)                      /*!< USART12 CR2: MASTER Mask                */
#define USART12_CR2_DBLS_Pos                  8                                                       /*!< USART12 CR2: DBLS Position              */
#define USART12_CR2_DBLS_Msk                  (0x01UL << USART12_CR2_DBLS_Pos)                        /*!< USART12 CR2: DBLS Mask                  */
#define USART12_CR2_EN_Pos                    9                                                       /*!< USART12 CR2: EN Position                */
#define USART12_CR2_EN_Msk                    (0x01UL << USART12_CR2_EN_Pos)                          /*!< USART12 CR2: EN Mask                    */
#define USART12_CR2_BFREN_Pos                 10                                                      /*!< USART12 CR2: BFREN Position             */
#define USART12_CR2_BFREN_Msk                 (0x01UL << USART12_CR2_BFREN_Pos)                       /*!< USART12 CR2: BFREN Mask                 */
#define USART12_CR2_RTOEN_Pos                 11                                                      /*!< USART12 CR2: RTOEN Position             */
#define USART12_CR2_RTOEN_Msk                 (0x01UL << USART12_CR2_RTOEN_Pos)                       /*!< USART12 CR2: RTOEN Mask                 */
#define USART12_CR2_RTOIE_Pos                 12                                                      /*!< USART12 CR2: RTOIE Position             */
#define USART12_CR2_RTOIE_Msk                 (0x01UL << USART12_CR2_RTOIE_Pos)                       /*!< USART12 CR2: RTOIE Mask                 */
#define USART12_CR2_DMARXIE_Pos               13                                                      /*!< USART12 CR2: DMARXIE Position           */
#define USART12_CR2_DMARXIE_Msk               (0x01UL << USART12_CR2_DMARXIE_Pos)                     /*!< USART12 CR2: DMARXIE Mask               */
#define USART12_CR2_DMATXIE_Pos               14                                                      /*!< USART12 CR2: DMATXIE Position           */
#define USART12_CR2_DMATXIE_Msk               (0x01UL << USART12_CR2_DMATXIE_Pos)                     /*!< USART12 CR2: DMATXIE Mask               */

/* ---------------------------------  USART12_ST  --------------------------------- */
#define USART12_ST_PE_Pos                     0                                                       /*!< USART12 ST: PE Position                 */
#define USART12_ST_PE_Msk                     (0x01UL << USART12_ST_PE_Pos)                           /*!< USART12 ST: PE Mask                     */
#define USART12_ST_FE_Pos                     1                                                       /*!< USART12 ST: FE Position                 */
#define USART12_ST_FE_Msk                     (0x01UL << USART12_ST_FE_Pos)                           /*!< USART12 ST: FE Mask                     */
#define USART12_ST_DOR_Pos                    2                                                       /*!< USART12 ST: DOR Position                */
#define USART12_ST_DOR_Msk                    (0x01UL << USART12_ST_DOR_Pos)                          /*!< USART12 ST: DOR Mask                    */
#define USART12_ST_RTOF_Pos                   3                                                       /*!< USART12 ST: RTOF Position               */
#define USART12_ST_RTOF_Msk                   (0x01UL << USART12_ST_RTOF_Pos)                         /*!< USART12 ST: RTOF Mask                   */
#define USART12_ST_RXC_Pos                    5                                                       /*!< USART12 ST: RXC Position                */
#define USART12_ST_RXC_Msk                    (0x01UL << USART12_ST_RXC_Pos)                          /*!< USART12 ST: RXC Mask                    */
#define USART12_ST_TXC_Pos                    6                                                       /*!< USART12 ST: TXC Position                */
#define USART12_ST_TXC_Msk                    (0x01UL << USART12_ST_TXC_Pos)                          /*!< USART12 ST: TXC Mask                    */
#define USART12_ST_DRE_Pos                    7                                                       /*!< USART12 ST: DRE Position                */
#define USART12_ST_DRE_Msk                    (0x01UL << USART12_ST_DRE_Pos)                          /*!< USART12 ST: DRE Mask                    */
#define USART12_ST_DMARXF_Pos                 8                                                       /*!< USART12 ST: DMARXF Position             */
#define USART12_ST_DMARXF_Msk                 (0x01UL << USART12_ST_DMARXF_Pos)                       /*!< USART12 ST: DMARXF Mask                 */
#define USART12_ST_DMATXF_Pos                 9                                                       /*!< USART12 ST: DMATXF Position             */
#define USART12_ST_DMATXF_Msk                 (0x01UL << USART12_ST_DMATXF_Pos)                       /*!< USART12 ST: DMATXF Mask                 */

/* ---------------------------------  USART12_BDR  -------------------------------- */
#define USART12_BDR_BDATA_Pos                 0                                                       /*!< USART12 BDR: BDATA Position             */
#define USART12_BDR_BDATA_Msk                 (0x00000fffUL << USART12_BDR_BDATA_Pos)                 /*!< USART12 BDR: BDATA Mask                 */

/* ---------------------------------  USART12_DR  --------------------------------- */
#define USART12_DR_DATA_Pos                   0                                                       /*!< USART12 DR: DATA Position               */
#define USART12_DR_DATA_Msk                   (0x000000ffUL << USART12_DR_DATA_Pos)                   /*!< USART12 DR: DATA Mask                   */

/* ---------------------------------  USART12_BFR  -------------------------------- */
#define USART12_BFR_BFC_Pos                   0                                                       /*!< USART12 BFR: BFC Position               */
#define USART12_BFR_BFC_Msk                   (0x000000ffUL << USART12_BFR_BFC_Pos)                   /*!< USART12 BFR: BFC Mask                   */

/* ---------------------------------  USART12_RTO  -------------------------------- */
#define USART12_RTO_RTO_Pos                   0                                                       /*!< USART12 RTO: RTO Position               */
#define USART12_RTO_RTO_Msk                   (0x00ffffffUL << USART12_RTO_RTO_Pos)                   /*!< USART12 RTO: RTO Mask                   */


/* ================================================================================ */
/* ================        struct 'USART13' Position & Mask        ================ */
/* ================================================================================ */


/* ---------------------------------  USART13_CR1  -------------------------------- */
#define USART13_CR1_RXE_Pos                   0                                                       /*!< USART13 CR1: RXE Position               */
#define USART13_CR1_RXE_Msk                   (0x01UL << USART13_CR1_RXE_Pos)                         /*!< USART13 CR1: RXE Mask                   */
#define USART13_CR1_TXE_Pos                   1                                                       /*!< USART13 CR1: TXE Position               */
#define USART13_CR1_TXE_Msk                   (0x01UL << USART13_CR1_TXE_Pos)                         /*!< USART13 CR1: TXE Mask                   */
#define USART13_CR1_RXCIE_Pos                 3                                                       /*!< USART13 CR1: RXCIE Position             */
#define USART13_CR1_RXCIE_Msk                 (0x01UL << USART13_CR1_RXCIE_Pos)                       /*!< USART13 CR1: RXCIE Mask                 */
#define USART13_CR1_TXCIE_Pos                 4                                                       /*!< USART13 CR1: TXCIE Position             */
#define USART13_CR1_TXCIE_Msk                 (0x01UL << USART13_CR1_TXCIE_Pos)                       /*!< USART13 CR1: TXCIE Mask                 */
#define USART13_CR1_DRIE_Pos                  5                                                       /*!< USART13 CR1: DRIE Position              */
#define USART13_CR1_DRIE_Msk                  (0x01UL << USART13_CR1_DRIE_Pos)                        /*!< USART13 CR1: DRIE Mask                  */
#define USART13_CR1_CPHA_Pos                  6                                                       /*!< USART13 CR1: CPHA Position              */
#define USART13_CR1_CPHA_Msk                  (0x01UL << USART13_CR1_CPHA_Pos)                        /*!< USART13 CR1: CPHA Mask                  */
#define USART13_CR1_CPOL_Pos                  7                                                       /*!< USART13 CR1: CPOL Position              */
#define USART13_CR1_CPOL_Msk                  (0x01UL << USART13_CR1_CPOL_Pos)                        /*!< USART13 CR1: CPOL Mask                  */
#define USART13_CR1_ORD_Pos                   8                                                       /*!< USART13 CR1: ORD Position               */
#define USART13_CR1_ORD_Msk                   (0x01UL << USART13_CR1_ORD_Pos)                         /*!< USART13 CR1: ORD Mask                   */
#define USART13_CR1_DLEN_Pos                  9                                                       /*!< USART13 CR1: DLEN Position              */
#define USART13_CR1_DLEN_Msk                  (0x07UL << USART13_CR1_DLEN_Pos)                        /*!< USART13 CR1: DLEN Mask                  */
#define USART13_CR1_PG_Pos                    12                                                      /*!< USART13 CR1: PG Position                */
#define USART13_CR1_PG_Msk                    (0x03UL << USART13_CR1_PG_Pos)                          /*!< USART13 CR1: PG Mask                    */
#define USART13_CR1_MS_Pos                    14                                                      /*!< USART13 CR1: MS Position                */
#define USART13_CR1_MS_Msk                    (0x03UL << USART13_CR1_MS_Pos)                          /*!< USART13 CR1: MS Mask                    */

/* ---------------------------------  USART13_CR2  -------------------------------- */
#define USART13_CR2_RX8_Pos                   0                                                       /*!< USART13 CR2: RX8 Position               */
#define USART13_CR2_RX8_Msk                   (0x01UL << USART13_CR2_RX8_Pos)                         /*!< USART13 CR2: RX8 Mask                   */
#define USART13_CR2_TX8_Pos                   1                                                       /*!< USART13 CR2: TX8 Position               */
#define USART13_CR2_TX8_Msk                   (0x01UL << USART13_CR2_TX8_Pos)                         /*!< USART13 CR2: TX8 Mask                   */
#define USART13_CR2_SB_Pos                    2                                                       /*!< USART13 CR2: SB Position                */
#define USART13_CR2_SB_Msk                    (0x01UL << USART13_CR2_SB_Pos)                          /*!< USART13 CR2: SB Mask                    */
#define USART13_CR2_FXCH_Pos                  3                                                       /*!< USART13 CR2: FXCH Position              */
#define USART13_CR2_FXCH_Msk                  (0x01UL << USART13_CR2_FXCH_Pos)                        /*!< USART13 CR2: FXCH Mask                  */
#define USART13_CR2_SSEN_Pos                  4                                                       /*!< USART13 CR2: SSEN Position              */
#define USART13_CR2_SSEN_Msk                  (0x01UL << USART13_CR2_SSEN_Pos)                        /*!< USART13 CR2: SSEN Mask                  */
#define USART13_CR2_DISSCK_Pos                5                                                       /*!< USART13 CR2: DISSCK Position            */
#define USART13_CR2_DISSCK_Msk                (0x01UL << USART13_CR2_DISSCK_Pos)                      /*!< USART13 CR2: DISSCK Mask                */
#define USART13_CR2_LOOPS_Pos                 6                                                       /*!< USART13 CR2: LOOPS Position             */
#define USART13_CR2_LOOPS_Msk                 (0x01UL << USART13_CR2_LOOPS_Pos)                       /*!< USART13 CR2: LOOPS Mask                 */
#define USART13_CR2_MASTER_Pos                7                                                       /*!< USART13 CR2: MASTER Position            */
#define USART13_CR2_MASTER_Msk                (0x01UL << USART13_CR2_MASTER_Pos)                      /*!< USART13 CR2: MASTER Mask                */
#define USART13_CR2_DBLS_Pos                  8                                                       /*!< USART13 CR2: DBLS Position              */
#define USART13_CR2_DBLS_Msk                  (0x01UL << USART13_CR2_DBLS_Pos)                        /*!< USART13 CR2: DBLS Mask                  */
#define USART13_CR2_EN_Pos                    9                                                       /*!< USART13 CR2: EN Position                */
#define USART13_CR2_EN_Msk                    (0x01UL << USART13_CR2_EN_Pos)                          /*!< USART13 CR2: EN Mask                    */
#define USART13_CR2_BFREN_Pos                 10                                                      /*!< USART13 CR2: BFREN Position             */
#define USART13_CR2_BFREN_Msk                 (0x01UL << USART13_CR2_BFREN_Pos)                       /*!< USART13 CR2: BFREN Mask                 */
#define USART13_CR2_RTOEN_Pos                 11                                                      /*!< USART13 CR2: RTOEN Position             */
#define USART13_CR2_RTOEN_Msk                 (0x01UL << USART13_CR2_RTOEN_Pos)                       /*!< USART13 CR2: RTOEN Mask                 */
#define USART13_CR2_RTOIE_Pos                 12                                                      /*!< USART13 CR2: RTOIE Position             */
#define USART13_CR2_RTOIE_Msk                 (0x01UL << USART13_CR2_RTOIE_Pos)                       /*!< USART13 CR2: RTOIE Mask                 */
#define USART13_CR2_DMARXIE_Pos               13                                                      /*!< USART13 CR2: DMARXIE Position           */
#define USART13_CR2_DMARXIE_Msk               (0x01UL << USART13_CR2_DMARXIE_Pos)                     /*!< USART13 CR2: DMARXIE Mask               */
#define USART13_CR2_DMATXIE_Pos               14                                                      /*!< USART13 CR2: DMATXIE Position           */
#define USART13_CR2_DMATXIE_Msk               (0x01UL << USART13_CR2_DMATXIE_Pos)                     /*!< USART13 CR2: DMATXIE Mask               */

/* ---------------------------------  USART13_ST  --------------------------------- */
#define USART13_ST_PE_Pos                     0                                                       /*!< USART13 ST: PE Position                 */
#define USART13_ST_PE_Msk                     (0x01UL << USART13_ST_PE_Pos)                           /*!< USART13 ST: PE Mask                     */
#define USART13_ST_FE_Pos                     1                                                       /*!< USART13 ST: FE Position                 */
#define USART13_ST_FE_Msk                     (0x01UL << USART13_ST_FE_Pos)                           /*!< USART13 ST: FE Mask                     */
#define USART13_ST_DOR_Pos                    2                                                       /*!< USART13 ST: DOR Position                */
#define USART13_ST_DOR_Msk                    (0x01UL << USART13_ST_DOR_Pos)                          /*!< USART13 ST: DOR Mask                    */
#define USART13_ST_RTOF_Pos                   3                                                       /*!< USART13 ST: RTOF Position               */
#define USART13_ST_RTOF_Msk                   (0x01UL << USART13_ST_RTOF_Pos)                         /*!< USART13 ST: RTOF Mask                   */
#define USART13_ST_RXC_Pos                    5                                                       /*!< USART13 ST: RXC Position                */
#define USART13_ST_RXC_Msk                    (0x01UL << USART13_ST_RXC_Pos)                          /*!< USART13 ST: RXC Mask                    */
#define USART13_ST_TXC_Pos                    6                                                       /*!< USART13 ST: TXC Position                */
#define USART13_ST_TXC_Msk                    (0x01UL << USART13_ST_TXC_Pos)                          /*!< USART13 ST: TXC Mask                    */
#define USART13_ST_DRE_Pos                    7                                                       /*!< USART13 ST: DRE Position                */
#define USART13_ST_DRE_Msk                    (0x01UL << USART13_ST_DRE_Pos)                          /*!< USART13 ST: DRE Mask                    */
#define USART13_ST_DMARXF_Pos                 8                                                       /*!< USART13 ST: DMARXF Position             */
#define USART13_ST_DMARXF_Msk                 (0x01UL << USART13_ST_DMARXF_Pos)                       /*!< USART13 ST: DMARXF Mask                 */
#define USART13_ST_DMATXF_Pos                 9                                                       /*!< USART13 ST: DMATXF Position             */
#define USART13_ST_DMATXF_Msk                 (0x01UL << USART13_ST_DMATXF_Pos)                       /*!< USART13 ST: DMATXF Mask                 */

/* ---------------------------------  USART13_BDR  -------------------------------- */
#define USART13_BDR_BDATA_Pos                 0                                                       /*!< USART13 BDR: BDATA Position             */
#define USART13_BDR_BDATA_Msk                 (0x00000fffUL << USART13_BDR_BDATA_Pos)                 /*!< USART13 BDR: BDATA Mask                 */

/* ---------------------------------  USART13_DR  --------------------------------- */
#define USART13_DR_DATA_Pos                   0                                                       /*!< USART13 DR: DATA Position               */
#define USART13_DR_DATA_Msk                   (0x000000ffUL << USART13_DR_DATA_Pos)                   /*!< USART13 DR: DATA Mask                   */

/* ---------------------------------  USART13_BFR  -------------------------------- */
#define USART13_BFR_BFC_Pos                   0                                                       /*!< USART13 BFR: BFC Position               */
#define USART13_BFR_BFC_Msk                   (0x000000ffUL << USART13_BFR_BFC_Pos)                   /*!< USART13 BFR: BFC Mask                   */

/* ---------------------------------  USART13_RTO  -------------------------------- */
#define USART13_RTO_RTO_Pos                   0                                                       /*!< USART13 RTO: RTO Position               */
#define USART13_RTO_RTO_Msk                   (0x00ffffffUL << USART13_RTO_RTO_Pos)                   /*!< USART13 RTO: RTO Mask                   */


/* ================================================================================ */
/* ================          Group 'UART' Position & Mask          ================ */
/* ================================================================================ */


/* ----------------------------------  UART_RBR  ---------------------------------- */
#define UART_RBR_RBR_Pos                      0                                                       /*!< UART RBR: RBR Position                  */
#define UART_RBR_RBR_Msk                      (0x000000ffUL << UART_RBR_RBR_Pos)                      /*!< UART RBR: RBR Mask                      */

/* ----------------------------------  UART_THR  ---------------------------------- */
#define UART_THR_THR_Pos                      0                                                       /*!< UART THR: THR Position                  */
#define UART_THR_THR_Msk                      (0x000000ffUL << UART_THR_THR_Pos)                      /*!< UART THR: THR Mask                      */

/* ----------------------------------  UART_IER  ---------------------------------- */
#define UART_IER_DRIE_Pos                     0                                                       /*!< UART IER: DRIE Position                 */
#define UART_IER_DRIE_Msk                     (0x01UL << UART_IER_DRIE_Pos)                           /*!< UART IER: DRIE Mask                     */
#define UART_IER_THREIE_Pos                   1                                                       /*!< UART IER: THREIE Position               */
#define UART_IER_THREIE_Msk                   (0x01UL << UART_IER_THREIE_Pos)                         /*!< UART IER: THREIE Mask                   */
#define UART_IER_RLSIE_Pos                    2                                                       /*!< UART IER: RLSIE Position                */
#define UART_IER_RLSIE_Msk                    (0x01UL << UART_IER_RLSIE_Pos)                          /*!< UART IER: RLSIE Mask                    */
#define UART_IER_TXEIE_Pos                    3                                                       /*!< UART IER: TXEIE Position                */
#define UART_IER_TXEIE_Msk                    (0x01UL << UART_IER_TXEIE_Pos)                          /*!< UART IER: TXEIE Mask                    */
#define UART_IER_DRXIEN_Pos                   4                                                       /*!< UART IER: DRXIEN Position               */
#define UART_IER_DRXIEN_Msk                   (0x01UL << UART_IER_DRXIEN_Pos)                         /*!< UART IER: DRXIEN Mask                   */
#define UART_IER_DTXIEN_Pos                   5                                                       /*!< UART IER: DTXIEN Position               */
#define UART_IER_DTXIEN_Msk                   (0x01UL << UART_IER_DTXIEN_Pos)                         /*!< UART IER: DTXIEN Mask                   */

/* ----------------------------------  UART_IIR  ---------------------------------- */
#define UART_IIR_IPEN_Pos                     0                                                       /*!< UART IIR: IPEN Position                 */
#define UART_IIR_IPEN_Msk                     (0x01UL << UART_IIR_IPEN_Pos)                           /*!< UART IIR: IPEN Mask                     */
#define UART_IIR_IID_Pos                      1                                                       /*!< UART IIR: IID Position                  */
#define UART_IIR_IID_Msk                      (0x07UL << UART_IIR_IID_Pos)                            /*!< UART IIR: IID Mask                      */
#define UART_IIR_TXE_Pos                      4                                                       /*!< UART IIR: TXE Position                  */
#define UART_IIR_TXE_Msk                      (0x01UL << UART_IIR_TXE_Pos)                            /*!< UART IIR: TXE Mask                      */

/* ----------------------------------  UART_LCR  ---------------------------------- */
#define UART_LCR_DLEN_Pos                     0                                                       /*!< UART LCR: DLEN Position                 */
#define UART_LCR_DLEN_Msk                     (0x03UL << UART_LCR_DLEN_Pos)                           /*!< UART LCR: DLEN Mask                     */
#define UART_LCR_STOPBIT_Pos                  2                                                       /*!< UART LCR: STOPBIT Position              */
#define UART_LCR_STOPBIT_Msk                  (0x01UL << UART_LCR_STOPBIT_Pos)                        /*!< UART LCR: STOPBIT Mask                  */
#define UART_LCR_PEN_Pos                      3                                                       /*!< UART LCR: PEN Position                  */
#define UART_LCR_PEN_Msk                      (0x01UL << UART_LCR_PEN_Pos)                            /*!< UART LCR: PEN Mask                      */
#define UART_LCR_PARITY_Pos                   4                                                       /*!< UART LCR: PARITY Position               */
#define UART_LCR_PARITY_Msk                   (0x01UL << UART_LCR_PARITY_Pos)                         /*!< UART LCR: PARITY Mask                   */
#define UART_LCR_STICKP_Pos                   5                                                       /*!< UART LCR: STICKP Position               */
#define UART_LCR_STICKP_Msk                   (0x01UL << UART_LCR_STICKP_Pos)                         /*!< UART LCR: STICKP Mask                   */
#define UART_LCR_BREAK_Pos                    6                                                       /*!< UART LCR: BREAK Position                */
#define UART_LCR_BREAK_Msk                    (0x01UL << UART_LCR_BREAK_Pos)                          /*!< UART LCR: BREAK Mask                    */

/* ----------------------------------  UART_DCR  ---------------------------------- */
#define UART_DCR_TXINV_Pos                    2                                                       /*!< UART DCR: TXINV Position                */
#define UART_DCR_TXINV_Msk                    (0x01UL << UART_DCR_TXINV_Pos)                          /*!< UART DCR: TXINV Mask                    */
#define UART_DCR_RXINV_Pos                    3                                                       /*!< UART DCR: RXINV Position                */
#define UART_DCR_RXINV_Msk                    (0x01UL << UART_DCR_RXINV_Pos)                          /*!< UART DCR: RXINV Mask                    */
#define UART_DCR_LBON_Pos                     4                                                       /*!< UART DCR: LBON Position                 */
#define UART_DCR_LBON_Msk                     (0x01UL << UART_DCR_LBON_Pos)                           /*!< UART DCR: LBON Mask                     */

/* ----------------------------------  UART_LSR  ---------------------------------- */
#define UART_LSR_DR_Pos                       0                                                       /*!< UART LSR: DR Position                   */
#define UART_LSR_DR_Msk                       (0x01UL << UART_LSR_DR_Pos)                             /*!< UART LSR: DR Mask                       */
#define UART_LSR_OE_Pos                       1                                                       /*!< UART LSR: OE Position                   */
#define UART_LSR_OE_Msk                       (0x01UL << UART_LSR_OE_Pos)                             /*!< UART LSR: OE Mask                       */
#define UART_LSR_PE_Pos                       2                                                       /*!< UART LSR: PE Position                   */
#define UART_LSR_PE_Msk                       (0x01UL << UART_LSR_PE_Pos)                             /*!< UART LSR: PE Mask                       */
#define UART_LSR_FE_Pos                       3                                                       /*!< UART LSR: FE Position                   */
#define UART_LSR_FE_Msk                       (0x01UL << UART_LSR_FE_Pos)                             /*!< UART LSR: FE Mask                       */
#define UART_LSR_BI_Pos                       4                                                       /*!< UART LSR: BI Position                   */
#define UART_LSR_BI_Msk                       (0x01UL << UART_LSR_BI_Pos)                             /*!< UART LSR: BI Mask                       */
#define UART_LSR_THRE_Pos                     5                                                       /*!< UART LSR: THRE Position                 */
#define UART_LSR_THRE_Msk                     (0x01UL << UART_LSR_THRE_Pos)                           /*!< UART LSR: THRE Mask                     */
#define UART_LSR_TEMT_Pos                     6                                                       /*!< UART LSR: TEMT Position                 */
#define UART_LSR_TEMT_Msk                     (0x01UL << UART_LSR_TEMT_Pos)                           /*!< UART LSR: TEMT Mask                     */

/* ----------------------------------  UART_BDR  ---------------------------------- */
#define UART_BDR_BDR_Pos                      0                                                       /*!< UART BDR: BDR Position                  */
#define UART_BDR_BDR_Msk                      (0x0000ffffUL << UART_BDR_BDR_Pos)                      /*!< UART BDR: BDR Mask                      */

/* ----------------------------------  UART_BFR  ---------------------------------- */
#define UART_BFR_BFR_Pos                      0                                                       /*!< UART BFR: BFR Position                  */
#define UART_BFR_BFR_Msk                      (0x000000ffUL << UART_BFR_BFR_Pos)                      /*!< UART BFR: BFR Mask                      */

/* ----------------------------------  UART_IDTR  --------------------------------- */
#define UART_IDTR_WAITVAL_Pos                 0                                                       /*!< UART IDTR: WAITVAL Position             */
#define UART_IDTR_WAITVAL_Msk                 (0x07UL << UART_IDTR_WAITVAL_Pos)                       /*!< UART IDTR: WAITVAL Mask                 */
#define UART_IDTR_DMS_Pos                     6                                                       /*!< UART IDTR: DMS Position                 */
#define UART_IDTR_DMS_Msk                     (0x01UL << UART_IDTR_DMS_Pos)                           /*!< UART IDTR: DMS Mask                     */
#define UART_IDTR_SMS_Pos                     7                                                       /*!< UART IDTR: SMS Position                 */
#define UART_IDTR_SMS_Msk                     (0x01UL << UART_IDTR_SMS_Pos)                           /*!< UART IDTR: SMS Mask                     */


/* ================================================================================ */
/* ================         struct 'UART0' Position & Mask         ================ */
/* ================================================================================ */


/* ----------------------------------  UART0_RBR  --------------------------------- */
#define UART0_RBR_RBR_Pos                     0                                                       /*!< UART0 RBR: RBR Position                 */
#define UART0_RBR_RBR_Msk                     (0x000000ffUL << UART0_RBR_RBR_Pos)                     /*!< UART0 RBR: RBR Mask                     */

/* ----------------------------------  UART0_THR  --------------------------------- */
#define UART0_THR_THR_Pos                     0                                                       /*!< UART0 THR: THR Position                 */
#define UART0_THR_THR_Msk                     (0x000000ffUL << UART0_THR_THR_Pos)                     /*!< UART0 THR: THR Mask                     */

/* ----------------------------------  UART0_IER  --------------------------------- */
#define UART0_IER_DRIE_Pos                    0                                                       /*!< UART0 IER: DRIE Position                */
#define UART0_IER_DRIE_Msk                    (0x01UL << UART0_IER_DRIE_Pos)                          /*!< UART0 IER: DRIE Mask                    */
#define UART0_IER_THREIE_Pos                  1                                                       /*!< UART0 IER: THREIE Position              */
#define UART0_IER_THREIE_Msk                  (0x01UL << UART0_IER_THREIE_Pos)                        /*!< UART0 IER: THREIE Mask                  */
#define UART0_IER_RLSIE_Pos                   2                                                       /*!< UART0 IER: RLSIE Position               */
#define UART0_IER_RLSIE_Msk                   (0x01UL << UART0_IER_RLSIE_Pos)                         /*!< UART0 IER: RLSIE Mask                   */
#define UART0_IER_TXEIE_Pos                   3                                                       /*!< UART0 IER: TXEIE Position               */
#define UART0_IER_TXEIE_Msk                   (0x01UL << UART0_IER_TXEIE_Pos)                         /*!< UART0 IER: TXEIE Mask                   */
#define UART0_IER_DRXIEN_Pos                  4                                                       /*!< UART0 IER: DRXIEN Position              */
#define UART0_IER_DRXIEN_Msk                  (0x01UL << UART0_IER_DRXIEN_Pos)                        /*!< UART0 IER: DRXIEN Mask                  */
#define UART0_IER_DTXIEN_Pos                  5                                                       /*!< UART0 IER: DTXIEN Position              */
#define UART0_IER_DTXIEN_Msk                  (0x01UL << UART0_IER_DTXIEN_Pos)                        /*!< UART0 IER: DTXIEN Mask                  */

/* ----------------------------------  UART0_IIR  --------------------------------- */
#define UART0_IIR_IPEN_Pos                    0                                                       /*!< UART0 IIR: IPEN Position                */
#define UART0_IIR_IPEN_Msk                    (0x01UL << UART0_IIR_IPEN_Pos)                          /*!< UART0 IIR: IPEN Mask                    */
#define UART0_IIR_IID_Pos                     1                                                       /*!< UART0 IIR: IID Position                 */
#define UART0_IIR_IID_Msk                     (0x07UL << UART0_IIR_IID_Pos)                           /*!< UART0 IIR: IID Mask                     */
#define UART0_IIR_TXE_Pos                     4                                                       /*!< UART0 IIR: TXE Position                 */
#define UART0_IIR_TXE_Msk                     (0x01UL << UART0_IIR_TXE_Pos)                           /*!< UART0 IIR: TXE Mask                     */

/* ----------------------------------  UART0_LCR  --------------------------------- */
#define UART0_LCR_DLEN_Pos                    0                                                       /*!< UART0 LCR: DLEN Position                */
#define UART0_LCR_DLEN_Msk                    (0x03UL << UART0_LCR_DLEN_Pos)                          /*!< UART0 LCR: DLEN Mask                    */
#define UART0_LCR_STOPBIT_Pos                 2                                                       /*!< UART0 LCR: STOPBIT Position             */
#define UART0_LCR_STOPBIT_Msk                 (0x01UL << UART0_LCR_STOPBIT_Pos)                       /*!< UART0 LCR: STOPBIT Mask                 */
#define UART0_LCR_PEN_Pos                     3                                                       /*!< UART0 LCR: PEN Position                 */
#define UART0_LCR_PEN_Msk                     (0x01UL << UART0_LCR_PEN_Pos)                           /*!< UART0 LCR: PEN Mask                     */
#define UART0_LCR_PARITY_Pos                  4                                                       /*!< UART0 LCR: PARITY Position              */
#define UART0_LCR_PARITY_Msk                  (0x01UL << UART0_LCR_PARITY_Pos)                        /*!< UART0 LCR: PARITY Mask                  */
#define UART0_LCR_STICKP_Pos                  5                                                       /*!< UART0 LCR: STICKP Position              */
#define UART0_LCR_STICKP_Msk                  (0x01UL << UART0_LCR_STICKP_Pos)                        /*!< UART0 LCR: STICKP Mask                  */
#define UART0_LCR_BREAK_Pos                   6                                                       /*!< UART0 LCR: BREAK Position               */
#define UART0_LCR_BREAK_Msk                   (0x01UL << UART0_LCR_BREAK_Pos)                         /*!< UART0 LCR: BREAK Mask                   */

/* ----------------------------------  UART0_DCR  --------------------------------- */
#define UART0_DCR_TXINV_Pos                   2                                                       /*!< UART0 DCR: TXINV Position               */
#define UART0_DCR_TXINV_Msk                   (0x01UL << UART0_DCR_TXINV_Pos)                         /*!< UART0 DCR: TXINV Mask                   */
#define UART0_DCR_RXINV_Pos                   3                                                       /*!< UART0 DCR: RXINV Position               */
#define UART0_DCR_RXINV_Msk                   (0x01UL << UART0_DCR_RXINV_Pos)                         /*!< UART0 DCR: RXINV Mask                   */
#define UART0_DCR_LBON_Pos                    4                                                       /*!< UART0 DCR: LBON Position                */
#define UART0_DCR_LBON_Msk                    (0x01UL << UART0_DCR_LBON_Pos)                          /*!< UART0 DCR: LBON Mask                    */

/* ----------------------------------  UART0_LSR  --------------------------------- */
#define UART0_LSR_DR_Pos                      0                                                       /*!< UART0 LSR: DR Position                  */
#define UART0_LSR_DR_Msk                      (0x01UL << UART0_LSR_DR_Pos)                            /*!< UART0 LSR: DR Mask                      */
#define UART0_LSR_OE_Pos                      1                                                       /*!< UART0 LSR: OE Position                  */
#define UART0_LSR_OE_Msk                      (0x01UL << UART0_LSR_OE_Pos)                            /*!< UART0 LSR: OE Mask                      */
#define UART0_LSR_PE_Pos                      2                                                       /*!< UART0 LSR: PE Position                  */
#define UART0_LSR_PE_Msk                      (0x01UL << UART0_LSR_PE_Pos)                            /*!< UART0 LSR: PE Mask                      */
#define UART0_LSR_FE_Pos                      3                                                       /*!< UART0 LSR: FE Position                  */
#define UART0_LSR_FE_Msk                      (0x01UL << UART0_LSR_FE_Pos)                            /*!< UART0 LSR: FE Mask                      */
#define UART0_LSR_BI_Pos                      4                                                       /*!< UART0 LSR: BI Position                  */
#define UART0_LSR_BI_Msk                      (0x01UL << UART0_LSR_BI_Pos)                            /*!< UART0 LSR: BI Mask                      */
#define UART0_LSR_THRE_Pos                    5                                                       /*!< UART0 LSR: THRE Position                */
#define UART0_LSR_THRE_Msk                    (0x01UL << UART0_LSR_THRE_Pos)                          /*!< UART0 LSR: THRE Mask                    */
#define UART0_LSR_TEMT_Pos                    6                                                       /*!< UART0 LSR: TEMT Position                */
#define UART0_LSR_TEMT_Msk                    (0x01UL << UART0_LSR_TEMT_Pos)                          /*!< UART0 LSR: TEMT Mask                    */

/* ----------------------------------  UART0_BDR  --------------------------------- */
#define UART0_BDR_BDR_Pos                     0                                                       /*!< UART0 BDR: BDR Position                 */
#define UART0_BDR_BDR_Msk                     (0x0000ffffUL << UART0_BDR_BDR_Pos)                     /*!< UART0 BDR: BDR Mask                     */

/* ----------------------------------  UART0_BFR  --------------------------------- */
#define UART0_BFR_BFR_Pos                     0                                                       /*!< UART0 BFR: BFR Position                 */
#define UART0_BFR_BFR_Msk                     (0x000000ffUL << UART0_BFR_BFR_Pos)                     /*!< UART0 BFR: BFR Mask                     */

/* ---------------------------------  UART0_IDTR  --------------------------------- */
#define UART0_IDTR_WAITVAL_Pos                0                                                       /*!< UART0 IDTR: WAITVAL Position            */
#define UART0_IDTR_WAITVAL_Msk                (0x07UL << UART0_IDTR_WAITVAL_Pos)                      /*!< UART0 IDTR: WAITVAL Mask                */
#define UART0_IDTR_DMS_Pos                    6                                                       /*!< UART0 IDTR: DMS Position                */
#define UART0_IDTR_DMS_Msk                    (0x01UL << UART0_IDTR_DMS_Pos)                          /*!< UART0 IDTR: DMS Mask                    */
#define UART0_IDTR_SMS_Pos                    7                                                       /*!< UART0 IDTR: SMS Position                */
#define UART0_IDTR_SMS_Msk                    (0x01UL << UART0_IDTR_SMS_Pos)                          /*!< UART0 IDTR: SMS Mask                    */


/* ================================================================================ */
/* ================         struct 'UART1' Position & Mask         ================ */
/* ================================================================================ */


/* ----------------------------------  UART1_THR  --------------------------------- */
#define UART1_THR_THR_Pos                     0                                                       /*!< UART1 THR: THR Position                 */
#define UART1_THR_THR_Msk                     (0x000000ffUL << UART1_THR_THR_Pos)                     /*!< UART1 THR: THR Mask                     */

/* ----------------------------------  UART1_RBR  --------------------------------- */
#define UART1_RBR_RBR_Pos                     0                                                       /*!< UART1 RBR: RBR Position                 */
#define UART1_RBR_RBR_Msk                     (0x000000ffUL << UART1_RBR_RBR_Pos)                     /*!< UART1 RBR: RBR Mask                     */

/* ----------------------------------  UART1_IER  --------------------------------- */
#define UART1_IER_DRIE_Pos                    0                                                       /*!< UART1 IER: DRIE Position                */
#define UART1_IER_DRIE_Msk                    (0x01UL << UART1_IER_DRIE_Pos)                          /*!< UART1 IER: DRIE Mask                    */
#define UART1_IER_THREIE_Pos                  1                                                       /*!< UART1 IER: THREIE Position              */
#define UART1_IER_THREIE_Msk                  (0x01UL << UART1_IER_THREIE_Pos)                        /*!< UART1 IER: THREIE Mask                  */
#define UART1_IER_RLSIE_Pos                   2                                                       /*!< UART1 IER: RLSIE Position               */
#define UART1_IER_RLSIE_Msk                   (0x01UL << UART1_IER_RLSIE_Pos)                         /*!< UART1 IER: RLSIE Mask                   */
#define UART1_IER_TXEIE_Pos                   3                                                       /*!< UART1 IER: TXEIE Position               */
#define UART1_IER_TXEIE_Msk                   (0x01UL << UART1_IER_TXEIE_Pos)                         /*!< UART1 IER: TXEIE Mask                   */
#define UART1_IER_DRXIEN_Pos                  4                                                       /*!< UART1 IER: DRXIEN Position              */
#define UART1_IER_DRXIEN_Msk                  (0x01UL << UART1_IER_DRXIEN_Pos)                        /*!< UART1 IER: DRXIEN Mask                  */
#define UART1_IER_DTXIEN_Pos                  5                                                       /*!< UART1 IER: DTXIEN Position              */
#define UART1_IER_DTXIEN_Msk                  (0x01UL << UART1_IER_DTXIEN_Pos)                        /*!< UART1 IER: DTXIEN Mask                  */

/* ----------------------------------  UART1_IIR  --------------------------------- */
#define UART1_IIR_IPEN_Pos                    0                                                       /*!< UART1 IIR: IPEN Position                */
#define UART1_IIR_IPEN_Msk                    (0x01UL << UART1_IIR_IPEN_Pos)                          /*!< UART1 IIR: IPEN Mask                    */
#define UART1_IIR_IID_Pos                     1                                                       /*!< UART1 IIR: IID Position                 */
#define UART1_IIR_IID_Msk                     (0x07UL << UART1_IIR_IID_Pos)                           /*!< UART1 IIR: IID Mask                     */
#define UART1_IIR_TXE_Pos                     4                                                       /*!< UART1 IIR: TXE Position                 */
#define UART1_IIR_TXE_Msk                     (0x01UL << UART1_IIR_TXE_Pos)                           /*!< UART1 IIR: TXE Mask                     */

/* ----------------------------------  UART1_LCR  --------------------------------- */
#define UART1_LCR_DLEN_Pos                    0                                                       /*!< UART1 LCR: DLEN Position                */
#define UART1_LCR_DLEN_Msk                    (0x03UL << UART1_LCR_DLEN_Pos)                          /*!< UART1 LCR: DLEN Mask                    */
#define UART1_LCR_STOPBIT_Pos                 2                                                       /*!< UART1 LCR: STOPBIT Position             */
#define UART1_LCR_STOPBIT_Msk                 (0x01UL << UART1_LCR_STOPBIT_Pos)                       /*!< UART1 LCR: STOPBIT Mask                 */
#define UART1_LCR_PEN_Pos                     3                                                       /*!< UART1 LCR: PEN Position                 */
#define UART1_LCR_PEN_Msk                     (0x01UL << UART1_LCR_PEN_Pos)                           /*!< UART1 LCR: PEN Mask                     */
#define UART1_LCR_PARITY_Pos                  4                                                       /*!< UART1 LCR: PARITY Position              */
#define UART1_LCR_PARITY_Msk                  (0x01UL << UART1_LCR_PARITY_Pos)                        /*!< UART1 LCR: PARITY Mask                  */
#define UART1_LCR_STICKP_Pos                  5                                                       /*!< UART1 LCR: STICKP Position              */
#define UART1_LCR_STICKP_Msk                  (0x01UL << UART1_LCR_STICKP_Pos)                        /*!< UART1 LCR: STICKP Mask                  */
#define UART1_LCR_BREAK_Pos                   6                                                       /*!< UART1 LCR: BREAK Position               */
#define UART1_LCR_BREAK_Msk                   (0x01UL << UART1_LCR_BREAK_Pos)                         /*!< UART1 LCR: BREAK Mask                   */

/* ----------------------------------  UART1_DCR  --------------------------------- */
#define UART1_DCR_TXINV_Pos                   2                                                       /*!< UART1 DCR: TXINV Position               */
#define UART1_DCR_TXINV_Msk                   (0x01UL << UART1_DCR_TXINV_Pos)                         /*!< UART1 DCR: TXINV Mask                   */
#define UART1_DCR_RXINV_Pos                   3                                                       /*!< UART1 DCR: RXINV Position               */
#define UART1_DCR_RXINV_Msk                   (0x01UL << UART1_DCR_RXINV_Pos)                         /*!< UART1 DCR: RXINV Mask                   */
#define UART1_DCR_LBON_Pos                    4                                                       /*!< UART1 DCR: LBON Position                */
#define UART1_DCR_LBON_Msk                    (0x01UL << UART1_DCR_LBON_Pos)                          /*!< UART1 DCR: LBON Mask                    */

/* ----------------------------------  UART1_LSR  --------------------------------- */
#define UART1_LSR_DR_Pos                      0                                                       /*!< UART1 LSR: DR Position                  */
#define UART1_LSR_DR_Msk                      (0x01UL << UART1_LSR_DR_Pos)                            /*!< UART1 LSR: DR Mask                      */
#define UART1_LSR_OE_Pos                      1                                                       /*!< UART1 LSR: OE Position                  */
#define UART1_LSR_OE_Msk                      (0x01UL << UART1_LSR_OE_Pos)                            /*!< UART1 LSR: OE Mask                      */
#define UART1_LSR_PE_Pos                      2                                                       /*!< UART1 LSR: PE Position                  */
#define UART1_LSR_PE_Msk                      (0x01UL << UART1_LSR_PE_Pos)                            /*!< UART1 LSR: PE Mask                      */
#define UART1_LSR_FE_Pos                      3                                                       /*!< UART1 LSR: FE Position                  */
#define UART1_LSR_FE_Msk                      (0x01UL << UART1_LSR_FE_Pos)                            /*!< UART1 LSR: FE Mask                      */
#define UART1_LSR_BI_Pos                      4                                                       /*!< UART1 LSR: BI Position                  */
#define UART1_LSR_BI_Msk                      (0x01UL << UART1_LSR_BI_Pos)                            /*!< UART1 LSR: BI Mask                      */
#define UART1_LSR_THRE_Pos                    5                                                       /*!< UART1 LSR: THRE Position                */
#define UART1_LSR_THRE_Msk                    (0x01UL << UART1_LSR_THRE_Pos)                          /*!< UART1 LSR: THRE Mask                    */
#define UART1_LSR_TEMT_Pos                    6                                                       /*!< UART1 LSR: TEMT Position                */
#define UART1_LSR_TEMT_Msk                    (0x01UL << UART1_LSR_TEMT_Pos)                          /*!< UART1 LSR: TEMT Mask                    */

/* ----------------------------------  UART1_BDR  --------------------------------- */
#define UART1_BDR_BDR_Pos                     0                                                       /*!< UART1 BDR: BDR Position                 */
#define UART1_BDR_BDR_Msk                     (0x0000ffffUL << UART1_BDR_BDR_Pos)                     /*!< UART1 BDR: BDR Mask                     */

/* ----------------------------------  UART1_BFR  --------------------------------- */
#define UART1_BFR_BFR_Pos                     0                                                       /*!< UART1 BFR: BFR Position                 */
#define UART1_BFR_BFR_Msk                     (0x000000ffUL << UART1_BFR_BFR_Pos)                     /*!< UART1 BFR: BFR Mask                     */

/* ---------------------------------  UART1_IDTR  --------------------------------- */
#define UART1_IDTR_WAITVAL_Pos                0                                                       /*!< UART1 IDTR: WAITVAL Position            */
#define UART1_IDTR_WAITVAL_Msk                (0x07UL << UART1_IDTR_WAITVAL_Pos)                      /*!< UART1 IDTR: WAITVAL Mask                */
#define UART1_IDTR_DMS_Pos                    6                                                       /*!< UART1 IDTR: DMS Position                */
#define UART1_IDTR_DMS_Msk                    (0x01UL << UART1_IDTR_DMS_Pos)                          /*!< UART1 IDTR: DMS Mask                    */
#define UART1_IDTR_SMS_Pos                    7                                                       /*!< UART1 IDTR: SMS Position                */
#define UART1_IDTR_SMS_Msk                    (0x01UL << UART1_IDTR_SMS_Pos)                          /*!< UART1 IDTR: SMS Mask                    */


/* ================================================================================ */
/* ================           Group 'SPI' Position & Mask          ================ */
/* ================================================================================ */


/* -----------------------------------  SPI_TDR  ---------------------------------- */
#define SPI_TDR_TDR_Pos                       0                                                       /*!< SPI TDR: TDR Position                   */
#define SPI_TDR_TDR_Msk                       (0x0001ffffUL << SPI_TDR_TDR_Pos)                       /*!< SPI TDR: TDR Mask                       */

/* -----------------------------------  SPI_RDR  ---------------------------------- */
#define SPI_RDR_RDR_Pos                       0                                                       /*!< SPI RDR: RDR Position                   */
#define SPI_RDR_RDR_Msk                       (0x0001ffffUL << SPI_RDR_RDR_Pos)                       /*!< SPI RDR: RDR Mask                       */

/* -----------------------------------  SPI_CR  ----------------------------------- */
#define SPI_CR_BITSZ_Pos                      0                                                       /*!< SPI CR: BITSZ Position                  */
#define SPI_CR_BITSZ_Msk                      (0x03UL << SPI_CR_BITSZ_Pos)                            /*!< SPI CR: BITSZ Mask                      */
#define SPI_CR_CPOL_Pos                       2                                                       /*!< SPI CR: CPOL Position                   */
#define SPI_CR_CPOL_Msk                       (0x01UL << SPI_CR_CPOL_Pos)                             /*!< SPI CR: CPOL Mask                       */
#define SPI_CR_CPHA_Pos                       3                                                       /*!< SPI CR: CPHA Position                   */
#define SPI_CR_CPHA_Msk                       (0x01UL << SPI_CR_CPHA_Pos)                             /*!< SPI CR: CPHA Mask                       */
#define SPI_CR_MSBF_Pos                       4                                                       /*!< SPI CR: MSBF Position                   */
#define SPI_CR_MSBF_Msk                       (0x01UL << SPI_CR_MSBF_Pos)                             /*!< SPI CR: MSBF Mask                       */
#define SPI_CR_MS_Pos                         5                                                       /*!< SPI CR: MS Position                     */
#define SPI_CR_MS_Msk                         (0x01UL << SPI_CR_MS_Pos)                               /*!< SPI CR: MS Mask                         */
#define SPI_CR_SSPOL_Pos                      8                                                       /*!< SPI CR: SSPOL Position                  */
#define SPI_CR_SSPOL_Msk                      (0x01UL << SPI_CR_SSPOL_Pos)                            /*!< SPI CR: SSPOL Mask                      */
#define SPI_CR_SSMO_Pos                       9                                                       /*!< SPI CR: SSMO Position                   */
#define SPI_CR_SSMO_Msk                       (0x01UL << SPI_CR_SSMO_Pos)                             /*!< SPI CR: SSMO Mask                       */
#define SPI_CR_SSMASK_Pos                     10                                                      /*!< SPI CR: SSMASK Position                 */
#define SPI_CR_SSMASK_Msk                     (0x01UL << SPI_CR_SSMASK_Pos)                           /*!< SPI CR: SSMASK Mask                     */
#define SPI_CR_LBE_Pos                        11                                                      /*!< SPI CR: LBE Position                    */
#define SPI_CR_LBE_Msk                        (0x01UL << SPI_CR_LBE_Pos)                              /*!< SPI CR: LBE Mask                        */
#define SPI_CR_SSOUT_Pos                      12                                                      /*!< SPI CR: SSOUT Position                  */
#define SPI_CR_SSOUT_Msk                      (0x01UL << SPI_CR_SSOUT_Pos)                            /*!< SPI CR: SSOUT Mask                      */
#define SPI_CR_SSMOD_Pos                      13                                                      /*!< SPI CR: SSMOD Position                  */
#define SPI_CR_SSMOD_Msk                      (0x01UL << SPI_CR_SSMOD_Pos)                            /*!< SPI CR: SSMOD Mask                      */
#define SPI_CR_RXIE_Pos                       14                                                      /*!< SPI CR: RXIE Position                   */
#define SPI_CR_RXIE_Msk                       (0x01UL << SPI_CR_RXIE_Pos)                             /*!< SPI CR: RXIE Mask                       */
#define SPI_CR_TXIE_Pos                       15                                                      /*!< SPI CR: TXIE Position                   */
#define SPI_CR_TXIE_Msk                       (0x01UL << SPI_CR_TXIE_Pos)                             /*!< SPI CR: TXIE Mask                       */
#define SPI_CR_SSCIE_Pos                      16                                                      /*!< SPI CR: SSCIE Position                  */
#define SPI_CR_SSCIE_Msk                      (0x01UL << SPI_CR_SSCIE_Pos)                            /*!< SPI CR: SSCIE Mask                      */
#define SPI_CR_RXDIE_Pos                      17                                                      /*!< SPI CR: RXDIE Position                  */
#define SPI_CR_RXDIE_Msk                      (0x01UL << SPI_CR_RXDIE_Pos)                            /*!< SPI CR: RXDIE Mask                      */
#define SPI_CR_TXDIE_Pos                      18                                                      /*!< SPI CR: TXDIE Position                  */
#define SPI_CR_TXDIE_Msk                      (0x01UL << SPI_CR_TXDIE_Pos)                            /*!< SPI CR: TXDIE Mask                      */
#define SPI_CR_RXBC_Pos                       19                                                      /*!< SPI CR: RXBC Position                   */
#define SPI_CR_RXBC_Msk                       (0x01UL << SPI_CR_RXBC_Pos)                             /*!< SPI CR: RXBC Mask                       */
#define SPI_CR_TXBC_Pos                       20                                                      /*!< SPI CR: TXBC Position                   */
#define SPI_CR_TXBC_Msk                       (0x01UL << SPI_CR_TXBC_Pos)                             /*!< SPI CR: TXBC Mask                       */

/* -----------------------------------  SPI_SR  ----------------------------------- */
#define SPI_SR_RRDY_Pos                       0                                                       /*!< SPI SR: RRDY Position                   */
#define SPI_SR_RRDY_Msk                       (0x01UL << SPI_SR_RRDY_Pos)                             /*!< SPI SR: RRDY Mask                       */
#define SPI_SR_TRDY_Pos                       1                                                       /*!< SPI SR: TRDY Position                   */
#define SPI_SR_TRDY_Msk                       (0x01UL << SPI_SR_TRDY_Pos)                             /*!< SPI SR: TRDY Mask                       */
#define SPI_SR_TXIDLE_Pos                     2                                                       /*!< SPI SR: TXIDLE Position                 */
#define SPI_SR_TXIDLE_Msk                     (0x01UL << SPI_SR_TXIDLE_Pos)                           /*!< SPI SR: TXIDLE Mask                     */
#define SPI_SR_UDRF_Pos                       3                                                       /*!< SPI SR: UDRF Position                   */
#define SPI_SR_UDRF_Msk                       (0x01UL << SPI_SR_UDRF_Pos)                             /*!< SPI SR: UDRF Mask                       */
#define SPI_SR_OVRF_Pos                       4                                                       /*!< SPI SR: OVRF Position                   */
#define SPI_SR_OVRF_Msk                       (0x01UL << SPI_SR_OVRF_Pos)                             /*!< SPI SR: OVRF Mask                       */
#define SPI_SR_SSON_Pos                       5                                                       /*!< SPI SR: SSON Position                   */
#define SPI_SR_SSON_Msk                       (0x01UL << SPI_SR_SSON_Pos)                             /*!< SPI SR: SSON Mask                       */
#define SPI_SR_SSDET_Pos                      6                                                       /*!< SPI SR: SSDET Position                  */
#define SPI_SR_SSDET_Msk                      (0x01UL << SPI_SR_SSDET_Pos)                            /*!< SPI SR: SSDET Mask                      */
#define SPI_SR_SBUSY_Pos                      7                                                       /*!< SPI SR: SBUSY Position                  */
#define SPI_SR_SBUSY_Msk                      (0x01UL << SPI_SR_SBUSY_Pos)                            /*!< SPI SR: SBUSY Mask                      */
#define SPI_SR_RXDMAF_Pos                     8                                                       /*!< SPI SR: RXDMAF Position                 */
#define SPI_SR_RXDMAF_Msk                     (0x01UL << SPI_SR_RXDMAF_Pos)                           /*!< SPI SR: RXDMAF Mask                     */
#define SPI_SR_TXDMAF_Pos                     9                                                       /*!< SPI SR: TXDMAF Position                 */
#define SPI_SR_TXDMAF_Msk                     (0x01UL << SPI_SR_TXDMAF_Pos)                           /*!< SPI SR: TXDMAF Mask                     */

/* -----------------------------------  SPI_BR  ----------------------------------- */
#define SPI_BR_BR_Pos                         0                                                       /*!< SPI BR: BR Position                     */
#define SPI_BR_BR_Msk                         (0x0000ffffUL << SPI_BR_BR_Pos)                         /*!< SPI BR: BR Mask                         */

/* -----------------------------------  SPI_EN  ----------------------------------- */
#define SPI_EN_ENABLE_Pos                     0                                                       /*!< SPI EN: ENABLE Position                 */
#define SPI_EN_ENABLE_Msk                     (0x01UL << SPI_EN_ENABLE_Pos)                           /*!< SPI EN: ENABLE Mask                     */

/* -----------------------------------  SPI_LR  ----------------------------------- */
#define SPI_LR_STL_Pos                        0                                                       /*!< SPI LR: STL Position                    */
#define SPI_LR_STL_Msk                        (0x000000ffUL << SPI_LR_STL_Pos)                        /*!< SPI LR: STL Mask                        */
#define SPI_LR_BTL_Pos                        8                                                       /*!< SPI LR: BTL Position                    */
#define SPI_LR_BTL_Msk                        (0x000000ffUL << SPI_LR_BTL_Pos)                        /*!< SPI LR: BTL Mask                        */
#define SPI_LR_SPL_Pos                        16                                                      /*!< SPI LR: SPL Position                    */
#define SPI_LR_SPL_Msk                        (0x000000ffUL << SPI_LR_SPL_Pos)                        /*!< SPI LR: SPL Mask                        */


/* ================================================================================ */
/* ================         struct 'SPI20' Position & Mask         ================ */
/* ================================================================================ */


/* ----------------------------------  SPI20_TDR  --------------------------------- */
#define SPI20_TDR_TDR_Pos                     0                                                       /*!< SPI20 TDR: TDR Position                 */
#define SPI20_TDR_TDR_Msk                     (0x0001ffffUL << SPI20_TDR_TDR_Pos)                     /*!< SPI20 TDR: TDR Mask                     */

/* ----------------------------------  SPI20_RDR  --------------------------------- */
#define SPI20_RDR_RDR_Pos                     0                                                       /*!< SPI20 RDR: RDR Position                 */
#define SPI20_RDR_RDR_Msk                     (0x0001ffffUL << SPI20_RDR_RDR_Pos)                     /*!< SPI20 RDR: RDR Mask                     */

/* ----------------------------------  SPI20_CR  ---------------------------------- */
#define SPI20_CR_BITSZ_Pos                    0                                                       /*!< SPI20 CR: BITSZ Position                */
#define SPI20_CR_BITSZ_Msk                    (0x03UL << SPI20_CR_BITSZ_Pos)                          /*!< SPI20 CR: BITSZ Mask                    */
#define SPI20_CR_CPOL_Pos                     2                                                       /*!< SPI20 CR: CPOL Position                 */
#define SPI20_CR_CPOL_Msk                     (0x01UL << SPI20_CR_CPOL_Pos)                           /*!< SPI20 CR: CPOL Mask                     */
#define SPI20_CR_CPHA_Pos                     3                                                       /*!< SPI20 CR: CPHA Position                 */
#define SPI20_CR_CPHA_Msk                     (0x01UL << SPI20_CR_CPHA_Pos)                           /*!< SPI20 CR: CPHA Mask                     */
#define SPI20_CR_MSBF_Pos                     4                                                       /*!< SPI20 CR: MSBF Position                 */
#define SPI20_CR_MSBF_Msk                     (0x01UL << SPI20_CR_MSBF_Pos)                           /*!< SPI20 CR: MSBF Mask                     */
#define SPI20_CR_MS_Pos                       5                                                       /*!< SPI20 CR: MS Position                   */
#define SPI20_CR_MS_Msk                       (0x01UL << SPI20_CR_MS_Pos)                             /*!< SPI20 CR: MS Mask                       */
#define SPI20_CR_SSPOL_Pos                    8                                                       /*!< SPI20 CR: SSPOL Position                */
#define SPI20_CR_SSPOL_Msk                    (0x01UL << SPI20_CR_SSPOL_Pos)                          /*!< SPI20 CR: SSPOL Mask                    */
#define SPI20_CR_SSMO_Pos                     9                                                       /*!< SPI20 CR: SSMO Position                 */
#define SPI20_CR_SSMO_Msk                     (0x01UL << SPI20_CR_SSMO_Pos)                           /*!< SPI20 CR: SSMO Mask                     */
#define SPI20_CR_SSMASK_Pos                   10                                                      /*!< SPI20 CR: SSMASK Position               */
#define SPI20_CR_SSMASK_Msk                   (0x01UL << SPI20_CR_SSMASK_Pos)                         /*!< SPI20 CR: SSMASK Mask                   */
#define SPI20_CR_LBE_Pos                      11                                                      /*!< SPI20 CR: LBE Position                  */
#define SPI20_CR_LBE_Msk                      (0x01UL << SPI20_CR_LBE_Pos)                            /*!< SPI20 CR: LBE Mask                      */
#define SPI20_CR_SSOUT_Pos                    12                                                      /*!< SPI20 CR: SSOUT Position                */
#define SPI20_CR_SSOUT_Msk                    (0x01UL << SPI20_CR_SSOUT_Pos)                          /*!< SPI20 CR: SSOUT Mask                    */
#define SPI20_CR_SSMOD_Pos                    13                                                      /*!< SPI20 CR: SSMOD Position                */
#define SPI20_CR_SSMOD_Msk                    (0x01UL << SPI20_CR_SSMOD_Pos)                          /*!< SPI20 CR: SSMOD Mask                    */
#define SPI20_CR_RXIE_Pos                     14                                                      /*!< SPI20 CR: RXIE Position                 */
#define SPI20_CR_RXIE_Msk                     (0x01UL << SPI20_CR_RXIE_Pos)                           /*!< SPI20 CR: RXIE Mask                     */
#define SPI20_CR_TXIE_Pos                     15                                                      /*!< SPI20 CR: TXIE Position                 */
#define SPI20_CR_TXIE_Msk                     (0x01UL << SPI20_CR_TXIE_Pos)                           /*!< SPI20 CR: TXIE Mask                     */
#define SPI20_CR_SSCIE_Pos                    16                                                      /*!< SPI20 CR: SSCIE Position                */
#define SPI20_CR_SSCIE_Msk                    (0x01UL << SPI20_CR_SSCIE_Pos)                          /*!< SPI20 CR: SSCIE Mask                    */
#define SPI20_CR_RXDIE_Pos                    17                                                      /*!< SPI20 CR: RXDIE Position                */
#define SPI20_CR_RXDIE_Msk                    (0x01UL << SPI20_CR_RXDIE_Pos)                          /*!< SPI20 CR: RXDIE Mask                    */
#define SPI20_CR_TXDIE_Pos                    18                                                      /*!< SPI20 CR: TXDIE Position                */
#define SPI20_CR_TXDIE_Msk                    (0x01UL << SPI20_CR_TXDIE_Pos)                          /*!< SPI20 CR: TXDIE Mask                    */
#define SPI20_CR_RXBC_Pos                     19                                                      /*!< SPI20 CR: RXBC Position                 */
#define SPI20_CR_RXBC_Msk                     (0x01UL << SPI20_CR_RXBC_Pos)                           /*!< SPI20 CR: RXBC Mask                     */
#define SPI20_CR_TXBC_Pos                     20                                                      /*!< SPI20 CR: TXBC Position                 */
#define SPI20_CR_TXBC_Msk                     (0x01UL << SPI20_CR_TXBC_Pos)                           /*!< SPI20 CR: TXBC Mask                     */

/* ----------------------------------  SPI20_SR  ---------------------------------- */
#define SPI20_SR_RRDY_Pos                     0                                                       /*!< SPI20 SR: RRDY Position                 */
#define SPI20_SR_RRDY_Msk                     (0x01UL << SPI20_SR_RRDY_Pos)                           /*!< SPI20 SR: RRDY Mask                     */
#define SPI20_SR_TRDY_Pos                     1                                                       /*!< SPI20 SR: TRDY Position                 */
#define SPI20_SR_TRDY_Msk                     (0x01UL << SPI20_SR_TRDY_Pos)                           /*!< SPI20 SR: TRDY Mask                     */
#define SPI20_SR_TXIDLE_Pos                   2                                                       /*!< SPI20 SR: TXIDLE Position               */
#define SPI20_SR_TXIDLE_Msk                   (0x01UL << SPI20_SR_TXIDLE_Pos)                         /*!< SPI20 SR: TXIDLE Mask                   */
#define SPI20_SR_UDRF_Pos                     3                                                       /*!< SPI20 SR: UDRF Position                 */
#define SPI20_SR_UDRF_Msk                     (0x01UL << SPI20_SR_UDRF_Pos)                           /*!< SPI20 SR: UDRF Mask                     */
#define SPI20_SR_OVRF_Pos                     4                                                       /*!< SPI20 SR: OVRF Position                 */
#define SPI20_SR_OVRF_Msk                     (0x01UL << SPI20_SR_OVRF_Pos)                           /*!< SPI20 SR: OVRF Mask                     */
#define SPI20_SR_SSON_Pos                     5                                                       /*!< SPI20 SR: SSON Position                 */
#define SPI20_SR_SSON_Msk                     (0x01UL << SPI20_SR_SSON_Pos)                           /*!< SPI20 SR: SSON Mask                     */
#define SPI20_SR_SSDET_Pos                    6                                                       /*!< SPI20 SR: SSDET Position                */
#define SPI20_SR_SSDET_Msk                    (0x01UL << SPI20_SR_SSDET_Pos)                          /*!< SPI20 SR: SSDET Mask                    */
#define SPI20_SR_SBUSY_Pos                    7                                                       /*!< SPI20 SR: SBUSY Position                */
#define SPI20_SR_SBUSY_Msk                    (0x01UL << SPI20_SR_SBUSY_Pos)                          /*!< SPI20 SR: SBUSY Mask                    */
#define SPI20_SR_RXDMAF_Pos                   8                                                       /*!< SPI20 SR: RXDMAF Position               */
#define SPI20_SR_RXDMAF_Msk                   (0x01UL << SPI20_SR_RXDMAF_Pos)                         /*!< SPI20 SR: RXDMAF Mask                   */
#define SPI20_SR_TXDMAF_Pos                   9                                                       /*!< SPI20 SR: TXDMAF Position               */
#define SPI20_SR_TXDMAF_Msk                   (0x01UL << SPI20_SR_TXDMAF_Pos)                         /*!< SPI20 SR: TXDMAF Mask                   */

/* ----------------------------------  SPI20_BR  ---------------------------------- */
#define SPI20_BR_BR_Pos                       0                                                       /*!< SPI20 BR: BR Position                   */
#define SPI20_BR_BR_Msk                       (0x0000ffffUL << SPI20_BR_BR_Pos)                       /*!< SPI20 BR: BR Mask                       */

/* ----------------------------------  SPI20_EN  ---------------------------------- */
#define SPI20_EN_ENABLE_Pos                   0                                                       /*!< SPI20 EN: ENABLE Position               */
#define SPI20_EN_ENABLE_Msk                   (0x01UL << SPI20_EN_ENABLE_Pos)                         /*!< SPI20 EN: ENABLE Mask                   */

/* ----------------------------------  SPI20_LR  ---------------------------------- */
#define SPI20_LR_STL_Pos                      0                                                       /*!< SPI20 LR: STL Position                  */
#define SPI20_LR_STL_Msk                      (0x000000ffUL << SPI20_LR_STL_Pos)                      /*!< SPI20 LR: STL Mask                      */
#define SPI20_LR_BTL_Pos                      8                                                       /*!< SPI20 LR: BTL Position                  */
#define SPI20_LR_BTL_Msk                      (0x000000ffUL << SPI20_LR_BTL_Pos)                      /*!< SPI20 LR: BTL Mask                      */
#define SPI20_LR_SPL_Pos                      16                                                      /*!< SPI20 LR: SPL Position                  */
#define SPI20_LR_SPL_Msk                      (0x000000ffUL << SPI20_LR_SPL_Pos)                      /*!< SPI20 LR: SPL Mask                      */


/* ================================================================================ */
/* ================         struct 'SPI21' Position & Mask         ================ */
/* ================================================================================ */


/* ----------------------------------  SPI21_RDR  --------------------------------- */
#define SPI21_RDR_RDR_Pos                     0                                                       /*!< SPI21 RDR: RDR Position                 */
#define SPI21_RDR_RDR_Msk                     (0x0001ffffUL << SPI21_RDR_RDR_Pos)                     /*!< SPI21 RDR: RDR Mask                     */

/* ----------------------------------  SPI21_TDR  --------------------------------- */
#define SPI21_TDR_TDR_Pos                     0                                                       /*!< SPI21 TDR: TDR Position                 */
#define SPI21_TDR_TDR_Msk                     (0x0001ffffUL << SPI21_TDR_TDR_Pos)                     /*!< SPI21 TDR: TDR Mask                     */

/* ----------------------------------  SPI21_CR  ---------------------------------- */
#define SPI21_CR_BITSZ_Pos                    0                                                       /*!< SPI21 CR: BITSZ Position                */
#define SPI21_CR_BITSZ_Msk                    (0x03UL << SPI21_CR_BITSZ_Pos)                          /*!< SPI21 CR: BITSZ Mask                    */
#define SPI21_CR_CPOL_Pos                     2                                                       /*!< SPI21 CR: CPOL Position                 */
#define SPI21_CR_CPOL_Msk                     (0x01UL << SPI21_CR_CPOL_Pos)                           /*!< SPI21 CR: CPOL Mask                     */
#define SPI21_CR_CPHA_Pos                     3                                                       /*!< SPI21 CR: CPHA Position                 */
#define SPI21_CR_CPHA_Msk                     (0x01UL << SPI21_CR_CPHA_Pos)                           /*!< SPI21 CR: CPHA Mask                     */
#define SPI21_CR_MSBF_Pos                     4                                                       /*!< SPI21 CR: MSBF Position                 */
#define SPI21_CR_MSBF_Msk                     (0x01UL << SPI21_CR_MSBF_Pos)                           /*!< SPI21 CR: MSBF Mask                     */
#define SPI21_CR_MS_Pos                       5                                                       /*!< SPI21 CR: MS Position                   */
#define SPI21_CR_MS_Msk                       (0x01UL << SPI21_CR_MS_Pos)                             /*!< SPI21 CR: MS Mask                       */
#define SPI21_CR_SSPOL_Pos                    8                                                       /*!< SPI21 CR: SSPOL Position                */
#define SPI21_CR_SSPOL_Msk                    (0x01UL << SPI21_CR_SSPOL_Pos)                          /*!< SPI21 CR: SSPOL Mask                    */
#define SPI21_CR_SSMO_Pos                     9                                                       /*!< SPI21 CR: SSMO Position                 */
#define SPI21_CR_SSMO_Msk                     (0x01UL << SPI21_CR_SSMO_Pos)                           /*!< SPI21 CR: SSMO Mask                     */
#define SPI21_CR_SSMASK_Pos                   10                                                      /*!< SPI21 CR: SSMASK Position               */
#define SPI21_CR_SSMASK_Msk                   (0x01UL << SPI21_CR_SSMASK_Pos)                         /*!< SPI21 CR: SSMASK Mask                   */
#define SPI21_CR_LBE_Pos                      11                                                      /*!< SPI21 CR: LBE Position                  */
#define SPI21_CR_LBE_Msk                      (0x01UL << SPI21_CR_LBE_Pos)                            /*!< SPI21 CR: LBE Mask                      */
#define SPI21_CR_SSOUT_Pos                    12                                                      /*!< SPI21 CR: SSOUT Position                */
#define SPI21_CR_SSOUT_Msk                    (0x01UL << SPI21_CR_SSOUT_Pos)                          /*!< SPI21 CR: SSOUT Mask                    */
#define SPI21_CR_SSMOD_Pos                    13                                                      /*!< SPI21 CR: SSMOD Position                */
#define SPI21_CR_SSMOD_Msk                    (0x01UL << SPI21_CR_SSMOD_Pos)                          /*!< SPI21 CR: SSMOD Mask                    */
#define SPI21_CR_RXIE_Pos                     14                                                      /*!< SPI21 CR: RXIE Position                 */
#define SPI21_CR_RXIE_Msk                     (0x01UL << SPI21_CR_RXIE_Pos)                           /*!< SPI21 CR: RXIE Mask                     */
#define SPI21_CR_TXIE_Pos                     15                                                      /*!< SPI21 CR: TXIE Position                 */
#define SPI21_CR_TXIE_Msk                     (0x01UL << SPI21_CR_TXIE_Pos)                           /*!< SPI21 CR: TXIE Mask                     */
#define SPI21_CR_SSCIE_Pos                    16                                                      /*!< SPI21 CR: SSCIE Position                */
#define SPI21_CR_SSCIE_Msk                    (0x01UL << SPI21_CR_SSCIE_Pos)                          /*!< SPI21 CR: SSCIE Mask                    */
#define SPI21_CR_RXDIE_Pos                    17                                                      /*!< SPI21 CR: RXDIE Position                */
#define SPI21_CR_RXDIE_Msk                    (0x01UL << SPI21_CR_RXDIE_Pos)                          /*!< SPI21 CR: RXDIE Mask                    */
#define SPI21_CR_TXDIE_Pos                    18                                                      /*!< SPI21 CR: TXDIE Position                */
#define SPI21_CR_TXDIE_Msk                    (0x01UL << SPI21_CR_TXDIE_Pos)                          /*!< SPI21 CR: TXDIE Mask                    */
#define SPI21_CR_RXBC_Pos                     19                                                      /*!< SPI21 CR: RXBC Position                 */
#define SPI21_CR_RXBC_Msk                     (0x01UL << SPI21_CR_RXBC_Pos)                           /*!< SPI21 CR: RXBC Mask                     */
#define SPI21_CR_TXBC_Pos                     20                                                      /*!< SPI21 CR: TXBC Position                 */
#define SPI21_CR_TXBC_Msk                     (0x01UL << SPI21_CR_TXBC_Pos)                           /*!< SPI21 CR: TXBC Mask                     */

/* ----------------------------------  SPI21_SR  ---------------------------------- */
#define SPI21_SR_RRDY_Pos                     0                                                       /*!< SPI21 SR: RRDY Position                 */
#define SPI21_SR_RRDY_Msk                     (0x01UL << SPI21_SR_RRDY_Pos)                           /*!< SPI21 SR: RRDY Mask                     */
#define SPI21_SR_TRDY_Pos                     1                                                       /*!< SPI21 SR: TRDY Position                 */
#define SPI21_SR_TRDY_Msk                     (0x01UL << SPI21_SR_TRDY_Pos)                           /*!< SPI21 SR: TRDY Mask                     */
#define SPI21_SR_TXIDLE_Pos                   2                                                       /*!< SPI21 SR: TXIDLE Position               */
#define SPI21_SR_TXIDLE_Msk                   (0x01UL << SPI21_SR_TXIDLE_Pos)                         /*!< SPI21 SR: TXIDLE Mask                   */
#define SPI21_SR_UDRF_Pos                     3                                                       /*!< SPI21 SR: UDRF Position                 */
#define SPI21_SR_UDRF_Msk                     (0x01UL << SPI21_SR_UDRF_Pos)                           /*!< SPI21 SR: UDRF Mask                     */
#define SPI21_SR_OVRF_Pos                     4                                                       /*!< SPI21 SR: OVRF Position                 */
#define SPI21_SR_OVRF_Msk                     (0x01UL << SPI21_SR_OVRF_Pos)                           /*!< SPI21 SR: OVRF Mask                     */
#define SPI21_SR_SSON_Pos                     5                                                       /*!< SPI21 SR: SSON Position                 */
#define SPI21_SR_SSON_Msk                     (0x01UL << SPI21_SR_SSON_Pos)                           /*!< SPI21 SR: SSON Mask                     */
#define SPI21_SR_SSDET_Pos                    6                                                       /*!< SPI21 SR: SSDET Position                */
#define SPI21_SR_SSDET_Msk                    (0x01UL << SPI21_SR_SSDET_Pos)                          /*!< SPI21 SR: SSDET Mask                    */
#define SPI21_SR_SBUSY_Pos                    7                                                       /*!< SPI21 SR: SBUSY Position                */
#define SPI21_SR_SBUSY_Msk                    (0x01UL << SPI21_SR_SBUSY_Pos)                          /*!< SPI21 SR: SBUSY Mask                    */
#define SPI21_SR_RXDMAF_Pos                   8                                                       /*!< SPI21 SR: RXDMAF Position               */
#define SPI21_SR_RXDMAF_Msk                   (0x01UL << SPI21_SR_RXDMAF_Pos)                         /*!< SPI21 SR: RXDMAF Mask                   */
#define SPI21_SR_TXDMAF_Pos                   9                                                       /*!< SPI21 SR: TXDMAF Position               */
#define SPI21_SR_TXDMAF_Msk                   (0x01UL << SPI21_SR_TXDMAF_Pos)                         /*!< SPI21 SR: TXDMAF Mask                   */

/* ----------------------------------  SPI21_BR  ---------------------------------- */
#define SPI21_BR_BR_Pos                       0                                                       /*!< SPI21 BR: BR Position                   */
#define SPI21_BR_BR_Msk                       (0x0000ffffUL << SPI21_BR_BR_Pos)                       /*!< SPI21 BR: BR Mask                       */

/* ----------------------------------  SPI21_EN  ---------------------------------- */
#define SPI21_EN_ENABLE_Pos                   0                                                       /*!< SPI21 EN: ENABLE Position               */
#define SPI21_EN_ENABLE_Msk                   (0x01UL << SPI21_EN_ENABLE_Pos)                         /*!< SPI21 EN: ENABLE Mask                   */

/* ----------------------------------  SPI21_LR  ---------------------------------- */
#define SPI21_LR_STL_Pos                      0                                                       /*!< SPI21 LR: STL Position                  */
#define SPI21_LR_STL_Msk                      (0x000000ffUL << SPI21_LR_STL_Pos)                      /*!< SPI21 LR: STL Mask                      */
#define SPI21_LR_BTL_Pos                      8                                                       /*!< SPI21 LR: BTL Position                  */
#define SPI21_LR_BTL_Msk                      (0x000000ffUL << SPI21_LR_BTL_Pos)                      /*!< SPI21 LR: BTL Mask                      */
#define SPI21_LR_SPL_Pos                      16                                                      /*!< SPI21 LR: SPL Position                  */
#define SPI21_LR_SPL_Msk                      (0x000000ffUL << SPI21_LR_SPL_Pos)                      /*!< SPI21 LR: SPL Mask                      */


/* ================================================================================ */
/* ================           Group 'I2C' Position & Mask          ================ */
/* ================================================================================ */


/* -----------------------------------  I2C_CR  ----------------------------------- */
#define I2C_CR_STARTC_Pos                     0                                                       /*!< I2C CR: STARTC Position                 */
#define I2C_CR_STARTC_Msk                     (0x01UL << I2C_CR_STARTC_Pos)                           /*!< I2C CR: STARTC Mask                     */
#define I2C_CR_STOPC_Pos                      1                                                       /*!< I2C CR: STOPC Position                  */
#define I2C_CR_STOPC_Msk                      (0x01UL << I2C_CR_STOPC_Pos)                            /*!< I2C CR: STOPC Mask                      */
#define I2C_CR_IMASTER_Pos                    2                                                       /*!< I2C CR: IMASTER Position                */
#define I2C_CR_IMASTER_Msk                    (0x01UL << I2C_CR_IMASTER_Pos)                          /*!< I2C CR: IMASTER Mask                    */
#define I2C_CR_ACKEN_Pos                      3                                                       /*!< I2C CR: ACKEN Position                  */
#define I2C_CR_ACKEN_Msk                      (0x01UL << I2C_CR_ACKEN_Pos)                            /*!< I2C CR: ACKEN Mask                      */
#define I2C_CR_IFLAG_Pos                      4                                                       /*!< I2C CR: IFLAG Position                  */
#define I2C_CR_IFLAG_Msk                      (0x01UL << I2C_CR_IFLAG_Pos)                            /*!< I2C CR: IFLAG Mask                      */
#define I2C_CR_IEN_Pos                        5                                                       /*!< I2C CR: IEN Position                    */
#define I2C_CR_IEN_Msk                        (0x01UL << I2C_CR_IEN_Pos)                              /*!< I2C CR: IEN Mask                        */
#define I2C_CR_TXDLYENB_Pos                   6                                                       /*!< I2C CR: TXDLYENB Position               */
#define I2C_CR_TXDLYENB_Msk                   (0x01UL << I2C_CR_TXDLYENB_Pos)                         /*!< I2C CR: TXDLYENB Mask                   */
#define I2C_CR_EN_Pos                         7                                                       /*!< I2C CR: EN Position                     */
#define I2C_CR_EN_Msk                         (0x01UL << I2C_CR_EN_Pos)                               /*!< I2C CR: EN Mask                         */
#define I2C_CR_INTERVAL_Pos                   8                                                       /*!< I2C CR: INTERVAL Position               */
#define I2C_CR_INTERVAL_Msk                   (0x03UL << I2C_CR_INTERVAL_Pos)                         /*!< I2C CR: INTERVAL Mask                   */

/* -----------------------------------  I2C_ST  ----------------------------------- */
#define I2C_ST_RXACK_Pos                      0                                                       /*!< I2C ST: RXACK Position                  */
#define I2C_ST_RXACK_Msk                      (0x01UL << I2C_ST_RXACK_Pos)                            /*!< I2C ST: RXACK Mask                      */
#define I2C_ST_TMODE_Pos                      1                                                       /*!< I2C ST: TMODE Position                  */
#define I2C_ST_TMODE_Msk                      (0x01UL << I2C_ST_TMODE_Pos)                            /*!< I2C ST: TMODE Mask                      */
#define I2C_ST_BUSY_Pos                       2                                                       /*!< I2C ST: BUSY Position                   */
#define I2C_ST_BUSY_Msk                       (0x01UL << I2C_ST_BUSY_Pos)                             /*!< I2C ST: BUSY Mask                       */
#define I2C_ST_MLOST_Pos                      3                                                       /*!< I2C ST: MLOST Position                  */
#define I2C_ST_MLOST_Msk                      (0x01UL << I2C_ST_MLOST_Pos)                            /*!< I2C ST: MLOST Mask                      */
#define I2C_ST_SSEL_Pos                       4                                                       /*!< I2C ST: SSEL Position                   */
#define I2C_ST_SSEL_Msk                       (0x01UL << I2C_ST_SSEL_Pos)                             /*!< I2C ST: SSEL Mask                       */
#define I2C_ST_STOPD_Pos                      5                                                       /*!< I2C ST: STOPD Position                  */
#define I2C_ST_STOPD_Msk                      (0x01UL << I2C_ST_STOPD_Pos)                            /*!< I2C ST: STOPD Mask                      */
#define I2C_ST_TEND_Pos                       6                                                       /*!< I2C ST: TEND Position                   */
#define I2C_ST_TEND_Msk                       (0x01UL << I2C_ST_TEND_Pos)                             /*!< I2C ST: TEND Mask                       */
#define I2C_ST_GCALL_Pos                      7                                                       /*!< I2C ST: GCALL Position                  */
#define I2C_ST_GCALL_Msk                      (0x01UL << I2C_ST_GCALL_Pos)                            /*!< I2C ST: GCALL Mask                      */
#define I2C_ST_SLT_Pos                        31                                                      /*!< I2C ST: SLT Position                    */
#define I2C_ST_SLT_Msk                        (0x01UL << I2C_ST_SLT_Pos)                              /*!< I2C ST: SLT Mask                        */

/* ----------------------------------  I2C_SAR1  ---------------------------------- */
#define I2C_SAR1_GCALLEN_Pos                  0                                                       /*!< I2C SAR1: GCALLEN Position              */
#define I2C_SAR1_GCALLEN_Msk                  (0x01UL << I2C_SAR1_GCALLEN_Pos)                        /*!< I2C SAR1: GCALLEN Mask                  */
#define I2C_SAR1_SLA_Pos                      1                                                       /*!< I2C SAR1: SLA Position                  */
#define I2C_SAR1_SLA_Msk                      (0x7fUL << I2C_SAR1_SLA_Pos)                            /*!< I2C SAR1: SLA Mask                      */

/* ----------------------------------  I2C_SAR2  ---------------------------------- */
#define I2C_SAR2_GCALLEN_Pos                  0                                                       /*!< I2C SAR2: GCALLEN Position              */
#define I2C_SAR2_GCALLEN_Msk                  (0x01UL << I2C_SAR2_GCALLEN_Pos)                        /*!< I2C SAR2: GCALLEN Mask                  */
#define I2C_SAR2_SLA_Pos                      1                                                       /*!< I2C SAR2: SLA Position                  */
#define I2C_SAR2_SLA_Msk                      (0x7fUL << I2C_SAR2_SLA_Pos)                            /*!< I2C SAR2: SLA Mask                      */

/* -----------------------------------  I2C_DR  ----------------------------------- */
#define I2C_DR_DATA_Pos                       0                                                       /*!< I2C DR: DATA Position                   */
#define I2C_DR_DATA_Msk                       (0x000000ffUL << I2C_DR_DATA_Pos)                       /*!< I2C DR: DATA Mask                       */

/* ----------------------------------  I2C_SDHR  ---------------------------------- */
#define I2C_SDHR_HLDT_Pos                     0                                                       /*!< I2C SDHR: HLDT Position                 */
#define I2C_SDHR_HLDT_Msk                     (0x00000fffUL << I2C_SDHR_HLDT_Pos)                     /*!< I2C SDHR: HLDT Mask                     */

/* ----------------------------------  I2C_SCLR  ---------------------------------- */
#define I2C_SCLR_SCLL_Pos                     0                                                       /*!< I2C SCLR: SCLL Position                 */
#define I2C_SCLR_SCLL_Msk                     (0x00000fffUL << I2C_SCLR_SCLL_Pos)                     /*!< I2C SCLR: SCLL Mask                     */

/* ----------------------------------  I2C_SCHR  ---------------------------------- */
#define I2C_SCHR_SCLH_Pos                     0                                                       /*!< I2C SCHR: SCLH Position                 */
#define I2C_SCHR_SCLH_Msk                     (0x00000fffUL << I2C_SCHR_SCLH_Pos)                     /*!< I2C SCHR: SCLH Mask                     */

/* ----------------------------------  I2C_SLTCR  --------------------------------- */
#define I2C_SLTCR_SLTEN_Pos                   0                                                       /*!< I2C SLTCR: SLTEN Position               */
#define I2C_SLTCR_SLTEN_Msk                   (0x01UL << I2C_SLTCR_SLTEN_Pos)                         /*!< I2C SLTCR: SLTEN Mask                   */
#define I2C_SLTCR_SLTINT_Pos                  1                                                       /*!< I2C SLTCR: SLTINT Position              */
#define I2C_SLTCR_SLTINT_Msk                  (0x01UL << I2C_SLTCR_SLTINT_Pos)                        /*!< I2C SLTCR: SLTINT Mask                  */

/* ---------------------------------  I2C_SLTPDR  --------------------------------- */
#define I2C_SLTPDR_PDATA_Pos                  0                                                       /*!< I2C SLTPDR: PDATA Position              */
#define I2C_SLTPDR_PDATA_Msk                  (0x00ffffffUL << I2C_SLTPDR_PDATA_Pos)                  /*!< I2C SLTPDR: PDATA Mask                  */

/* ----------------------------------  I2C_MBCR  ---------------------------------- */
#define I2C_MBCR_SDAMCE_Pos                   0                                                       /*!< I2C MBCR: SDAMCE Position               */
#define I2C_MBCR_SDAMCE_Msk                   (0x01UL << I2C_MBCR_SDAMCE_Pos)                         /*!< I2C MBCR: SDAMCE Mask                   */
#define I2C_MBCR_SCLMCE_Pos                   1                                                       /*!< I2C MBCR: SCLMCE Position               */
#define I2C_MBCR_SCLMCE_Msk                   (0x01UL << I2C_MBCR_SCLMCE_Pos)                         /*!< I2C MBCR: SCLMCE Mask                   */
#define I2C_MBCR_SDAO_Pos                     2                                                       /*!< I2C MBCR: SDAO Position                 */
#define I2C_MBCR_SDAO_Msk                     (0x01UL << I2C_MBCR_SDAO_Pos)                           /*!< I2C MBCR: SDAO Mask                     */
#define I2C_MBCR_SCLO_Pos                     3                                                       /*!< I2C MBCR: SCLO Position                 */
#define I2C_MBCR_SCLO_Msk                     (0x01UL << I2C_MBCR_SCLO_Pos)                           /*!< I2C MBCR: SCLO Mask                     */
#define I2C_MBCR_SDAS_Pos                     8                                                       /*!< I2C MBCR: SDAS Position                 */
#define I2C_MBCR_SDAS_Msk                     (0x01UL << I2C_MBCR_SDAS_Pos)                           /*!< I2C MBCR: SDAS Mask                     */
#define I2C_MBCR_SCLS_Pos                     9                                                       /*!< I2C MBCR: SCLS Position                 */
#define I2C_MBCR_SCLS_Msk                     (0x01UL << I2C_MBCR_SCLS_Pos)                           /*!< I2C MBCR: SCLS Mask                     */


/* ================================================================================ */
/* ================          struct 'I2C0' Position & Mask         ================ */
/* ================================================================================ */


/* -----------------------------------  I2C0_CR  ---------------------------------- */
#define I2C0_CR_STARTC_Pos                    0                                                       /*!< I2C0 CR: STARTC Position                */
#define I2C0_CR_STARTC_Msk                    (0x01UL << I2C0_CR_STARTC_Pos)                          /*!< I2C0 CR: STARTC Mask                    */
#define I2C0_CR_STOPC_Pos                     1                                                       /*!< I2C0 CR: STOPC Position                 */
#define I2C0_CR_STOPC_Msk                     (0x01UL << I2C0_CR_STOPC_Pos)                           /*!< I2C0 CR: STOPC Mask                     */
#define I2C0_CR_IMASTER_Pos                   2                                                       /*!< I2C0 CR: IMASTER Position               */
#define I2C0_CR_IMASTER_Msk                   (0x01UL << I2C0_CR_IMASTER_Pos)                         /*!< I2C0 CR: IMASTER Mask                   */
#define I2C0_CR_ACKEN_Pos                     3                                                       /*!< I2C0 CR: ACKEN Position                 */
#define I2C0_CR_ACKEN_Msk                     (0x01UL << I2C0_CR_ACKEN_Pos)                           /*!< I2C0 CR: ACKEN Mask                     */
#define I2C0_CR_IFLAG_Pos                     4                                                       /*!< I2C0 CR: IFLAG Position                 */
#define I2C0_CR_IFLAG_Msk                     (0x01UL << I2C0_CR_IFLAG_Pos)                           /*!< I2C0 CR: IFLAG Mask                     */
#define I2C0_CR_IEN_Pos                       5                                                       /*!< I2C0 CR: IEN Position                   */
#define I2C0_CR_IEN_Msk                       (0x01UL << I2C0_CR_IEN_Pos)                             /*!< I2C0 CR: IEN Mask                       */
#define I2C0_CR_TXDLYENB_Pos                  6                                                       /*!< I2C0 CR: TXDLYENB Position              */
#define I2C0_CR_TXDLYENB_Msk                  (0x01UL << I2C0_CR_TXDLYENB_Pos)                        /*!< I2C0 CR: TXDLYENB Mask                  */
#define I2C0_CR_EN_Pos                        7                                                       /*!< I2C0 CR: EN Position                    */
#define I2C0_CR_EN_Msk                        (0x01UL << I2C0_CR_EN_Pos)                              /*!< I2C0 CR: EN Mask                        */
#define I2C0_CR_INTERVAL_Pos                  8                                                       /*!< I2C0 CR: INTERVAL Position              */
#define I2C0_CR_INTERVAL_Msk                  (0x03UL << I2C0_CR_INTERVAL_Pos)                        /*!< I2C0 CR: INTERVAL Mask                  */

/* -----------------------------------  I2C0_ST  ---------------------------------- */
#define I2C0_ST_RXACK_Pos                     0                                                       /*!< I2C0 ST: RXACK Position                 */
#define I2C0_ST_RXACK_Msk                     (0x01UL << I2C0_ST_RXACK_Pos)                           /*!< I2C0 ST: RXACK Mask                     */
#define I2C0_ST_TMODE_Pos                     1                                                       /*!< I2C0 ST: TMODE Position                 */
#define I2C0_ST_TMODE_Msk                     (0x01UL << I2C0_ST_TMODE_Pos)                           /*!< I2C0 ST: TMODE Mask                     */
#define I2C0_ST_BUSY_Pos                      2                                                       /*!< I2C0 ST: BUSY Position                  */
#define I2C0_ST_BUSY_Msk                      (0x01UL << I2C0_ST_BUSY_Pos)                            /*!< I2C0 ST: BUSY Mask                      */
#define I2C0_ST_MLOST_Pos                     3                                                       /*!< I2C0 ST: MLOST Position                 */
#define I2C0_ST_MLOST_Msk                     (0x01UL << I2C0_ST_MLOST_Pos)                           /*!< I2C0 ST: MLOST Mask                     */
#define I2C0_ST_SSEL_Pos                      4                                                       /*!< I2C0 ST: SSEL Position                  */
#define I2C0_ST_SSEL_Msk                      (0x01UL << I2C0_ST_SSEL_Pos)                            /*!< I2C0 ST: SSEL Mask                      */
#define I2C0_ST_STOPD_Pos                     5                                                       /*!< I2C0 ST: STOPD Position                 */
#define I2C0_ST_STOPD_Msk                     (0x01UL << I2C0_ST_STOPD_Pos)                           /*!< I2C0 ST: STOPD Mask                     */
#define I2C0_ST_TEND_Pos                      6                                                       /*!< I2C0 ST: TEND Position                  */
#define I2C0_ST_TEND_Msk                      (0x01UL << I2C0_ST_TEND_Pos)                            /*!< I2C0 ST: TEND Mask                      */
#define I2C0_ST_GCALL_Pos                     7                                                       /*!< I2C0 ST: GCALL Position                 */
#define I2C0_ST_GCALL_Msk                     (0x01UL << I2C0_ST_GCALL_Pos)                           /*!< I2C0 ST: GCALL Mask                     */
#define I2C0_ST_SLT_Pos                       31                                                      /*!< I2C0 ST: SLT Position                   */
#define I2C0_ST_SLT_Msk                       (0x01UL << I2C0_ST_SLT_Pos)                             /*!< I2C0 ST: SLT Mask                       */

/* ----------------------------------  I2C0_SAR1  --------------------------------- */
#define I2C0_SAR1_GCALLEN_Pos                 0                                                       /*!< I2C0 SAR1: GCALLEN Position             */
#define I2C0_SAR1_GCALLEN_Msk                 (0x01UL << I2C0_SAR1_GCALLEN_Pos)                       /*!< I2C0 SAR1: GCALLEN Mask                 */
#define I2C0_SAR1_SLA_Pos                     1                                                       /*!< I2C0 SAR1: SLA Position                 */
#define I2C0_SAR1_SLA_Msk                     (0x7fUL << I2C0_SAR1_SLA_Pos)                           /*!< I2C0 SAR1: SLA Mask                     */

/* ----------------------------------  I2C0_SAR2  --------------------------------- */
#define I2C0_SAR2_GCALLEN_Pos                 0                                                       /*!< I2C0 SAR2: GCALLEN Position             */
#define I2C0_SAR2_GCALLEN_Msk                 (0x01UL << I2C0_SAR2_GCALLEN_Pos)                       /*!< I2C0 SAR2: GCALLEN Mask                 */
#define I2C0_SAR2_SLA_Pos                     1                                                       /*!< I2C0 SAR2: SLA Position                 */
#define I2C0_SAR2_SLA_Msk                     (0x7fUL << I2C0_SAR2_SLA_Pos)                           /*!< I2C0 SAR2: SLA Mask                     */

/* -----------------------------------  I2C0_DR  ---------------------------------- */
#define I2C0_DR_DATA_Pos                      0                                                       /*!< I2C0 DR: DATA Position                  */
#define I2C0_DR_DATA_Msk                      (0x000000ffUL << I2C0_DR_DATA_Pos)                      /*!< I2C0 DR: DATA Mask                      */

/* ----------------------------------  I2C0_SDHR  --------------------------------- */
#define I2C0_SDHR_HLDT_Pos                    0                                                       /*!< I2C0 SDHR: HLDT Position                */
#define I2C0_SDHR_HLDT_Msk                    (0x00000fffUL << I2C0_SDHR_HLDT_Pos)                    /*!< I2C0 SDHR: HLDT Mask                    */

/* ----------------------------------  I2C0_SCLR  --------------------------------- */
#define I2C0_SCLR_SCLL_Pos                    0                                                       /*!< I2C0 SCLR: SCLL Position                */
#define I2C0_SCLR_SCLL_Msk                    (0x00000fffUL << I2C0_SCLR_SCLL_Pos)                    /*!< I2C0 SCLR: SCLL Mask                    */

/* ----------------------------------  I2C0_SCHR  --------------------------------- */
#define I2C0_SCHR_SCLH_Pos                    0                                                       /*!< I2C0 SCHR: SCLH Position                */
#define I2C0_SCHR_SCLH_Msk                    (0x00000fffUL << I2C0_SCHR_SCLH_Pos)                    /*!< I2C0 SCHR: SCLH Mask                    */

/* ---------------------------------  I2C0_SLTCR  --------------------------------- */
#define I2C0_SLTCR_SLTEN_Pos                  0                                                       /*!< I2C0 SLTCR: SLTEN Position              */
#define I2C0_SLTCR_SLTEN_Msk                  (0x01UL << I2C0_SLTCR_SLTEN_Pos)                        /*!< I2C0 SLTCR: SLTEN Mask                  */
#define I2C0_SLTCR_SLTINT_Pos                 1                                                       /*!< I2C0 SLTCR: SLTINT Position             */
#define I2C0_SLTCR_SLTINT_Msk                 (0x01UL << I2C0_SLTCR_SLTINT_Pos)                       /*!< I2C0 SLTCR: SLTINT Mask                 */

/* ---------------------------------  I2C0_SLTPDR  -------------------------------- */
#define I2C0_SLTPDR_PDATA_Pos                 0                                                       /*!< I2C0 SLTPDR: PDATA Position             */
#define I2C0_SLTPDR_PDATA_Msk                 (0x00ffffffUL << I2C0_SLTPDR_PDATA_Pos)                 /*!< I2C0 SLTPDR: PDATA Mask                 */

/* ----------------------------------  I2C0_MBCR  --------------------------------- */
#define I2C0_MBCR_SDAMCE_Pos                  0                                                       /*!< I2C0 MBCR: SDAMCE Position              */
#define I2C0_MBCR_SDAMCE_Msk                  (0x01UL << I2C0_MBCR_SDAMCE_Pos)                        /*!< I2C0 MBCR: SDAMCE Mask                  */
#define I2C0_MBCR_SCLMCE_Pos                  1                                                       /*!< I2C0 MBCR: SCLMCE Position              */
#define I2C0_MBCR_SCLMCE_Msk                  (0x01UL << I2C0_MBCR_SCLMCE_Pos)                        /*!< I2C0 MBCR: SCLMCE Mask                  */
#define I2C0_MBCR_SDAO_Pos                    2                                                       /*!< I2C0 MBCR: SDAO Position                */
#define I2C0_MBCR_SDAO_Msk                    (0x01UL << I2C0_MBCR_SDAO_Pos)                          /*!< I2C0 MBCR: SDAO Mask                    */
#define I2C0_MBCR_SCLO_Pos                    3                                                       /*!< I2C0 MBCR: SCLO Position                */
#define I2C0_MBCR_SCLO_Msk                    (0x01UL << I2C0_MBCR_SCLO_Pos)                          /*!< I2C0 MBCR: SCLO Mask                    */
#define I2C0_MBCR_SDAS_Pos                    8                                                       /*!< I2C0 MBCR: SDAS Position                */
#define I2C0_MBCR_SDAS_Msk                    (0x01UL << I2C0_MBCR_SDAS_Pos)                          /*!< I2C0 MBCR: SDAS Mask                    */
#define I2C0_MBCR_SCLS_Pos                    9                                                       /*!< I2C0 MBCR: SCLS Position                */
#define I2C0_MBCR_SCLS_Msk                    (0x01UL << I2C0_MBCR_SCLS_Pos)                          /*!< I2C0 MBCR: SCLS Mask                    */


/* ================================================================================ */
/* ================          struct 'I2C1' Position & Mask         ================ */
/* ================================================================================ */


/* -----------------------------------  I2C1_CR  ---------------------------------- */
#define I2C1_CR_STARTC_Pos                    0                                                       /*!< I2C1 CR: STARTC Position                */
#define I2C1_CR_STARTC_Msk                    (0x01UL << I2C1_CR_STARTC_Pos)                          /*!< I2C1 CR: STARTC Mask                    */
#define I2C1_CR_STOPC_Pos                     1                                                       /*!< I2C1 CR: STOPC Position                 */
#define I2C1_CR_STOPC_Msk                     (0x01UL << I2C1_CR_STOPC_Pos)                           /*!< I2C1 CR: STOPC Mask                     */
#define I2C1_CR_IMASTER_Pos                   2                                                       /*!< I2C1 CR: IMASTER Position               */
#define I2C1_CR_IMASTER_Msk                   (0x01UL << I2C1_CR_IMASTER_Pos)                         /*!< I2C1 CR: IMASTER Mask                   */
#define I2C1_CR_ACKEN_Pos                     3                                                       /*!< I2C1 CR: ACKEN Position                 */
#define I2C1_CR_ACKEN_Msk                     (0x01UL << I2C1_CR_ACKEN_Pos)                           /*!< I2C1 CR: ACKEN Mask                     */
#define I2C1_CR_IFLAG_Pos                     4                                                       /*!< I2C1 CR: IFLAG Position                 */
#define I2C1_CR_IFLAG_Msk                     (0x01UL << I2C1_CR_IFLAG_Pos)                           /*!< I2C1 CR: IFLAG Mask                     */
#define I2C1_CR_IEN_Pos                       5                                                       /*!< I2C1 CR: IEN Position                   */
#define I2C1_CR_IEN_Msk                       (0x01UL << I2C1_CR_IEN_Pos)                             /*!< I2C1 CR: IEN Mask                       */
#define I2C1_CR_TXDLYENB_Pos                  6                                                       /*!< I2C1 CR: TXDLYENB Position              */
#define I2C1_CR_TXDLYENB_Msk                  (0x01UL << I2C1_CR_TXDLYENB_Pos)                        /*!< I2C1 CR: TXDLYENB Mask                  */
#define I2C1_CR_EN_Pos                        7                                                       /*!< I2C1 CR: EN Position                    */
#define I2C1_CR_EN_Msk                        (0x01UL << I2C1_CR_EN_Pos)                              /*!< I2C1 CR: EN Mask                        */
#define I2C1_CR_INTERVAL_Pos                  8                                                       /*!< I2C1 CR: INTERVAL Position              */
#define I2C1_CR_INTERVAL_Msk                  (0x03UL << I2C1_CR_INTERVAL_Pos)                        /*!< I2C1 CR: INTERVAL Mask                  */

/* -----------------------------------  I2C1_ST  ---------------------------------- */
#define I2C1_ST_RXACK_Pos                     0                                                       /*!< I2C1 ST: RXACK Position                 */
#define I2C1_ST_RXACK_Msk                     (0x01UL << I2C1_ST_RXACK_Pos)                           /*!< I2C1 ST: RXACK Mask                     */
#define I2C1_ST_TMODE_Pos                     1                                                       /*!< I2C1 ST: TMODE Position                 */
#define I2C1_ST_TMODE_Msk                     (0x01UL << I2C1_ST_TMODE_Pos)                           /*!< I2C1 ST: TMODE Mask                     */
#define I2C1_ST_BUSY_Pos                      2                                                       /*!< I2C1 ST: BUSY Position                  */
#define I2C1_ST_BUSY_Msk                      (0x01UL << I2C1_ST_BUSY_Pos)                            /*!< I2C1 ST: BUSY Mask                      */
#define I2C1_ST_MLOST_Pos                     3                                                       /*!< I2C1 ST: MLOST Position                 */
#define I2C1_ST_MLOST_Msk                     (0x01UL << I2C1_ST_MLOST_Pos)                           /*!< I2C1 ST: MLOST Mask                     */
#define I2C1_ST_SSEL_Pos                      4                                                       /*!< I2C1 ST: SSEL Position                  */
#define I2C1_ST_SSEL_Msk                      (0x01UL << I2C1_ST_SSEL_Pos)                            /*!< I2C1 ST: SSEL Mask                      */
#define I2C1_ST_STOPD_Pos                     5                                                       /*!< I2C1 ST: STOPD Position                 */
#define I2C1_ST_STOPD_Msk                     (0x01UL << I2C1_ST_STOPD_Pos)                           /*!< I2C1 ST: STOPD Mask                     */
#define I2C1_ST_TEND_Pos                      6                                                       /*!< I2C1 ST: TEND Position                  */
#define I2C1_ST_TEND_Msk                      (0x01UL << I2C1_ST_TEND_Pos)                            /*!< I2C1 ST: TEND Mask                      */
#define I2C1_ST_GCALL_Pos                     7                                                       /*!< I2C1 ST: GCALL Position                 */
#define I2C1_ST_GCALL_Msk                     (0x01UL << I2C1_ST_GCALL_Pos)                           /*!< I2C1 ST: GCALL Mask                     */
#define I2C1_ST_SLT_Pos                       31                                                      /*!< I2C1 ST: SLT Position                   */
#define I2C1_ST_SLT_Msk                       (0x01UL << I2C1_ST_SLT_Pos)                             /*!< I2C1 ST: SLT Mask                       */

/* ----------------------------------  I2C1_SAR1  --------------------------------- */
#define I2C1_SAR1_GCALLEN_Pos                 0                                                       /*!< I2C1 SAR1: GCALLEN Position             */
#define I2C1_SAR1_GCALLEN_Msk                 (0x01UL << I2C1_SAR1_GCALLEN_Pos)                       /*!< I2C1 SAR1: GCALLEN Mask                 */
#define I2C1_SAR1_SLA_Pos                     1                                                       /*!< I2C1 SAR1: SLA Position                 */
#define I2C1_SAR1_SLA_Msk                     (0x7fUL << I2C1_SAR1_SLA_Pos)                           /*!< I2C1 SAR1: SLA Mask                     */

/* ----------------------------------  I2C1_SAR2  --------------------------------- */
#define I2C1_SAR2_GCALLEN_Pos                 0                                                       /*!< I2C1 SAR2: GCALLEN Position             */
#define I2C1_SAR2_GCALLEN_Msk                 (0x01UL << I2C1_SAR2_GCALLEN_Pos)                       /*!< I2C1 SAR2: GCALLEN Mask                 */
#define I2C1_SAR2_SLA_Pos                     1                                                       /*!< I2C1 SAR2: SLA Position                 */
#define I2C1_SAR2_SLA_Msk                     (0x7fUL << I2C1_SAR2_SLA_Pos)                           /*!< I2C1 SAR2: SLA Mask                     */

/* -----------------------------------  I2C1_DR  ---------------------------------- */
#define I2C1_DR_DATA_Pos                      0                                                       /*!< I2C1 DR: DATA Position                  */
#define I2C1_DR_DATA_Msk                      (0x000000ffUL << I2C1_DR_DATA_Pos)                      /*!< I2C1 DR: DATA Mask                      */

/* ----------------------------------  I2C1_SDHR  --------------------------------- */
#define I2C1_SDHR_HLDT_Pos                    0                                                       /*!< I2C1 SDHR: HLDT Position                */
#define I2C1_SDHR_HLDT_Msk                    (0x00000fffUL << I2C1_SDHR_HLDT_Pos)                    /*!< I2C1 SDHR: HLDT Mask                    */

/* ----------------------------------  I2C1_SCLR  --------------------------------- */
#define I2C1_SCLR_SCLL_Pos                    0                                                       /*!< I2C1 SCLR: SCLL Position                */
#define I2C1_SCLR_SCLL_Msk                    (0x00000fffUL << I2C1_SCLR_SCLL_Pos)                    /*!< I2C1 SCLR: SCLL Mask                    */

/* ----------------------------------  I2C1_SCHR  --------------------------------- */
#define I2C1_SCHR_SCLH_Pos                    0                                                       /*!< I2C1 SCHR: SCLH Position                */
#define I2C1_SCHR_SCLH_Msk                    (0x00000fffUL << I2C1_SCHR_SCLH_Pos)                    /*!< I2C1 SCHR: SCLH Mask                    */

/* ---------------------------------  I2C1_SLTCR  --------------------------------- */
#define I2C1_SLTCR_SLTEN_Pos                  0                                                       /*!< I2C1 SLTCR: SLTEN Position              */
#define I2C1_SLTCR_SLTEN_Msk                  (0x01UL << I2C1_SLTCR_SLTEN_Pos)                        /*!< I2C1 SLTCR: SLTEN Mask                  */
#define I2C1_SLTCR_SLTINT_Pos                 1                                                       /*!< I2C1 SLTCR: SLTINT Position             */
#define I2C1_SLTCR_SLTINT_Msk                 (0x01UL << I2C1_SLTCR_SLTINT_Pos)                       /*!< I2C1 SLTCR: SLTINT Mask                 */

/* ---------------------------------  I2C1_SLTPDR  -------------------------------- */
#define I2C1_SLTPDR_PDATA_Pos                 0                                                       /*!< I2C1 SLTPDR: PDATA Position             */
#define I2C1_SLTPDR_PDATA_Msk                 (0x00ffffffUL << I2C1_SLTPDR_PDATA_Pos)                 /*!< I2C1 SLTPDR: PDATA Mask                 */

/* ----------------------------------  I2C1_MBCR  --------------------------------- */
#define I2C1_MBCR_SDAMCE_Pos                  0                                                       /*!< I2C1 MBCR: SDAMCE Position              */
#define I2C1_MBCR_SDAMCE_Msk                  (0x01UL << I2C1_MBCR_SDAMCE_Pos)                        /*!< I2C1 MBCR: SDAMCE Mask                  */
#define I2C1_MBCR_SCLMCE_Pos                  1                                                       /*!< I2C1 MBCR: SCLMCE Position              */
#define I2C1_MBCR_SCLMCE_Msk                  (0x01UL << I2C1_MBCR_SCLMCE_Pos)                        /*!< I2C1 MBCR: SCLMCE Mask                  */
#define I2C1_MBCR_SDAO_Pos                    2                                                       /*!< I2C1 MBCR: SDAO Position                */
#define I2C1_MBCR_SDAO_Msk                    (0x01UL << I2C1_MBCR_SDAO_Pos)                          /*!< I2C1 MBCR: SDAO Mask                    */
#define I2C1_MBCR_SCLO_Pos                    3                                                       /*!< I2C1 MBCR: SCLO Position                */
#define I2C1_MBCR_SCLO_Msk                    (0x01UL << I2C1_MBCR_SCLO_Pos)                          /*!< I2C1 MBCR: SCLO Mask                    */
#define I2C1_MBCR_SDAS_Pos                    8                                                       /*!< I2C1 MBCR: SDAS Position                */
#define I2C1_MBCR_SDAS_Msk                    (0x01UL << I2C1_MBCR_SDAS_Pos)                          /*!< I2C1 MBCR: SDAS Mask                    */
#define I2C1_MBCR_SCLS_Pos                    9                                                       /*!< I2C1 MBCR: SCLS Position                */
#define I2C1_MBCR_SCLS_Msk                    (0x01UL << I2C1_MBCR_SCLS_Pos)                          /*!< I2C1 MBCR: SCLS Mask                    */


/* ================================================================================ */
/* ================          struct 'I2C2' Position & Mask         ================ */
/* ================================================================================ */


/* -----------------------------------  I2C2_CR  ---------------------------------- */
#define I2C2_CR_STARTC_Pos                    0                                                       /*!< I2C2 CR: STARTC Position                */
#define I2C2_CR_STARTC_Msk                    (0x01UL << I2C2_CR_STARTC_Pos)                          /*!< I2C2 CR: STARTC Mask                    */
#define I2C2_CR_STOPC_Pos                     1                                                       /*!< I2C2 CR: STOPC Position                 */
#define I2C2_CR_STOPC_Msk                     (0x01UL << I2C2_CR_STOPC_Pos)                           /*!< I2C2 CR: STOPC Mask                     */
#define I2C2_CR_IMASTER_Pos                   2                                                       /*!< I2C2 CR: IMASTER Position               */
#define I2C2_CR_IMASTER_Msk                   (0x01UL << I2C2_CR_IMASTER_Pos)                         /*!< I2C2 CR: IMASTER Mask                   */
#define I2C2_CR_ACKEN_Pos                     3                                                       /*!< I2C2 CR: ACKEN Position                 */
#define I2C2_CR_ACKEN_Msk                     (0x01UL << I2C2_CR_ACKEN_Pos)                           /*!< I2C2 CR: ACKEN Mask                     */
#define I2C2_CR_IFLAG_Pos                     4                                                       /*!< I2C2 CR: IFLAG Position                 */
#define I2C2_CR_IFLAG_Msk                     (0x01UL << I2C2_CR_IFLAG_Pos)                           /*!< I2C2 CR: IFLAG Mask                     */
#define I2C2_CR_IEN_Pos                       5                                                       /*!< I2C2 CR: IEN Position                   */
#define I2C2_CR_IEN_Msk                       (0x01UL << I2C2_CR_IEN_Pos)                             /*!< I2C2 CR: IEN Mask                       */
#define I2C2_CR_TXDLYENB_Pos                  6                                                       /*!< I2C2 CR: TXDLYENB Position              */
#define I2C2_CR_TXDLYENB_Msk                  (0x01UL << I2C2_CR_TXDLYENB_Pos)                        /*!< I2C2 CR: TXDLYENB Mask                  */
#define I2C2_CR_EN_Pos                        7                                                       /*!< I2C2 CR: EN Position                    */
#define I2C2_CR_EN_Msk                        (0x01UL << I2C2_CR_EN_Pos)                              /*!< I2C2 CR: EN Mask                        */
#define I2C2_CR_INTERVAL_Pos                  8                                                       /*!< I2C2 CR: INTERVAL Position              */
#define I2C2_CR_INTERVAL_Msk                  (0x03UL << I2C2_CR_INTERVAL_Pos)                        /*!< I2C2 CR: INTERVAL Mask                  */

/* -----------------------------------  I2C2_ST  ---------------------------------- */
#define I2C2_ST_RXACK_Pos                     0                                                       /*!< I2C2 ST: RXACK Position                 */
#define I2C2_ST_RXACK_Msk                     (0x01UL << I2C2_ST_RXACK_Pos)                           /*!< I2C2 ST: RXACK Mask                     */
#define I2C2_ST_TMODE_Pos                     1                                                       /*!< I2C2 ST: TMODE Position                 */
#define I2C2_ST_TMODE_Msk                     (0x01UL << I2C2_ST_TMODE_Pos)                           /*!< I2C2 ST: TMODE Mask                     */
#define I2C2_ST_BUSY_Pos                      2                                                       /*!< I2C2 ST: BUSY Position                  */
#define I2C2_ST_BUSY_Msk                      (0x01UL << I2C2_ST_BUSY_Pos)                            /*!< I2C2 ST: BUSY Mask                      */
#define I2C2_ST_MLOST_Pos                     3                                                       /*!< I2C2 ST: MLOST Position                 */
#define I2C2_ST_MLOST_Msk                     (0x01UL << I2C2_ST_MLOST_Pos)                           /*!< I2C2 ST: MLOST Mask                     */
#define I2C2_ST_SSEL_Pos                      4                                                       /*!< I2C2 ST: SSEL Position                  */
#define I2C2_ST_SSEL_Msk                      (0x01UL << I2C2_ST_SSEL_Pos)                            /*!< I2C2 ST: SSEL Mask                      */
#define I2C2_ST_STOPD_Pos                     5                                                       /*!< I2C2 ST: STOPD Position                 */
#define I2C2_ST_STOPD_Msk                     (0x01UL << I2C2_ST_STOPD_Pos)                           /*!< I2C2 ST: STOPD Mask                     */
#define I2C2_ST_TEND_Pos                      6                                                       /*!< I2C2 ST: TEND Position                  */
#define I2C2_ST_TEND_Msk                      (0x01UL << I2C2_ST_TEND_Pos)                            /*!< I2C2 ST: TEND Mask                      */
#define I2C2_ST_GCALL_Pos                     7                                                       /*!< I2C2 ST: GCALL Position                 */
#define I2C2_ST_GCALL_Msk                     (0x01UL << I2C2_ST_GCALL_Pos)                           /*!< I2C2 ST: GCALL Mask                     */
#define I2C2_ST_SLT_Pos                       31                                                      /*!< I2C2 ST: SLT Position                   */
#define I2C2_ST_SLT_Msk                       (0x01UL << I2C2_ST_SLT_Pos)                             /*!< I2C2 ST: SLT Mask                       */

/* ----------------------------------  I2C2_SAR1  --------------------------------- */
#define I2C2_SAR1_GCALLEN_Pos                 0                                                       /*!< I2C2 SAR1: GCALLEN Position             */
#define I2C2_SAR1_GCALLEN_Msk                 (0x01UL << I2C2_SAR1_GCALLEN_Pos)                       /*!< I2C2 SAR1: GCALLEN Mask                 */
#define I2C2_SAR1_SLA_Pos                     1                                                       /*!< I2C2 SAR1: SLA Position                 */
#define I2C2_SAR1_SLA_Msk                     (0x7fUL << I2C2_SAR1_SLA_Pos)                           /*!< I2C2 SAR1: SLA Mask                     */

/* ----------------------------------  I2C2_SAR2  --------------------------------- */
#define I2C2_SAR2_GCALLEN_Pos                 0                                                       /*!< I2C2 SAR2: GCALLEN Position             */
#define I2C2_SAR2_GCALLEN_Msk                 (0x01UL << I2C2_SAR2_GCALLEN_Pos)                       /*!< I2C2 SAR2: GCALLEN Mask                 */
#define I2C2_SAR2_SLA_Pos                     1                                                       /*!< I2C2 SAR2: SLA Position                 */
#define I2C2_SAR2_SLA_Msk                     (0x7fUL << I2C2_SAR2_SLA_Pos)                           /*!< I2C2 SAR2: SLA Mask                     */

/* -----------------------------------  I2C2_DR  ---------------------------------- */
#define I2C2_DR_DATA_Pos                      0                                                       /*!< I2C2 DR: DATA Position                  */
#define I2C2_DR_DATA_Msk                      (0x000000ffUL << I2C2_DR_DATA_Pos)                      /*!< I2C2 DR: DATA Mask                      */

/* ----------------------------------  I2C2_SDHR  --------------------------------- */
#define I2C2_SDHR_HLDT_Pos                    0                                                       /*!< I2C2 SDHR: HLDT Position                */
#define I2C2_SDHR_HLDT_Msk                    (0x00000fffUL << I2C2_SDHR_HLDT_Pos)                    /*!< I2C2 SDHR: HLDT Mask                    */

/* ----------------------------------  I2C2_SCLR  --------------------------------- */
#define I2C2_SCLR_SCLL_Pos                    0                                                       /*!< I2C2 SCLR: SCLL Position                */
#define I2C2_SCLR_SCLL_Msk                    (0x00000fffUL << I2C2_SCLR_SCLL_Pos)                    /*!< I2C2 SCLR: SCLL Mask                    */

/* ----------------------------------  I2C2_SCHR  --------------------------------- */
#define I2C2_SCHR_SCLH_Pos                    0                                                       /*!< I2C2 SCHR: SCLH Position                */
#define I2C2_SCHR_SCLH_Msk                    (0x00000fffUL << I2C2_SCHR_SCLH_Pos)                    /*!< I2C2 SCHR: SCLH Mask                    */

/* ---------------------------------  I2C2_SLTCR  --------------------------------- */
#define I2C2_SLTCR_SLTEN_Pos                  0                                                       /*!< I2C2 SLTCR: SLTEN Position              */
#define I2C2_SLTCR_SLTEN_Msk                  (0x01UL << I2C2_SLTCR_SLTEN_Pos)                        /*!< I2C2 SLTCR: SLTEN Mask                  */
#define I2C2_SLTCR_SLTINT_Pos                 1                                                       /*!< I2C2 SLTCR: SLTINT Position             */
#define I2C2_SLTCR_SLTINT_Msk                 (0x01UL << I2C2_SLTCR_SLTINT_Pos)                       /*!< I2C2 SLTCR: SLTINT Mask                 */

/* ---------------------------------  I2C2_SLTPDR  -------------------------------- */
#define I2C2_SLTPDR_PDATA_Pos                 0                                                       /*!< I2C2 SLTPDR: PDATA Position             */
#define I2C2_SLTPDR_PDATA_Msk                 (0x00ffffffUL << I2C2_SLTPDR_PDATA_Pos)                 /*!< I2C2 SLTPDR: PDATA Mask                 */

/* ----------------------------------  I2C2_MBCR  --------------------------------- */
#define I2C2_MBCR_SDAMCE_Pos                  0                                                       /*!< I2C2 MBCR: SDAMCE Position              */
#define I2C2_MBCR_SDAMCE_Msk                  (0x01UL << I2C2_MBCR_SDAMCE_Pos)                        /*!< I2C2 MBCR: SDAMCE Mask                  */
#define I2C2_MBCR_SCLMCE_Pos                  1                                                       /*!< I2C2 MBCR: SCLMCE Position              */
#define I2C2_MBCR_SCLMCE_Msk                  (0x01UL << I2C2_MBCR_SCLMCE_Pos)                        /*!< I2C2 MBCR: SCLMCE Mask                  */
#define I2C2_MBCR_SDAO_Pos                    2                                                       /*!< I2C2 MBCR: SDAO Position                */
#define I2C2_MBCR_SDAO_Msk                    (0x01UL << I2C2_MBCR_SDAO_Pos)                          /*!< I2C2 MBCR: SDAO Mask                    */
#define I2C2_MBCR_SCLO_Pos                    3                                                       /*!< I2C2 MBCR: SCLO Position                */
#define I2C2_MBCR_SCLO_Msk                    (0x01UL << I2C2_MBCR_SCLO_Pos)                          /*!< I2C2 MBCR: SCLO Mask                    */
#define I2C2_MBCR_SDAS_Pos                    8                                                       /*!< I2C2 MBCR: SDAS Position                */
#define I2C2_MBCR_SDAS_Msk                    (0x01UL << I2C2_MBCR_SDAS_Pos)                          /*!< I2C2 MBCR: SDAS Mask                    */
#define I2C2_MBCR_SCLS_Pos                    9                                                       /*!< I2C2 MBCR: SCLS Position                */
#define I2C2_MBCR_SCLS_Msk                    (0x01UL << I2C2_MBCR_SCLS_Pos)                          /*!< I2C2 MBCR: SCLS Mask                    */


/* ================================================================================ */
/* ================          struct 'ADC' Position & Mask          ================ */
/* ================================================================================ */


/* -----------------------------------  ADC_MR  ----------------------------------- */
#define ADC_MR_TRGSEL_Pos                     0                                                       /*!< ADC MR: TRGSEL Position                 */
#define ADC_MR_TRGSEL_Msk                     (0x03UL << ADC_MR_TRGSEL_Pos)                           /*!< ADC MR: TRGSEL Mask                     */
#define ADC_MR_ADMOD_Pos                      4                                                       /*!< ADC MR: ADMOD Position                  */
#define ADC_MR_ADMOD_Msk                      (0x03UL << ADC_MR_ADMOD_Pos)                            /*!< ADC MR: ADMOD Mask                      */
#define ADC_MR_ARST_Pos                       6                                                       /*!< ADC MR: ARST Position                   */
#define ADC_MR_ARST_Msk                       (0x01UL << ADC_MR_ARST_Pos)                             /*!< ADC MR: ARST Mask                       */
#define ADC_MR_ADEN_Pos                       7                                                       /*!< ADC MR: ADEN Position                   */
#define ADC_MR_ADEN_Msk                       (0x01UL << ADC_MR_ADEN_Pos)                             /*!< ADC MR: ADEN Mask                       */
#define ADC_MR_SEQCNT_Pos                     8                                                       /*!< ADC MR: SEQCNT Position                 */
#define ADC_MR_SEQCNT_Msk                     (0x07UL << ADC_MR_SEQCNT_Pos)                           /*!< ADC MR: SEQCNT Mask                     */
#define ADC_MR_STSEL_Pos                      12                                                      /*!< ADC MR: STSEL Position                  */
#define ADC_MR_STSEL_Msk                      (0x1fUL << ADC_MR_STSEL_Pos)                            /*!< ADC MR: STSEL Mask                      */
#define ADC_MR_DMAEN_Pos                      17                                                      /*!< ADC MR: DMAEN Position                  */
#define ADC_MR_DMAEN_Msk                      (0x01UL << ADC_MR_DMAEN_Pos)                            /*!< ADC MR: DMAEN Mask                      */
#define ADC_MR_CHINFO_Pos                     20                                                      /*!< ADC MR: CHINFO Position                 */
#define ADC_MR_CHINFO_Msk                     (0x01UL << ADC_MR_CHINFO_Pos)                           /*!< ADC MR: CHINFO Mask                     */
#define ADC_MR_TRGINFO_Pos                    21                                                      /*!< ADC MR: TRGINFO Position                */
#define ADC_MR_TRGINFO_Msk                    (0x01UL << ADC_MR_TRGINFO_Pos)                          /*!< ADC MR: TRGINFO Mask                    */

/* ----------------------------------  ADC_CSCR  ---------------------------------- */
#define ADC_CSCR_CACH_Pos                     0                                                       /*!< ADC CSCR: CACH Position                 */
#define ADC_CSCR_CACH_Msk                     (0x1fUL << ADC_CSCR_CACH_Pos)                           /*!< ADC CSCR: CACH Mask                     */
#define ADC_CSCR_CSEQN_Pos                    8                                                       /*!< ADC CSCR: CSEQN Position                */
#define ADC_CSCR_CSEQN_Msk                    (0x07UL << ADC_CSCR_CSEQN_Pos)                          /*!< ADC CSCR: CSEQN Mask                    */

/* -----------------------------------  ADC_CCR  ---------------------------------- */
#define ADC_CCR_CLKINVT_Pos                   5                                                       /*!< ADC CCR: CLKINVT Position               */
#define ADC_CCR_CLKINVT_Msk                   (0x01UL << ADC_CCR_CLKINVT_Pos)                         /*!< ADC CCR: CLKINVT Mask                   */
#define ADC_CCR_EXTCLK_Pos                    6                                                       /*!< ADC CCR: EXTCLK Position                */
#define ADC_CCR_EXTCLK_Msk                    (0x01UL << ADC_CCR_EXTCLK_Pos)                          /*!< ADC CCR: EXTCLK Mask                    */
#define ADC_CCR_ADCPD_Pos                     7                                                       /*!< ADC CCR: ADCPD Position                 */
#define ADC_CCR_ADCPD_Msk                     (0x01UL << ADC_CCR_ADCPD_Pos)                           /*!< ADC CCR: ADCPD Mask                     */
#define ADC_CCR_CLKDIV_Pos                    8                                                       /*!< ADC CCR: CLKDIV Position                */
#define ADC_CCR_CLKDIV_Msk                    (0x7fUL << ADC_CCR_CLKDIV_Pos)                          /*!< ADC CCR: CLKDIV Mask                    */

/* -----------------------------------  ADC_TRG  ---------------------------------- */
#define ADC_TRG_SEQTRG0_BSTTRG_Pos            0                                                       /*!< ADC TRG: SEQTRG0_BSTTRG Position        */
#define ADC_TRG_SEQTRG0_BSTTRG_Msk            (0x0fUL << ADC_TRG_SEQTRG0_BSTTRG_Pos)                  /*!< ADC TRG: SEQTRG0_BSTTRG Mask            */
#define ADC_TRG_SEQTRG1_Pos                   4                                                       /*!< ADC TRG: SEQTRG1 Position               */
#define ADC_TRG_SEQTRG1_Msk                   (0x0fUL << ADC_TRG_SEQTRG1_Pos)                         /*!< ADC TRG: SEQTRG1 Mask                   */
#define ADC_TRG_SEQTRG2_Pos                   8                                                       /*!< ADC TRG: SEQTRG2 Position               */
#define ADC_TRG_SEQTRG2_Msk                   (0x0fUL << ADC_TRG_SEQTRG2_Pos)                         /*!< ADC TRG: SEQTRG2 Mask                   */
#define ADC_TRG_SEQTRG3_Pos                   12                                                      /*!< ADC TRG: SEQTRG3 Position               */
#define ADC_TRG_SEQTRG3_Msk                   (0x0fUL << ADC_TRG_SEQTRG3_Pos)                         /*!< ADC TRG: SEQTRG3 Mask                   */
#define ADC_TRG_SEQTRG4_Pos                   16                                                      /*!< ADC TRG: SEQTRG4 Position               */
#define ADC_TRG_SEQTRG4_Msk                   (0x0fUL << ADC_TRG_SEQTRG4_Pos)                         /*!< ADC TRG: SEQTRG4 Mask                   */
#define ADC_TRG_SEQTRG5_Pos                   20                                                      /*!< ADC TRG: SEQTRG5 Position               */
#define ADC_TRG_SEQTRG5_Msk                   (0x0fUL << ADC_TRG_SEQTRG5_Pos)                         /*!< ADC TRG: SEQTRG5 Mask                   */
#define ADC_TRG_SEQTRG6_Pos                   24                                                      /*!< ADC TRG: SEQTRG6 Position               */
#define ADC_TRG_SEQTRG6_Msk                   (0x0fUL << ADC_TRG_SEQTRG6_Pos)                         /*!< ADC TRG: SEQTRG6 Mask                   */
#define ADC_TRG_SEQTRG7_Pos                   28                                                      /*!< ADC TRG: SEQTRG7 Position               */
#define ADC_TRG_SEQTRG7_Msk                   (0x0fUL << ADC_TRG_SEQTRG7_Pos)                         /*!< ADC TRG: SEQTRG7 Mask                   */

/* ----------------------------------  ADC_SCSR1  --------------------------------- */
#define ADC_SCSR1_SEQ0CH_Pos                  0                                                       /*!< ADC SCSR1: SEQ0CH Position              */
#define ADC_SCSR1_SEQ0CH_Msk                  (0x1fUL << ADC_SCSR1_SEQ0CH_Pos)                        /*!< ADC SCSR1: SEQ0CH Mask                  */
#define ADC_SCSR1_SEQ1CH_Pos                  8                                                       /*!< ADC SCSR1: SEQ1CH Position              */
#define ADC_SCSR1_SEQ1CH_Msk                  (0x1fUL << ADC_SCSR1_SEQ1CH_Pos)                        /*!< ADC SCSR1: SEQ1CH Mask                  */
#define ADC_SCSR1_SEQ2CH_Pos                  16                                                      /*!< ADC SCSR1: SEQ2CH Position              */
#define ADC_SCSR1_SEQ2CH_Msk                  (0x1fUL << ADC_SCSR1_SEQ2CH_Pos)                        /*!< ADC SCSR1: SEQ2CH Mask                  */
#define ADC_SCSR1_SEQ3CH_Pos                  24                                                      /*!< ADC SCSR1: SEQ3CH Position              */
#define ADC_SCSR1_SEQ3CH_Msk                  (0x1fUL << ADC_SCSR1_SEQ3CH_Pos)                        /*!< ADC SCSR1: SEQ3CH Mask                  */

/* ----------------------------------  ADC_SCSR2  --------------------------------- */
#define ADC_SCSR2_SEQ4CH_Pos                  0                                                       /*!< ADC SCSR2: SEQ4CH Position              */
#define ADC_SCSR2_SEQ4CH_Msk                  (0x1fUL << ADC_SCSR2_SEQ4CH_Pos)                        /*!< ADC SCSR2: SEQ4CH Mask                  */
#define ADC_SCSR2_SEQ5CH_Pos                  8                                                       /*!< ADC SCSR2: SEQ5CH Position              */
#define ADC_SCSR2_SEQ5CH_Msk                  (0x1fUL << ADC_SCSR2_SEQ5CH_Pos)                        /*!< ADC SCSR2: SEQ5CH Mask                  */
#define ADC_SCSR2_SEQ6CH_Pos                  16                                                      /*!< ADC SCSR2: SEQ6CH Position              */
#define ADC_SCSR2_SEQ6CH_Msk                  (0x1fUL << ADC_SCSR2_SEQ6CH_Pos)                        /*!< ADC SCSR2: SEQ6CH Mask                  */
#define ADC_SCSR2_SEQ7CH_Pos                  24                                                      /*!< ADC SCSR2: SEQ7CH Position              */
#define ADC_SCSR2_SEQ7CH_Msk                  (0x1fUL << ADC_SCSR2_SEQ7CH_Pos)                        /*!< ADC SCSR2: SEQ7CH Mask                  */

/* -----------------------------------  ADC_CR  ----------------------------------- */
#define ADC_CR_ASTART_Pos                     0                                                       /*!< ADC CR: ASTART Position                 */
#define ADC_CR_ASTART_Msk                     (0x01UL << ADC_CR_ASTART_Pos)                           /*!< ADC CR: ASTART Mask                     */
#define ADC_CR_TRGCLR_Pos                     1                                                       /*!< ADC CR: TRGCLR Position                 */
#define ADC_CR_TRGCLR_Msk                     (0x01UL << ADC_CR_TRGCLR_Pos)                           /*!< ADC CR: TRGCLR Mask                     */
#define ADC_CR_ASTOP_Pos                      7                                                       /*!< ADC CR: ASTOP Position                  */
#define ADC_CR_ASTOP_Msk                      (0x01UL << ADC_CR_ASTOP_Pos)                            /*!< ADC CR: ASTOP Mask                      */

/* -----------------------------------  ADC_SR  ----------------------------------- */
#define ADC_SR_EOCIF_Pos                      0                                                       /*!< ADC SR: EOCIF Position                  */
#define ADC_SR_EOCIF_Msk                      (0x01UL << ADC_SR_EOCIF_Pos)                            /*!< ADC SR: EOCIF Mask                      */
#define ADC_SR_EOSIF_Pos                      2                                                       /*!< ADC SR: EOSIF Position                  */
#define ADC_SR_EOSIF_Msk                      (0x01UL << ADC_SR_EOSIF_Pos)                            /*!< ADC SR: EOSIF Mask                      */
#define ADC_SR_TRGIF_Pos                      3                                                       /*!< ADC SR: TRGIF Position                  */
#define ADC_SR_TRGIF_Msk                      (0x01UL << ADC_SR_TRGIF_Pos)                            /*!< ADC SR: TRGIF Mask                      */
#define ADC_SR_DMAIF_Pos                      4                                                       /*!< ADC SR: DMAIF Position                  */
#define ADC_SR_DMAIF_Msk                      (0x01UL << ADC_SR_DMAIF_Pos)                            /*!< ADC SR: DMAIF Mask                      */
#define ADC_SR_DOVRUN_Pos                     5                                                       /*!< ADC SR: DOVRUN Position                 */
#define ADC_SR_DOVRUN_Msk                     (0x01UL << ADC_SR_DOVRUN_Pos)                           /*!< ADC SR: DOVRUN Mask                     */
#define ADC_SR_CMPIFLG_Pos                    8                                                       /*!< ADC SR: CMPIFLG Position                */
#define ADC_SR_CMPIFLG_Msk                    (0x01UL << ADC_SR_CMPIFLG_Pos)                          /*!< ADC SR: CMPIFLG Mask                    */

/* -----------------------------------  ADC_IER  ---------------------------------- */
#define ADC_IER_EOCIE_Pos                     0                                                       /*!< ADC IER: EOCIE Position                 */
#define ADC_IER_EOCIE_Msk                     (0x01UL << ADC_IER_EOCIE_Pos)                           /*!< ADC IER: EOCIE Mask                     */
#define ADC_IER_EOSIE_Pos                     2                                                       /*!< ADC IER: EOSIE Position                 */
#define ADC_IER_EOSIE_Msk                     (0x01UL << ADC_IER_EOSIE_Pos)                           /*!< ADC IER: EOSIE Mask                     */
#define ADC_IER_TRGIE_Pos                     3                                                       /*!< ADC IER: TRGIE Position                 */
#define ADC_IER_TRGIE_Msk                     (0x01UL << ADC_IER_TRGIE_Pos)                           /*!< ADC IER: TRGIE Mask                     */
#define ADC_IER_DMAIE_Pos                     4                                                       /*!< ADC IER: DMAIE Position                 */
#define ADC_IER_DMAIE_Msk                     (0x01UL << ADC_IER_DMAIE_Pos)                           /*!< ADC IER: DMAIE Mask                     */

/* -----------------------------------  ADC_DDR  ---------------------------------- */
#define ADC_DDR_ADDMAR_Pos                    4                                                       /*!< ADC DDR: ADDMAR Position                */
#define ADC_DDR_ADDMAR_Msk                    (0x00000fffUL << ADC_DDR_ADDMAR_Pos)                    /*!< ADC DDR: ADDMAR Mask                    */
#define ADC_DDR_ADMACH_Pos                    16                                                      /*!< ADC DDR: ADMACH Position                */
#define ADC_DDR_ADMACH_Msk                    (0x1fUL << ADC_DDR_ADMACH_Pos)                          /*!< ADC DDR: ADMACH Mask                    */
#define ADC_DDR_TRGINFO0_Pos                  24                                                      /*!< ADC DDR: TRGINFO0 Position              */
#define ADC_DDR_TRGINFO0_Msk                  (0x01UL << ADC_DDR_TRGINFO0_Pos)                        /*!< ADC DDR: TRGINFO0 Mask                  */
#define ADC_DDR_TRGINFO1_Pos                  25                                                      /*!< ADC DDR: TRGINFO1 Position              */
#define ADC_DDR_TRGINFO1_Msk                  (0x01UL << ADC_DDR_TRGINFO1_Pos)                        /*!< ADC DDR: TRGINFO1 Mask                  */
#define ADC_DDR_TRGINFO2_Pos                  26                                                      /*!< ADC DDR: TRGINFO2 Position              */
#define ADC_DDR_TRGINFO2_Msk                  (0x01UL << ADC_DDR_TRGINFO2_Pos)                        /*!< ADC DDR: TRGINFO2 Mask                  */
#define ADC_DDR_TRGINFO3_Pos                  27                                                      /*!< ADC DDR: TRGINFO3 Position              */
#define ADC_DDR_TRGINFO3_Msk                  (0x01UL << ADC_DDR_TRGINFO3_Pos)                        /*!< ADC DDR: TRGINFO3 Mask                  */
#define ADC_DDR_TRGINFO4_Pos                  28                                                      /*!< ADC DDR: TRGINFO4 Position              */
#define ADC_DDR_TRGINFO4_Msk                  (0x01UL << ADC_DDR_TRGINFO4_Pos)                        /*!< ADC DDR: TRGINFO4 Mask                  */
#define ADC_DDR_TRGINFO5_Pos                  29                                                      /*!< ADC DDR: TRGINFO5 Position              */
#define ADC_DDR_TRGINFO5_Msk                  (0x01UL << ADC_DDR_TRGINFO5_Pos)                        /*!< ADC DDR: TRGINFO5 Mask                  */
#define ADC_DDR_TRGINFO6_Pos                  30                                                      /*!< ADC DDR: TRGINFO6 Position              */
#define ADC_DDR_TRGINFO6_Msk                  (0x01UL << ADC_DDR_TRGINFO6_Pos)                        /*!< ADC DDR: TRGINFO6 Mask                  */
#define ADC_DDR_TRGINFO7_Pos                  31                                                      /*!< ADC DDR: TRGINFO7 Position              */
#define ADC_DDR_TRGINFO7_Msk                  (0x01UL << ADC_DDR_TRGINFO7_Pos)                        /*!< ADC DDR: TRGINFO7 Mask                  */

/* -----------------------------------  ADC_DR0  ---------------------------------- */
#define ADC_DR0_ADDATA_Pos                    4                                                       /*!< ADC DR0: ADDATA Position                */
#define ADC_DR0_ADDATA_Msk                    (0x00000fffUL << ADC_DR0_ADDATA_Pos)                    /*!< ADC DR0: ADDATA Mask                    */
#define ADC_DR0_ACH_Pos                       16                                                      /*!< ADC DR0: ACH Position                   */
#define ADC_DR0_ACH_Msk                       (0x1fUL << ADC_DR0_ACH_Pos)                             /*!< ADC DR0: ACH Mask                       */
#define ADC_DR0_TRGINFO0_Pos                  24                                                      /*!< ADC DR0: TRGINFO0 Position              */
#define ADC_DR0_TRGINFO0_Msk                  (0x01UL << ADC_DR0_TRGINFO0_Pos)                        /*!< ADC DR0: TRGINFO0 Mask                  */
#define ADC_DR0_TRGINFO1_Pos                  25                                                      /*!< ADC DR0: TRGINFO1 Position              */
#define ADC_DR0_TRGINFO1_Msk                  (0x01UL << ADC_DR0_TRGINFO1_Pos)                        /*!< ADC DR0: TRGINFO1 Mask                  */
#define ADC_DR0_TRGINFO2_Pos                  26                                                      /*!< ADC DR0: TRGINFO2 Position              */
#define ADC_DR0_TRGINFO2_Msk                  (0x01UL << ADC_DR0_TRGINFO2_Pos)                        /*!< ADC DR0: TRGINFO2 Mask                  */
#define ADC_DR0_TRGINFO3_Pos                  27                                                      /*!< ADC DR0: TRGINFO3 Position              */
#define ADC_DR0_TRGINFO3_Msk                  (0x01UL << ADC_DR0_TRGINFO3_Pos)                        /*!< ADC DR0: TRGINFO3 Mask                  */
#define ADC_DR0_TRGINFO4_Pos                  28                                                      /*!< ADC DR0: TRGINFO4 Position              */
#define ADC_DR0_TRGINFO4_Msk                  (0x01UL << ADC_DR0_TRGINFO4_Pos)                        /*!< ADC DR0: TRGINFO4 Mask                  */
#define ADC_DR0_TRGINFO5_Pos                  29                                                      /*!< ADC DR0: TRGINFO5 Position              */
#define ADC_DR0_TRGINFO5_Msk                  (0x01UL << ADC_DR0_TRGINFO5_Pos)                        /*!< ADC DR0: TRGINFO5 Mask                  */
#define ADC_DR0_TRGINFO6_Pos                  30                                                      /*!< ADC DR0: TRGINFO6 Position              */
#define ADC_DR0_TRGINFO6_Msk                  (0x01UL << ADC_DR0_TRGINFO6_Pos)                        /*!< ADC DR0: TRGINFO6 Mask                  */
#define ADC_DR0_TRGINFO7_Pos                  31                                                      /*!< ADC DR0: TRGINFO7 Position              */
#define ADC_DR0_TRGINFO7_Msk                  (0x01UL << ADC_DR0_TRGINFO7_Pos)                        /*!< ADC DR0: TRGINFO7 Mask                  */

/* -----------------------------------  ADC_DR1  ---------------------------------- */
#define ADC_DR1_ADDATA_Pos                    4                                                       /*!< ADC DR1: ADDATA Position                */
#define ADC_DR1_ADDATA_Msk                    (0x00000fffUL << ADC_DR1_ADDATA_Pos)                    /*!< ADC DR1: ADDATA Mask                    */
#define ADC_DR1_ACH_Pos                       16                                                      /*!< ADC DR1: ACH Position                   */
#define ADC_DR1_ACH_Msk                       (0x1fUL << ADC_DR1_ACH_Pos)                             /*!< ADC DR1: ACH Mask                       */
#define ADC_DR1_TRGINFO0_Pos                  24                                                      /*!< ADC DR1: TRGINFO0 Position              */
#define ADC_DR1_TRGINFO0_Msk                  (0x01UL << ADC_DR1_TRGINFO0_Pos)                        /*!< ADC DR1: TRGINFO0 Mask                  */
#define ADC_DR1_TRGINFO1_Pos                  25                                                      /*!< ADC DR1: TRGINFO1 Position              */
#define ADC_DR1_TRGINFO1_Msk                  (0x01UL << ADC_DR1_TRGINFO1_Pos)                        /*!< ADC DR1: TRGINFO1 Mask                  */
#define ADC_DR1_TRGINFO2_Pos                  26                                                      /*!< ADC DR1: TRGINFO2 Position              */
#define ADC_DR1_TRGINFO2_Msk                  (0x01UL << ADC_DR1_TRGINFO2_Pos)                        /*!< ADC DR1: TRGINFO2 Mask                  */
#define ADC_DR1_TRGINFO3_Pos                  27                                                      /*!< ADC DR1: TRGINFO3 Position              */
#define ADC_DR1_TRGINFO3_Msk                  (0x01UL << ADC_DR1_TRGINFO3_Pos)                        /*!< ADC DR1: TRGINFO3 Mask                  */
#define ADC_DR1_TRGINFO4_Pos                  28                                                      /*!< ADC DR1: TRGINFO4 Position              */
#define ADC_DR1_TRGINFO4_Msk                  (0x01UL << ADC_DR1_TRGINFO4_Pos)                        /*!< ADC DR1: TRGINFO4 Mask                  */
#define ADC_DR1_TRGINFO5_Pos                  29                                                      /*!< ADC DR1: TRGINFO5 Position              */
#define ADC_DR1_TRGINFO5_Msk                  (0x01UL << ADC_DR1_TRGINFO5_Pos)                        /*!< ADC DR1: TRGINFO5 Mask                  */
#define ADC_DR1_TRGINFO6_Pos                  30                                                      /*!< ADC DR1: TRGINFO6 Position              */
#define ADC_DR1_TRGINFO6_Msk                  (0x01UL << ADC_DR1_TRGINFO6_Pos)                        /*!< ADC DR1: TRGINFO6 Mask                  */
#define ADC_DR1_TRGINFO7_Pos                  31                                                      /*!< ADC DR1: TRGINFO7 Position              */
#define ADC_DR1_TRGINFO7_Msk                  (0x01UL << ADC_DR1_TRGINFO7_Pos)                        /*!< ADC DR1: TRGINFO7 Mask                  */

/* -----------------------------------  ADC_DR2  ---------------------------------- */
#define ADC_DR2_ADDATA_Pos                    4                                                       /*!< ADC DR2: ADDATA Position                */
#define ADC_DR2_ADDATA_Msk                    (0x00000fffUL << ADC_DR2_ADDATA_Pos)                    /*!< ADC DR2: ADDATA Mask                    */
#define ADC_DR2_ACH_Pos                       16                                                      /*!< ADC DR2: ACH Position                   */
#define ADC_DR2_ACH_Msk                       (0x1fUL << ADC_DR2_ACH_Pos)                             /*!< ADC DR2: ACH Mask                       */
#define ADC_DR2_TRGINFO0_Pos                  24                                                      /*!< ADC DR2: TRGINFO0 Position              */
#define ADC_DR2_TRGINFO0_Msk                  (0x01UL << ADC_DR2_TRGINFO0_Pos)                        /*!< ADC DR2: TRGINFO0 Mask                  */
#define ADC_DR2_TRGINFO1_Pos                  25                                                      /*!< ADC DR2: TRGINFO1 Position              */
#define ADC_DR2_TRGINFO1_Msk                  (0x01UL << ADC_DR2_TRGINFO1_Pos)                        /*!< ADC DR2: TRGINFO1 Mask                  */
#define ADC_DR2_TRGINFO2_Pos                  26                                                      /*!< ADC DR2: TRGINFO2 Position              */
#define ADC_DR2_TRGINFO2_Msk                  (0x01UL << ADC_DR2_TRGINFO2_Pos)                        /*!< ADC DR2: TRGINFO2 Mask                  */
#define ADC_DR2_TRGINFO3_Pos                  27                                                      /*!< ADC DR2: TRGINFO3 Position              */
#define ADC_DR2_TRGINFO3_Msk                  (0x01UL << ADC_DR2_TRGINFO3_Pos)                        /*!< ADC DR2: TRGINFO3 Mask                  */
#define ADC_DR2_TRGINFO4_Pos                  28                                                      /*!< ADC DR2: TRGINFO4 Position              */
#define ADC_DR2_TRGINFO4_Msk                  (0x01UL << ADC_DR2_TRGINFO4_Pos)                        /*!< ADC DR2: TRGINFO4 Mask                  */
#define ADC_DR2_TRGINFO5_Pos                  29                                                      /*!< ADC DR2: TRGINFO5 Position              */
#define ADC_DR2_TRGINFO5_Msk                  (0x01UL << ADC_DR2_TRGINFO5_Pos)                        /*!< ADC DR2: TRGINFO5 Mask                  */
#define ADC_DR2_TRGINFO6_Pos                  30                                                      /*!< ADC DR2: TRGINFO6 Position              */
#define ADC_DR2_TRGINFO6_Msk                  (0x01UL << ADC_DR2_TRGINFO6_Pos)                        /*!< ADC DR2: TRGINFO6 Mask                  */
#define ADC_DR2_TRGINFO7_Pos                  31                                                      /*!< ADC DR2: TRGINFO7 Position              */
#define ADC_DR2_TRGINFO7_Msk                  (0x01UL << ADC_DR2_TRGINFO7_Pos)                        /*!< ADC DR2: TRGINFO7 Mask                  */

/* -----------------------------------  ADC_DR3  ---------------------------------- */
#define ADC_DR3_ADDATA_Pos                    4                                                       /*!< ADC DR3: ADDATA Position                */
#define ADC_DR3_ADDATA_Msk                    (0x00000fffUL << ADC_DR3_ADDATA_Pos)                    /*!< ADC DR3: ADDATA Mask                    */
#define ADC_DR3_ACH_Pos                       16                                                      /*!< ADC DR3: ACH Position                   */
#define ADC_DR3_ACH_Msk                       (0x1fUL << ADC_DR3_ACH_Pos)                             /*!< ADC DR3: ACH Mask                       */
#define ADC_DR3_TRGINFO0_Pos                  24                                                      /*!< ADC DR3: TRGINFO0 Position              */
#define ADC_DR3_TRGINFO0_Msk                  (0x01UL << ADC_DR3_TRGINFO0_Pos)                        /*!< ADC DR3: TRGINFO0 Mask                  */
#define ADC_DR3_TRGINFO1_Pos                  25                                                      /*!< ADC DR3: TRGINFO1 Position              */
#define ADC_DR3_TRGINFO1_Msk                  (0x01UL << ADC_DR3_TRGINFO1_Pos)                        /*!< ADC DR3: TRGINFO1 Mask                  */
#define ADC_DR3_TRGINFO2_Pos                  26                                                      /*!< ADC DR3: TRGINFO2 Position              */
#define ADC_DR3_TRGINFO2_Msk                  (0x01UL << ADC_DR3_TRGINFO2_Pos)                        /*!< ADC DR3: TRGINFO2 Mask                  */
#define ADC_DR3_TRGINFO3_Pos                  27                                                      /*!< ADC DR3: TRGINFO3 Position              */
#define ADC_DR3_TRGINFO3_Msk                  (0x01UL << ADC_DR3_TRGINFO3_Pos)                        /*!< ADC DR3: TRGINFO3 Mask                  */
#define ADC_DR3_TRGINFO4_Pos                  28                                                      /*!< ADC DR3: TRGINFO4 Position              */
#define ADC_DR3_TRGINFO4_Msk                  (0x01UL << ADC_DR3_TRGINFO4_Pos)                        /*!< ADC DR3: TRGINFO4 Mask                  */
#define ADC_DR3_TRGINFO5_Pos                  29                                                      /*!< ADC DR3: TRGINFO5 Position              */
#define ADC_DR3_TRGINFO5_Msk                  (0x01UL << ADC_DR3_TRGINFO5_Pos)                        /*!< ADC DR3: TRGINFO5 Mask                  */
#define ADC_DR3_TRGINFO6_Pos                  30                                                      /*!< ADC DR3: TRGINFO6 Position              */
#define ADC_DR3_TRGINFO6_Msk                  (0x01UL << ADC_DR3_TRGINFO6_Pos)                        /*!< ADC DR3: TRGINFO6 Mask                  */
#define ADC_DR3_TRGINFO7_Pos                  31                                                      /*!< ADC DR3: TRGINFO7 Position              */
#define ADC_DR3_TRGINFO7_Msk                  (0x01UL << ADC_DR3_TRGINFO7_Pos)                        /*!< ADC DR3: TRGINFO7 Mask                  */

/* -----------------------------------  ADC_DR4  ---------------------------------- */
#define ADC_DR4_ADDATA_Pos                    4                                                       /*!< ADC DR4: ADDATA Position                */
#define ADC_DR4_ADDATA_Msk                    (0x00000fffUL << ADC_DR4_ADDATA_Pos)                    /*!< ADC DR4: ADDATA Mask                    */
#define ADC_DR4_ACH_Pos                       16                                                      /*!< ADC DR4: ACH Position                   */
#define ADC_DR4_ACH_Msk                       (0x1fUL << ADC_DR4_ACH_Pos)                             /*!< ADC DR4: ACH Mask                       */
#define ADC_DR4_TRGINFO0_Pos                  24                                                      /*!< ADC DR4: TRGINFO0 Position              */
#define ADC_DR4_TRGINFO0_Msk                  (0x01UL << ADC_DR4_TRGINFO0_Pos)                        /*!< ADC DR4: TRGINFO0 Mask                  */
#define ADC_DR4_TRGINFO1_Pos                  25                                                      /*!< ADC DR4: TRGINFO1 Position              */
#define ADC_DR4_TRGINFO1_Msk                  (0x01UL << ADC_DR4_TRGINFO1_Pos)                        /*!< ADC DR4: TRGINFO1 Mask                  */
#define ADC_DR4_TRGINFO2_Pos                  26                                                      /*!< ADC DR4: TRGINFO2 Position              */
#define ADC_DR4_TRGINFO2_Msk                  (0x01UL << ADC_DR4_TRGINFO2_Pos)                        /*!< ADC DR4: TRGINFO2 Mask                  */
#define ADC_DR4_TRGINFO3_Pos                  27                                                      /*!< ADC DR4: TRGINFO3 Position              */
#define ADC_DR4_TRGINFO3_Msk                  (0x01UL << ADC_DR4_TRGINFO3_Pos)                        /*!< ADC DR4: TRGINFO3 Mask                  */
#define ADC_DR4_TRGINFO4_Pos                  28                                                      /*!< ADC DR4: TRGINFO4 Position              */
#define ADC_DR4_TRGINFO4_Msk                  (0x01UL << ADC_DR4_TRGINFO4_Pos)                        /*!< ADC DR4: TRGINFO4 Mask                  */
#define ADC_DR4_TRGINFO5_Pos                  29                                                      /*!< ADC DR4: TRGINFO5 Position              */
#define ADC_DR4_TRGINFO5_Msk                  (0x01UL << ADC_DR4_TRGINFO5_Pos)                        /*!< ADC DR4: TRGINFO5 Mask                  */
#define ADC_DR4_TRGINFO6_Pos                  30                                                      /*!< ADC DR4: TRGINFO6 Position              */
#define ADC_DR4_TRGINFO6_Msk                  (0x01UL << ADC_DR4_TRGINFO6_Pos)                        /*!< ADC DR4: TRGINFO6 Mask                  */
#define ADC_DR4_TRGINFO7_Pos                  31                                                      /*!< ADC DR4: TRGINFO7 Position              */
#define ADC_DR4_TRGINFO7_Msk                  (0x01UL << ADC_DR4_TRGINFO7_Pos)                        /*!< ADC DR4: TRGINFO7 Mask                  */

/* -----------------------------------  ADC_DR5  ---------------------------------- */
#define ADC_DR5_ADDATA_Pos                    4                                                       /*!< ADC DR5: ADDATA Position                */
#define ADC_DR5_ADDATA_Msk                    (0x00000fffUL << ADC_DR5_ADDATA_Pos)                    /*!< ADC DR5: ADDATA Mask                    */
#define ADC_DR5_ACH_Pos                       16                                                      /*!< ADC DR5: ACH Position                   */
#define ADC_DR5_ACH_Msk                       (0x1fUL << ADC_DR5_ACH_Pos)                             /*!< ADC DR5: ACH Mask                       */
#define ADC_DR5_TRGINFO0_Pos                  24                                                      /*!< ADC DR5: TRGINFO0 Position              */
#define ADC_DR5_TRGINFO0_Msk                  (0x01UL << ADC_DR5_TRGINFO0_Pos)                        /*!< ADC DR5: TRGINFO0 Mask                  */
#define ADC_DR5_TRGINFO1_Pos                  25                                                      /*!< ADC DR5: TRGINFO1 Position              */
#define ADC_DR5_TRGINFO1_Msk                  (0x01UL << ADC_DR5_TRGINFO1_Pos)                        /*!< ADC DR5: TRGINFO1 Mask                  */
#define ADC_DR5_TRGINFO2_Pos                  26                                                      /*!< ADC DR5: TRGINFO2 Position              */
#define ADC_DR5_TRGINFO2_Msk                  (0x01UL << ADC_DR5_TRGINFO2_Pos)                        /*!< ADC DR5: TRGINFO2 Mask                  */
#define ADC_DR5_TRGINFO3_Pos                  27                                                      /*!< ADC DR5: TRGINFO3 Position              */
#define ADC_DR5_TRGINFO3_Msk                  (0x01UL << ADC_DR5_TRGINFO3_Pos)                        /*!< ADC DR5: TRGINFO3 Mask                  */
#define ADC_DR5_TRGINFO4_Pos                  28                                                      /*!< ADC DR5: TRGINFO4 Position              */
#define ADC_DR5_TRGINFO4_Msk                  (0x01UL << ADC_DR5_TRGINFO4_Pos)                        /*!< ADC DR5: TRGINFO4 Mask                  */
#define ADC_DR5_TRGINFO5_Pos                  29                                                      /*!< ADC DR5: TRGINFO5 Position              */
#define ADC_DR5_TRGINFO5_Msk                  (0x01UL << ADC_DR5_TRGINFO5_Pos)                        /*!< ADC DR5: TRGINFO5 Mask                  */
#define ADC_DR5_TRGINFO6_Pos                  30                                                      /*!< ADC DR5: TRGINFO6 Position              */
#define ADC_DR5_TRGINFO6_Msk                  (0x01UL << ADC_DR5_TRGINFO6_Pos)                        /*!< ADC DR5: TRGINFO6 Mask                  */
#define ADC_DR5_TRGINFO7_Pos                  31                                                      /*!< ADC DR5: TRGINFO7 Position              */
#define ADC_DR5_TRGINFO7_Msk                  (0x01UL << ADC_DR5_TRGINFO7_Pos)                        /*!< ADC DR5: TRGINFO7 Mask                  */

/* -----------------------------------  ADC_DR6  ---------------------------------- */
#define ADC_DR6_ADDATA_Pos                    4                                                       /*!< ADC DR6: ADDATA Position                */
#define ADC_DR6_ADDATA_Msk                    (0x00000fffUL << ADC_DR6_ADDATA_Pos)                    /*!< ADC DR6: ADDATA Mask                    */
#define ADC_DR6_ACH_Pos                       16                                                      /*!< ADC DR6: ACH Position                   */
#define ADC_DR6_ACH_Msk                       (0x1fUL << ADC_DR6_ACH_Pos)                             /*!< ADC DR6: ACH Mask                       */
#define ADC_DR6_TRGINFO0_Pos                  24                                                      /*!< ADC DR6: TRGINFO0 Position              */
#define ADC_DR6_TRGINFO0_Msk                  (0x01UL << ADC_DR6_TRGINFO0_Pos)                        /*!< ADC DR6: TRGINFO0 Mask                  */
#define ADC_DR6_TRGINFO1_Pos                  25                                                      /*!< ADC DR6: TRGINFO1 Position              */
#define ADC_DR6_TRGINFO1_Msk                  (0x01UL << ADC_DR6_TRGINFO1_Pos)                        /*!< ADC DR6: TRGINFO1 Mask                  */
#define ADC_DR6_TRGINFO2_Pos                  26                                                      /*!< ADC DR6: TRGINFO2 Position              */
#define ADC_DR6_TRGINFO2_Msk                  (0x01UL << ADC_DR6_TRGINFO2_Pos)                        /*!< ADC DR6: TRGINFO2 Mask                  */
#define ADC_DR6_TRGINFO3_Pos                  27                                                      /*!< ADC DR6: TRGINFO3 Position              */
#define ADC_DR6_TRGINFO3_Msk                  (0x01UL << ADC_DR6_TRGINFO3_Pos)                        /*!< ADC DR6: TRGINFO3 Mask                  */
#define ADC_DR6_TRGINFO4_Pos                  28                                                      /*!< ADC DR6: TRGINFO4 Position              */
#define ADC_DR6_TRGINFO4_Msk                  (0x01UL << ADC_DR6_TRGINFO4_Pos)                        /*!< ADC DR6: TRGINFO4 Mask                  */
#define ADC_DR6_TRGINFO5_Pos                  29                                                      /*!< ADC DR6: TRGINFO5 Position              */
#define ADC_DR6_TRGINFO5_Msk                  (0x01UL << ADC_DR6_TRGINFO5_Pos)                        /*!< ADC DR6: TRGINFO5 Mask                  */
#define ADC_DR6_TRGINFO6_Pos                  30                                                      /*!< ADC DR6: TRGINFO6 Position              */
#define ADC_DR6_TRGINFO6_Msk                  (0x01UL << ADC_DR6_TRGINFO6_Pos)                        /*!< ADC DR6: TRGINFO6 Mask                  */
#define ADC_DR6_TRGINFO7_Pos                  31                                                      /*!< ADC DR6: TRGINFO7 Position              */
#define ADC_DR6_TRGINFO7_Msk                  (0x01UL << ADC_DR6_TRGINFO7_Pos)                        /*!< ADC DR6: TRGINFO7 Mask                  */

/* -----------------------------------  ADC_DR7  ---------------------------------- */
#define ADC_DR7_ADDATA_Pos                    4                                                       /*!< ADC DR7: ADDATA Position                */
#define ADC_DR7_ADDATA_Msk                    (0x00000fffUL << ADC_DR7_ADDATA_Pos)                    /*!< ADC DR7: ADDATA Mask                    */
#define ADC_DR7_ACH_Pos                       16                                                      /*!< ADC DR7: ACH Position                   */
#define ADC_DR7_ACH_Msk                       (0x1fUL << ADC_DR7_ACH_Pos)                             /*!< ADC DR7: ACH Mask                       */
#define ADC_DR7_TRGINFO0_Pos                  24                                                      /*!< ADC DR7: TRGINFO0 Position              */
#define ADC_DR7_TRGINFO0_Msk                  (0x01UL << ADC_DR7_TRGINFO0_Pos)                        /*!< ADC DR7: TRGINFO0 Mask                  */
#define ADC_DR7_TRGINFO1_Pos                  25                                                      /*!< ADC DR7: TRGINFO1 Position              */
#define ADC_DR7_TRGINFO1_Msk                  (0x01UL << ADC_DR7_TRGINFO1_Pos)                        /*!< ADC DR7: TRGINFO1 Mask                  */
#define ADC_DR7_TRGINFO2_Pos                  26                                                      /*!< ADC DR7: TRGINFO2 Position              */
#define ADC_DR7_TRGINFO2_Msk                  (0x01UL << ADC_DR7_TRGINFO2_Pos)                        /*!< ADC DR7: TRGINFO2 Mask                  */
#define ADC_DR7_TRGINFO3_Pos                  27                                                      /*!< ADC DR7: TRGINFO3 Position              */
#define ADC_DR7_TRGINFO3_Msk                  (0x01UL << ADC_DR7_TRGINFO3_Pos)                        /*!< ADC DR7: TRGINFO3 Mask                  */
#define ADC_DR7_TRGINFO4_Pos                  28                                                      /*!< ADC DR7: TRGINFO4 Position              */
#define ADC_DR7_TRGINFO4_Msk                  (0x01UL << ADC_DR7_TRGINFO4_Pos)                        /*!< ADC DR7: TRGINFO4 Mask                  */
#define ADC_DR7_TRGINFO5_Pos                  29                                                      /*!< ADC DR7: TRGINFO5 Position              */
#define ADC_DR7_TRGINFO5_Msk                  (0x01UL << ADC_DR7_TRGINFO5_Pos)                        /*!< ADC DR7: TRGINFO5 Mask                  */
#define ADC_DR7_TRGINFO6_Pos                  30                                                      /*!< ADC DR7: TRGINFO6 Position              */
#define ADC_DR7_TRGINFO6_Msk                  (0x01UL << ADC_DR7_TRGINFO6_Pos)                        /*!< ADC DR7: TRGINFO6 Mask                  */
#define ADC_DR7_TRGINFO7_Pos                  31                                                      /*!< ADC DR7: TRGINFO7 Position              */
#define ADC_DR7_TRGINFO7_Msk                  (0x01UL << ADC_DR7_TRGINFO7_Pos)                        /*!< ADC DR7: TRGINFO7 Mask                  */

/* ----------------------------------  ADC_CMPR  ---------------------------------- */
#define ADC_CMPR_CVAL_Pos                     4                                                       /*!< ADC CMPR: CVAL Position                 */
#define ADC_CMPR_CVAL_Msk                     (0x00000fffUL << ADC_CMPR_CVAL_Pos)                     /*!< ADC CMPR: CVAL Mask                     */
#define ADC_CMPR_CCH_Pos                      16                                                      /*!< ADC CMPR: CCH Position                  */
#define ADC_CMPR_CCH_Msk                      (0x1fUL << ADC_CMPR_CCH_Pos)                            /*!< ADC CMPR: CCH Mask                      */
#define ADC_CMPR_LTE_Pos                      21                                                      /*!< ADC CMPR: LTE Position                  */
#define ADC_CMPR_LTE_Msk                      (0x01UL << ADC_CMPR_LTE_Pos)                            /*!< ADC CMPR: LTE Mask                      */
#define ADC_CMPR_CMPEN_Pos                    23                                                      /*!< ADC CMPR: CMPEN Position                */
#define ADC_CMPR_CMPEN_Msk                    (0x01UL << ADC_CMPR_CMPEN_Pos)                          /*!< ADC CMPR: CMPEN Mask                    */
#define ADC_CMPR_CMPIEN_Pos                   24                                                      /*!< ADC CMPR: CMPIEN Position               */
#define ADC_CMPR_CMPIEN_Msk                   (0x01UL << ADC_CMPR_CMPIEN_Pos)                         /*!< ADC CMPR: CMPIEN Mask                   */

/* -----------------------------------  ADC_BCR  ---------------------------------- */
#define ADC_BCR_BYPSEL_Pos                    0                                                       /*!< ADC BCR: BYPSEL Position                */
#define ADC_BCR_BYPSEL_Msk                    (0x01UL << ADC_BCR_BYPSEL_Pos)                          /*!< ADC BCR: BYPSEL Mask                    */
#define ADC_BCR_BUFEN_Pos                     1                                                       /*!< ADC BCR: BUFEN Position                 */
#define ADC_BCR_BUFEN_Msk                     (0x01UL << ADC_BCR_BUFEN_Pos)                           /*!< ADC BCR: BUFEN Mask                     */
#define ADC_BCR_TBUFSEL_Pos                   4                                                       /*!< ADC BCR: TBUFSEL Position               */
#define ADC_BCR_TBUFSEL_Msk                   (0x07UL << ADC_BCR_TBUFSEL_Pos)                         /*!< ADC BCR: TBUFSEL Mask                   */


/* ================================================================================ */
/* ================          struct 'DAC' Position & Mask          ================ */
/* ================================================================================ */


/* -----------------------------------  DAC_DR  ----------------------------------- */
#define DAC_DR_DACDR_Pos                      0                                                       /*!< DAC DR: DACDR Position                  */
#define DAC_DR_DACDR_Msk                      (0x0000ffffUL << DAC_DR_DACDR_Pos)                      /*!< DAC DR: DACDR Mask                      */

/* -----------------------------------  DAC_BR  ----------------------------------- */
#define DAC_BR_DACBR_Pos                      0                                                       /*!< DAC BR: DACBR Position                  */
#define DAC_BR_DACBR_Msk                      (0x0000ffffUL << DAC_BR_DACBR_Pos)                      /*!< DAC BR: DACBR Mask                      */

/* -----------------------------------  DAC_CR  ----------------------------------- */
#define DAC_CR_DACEN_Pos                      0                                                       /*!< DAC CR: DACEN Position                  */
#define DAC_CR_DACEN_Msk                      (0x01UL << DAC_CR_DACEN_Pos)                            /*!< DAC CR: DACEN Mask                      */
#define DAC_CR_DACRLDS_Pos                    1                                                       /*!< DAC CR: DACRLDS Position                */
#define DAC_CR_DACRLDS_Msk                    (0x03UL << DAC_CR_DACRLDS_Pos)                          /*!< DAC CR: DACRLDS Mask                    */
#define DAC_CR_DACBC_Pos                      4                                                       /*!< DAC CR: DACBC Position                  */
#define DAC_CR_DACBC_Msk                      (0x01UL << DAC_CR_DACBC_Pos)                            /*!< DAC CR: DACBC Mask                      */
#define DAC_CR_DACOUTBUFEN_Pos                10                                                      /*!< DAC CR: DACOUTBUFEN Position            */
#define DAC_CR_DACOUTBUFEN_Msk                (0x01UL << DAC_CR_DACOUTBUFEN_Pos)                      /*!< DAC CR: DACOUTBUFEN Mask                */
#define DAC_CR_DAC0_OUT_EN_Pos                11                                                      /*!< DAC CR: DAC0_OUT_EN Position            */
#define DAC_CR_DAC0_OUT_EN_Msk                (0x01UL << DAC_CR_DAC0_OUT_EN_Pos)                      /*!< DAC CR: DAC0_OUT_EN Mask                */
#define DAC_CR_DAC2_OUT_EN_Pos                13                                                      /*!< DAC CR: DAC2_OUT_EN Position            */
#define DAC_CR_DAC2_OUT_EN_Msk                (0x01UL << DAC_CR_DAC2_OUT_EN_Pos)                      /*!< DAC CR: DAC2_OUT_EN Mask                */

/* ----------------------------------  DAC_PGSR  ---------------------------------- */
#define DAC_PGSR_PSG_Pos                      0                                                       /*!< DAC PGSR: PSG Position                  */
#define DAC_PGSR_PSG_Msk                      (0x0fUL << DAC_PGSR_PSG_Pos)                            /*!< DAC PGSR: PSG Mask                      */

/* ----------------------------------  DAC_OFSCR  --------------------------------- */
#define DAC_OFSCR_OFS_Pos                     0                                                       /*!< DAC OFSCR: OFS Position                 */
#define DAC_OFSCR_OFS_Msk                     (0x0fUL << DAC_OFSCR_OFS_Pos)                           /*!< DAC OFSCR: OFS Mask                     */
#define DAC_OFSCR_OFSDIR_Pos                  6                                                       /*!< DAC OFSCR: OFSDIR Position              */
#define DAC_OFSCR_OFSDIR_Msk                  (0x01UL << DAC_OFSCR_OFSDIR_Pos)                        /*!< DAC OFSCR: OFSDIR Mask                  */
#define DAC_OFSCR_OFSEN_Pos                   7                                                       /*!< DAC OFSCR: OFSEN Position               */
#define DAC_OFSCR_OFSEN_Msk                   (0x01UL << DAC_OFSCR_OFSEN_Pos)                         /*!< DAC OFSCR: OFSEN Mask                   */

/* -----------------------------------  DAC_ICR  ---------------------------------- */
#define DAC_ICR_DAMIE_Pos                     0                                                       /*!< DAC ICR: DAMIE Position                 */
#define DAC_ICR_DAMIE_Msk                     (0x01UL << DAC_ICR_DAMIE_Pos)                           /*!< DAC ICR: DAMIE Mask                     */
#define DAC_ICR_DUDRUNE_Pos                   1                                                       /*!< DAC ICR: DUDRUNE Position               */
#define DAC_ICR_DUDRUNE_Msk                   (0x01UL << DAC_ICR_DUDRUNE_Pos)                         /*!< DAC ICR: DUDRUNE Mask                   */
#define DAC_ICR_DMAIF_Pos                     4                                                       /*!< DAC ICR: DMAIF Position                 */
#define DAC_ICR_DMAIF_Msk                     (0x01UL << DAC_ICR_DMAIF_Pos)                           /*!< DAC ICR: DMAIF Mask                     */
#define DAC_ICR_DUDRUNF_Pos                   5                                                       /*!< DAC ICR: DUDRUNF Position               */
#define DAC_ICR_DUDRUNF_Msk                   (0x01UL << DAC_ICR_DUDRUNF_Pos)                         /*!< DAC ICR: DUDRUNF Mask                   */


/* ================================================================================ */
/* ================          struct 'CMP' Position & Mask          ================ */
/* ================================================================================ */


/* ---------------------------------  CMP_CMP0CR  --------------------------------- */
#define CMP_CMP0CR_C0INPSEL_Pos               0                                                       /*!< CMP CMP0CR: C0INPSEL Position           */
#define CMP_CMP0CR_C0INPSEL_Msk               (0x03UL << CMP_CMP0CR_C0INPSEL_Pos)                     /*!< CMP CMP0CR: C0INPSEL Mask               */
#define CMP_CMP0CR_C0INNSEL_Pos               4                                                       /*!< CMP CMP0CR: C0INNSEL Position           */
#define CMP_CMP0CR_C0INNSEL_Msk               (0x03UL << CMP_CMP0CR_C0INNSEL_Pos)                     /*!< CMP CMP0CR: C0INNSEL Mask               */
#define CMP_CMP0CR_C0EN_Pos                   12                                                      /*!< CMP CMP0CR: C0EN Position               */
#define CMP_CMP0CR_C0EN_Msk                   (0x01UL << CMP_CMP0CR_C0EN_Pos)                         /*!< CMP CMP0CR: C0EN Mask                   */
#define CMP_CMP0CR_C0HYSSEL_Pos               16                                                      /*!< CMP CMP0CR: C0HYSSEL Position           */
#define CMP_CMP0CR_C0HYSSEL_Msk               (0x01UL << CMP_CMP0CR_C0HYSSEL_Pos)                     /*!< CMP CMP0CR: C0HYSSEL Mask               */
#define CMP_CMP0CR_C0HYSEN_Pos                20                                                      /*!< CMP CMP0CR: C0HYSEN Position            */
#define CMP_CMP0CR_C0HYSEN_Msk                (0x01UL << CMP_CMP0CR_C0HYSEN_Pos)                      /*!< CMP CMP0CR: C0HYSEN Mask                */

/* ---------------------------------  CMP_CMP1CR  --------------------------------- */
#define CMP_CMP1CR_C1INPSEL_Pos               0                                                       /*!< CMP CMP1CR: C1INPSEL Position           */
#define CMP_CMP1CR_C1INPSEL_Msk               (0x03UL << CMP_CMP1CR_C1INPSEL_Pos)                     /*!< CMP CMP1CR: C1INPSEL Mask               */
#define CMP_CMP1CR_C1INNSEL_Pos               4                                                       /*!< CMP CMP1CR: C1INNSEL Position           */
#define CMP_CMP1CR_C1INNSEL_Msk               (0x03UL << CMP_CMP1CR_C1INNSEL_Pos)                     /*!< CMP CMP1CR: C1INNSEL Mask               */
#define CMP_CMP1CR_C1EN_Pos                   12                                                      /*!< CMP CMP1CR: C1EN Position               */
#define CMP_CMP1CR_C1EN_Msk                   (0x01UL << CMP_CMP1CR_C1EN_Pos)                         /*!< CMP CMP1CR: C1EN Mask                   */
#define CMP_CMP1CR_C1HYSSEL_Pos               16                                                      /*!< CMP CMP1CR: C1HYSSEL Position           */
#define CMP_CMP1CR_C1HYSSEL_Msk               (0x01UL << CMP_CMP1CR_C1HYSSEL_Pos)                     /*!< CMP CMP1CR: C1HYSSEL Mask               */
#define CMP_CMP1CR_C1HYSEN_Pos                20                                                      /*!< CMP CMP1CR: C1HYSEN Position            */
#define CMP_CMP1CR_C1HYSEN_Msk                (0x01UL << CMP_CMP1CR_C1HYSEN_Pos)                      /*!< CMP CMP1CR: C1HYSEN Mask                */

/* ----------------------------------  CMP_DBNC  ---------------------------------- */
#define CMP_DBNC_C0DBNC_Pos                   0                                                       /*!< CMP DBNC: C0DBNC Position               */
#define CMP_DBNC_C0DBNC_Msk                   (0x0fUL << CMP_DBNC_C0DBNC_Pos)                         /*!< CMP DBNC: C0DBNC Mask                   */
#define CMP_DBNC_C1DBNC_Pos                   4                                                       /*!< CMP DBNC: C1DBNC Position               */
#define CMP_DBNC_C1DBNC_Msk                   (0x0fUL << CMP_DBNC_C1DBNC_Pos)                         /*!< CMP DBNC: C1DBNC Mask                   */
#define CMP_DBNC_DBNCTB_Pos                   16                                                      /*!< CMP DBNC: DBNCTB Position               */
#define CMP_DBNC_DBNCTB_Msk                   (0x0000ffffUL << CMP_DBNC_DBNCTB_Pos)                   /*!< CMP DBNC: DBNCTB Mask                   */

/* ----------------------------------  CMP_ICON  ---------------------------------- */
#define CMP_ICON_C0IMODE_Pos                  0                                                       /*!< CMP ICON: C0IMODE Position              */
#define CMP_ICON_C0IMODE_Msk                  (0x03UL << CMP_ICON_C0IMODE_Pos)                        /*!< CMP ICON: C0IMODE Mask                  */
#define CMP_ICON_C1IMODE_Pos                  2                                                       /*!< CMP ICON: C1IMODE Position              */
#define CMP_ICON_C1IMODE_Msk                  (0x03UL << CMP_ICON_C1IMODE_Pos)                        /*!< CMP ICON: C1IMODE Mask                  */
#define CMP_ICON_C0IPOL_Pos                   8                                                       /*!< CMP ICON: C0IPOL Position               */
#define CMP_ICON_C0IPOL_Msk                   (0x01UL << CMP_ICON_C0IPOL_Pos)                         /*!< CMP ICON: C0IPOL Mask                   */
#define CMP_ICON_C1IPOL_Pos                   9                                                       /*!< CMP ICON: C1IPOL Position               */
#define CMP_ICON_C1IPOL_Msk                   (0x01UL << CMP_ICON_C1IPOL_Pos)                         /*!< CMP ICON: C1IPOL Mask                   */
#define CMP_ICON_C0TPOL_Pos                   12                                                      /*!< CMP ICON: C0TPOL Position               */
#define CMP_ICON_C0TPOL_Msk                   (0x01UL << CMP_ICON_C0TPOL_Pos)                         /*!< CMP ICON: C0TPOL Mask                   */
#define CMP_ICON_C1TPOL_Pos                   13                                                      /*!< CMP ICON: C1TPOL Position               */
#define CMP_ICON_C1TPOL_Msk                   (0x01UL << CMP_ICON_C1TPOL_Pos)                         /*!< CMP ICON: C1TPOL Mask                   */

/* -----------------------------------  CMP_IEN  ---------------------------------- */
#define CMP_IEN_C0IEN_Pos                     0                                                       /*!< CMP IEN: C0IEN Position                 */
#define CMP_IEN_C0IEN_Msk                     (0x01UL << CMP_IEN_C0IEN_Pos)                           /*!< CMP IEN: C0IEN Mask                     */
#define CMP_IEN_C1IEN_Pos                     1                                                       /*!< CMP IEN: C1IEN Position                 */
#define CMP_IEN_C1IEN_Msk                     (0x01UL << CMP_IEN_C1IEN_Pos)                           /*!< CMP IEN: C1IEN Mask                     */
#define CMP_IEN_COUTMON_Pos                   7                                                       /*!< CMP IEN: COUTMON Position               */
#define CMP_IEN_COUTMON_Msk                   (0x01UL << CMP_IEN_COUTMON_Pos)                         /*!< CMP IEN: COUTMON Mask                   */

/* -----------------------------------  CMP_IST  ---------------------------------- */
#define CMP_IST_C0IRQ_Pos                     0                                                       /*!< CMP IST: C0IRQ Position                 */
#define CMP_IST_C0IRQ_Msk                     (0x01UL << CMP_IST_C0IRQ_Pos)                           /*!< CMP IST: C0IRQ Mask                     */
#define CMP_IST_C1IRQ_Pos                     1                                                       /*!< CMP IST: C1IRQ Position                 */
#define CMP_IST_C1IRQ_Msk                     (0x01UL << CMP_IST_C1IRQ_Pos)                           /*!< CMP IST: C1IRQ Mask                     */
#define CMP_IST_C0DO_Pos                      8                                                       /*!< CMP IST: C0DO Position                  */
#define CMP_IST_C0DO_Msk                      (0x01UL << CMP_IST_C0DO_Pos)                            /*!< CMP IST: C0DO Mask                      */
#define CMP_IST_C1DO_Pos                      9                                                       /*!< CMP IST: C1DO Position                  */
#define CMP_IST_C1DO_Msk                      (0x01UL << CMP_IST_C1DO_Pos)                            /*!< CMP IST: C1DO Mask                      */
#define CMP_IST_C0COUT_Pos                    12                                                      /*!< CMP IST: C0COUT Position                */
#define CMP_IST_C0COUT_Msk                    (0x01UL << CMP_IST_C0COUT_Pos)                          /*!< CMP IST: C0COUT Mask                    */
#define CMP_IST_C1COUT_Pos                    13                                                      /*!< CMP IST: C1COUT Position                */
#define CMP_IST_C1COUT_Msk                    (0x01UL << CMP_IST_C1COUT_Pos)                          /*!< CMP IST: C1COUT Mask                    */
#define CMP_IST_C0EPR_Pos                     16                                                      /*!< CMP IST: C0EPR Position                 */
#define CMP_IST_C0EPR_Msk                     (0x01UL << CMP_IST_C0EPR_Pos)                           /*!< CMP IST: C0EPR Mask                     */
#define CMP_IST_C0EPF_Pos                     17                                                      /*!< CMP IST: C0EPF Position                 */
#define CMP_IST_C0EPF_Msk                     (0x01UL << CMP_IST_C0EPF_Pos)                           /*!< CMP IST: C0EPF Mask                     */
#define CMP_IST_C1EPR_Pos                     18                                                      /*!< CMP IST: C1EPR Position                 */
#define CMP_IST_C1EPR_Msk                     (0x01UL << CMP_IST_C1EPR_Pos)                           /*!< CMP IST: C1EPR Mask                     */
#define CMP_IST_C1EPF_Pos                     19                                                      /*!< CMP IST: C1EPF Position                 */
#define CMP_IST_C1EPF_Msk                     (0x01UL << CMP_IST_C1EPF_Pos)                           /*!< CMP IST: C1EPF Mask                     */

/* ----------------------------------  CMP_ICLR  ---------------------------------- */
#define CMP_ICLR_C0ICLR_Pos                   0                                                       /*!< CMP ICLR: C0ICLR Position               */
#define CMP_ICLR_C0ICLR_Msk                   (0x01UL << CMP_ICLR_C0ICLR_Pos)                         /*!< CMP ICLR: C0ICLR Mask                   */
#define CMP_ICLR_C1ICLR_Pos                   1                                                       /*!< CMP ICLR: C1ICLR Position               */
#define CMP_ICLR_C1ICLR_Msk                   (0x01UL << CMP_ICLR_C1ICLR_Pos)                         /*!< CMP ICLR: C1ICLR Mask                   */
#define CMP_ICLR_C0EPRFC_Pos                  16                                                      /*!< CMP ICLR: C0EPRFC Position              */
#define CMP_ICLR_C0EPRFC_Msk                  (0x01UL << CMP_ICLR_C0EPRFC_Pos)                        /*!< CMP ICLR: C0EPRFC Mask                  */
#define CMP_ICLR_C0EPFFC_Pos                  17                                                      /*!< CMP ICLR: C0EPFFC Position              */
#define CMP_ICLR_C0EPFFC_Msk                  (0x01UL << CMP_ICLR_C0EPFFC_Pos)                        /*!< CMP ICLR: C0EPFFC Mask                  */
#define CMP_ICLR_C1EPRFC_Pos                  18                                                      /*!< CMP ICLR: C1EPRFC Position              */
#define CMP_ICLR_C1EPRFC_Msk                  (0x01UL << CMP_ICLR_C1EPRFC_Pos)                        /*!< CMP ICLR: C1EPRFC Mask                  */
#define CMP_ICLR_C1EPFFC_Pos                  19                                                      /*!< CMP ICLR: C1EPFFC Position              */
#define CMP_ICLR_C1EPFFC_Msk                  (0x01UL << CMP_ICLR_C1EPFFC_Pos)                        /*!< CMP ICLR: C1EPFFC Mask                  */


/* ================================================================================ */
/* ================          struct 'LCD' Position & Mask          ================ */
/* ================================================================================ */


/* -----------------------------------  LCD_CR  ----------------------------------- */
#define LCD_CR_DISP_Pos                       0                                                       /*!< LCD CR: DISP Position                   */
#define LCD_CR_DISP_Msk                       (0x01UL << LCD_CR_DISP_Pos)                             /*!< LCD CR: DISP Mask                       */
#define LCD_CR_LCLK_Pos                       1                                                       /*!< LCD CR: LCLK Position                   */
#define LCD_CR_LCLK_Msk                       (0x03UL << LCD_CR_LCLK_Pos)                             /*!< LCD CR: LCLK Mask                       */
#define LCD_CR_DBS_Pos                        3                                                       /*!< LCD CR: DBS Position                    */
#define LCD_CR_DBS_Msk                        (0x07UL << LCD_CR_DBS_Pos)                              /*!< LCD CR: DBS Mask                        */
#define LCD_CR_IRSEL_Pos                      6                                                       /*!< LCD CR: IRSEL Position                  */
#define LCD_CR_IRSEL_Msk                      (0x03UL << LCD_CR_IRSEL_Pos)                            /*!< LCD CR: IRSEL Mask                      */

/* ----------------------------------  LCD_BCCR  ---------------------------------- */
#define LCD_BCCR_VLCD_Pos                     0                                                       /*!< LCD BCCR: VLCD Position                 */
#define LCD_BCCR_VLCD_Msk                     (0x0fUL << LCD_BCCR_VLCD_Pos)                           /*!< LCD BCCR: VLCD Mask                     */
#define LCD_BCCR_LCTEN_Pos                    5                                                       /*!< LCD BCCR: LCTEN Position                */
#define LCD_BCCR_LCTEN_Msk                    (0x01UL << LCD_BCCR_LCTEN_Pos)                          /*!< LCD BCCR: LCTEN Mask                    */
#define LCD_BCCR_BMSEL_Pos                    8                                                       /*!< LCD BCCR: BMSEL Position                */
#define LCD_BCCR_BMSEL_Msk                    (0x07UL << LCD_BCCR_BMSEL_Pos)                          /*!< LCD BCCR: BMSEL Mask                    */
#define LCD_BCCR_LCDABC_Pos                   12                                                      /*!< LCD BCCR: LCDABC Position               */
#define LCD_BCCR_LCDABC_Msk                   (0x01UL << LCD_BCCR_LCDABC_Pos)                         /*!< LCD BCCR: LCDABC Mask                   */

/* ----------------------------------  LCD_BSSR  ---------------------------------- */
#define LCD_BSSR_VLC0EN_Pos                   4                                                       /*!< LCD BSSR: VLC0EN Position               */
#define LCD_BSSR_VLC0EN_Msk                   (0x01UL << LCD_BSSR_VLC0EN_Pos)                         /*!< LCD BSSR: VLC0EN Mask                   */
#define LCD_BSSR_VLC1EN_Pos                   5                                                       /*!< LCD BSSR: VLC1EN Position               */
#define LCD_BSSR_VLC1EN_Msk                   (0x01UL << LCD_BSSR_VLC1EN_Pos)                         /*!< LCD BSSR: VLC1EN Mask                   */
#define LCD_BSSR_VLC2EN_Pos                   6                                                       /*!< LCD BSSR: VLC2EN Position               */
#define LCD_BSSR_VLC2EN_Msk                   (0x01UL << LCD_BSSR_VLC2EN_Pos)                         /*!< LCD BSSR: VLC2EN Mask                   */
#define LCD_BSSR_VLC3EN_Pos                   7                                                       /*!< LCD BSSR: VLC3EN Position               */
#define LCD_BSSR_VLC3EN_Msk                   (0x01UL << LCD_BSSR_VLC3EN_Pos)                         /*!< LCD BSSR: VLC3EN Mask                   */
#define LCD_BSSR_LCDEPEN_Pos                  8                                                       /*!< LCD BSSR: LCDEPEN Position              */
#define LCD_BSSR_LCDEPEN_Msk                  (0x01UL << LCD_BSSR_LCDEPEN_Pos)                        /*!< LCD BSSR: LCDEPEN Mask                  */
#define LCD_BSSR_LCDDR_Pos                    9                                                       /*!< LCD BSSR: LCDDR Position                */
#define LCD_BSSR_LCDDR_Msk                    (0x01UL << LCD_BSSR_LCDDR_Pos)                          /*!< LCD BSSR: LCDDR Mask                    */


/* ================================================================================ */
/* ================          struct 'CRC' Position & Mask          ================ */
/* ================================================================================ */


/* -----------------------------------  CRC_CR  ----------------------------------- */
#define CRC_CR_INIT_EN_Pos                    0                                                       /*!< CRC CR: INIT_EN Position                */
#define CRC_CR_INIT_EN_Msk                    (0x01UL << CRC_CR_INIT_EN_Pos)                          /*!< CRC CR: INIT_EN Mask                    */
#define CRC_CR_POLY_Pos                       1                                                       /*!< CRC CR: POLY Position                   */
#define CRC_CR_POLY_Msk                       (0x03UL << CRC_CR_POLY_Pos)                             /*!< CRC CR: POLY Mask                       */
#define CRC_CR_DMADINT_Pos                    8                                                       /*!< CRC CR: DMADINT Position                */
#define CRC_CR_DMADINT_Msk                    (0x01UL << CRC_CR_DMADINT_Pos)                          /*!< CRC CR: DMADINT Mask                    */
#define CRC_CR_IN_REV_Pos                     16                                                      /*!< CRC CR: IN_REV Position                 */
#define CRC_CR_IN_REV_Msk                     (0x01UL << CRC_CR_IN_REV_Pos)                           /*!< CRC CR: IN_REV Mask                     */
#define CRC_CR_OUT_REV_Pos                    20                                                      /*!< CRC CR: OUT_REV Position                */
#define CRC_CR_OUT_REV_Msk                    (0x01UL << CRC_CR_OUT_REV_Pos)                          /*!< CRC CR: OUT_REV Mask                    */
#define CRC_CR_OUT_INV_Pos                    21                                                      /*!< CRC CR: OUT_INV Position                */
#define CRC_CR_OUT_INV_Msk                    (0x01UL << CRC_CR_OUT_INV_Pos)                          /*!< CRC CR: OUT_INV Mask                    */

/* -----------------------------------  CRC_IDR  ---------------------------------- */
#define CRC_IDR_INPUT_Pos                     0                                                       /*!< CRC IDR: INPUT Position                 */
#define CRC_IDR_INPUT_Msk                     (0x000000ffUL << CRC_IDR_INPUT_Pos)                     /*!< CRC IDR: INPUT Mask                     */

/* -----------------------------------  CRC_ODR  ---------------------------------- */
#define CRC_ODR_OUTPUT_Pos                    0                                                       /*!< CRC ODR: OUTPUT Position                */
#define CRC_ODR_OUTPUT_Msk                    (0xffffffffUL << CRC_ODR_OUTPUT_Pos)                    /*!< CRC ODR: OUTPUT Mask                    */

/* -----------------------------------  CRC_SR  ----------------------------------- */
#define CRC_SR_DMADINT_Pos                    8                                                       /*!< CRC SR: DMADINT Position                */
#define CRC_SR_DMADINT_Msk                    (0x01UL << CRC_SR_DMADINT_Pos)                          /*!< CRC SR: DMADINT Mask                    */


/* ================================================================================ */
/* ================           struct 'TS' Position & Mask          ================ */
/* ================================================================================ */


/* ------------------------------------  TS_CR  ----------------------------------- */
#define TS_CR_START_Pos                       0                                                       /*!< TS CR: START Position                   */
#define TS_CR_START_Msk                       (0x01UL << TS_CR_START_Pos)                             /*!< TS CR: START Mask                       */
#define TS_CR_INTEN_Pos                       8                                                       /*!< TS CR: INTEN Position                   */
#define TS_CR_INTEN_Msk                       (0x01UL << TS_CR_INTEN_Pos)                             /*!< TS CR: INTEN Mask                       */

/* ----------------------------------  TS_RCCNT  ---------------------------------- */
#define TS_RCCNT_RCCV_Pos                     0                                                       /*!< TS RCCNT: RCCV Position                 */
#define TS_RCCNT_RCCV_Msk                     (0xffffffffUL << TS_RCCNT_RCCV_Pos)                     /*!< TS RCCNT: RCCV Mask                     */

/* ----------------------------------  TS_SCCNT  ---------------------------------- */
#define TS_SCCNT_SCCV_Pos                     0                                                       /*!< TS SCCNT: SCCV Position                 */
#define TS_SCCNT_SCCV_Msk                     (0xffffffffUL << TS_SCCNT_SCCV_Pos)                     /*!< TS SCCNT: SCCV Mask                     */

/* ------------------------------------  TS_SR  ----------------------------------- */
#define TS_SR_BUSY_Pos                        0                                                       /*!< TS SR: BUSY Position                    */
#define TS_SR_BUSY_Msk                        (0x01UL << TS_SR_BUSY_Pos)                              /*!< TS SR: BUSY Mask                        */
#define TS_SR_DONE_Pos                        8                                                       /*!< TS SR: DONE Position                    */
#define TS_SR_DONE_Msk                        (0x01UL << TS_SR_DONE_Pos)                              /*!< TS SR: DONE Mask                        */



/* ================================================================================ */
/* ================              Peripheral memory map             ================ */
/* ================================================================================ */

#define SCUCC_BASE                      0x4000F000UL
#define SCU_BASE                        0x40000000UL
#define SCULV_BASE                      0x40005100UL
#define PA_BASE                         0x40001000UL
#define PB_BASE                         0x40001100UL
#define PC_BASE                         0x40001200UL
#define PD_BASE                         0x40001300UL
#define PE_BASE                         0x40001400UL
#define PF_BASE                         0x40001500UL
#define PCU1_BASE                       0x40001544UL
#define PCU2_BASE                       0x40001F00UL
#define CFMC_BASE                       0x40000100UL
#define DFMC_BASE                       0x40000200UL
#define DMAC0_BASE                      0x40000400UL
#define DMAC1_BASE                      0x40000410UL
#define DMAC2_BASE                      0x40000420UL
#define DMAC3_BASE                      0x40000430UL
#define DMAC4_BASE                      0x40000440UL
#define DMAC5_BASE                      0x40000450UL
#define DMAC6_BASE                      0x40000460UL
#define DMAC7_BASE                      0x40000470UL
#define WDT_BASE                        0x40001A00UL
#define WT_BASE                         0x40002000UL
#define TIMER10_BASE                    0x40002100UL
#define TIMER11_BASE                    0x40002200UL
#define TIMER12_BASE                    0x40002300UL
#define TIMER13_BASE                    0x40002700UL
#define TIMER14_BASE                    0x40002800UL
#define TIMER15_BASE                    0x40002900UL
#define TIMER16_BASE                    0x40002A00UL
#define TIMER20_BASE                    0x40002500UL
#define TIMER21_BASE                    0x40002600UL
#define TIMER30_BASE                    0x40002400UL
#define USART10_BASE                    0x40003800UL
#define USART11_BASE                    0x40003900UL
#define USART12_BASE                    0x40003A00UL
#define USART13_BASE                    0x40003B00UL
#define UART0_BASE                      0x40004000UL
#define UART1_BASE                      0x40004100UL
#define SPI20_BASE                      0x40004C00UL
#define SPI21_BASE                      0x40004D00UL
#define I2C0_BASE                       0x40004800UL
#define I2C1_BASE                       0x40004900UL
#define I2C2_BASE                       0x40004A00UL
#define ADC_BASE                        0x40003100UL
#define DAC_BASE                        0x40003450UL
#define CMP_BASE                        0x40003420UL
#define LCD_BASE                        0x40005000UL
#define CRC_BASE                        0x40000300UL
#define TS_BASE                         0x40006300UL


/* ================================================================================ */
/* ================             Peripheral declaration             ================ */
/* ================================================================================ */

#define SCUCC                           ((SCUCC_Type              *) SCUCC_BASE)
#define SCU                             ((SCU_Type                *) SCU_BASE)
#define SCULV                           ((SCULV_Type              *) SCULV_BASE)
#define PA                              ((PORT_Type               *) PA_BASE)
#define PB                              ((PORT_Type               *) PB_BASE)
#define PC                              ((PORT_Type               *) PC_BASE)
#define PD                              ((PORT_Type               *) PD_BASE)
#define PE                              ((PORT_Type               *) PE_BASE)
#define PF                              ((PORTF_Type              *) PF_BASE)
#define PCU1                            ((PCU1_Type               *) PCU1_BASE)
#define PCU2                            ((PCU2_Type               *) PCU2_BASE)
#define CFMC                            ((CFMC_Type               *) CFMC_BASE)
#define DFMC                            ((DFMC_Type               *) DFMC_BASE)
#define DMAC0                           ((DMAC_Type               *) DMAC0_BASE)
#define DMAC1                           ((DMAC_Type               *) DMAC1_BASE)
#define DMAC2                           ((DMAC_Type               *) DMAC2_BASE)
#define DMAC3                           ((DMAC_Type               *) DMAC3_BASE)
#define DMAC4                           ((DMAC_Type               *) DMAC4_BASE)
#define DMAC5                           ((DMAC_Type               *) DMAC5_BASE)
#define DMAC6                           ((DMAC_Type               *) DMAC6_BASE)
#define DMAC7                           ((DMAC_Type               *) DMAC7_BASE)
#define WDT                             ((WDT_Type                *) WDT_BASE)
#define WT                              ((WT_Type                 *) WT_BASE)
#define TIMER10                         ((TIMER1n_Type            *) TIMER10_BASE)
#define TIMER11                         ((TIMER1n_Type            *) TIMER11_BASE)
#define TIMER12                         ((TIMER1n_Type            *) TIMER12_BASE)
#define TIMER13                         ((TIMER1n_Type            *) TIMER13_BASE)
#define TIMER14                         ((TIMER1n_Type            *) TIMER14_BASE)
#define TIMER15                         ((TIMER1n_Type            *) TIMER15_BASE)
#define TIMER16                         ((TIMER1n_Type            *) TIMER16_BASE)
#define TIMER20                         ((TIMER2n_Type            *) TIMER20_BASE)
#define TIMER21                         ((TIMER2n_Type            *) TIMER21_BASE)
#define TIMER30                         ((TIMER3n_Type            *) TIMER30_BASE)
#define USART10                         ((USART_Type              *) USART10_BASE)
#define USART11                         ((USART_Type              *) USART11_BASE)
#define USART12                         ((USART_Type              *) USART12_BASE)
#define USART13                         ((USART_Type              *) USART13_BASE)
#define UART0                           ((UART_Type               *) UART0_BASE)
#define UART1                           ((UART_Type               *) UART1_BASE)
#define SPI20                           ((SPI_Type                *) SPI20_BASE)
#define SPI21                           ((SPI_Type                *) SPI21_BASE)
#define I2C0                            ((I2C_Type                *) I2C0_BASE)
#define I2C1                            ((I2C_Type                *) I2C1_BASE)
#define I2C2                            ((I2C_Type                *) I2C2_BASE)
#define ADC                             ((ADC_Type                *) ADC_BASE)
#define DAC                             ((DAC_Type                *) DAC_BASE)
#define CMP                             ((CMP_Type                *) CMP_BASE)
#define LCD                             ((LCD_Type                *) LCD_BASE)
#define CRC                             ((CRC_Type                *) CRC_BASE)
#define TS                              ((TS_Type                 *) TS_BASE)


/** @} */ /* End of group Device_Peripheral_Registers */
/** @} */ /* End of group A31G22x */
/** @} */ /* End of group ABOV Semiconductor Co., Ltd. */

#ifdef __cplusplus
}
#endif


#endif  /* A31G22x_H */

